#include <mpi.h>

/* ------ If parallelizing with MPI, define data type for
          communication with slave                           -------- */

  /* matrix diagonalization is performed on a single processor */
#ifndef  ONE_PROCESSOR_SPECTRUM
#define ONE_PROCESSOR_SPECTRUM 1
#endif

/* processor rank for master */

#define MASTER 0

/************************ function prototypes ********************/

int master(sectors *(*)[2],element *,element (*)[HINDEX+2],int *,
	    int *,element *,int); /* master for MPI */
void slave(void);                   /* slave for MPI */
void initmpisectors(void);  /*initialize mpisectors and mpitype */
                            /*initialize communicator of just slaves.*/ 

#if ONE_PROCESSOR_SPECTRUM

MPI_Comm mpiallslaves;  /* communicator handle of all slaves.  */

#else

void MasterShutDown(void);

void spectrum2(sectors *s,         /* basis, filled by initbasis(...) */ 
	      sectors *s2,        /* second basis for nonzero momentum */
	      doublereal **vals,  /* list of eigenvalues */
	      doublereal **vecin, /* list of eigenvectors */
	      integer nval,       /* number of eigenvalues */
	      element *couplings, /* coupling constants */
	      element *angle,     /* angles and momenta, length HINDEX+2 */
	      int globalkt,       /* maximum value of kt, for mapcouplings */
	      integer nfig);      /* number of significant digits in answer */

void FindChunk(integer *Size, int PeID, int Comm_Size, MPI_Comm Our_Comm);

#endif
