#ifndef EXTRAPOLATE_INCLUDED
#define EXTRAPOLATE_INCLUDED

#include "spectrum.h"
#include "basis.h"
#include "fortran.h"

#define KSQUARED GLUE_PERIODIC /* include 1/K^2 with periodic BC's */


/************************************************************************/

element pextrapolate(integer ns, specify_calculation *s,element **vals);
void extrapolate(element **tval, integer ns, specify_calculation  *s, 
		 element **vals, integer *th, int nval,element *pextrap);
void kpweights(element *,integer *,int,specify_calculation *,element);
          /* function to extrapolate in K and p-truncation */
extern fsub fcn2(integer *, integer *, doublereal *,doublereal *,integer *);
void lextrapolate(element **tval, integer ns, specify_calculation *s, 
		    element **vals, integer *th, integer nval, 
		      element *pextrap, element *kmaxlist);
                   /* extrapolation procedure for nonzero L  */
void kmaxweights(element *,integer *,int,specify_calculation *,element *,
		 element);
          /* function to extrapolate in K, p-truncation, and K_max. */
void wweights(element *,integer *,int,int (*)[HINDEX]); 
                                     /* fit winding modes */ 
void lweights(element *,integer *,int,element *); 
                                  /*fit longitudinal potential */
element fdot(const element *,const element *,int); /* dot product */
int dot(const int *,const int *,int); /* dot product */

#endif
