
void print_jessica_header(FILE *fp, doublereal xtol,  int *chargest, 
			  int *multis, 
	                  int *multit, int *charge_still, int *multistill,
			  int *ht_zero){
  int i,j,k,l;
  /*  Print out the results in the output file **/
  fprintf(fp,"********* Eigenvalues for the 3+1 transverse lattice *********\n");
  fprintf(fp,"Couplings:\n    ");
  for(i=0; i<NPARAMS; i++){
    fprintf(fp,"  %i:%s",i,coupling_string(i));
    if(i%5==4 && i!=NPARAMS-1)fprintf(fp,"\n    ");
  }    
  fprintf(fp,"\nUse chi^2 fit with %i criteria and tolerance %g.\n",
	  CHI_DIM,xtol);
  switch(scalemethod){
  case 0:
    fprintf(fp,"Overall scale from longitudinal string tension.\n");
    break;
  case 1:
    fprintf(fp,"Overall scale from fitting lowest state to lattice value.\n");
    break;
  case 2:
    fprintf(fp,"Overall scale determined from best fit for c^2.\n");
    break;
  case 3:
    fprintf(fp,"Overall scale from minimizing chi^2.\n");
    break;
  default:
    fprintf(stderr,__FILE__":  Incorrect scale method = %i, exiting.\n",
	    scalemethod);
  }
#if KSQUARED
  fprintf(fp,"1/K^2 term used in all extrapolations.\n");
#endif
#if FEXTRA>0
  fprintf(fp,"Includes %i nonstandard fit criteria (such as a \n"
	  " specific lattice spacing).\n",FEXTRA);
#endif
#if FTEPER>0
  fprintf(fp,"Includes a fit to %i eigenvalues from Teper.\n",FTEPER);
#endif
#if FPARITY>0
  fprintf(fp,"Parity doublets (charge,multi,state) with error for difference\n"
	  "  over average.\n");
  for(i=0; i<FPARITY; i++)
    fprintf(fp,"  (%2i,%2i,%i) and (%2i,%2i,%i), error %g\n",
	    whichparity[i][0].charge,whichparity[i][0].multi,
	    whichparity[i][0].state,
	    whichparity[i][1].charge,whichparity[i][1].multi,
	    whichparity[i][1].state,parityerr[i]);
#else
  fprintf(fp,"No parity doublets.\n");
#endif
  fprintf(fp,"Spectrum for P_perp a = (0,0),");
  for(i=0; i<NP1; i++){
    fprintf(fp," (");
    for(j=0; j<HINDEX; j++)fprintf(fp," %g",p1a[i][j]);
    fprintf(fp,")");
  }
  fprintf(fp,"\n  using %i states (multiplet, charge, c^2 error for each) =",
	  NPERPVALS);
  for(i=0; i<NPERP; i++){
    fprintf(fp,"\n  (%2i, %2i,",multis[i],chargest[i]);
    for(j=0; j<FCSQUARED; j++)
      fprintf(fp," %g",c2err[i][j]);
    fprintf(fp,")");
  }
  fprintf(fp,"\nSpectrum for P_perp a = (0,0),");
  for(i=0; i<NP2; i++){
    fprintf(fp," (");
    for(j=0; j<HINDEX; j++)fprintf(fp," %g",p2a[i][j]);
    fprintf(fp,")");
  }
  fprintf(fp,"\n  using %i states (multiplet, charge, c^2 error for each) =",
	  NPERPVALS);
  for(i=0; i<NPERP; i++){
    fprintf(fp,"\n  (%2i, %2i,",multit[i],chargest[i]);
    for(j=0; j<FCSQUARED; j++)
      fprintf(fp," %g",c2err[i][j]);
    fprintf(fp,")");
  }
#if NSTILL>0
  fprintf(fp,".\nOrdinary spectra multiplets, %i states, (charge,multiplet) =",
	  NSTILLVALS);
  for(i=0, k=5; i<NSTILL; k++, i++){
    if(k%6==0)fprintf(fp,"\n ");
    fprintf(fp," (%2i, %2i) ",charge_still[i],multistill[i]);
  }
#endif
  fprintf(fp,".\nAll spectra extrapolated using (K,p) =");
  for(i=0, k=3; i<NS; k++, i++){
    if(k%5==0)fprintf(fp,"\n ");
    fprintf(fp," (%i/2,%i) ",kt[i],np[i]);
  }
  fprintf(fp,".\nWinding potential using (n,K,p) =");
  for(i=0, k=2; i<NWIND; i++)
    for(j=0; j<WNS; k++, j++){
      if(k%4==0)fprintf(fp,"\n ");
      fprintf(fp," (");
      for(l=0; l<HINDEX; l++)fprintf(fp," %i",wht0[i][l]);
      fprintf(fp,",%i/2,%i) ",wkt0[i][j],wnp0[i][j]);
    }
  fprintf(fp,".\nRoundness of winding using (n,K,p) =");
  for(i=0, k=3; i<FWIND; k=0, i++){
    for(j=0; j<WNS; k++, j++){
      if(k%4==0)fprintf(fp,"\n ");
      fprintf(fp," (");
      for(l=0; l<HINDEX; l++)fprintf(fp," %i",wht[i][l]);
      fprintf(fp,",%i/2,%i) ",wkt[i][j],wnp[i][j]);
    }
    fprintf(fp,"\n  with error %g;",werr[i]);
  }
  fprintf(fp," in G^2 N units.\n"
	  "Heavy potential determined using (n,K,p,K_max) =");
  for(j=0, k=3; j<LNS; k++, j++){
    if(k%3==0)fprintf(fp,"\n ");
    fprintf(fp," (");
    for(l=0; l<HINDEX; l++)fprintf(fp," %i",ht_zero[l]);
    fprintf(fp,",%i/2,%i,%g) ",lkt0[j],lnp0[j],lkmax0[j]);
  }
  fprintf(fp,",\n L =");
  for(i=0; i<NLONG; i++)fprintf(fp," %g%+g*m",llong0[i],llong0m[i]);
  fprintf(fp,"\n (all in G^2 N units)");
  if(FSCALE)fprintf(fp,"; relative scale error=%g",lerr0);
  fprintf(fp,".\nRoundness determined using (n,K,p,K_max) =");
  for(i=0, k=2; i<FLONG; k=0, i++){
    for(j=0; j<LNS; k++, j++){
      if(k%3==0)fprintf(fp,"\n ");
      fprintf(fp," (");
      for(l=0; l<HINDEX; l++)fprintf(fp," %i",lht[i][l]);
      fprintf(fp,",%i/2,%i,%g) ",lkt[i][j],lnp[i][j],lkmax[i][j]);
    }
    fprintf(fp,"\n L=%g%+g*m and error %g;",
	    llong[i],llongm[i],lerr[i]);
  }
  fprintf(fp," all in G^2 N units.\np-extrapolation using n=(");
  for(l=0; l<HINDEX; l++)fprintf(fp," %i",pht1[l]);
  fprintf(fp,") and (K,p) =");
  for(j=0, k=4; j<PNS; k++, j++){
    if(k%5==0)fprintf(fp,"\n ");
    fprintf(fp," (%i/2,%i) ",pkt1,pnp1[j]);
  }
  fprintf(fp,".\nResult format:\n"
	  " Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\n"
	  " The %i couplings  (G^2 N units);\n"
	  "   which couplings -- if any -- were fit.\n"
	  " Winding potential and heavy souce potential fits.\n"
	  " Roundness of winding potential, %i values, and roundness of\n"
	  "   heavy source potential, %i values, (G^2 N units)\n"
	  "   showing measured value and derived value for each.\n"
	  " The rescaled spectrum for each P_perp*a and c^2 values.\n"
#if NSTILL>0
	  " Finally come the states for the ordinary spectra.\n"
#endif
	  "\n",NPARAMS,FWIND,FLONG);
  fflush(fp);
}

void print_jessica(FILE *fp, glue_best *best, element chi2, integer info, 
		      integer nfev,integer npar){
  int i,j,k;
  fprintf(fp,"%li %li " PDIGITS " " PDIGITS " " PDIGITS "\n",
	  info,nfev,chi2,best->pextrap,best->rescale);
  for(i=0; i<NPARAMS; i++)fprintf(fp,PDIGITS " ",par[i]);
  if(npar>0)fprintf(fp,"\n");
  for(i=0; i<npar; i++)fprintf(fp," %i",wpar[i]);
  fprintf(fp,"\n");
  for(i=0; i<wth; i++)fprintf(fp,"%f ",best->wfitting[i]);
  for(i=0; i<lth; i++)fprintf(fp," %f",best->lfitting[i]);
  fprintf(fp,"\n");
  for(i=0; i<FWIND; i++)
    fprintf(fp,"%f %f  ",best->wvalue[i],best->calcwvalue[i]);
  for(i=0; i<FLONG; i++)
    fprintf(fp,"%f %f  ",best->lvalue[i],best->calclvalue[i]);
  fprintf(fp,"\n");
#if NP1>0
  for(i=0; i<NPERP; i++)
    for(k=0; k<NPERPVALS; k++){
      for(j=0; j<NP1+1; j++)
	fprintf(fp," %f",best->rescale*best->spectrumvals1[j][i][k]);
      for(j=0; j<NP1; j++)
	fprintf(fp," %g",best->c2[j][i][k]); 
      fprintf(fp,"\n");
    }
#endif
#if NP2>0
  for(i=0; i<NPERP; i++)
    for(k=0; k<NPERPVALS; k++){
      for(j=0; j<NP2+1; j++)
	fprintf(fp," %f",best->rescale*best->spectrumvals2[j][i][k]);
      for(j=0; j<NP2; j++)
	fprintf(fp," %g",best->c2[NP1+j][i][k]);
      fprintf(fp,"\n");
    }
#endif
  for(i=0; i<NSTILL; i++){
    for(j=0; j<NSTILLVALS; j++)
      fprintf(fp,"%f ",best->rescale*best->stillvals[i][j]);
    fprintf(fp,"\n");
  }
  fprintf(fp,"\n");
  fflush(fp);
}

