hc[x_]:=Conjugate[Transpose[x]]

(*************Original Chiral basis *************************)

dg[0]={{ 0, 0,-1, 0},
       { 0, 0, 0,-1},
       {-1, 0, 0, 0},
       { 0,-1, 0, 0}};

dg[1]={{ 0, 0, 0, 1},
       { 0, 0, 1, 0},
       { 0,-1, 0, 0},
       {-1, 0, 0, 0}};

dg[2]={{ 0, 0, 0,-I},
       { 0, 0, I, 0},
       { 0, I, 0, 0},
       {-I, 0, 0, 0}};

dg[3]={{ 0, 0, 1, 0},
       { 0, 0, 0,-1},
       {-1, 0, 0, 0},
       { 0, 1, 0, 0}};

dg[5]=I dg[0].dg[1].dg[2].dg[3];
dg[plus]=(dg[0]+dg[3])/Sqrt[2];
dg[minus]=(dg[0]-dg[3])/Sqrt[2];

psi={up,vp,vm,um}/2^(1/4);

Simplify[Conjugate[psi].dg[0].psi]
Simplify[Conjugate[psi].dg[0].dg[1].psi]
Simplify[Conjugate[psi].dg[0].dg[2].psi]
Simplify[Conjugate[psi].dg[0].dg[plus].psi]
Simplify[Conjugate[psi].dg[0].dg[minus].psi]

dg[0].MatrixExp[-Pi/4 (dg[2].dg[3]-dg[3].dg[2])]
dg[0].MatrixExp[-Pi/4 (dg[3].dg[1]-dg[1].dg[3])]
rz[theta_]:=MatrixExp[-theta/4 (dg[1].dg[2]-dg[2].dg[1])]

I/4 (dg[1].dg[2]-dg[2].dg[1])

(**************Rotate basis***************************)

rot={{ 1, 0, 0, 1},
     { 1, 0, 0,-1},
     { 0, 1, 1, 0},
     { 0, 1,-1, 0}}/Sqrt[2];

rot.hc[rot]
rot.{up,vp,vm,um}

rg[0]=rot.dg[0].hc[rot];
rg[1]=rot.dg[1].hc[rot];
rg[2]=rot.dg[2].hc[rot];
rg[3]=rot.dg[3].hc[rot];
rg[5]=rot.dg[5].hc[rot];

rg[plus]=(rg[0]+rg[3])/Sqrt[2];
rg[minus]=(rg[0]-rg[3])/Sqrt[2];

rg[minus].rg[plus]/2

rg[plus].rg[minus]/2

psir={up,um,vp,vm}/2^(1/4);
Conjugate[psir].rg[0].psir
Conjugate[psir].rg[0].rg[1].psir
Conjugate[psir].rg[0].rg[2].psir
Conjugate[psir].rg[0].rg[plus].psir
Conjugate[psir].rg[0].rg[minus].psir

Exp[I Pi/2 rg[3]].psir
Exp[I Pi rg[3]].psir
Exp[I 2 Pi rg[3]].psir

