#
#  here are the machine-dependant parameters:
#  GNU version
#
#---------------------------------------------------------------------------
CC=gcc
FC=g77
#
#    -pg is for profiler gprof
#    -g is gdb debugger
#    -fcheck-memory-usage
#
DEBUG=
#
LIBS=-llong  -lport3 -larpack_LINUX -llanso
#
#          both -ansi & -pendantic needed to force ANSI c 
#               -O3 is optimization (should have -O when using valgrind)
#  -march=i686: machine-specific instructions
#  -malign-double does not make sense in 64 bit mode
# 
ifeq ($(shell uname -m),x86_64)
  COPTS= -O3 -Wall -m64 -L../lib/ -I../lib/blocksparse -I../davecode
  FOPTS= -O2 -Wall -m64 -L../lib/
#  acml is AMD's lib for BLAS and LAPACK
  LIBS += -lacml  
else
# 32-bit libs are in ../lib/32 (override default in Makefile)
  COPTS= -Wall -march=i686 -L../lib/32 -I../lib/blocksparse -I../davecode
  FOPTS= -Wall -march=i686 -L../lib/32 -fbounds-check -finit-local-zero
  LIBS += -llapack -lblas
endif
#  -W  other possible bad things...
#
# mpi command
#
MPIFC=mpif77
MPICC=mpicc
#
DFLAG=-D







