hc[x_]:=Conjugate[Transpose[x]]

(*************Original Chiral basis *************************)

dg[0]={{ 0, 0,-1, 0},
       { 0, 0, 0,-1},
       {-1, 0, 0, 0},
       { 0,-1, 0, 0}};

dg[1]={{ 0, 0, 0, 1},
       { 0, 0, 1, 0},
       { 0,-1, 0, 0},
       {-1, 0, 0, 0}};

dg[2]={{ 0, 0, 0,-I},
       { 0, 0, I, 0},
       { 0, I, 0, 0},
       {-I, 0, 0, 0}};

dg[3]={{ 0, 0, 1, 0},
       { 0, 0, 0,-1},
       {-1, 0, 0, 0},
       { 0, 1, 0, 0}};

(* charge conjugation matrix *)

dc={{0,-1,0,0},{1,0,0,0},{0,0,0,1},{0,0,-1,0}};

dg[5]=I dg[0].dg[1].dg[2].dg[3];
dg[plus]=(dg[0]+dg[3])/Sqrt[2];
dg[minus]=(dg[0]-dg[3])/Sqrt[2];

(* Sigma and 90 degree rotation *)

sigma[mu_,nu_]=I/2 (dg[mu].dg[nu]-dg[nu].dg[mu])

rr=(IdentityMatrix[4] + I sigma[1,2])/Sqrt[2]

sigma[1]={{0,1},{1,0}};
sigma[2]={{0,-I},{I,0}};
sigma[3]={{1,0},{0,-1}};

psi={up,vp,vm,um}/2^(1/4);
u={up,um};
v={vp,vm};


(* test lots of stuff: all of the following equal zero *)
(*

Expand[Conjugate[psi].dg[0].dg[plus].psi-Conjugate[u].u]

Expand[Conjugate[psi].dg[0].dg[minus].psi-Conjugate[v].v]

Expand[Conjugate[psi].dg[0].psi-(-1/Sqrt[2]*(Conjugate[u].sigma[1].v+
     Conjugate[v].sigma[1].u))]

Expand[Conjugate[psi].dg[0].dg[5].psi-(I/Sqrt[2]*(Conjugate[u].sigma[2].v+
     Conjugate[v].sigma[2].u))]

Expand[Conjugate[psi].dg[0].dg[1].psi-(1/Sqrt[2]*(Conjugate[u].sigma[3].v+
     Conjugate[v].sigma[3].u))]

Expand[Conjugate[psi].dg[0].dg[2].psi-(-I/Sqrt[2]*(Conjugate[u].v-
     Conjugate[v].u))]

Expand[Conjugate[psi].dg[0].dg[plus].dg[5].psi-Conjugate[u].sigma[3].u]

Expand[Conjugate[psi].dg[0].dg[minus].dg[5].psi-Conjugate[v].sigma[3].v]

Expand[Conjugate[psi].dg[0].dg[1].dg[5].psi-(Conjugate[u].v+Conjugate[v].u)/Sqrt[2]]

Expand[Conjugate[psi].dg[0].dg[2].dg[5].psi+ I (Conjugate[u].sigma[3].v-Conjugate[v].sigma[3].u)/Sqrt[2]]

Expand[Conjugate[psi].dg[0].sigma[1,2].psi+
    I/Sqrt[2] (Conjugate[u].sigma[2].v-Conjugate[v].sigma[2].u)]

*)

