(* code from interact_meson.c *)

   (* convert from new method to old method *)
    conv[ff_,kk_]:=ff/(1-2 ff/Pi Sum[1/l,{l,1/2,kk-1/2}])
    (* convert from old method to new method*)
    invconv[ff_,kk_]:=ff/(1+2 ff/Pi Sum[1/l,{l,1/2,kk-1/2}])
    (* list of couplings done the old way *)
    kappalist={-0.6578485781, 0.5403484159, -0.1179405157,
          -0.1172333778, 0.02454314234, 0.5106455396};
    (* list of K values *)
    kklist={20/2,22/2,24/2,26/2,30/2,40/2};
    mat=Map[Table[LaguerreL[n - 1, 0, #/10.0], {n,
          Length[kappalist]}]&,kklist]
    newlist=Apply[invconv,Transpose[{mat.kappalist,kklist}],{1}]
    (* list of couplings done the new way *)
    newkappalist=Inverse[mat].newlist

   fitting=Fit[Transpose[{kklist,newlist}],{1,1/x,1/Log[x]},x]
   Show[
     Plot[fitting,{x,10,20},DisplayFunction->Identity],
     ListPlot[Transpose[{kklist,newlist}],DisplayFunction->Identity],
     DisplayFunction->$DisplayFunction
   ]

