(***********************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which typically
will have the same name as this file except ending in ".nb" instead of
".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent to
using the Evaluate Initialization Cells menu command in the front end.

DO NOT EDIT THIS FILE.  This entire file is regenerated automatically 
each time the parent Notebook file is saved in the Mathematica front end.
Any changes you make to this file will be overwritten.
***********************************************************************)











zetaf[h1_,_[_,1],h2_]:={{0,-I},{I,0}}[[ 3/2-h1[[2]], 3/2-h2[[2]] ]];

zetaf[h1_,_[_,2],h2_]:=-{{0,1},{1,0}}[[ 3/2-h1[[2]], 3/2-h2[[2]] ]];

zetaf[h1_,_[_,-1],h2_]:=-{{0,-I},{I,0}}[[ 3/2-h1[[2]], 3/2-h2[[2]] ]];

zetaf[h1_,_[_,-2],h2_]:={{0,1},{1,0}}[[ 3/2-h1[[2]], 3/2-h2[[2]] ]];

zetafzetaf[h1_,a1_,a2_,h2_]:=
    Block[{f1,fa},
      Sum[zetaf[h1,a1,f1[fa,hh]] zetaf[f1[fa,hh],a2,h2],{hh,-1/2,1/2}]];



Clear[elfkappa,elfquarkquark,elfquarkglue,elfglueglue];

(* Correct way: Sum[1/k,{k,1/2,kl-1}]/(2 Pi kl)*)

elfkappa[kl_]:=elfkappa[kl]=If[kl>1/2,Sum[1/k,{k,1,kl-1/2}]/(2 Pi kl),0];

elfquarkquark[k1_,k2_]:=
    elfquarkquark[k1,k2]=
      Sum[If[k\[NotEqual]k1,1/(k1-k)^2,0],{k,1/2,k1+k2-1/2}]/(4 Pi);

elfquarkglue::usage=
    "elfquarkglue[k1,k2]:  k1 is the quark {1/2,3/2,...} and k2 is the link \
field {1,2,3,...}";

elfquarkglue[k1_,k2_]:=
    elfquarkglue[kl]=(Sqrt[1+k1/k2]-1)/(4 Pi k1)+
        Sum[If[k1\[NotEqual]r,(k1+2  k2-r)/(Sqrt[k2 (k1+k2-r)]*(k1-r)^2),
              0],{r,1/2,k1+k2-1}]/(8 Pi);

elfglueglue::usage=
    "This is the link-link expression from the c-program \"improved.c\" This \
is modified for periodic boundary conditions,no zero modes.";

elfglueglue[k1_,k2_]:=
    Block[{kt=k1+k2},
      1/(16 Sqrt[k1 k2])+
        Sum[If[k\[NotEqual]
                k1,(k1+k) (k2+kt-k)/(Sqrt[k1 k2 k (kt-k)] (k1-k)^2),0],{k,1,
              kt-1}]/(16 Pi)];

makeham::usage=
    "makeham[leftstate,rightstate,{mub,muf,g2,kappas,kappaa,beta,lambda1,\
lambda2,lambda3,lambda4,lambda5},npmax]  calculates P^- where both leftstate
and rightstate are in |ket> form and npmax is the maximum number of \
particles,
both quarks and gluons, in all states of the basis.";

makeham[sl_,
    sr_,{mub_,muf_,g2_,kappas_,kappaa_,beta_,lambda1_,lambda2_,lambda3_,
      lambda4_,lambda5_},npmax_]:=
  Block[{kl=Map[First,sl],kr=Map[First,sr],hl=Map[Part[#,2]&,sl],
      hr=Map[Part[#,2]&,sr]},Which[  
      
      Length[sl]\[Equal]Length[sr],
      (* diagonal interactions *)
      If[sl===sr,
          (* Self-energy interactions *)
          
          muf^2/(2 kl[[1]])+muf^2/(2 kl[[-1]])+
            Sum[mub^2/(2 kl[[i]]),{i,2,Length[sl]-1}]+
            Sum[g2 elfglueglue[kl[[i]],kl[[i+1]]],{i,2,Length[sl]-2}]+
            If[Length[sl]<
                npmax,(kappaa^2+kappas^2)*(elfkappa[kl[[1]]]+
                    elfkappa[kl[[-1]]]),0]+
            g2 If[Length[sl]\[Equal]2, elfquarkquark[kl[[1]],kl[[2]]],
                elfquarkglue[kl[[1]],kl[[2]]]+
                  elfquarkglue[kl[[-1]],kl[[-2]]]],
          (* non-diagnal (only) 2\[Rule]2 particle interactions *)
          (* 
            gluon-gluon \[Rule] gluon-gluon interactions *)
          
          Sum[If[Drop[sl,{i,i+1}]===Drop[sr,{i,i+1}],
                (*Instantaneous gluon-gluon \[Rule] 
                    gluon-gluon normal interaction *)
                
                If[hl[[i]]\[Equal]hr[[i]] && 
                    hl[[i+1]]\[Equal]
                      hr[[i+1]],-g2*(kl[[i]]+
                        kr[[i]])*(kl[[i+1]]+
                          kr[[i+1]])/(16 Pi Sqrt[
                            kl[[i]]*kr[[i]]*kl[[i+1]]*
                              kr[[i+1]]](kl[[i]]-kr[[i]])^2),0],
                0],{i,2,Length[sl]-2}]+
            If[Length[sl]>2,
              (* quark-gluon \[Rule] quark-gluon interaction *)
              
              If[Drop[sl,2]===Drop[sr,2] && hl[[2]]\[Equal]hr[[2]] && 
                    Rest[sl[[1]]]===
                      Rest[sr[[1]]],-g2 (kl[[2]]+
                          kr[[2]])/(8 Pi Sqrt[
                            kl[[2]] kr[[2]]] (kl[[1]]-kr[[1]])^2),0]+
                (* antiquark-gluon \[Rule] antiquark-gluon interaction *)
    
                            
                If[Drop[sl,-2]===Drop[sr,-2] &&  hl[[-2]]\[Equal]hr[[-2]] &&
                    Rest[sl[[-1]]]===
                      Rest[sr[[-1]]],-g2 (kl[[-2]]+
                          kr[[-2]])/(8 Pi Sqrt[
                            kl[[-2]] kr[[-2]]] (kl[[-1]]-kr[[-1]])^2),0],
              (* quark-quark \[Rule] quark-quark interaction *)
              
              If[ Rest[sl[[1]]]===Rest[sr[[1]]]&& 
                  Rest[sl[[2]]]===Rest[sr[[2]]],
                -g2/(4 Pi (kl[[1]]-kr[[1]])^2),0]
              ]
          ]+
        (* Both diagonal and non-diagonal interactions *)
        
        If[Length[sl]>2,
          (* quark-gluon \[Rule] quark-gluon interactions *)
          
          If[Drop[sl,2]===Drop[sr,2],
              If[Rest[sl[[1]]]===Rest[sr[[1]]],
                  kappas^2/(8 Pi Sqrt[kl[[2]] kr[[2]]] (kr[[1]]+kr[[2]])),0]+
                kappaa kappas (zetaf[sl[[1]],sl[[2]],sr[[1]]]+
                        zetaf[sl[[1]],sr[[2]],sr[[1]]])/(8 Pi Sqrt[
                          kl[[2]] kr[[2]]] (kr[[1]]+kr[[2]]))+
                kappaa^2 zetafzetaf[sl[[1]],sl[[2]],sr[[2]],
                      sr[[1]]]/(8 Pi Sqrt[kl[[2]] kr[[2]]] (kr[[1]]+kr[[2]])),
              0]+
            (* antiuark-gluon \[Rule] antiquark-gluon interactions *)
        
                If[Drop[sl,-2]===Drop[sr,-2],
              If[Rest[sl[[-1]]]===Rest[sr[[-1]]],
                  kappas^2/(8 Pi Sqrt[kl[[-2]] kr[[-2]]] (kr[[-1]]+kr[[-2]])),
                  0]-kappaa kappas Conjugate[
                      zetaf[sr[[-1]],sl[[-2]],sl[[-1]]]+
                        zetaf[sr[[-1]],sr[[-2]],sl[[-1]]]]/(8 Pi Sqrt[
                          kl[[-2]] kr[[-2]]] (kr[[-1]]+kr[[-2]]))+
                kappaa^2 Conjugate[
                      zetafzetaf[sr[[-1]],sr[[-2]],sl[[-2]],
                        sl[[-1]]]]/(8 Pi Sqrt[
                          kl[[-2]] kr[[-2]]] (kr[[-1]]+kr[[-2]])),0],0]+
        (* gluon-gluon \[Rule] gluon-gluon interactions *)
        
        Sum[If[Drop[sl,{i,i+1}]===Drop[sr,{i,i+1}] ,
            (*Instantaneous annihilation interaction *)
            
            If[ hl[[i]]==-hl[[i+1]] && hr[[i]]\[Equal]-hr[[i+1]],
                g2*(kl[[i]]-
                      kl[[i+1]])*(kr[[i]]-
                        kr[[i+1]])/(16 Pi Sqrt[
                          kl[[i]]*kr[[i]]*kl[[i+1]]*
                            kr[[i+1]]](kl[[i]]+kl[[i+1]])^2),0]+
              (* Effective potential terms *)
              
              If[hl[[i]]\[Equal]hr[[i+1]] && hr[[i]]\[Equal]hl[[i+1]] && 
                  Abs[hl[[i]]]\[NotEqual]
                    Abs[hr[[i]]],-beta/(8 Pi Sqrt[
                        kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),0]+
              If[hl[[i]]\[Equal]-hl[[i+1]] && hr[[i]]\[Equal]-hr[[i+1]] && 
                  hl[[i]]\[Equal]hr[[i]],
                lambda1/(4 Pi Sqrt[kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),0]+
              If[hl[[i]]\[Equal]hr[[i+1]] && hr[[i]]\[Equal]hl[[i+1]] && 
                  Abs[hl[[i]]]\[Equal]Abs[hr[[i]]],
                lambda2/(8 Pi Sqrt[kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),0]+
              If[(hl[[i]]\[Equal]-hl[[i+1]] && hr[[i]]\[Equal]-hr[[i+1]] && 
                      Abs[hl[[i]]]\[NotEqual]Abs[
                          hr[[i]]])||(hl[[i]]\[Equal]hr[[i]] && 
                      hr[[i+1]]\[Equal]hl[[i+1]] && 
                      Abs[hl[[i]]]\[NotEqual]Abs[hl[[i+1]]]),
                lambda4/(8 Pi Sqrt[kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),0],
            0],{i,2,Length[sl]-2}],
      
      Length[sl]==Length[sr]+1,
      (* Yukawa quark \[Rule] quark-gluon interactions *) 
      If[Drop[sl,2]===Drop[sr,1],
          If[Rest[sl[[1]]]===
                Rest[sr[[1]]],-kappas muf (kl[[1]]+
                      kr[[1]])/(4  Sqrt[Pi kl[[2]]] kl[[1]] kr[[1]]),0]+
            muf kappaa Sqrt[
                kl[[2]]] zetaf[sl[[1]],sl[[2]],
                  sr[[1]]]/(4  Sqrt[Pi] kr[[1]] kl[[1]]),0]+
        (* Yukawa antiquark \[Rule] antiquark-gluon interactions *) 
        If[Drop[sl,-2]===Drop[sr,-1],
          If[Rest[sl[[-1]]]===
                Rest[sr[[-1]]],-kappas  muf  (kl[[-1]]+ 
                      kr[[-1]])/(4 Sqrt[Pi kl[[-2]]] kl[[-1]] kr[[-1]] ),0]-
            kappaa  muf Sqrt[
                kr[[-1]]-kl[[-1]]]  Conjugate[
                  zetaf[sr[[-1]],sl[[-2]],
                    sl[[-1]]]]/(4 Sqrt[Pi] kl[[-1]] kr[[-1]] ) ,
          0],
      
      Length[sl]==Length[sr]+2,
      (* quark \[Rule] quark-glue-glue interactions *)
      
      If[Drop[sl,3]===Drop[sr,1],
          If[Rest[sl[[1]]]===Rest[sr[[1]]],
              kappas^2 /(8 Pi Sqrt[kl[[2]] kl[[3]]] (kl[[1]]+kl[[2]])),0]+
            kappaa kappas (zetaf[sl[[1]],sl[[3]],sr[[1]]]-
                    zetaf[sl[[1]],sl[[2]],sr[[1]]])/(8 Pi Sqrt[
                      kl[[2]] kl[[3]]] (kl[[3]]-kr[[1]]))+
            kappaa^2 zetafzetaf[sl[[1]],sl[[2]],sl[[3]],
                  sr[[1]]]/(8 Pi Sqrt[kl[[2]] kl[[3]]] (kl[[3]]-kr[[1]]))+
            If[Rest[sl[[1]]]===Rest[sr[[1]]] && 
                hl[[2]]\[Equal]-hl[[3]],-g2 (kl[[2]]-
                      kl[[3]])/(8 Pi Sqrt[
                        kl[[2]] kl[[3]]] (kl[[1]]-kr[[1]])^2),0],0]+
        (* antiquark \[Rule] antiquark-glue-glue interactions *)
        
        If[Drop[sl,-3]===Drop[sr,-1],
          If[Rest[sl[[-1]]]===Rest[sr[[-1]]],
              kappas^2 /(8 Pi Sqrt[kl[[-2]] kl[[-3]]] (kl[[-1]]+kl[[-2]])),0]+
            kappaa kappas Conjugate[
                  zetaf[sr[[-1]],sl[[-3]],sl[[-1]]]-
                    zetaf[sr[[-1]],sl[[-2]],sl[[-1]]]]/(8 Pi Sqrt[
                      kl[[-2]] kl[[-3]]] (kl[[-1]]+kl[[-2]]))-
            kappaa^2 Conjugate[
                  zetafzetaf[sr[[-1]],sl[[-3]],sl[[-2]],
                    sl[[-1]]]]/(8 Pi Sqrt[
                      kl[[-2]] kl[[-3]]] (kl[[-1]]+kl[[-2]]))+
            If[Rest[sl[[-1]]]===Rest[sr[[-1]]] && hl[[-2]]\[Equal]-hl[[-3]],
              g2 (kl[[-3]]-
                      kl[[-2]])/(8 Pi Sqrt[
                        kl[[-2]] kl[[-3]]] (kl[[-1]]-kr[[-1]])^2),0],0]+
        (* gauge glue \[Rule] glue-glue-glue interactions *)
        
        Sum[If[Drop[sl,{i,i+2}]===Drop[sr,{i}],
            If[hl[[i+2]]==-hl[[i+1]] && 
                  hl[[i]]\[Equal]
                    hr[[i]],-g2 (kl[[i]]+
                      kr[[i]]) (kl[[i+1]]-
                        kl[[i+2]])/(16 Pi Sqrt[
                          kl[[i]] kr[[i]] kl[[i+1]] kl[[i+2]]] (kr[[i]]-
                              kl[[i]])^2),0]+
              If[hl[[i]]==-hl[[i+1]] && hl[[i+2]]\[Equal]hr[[i]],
                g2 (kr[[i]]+
                      kl[[i+2]]) (kl[[i]]-
                        kl[[i+1]])/(16 Pi Sqrt[
                          kl[[i]] kr[[i]] kl[[i+1]] kl[[i+2]]] (kl[[i+2]]-
                              kr[[i]])^2),0]+
              If[hr[[i]]\[Equal]hl[[i+1]] && hl[[i]]\[Equal]-hl[[i+2]] && 
                  Abs[hl[[i]]]\[NotEqual]
                    Abs[hr[[i]]],-beta/(8 Pi Sqrt[
                        kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),0]+
              If[hr[[i]]\[Equal]hl[[i+2]] && hl[[i]]\[Equal]-hl[[i+1]] && 
                  hl[[i]]\[Equal]hr[[i]],
                lambda1/(4 Pi Sqrt[kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),0]+
              If[Abs[hr[[i]]]\[Equal]Abs[hl[[i]]] && 
                  hl[[i]]\[Equal]-hl[[i+2]] && hl[[i+1]]\[Equal]hr[[i]],
                lambda2/(8 Pi Sqrt[kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),0]+
              If[(hl[[i]]\[Equal]-hl[[i+1]] && hl[[i+2]]\[Equal]hr[[i]]&& 
                      Abs[hl[[i+1]]]\[NotEqual]
                        Abs[hr[[i]]]) ||(hl[[i+2]]\[Equal]-hl[[i+1]] && 
                      hl[[i]]\[Equal]hr[[i]]&& 
                      Abs[hl[[i+1]]]\[NotEqual]Abs[hr[[i]]]),
                lambda4/(8 Pi Sqrt[kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),0],
            0],{i,2,Length[sr]-1}],
      
      Length[sl]==Length[sr]-1,
      (* Yukawa quark-gluon \[Rule] quark interactions *) 
      If[Drop[sl,1]===Drop[sr,2],
          If[Rest[sl[[1]]]===
                Rest[sr[[1]]],-kappas  muf  (kl[[1]]+
                      kr[[1]])/(4 Sqrt[Pi kr[[2]]] kl[[1]] kr[[1]]) ,0]+
            kappaa  muf Sqrt[
                kr[[2]]]  zetaf[sl[[1]],sr[[2]],
                  sr[[1]]]/(4 Sqrt[Pi] kr[[1]] kl[[1]]) ,0]+(* 
          Yukawa antiquark-gluon \[Rule] antiquark interactions *) 
        If[Drop[sl,-1]===Drop[sr,-2],
          If[Rest[sl[[-1]]]===
                Rest[sr[[-1]]],-kappas  muf  (kr[[-1]]+
                      kl[[-1]])/(4 Sqrt[Pi kr[[-2]]] kr[[-1]] kl[[-1]]) ,0]-
            kappaa  muf Sqrt[
                kr[[-2]]]  Conjugate[
                  zetaf[sr[[-1]],sr[[-2]],
                    sl[[-1]]]]/(4 Sqrt[Pi] kr[[-1]] kl[[-1]]) ,0],
      
      Length[sl]==Length[sr]-2,
      (* quark-glue-glue \[Rule] quark interactions *)
      
      If[Drop[sl,1]===Drop[sr,3],
          If[Rest[sl[[1]]]===Rest[sr[[1]]],
              kappas^2 /(8 Pi Sqrt[kr[[2]] kr[[3]]] (kr[[1]]+kr[[2]])),0]+
            kappaa kappas (zetaf[sl[[1]],sr[[2]],sr[[1]]]-
                    zetaf[sl[[1]],sr[[3]],sr[[1]]])/(8 Pi Sqrt[
                      kr[[2]] kr[[3]]] (kr[[1]]+kr[[2]]))-
            kappaa^2 zetafzetaf[sl[[1]],sr[[3]],sr[[2]],
                  sr[[1]]]/(8 Pi Sqrt[kr[[2]] kr[[3]]] (kr[[1]]+kr[[2]]))+
            If[Rest[sl[[1]]]===Rest[sr[[1]]] && 
                hr[[2]]\[Equal]-hr[[3]],-g2 (kr[[2]]-
                      kr[[3]])/(8 Pi Sqrt[
                        kr[[2]] kr[[3]]] (kl[[1]]-kr[[1]])^2),0],0]+
        (* antiquark-glue-glue \[Rule] antiquark interactions *)
        
        If[Drop[sl,-1]===Drop[sr,-3],
          If[Rest[sl[[-1]]]===Rest[sr[[-1]]],
              kappas^2 /(8 Pi Sqrt[kr[[-2]] kr[[-3]]] (kr[[-1]]+kr[[-2]])),0]-
            kappaa kappas Conjugate[
                  zetaf[sr[[-1]],sr[[-2]],sl[[-1]]]-
                    zetaf[sr[[-1]],sr[[-3]],sl[[-1]]]]/(8 Pi Sqrt[
                      kr[[-2]] kr[[-3]]] (kr[[-1]]+kr[[-2]]))-
            kappaa^2 Conjugate[
                  zetafzetaf[sr[[-1]],sr[[-2]],sr[[-3]],
                    sl[[-1]]]]/(8 Pi Sqrt[
                      kr[[-2]] kr[[-3]]] (kr[[-1]]+kr[[-2]]))+
            If[Rest[sl[[-1]]]===Rest[sr[[-1]]] && hr[[-2]]===-hr[[-3]],
              g2 (kr[[-3]]-
                      kr[[-2]])/(8 Pi Sqrt[
                        kr[[-2]] kr[[-3]]] (kl[[-1]]-kr[[-1]])^2),0],0]+
        (* gauge glue-glue-glue \[Rule] glue interactions *)
        
        Sum[If[Drop[sl,{i}]===Drop[sr,{i,i+2}],
            If[hr[[i+2]]==-hr[[i+1]] && 
                  hr[[i]]\[Equal]
                    hl[[i]],-g2 (kl[[i]]+
                      kr[[i]]) (kr[[i+1]]-
                        kr[[i+2]])/(16 Pi Sqrt[
                          kl[[i]] kr[[i]] kr[[i+1]] kr[[i+2]]] (kr[[i]]-
                              kl[[i]])^2),0]+
              If[hr[[i]]==-hr[[i+1]] && hr[[i+2]]\[Equal]hl[[i]],
                g2 (kl[[i]]+
                      kr[[i+2]]) (kr[[i]]-
                        kr[[i+1]])/(16 Pi Sqrt[
                          kl[[i]] kr[[i]] kr[[i+1]] kr[[i+2]]] (kr[[i+2]]-
                              kl[[i]])^2),0]+
              If[hl[[i]]\[Equal]hr[[i+1]] && hr[[i]]\[Equal]-hr[[i+2]] && 
                  Abs[hl[[i]]]\[NotEqual]
                    Abs[hr[[i]]],-beta/(8 Pi Sqrt[
                        kr[[i]] kr[[i+1]] kr[[i+2]] kl[[i]]]),0]+
              If[hl[[i]]\[Equal]hr[[i+2]] && hr[[i]]\[Equal]-hr[[i+1]] && 
                  hl[[i]]\[Equal]hr[[i]],
                lambda1/(4 Pi Sqrt[kl[[i]] kr[[i+1]] kr[[i+2]] kr[[i]]]),0]+
              If[Abs[hr[[i]]]\[Equal]Abs[hl[[i]]] && 
                  hr[[i]]\[Equal]-hr[[i+2]] && hl[[i]]\[Equal]hr[[i+1]],
                lambda2/(8 Pi Sqrt[kr[[i]] kr[[i+1]] kr[[i+2]] kl[[i]]]),0]+
              If[(hr[[i]]\[Equal]-hr[[i+1]] && hr[[i+2]]\[Equal]hl[[i]]&& 
                      Abs[hr[[i+1]]]\[NotEqual]
                        Abs[hl[[i]]]) ||(hr[[i+2]]\[Equal]-hr[[i+1]] && 
                      hr[[i]]\[Equal]hl[[i]]&& 
                      Abs[hr[[i+1]]]\[NotEqual]Abs[hl[[i]]]),
                lambda4/(8 Pi Sqrt[kl[[i]] kr[[i+1]] kr[[i+2]] kr[[i]]]),0],
            0],{i,2,Length[sl]-1}],
      
      True,
      0
      
      ]]





If[!StringMatchQ[makeham::usage,"*aperp*"],
    makeham::usage=
      makeham::usage<>
        "\n\nmakeham[leftstate,rightstate,aperp,{mub,muf,g2,kappas,kappaa,\
beta,lambda1,lambda2,lambda3,lambda4,lambda5},npmax]  calculates P^- where \
both leftstate and rightstate are in |ket> form and npmax is the maximum \
number of particles, both quarks and gluons, in all states of the basis.  The \
vector aperp is the lattice spacing times transverse momentum."];

choose[x_]:=
    Switch[x[[2]],1,{1,0},2,{0,1},-1,{-1,0},-2,{0,-1},1/2,Null,-1/2,Null];

makeham[sl_,sr_,
    aperp_List,{mub_,muf_,g2_,kappas_,kappaa_,beta_,lambda1_,lambda2_,
      lambda3_,lambda4_,lambda5_},npmax_]:=
  Block[{kl=Map[First,sl],kr=Map[First,sr],hl=Map[choose,sl],
      hr=Map[choose,sr],kt},
    kt=Apply[Plus,kl];
    Which[  
      
      Length[sl]\[Equal]Length[sr],
      (* diagonal interactions *)
      If[sl===sr,
          (* Self-energy interactions *)
          
          muf^2/(2 kl[[1]])+muf^2/(2 kl[[-1]])+
            Sum[mub^2/(2 kl[[i]]),{i,2,Length[sl]-1}]+
            Sum[g2 elfglueglue[kl[[i]],kl[[i+1]]],{i,2,Length[sl]-2}]+
            If[Length[sl]<
                npmax,(kappaa^2+kappas^2)*(elfkappa[kl[[1]]]+
                    elfkappa[kl[[-1]]]),0]+
            g2 If[Length[sl]\[Equal]2, elfquarkquark[kl[[1]],kl[[2]]],
                elfquarkglue[kl[[1]],kl[[2]]]+
                  elfquarkglue[kl[[-1]],kl[[-2]]]],
          (* 
            Strictly non-
                diagnal 2\[Rule]2 particle interactions *)
          (* 
            gluon-gluon \[Rule] gluon-gluon interactions *)
          
          Sum[If[Drop[sl,{i,i+1}]===Drop[sr,{i,i+1}],
                (*Instantaneous gluon-gluon \[Rule] 
                    gluon-gluon normal interaction *)
                
                If[hl[[i]]\[Equal]hr[[i]] && 
                    hl[[i+1]]\[Equal]
                      hr[[i+1]],-Exp[
                        I aperp .((hr[[i]]-hl[[i]])*(kr[[i]]+
                                        kr[[i+1]])+(hr[[i]]+
                                        hr[[i+1]])*(kr[[i+1]]-
                                        kl[[i+1]]))/(2 kt)]*
                    g2*(kl[[i]]+
                        kr[[i]])*(kl[[i+1]]+
                          kr[[i+1]])/(16 Pi Sqrt[
                            kl[[i]]*kr[[i]]*kl[[i+1]]*
                              kr[[i+1]]](kl[[i]]-kr[[i]])^2),0],
                0],{i,2,Length[sl]-2}]+
            If[Length[sl]>2,
              (* quark-gluon \[Rule] quark-gluon interaction *)
              
              If[Drop[sl,2]===Drop[sr,2] && hl[[2]]\[Equal]hr[[2]] && 
                    Rest[sl[[1]]]===
                      Rest[sr[[1]]],-Exp[
                        I aperp .(hl[[2]] (kl[[1]]+kl[[2]]/2)-
                                  hr[[2]] (kr[[1]]+kr[[2]]/2))/kt]*
                    g2*(kl[[2]]+
                          kr[[2]])/(8 Pi Sqrt[
                            kl[[2]] kr[[2]]] (kl[[1]]-kr[[1]])^2),0]+
                (* antiquark-gluon \[Rule] antiquark-gluon interaction *)
    
                            
                If[Drop[sl,-2]===Drop[sr,-2] &&  hl[[-2]]\[Equal]hr[[-2]] &&
                    Rest[sl[[-1]]]===
                      Rest[sr[[-1]]],-Exp[-I aperp .(hl[[-2]] (kl[[-1]]+
                                        kl[[-2]]/2)-
                                  hr[[-2]] (kr[[-1]]+ kr[[-2]]/2))/kt]*
                    g2 (kl[[-2]]+
                          kr[[-2]])/(8 Pi Sqrt[
                            kl[[-2]] kr[[-2]]] (kl[[-1]]-kr[[-1]])^2),0],
              (* quark-quark \[Rule] quark-quark interaction *)
              
              If[ Rest[sl[[1]]]===Rest[sr[[1]]]&& 
                  Rest[sl[[2]]]===Rest[sr[[2]]],
                -g2/(4 Pi (kl[[1]]-kr[[1]])^2),0]
              ]
          ]+
        (* Both diagonal and non-diagonal interactions *)
        
        If[Length[sl]>2,
          (* quark-gluon \[Rule] quark-gluon interactions *)
          
          If[Drop[sl,2]===Drop[sr,2],
              Exp[I aperp .(hl[[2]] (kl[[1]]+kl[[2]]/2)-
                            hr[[2]] (kr[[1]]+kr[[2]]/2))/kt]*(If[
                      Rest[sl[[1]]]===Rest[sr[[1]]],
                      kappas^2/(8 Pi Sqrt[kl[[2]] kr[[2]]] (kr[[1]]+kr[[2]])),
                      0]+kappaa kappas (zetaf[sl[[1]],sl[[2]],sr[[1]]]+
                            zetaf[sl[[1]],sr[[2]],sr[[1]]])/(8 Pi Sqrt[
                              kl[[2]] kr[[2]]] (kr[[1]]+kr[[2]]))+
                    kappaa^2 zetafzetaf[sl[[1]],sl[[2]],sr[[2]],
                          sr[[1]]]/(8 Pi Sqrt[
                              kl[[2]] kr[[2]]] (kr[[1]]+kr[[2]]))),0]+
            (* antiuark-gluon \[Rule] antiquark-gluon interactions *)
        
                If[Drop[sl,-2]===Drop[sr,-2],
              Exp[-I aperp .(hl[[-2]] (kl[[-1]]+kl[[-2]]/2)-
                            hr[[-2]] (kr[[-1]]+ kr[[-2]]/2))/kt]*(If[
                      Rest[sl[[-1]]]===Rest[sr[[-1]]],
                      kappas^2/(8 Pi Sqrt[
                              kl[[-2]] kr[[-2]]] (kr[[-1]]+kr[[-2]])),0]-
                    kappaa kappas Conjugate[
                          zetaf[sr[[-1]],sl[[-2]],sl[[-1]]]+
                            zetaf[sr[[-1]],sr[[-2]],sl[[-1]]]]/(8 Pi Sqrt[
                              kl[[-2]] kr[[-2]]] (kr[[-1]]+kr[[-2]]))+
                    kappaa^2 Conjugate[
                          zetafzetaf[sr[[-1]],sr[[-2]],sl[[-2]],
                            sl[[-1]]]]/(8 Pi Sqrt[
                              kl[[-2]] kr[[-2]]] (kr[[-1]]+kr[[-2]]))),0],0]+
        (* gluon-gluon \[Rule] gluon-gluon interactions *)
        
        Sum[If[Drop[sl,{i,i+1}]===Drop[sr,{i,i+1}] ,
            
            Exp[I aperp .((hr[[i]]-hl[[i]])*(kr[[i]]+kr[[i+1]])+(hr[[i]]+
                                hr[[i+1]])*(kr[[i+1]]-kl[[i+1]]))/(2 kt)]*(
                (*Instantaneous annihilation interaction *)
                
                If[ hl[[i]]==-hl[[i+1]] && hr[[i]]\[Equal]-hr[[i+1]],
                    g2*(kl[[i]]-
                          kl[[i+1]])*(kr[[i]]-
                            kr[[i+1]])/(16 Pi Sqrt[
                              kl[[i]]*kr[[i]]*kl[[i+1]]*
                                kr[[i+1]]](kl[[i]]+kl[[i+1]])^2),0]+
                  (* Effective potential terms *)
                  
                  If[hl[[i]]\[Equal]hr[[i+1]] && hr[[i]]\[Equal]hl[[i+1]] && 
                      Abs[hl[[i]]]\[NotEqual]
                        Abs[hr[[i]]],-beta/(8 Pi Sqrt[
                            kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),0]+
                  If[hl[[i]]\[Equal]-hl[[i+1]] && hr[[i]]\[Equal]-hr[[i+1]] && 
                      hl[[i]]\[Equal]hr[[i]],
                    lambda1/(4 Pi Sqrt[kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),
                    0]+If[hl[[i]]\[Equal]hr[[i+1]] && 
                      hr[[i]]\[Equal]hl[[i+1]] && 
                      Abs[hl[[i]]]\[Equal]Abs[hr[[i]]],
                    lambda2/(8 Pi Sqrt[kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),
                    0]+If[(hl[[i]]\[Equal]-hl[[i+1]] && 
                          hr[[i]]\[Equal]-hr[[i+1]] && 
                          Abs[hl[[i]]]\[NotEqual]
                            Abs[hr[[i]]])||(hl[[i]]\[Equal]hr[[i]] && 
                          hr[[i+1]]\[Equal]hl[[i+1]] && 
                          Abs[hl[[i]]]\[NotEqual]Abs[hl[[i+1]]]),
                    lambda4/(8 Pi Sqrt[kr[[i]] kr[[i+1]] kl[[i]] kl[[i+1]]]),
                    0]),0],{i,2,Length[sl]-2}],
      
      Length[sl]==Length[sr]+1,
      (* Yukawa quark \[Rule] quark-gluon interactions *) 
      If[Drop[sl,2]===Drop[sr,1],
          Exp[I aperp .hl[[2]](kl[[1]]+kl[[2]]/2)/kt]*(If[
                  Rest[sl[[1]]]===
                    Rest[sr[[1]]],-kappas muf (kl[[1]]+
                          kr[[1]])/(4  Sqrt[Pi kl[[2]]] kl[[1]] kr[[1]]),0]+
                muf kappaa Sqrt[
                    kl[[2]]] zetaf[sl[[1]],sl[[2]],
                      sr[[1]]]/(4  Sqrt[Pi] kr[[1]] kl[[1]])),0]+
        (* Yukawa antiquark \[Rule] antiquark-gluon interactions *) 
        If[Drop[sl,-2]===Drop[sr,-1],
          Exp[-I aperp .hl[[-2]](kl[[-1]]+kl[[-2]]/2)/kt]*(If[
                  Rest[sl[[-1]]]===
                    Rest[sr[[-1]]],-kappas  muf  (kl[[-1]]+ 
                          kr[[-1]])/(4 Sqrt[Pi kl[[-2]]] kl[[-1]] kr[[-1]] ),
                  0]-kappaa  muf Sqrt[
                    kr[[-1]]-kl[[-1]]]  Conjugate[
                      zetaf[sr[[-1]],sl[[-2]],
                        sl[[-1]]]]/(4 Sqrt[Pi] kl[[-1]] kr[[-1]] )) ,
          0],
      
      Length[sl]==Length[sr]+2,
      (* quark \[Rule] quark-glue-glue interactions *)
      
      If[Drop[sl,3]===Drop[sr,1],
          Exp[I aperp .(kl[[1]] (hl[[2]]+hl[[3]])+kl[[2]] (hl[[2]]/2+hl[[3]])+
                        kl[[3]] hl[[3]]/2)/kt]*(If[
                  Rest[sl[[1]]]===Rest[sr[[1]]],
                  kappas^2 /(8 Pi Sqrt[kl[[2]] kl[[3]]] (kl[[1]]+kl[[2]])),0]+
                kappaa kappas (zetaf[sl[[1]],sl[[3]],sr[[1]]]-
                        zetaf[sl[[1]],sl[[2]],sr[[1]]])/(8 Pi Sqrt[
                          kl[[2]] kl[[3]]] (kl[[3]]-kr[[1]]))+
                kappaa^2 zetafzetaf[sl[[1]],sl[[2]],sl[[3]],
                      sr[[1]]]/(8 Pi Sqrt[kl[[2]] kl[[3]]] (kl[[3]]-kr[[1]]))+
                If[Rest[sl[[1]]]===Rest[sr[[1]]] && 
                    hl[[2]]\[Equal]-hl[[3]],-g2 (kl[[2]]-
                          kl[[3]])/(8 Pi Sqrt[
                            kl[[2]] kl[[3]]] (kl[[1]]-kr[[1]])^2),0]),0]+
        (* antiquark \[Rule] antiquark-glue-glue interactions *)
        
        If[Drop[sl,-3]===Drop[sr,-1],
          Exp[-I aperp .(kl[[-1]] (hl[[-2]]+hl[[-3]])+
                        kl[[-2]] (hl[[-2]]/2+hl[[-3]])+kl[[-3]] hl[[-3]]/2)/
                  kt]*(If[Rest[sl[[-1]]]===Rest[sr[[-1]]],
                  kappas^2 /(8 Pi Sqrt[
                          kl[[-2]] kl[[-3]]] (kl[[-1]]+kl[[-2]])),0]+
                kappaa kappas Conjugate[
                      zetaf[sr[[-1]],sl[[-3]],sl[[-1]]]-
                        zetaf[sr[[-1]],sl[[-2]],sl[[-1]]]]/(8 Pi Sqrt[
                          kl[[-2]] kl[[-3]]] (kl[[-1]]+kl[[-2]]))-
                kappaa^2 Conjugate[
                      zetafzetaf[sr[[-1]],sl[[-3]],sl[[-2]],
                        sl[[-1]]]]/(8 Pi Sqrt[
                          kl[[-2]] kl[[-3]]] (kl[[-1]]+kl[[-2]]))+
                If[Rest[sl[[-1]]]===Rest[sr[[-1]]] && 
                    hl[[-2]]\[Equal]-hl[[-3]],
                  g2 (kl[[-3]]-
                          kl[[-2]])/(8 Pi Sqrt[
                            kl[[-2]] kl[[-3]]] (kl[[-1]]-kr[[-1]])^2),0]),0]+
        (* gauge glue \[Rule] glue-glue-glue interactions *)
        
        Sum[If[Drop[sl,{i,i+2}]===Drop[sr,{i}],
            Exp[-I aperp .(kl[[i]] (hl[[i]]-hr[[i]])+
                          kl[[i+1]] (hl[[i]]-hl[[i+2]])+
                          kl[[i+2]] (hl[[i]]+hl[[i+1]]))/(2 kt)]*(If[
                    hl[[i+2]]==-hl[[i+1]] && 
                      hl[[i]]\[Equal]
                        hr[[i]],-g2 (kl[[i]]+
                          kr[[i]]) (kl[[i+1]]-
                            kl[[i+2]])/(16 Pi Sqrt[
                              kl[[i]] kr[[i]] kl[[i+1]] kl[[i+2]]] (kr[[i]]-
                                  kl[[i]])^2),0]+
                  If[hl[[i]]==-hl[[i+1]] && hl[[i+2]]\[Equal]hr[[i]],
                    g2 (kr[[i]]+
                          kl[[i+2]]) (kl[[i]]-
                            kl[[i+1]])/(16 Pi Sqrt[
                              kl[[i]] kr[[i]] kl[[i+1]] kl[[i+2]]] (kl[[i+2]]-
                                  kr[[i]])^2),0]+
                  If[hr[[i]]\[Equal]hl[[i+1]] && hl[[i]]\[Equal]-hl[[i+2]] && 
                      Abs[hl[[i]]]\[NotEqual]
                        Abs[hr[[i]]],-beta/(8 Pi Sqrt[
                            kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),0]+
                  If[hr[[i]]\[Equal]hl[[i+2]] && hl[[i]]\[Equal]-hl[[i+1]] && 
                      hl[[i]]\[Equal]hr[[i]],
                    lambda1/(4 Pi Sqrt[kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),
                    0]+If[Abs[hr[[i]]]\[Equal]Abs[hl[[i]]] && 
                      hl[[i]]\[Equal]-hl[[i+2]] && hl[[i+1]]\[Equal]hr[[i]],
                    lambda2/(8 Pi Sqrt[kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),
                    0]+If[(hl[[i]]\[Equal]-hl[[i+1]] && 
                          hl[[i+2]]\[Equal]hr[[i]]&& 
                          Abs[hl[[i+1]]]\[NotEqual]
                            Abs[hr[[i]]]) ||(hl[[i+2]]\[Equal]-hl[[i+1]] && 
                          hl[[i]]\[Equal]hr[[i]]&& 
                          Abs[hl[[i+1]]]\[NotEqual]Abs[hr[[i]]]),
                    lambda4/(8 Pi Sqrt[kl[[i]] kl[[i+1]] kl[[i+2]] kr[[i]]]),
                    0]),0],{i,2,Length[sr]-1}],
      
      Length[sl]==Length[sr]-1,
      (* Yukawa quark-gluon \[Rule] quark interactions *) 
      If[Drop[sl,1]===Drop[sr,2],
          Exp[-I aperp .hr[[2]](kr[[1]]+kr[[2]]/2)/kt]*(If[
                  Rest[sl[[1]]]===
                    Rest[sr[[1]]],-kappas  muf  (kl[[1]]+
                          kr[[1]])/(4 Sqrt[Pi kr[[2]]] kl[[1]] kr[[1]]) ,0]+
                kappaa  muf Sqrt[
                    kr[[2]]]  zetaf[sl[[1]],sr[[2]],
                      sr[[1]]]/(4 Sqrt[Pi] kr[[1]] kl[[1]])) ,0]+(* 
          Yukawa antiquark-gluon \[Rule] antiquark interactions *) 
        If[Drop[sl,-1]===Drop[sr,-2],
          Exp[I aperp .hr[[-2]](kr[[-1]]+kr[[-2]]/2)/kt]*(If[
                  Rest[sl[[-1]]]===
                    Rest[sr[[-1]]],-kappas  muf  (kr[[-1]]+
                          kl[[-1]])/(4 Sqrt[Pi kr[[-2]]] kr[[-1]] kl[[-1]]) ,
                  0]-kappaa  muf Sqrt[
                    kr[[-2]]]  Conjugate[
                      zetaf[sr[[-1]],sr[[-2]],
                        sl[[-1]]]]/(4 Sqrt[Pi] kr[[-1]] kl[[-1]])) ,0],
      
      Length[sl]==Length[sr]-2,
      (* quark-glue-glue \[Rule] quark interactions *)
      
      If[Drop[sl,1]===Drop[sr,3],
          Exp[-I aperp .(kr[[1]] (hr[[2]]+hr[[3]])+
                        kr[[2]] (hr[[2]]/2+hr[[3]])+kr[[3]] hr[[3]]/2)/
                  kt]*(If[Rest[sl[[1]]]===Rest[sr[[1]]],
                  kappas^2 /(8 Pi Sqrt[kr[[2]] kr[[3]]] (kr[[1]]+kr[[2]])),0]+
                kappaa kappas (zetaf[sl[[1]],sr[[2]],sr[[1]]]-
                        zetaf[sl[[1]],sr[[3]],sr[[1]]])/(8 Pi Sqrt[
                          kr[[2]] kr[[3]]] (kr[[1]]+kr[[2]]))-
                kappaa^2 zetafzetaf[sl[[1]],sr[[3]],sr[[2]],
                      sr[[1]]]/(8 Pi Sqrt[kr[[2]] kr[[3]]] (kr[[1]]+kr[[2]]))+
                If[Rest[sl[[1]]]===Rest[sr[[1]]] && 
                    hr[[2]]\[Equal]-hr[[3]],-g2 (kr[[2]]-
                          kr[[3]])/(8 Pi Sqrt[
                            kr[[2]] kr[[3]]] (kl[[1]]-kr[[1]])^2),0]),0]+
        (* antiquark-glue-glue \[Rule] antiquark interactions *)
        
        If[Drop[sl,-1]===Drop[sr,-3],
          Exp[I aperp .(kr[[-1]] (hr[[-2]]+hr[[-3]])+
                        kr[[-2]] (hr[[-2]]/2+hr[[-3]])+kr[[-3]] hr[[-3]]/2)/
                  kt]*(If[Rest[sl[[-1]]]===Rest[sr[[-1]]],
                  kappas^2 /(8 Pi Sqrt[
                          kr[[-2]] kr[[-3]]] (kr[[-1]]+kr[[-2]])),0]-
                kappaa kappas Conjugate[
                      zetaf[sr[[-1]],sr[[-2]],sl[[-1]]]-
                        zetaf[sr[[-1]],sr[[-3]],sl[[-1]]]]/(8 Pi Sqrt[
                          kr[[-2]] kr[[-3]]] (kr[[-1]]+kr[[-2]]))-
                kappaa^2 Conjugate[
                      zetafzetaf[sr[[-1]],sr[[-2]],sr[[-3]],
                        sl[[-1]]]]/(8 Pi Sqrt[
                          kr[[-2]] kr[[-3]]] (kr[[-1]]+kr[[-2]]))+
                If[Rest[sl[[-1]]]===Rest[sr[[-1]]] && hr[[-2]]===-hr[[-3]],
                  g2 (kr[[-3]]-
                          kr[[-2]])/(8 Pi Sqrt[
                            kr[[-2]] kr[[-3]]] (kl[[-1]]-kr[[-1]])^2),0]),0]+
        (* gauge glue-glue-glue \[Rule] glue interactions *)
        
        Sum[If[Drop[sl,{i}]===Drop[sr,{i,i+2}],
            Exp[I aperp .(kr[[i]] (hr[[i]]-hl[[i]])+
                          kr[[i+1]] (hr[[i]]-hr[[i+2]])+
                          kr[[i+2]] (hr[[i]]+hr[[i+1]]))/(2 kt)]*(If[
                    hr[[i+2]]==-hr[[i+1]] && 
                      hr[[i]]\[Equal]
                        hl[[i]],-g2 (kl[[i]]+
                          kr[[i]]) (kr[[i+1]]-
                            kr[[i+2]])/(16 Pi Sqrt[
                              kl[[i]] kr[[i]] kr[[i+1]] kr[[i+2]]] (kr[[i]]-
                                  kl[[i]])^2),0]+
                  If[hr[[i]]==-hr[[i+1]] && hr[[i+2]]\[Equal]hl[[i]],
                    g2 (kl[[i]]+
                          kr[[i+2]]) (kr[[i]]-
                            kr[[i+1]])/(16 Pi Sqrt[
                              kl[[i]] kr[[i]] kr[[i+1]] kr[[i+2]]] (kr[[i+2]]-
                                  kl[[i]])^2),0]+
                  If[hl[[i]]\[Equal]hr[[i+1]] && hr[[i]]\[Equal]-hr[[i+2]] && 
                      Abs[hl[[i]]]\[NotEqual]
                        Abs[hr[[i]]],-beta/(8 Pi Sqrt[
                            kr[[i]] kr[[i+1]] kr[[i+2]] kl[[i]]]),0]+
                  If[hl[[i]]\[Equal]hr[[i+2]] && hr[[i]]\[Equal]-hr[[i+1]] && 
                      hl[[i]]\[Equal]hr[[i]],
                    lambda1/(4 Pi Sqrt[kl[[i]] kr[[i+1]] kr[[i+2]] kr[[i]]]),
                    0]+If[Abs[hr[[i]]]\[Equal]Abs[hl[[i]]] && 
                      hr[[i]]\[Equal]-hr[[i+2]] && hl[[i]]\[Equal]hr[[i+1]],
                    lambda2/(8 Pi Sqrt[kr[[i]] kr[[i+1]] kr[[i+2]] kl[[i]]]),
                    0]+If[(hr[[i]]\[Equal]-hr[[i+1]] && 
                          hr[[i+2]]\[Equal]hl[[i]]&& 
                          Abs[hr[[i+1]]]\[NotEqual]
                            Abs[hl[[i]]]) ||(hr[[i+2]]\[Equal]-hr[[i+1]] && 
                          hr[[i]]\[Equal]hl[[i]]&& 
                          Abs[hr[[i+1]]]\[NotEqual]Abs[hl[[i]]]),
                    lambda4/(8 Pi Sqrt[kl[[i]] kr[[i+1]] kr[[i+2]] kr[[i]]]),
                    0]),0],{i,2,Length[sl]-1}],
      
      True,
      0
      
      ]]

















































































