#
#  machine specific commands and flags
#
ifeq ($(shell uname -m),x86_64)
  CFLAGS= -Wall -O3 -m64
else
  CFLAGS= -Wall -O3 -m32 -march=i686
endif
#
#  For liblong.a, I found:
#  It looks like specifying optimization e.g. -O1 doesn't work.
#  with RedHat g77 version 2.96, optimization -O3 works...
#  with GNU F77 version 3.0.4, optimization greater than -O1 doesn't work
#
#  -O3 -fbounds-check 
# should have -O when debugging
# align-double: according to g77 info, this is always good for 32 bits.
# march=i686: machine-specific instructions for i686
#
FC=g77
MPIFC=mpif77
ifeq ($(shell uname -m),x86_64)
  FFLAGS= -Wall -O2 -m64
else
  FFLAGS= -Wall -O2 -march=i686 -m32
endif
#
# flag for compiler macro directive
#
DFLAG=-D
NOOPT=-O0

AR=ar
RANLIB=ranlib
CD=cd
RM=rm
ECHO=echo
MAKE=/usr/bin/gmake
#
# Destination directory for libraries
#
ifeq ($(shell uname -m),x86_64)
  LIBDIR=../
else
  LIBDIR=../32
endif



