C
C  This computes various machine error quantities
C  the results are put in the rdata common block.
C  See the include file "rdata.f"
C

      SUBROUTINE FINDEPSILON(N,CONDM,KAPPA)
      IMPLICIT NONE
      INTEGER N,DONE
      DOUBLE PRECISION CONDM,KAPPA
C
C     N is the global size of the matrix (NTOTAL if MPI is used)
C
      INCLUDE 'rdata.f'
C
C.... Use D1MACH to find EPS.  (BLAS auxilary routine)
C.... Was using MACHAR but MACHAR doesn't work on g77: it
C.... returns the register value for EPS.
C
      DOUBLE PRECISION D1MACH
      DATA DONE/0/
C
      IF(DONE.EQ.0)THEN
         EPS = D1MACH(4)
         REPS = SQRT(EPS)
         EPS34 = REPS*SQRT(REPS)
         DONE = 1
      ENDIF
      EPS1 = EPS*SQRT(DBLE(N))
      EPSN = EPS*DBLE(N)
      RCEPS1 = SQRT(MAX(ABS(CONDM),1.0D0))*EPS1
C 
C....    rationalize KAPPA
C   BvdS: this was forgotten by Wu and Simon, KAPPA is used by laconv(...)
C
      KAPPA = MAX(ABS(KAPPA),EPS34)
      END



