#ifndef MPI_FUNCTIONS_INCLUDED
#define MPI_FUNCTIONS_INCLUDED
C
C  Redefine function names and arguements (adding the MPICOM) 
C  for the parallel case.
C
C  Unfortunately, they do not work for functions with line
C  continuation (such cases must be done by hand)
C
#ifdef USE_MPI
C
#ifdef COMPLEX_VERSION
#define OP_(B1,B2,B3,B4) ZOP(B1,B2,B3,B4,MPICOM)
#define OPM_(B1,B2,B3) ZOPM(B1,B2,B3,MPICOM)
#else
#define OP_(B1,B2,B3,B4) OP(B1,B2,B3,B4,MPICOM)
#define OPM_(B1,B2,B3) OPM(B1,B2,B3,MPICOM)
#endif
C
#define ZDOTC(A1,A2,A3,A4,A5) ZDOTCMPI(A1,A2,A3,A4,A5,MPICOM)
#define zCHECKORTHO(N,J,Q,QA,MSGLVL) pzCHECKORTHO(N,J,Q,QA,MSGLVL,MPICOM)
#define CHECKORTHO(N,J,Q,QA,MSGLVL) pCHECKORTHO(N,J,Q,QA,MSGLVL,MPICOM)
#define DDOT(N,DX,INCX,DY,INCY) DDOTMPI(N,DX,INCX,DY,INCY,MPICOM)
#define STARTV(N,J,R,RA,Q,EPS,MSGLVL) pSTARTV(N,J,R,RA,Q,EPS,MSGLVL,MPICOM)
#define zSTARTV(N,J,R,RA,Q,EPS,MSGLVL) pzSTARTV(N,J,R,RA,Q,EPS,MSGLVL,MPICOM)
#define STPONE(N,ALF,R,RA,Q,QA,MSGLVL) pSTPONE(N,ALF,R,RA,Q,QA,MSGLVL,MPICOM)
#define zSTPONE(N,ALF,R,RA,Q,QA,MSGLVL) pzSTPONE(N,ALF,R,RA,Q,QA,MSGLVL,MPICOM)
C
#else
C
#ifdef COMPLEX_VERSION
#define OP_(B1,B2,B3,B4) ZOP(B1,B2,B3,B4)
#define OPM_(B1,B2,B3) ZOPM(B1,B2,B3)
#else
#define OP_(B1,B2,B3,B4) OP(B1,B2,B3,B4)
#define OPM_(B1,B2,B3) OPM(B1,B2,B3)
#endif
C
#endif 
C
#endif





