C
C @(#)ritvec.f	1.7 (BNP) 5/18/89
C
      SUBROUTINE RITVEC(N,J,MAXPRS,VEC,KAPPA,RITZ,BND,ALF,BET,
     *     Q,IERR,MSGLVL)
      IMPLICIT NONE
      INTEGER N,J,MAXPRS,IERR,MSGLVL
      DOUBLE PRECISION KAPPA,RITZ(J),BND(J),ALF(J),BET(J+1)
      DOUBLE PRECISION VEC(N,MAXPRS),Q(N,J)
C
C   Subroutine to calculate eigenvectors given the
C   Ritz vectors.
C
C   J      (input) number of lanzos steps taken.
C   MAXPRS (input) number of eigenvectors to calculate
C   VEC    (output) array containing the eigenvectors
C   Q      (input) array containing Q, the Ritz vectors
C   KAPPA  (input/output) Relative accuracy desired for Ritz
C          Ritz vectors.  It is only used by this routine.
C
C.... subroutines:      TQL2,DSTQRB,STORE
C.... BLAS routines:    DAXPY,DCOPY,DSCAL
C
      DOUBLE PRECISION WRK1(N),BETA(J-1),WRK2(2*J),S(J,J)
C
      INTEGER K
      DOUBLE PRECISION ZERO,ONE
      PARAMETER (ZERO=0.0D0,ONE=1.0D0)
      CHARACTER*1 COMPZ,TRANS
      PARAMETER(COMPZ='I',TRANS='N')
C
C
C  Find the eigenvectors of the J by J tridiagonal matrix
C  This operation is replicated on each processor.
C
      CALL DCOPY(J,ALF,1,WRK1,1)
      IF (J.GT.1) CALL DCOPY(J-1,BET(2),1,BETA,1)
      CALL DSTEQR(COMPZ,J,WRK1,BETA,S,J,WRK2,IERR)
      IF (IERR.NE.0) RETURN
C     
C.... on return WRK1 contains eigenvalues in ascending order
C.... and S contains the corresponding eigenvectors
C     
C
      DO K = 1,MAXPRS
         IF (BND(K).GT.KAPPA*ABS(RITZ(K))) THEN
            PRINT *,'RITZ VECTOR K=',K,' NOT CONVERGED, BND=',BND(K)
            PRINT *,'  KAPPA=',KAPPA,' RITZ=',RITZ(K)
            IERR=IERR+2048
         ENDIF
         CALL DGEMV ( TRANS, N, J, ONE, Q, N, S(1,K), 1,
     $        ZERO, VEC(1,K), 1 )         
      ENDDO
      RETURN
      END
      









