C
C @(#)stpone.f	3.13 (BNP) 6/3/89; from stpone.f 2.8 6/17/88
C
C
#include "mpi_functions.h"
#ifdef USE_MPI
      SUBROUTINE pSTPONE(N,ALF,R,RA,Q,QA,MSGLVL,MPICOM)
#else
      SUBROUTINE STPONE(N,ALF,R,RA,Q,QA,MSGLVL)
#endif
      IMPLICIT NONE
      INTEGER N,MSGLVL
      DOUBLE PRECISION R(N),RA(N),Q(N,1),QA(N),ALF(1)
C
C.... This routine performs the first step of the Lanczos algorithm.
C.... It performs a step of extended local re-orthogonalization.
C
C.... N      dimension of the eigenproblem
C.... ALF    diagonal elements of T
C.... R      an array containing new Lanczos vector
C.... RA     M.R array
C.... Q      array containing previous Lanczos vectors
C.... QA     M.Q(1)
C.... MPICOM MPI communicator
C
C.... BLAS routines:    DATX,DAXPY,DDOT,DSCAL
C.... subroutines:      STARTV,DDOTMPI
C.... user-supplied:    OP,OPM,STORE
C
C
C.... common block for machine epsilon and related variables
C
      INCLUDE 'rdata.f'
C
      DOUBLE PRECISION T
C
#ifdef USE_MPI
      INTEGER MPICOM
      DOUBLE PRECISION pSTARTV,DDOTMPI
#else
      DOUBLE PRECISION STARTV,DDOT
#endif
C
      DOUBLE PRECISION ZERO,ONE
      PARAMETER (ZERO=0.0D0, ONE=1.0D0)
C
C.... get initial vector
C
      RNM = STARTV(N,1,Q,QA,Q,EPS,MSGLVL)
      IF (RNM.EQ.ZERO) RETURN
C
C.... normalize starting vector
C
      T = ONE/RNM
      CALL DSCAL(N,T,Q,1)
      CALL DSCAL(N,T,QA,1)
C
C.... take the first step
C
      CALL OP_(N,QA,Q,R)
      T = DDOT(N,QA,1,R,1)
      CALL DAXPY(N,-T,Q(1,1),1,R,1)
      ALF(1)=T
C
C.... restore local orthogonality
C
      T = DDOT(N,QA,1,R,1)
      CALL DAXPY(N,-T,Q(1,1),1,R,1)
      ALF(1) = ALF(1)+T
      CALL OPM_(N,R,RA)
      RNM = SQRT(DDOT(N,RA,1,R,1))
      ANORM = RNM+ABS(ALF(1))
      TOL = EPSN*ANORM
C
      RETURN
      END


