C
C   MPI version of ZDOTC routine in BLAS
C
      DOUBLE COMPLEX FUNCTION ZDOTCMPI(N,DX,INCX,DY,INCY,MPICOM)
      IMPLICIT NONE
      INCLUDE 'mpif.h'
C
C     forms the dot product of two conformally distributed vectors
C
      DOUBLE COMPLEX DX(*), DY(*), STEMP, ZDOTC
      INTEGER IERR,N,INCX,INCY,MPICOM
      EXTERNAL DDOT
C
C     call  ZDOTC on local data to compute partial sum
C
      STEMP = ZDOTC(N,DX,INCX,DY,INCY)
      IERR = 0
C
C     call MPI communication routine to add the partial sums together
C
         CALL MPI_ALLREDUCE(STEMP,ZDOTCMPI,1,MPI_DOUBLE_COMPLEX,
     $        MPI_SUM,MPICOM,IERR)
      IF (IERR.NE.MPI_SUCCESS) CALL MPI_ABORT(MPI_COMM_WORLD,IERR)
C
      RETURN

      END
