C
C @(#)ritvec.f	1.7 (BNP) 5/18/89
C
C    
C
      SUBROUTINE zRITVEC(N,J,MAXPRS,VEC,KAPPA,RITZ,BND,ALF,BET,
     *     Q,IERR,MSGLVL)
      IMPLICIT NONE
      INTEGER N,J,MAXPRS,IERR,MSGLVL
      DOUBLE PRECISION KAPPA,RITZ(J),BND(J),ALF(J),BET(J)
      DOUBLE COMPLEX VEC(N,MAXPRS),Q(N,J) 
C
C   Complex version
C
C   Subroutine to calculate eigenvectors given the
C   Ritz vectors.
C
C   J      (input) number of lanzos steps taken.
C   MAXPRS (input) number of eigenvectors to calculate
C   VEC    (output) array containing the eigenvectors
C   Q      (input) array containing Q, the Ritz vectors
C   KAPPA  (input/output) Relative accuracy desired for Ritz
C          Ritz vectors.  It is only used by this routine.
C
C.... subroutines:      TQL2,STORE
C.... BLAS routines:    DCOPY,DSCAL,ZDSCAL,ZAXPY
C
      DOUBLE PRECISION ALPHA(J),BETA(J-1),DWRK(2*J),S(J,J)
      DOUBLE COMPLEX ZWORK(J)
C
      INTEGER I,K
      DOUBLE PRECISION ZERO
      PARAMETER (ZERO=0.0D0)
      DOUBLE COMPLEX ZONE
      PARAMETER ( ZONE  = ( 1.0D+0, 0.0D+0 ) )
      DOUBLE COMPLEX ZZERO
      PARAMETER ( ZZERO = ( 0.0D+0, 0.0D+0 ) )
      CHARACTER*1 COMPZ,TRANS
      PARAMETER(COMPZ='I',TRANS='N')
C
C
C  Find the eigenvectors of the J by J tridiagonal matrix
C  This operation is replicated on each processor.
C
      CALL DCOPY(J,ALF,1,ALPHA,1)
      IF (J.GT.1) CALL DCOPY(J-1,BET(2),1,BETA,1)
      CALL DSTEQR(COMPZ,J,ALPHA,BETA,S,J,DWRK,IERR)
      IF (IERR.NE.0) RETURN
C     
C.... on return ALPHA contains eigenvalues in ascending order
C.... and S contains the corresponding eigenvectors
C     
C     
      DO K = 1,MAXPRS
         IF (BND(K).GT.KAPPA*ABS(RITZ(K))) THEN
            PRINT *,'RITZ VECTOR K=',K,' NOT CONVERGED, BND=',BND(K)
            PRINT *,'  KAPPA=',KAPPA,' RITZ=',RITZ(K)
            IERR=IERR+2048
         ENDIF
         DO I = 1,J
            ZWORK(I)=DCMPLX(S(I,K),ZERO)
         ENDDO
         CALL ZGEMV ( TRANS, N, J, ZONE, Q, N, ZWORK, 1,
     $        ZZERO, VEC(1,K), 1 )         
      ENDDO
      RETURN
      END
      
