C
C @(#)stpone.f	3.13 (BNP) 6/3/89; from stpone.f 2.8 6/17/88
C
#define COMPLEX_VERSION
#include "mpi_functions.h"
#ifdef USE_MPI
      SUBROUTINE pzSTPONE(N,ALF,R,RA,Q,QA,MSGLVL,MPICOM)
#else
      SUBROUTINE zSTPONE(N,ALF,R,RA,Q,QA,MSGLVL)
#endif
      IMPLICIT NONE
      INTEGER N,MSGLVL,IERR
      DOUBLE PRECISION ALF(1)
      DOUBLE COMPLEX  R(N),RA(N),Q(N,1),QA(N)
C
C.... This routine performs the first step of the Lanczos algorithm.
C.... It performs a step of extended local re-orthogonalization.
C
C.... N      dimension of the eigenproblem
C.... ALF    diagonal elements of T
C.... R      an array containing new Lanczos vector
C.... RA     M.R array
C.... Q      array containing previous Lanczos vectors
C.... QA     M.Q(1)
C.... MPICOM MPI communicator
C
C.... BLAS routines:    DAXPY,DDOT,ZDSCAL, ZCOPY
C.... subroutines:      zSTARTV,DDOTMPI
C.... user-supplied:    OP,OPM,STORE
C
C
C.... common block for machine epsilon and related variables
C
      INCLUDE 'rdata.f'
C
      DOUBLE PRECISION REALONLY
      DOUBLE PRECISION T
C
#ifdef USE_MPI
      INTEGER MPICOM
      DOUBLE PRECISION pzSTARTV
      DOUBLE COMPLEX ZDOTCMPI
#else
      DOUBLE PRECISION zSTARTV
      DOUBLE COMPLEX ZDOTC
#endif
C
      DOUBLE PRECISION ZERO,ONE
      PARAMETER (ZERO=0.0D0,ONE=1.0D0)
C
C.... get initial vector, default is random
C
      RNM = zSTARTV(N,1,Q,QA,Q,EPS,MSGLVL)
      IF (RNM.EQ.ZERO) RETURN
C
C.... normalize starting vector
C
      T = ONE/RNM
      CALL ZDSCAL(N,T,Q,1)
      CALL ZDSCAL(N,T,QA,1)
C
C.... take the first step
C
      CALL OP_(N,QA,Q,R)
C
C.... If M and K are Hermetian, this should be real:
C
      T = REALONLY(ZDOTC(N,QA,1,R,1),IERR)
      CALL ZAXPY(N,-DCMPLX(T,ZERO),Q,1,R,1)
      ALF(1) = T
C
C.... restore local orthogonality
C     It is not obvious, but this is real:
C
      T = REALONLY(ZDOTC(N,QA,1,R,1),IERR)
      CALL ZAXPY(N,-DCMPLX(T,ZERO),Q,1,R,1)
      ALF(1) = ALF(1)+T
      CALL OPM_(N,R,RA)
      RNM = SQRT(REALONLY(ZDOTC(N,RA,1,R,1),IERR))
      ANORM = RNM+ABS(ALF(1))
      TOL = EPSN*ANORM
C
      RETURN
      END










