#include <stdio.h>
#include <stdlib.h>
#include "hamilton.h"
#include "fortran.h"
#include <float.h>
#define ZEROTEST(A) ((A) < DBL_EPSILON) /*macro for testing if equal to zero*/

int main()
{
  /* make test case */
  doublecomplex *test = malloc(9*sizeof(doublecomplex));
  integer *testr = malloc(7*sizeof(integer));
  integer *testc = malloc(9*sizeof(integer));
  test[0].re=1;
  test[0].im=0;
  test[1].re=0;
  test[1].im=2;
  test[2].re=4;
  test[2].im=0;
  test[3].re=2;
  test[3].im=0;
  test[4].re=3;
  test[4].im=0;
  test[5].re=0;
  test[5].im=1;
  test[6].re=1;
  test[6].im=0;
  test[7].re=0;
  test[7].im=-1;
  test[8].re=2;
  test[8].im=0;
  testc[0]=0;
  testc[1]=2;
  testc[2]=5;
  testc[3]=1;
  testc[4]=3;
  testc[5]=4;
  testc[6]=2;
  testc[7]=5;
  testc[8]=4;
  testr[0]=0;
  testr[1]=3;
  testr[2]=6;
  testr[3]=8;
  testr[4]=8;
  testr[5]=9;
  testr[6]=9;

  integer nz = 9;
  integer neqns = 6;
  integer num = 4;
  integer na = 2;
  integer nb = 3;
  integer nc = 4;

  double *inner = malloc(neqns*sizeof(double));
  inner[0]=1;
  inner[1]=0;
  inner[2]=0;
  inner[3]=0;
  inner[4]=1;
  inner[5]=0;

  doublecomplex *parta = malloc(na*sizeof(doublecomplex));
  doublecomplex *partb = malloc(nb*sizeof(doublecomplex));
  doublecomplex *partc = malloc(nc*sizeof(doublecomplex));
  integer *partar = malloc(na*sizeof(integer));
  integer *partbr = malloc(nb*sizeof(integer));
  integer *partcr = malloc(nc*sizeof(integer));
  integer *partac = malloc(na*sizeof(integer));
  integer *partbc = malloc(nb*sizeof(integer));
  integer *partcc = malloc(nc*sizeof(integer));

  int i, row, kount, ai, ci, ar, cr;
  integer *list = malloc(neqns*sizeof(integer));
  ai = ci = 0;
  for(i = 0; i < neqns; i++) {
    if(ZEROTEST(inner[i]))
      list[i] = ci++;
    else
      list[i] = ai++;
  }
  if(neqns != (ai + ci))
    return;

  int aknt, bknt, cknt;
  kount = aknt = bknt = cknt = 0;
  row = ar = cr = -1;
  for(i = 0; i < nz; i++) {
    while(testr[row+1] <= i) {
      ++row;
      if(ZEROTEST(inner[row]))
	++cr;
      else
	++ar;
    }
    if(ZEROTEST(inner[row]) && ZEROTEST(inner[testc[i]])) {
      partc[cknt].re = test[i].re;     /* part c */
      partc[cknt].im = test[i].im;      
      partcr[cknt] = cr;
      partcc[cknt] = list[testc[i]];
      cknt++;
    }
    else if(ZEROTEST(inner[row]) && !ZEROTEST(inner[testc[i]])) {
      partb[bknt].re = test[i].re * inner[testc[i]];   /* part b dagger */
      partb[bknt].im = -test[i].im * inner[testc[i]];
      partbr[bknt] = list[testc[i]];
      partbc[bknt] = cr;
      bknt++;
    }
    else if(!ZEROTEST(inner[row]) && ZEROTEST(inner[testc[i]])) {
      partb[bknt].re = test[i].re * inner[row];   /* part b */
      partb[bknt].im = test[i].im * inner[row];
      partbr[bknt] = ar;
      partbc[bknt] = list[testc[i]];
      bknt++;
    }
    else {    /* must be part a */
      parta[aknt].re = test[i].re * inner[row] * inner[testc[i]];
      parta[aknt].im = test[i].im * inner[row] * inner[testc[i]];
      partar[aknt] = ar;
      partac[aknt] = list[testc[i]];
      aknt++;
    }
  }

  printf("PartA:\n");
  for(i = 0; i < na; i++)
    printf("%f + %f I \t%d\t%d\n",parta[i].re,parta[i].im,partar[i],partac[i]);
  printf("PartB:\n");
  for(i = 0; i < nb; i++)
    printf("%f + %f I \t%d\t%d\n",partb[i].re,partb[i].im,partbr[i],partbc[i]);
  printf("PartC:\n");
  for(i = 0; i < nc; i++)
    printf("%f + %f I \t%d\t%d\n",partc[i].re,partc[i].im,partcr[i],partcc[i]);

  free(test);
  free(testr);
  free(testc);
  free(parta);
  free(partb);
  free(partc);
  free(partar);
  free(partac);
  free(partbr);
  free(partbc);
  free(partcr);
  free(partcc);
  free(list);
  free(inner);
  return;
}
