(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[    108133,       2308]*)
(*NotebookOutlinePosition[    108774,       2331]*)
(*  CellTagsIndexPosition[    108730,       2327]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Benchmarks for mesons", "Subtitle"],

Cell["\<\
The following are benchmarks for mesons with p_perp*a=(1,0), C=+, \
and multiplet=15.\
\>", "Text"],

Cell[CellGroupData[{

Cell["Number of states", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4states = {{15, 7679}, {20, 19010}, {25, 38086}, {30, 66715}, {40, 
          161220}, {50, 318575}}\)], "Input"],

Cell[BoxData[
    \({{15, 7679}, {20, 19010}, {25, 38086}, {30, 66715}, {40, 161220}, {50, 
        318575}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4fitting = Fit[p4states, {kk^3, kk^2}, kk]\)], "Input"],

Cell[BoxData[
    \(\(-5.760782132417235`\)\ kk\^2 + 2.6636880705877792`\ kk\^3\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4fitting /. kk \[Rule] 144\)], "Input"],

Cell[BoxData[
    \(7.834274381468175`*^6\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[ListPlot[p4states, DisplayFunction \[Rule] Identity], 
      Plot[p4fitting, {kk, 0, 50}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0190476 0.0147225 1.84759e-06 [
[.21429 .00222 -6 -9 ]
[.21429 .00222 6 0 ]
[.40476 .00222 -6 -9 ]
[.40476 .00222 6 0 ]
[.59524 .00222 -6 -9 ]
[.59524 .00222 6 0 ]
[.78571 .00222 -6 -9 ]
[.78571 .00222 6 0 ]
[.97619 .00222 -6 -9 ]
[.97619 .00222 6 0 ]
[.01131 .1071 -30 -4.5 ]
[.01131 .1071 0 4.5 ]
[.01131 .19948 -36 -4.5 ]
[.01131 .19948 0 4.5 ]
[.01131 .29186 -36 -4.5 ]
[.01131 .29186 0 4.5 ]
[.01131 .38424 -36 -4.5 ]
[.01131 .38424 0 4.5 ]
[.01131 .47662 -36 -4.5 ]
[.01131 .47662 0 4.5 ]
[.01131 .569 -36 -4.5 ]
[.01131 .569 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01472 m
.21429 .02097 L
s
[(10)] .21429 .00222 0 1 Mshowa
.40476 .01472 m
.40476 .02097 L
s
[(20)] .40476 .00222 0 1 Mshowa
.59524 .01472 m
.59524 .02097 L
s
[(30)] .59524 .00222 0 1 Mshowa
.78571 .01472 m
.78571 .02097 L
s
[(40)] .78571 .00222 0 1 Mshowa
.97619 .01472 m
.97619 .02097 L
s
[(50)] .97619 .00222 0 1 Mshowa
.125 Mabswid
.0619 .01472 m
.0619 .01847 L
s
.1 .01472 m
.1 .01847 L
s
.1381 .01472 m
.1381 .01847 L
s
.17619 .01472 m
.17619 .01847 L
s
.25238 .01472 m
.25238 .01847 L
s
.29048 .01472 m
.29048 .01847 L
s
.32857 .01472 m
.32857 .01847 L
s
.36667 .01472 m
.36667 .01847 L
s
.44286 .01472 m
.44286 .01847 L
s
.48095 .01472 m
.48095 .01847 L
s
.51905 .01472 m
.51905 .01847 L
s
.55714 .01472 m
.55714 .01847 L
s
.63333 .01472 m
.63333 .01847 L
s
.67143 .01472 m
.67143 .01847 L
s
.70952 .01472 m
.70952 .01847 L
s
.74762 .01472 m
.74762 .01847 L
s
.82381 .01472 m
.82381 .01847 L
s
.8619 .01472 m
.8619 .01847 L
s
.9 .01472 m
.9 .01847 L
s
.9381 .01472 m
.9381 .01847 L
s
.25 Mabswid
0 .01472 m
1 .01472 L
s
.02381 .1071 m
.03006 .1071 L
s
[(50000)] .01131 .1071 1 0 Mshowa
.02381 .19948 m
.03006 .19948 L
s
[(100000)] .01131 .19948 1 0 Mshowa
.02381 .29186 m
.03006 .29186 L
s
[(150000)] .01131 .29186 1 0 Mshowa
.02381 .38424 m
.03006 .38424 L
s
[(200000)] .01131 .38424 1 0 Mshowa
.02381 .47662 m
.03006 .47662 L
s
[(250000)] .01131 .47662 1 0 Mshowa
.02381 .569 m
.03006 .569 L
s
[(300000)] .01131 .569 1 0 Mshowa
.125 Mabswid
.02381 .0332 m
.02756 .0332 L
s
.02381 .05167 m
.02756 .05167 L
s
.02381 .07015 m
.02756 .07015 L
s
.02381 .08863 m
.02756 .08863 L
s
.02381 .12558 m
.02756 .12558 L
s
.02381 .14405 m
.02756 .14405 L
s
.02381 .16253 m
.02756 .16253 L
s
.02381 .18101 m
.02756 .18101 L
s
.02381 .21796 m
.02756 .21796 L
s
.02381 .23643 m
.02756 .23643 L
s
.02381 .25491 m
.02756 .25491 L
s
.02381 .27339 m
.02756 .27339 L
s
.02381 .31034 m
.02756 .31034 L
s
.02381 .32881 m
.02756 .32881 L
s
.02381 .34729 m
.02756 .34729 L
s
.02381 .36576 m
.02756 .36576 L
s
.02381 .40272 m
.02756 .40272 L
s
.02381 .42119 m
.02756 .42119 L
s
.02381 .43967 m
.02756 .43967 L
s
.02381 .45814 m
.02756 .45814 L
s
.02381 .4951 m
.02756 .4951 L
s
.02381 .51357 m
.02756 .51357 L
s
.02381 .53205 m
.02756 .53205 L
s
.02381 .55052 m
.02756 .55052 L
s
.02381 .58748 m
.02756 .58748 L
s
.02381 .60595 m
.02756 .60595 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.30952 .02891 Mdot
.40476 .04985 Mdot
.5 .08509 Mdot
.59524 .13798 Mdot
.78571 .31259 Mdot
.97619 .60332 Mdot
.5 Mabswid
.02381 .01472 m
.02499 .01472 L
.02605 .01472 L
.02729 .01472 L
.02846 .01472 L
.03053 .01472 L
.03279 .01472 L
.04262 .01472 L
.0452 .01472 L
.04647 .01472 L
.04762 .01472 L
.04884 .01472 L
.05015 .01472 L
.05083 .01472 L
.05157 .01472 L
.05227 .01472 L
.05293 .01472 L
.05417 .01472 L
.05534 .01472 L
.0564 .01472 L
.05753 .01472 L
.06009 .01472 L
.06244 .01472 L
.06488 .01472 L
.0675 .01473 L
.07221 .01473 L
.07509 .01474 L
.07782 .01475 L
.08293 .01477 L
.08832 .01479 L
.0933 .01482 L
.10458 .01491 L
.11421 .01501 L
.12324 .01513 L
.13328 .01531 L
.14385 .01553 L
.16403 .01611 L
.18253 .01683 L
.20228 .01784 L
.22064 .01902 L
.25969 .02244 L
.28103 .0249 L
.30118 .02766 L
.33965 .03423 L
.38057 .04333 L
.41997 .0544 L
.45786 .06743 L
.4982 .08415 L
.53702 .10326 L
.5783 .12711 L
Mistroke
.61806 .15381 L
.65631 .18318 L
.697 .21869 L
.73619 .25729 L
.77782 .30333 L
.81794 .35287 L
.85654 .40561 L
.8976 .46742 L
.93714 .53281 L
.97516 .60135 L
.97619 .60329 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000900001Hb000`400?l00000o`00003oo`3ooooo
0?oood80oooo003o0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo
003o0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o0?ooool0
oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o0?ooool0oooo@P3oool0
0?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo002U0?ooo`P000001P3oool4000004l0oooo
200000060?ooo`@00000C`3oool6000000P0oooo1000001@0?ooo`H000001P3oool400000500oooo
1@0000080?ooo`@000001P3oool00:T0oooo00<000000?ooo`3oool01P3oool2000000<0oooo00<0
00000?ooo`3oool0C03oool2000000D0oooo00<000000?ooo`3oool00`3oool2000000<0oooo00<0
00000?ooo`3oool0C03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo0P00
00030?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool01@3oool2000000<0oooo00<0
00000?ooo`3oool0C03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo0P00
00030?ooo`030000003oool0oooo00<0oooo002Y0?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool00P3oool2000004l0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0080oooo0P00001D0?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool00P3oool200000540oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`02
0?ooo`800000E03oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0P000004
0?ooo`00Z@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0CP3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0DP3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0BP3oool8000000@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1B0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?oo
o`00Z@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0C`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0DP3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0BP3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`00Z@3oool00`000000oooo0?ooo`050?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool0D@3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool0B`3oool01@000000oooo0?ooo`3oool0000000H0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`00Z@3oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0D@3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0CP3oool4000000D0oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1;0?ooo`050000003oool0oooo0?ooo`00
00001P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo04`0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool00P3oool00:T0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo0540oooo0P0000040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
D03oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
C03oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0C03oool5000000H0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`00
Z@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
DP3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
D@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
C03oool010000000oooo0?ooo`0000060?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0C03oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool00P3oool00:T0oooo00<000000?ooo`3oool01@3oool2000000D0oooo00<000000?ooo`3oool0
DP3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`1A0?ooo`030000
003oool0oooo00<0oooo0P0000050?ooo`030000003oool0oooo04d0oooo00<000000?ooo`000000
1P3oool2000000D0oooo00<000000?ooo`3oool0C03oool00`000000oooo0?ooo`080?ooo`800000
1@3oool00`000000oooo0?ooo`020?ooo`00Y@3oool01@000000oooo0?ooo`3oool0000000P0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0580oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo04h0oooo
00<000000?ooo`0000001`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo04d0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo
002V0?ooo`@00000203oool2000000<0oooo00<000000?ooo`3oool0C03oool2000000<0oooo0P00
00060?ooo`8000000`3oool00`000000oooo0?ooo`1<0?ooo`8000000`3oool00`000000oooo0?oo
o`050?ooo`8000000`3oool00`000000oooo0?ooo`1?0?ooo`8000001`3oool2000000<0oooo00<0
00000?ooo`3oool0C@3oool00`000000oooo0?ooo`090?ooo`8000000`3oool00`000000oooo0?oo
o`030?ooo`00Z03oool2000000T0oooo1000001A0?ooo`@00000203oool400000540oooo0`000009
0?ooo`@00000DP3oool2000000P0oooo1000001@0?ooo`H000001`3oool4000000H0oooo003o0?oo
ool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooo00oooo
001>0?ooo`030000003oool0oooo0?l0ooool03oool004h0oooo00<000000?ooo`3oool0o`3oooo`
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooo00oooo001>0?ooo`030000003oool0oooo0?l0
ooool03oool004h0oooo00<000000?ooo`3oool0o`3oooo`0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?oooo00oooo001>0?ooo`030000003oool0oooo0?l0ooool03oool00480ooooo`00003n0000
0040oooo001>0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`0@0?ooo`030000003oool0oooo00l0oooo500000000`3oool000000?ooo`0A0?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0@0?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0@0?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0@0?ooo`03
0000003oool0oooo0100oooo00<000000?ooo`3oool02`3oool004h0oooo00<000000?ooo`3oool0
403oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0
403oool00`000000oooo0?ooo`0@0?ooo`X000002P3oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo0140oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0@0?ooo`030000
003oool0oooo00/0oooo001>0?ooo`030000003oool0oooo05h0oooo00<000000?ooo`3oool01@3o
ool;000004h0oooo00<000000?ooo`3oool0GP3oool00`000000oooo0?ooo`1M0?ooo`030000003o
ool0oooo05h0oooo00<000000?ooo`3oool02`3oool004h0oooo00<000000?ooo`3oool0L03oool;
00000?l0ooooM@3oool004h0oooo00<000000?ooo`3oool0N`3oool;000000P0oooo0`00003o0?oo
oel0oooo001>0?ooo`030000003oool0oooo08D0oooo3000003o0?oooel0oooo001>0?ooo`030000
003oool0oooo08d0oooo1@00003o0?oooeh0oooo001>0?ooo`030000003oool0oooo08l0oooo00<0
00000?ooo`3oool01@00003o0?oooeT0oooo001>0?ooo`<00000U`3oool500000?l0ooooE03oool0
04h0oooo00<000000?ooo`3oool0W03oool500000?l0ooooC`3oool004h0oooo00<000000?ooo`3o
ool0X@3oool500000?l0ooooBP3oool004h0oooo00<000000?ooo`3oool0YP3oool500000?l0oooo
A@3oool004h0oooo00<000000?ooo`3oool0Z`3oool500000?l0oooo@03oool004h0oooo00<00000
0?ooo`3oool0/03oool400000?l0oooo?03oool004h0oooo00<000000?ooo`3oool0]03oool40000
0?l0oooo>03oool004h0oooo00<000000?ooo`3oool0]`3oool4000000<0oooo0`00003o0?ooobl0
oooo001>0?ooo`030000003oool0oooo0;/0oooo1P00003o0?ooobl0oooo001>0?ooo`030000003o
ool0oooo0;h0oooo1000003o0?ooobh0oooo001>0?ooo`<00000_`3oool00`000000oooo00000003
00000?l0oooo:`3oool004h0oooo00<000000?ooo`3oool0a@3oool300000?l0oooo:03oool004h0
oooo00<000000?ooo`3oool0b03oool300000?l0oooo9@3oool004h0oooo00<000000?ooo`3oool0
b`3oool300000?l0oooo8P3oool004h0oooo00<000000?ooo`3oool0cP3oool300000?l0oooo7`3o
ool004h0oooo00<000000?ooo`3oool0d03oool300000?l0oooo7@3oool004h0oooo00<000000?oo
o`3oool0d`3oool300000?l0oooo6P3oool004h0oooo00<000000?ooo`3oool0eP3oool300000?l0
oooo5`3oool004h0oooo00<000000?ooo`3oool0f@3oool300000?l0oooo503oool004h0oooo0`00
003L0?ooo`800000o`3ooolB0?ooo`00CP3oool00`000000oooo0?ooo`3N0?ooo`<00000o`3oool?
0?ooo`00CP3oool00`000000oooo0?ooo`3Q0?ooo`800000o`3oool=0?ooo`00CP3oool00`000000
oooo0?ooo`3S0?ooo`<00000o`3oool:0?ooo`00CP3oool00`000000oooo0?ooo`3V0?ooo`800000
o`3oool80?ooo`00CP3oool00`000000oooo0?ooo`3X0?ooo`<00000o`3oool50?ooo`00CP3oool0
0`000000oooo0?ooo`3[0?ooo`8000000P3oool300000?d0oooo001>0?ooo`030000003oool0oooo
0>d0oooo1@00003m0?ooo`00CP3oool00`000000oooo0?ooo`3_0?ooo`<00000o@3oool004h0oooo
0`00003`0?ooo`@00000n`3oool004h0oooo00<000000?ooo`3oool0l`3oool300000?T0oooo001>
0?ooo`030000003oool0oooo0?D0oooo0`00003g0?ooo`00CP3oool00`000000oooo0?ooo`3g0?oo
o`<00000m@3oool004h0oooo00<000000?ooo`3oool0n@3oool300000?<0oooo000?0?ooo`D00000
203oool4000000P0oooo100000080?ooo`@00000203oool4000000X0oooo00<000000?ooo`3oool0
n`3oool300000?40oooo000>0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103o
ool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103o
ool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool01`3o
ool00`000000oooo0?ooo`3m0?ooo`<00000k`3oool001D0oooo00<000000?ooo`3oool00`3oool0
0`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`8000001@3oool0
0`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`800000203oool0
0`000000oooo0?ooo`3o0?ooo`<00000k@3oool001D0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3oool20?oo
o`<00000j`3oool001D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3oool40?ooo`800000jP3oool001D0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo
1000003o0?ooo`D0oooo0P00003X0?ooo`003`3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo0?l0oooo203oool200000>H0oooo000?0?ooo`D000001P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3oool90?ooo`<00000i03oool0
00l0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0o`3oool;0?ooo`800000h`3oool000l0oooo00<000000?ooo`3o
ool0203oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3o
ool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`3o0?ooo`d0oooo0P00003Q0?ooo`003`3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo
0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01`3oool00`000000oooo
0?ooo`3o0?ooo`l0oooo0P00003O0?ooo`003`3oool00`000000oooo0?ooo`090?ooo`8000000`3o
ool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3o
ool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo0?l0oooo403oool300000=d0oooo000?0?ooo`H000001`3oool4000000P0oooo10000008
0?ooo`@00000203oool4000000X0oooo00<000000?ooo`3oool0o`3ooolB0?ooo`800000g03oool0
04h0oooo00<000000?ooo`3oool0o`3ooolD0?ooo`800000fP3oool004h0oooo0`00003o0?oooaH0
oooo0P00003H0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooaL0oooo0P00003G0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?oooaT0oooo0P00003E0?ooo`00CP3oool00`000000oooo0?ooo`3o
0?oooaX0oooo0P00003D0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooa`0oooo0P00003B0?oo
o`00CP3oool00`000000oooo0?ooo`3o0?oooad0oooo0P000000103oool0000000000000003=0?oo
o`00CP3oool00`000000oooo0?ooo`3o0?oooal0oooo1000003=0?ooo`00CP3oool00`000000oooo
0?ooo`3o0?ooob00oooo0`00003=0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooob40oooo0P00
003=0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooob<0oooo0P00003;0?ooo`00CP3oool30000
0?l0oooo903oool200000<X0oooo001>0?ooo`030000003oool0oooo0?l0oooo9P3oool200000<P0
oooo001>0?ooo`030000003oool0oooo0?l0oooo9`3oool200000<L0oooo001>0?ooo`030000003o
ool0oooo0?l0oooo:@3oool200000<D0oooo001>0?ooo`030000003oool0oooo0?l0oooo:P3oool2
00000<@0oooo001>0?ooo`030000003oool0oooo0?l0oooo;03oool00`000000oooo0?ooo`310?oo
o`00CP3oool00`000000oooo0?ooo`3o0?ooobd0oooo0P0000310?ooo`00CP3oool00`000000oooo
0?ooo`3o0?ooobh0oooo0P0000300?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooc00oooo0P00
002n0?ooo`00CP3oool300000?l0oooo<@3oool200000;d0oooo001>0?ooo`030000003oool0oooo
0?l0oooo<`3oool200000;/0oooo001>0?ooo`030000003oool0oooo0?l0oooo=03oool200000;X0
oooo001>0?ooo`030000003oool0oooo0?l0oooo=P3oool00`000000oooo0?ooo`2g0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?ooocL0oooo0P00002g0?ooo`00CP3oool00`000000oooo0?ooo`3o
0?ooocP0oooo0P00002f0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooocX0oooo0P00002d0?oo
o`00CP3oool00`000000oooo0?ooo`3o0?oooc/0oooo0P00002c0?ooo`00CP3oool00`000000oooo
0?ooo`3o0?ooocd0oooo0P00002a0?ooo`00CP3oool300000?l0oooo?P3oool200000;00oooo001>
0?ooo`030000003oool0oooo0?l0oooo@03oool00`000000oooo0?ooo`2]0?ooo`00CP3oool00`00
0000oooo0?ooo`3o0?oood40oooo00<000000?ooo`3oool0[03oool004h0oooo00<000000?ooo`3o
ool0o`3ooom20?ooo`030000003oool0oooo0:/0oooo001>0?ooo`030000003oool0oooo0?l0oooo
@`3oool00`000000oooo0?ooo`2Z0?ooo`000P3oool8000000H0oooo100000080?ooo`@00000203o
ool4000000P0oooo100000080?ooo`@000002P3oool00`000000oooo0?ooo`3o0?oood@0oooo00<0
00000?ooo`3oool0Z@3oool000H0oooo00<000000?ooo`3oool01P3oool2000000<0oooo00<00000
0?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<00000
0?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`3o0?ooodD0oooo00<000000?ooo`3oool0Z03oool0
00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`00
0000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`00
0000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`800000203oool00`00
0000oooo0?ooo`3o0?ooodH0oooo0P00002X0?ooo`001P3oool00`000000oooo0?ooo`050?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooom70?ooo`800000Y`3oool000H0oooo
00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0oooo
B03oool200000:H0oooo00060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3o
ool400000?l0ooooB03oool200000:D0oooo00060?ooo`030000003oool0oooo00D0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooodX0oooo0P00002T0?ooo`001P3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooom;0?oo
o`800000X`3oool000H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo0?l0ooooC03oool200000:80oooo00060?ooo`030000003oool0oooo00D0oooo
0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo
0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo
0P0000050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooom=0?ooo`800000
X@3oool00080oooo00D000000?ooo`3oool0oooo000000080?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool0o`3ooom?0?ooo`030000003oool0oooo09h0oooo00030?ooo`@00000203o
ool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103o
ool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103o
ool2000000<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3o0?oooe00oooo00<0
00000?ooo`3oool0W@3oool000D0oooo0P0000090?ooo`@00000203oool4000000P0oooo10000008
0?ooo`@00000203oool4000000X0oooo00<000000?ooo`3oool0o`3ooomA0?ooo`030000003oool0
oooo09`0oooo001>0?ooo`030000003oool0oooo0?l0ooooDP3oool00`000000oooo0?ooo`2K0?oo
o`00CP3oool300000?l0ooooD`3oool00`000000oooo0?ooo`2J0?ooo`00CP3oool00`000000oooo
0?ooo`3o0?oooe@0oooo00<000000?ooo`3oool0V@3oool004h0oooo00<000000?ooo`3oool0o`3o
oomE0?ooo`030000003oool0oooo09P0oooo001>0?ooo`030000003oool0oooo0?l0ooooEP3oool0
0`000000oooo0?ooo`2G0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooeL0oooo00<000000?oo
o`3oool0UP3oool004h0oooo00<000000?ooo`3oool0o`3ooomH0?ooo`030000003oool0oooo09D0
oooo001>0?ooo`030000003oool0oooo0?l0ooooF@3oool00`000000oooo0?ooo`2D0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?oooeX0oooo0P00002D0?ooo`00CP3oool00`000000oooo0?ooo`3o
0?oooe/0oooo0P00002C0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooe`0oooo0P00002B0?oo
o`00CP3oool300000?l0ooooG@3oool200000940oooo001>0?ooo`030000003oool0oooo0?l0oooo
GP3oool200000900oooo001>0?ooo`030000003oool0oooo0?l0ooooG`3oool2000008l0oooo001>
0?ooo`030000003oool0oooo0?l0ooooH03oool2000008h0oooo001>0?ooo`030000003oool0oooo
0?l0ooooH@3oool2000008d0oooo001>0?ooo`030000003oool0oooo0?l0ooooH`3oool00`000000
oooo0?ooo`2:0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooof@0oooo00<000000?ooo`3oool0
R@3oool004h0oooo00<000000?ooo`3oool0o`3ooomU0?ooo`030000003oool0oooo08P0oooo001>
0?ooo`030000003oool0oooo0?l0ooooIP3oool00`000000oooo0?ooo`270?ooo`00CP3oool30000
0?l0ooooI`3oool00`000000oooo0?ooo`260?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooofP0
oooo00<000000?ooo`3oool0Q@3oool004h0oooo00<000000?ooo`3oool0o`3ooomY0?ooo`030000
003oool0oooo08@0oooo001>0?ooo`030000003oool0oooo0?l0ooooJP3oool00`000000oooo0?oo
o`230?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooofX0oooo0P0000240?ooo`00CP3oool00`00
0000oooo0?ooo`3o0?ooof/0oooo0P0000230?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooof`0
oooo0P0000220?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooofd0oooo00<000000?ooo`3oool0
P03oool004h0oooo00<000000?ooo`3oool0o`3ooom^0?ooo`030000003oool0oooo07l0oooo001>
0?ooo`<00000o`3ooom_0?ooo`030000003oool0oooo07h0oooo001>0?ooo`030000003oool0oooo
0?l0ooooL03oool00`000000oooo0?ooo`1m0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooog40
oooo00<000000?ooo`3oool0O03oool004h0oooo00<000000?ooo`3oool0o`3oooma0?ooo`800000
O@3oool004h0oooo00<000000?ooo`3oool0o`3ooomb0?ooo`800000O03oool00080oooo20000005
0?ooo`D00000203oool4000000P0oooo100000080?ooo`@00000203oool4000000X0oooo00<00000
0?ooo`3oool0o`3ooomc0?ooo`800000N`3oool000H0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo
00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo
00@0oooo0P0000030?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3ooomd0?oo
o`030000003oool0oooo07T0oooo00060?ooo`030000003oool0oooo00`0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`80
00001@3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`80
0000203oool00`000000oooo0?ooo`3o0?ooogD0oooo00<000000?ooo`3oool0N03oool000H0oooo
00<000000?ooo`3oool0303oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooogH0oooo00<000000?ooo`3oool0
M`3oool000H0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooogL0oooo00<0
00000?ooo`3oool0MP3oool000H0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool400000?l0ooooM`3oool0
0`000000oooo0?ooo`1e0?ooo`001P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0o`3ooomh0?ooo`800000MP3oool000H0oooo00<000000?ooo`3o
ool01P3oool5000000H0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo0?l0ooooN@3oool2000007D0oooo00060?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0203oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0o`3ooomj0?ooo`800000M03oool000H0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`080?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`8000001@3o
ool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`8000001@3o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooN`3oool00`000000oooo0?oo
o`1b0?ooo`000P3oool01@000000oooo0?ooo`3oool0000000P0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3o
ooml0?ooo`030000003oool0oooo0740oooo00030?ooo`@00000203oool00`000000oooo0?ooo`09
0?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`04
0?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo0?l0ooooO@3oool00`000000oooo0?ooo`1`0?ooo`001@3oool20000
00P0oooo1P0000070?ooo`@00000203oool4000000P0oooo100000080?ooo`@000002P3oool00`00
0000oooo0?ooo`3o0?ooogh0oooo00<000000?ooo`3oool0K`3oool004h0oooo00<000000?ooo`3o
ool0o`3ooomo0?ooo`030000003oool0oooo06h0oooo001>0?ooo`<00000o`3ooomo0?ooo`D00000
K03oool004h0oooo00<000000?ooo`3oool0o`3ooon00?ooo`@00000K03oool004h0oooo00<00000
0?ooo`3oool0o`3ooon10?ooo`<00000K03oool004h0oooo00<000000?ooo`3oool0o`3ooon20?oo
o`030000003oool0oooo06/0oooo001>0?ooo`030000003oool0oooo0?l0ooooP`3oool00`000000
oooo0?ooo`1Z0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooh@0oooo00<000000?ooo`3oool0
J@3oool004h0oooo00<000000?ooo`3oool0o`3ooon40?ooo`800000JP3oool004h0oooo00<00000
0?ooo`3oool0o`3ooon50?ooo`800000J@3oool004h0oooo00<000000?ooo`3oool0o`3ooon60?oo
o`030000003oool0oooo06L0oooo001>0?ooo`030000003oool0oooo0?l0ooooQ`3oool00`000000
oooo0?ooo`1V0?ooo`00CP3oool300000?l0ooooR03oool00`000000oooo0?ooo`1U0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?ooohT0oooo00<000000?ooo`3oool0I03oool004h0oooo00<00000
0?ooo`3oool0o`3ooon90?ooo`800000I@3oool004h0oooo00<000000?ooo`3oool0o`3ooon:0?oo
o`800000I03oool004h0oooo00<000000?ooo`3oool0o`3ooon;0?ooo`030000003oool0oooo0680
oooo001>0?ooo`030000003oool0oooo0?l0ooooS03oool00`000000oooo0?ooo`1Q0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?ooohd0oooo00<000000?ooo`3oool0H03oool004h0oooo00<00000
0?ooo`3oool0o`3ooon>0?ooo`030000003oool0oooo05l0oooo001>0?ooo`030000003oool0oooo
0?l0ooooSP3oool200000600oooo001>0?ooo`<00000o`3ooon?0?ooo`800000G`3oool004h0oooo
00<000000?ooo`3oool0o`3ooon@0?ooo`030000003oool0oooo05d0oooo001>0?ooo`030000003o
ool0oooo0?l0ooooT@3oool00`000000oooo0?ooo`1L0?ooo`00CP3oool00`000000oooo0?ooo`3o
0?oooi80oooo00<000000?ooo`3oool0F`3oool004h0oooo00<000000?ooo`3oool0o`3ooonC0?oo
o`030000003oool0oooo05X0oooo001>0?ooo`030000003oool0oooo0?l0ooooT`3oool2000005/0
oooo001>0?ooo`030000003oool0oooo0?l0ooooU03oool00`000000oooo0?ooo`1I0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?oooiD0oooo00<000000?ooo`3oool0F03oool004h0oooo00<00000
0?ooo`3oool0o`3ooonF0?ooo`030000003oool0oooo05L0oooo001>0?ooo`<00000o`3ooonF0?oo
o`800000F03oool004h0oooo00<000000?ooo`3oool0o`3ooonG0?ooo`030000003oool0oooo05H0
oooo001>0?ooo`030000003oool0oooo0?l0ooooV03oool00`000000oooo0?ooo`1E0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?oooiT0oooo00<000000?ooo`3oool0E03oool004h0oooo00<00000
0?ooo`3oool0o`3ooonI0?ooo`800000E@3oool00080oooo200000060?ooo`@00000203oool40000
00P0oooo100000080?ooo`@00000203oool4000000X0oooo00<000000?ooo`3oool0o`3ooonJ0?oo
o`030000003oool0oooo05<0oooo00020?ooo`8000001@3oool00`000000oooo0?ooo`030?ooo`80
00000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`80
00000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`80
00000`3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0?l0ooooV`3oool00`000000
oooo0?ooo`1B0?ooo`00103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0oooo
00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0oooo
00<000000?ooo`3oool00P3oool2000000P0oooo00<000000?ooo`3oool0o`3ooonL0?ooo`030000
003oool0oooo0540oooo00050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3o
ool00`000000oooo0?ooo`3o0?oooi`0oooo00<000000?ooo`3oool0D@3oool000H0oooo00<00000
0?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooW@3oool0
0`000000oooo0?ooo`1@0?ooo`001`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
00H0oooo1000003o0?oooid0oooo00<000000?ooo`3oool0C`3oool000P0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooWP3oool200000500
oooo00080?ooo`800000103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0oooo
W`3oool00`000000oooo0?ooo`1>0?ooo`002@3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0o`3ooonP0?ooo`030000003oool0oooo04d0oooo0009
0?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P000005
0?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P000005
0?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool0o`3ooonQ0?ooo`030000003oool0oooo04`0oooo00020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo
0?l0ooooX@3oool2000004d0oooo00020?ooo`8000000`3oool2000000H0oooo0P0000030?ooo`03
0000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`03
0000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`03
0000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3ooonR0?ooo`030000003oool0oooo04/0
oooo00040?ooo`@00000203oool4000000P0oooo100000080?ooo`@00000203oool4000000P0oooo
1000000:0?ooo`030000003oool0oooo0?l0ooooX`3oool00`000000oooo0?ooo`1:0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?oooj@0oooo00<000000?ooo`3oool0B@3oool004h0oooo0`00003o
0?oooj@0oooo0P00001:0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooojD0oooo00<000000?oo
o`3oool0B03oool004h0oooo00<000000?ooo`3oool0o`3ooonV0?ooo`030000003oool0oooo04L0
oooo001>0?ooo`030000003oool0oooo0?l0ooooY`3oool00`000000oooo0?ooo`160?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?ooojL0oooo00<000000?ooo`3oool0AP3oool004h0oooo00<00000
0?ooo`3oool0o`3ooonX0?ooo`030000003oool0oooo04D0oooo001>0?ooo`030000003oool0oooo
0?l0ooooZ03oool2000004H0oooo001>0?ooo`030000003oool0oooo0?l0ooooZ@3oool00`000000
oooo0?ooo`140?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooojX0oooo00<000000?ooo`3oool0
@`3oool004h0oooo00<000000?ooo`3oool0o`3ooonZ0?ooo`800000A03oool004h0oooo0`00003o
0?oooj/0oooo00<000000?ooo`3oool0@P3oool004h0oooo00<000000?ooo`3oool0o`3ooon/0?oo
o`030000003oool0oooo0440oooo001>0?ooo`030000003oool0oooo0?l0oooo[03oool200000480
oooo001>0?ooo`030000003oool0oooo0?l0oooo[@3oool00`000000oooo0?ooo`100?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?ooojh0oooo00<000000?ooo`3oool0?`3oool004h0oooo00<00000
0?ooo`3oool0o`3ooon^0?ooo`030000003oool0oooo03l0oooo001>0?ooo`030000003oool0oooo
0?l0oooo[`3oool00`000000oooo0?ooo`0n0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oook00
oooo00<000000?ooo`3oool0?@3oool004h0oooo00<000000?ooo`3oool0o`3ooon`0?ooo`030000
003oool0oooo03d0oooo001>0?ooo`<00000o`3ooona0?ooo`030000003oool0oooo03`0oooo001>
0?ooo`030000003oool0oooo0?l0oooo/P3oool00`000000oooo0?ooo`0k0?ooo`00CP3oool00`00
0000oooo0?ooo`3o0?oook80oooo00<000000?ooo`3oool0>`3oool004h0oooo00<000000?ooo`3o
ool0o`3ooonc0?ooo`030000003oool0oooo03X0oooo001>0?ooo`030000003oool0oooo0?l0oooo
/`3oool2000003/0oooo001>0?ooo`030000003oool0oooo0?l0oooo]03oool00`000000oooo0?oo
o`0i0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oookD0oooo00<000000?ooo`3oool0>03oool0
04h0oooo00<000000?ooo`3oool0o`3ooone0?ooo`800000>@3oool004h0oooo00<000000?ooo`3o
ool0o`3ooonf0?ooo`030000003oool0oooo03L0oooo001>0?ooo`<00000o`3ooong0?ooo`030000
003oool0oooo03H0oooo001>0?ooo`030000003oool0oooo0?l0oooo]`3oool2000003L0oooo001>
0?ooo`030000003oool0oooo0?l0oooo^03oool00`000000oooo0?ooo`0e0?ooo`00CP3oool00`00
0000oooo0?ooo`3o0?oookT0oooo00<000000?ooo`3oool0=03oool004h0oooo00<000000?ooo`3o
ool0o`3oooni0?ooo`030000003oool0oooo03@0oooo00020?ooo`P000001@3oool5000000P0oooo
100000080?ooo`@00000203oool4000000P0oooo1000000:0?ooo`030000003oool0oooo0?l0oooo
^P3oool00`000000oooo0?ooo`0c0?ooo`000P3oool2000000D0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003o
ool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003o
ool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3o
oonk0?ooo`030000003oool0oooo0380oooo00040?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0P000005
0?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P000005
0?ooo`030000003oool0oooo0080oooo0P0000080?ooo`030000003oool0oooo0?l0oooo^`3oool0
0`000000oooo0?ooo`0b0?ooo`001@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
0?l0oooo_03oool00`000000oooo0?ooo`0a0?ooo`001P3oool00`000000oooo0?ooo`0<0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo0?l0oooo_03oool200000380oooo00070?ooo`030000003oool0oooo00/0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo
1000003o0?oook`0oooo00<000000?ooo`3oool0<03oool000P0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0oooo_P3oool00`000000oooo0?oo
o`0_0?ooo`00203oool2000000D0oooo1@0000060?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?oookh0oooo0P00000`0?ooo`002@3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo0?l0oooo_`3oool00`000000oooo0?ooo`0^0?oo
o`002@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00P0oooo0P0000050?ooo`03
0000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`03
0000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool0o`3oooo00?ooo`030000003oool0oooo02d0oooo00020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3o0?oool00oooo00<000000?ooo`3oool0
;@3oool00080oooo0P0000030?ooo`8000001P3oool00`000000oooo0?ooo`090?ooo`8000000`3o
ool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3o
ool00`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`070?ooo`030000003o
ool0oooo0?l0oooo`@3oool00`000000oooo0?ooo`0/0?ooo`00103oool4000000L0oooo1P000007
0?ooo`@00000203oool4000000P0oooo100000080?ooo`@000002P3oool00`000000oooo0?ooo`3o
0?oool80oooo00<000000?ooo`3oool0:`3oool004h0oooo00<000000?ooo`3oool0o`3oooo20?oo
o`030000003oool0oooo02/0oooo001>0?ooo`<00000o`3oooo30?ooo`030000003oool0oooo02X0
oooo001>0?ooo`030000003oool0oooo0?l0oooo``3oool2000002/0oooo001>0?ooo`030000003o
ool0oooo0?l0ooooa03oool00`000000oooo0?ooo`0Y0?ooo`00CP3oool00`000000oooo0?ooo`3o
0?ooolD0oooo00<000000?ooo`3oool0:03oool004h0oooo00<000000?ooo`3oool0o`3oooo50?oo
o`800000:@3oool004h0oooo00<000000?ooo`3oool0o`3oooo60?ooo`030000003oool0oooo02L0
oooo001>0?ooo`030000003oool0oooo0?l0ooooa`3oool00`000000oooo0?ooo`0V0?ooo`00CP3o
ool00`000000oooo0?ooo`3o0?ooolL0oooo00<000000?ooo`3oool09P3oool004h0oooo00<00000
0?ooo`3oool0o`3oooo80?ooo`030000003oool0oooo02D0oooo001>0?ooo`030000003oool0oooo
0?l0oooob@3oool00`000000oooo0?ooo`0T0?ooo`00CP3oool300000?l0oooob@3oool00`000000
oooo0?ooo`0T0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooolX0oooo00<000000?ooo`3oool0
8`3oool004h0oooo00<000000?ooo`3oool0o`3oooo:0?ooo`800000903oool004h0oooo00<00000
0?ooo`3oool0o`3oooo;0?ooo`030000003oool0oooo0280oooo001>0?ooo`030000003oool0oooo
0?l0ooooc03oool00`000000oooo0?ooo`0Q0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oool`0
oooo0P00000R0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooold0oooo00<000000?ooo`3oool0
803oool004h0oooo00<000000?ooo`3oool0o`3oooo>0?ooo`030000003oool0oooo01l0oooo001>
0?ooo`030000003oool0oooo0?l0oooocP3oool00`000000oooo0?ooo`0O0?ooo`00CP3oool30000
0?l0ooooc`3oool00`000000oooo0?ooo`0N0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooll0
oooo0P00000O0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooom00oooo00<000000?ooo`3oool0
7@3oool004h0oooo00<000000?ooo`3oool0o`3ooooA0?ooo`030000003oool0oooo01`0oooo001>
0?ooo`030000003oool0oooo0?l0ooood@3oool00`000000oooo0?ooo`0L0?ooo`00CP3oool00`00
0000oooo0?ooo`3o0?ooom80oooo00<000000?ooo`3oool06`3oool004h0oooo00<000000?ooo`3o
ool0o`3ooooB0?ooo`030000003oool0oooo01/0oooo001>0?ooo`030000003oool0oooo0?l0oooo
d`3oool00`000000oooo0?ooo`0J0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooom<0oooo00<0
00000?ooo`3oool06P3oool004h0oooo0`00003o0?ooom@0oooo00<000000?ooo`3oool06@3oool0
04h0oooo00<000000?ooo`3oool0o`3ooooD0?ooo`030000003oool0oooo01T0oooo001>0?ooo`03
0000003oool0oooo0?l0ooooe@3oool00`000000oooo0?ooo`0H0?ooo`00CP3oool00`000000oooo
0?ooo`3o0?ooomD0oooo0P00000I0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooomH0oooo00<0
00000?ooo`3oool05`3oool00080oooo1P0000080?ooo`@00000203oool4000000P0oooo10000008
0?ooo`@00000203oool4000000X0oooo00<000000?ooo`3oool0o`3ooooG0?ooo`030000003oool0
oooo01H0oooo00020?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool20000
00<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103oool20000
00<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103oool20000
00<0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3o0?ooomL0oooo00<000000?oo
o`3oool05P3oool000T0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`80
00001@3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`80
00001@3oool00`000000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`020?ooo`80
0000203oool00`000000oooo0?ooo`3o0?ooomP0oooo00<000000?ooo`3oool05@3oool000T0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0oooo
f03oool00`000000oooo0?ooo`0E0?ooo`002@3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0o`3ooooI0?ooo`030000003oool0oooo01@0oooo0008
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool400000?l0oooof03oool0
0`000000oooo0?ooo`0D0?ooo`001@3oool4000000D0oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`3o0?ooomX0oooo00<000000?ooo`3oool04`3oool000L0oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0oooofP3oool00`000000
oooo0?ooo`0C0?ooo`00203oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo
00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0o`3ooooK0?ooo`030000003oool0oooo0180oooo00080?ooo`030000003o
ool0oooo00<0oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003o
ool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003o
ool0oooo0080oooo0P0000050?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3o
oooK0?ooo`8000004`3oool000P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo0?l0oooog03oool00`000000oooo0?ooo`0A0?ooo`000P3oool20000
00<0oooo00<000000?ooo`3oool01@3oool2000000<0oooo00<000000?ooo`3oool0103oool20000
00<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0103oool20000
00<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`3o0?ooomd0oooo00<000000?ooo`3oool0403oool000@0oooo0`0000090?ooo`@0
0000203oool4000000P0oooo100000080?ooo`@00000203oool4000000X0oooo00<000000?ooo`3o
ool0o`3ooooM0?ooo`030000003oool0oooo0100oooo001>0?ooo`030000003oool0oooo0?l0oooo
gP3oool00`000000oooo0?ooo`0?0?ooo`00CP3oool300000?l0oooogP3oool00`000000oooo0?oo
o`0?0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooml0oooo00<000000?ooo`3oool03P3oool0
04h0oooo00<000000?ooo`3oool0o`3ooooO0?ooo`030000003oool0oooo00h0oooo001>0?ooo`03
0000003oool0oooo0?l0ooooh03oool00`000000oooo0?ooo`0=0?ooo`00CP3oool00`000000oooo
0?ooo`3o0?ooon00oooo00<000000?ooo`3oool03@3oool004h0oooo00<000000?ooo`3oool0o`3o
oooQ0?ooo`030000003oool0oooo00`0oooo001>0?ooo`030000003oool0oooo0?l0ooooh@3oool2
000000d0oooo001>0?ooo`030000003oool0oooo0?l0oooohP3oool3000000/0oooo001>0?ooo`03
0000003oool0oooo0?l0ooooh@3oool4000000/0oooo001>0?ooo`030000003oool0oooo0?l0oooo
hP3oool3000000/0oooo001>0?ooo`<00000o`3ooooS0?ooo`030000003oool0oooo00X0oooo001>
0?ooo`030000003oool0oooo0?l0ooool03oool004h0oooo00<000000?ooo`3oool0o`3oooo`0?oo
o`00CP3oool00`000000oooo0?ooo`3o0?oooo00oooo001>0?ooo`030000003oool0oooo0?l0oooo
l03oool004h0oooo00<000000?ooo`3oool0o`3oooo`0?ooo`00CP3oool00`000000oooo0?ooo`3o
0?oooo00oooo003o0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo
003o0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o0?ooool0
oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o0?ooool0oooo@P3oool0
0?l0ooooo`3ooom20?ooo`00\
\>"],
  ImageRangeCache->{{{0, 575}, {354.875, 0}} -> {-8.08648, -38461, 0.206389, \
2127.75}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5states = {{10, 15505}, {15, 94955}, {18, 209373}, {20, 328910}, {25, 
          847950}}\)], "Input"],

Cell[BoxData[
    \({{10, 15505}, {15, 94955}, {18, 209373}, {20, 328910}, {25, 
        847950}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5fitting = Fit[p5states, {kk^4, kk^3}, kk]\)], "Input"],

Cell[BoxData[
    \(\(-11.258073813460756`\)\ kk\^3 + 2.620775118188929`\ kk\^4\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[ListPlot[p5states, DisplayFunction \[Rule] Identity], 
      Plot[p5fitting, {kk, 0, 25}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.0380952 0.0149482 2.47711e-06 [
[.21429 .00245 -3 -9 ]
[.21429 .00245 3 0 ]
[.40476 .00245 -6 -9 ]
[.40476 .00245 6 0 ]
[.59524 .00245 -6 -9 ]
[.59524 .00245 6 0 ]
[.78571 .00245 -6 -9 ]
[.78571 .00245 6 0 ]
[.97619 .00245 -6 -9 ]
[.97619 .00245 6 0 ]
[.01131 .1388 -30 -4.5 ]
[.01131 .1388 0 4.5 ]
[.01131 .26266 -36 -4.5 ]
[.01131 .26266 0 4.5 ]
[.01131 .38651 -36 -4.5 ]
[.01131 .38651 0 4.5 ]
[.01131 .51037 -36 -4.5 ]
[.01131 .51037 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .01495 m
.21429 .0212 L
s
[(5)] .21429 .00245 0 1 Mshowa
.40476 .01495 m
.40476 .0212 L
s
[(10)] .40476 .00245 0 1 Mshowa
.59524 .01495 m
.59524 .0212 L
s
[(15)] .59524 .00245 0 1 Mshowa
.78571 .01495 m
.78571 .0212 L
s
[(20)] .78571 .00245 0 1 Mshowa
.97619 .01495 m
.97619 .0212 L
s
[(25)] .97619 .00245 0 1 Mshowa
.125 Mabswid
.0619 .01495 m
.0619 .0187 L
s
.1 .01495 m
.1 .0187 L
s
.1381 .01495 m
.1381 .0187 L
s
.17619 .01495 m
.17619 .0187 L
s
.25238 .01495 m
.25238 .0187 L
s
.29048 .01495 m
.29048 .0187 L
s
.32857 .01495 m
.32857 .0187 L
s
.36667 .01495 m
.36667 .0187 L
s
.44286 .01495 m
.44286 .0187 L
s
.48095 .01495 m
.48095 .0187 L
s
.51905 .01495 m
.51905 .0187 L
s
.55714 .01495 m
.55714 .0187 L
s
.63333 .01495 m
.63333 .0187 L
s
.67143 .01495 m
.67143 .0187 L
s
.70952 .01495 m
.70952 .0187 L
s
.74762 .01495 m
.74762 .0187 L
s
.82381 .01495 m
.82381 .0187 L
s
.8619 .01495 m
.8619 .0187 L
s
.9 .01495 m
.9 .0187 L
s
.9381 .01495 m
.9381 .0187 L
s
.25 Mabswid
0 .01495 m
1 .01495 L
s
.02381 .1388 m
.03006 .1388 L
s
[(50000)] .01131 .1388 1 0 Mshowa
.02381 .26266 m
.03006 .26266 L
s
[(100000)] .01131 .26266 1 0 Mshowa
.02381 .38651 m
.03006 .38651 L
s
[(150000)] .01131 .38651 1 0 Mshowa
.02381 .51037 m
.03006 .51037 L
s
[(200000)] .01131 .51037 1 0 Mshowa
.125 Mabswid
.02381 .03972 m
.02756 .03972 L
s
.02381 .06449 m
.02756 .06449 L
s
.02381 .08926 m
.02756 .08926 L
s
.02381 .11403 m
.02756 .11403 L
s
.02381 .16357 m
.02756 .16357 L
s
.02381 .18835 m
.02756 .18835 L
s
.02381 .21312 m
.02756 .21312 L
s
.02381 .23789 m
.02756 .23789 L
s
.02381 .28743 m
.02756 .28743 L
s
.02381 .3122 m
.02756 .3122 L
s
.02381 .33697 m
.02756 .33697 L
s
.02381 .36174 m
.02756 .36174 L
s
.02381 .41129 m
.02756 .41129 L
s
.02381 .43606 m
.02756 .43606 L
s
.02381 .46083 m
.02756 .46083 L
s
.02381 .4856 m
.02756 .4856 L
s
.02381 .53514 m
.02756 .53514 L
s
.02381 .55991 m
.02756 .55991 L
s
.02381 .58468 m
.02756 .58468 L
s
.02381 .60945 m
.02756 .60945 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.40476 .05336 Mdot
.59524 .25016 Mdot
.70952 .53359 Mdot
.5 Mabswid
.02381 .01495 m
.02499 .01495 L
.02605 .01495 L
.02729 .01495 L
.02846 .01495 L
.02954 .01495 L
.03053 .01495 L
.03163 .01495 L
.03279 .01495 L
.03395 .01495 L
.0352 .01495 L
.03746 .01495 L
.04016 .01495 L
.04262 .01495 L
.04748 .01494 L
.05023 .01494 L
.05278 .01494 L
.06244 .01493 L
.06795 .01492 L
.07314 .01491 L
.08284 .01488 L
.10458 .01481 L
.12296 .01475 L
.12799 .01474 L
.13339 .01473 L
.13601 .01472 L
.13849 .01472 L
.14071 .01472 L
.14197 .01472 L
.14313 .01472 L
.14427 .01472 L
.1455 .01472 L
.14666 .01472 L
.14773 .01472 L
.14891 .01472 L
.1502 .01472 L
.15085 .01472 L
.15154 .01472 L
.1528 .01472 L
.15557 .01472 L
.15818 .01473 L
.16053 .01474 L
.16307 .01475 L
.16839 .01477 L
.17403 .01481 L
.17884 .01485 L
.18413 .01491 L
.1943 .01505 L
.20358 .01524 L
.2143 .01552 L
Mistroke
.22447 .01587 L
.23409 .01628 L
.24432 .01683 L
.26272 .01811 L
.28417 .02021 L
.30435 .0229 L
.32447 .02643 L
.34296 .03053 L
.36342 .03619 L
.3825 .04269 L
.42052 .0598 L
.45948 .08429 L
.50089 .11986 L
.54079 .16544 L
.57917 .22177 L
.62001 .2975 L
.65933 .38828 L
.69713 .49451 L
Mfstroke
.69713 .49451 m
.7336 .61803 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`4000900001Hb000`400?l00000o`00003oo`3ooooo
0?oood80oooo003o0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo
003o0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o0?ooool0
oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o0?ooool0oooo@P3oool0
0?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo002/0?ooo`D00000E@3oool8000000H0oooo
1000001?0?ooo`P000001@3oool5000004h0oooo200000060?ooo`@00000C`3oool8000000D0oooo
1@0000060?ooo`00Z`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo05H0oooo00<0
00000?ooo`3oool01P3oool2000000<0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?oo
o`050?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0B`3oool2000000D0oooo00<0
00000?ooo`3oool00`3oool2000000<0oooo00<000000?ooo`3oool0C03oool2000000D0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo002b
0?ooo`030000003oool0oooo05D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`02
0?ooo`800000D@3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo04`0oooo00<00000
0?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0P00001?
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`02
0?ooo`00/P3oool00`000000oooo0?ooo`1E0?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`1?0?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool0C@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool0CP3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0080oooo002b0?ooo`03
0000003oool0oooo05D0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo04l0oooo00<000000?ooo`3oool0303oool00`000000oooo0?ooo`1>0?ooo`03
0000003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1?0?ooo`03
0000003oool0oooo00`0oooo00<000000?ooo`3oool00P3oool00;80oooo00<000000?ooo`3oool0
E@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
C`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0500oooo00<000000?ooo`3oool0
2`3oool00`000000oooo0?ooo`020?ooo`00[03oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo05H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo04l0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo0540oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`040?ooo`030000003o
ool0oooo0540oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003o
ool0oooo00<0oooo002/0?ooo`D00000F@3oool00`000000oooo0?ooo`050?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool0C`3oool00`000000oooo0?ooo`060?ooo`D00000E03oool2
000000@0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`1A0?ooo`8000001@3oool5
000000H0oooo002/0?ooo`030000003oool0oooo05/0oooo00<000000?ooo`3oool01@3oool00`00
0000oooo0?ooo`040?ooo`030000003oool0oooo04l0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`1G0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`00
0000oooo0?ooo`1B0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0203oool00:`0
oooo00<000000?ooo`3oool0F`3oool00`000000oooo0?ooo`050?ooo`8000001@3oool00`000000
oooo0?ooo`1?0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0E`3oool00`000000
oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`1B0?ooo`030000003oool0oooo00<0
oooo00<000000?ooo`3oool0203oool00:`0oooo00<000000?ooo`3oool0E`3oool01@000000oooo
0?ooo`3oool0000000P0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`1<0?ooo`05
0000003oool0oooo0?ooo`000000203oool00`000000oooo0?ooo`1@0?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo
04`0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo
00P0oooo002/0?ooo`030000003oool0oooo05P0oooo100000080?ooo`8000000`3oool00`000000
oooo0?ooo`1=0?ooo`@00000203oool00`000000oooo0?ooo`1@0?ooo`8000000`3oool2000000H0
oooo0P0000030?ooo`030000003oool0oooo04`0oooo0P0000030?ooo`8000001P3oool00`000000
oooo0?ooo`080?ooo`00[03oool6000005L0oooo0P0000090?ooo`@00000DP3oool2000000P0oooo
1P00001?0?ooo`@00000203oool400000540oooo100000070?ooo`H000001@3oool00?l0ooooo`3o
oom20?ooo`00o`3ooooo0?oood80oooo001>0?ooo`030000003oool0oooo0?l0ooool03oool004h0
oooo00<000000?ooo`3oool0o`3oooo`0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooo00oooo
001>0?ooo`030000003oool0oooo0?l0ooool03oool004h0oooo00<000000?ooo`3oool0o`3oooo`
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooo00oooo001>0?ooo`030000003oool0oooo0?l0
ooool03oool004h0oooo00<000000?ooo`3oool0o`3oooo`0?ooo`00@P3ooooo00000?h000000@3o
ool004h0oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo0100oooo00<000000?ooo`3oool0403oool00`000000oooo0?ooo`0A0?ooo`030000003oool0
oooo00D0oooo4`00000<0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`0@0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0403oool0
0`000000oooo0?ooo`0@0?ooo`030000003oool0oooo00/0oooo001>0?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0@0?ooo`030000003oool0oooo
00D0oooo1P0000060?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`0A0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0403oool00`00
0000oooo0?ooo`0@0?ooo`030000003oool0oooo00/0oooo001>0?ooo`030000003oool0oooo05h0
oooo00<000000?ooo`3oool07P3oool8000003P0oooo00<000000?ooo`3oool0GP3oool00`000000
oooo0?ooo`1M0?ooo`030000003oool0oooo05h0oooo00<000000?ooo`3oool02`3oool004h0oooo
00<000000?ooo`3oool0Q`3oool800000?l0ooooH@3oool004h0oooo00<000000?ooo`3oool0S`3o
ool500000?l0ooooG03oool004h0oooo00<000000?ooo`3oool0U03oool500000?l0ooooE`3oool0
04h0oooo00<000000?ooo`3oool0V@3oool400000?l0ooooD`3oool004h0oooo00<000000?ooo`3o
ool0W@3oool400000?l0ooooC`3oool004h0oooo00<000000?ooo`3oool0X@3oool400000?l0oooo
B`3oool004h0oooo00<000000?ooo`3oool0Y@3oool400000?l0ooooA`3oool004h0oooo00<00000
0?ooo`3oool0Z@3oool300000?l0ooooA03oool004h0oooo0`00002/0?ooo`<00000o`3ooom10?oo
o`00CP3oool00`000000oooo0?ooo`2_0?ooo`<00000o`3oooln0?ooo`00CP3oool00`000000oooo
0?ooo`2b0?ooo`<00000o`3ooolk0?ooo`00CP3oool00`000000oooo0?ooo`2e0?ooo`800000o`3o
ooli0?ooo`00CP3oool00`000000oooo0?ooo`2g0?ooo`800000o`3ooolg0?ooo`00CP3oool00`00
0000oooo0?ooo`2i0?ooo`800000o`3ooole0?ooo`00CP3oool00`000000oooo0?ooo`2k0?ooo`H0
0000o`3oool_0?ooo`00CP3oool00`000000oooo0?ooo`2m0?ooo`@00000o`3oool_0?ooo`00CP3o
ool00`000000oooo0?ooo`2n0?ooo`@00000o`3oool^0?ooo`00CP3oool00`000000oooo0?ooo`2o
0?ooo`030000003oool0oooo00800000o`3oool/0?ooo`00CP3oool00`000000oooo0?ooo`340?oo
o`800000o`3ooolZ0?ooo`00CP3oool00`000000oooo0?ooo`360?ooo`800000o`3ooolX0?ooo`00
CP3oool00`000000oooo0?ooo`380?ooo`800000o`3ooolV0?ooo`00CP3oool300000<X0oooo0P00
003o0?ooob@0oooo001>0?ooo`030000003oool0oooo0<`0oooo00<000000?ooo`3oool0o`3ooolQ
0?ooo`00CP3oool00`000000oooo0?ooo`3=0?ooo`800000o`3ooolQ0?ooo`00CP3oool00`000000
oooo0?ooo`3?0?ooo`800000o`3ooolO0?ooo`00CP3oool00`000000oooo0?ooo`3A0?ooo`030000
003oool0oooo0?l0oooo703oool004h0oooo00<000000?ooo`3oool0dP3oool200000?l0oooo703o
ool004h0oooo00<000000?ooo`3oool0e03oool200000?l0oooo6P3oool004h0oooo00<000000?oo
o`3oool0eP3oool00`000000oooo0?ooo`3o0?oooaL0oooo001>0?ooo`030000003oool0oooo0=L0
oooo0P00003o0?oooaL0oooo001>0?ooo`030000003oool0oooo0=T0oooo0P00003o0?oooaD0oooo
001>0?ooo`030000003oool0oooo0=/0oooo00<000000?ooo`3oool0o`3ooolB0?ooo`00CP3oool0
0`000000oooo0?ooo`3L0?ooo`030000003oool0oooo0?l0oooo4@3oool004h0oooo00<000000?oo
o`3oool0g@3oool200000?l0oooo4@3oool004h0oooo0`00003N0?ooo`800000o`3oool@0?ooo`00
CP3oool00`000000oooo0?ooo`3O0?ooo`800000o`3oool?0?ooo`00CP3oool00`000000oooo0?oo
o`3Q0?ooo`030000003oool0oooo0?l0oooo303oool004h0oooo00<000000?ooo`3oool0hP3oool0
0`000000oooo0?ooo`3o0?ooo`/0oooo001>0?ooo`030000003oool0oooo0><0oooo00<000000?oo
o`3oool0o`3oool:0?ooo`00CP3oool00`000000oooo0?ooo`3T0?ooo`800000o`3oool:0?ooo`00
CP3oool00`000000oooo0?ooo`3U0?ooo`800000o`3oool90?ooo`00CP3oool00`000000oooo0?oo
o`3V0?ooo`800000o`3oool80?ooo`00CP3oool00`000000oooo0?ooo`3X0?ooo`030000003oool0
oooo0?l0oooo1@3oool004h0oooo00<000000?ooo`3oool0j@3oool00`000000oooo0?ooo`3o0?oo
o`@0oooo001>0?ooo`030000003oool0oooo0>X0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
CP3oool00`000000oooo0?ooo`3[0?ooo`800000o`3oool30?ooo`00CP3oool300000>`0oooo0P00
003o0?ooo`80oooo001>0?ooo`030000003oool0oooo0>d0oooo0P00003o0?ooo`40oooo001>0?oo
o`030000003oool0oooo0>l0oooo00<000000?ooo`3oool0o@3oool004h0oooo00<000000?ooo`3o
ool0l03oool00`000000oooo0?ooo`3l0?ooo`00CP3oool00`000000oooo0?ooo`3a0?ooo`030000
003oool0oooo0?/0oooo001>0?ooo`030000003oool0oooo0?80oooo00<000000?ooo`3oool0nP3o
ool004h0oooo00<000000?ooo`3oool0lP3oool200000?/0oooo001>0?ooo`030000003oool0oooo
0?<0oooo0P00003j0?ooo`003`3oool5000000P0oooo100000080?ooo`@00000203oool4000000P0
oooo1000000:0?ooo`030000003oool0oooo0?@0oooo0P00003i0?ooo`003P3oool00`000000oooo
0?ooo`030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo
0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo
0P0000030?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0m@3oool00`000000oooo
0?ooo`3g0?ooo`005@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0P00
00050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P00
00050?ooo`030000003oool0oooo0080oooo0P0000080?ooo`030000003oool0oooo0?H0oooo00<0
00000?ooo`3oool0mP3oool001D0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`02
0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`04
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0m`3oool00`000000oooo0?ooo`3e
0?ooo`005@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`3h0?ooo`030000003oool0oooo0?@0oooo000E0?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`@0
0000n03oool00`000000oooo0?ooo`3c0?ooo`003`3oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo0?T0oooo0P00003d0?ooo`003`3oool5000000H0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3o
ool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?X0oooo0P00003c0?ooo`003`3oool0
0`000000oooo0?ooo`080?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`3k0?ooo`030000003oool0oooo0?40oooo000?0?ooo`030000003oool0oooo
00P0oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo
0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo
00H0oooo00<000000?ooo`3oool0o03oool00`000000oooo0?ooo`3`0?ooo`003`3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool01`3oool00`000000
oooo0?ooo`3m0?ooo`030000003oool0oooo0>l0oooo000?0?ooo`030000003oool0oooo00T0oooo
0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo
0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool0oP3oool00`000000oooo0?ooo`3^0?ooo`003`3oool6000000L0oooo1000
00080?ooo`@00000203oool4000000P0oooo1000000:0?ooo`030000003oool0oooo0?l0oooo00<0
00000?ooo`3oool0k@3oool004h0oooo00<000000?ooo`3oool0o`3oool200000>h0oooo001>0?oo
o`030000003oool0oooo0?l0oooo0@3oool200000>d0oooo001>0?ooo`030000003oool0oooo0?l0
oooo0P3oool200000>`0oooo001>0?ooo`030000003oool0oooo0?l0oooo0`3oool00`000000oooo
0?ooo`3Z0?ooo`00CP3oool300000?l0oooo103oool00`000000oooo0?ooo`3Y0?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?ooo`D0oooo00<000000?ooo`3oool0j03oool004h0oooo00<000000?oo
o`3oool0o`3oool60?ooo`030000003oool0oooo0>L0oooo001>0?ooo`030000003oool0oooo0?l0
oooo1P3oool00`000000oooo0?ooo`3W0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooo`L0oooo
00<000000?ooo`3oool0iP3oool004h0oooo00<000000?ooo`3oool0o`3oool80?ooo`030000003o
ool0oooo0>D0oooo001>0?ooo`030000003oool0oooo0?l0oooo203oool00`000000oooo0?ooo`3U
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooo`T0oooo00<000000?ooo`3oool0i03oool004h0
oooo00<000000?ooo`3oool0o`3oool90?ooo`800000i@3oool004h0oooo00<000000?ooo`3oool0
o`3oool:0?ooo`030000003oool0oooo0><0oooo001>0?ooo`030000003oool0oooo0?l0oooo2`3o
ool00`000000oooo0?ooo`3R0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooo`/0oooo0P00003S
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooo``0oooo00<000000?ooo`3oool0h@3oool004h0
oooo0`00003o0?ooo`d0oooo00<000000?ooo`3oool0h03oool004h0oooo00<000000?ooo`3oool0
o`3oool=0?ooo`800000h@3oool004h0oooo00<000000?ooo`3oool0o`3oool>0?ooo`030000003o
ool0oooo0=l0oooo001>0?ooo`030000003oool0oooo0?l0oooo3`3oool00`000000oooo0?ooo`3N
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooo`l0oooo0P00003O0?ooo`00CP3oool00`000000
oooo0?ooo`3o0?oooa00oooo00<000000?ooo`3oool0g@3oool004h0oooo00<000000?ooo`3oool0
o`3ooolA0?ooo`030000003oool0oooo0=`0oooo001>0?ooo`030000003oool0oooo0?l0oooo4@3o
ool200000=d0oooo001>0?ooo`030000003oool0oooo0?l0oooo4P3oool00`000000oooo0?ooo`3K
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooa<0oooo00<000000?ooo`3oool0fP3oool004h0
oooo00<000000?ooo`3oool0o`3ooolC0?ooo`800000f`3oool004h0oooo00<000000?ooo`3oool0
o`3ooolD0?ooo`030000003oool0oooo0=T0oooo001>0?ooo`030000003oool0oooo0?l0oooo5@3o
ool00`000000oooo0?ooo`3H0?ooo`00CP3oool300000?l0oooo5@3oool00`000000oooo0?ooo`3H
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooaH0oooo00<000000?ooo`3oool0e`3oool004h0
oooo00<000000?ooo`3oool0o`3ooolG0?ooo`030000003oool0oooo0=H0oooo001>0?ooo`030000
003oool0oooo0?l0oooo5`3oool00`000000oooo0?ooo`3F0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?oooaP0oooo00<000000?ooo`3oool0e@3oool004h0oooo00<000000?ooo`3oool0o`3ooolH
0?ooo`800000eP3oool004h0oooo00<000000?ooo`3oool0o`3ooolI0?ooo`030000003oool0oooo
0=@0oooo001>0?ooo`030000003oool0oooo0?l0oooo6P3oool00`000000oooo0?ooo`3C0?ooo`00
CP3oool00`000000oooo0?ooo`3o0?oooaX0oooo00<000000?ooo`3oool0d`3oool004h0oooo00<0
00000?ooo`3oool0o`3ooolK0?ooo`030000003oool0oooo0=80oooo001>0?ooo`030000003oool0
oooo0?l0oooo6`3oool00`000000oooo0?ooo`3B0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oo
oa`0oooo00<000000?ooo`3oool0d@3oool004h0oooo0`00003o0?oooa`0oooo00<000000?ooo`3o
ool0d@3oool004h0oooo00<000000?ooo`3oool0o`3ooolM0?ooo`030000003oool0oooo0=00oooo
001>0?ooo`030000003oool0oooo0?l0oooo7@3oool00`000000oooo0?ooo`3@0?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?oooah0oooo00<000000?ooo`3oool0c`3oool004h0oooo00<000000?oo
o`3oool0o`3ooolN0?ooo`800000d03oool004h0oooo00<000000?ooo`3oool0o`3ooolO0?ooo`@0
0000c@3oool004h0oooo00<000000?ooo`3oool0o`3ooolO0?ooo`@00000c@3oool004h0oooo00<0
00000?ooo`3oool0o`3ooolP0?ooo`<00000c@3oool00080oooo200000060?ooo`@00000203oool4
000000P0oooo100000080?ooo`@00000203oool4000000X0oooo00<000000?ooo`3oool0o`3ooolQ
0?ooo`030000003oool0oooo0<`0oooo00060?ooo`030000003oool0oooo00H0oooo0P0000030?oo
o`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?oo
o`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3ooolQ0?ooo`030000003oool0oooo
0<`0oooo00060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool00P3oool2000000D0
oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0
oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000P0
oooo00<000000?ooo`3oool0o`3ooolR0?ooo`030000003oool0oooo0</0oooo00060?ooo`030000
003oool0oooo00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooob80oooo
00<000000?ooo`3oool0b`3oool000H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo0?l0oooo8`3oool00`000000oooo0?ooo`3:0?ooo`001P3oool0
0`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo1000003o0?ooob80oooo00<00000
0?ooo`3oool0bP3oool000H0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo0?l0oooo903oool00`000000oooo0?ooo`390?ooo`001P3oool00`000000
oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooolT0?ooo`03
0000003oool0oooo0<T0oooo00060?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`3o0?ooobD0oooo00<000000?ooo`3oool0b03oool000H0oooo00<0
00000?ooo`3oool01@3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<0
00000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<0
00000?ooo`3oool00P3oool2000000D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`3o0?ooobD0oooo0P0000390?ooo`000P3oool01@000000oooo0?ooo`3oool0000000P0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`3o0?ooobH0oooo00<000000?ooo`3oool0a`3o
ool000<0oooo100000080?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool0
0`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool0
0`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo0?l0oooo9P3oool200000<P0oooo00050?ooo`8000002@3oool4000000P0oooo100000080?oo
o`@00000203oool4000000P0oooo1000000:0?ooo`030000003oool0oooo0?l0oooo9`3oool00`00
0000oooo0?ooo`360?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooobP0oooo00<000000?ooo`3o
ool0a@3oool004h0oooo00<000000?ooo`3oool0o`3ooolX0?ooo`030000003oool0oooo0<D0oooo
001>0?ooo`030000003oool0oooo0?l0oooo:@3oool00`000000oooo0?ooo`340?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?ooobT0oooo00<000000?ooo`3oool0a03oool004h0oooo0`00003o0?oo
obX0oooo00<000000?ooo`3oool0``3oool004h0oooo00<000000?ooo`3oool0o`3ooolZ0?ooo`03
0000003oool0oooo0<<0oooo001>0?ooo`030000003oool0oooo0?l0oooo:`3oool00`000000oooo
0?ooo`320?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooob/0oooo00<000000?ooo`3oool0`P3o
ool004h0oooo00<000000?ooo`3oool0o`3oool/0?ooo`030000003oool0oooo0<40oooo001>0?oo
o`030000003oool0oooo0?l0oooo;03oool200000<80oooo001>0?ooo`030000003oool0oooo0?l0
oooo;@3oool00`000000oooo0?ooo`300?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooobd0oooo
00<000000?ooo`3oool0`03oool004h0oooo00<000000?ooo`3oool0o`3oool^0?ooo`030000003o
ool0oooo0;l0oooo001>0?ooo`030000003oool0oooo0?l0oooo;P3oool00`000000oooo0?ooo`2o
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooobl0oooo00<000000?ooo`3oool0_P3oool004h0
oooo00<000000?ooo`3oool0o`3oool_0?ooo`030000003oool0oooo0;h0oooo001>0?ooo`030000
003oool0oooo0?l0oooo<03oool00`000000oooo0?ooo`2m0?ooo`00CP3oool300000?l0oooo<03o
ool00`000000oooo0?ooo`2m0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooc00oooo0P00002n
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooc40oooo00<000000?ooo`3oool0_03oool004h0
oooo00<000000?ooo`3oool0o`3ooola0?ooo`030000003oool0oooo0;`0oooo001>0?ooo`030000
003oool0oooo0?l0oooo<P3oool00`000000oooo0?ooo`2k0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?oooc80oooo00<000000?ooo`3oool0^`3oool004h0oooo00<000000?ooo`3oool0o`3ooolc
0?ooo`030000003oool0oooo0;X0oooo001>0?ooo`030000003oool0oooo0?l0oooo<`3oool00`00
0000oooo0?ooo`2j0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooc<0oooo0P00002k0?ooo`00
CP3oool00`000000oooo0?ooo`3o0?oooc@0oooo00<000000?ooo`3oool0^@3oool004h0oooo00<0
00000?ooo`3oool0o`3ooold0?ooo`030000003oool0oooo0;T0oooo001>0?ooo`030000003oool0
oooo0?l0oooo=@3oool00`000000oooo0?ooo`2h0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oo
ocD0oooo00<000000?ooo`3oool0^03oool004h0oooo0`00003o0?ooocH0oooo00<000000?ooo`3o
ool0]`3oool004h0oooo00<000000?ooo`3oool0o`3ooolf0?ooo`030000003oool0oooo0;L0oooo
001>0?ooo`030000003oool0oooo0?l0oooo=`3oool00`000000oooo0?ooo`2f0?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?ooocL0oooo00<000000?ooo`3oool0]P3oool004h0oooo00<000000?oo
o`3oool0o`3ooolg0?ooo`030000003oool0oooo0;H0oooo001>0?ooo`030000003oool0oooo0?l0
oooo>03oool00`000000oooo0?ooo`2e0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooocP0oooo
00<000000?ooo`3oool0]@3oool004h0oooo00<000000?ooo`3oool0o`3oooli0?ooo`030000003o
ool0oooo0;@0oooo001>0?ooo`030000003oool0oooo0?l0oooo>@3oool00`000000oooo0?ooo`2d
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooocX0oooo00<000000?ooo`3oool0/`3oool004h0
oooo00<000000?ooo`3oool0o`3ooolj0?ooo`030000003oool0oooo0;<0oooo001>0?ooo`030000
003oool0oooo0?l0oooo>P3oool200000;@0oooo001>0?ooo`<00000o`3ooolk0?ooo`030000003o
ool0oooo0;80oooo001>0?ooo`030000003oool0oooo0?l0oooo>`3oool00`000000oooo0?ooo`2b
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooc`0oooo00<000000?ooo`3oool0/@3oool004h0
oooo00<000000?ooo`3oool0o`3oooll0?ooo`030000003oool0oooo0;40oooo001>0?ooo`030000
003oool0oooo0?l0oooo?@3oool00`000000oooo0?ooo`2`0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?ooocd0oooo00<000000?ooo`3oool0/03oool004h0oooo00<000000?ooo`3oool0o`3ooolm
0?ooo`800000/@3oool004h0oooo00<000000?ooo`3oool0o`3oooln0?ooo`030000003oool0oooo
0:l0oooo00020?ooo`P000001@3oool5000000P0oooo100000080?ooo`@00000203oool4000000P0
oooo1000000:0?ooo`030000003oool0oooo0?l0oooo?P3oool00`000000oooo0?ooo`2_0?ooo`00
1P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
103oool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0
103oool2000000<0oooo00<000000?ooo`3oool0103oool2000000<0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`3o0?ooocl0oooo00<000000?ooo`3oool0[P3oool000H0oooo00<0
00000?ooo`3oool0303oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo0P00
00050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P00
00050?ooo`030000003oool0oooo0080oooo0P0000080?ooo`030000003oool0oooo0?l0oooo?`3o
ool00`000000oooo0?ooo`2^0?ooo`001P3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo0?l0oooo@03oool00`000000oooo0?ooo`2]0?ooo`001P3oool00`000000oooo0?ooo`0<0?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo0?l0oooo@03oool00`000000oooo0?ooo`2]0?ooo`001P3oool00`000000
oooo0?ooo`0<0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`060?ooo`@00000o`3ooom00?ooo`030000003oool0oooo0:`0oooo00060?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`030?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000
003oool0oooo00@0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?oood40oooo
00<000000?ooo`3oool0[03oool000H0oooo00<000000?ooo`3oool01P3oool5000000H0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0oooo@@3o
ool00`000000oooo0?ooo`2/0?ooo`001P3oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0
oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0
oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo0?l0oooo@P3oool00`000000oooo0?ooo`2[0?ooo`001P3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00P0oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?oo
o`030000003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooom20?ooo`030000003oool0oooo
0:/0oooo00020?ooo`050000003oool0oooo0?ooo`000000203oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3o0?oo
od80oooo00<000000?ooo`3oool0Z`3oool000<0oooo100000080?ooo`030000003oool0oooo00T0
oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00@0
oooo0P0000030?ooo`030000003oool0oooo00@0oooo0P0000030?ooo`030000003oool0oooo00L0
oooo00<000000?ooo`3oool0o`3ooom30?ooo`030000003oool0oooo0:X0oooo00050?ooo`800000
203oool6000000L0oooo100000080?ooo`@00000203oool4000000P0oooo1000000:0?ooo`030000
003oool0oooo0?l0oooo@`3oool00`000000oooo0?ooo`2Z0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?oood<0oooo00<000000?ooo`3oool0ZP3oool004h0oooo00<000000?ooo`3oool0o`3ooom4
0?ooo`030000003oool0oooo0:T0oooo001>0?ooo`030000003oool0oooo0?l0ooooA03oool00`00
0000oooo0?ooo`2Y0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oood@0oooo0P00002Z0?ooo`00
CP3oool300000?l0ooooA@3oool00`000000oooo0?ooo`2X0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?ooodD0oooo00<000000?ooo`3oool0Z03oool004h0oooo00<000000?ooo`3oool0o`3ooom6
0?ooo`030000003oool0oooo0:L0oooo001>0?ooo`030000003oool0oooo0?l0ooooAP3oool00`00
0000oooo0?ooo`2W0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooodH0oooo00<000000?ooo`3o
ool0Y`3oool004h0oooo00<000000?ooo`3oool0o`3ooom70?ooo`030000003oool0oooo0:H0oooo
001>0?ooo`030000003oool0oooo0?l0ooooA`3oool00`000000oooo0?ooo`2V0?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?ooodL0oooo00<000000?ooo`3oool0YP3oool004h0oooo00<000000?oo
o`3oool0o`3ooom80?ooo`030000003oool0oooo0:D0oooo001>0?ooo`030000003oool0oooo0?l0
ooooB03oool00`000000oooo0?ooo`2U0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooodP0oooo
00<000000?ooo`3oool0Y@3oool004h0oooo00<000000?ooo`3oool0o`3ooom90?ooo`030000003o
ool0oooo0:@0oooo001>0?ooo`030000003oool0oooo0?l0ooooB@3oool00`000000oooo0?ooo`2T
0?ooo`00CP3oool300000?l0ooooB@3oool00`000000oooo0?ooo`2T0?ooo`00CP3oool00`000000
oooo0?ooo`3o0?ooodX0oooo00<000000?ooo`3oool0X`3oool004h0oooo00<000000?ooo`3oool0
o`3ooom:0?ooo`030000003oool0oooo0:<0oooo001>0?ooo`030000003oool0oooo0?l0ooooBP3o
ool200000:@0oooo001>0?ooo`030000003oool0oooo0?l0ooooB`3oool00`000000oooo0?ooo`2R
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oood/0oooo00<000000?ooo`3oool0XP3oool004h0
oooo00<000000?ooo`3oool0o`3ooom<0?ooo`030000003oool0oooo0:40oooo001>0?ooo`030000
003oool0oooo0?l0ooooC03oool00`000000oooo0?ooo`2Q0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?oood`0oooo00<000000?ooo`3oool0X@3oool004h0oooo00<000000?ooo`3oool0o`3ooom=
0?ooo`030000003oool0oooo0:00oooo001>0?ooo`030000003oool0oooo0?l0ooooC@3oool00`00
0000oooo0?ooo`2P0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooodd0oooo00<000000?ooo`3o
ool0X03oool004h0oooo00<000000?ooo`3oool0o`3ooom>0?ooo`030000003oool0oooo09l0oooo
001>0?ooo`<00000o`3ooom>0?ooo`030000003oool0oooo09l0oooo001>0?ooo`030000003oool0
oooo0?l0ooooCP3oool00`000000oooo0?ooo`2O0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oo
odl0oooo00<000000?ooo`3oool0WP3oool004h0oooo00<000000?ooo`3oool0o`3ooom?0?ooo`03
0000003oool0oooo09h0oooo001>0?ooo`030000003oool0oooo0?l0ooooC`3oool00`000000oooo
0?ooo`2N0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooe00oooo00<000000?ooo`3oool0W@3o
ool004h0oooo00<000000?ooo`3oool0o`3ooom@0?ooo`030000003oool0oooo09d0oooo001>0?oo
o`030000003oool0oooo0?l0ooooD03oool2000009h0oooo001>0?ooo`030000003oool0oooo0?l0
ooooD@3oool00`000000oooo0?ooo`2L0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooe40oooo
00<000000?ooo`3oool0W03oool004h0oooo00<000000?ooo`3oool0o`3ooomB0?ooo`030000003o
ool0oooo09/0oooo001>0?ooo`030000003oool0oooo0?l0ooooDP3oool00`000000oooo0?ooo`2K
0?ooo`00CP3oool300000?l0ooooDP3oool00`000000oooo0?ooo`2K0?ooo`00CP3oool00`000000
oooo0?ooo`3o0?oooe<0oooo00<000000?ooo`3oool0VP3oool004h0oooo00<000000?ooo`3oool0
o`3ooomC0?ooo`030000003oool0oooo09X0oooo001>0?ooo`030000003oool0oooo0?l0ooooD`3o
ool00`000000oooo0?ooo`2J0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooe@0oooo00<00000
0?ooo`3oool0V@3oool004h0oooo00<000000?ooo`3oool0o`3ooomD0?ooo`030000003oool0oooo
09T0oooo001>0?ooo`030000003oool0oooo0?l0ooooE03oool00`000000oooo0?ooo`2I0?ooo`00
CP3oool00`000000oooo0?ooo`3o0?oooeD0oooo00<000000?ooo`3oool0V03oool00080oooo2000
00060?ooo`@00000203oool4000000P0oooo100000080?ooo`@00000203oool4000000X0oooo00<0
00000?ooo`3oool0o`3ooomE0?ooo`030000003oool0oooo09P0oooo00020?ooo`8000001@3oool0
0`000000oooo0?ooo`030?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool0
0`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool0
0`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo0?l0ooooE@3oool00`000000oooo0?ooo`2H0?ooo`00103oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?oo
o`3oool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000D0oooo00<000000?oo
o`3oool00P3oool2000000D0oooo00<000000?ooo`3oool00P3oool2000000P0oooo00<000000?oo
o`3oool0o`3ooomE0?ooo`800000V@3oool000D0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooEP3oool00`000000oooo0?ooo`2G0?ooo`00
1P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
0P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
o`3ooomF0?ooo`030000003oool0oooo09L0oooo00070?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool0103oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<0
00000?ooo`3oool01P3oool400000?l0ooooE@3oool00`000000oooo0?ooo`2G0?ooo`00203oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool0
0`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool0
0`000000oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomG
0?ooo`030000003oool0oooo09H0oooo00080?ooo`800000103oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo0?l0ooooE`3oool00`000000oooo0?ooo`2F0?ooo`002@3oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000
oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`040?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomG0?ooo`03
0000003oool0oooo09H0oooo00090?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000
003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000
003oool0oooo0080oooo0P0000050?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomH0?ooo`030000003oool0oooo09D0oooo
00020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool00P3oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo0?l0ooooF03oool00`000000oooo0?ooo`2E0?ooo`000P3oool2
000000<0oooo0P0000060?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool0
0`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`040?ooo`8000000`3oool0
0`000000oooo0?ooo`040?ooo`8000000`3oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo0?l0ooooF03oool00`000000oooo0?ooo`2E0?ooo`00103oool4000000P0oooo100000080?oo
o`@00000203oool4000000P0oooo100000080?ooo`@000002P3oool00`000000oooo0?ooo`3o0?oo
oeT0oooo00<000000?ooo`3oool0U03oool004h0oooo00<000000?ooo`3oool0o`3ooomI0?ooo`03
0000003oool0oooo09@0oooo001>0?ooo`030000003oool0oooo0?l0ooooF@3oool00`000000oooo
0?ooo`2D0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooeT0oooo1000002C0?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?oooeT0oooo1000002C0?ooo`00CP3oool300000?l0ooooFP3oool30000
09<0oooo001>0?ooo`030000003oool0oooo0?l0ooooFP3oool2000009@0oooo001>0?ooo`030000
003oool0oooo0?l0ooooF`3oool00`000000oooo0?ooo`2B0?ooo`00CP3oool00`000000oooo0?oo
o`3o0?oooe/0oooo00<000000?ooo`3oool0TP3oool004h0oooo00<000000?ooo`3oool0o`3ooomK
0?ooo`030000003oool0oooo0980oooo001>0?ooo`030000003oool0oooo0?l0ooooG03oool00`00
0000oooo0?ooo`2A0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooe`0oooo00<000000?ooo`3o
ool0T@3oool004h0oooo00<000000?ooo`3oool0o`3ooomL0?ooo`030000003oool0oooo0940oooo
001>0?ooo`030000003oool0oooo0?l0ooooG03oool00`000000oooo0?ooo`2A0?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?oooed0oooo00<000000?ooo`3oool0T03oool004h0oooo00<000000?oo
o`3oool0o`3ooomM0?ooo`030000003oool0oooo0900oooo001>0?ooo`030000003oool0oooo0?l0
ooooG@3oool00`000000oooo0?ooo`2@0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oooeh0oooo
00<000000?ooo`3oool0S`3oool004h0oooo0`00003o0?oooeh0oooo00<000000?ooo`3oool0S`3o
ool004h0oooo00<000000?ooo`3oool0o`3ooomN0?ooo`030000003oool0oooo08l0oooo001>0?oo
o`030000003oool0oooo0?l0ooooG`3oool00`000000oooo0?ooo`2>0?ooo`00CP3oool00`000000
oooo0?ooo`3o0?oooel0oooo00<000000?ooo`3oool0SP3oool004h0oooo00<000000?ooo`3oool0
o`3ooomO0?ooo`030000003oool0oooo08h0oooo001>0?ooo`030000003oool0oooo0?l0ooooG`3o
ool00`000000oooo0?ooo`2>0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooof00oooo00<00000
0?ooo`3oool0S@3oool004h0oooo00<000000?ooo`3oool0o`3ooomP0?ooo`030000003oool0oooo
08d0oooo001>0?ooo`030000003oool0oooo0?l0ooooH03oool00`000000oooo0?ooo`2=0?ooo`00
CP3oool00`000000oooo0?ooo`3o0?ooof40oooo00<000000?ooo`3oool0S03oool004h0oooo00<0
00000?ooo`3oool0o`3ooomQ0?ooo`030000003oool0oooo08`0oooo001>0?ooo`030000003oool0
oooo0?l0ooooH@3oool00`000000oooo0?ooo`2<0?ooo`00CP3oool00`000000oooo0?ooo`3o0?oo
of80oooo00<000000?ooo`3oool0R`3oool004h0oooo0`00003o0?ooof80oooo00<000000?ooo`3o
ool0R`3oool004h0oooo00<000000?ooo`3oool0o`3ooomR0?ooo`030000003oool0oooo08/0oooo
001>0?ooo`030000003oool0oooo0?l0ooooHP3oool00`000000oooo0?ooo`2;0?ooo`00CP3oool0
0`000000oooo0?ooo`3o0?ooof<0oooo00<000000?ooo`3oool0RP3oool004h0oooo00<000000?oo
o`3oool0o`3ooomS0?ooo`030000003oool0oooo08X0oooo001>0?ooo`030000003oool0oooo0?l0
ooooH`3oool00`000000oooo0?ooo`2:0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooof@0oooo
00<000000?ooo`3oool0R@3oool004h0oooo00<000000?ooo`3oool0o`3ooomT0?ooo`030000003o
ool0oooo08T0oooo001>0?ooo`030000003oool0oooo0?l0ooooI03oool00`000000oooo0?ooo`29
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooofD0oooo00<000000?ooo`3oool0R03oool004h0
oooo00<000000?ooo`3oool0o`3ooomU0?ooo`030000003oool0oooo08P0oooo001>0?ooo`030000
003oool0oooo0?l0ooooI@3oool00`000000oooo0?ooo`280?ooo`00CP3oool300000?l0ooooI@3o
ool2000008T0oooo001>0?ooo`030000003oool0oooo0?l0ooooIP3oool00`000000oooo0?ooo`27
0?ooo`00CP3oool00`000000oooo0?ooo`3o0?ooofH0oooo00<000000?ooo`3oool0Q`3oool004h0
oooo00<000000?ooo`3oool0o`3ooomV0?ooo`030000003oool0oooo08L0oooo001>0?ooo`030000
003oool0oooo0?l0ooooI`3oool00`000000oooo0?ooo`260?ooo`00CP3oool00`000000oooo0?oo
o`3o0?ooofL0oooo00<000000?ooo`3oool0QP3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oo
od80oooo003o0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o
0?ooool0oooo@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo003o0?ooool0oooo
@P3oool00?l0ooooo`3ooom20?ooo`00o`3ooooo0?oood80oooo0000\
\>"],
  ImageRangeCache->{{{0, 575}, {354.875, 0}} -> {-4.04324, -28731.4, \
0.103194, 1587.02}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Number of nonzero and memory", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4size = {{15, 7679, 482468}, {20, 19010, 1590703}, {30, 66715, 
          8305827}, {40, 161220, 26633486}, {50, 318525, 
          66. *10^6}}\)], "Input"],

Cell[BoxData[
    \({{15, 7679, 482468}, {20, 19010, 1590703}, {30, 66715, 8305827}, {40, 
        161220, 26633486}, {50, 318525, 6.6`*^7}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4nonzero = Map[\((#[\([{1, 3}]\)])\) &, p4size]\)], "Input"],

Cell[BoxData[
    \({{15, 482468}, {20, 1590703}, {30, 8305827}, {40, 26633486}, {50, 
        6.6`*^7}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Fit[Log[p4nonzero], {x, 1}, x]\)], "Input"],

Cell[BoxData[
    \(\(\(2.0441875080737666`\)\(\[InvisibleSpace]\)\) + 
      4.0812410078402745`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4nzfit = Fit[p4nonzero, {kk^4, kk^3}, kk]\)], "Input"],

Cell[BoxData[
    \(\(-26.84932718150732`\)\ kk\^3 + 11.094719984710897`\ kk\^4\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4nzfit /. kk \[Rule] 144\)], "Input"],

Cell[BoxData[
    \(4.690354854296339`*^9\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[
      ListPlot[Map[{#[\([1]\)], Log[#[\([2]\)]]} &, p4nonzero], 
        DisplayFunction \[Rule] Identity], 
      Plot[Log[p4nzfit], {kk, 10, 50}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5size = {{10, 15505, 602208}, {15, 94955, 5443819}, {18, 209373, 
          14393272}, {20, 328910, 24949552}}\)], "Input"],

Cell[BoxData[
    \({{10, 15505, 602208}, {15, 94955, 5443819}, {18, 209373, 
        14393272}, {20, 328910, 24949552}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5nonzero = Map[\((#[\([{1, 3}]\)])\) &, p5size]\)], "Input"],

Cell[BoxData[
    \({{10, 602208}, {15, 5443819}, {18, 14393272}, {20, 
        24949552}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Fit[Log[p5nonzero], {x, 1}, x]\)], "Input"],

Cell[BoxData[
    \(\(\(0.9250501251496434`\)\(\[InvisibleSpace]\)\) + 
      5.380764390070887`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5nzfit = Fit[p5nonzero, {kk^5, kk^4}, kk]\)], "Input"],

Cell[BoxData[
    \(\(-35.86437273676208`\)\ kk\^4 + 9.593653314572837`\ kk\^5\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[
      ListPlot[Map[{#[\([1]\)], Log[#[\([2]\)]]} &, p5nonzero], 
        DisplayFunction \[Rule] Identity], 
      Plot[Log[p5nzfit], {kk, 10, 20}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["\<\
Estimate the total memory needed using 8 bytes for double \
precision, 8 bytes for addressing, complex numbers, and 150 multiplies (this \
seems to be roughly constant in the trials). There about 5 other working \
vectors  plus the basis itself.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4mem = 
      Map[{#[\([1]\)], 8.0*\((2*160*#[\([2]\)] + 3*#[\([3]\)])\)} &, 
        p4size]\)], "Input"],

Cell[BoxData[
    \({{15, 3.1237472`*^7}, {20, 8.6842472`*^7}, {30, 3.70130248`*^8}, {40, 
        1.051926864`*^9}, {50, 2.399424`*^9}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Fit[p4mem, {kk^4, kk^3}, kk]\)], "Input"],

Cell[BoxData[
    \(5225.360743408122`\ kk\^3 + 275.3205302376342`\ kk\^4\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5mem = 
      Map[{#[\([1]\)], 8.0*\((2*160*#[\([2]\)] + 3*#[\([3]\)])\)} &, 
        p5size]\)], "Input"],

Cell[BoxData[
    \({{10, 5.4145792`*^7}, {15, 3.73736456`*^8}, {18, 8.81433408`*^8}, {20, 
        1.440798848`*^9}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Fit[p5mem, {kk^5, kk^4}, kk]\)], "Input"],

Cell[BoxData[
    \(2563.7486611522863`\ kk\^4 + 322.4950965874573`\ kk\^5\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Efficiency of Lanczos", "Section"],

Cell["\<\
The Lanczos routine is dominated by the sparse matrix-vector \
multiply.
The matrix is complex Hermitian
Assume 16 flops per nonzero matrix element (4 multiplies and 4 adds for each \
triangle) and 150 multiplies (this seems to be roughly constant in the \
trials). \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4flops = Map[{#[\([1]\)], 16.0*150*#[\([3]\)]} &, p4size]\)], "Input"],

Cell[BoxData[
    \({{15, 1.1579232`*^9}, {20, 3.8176872`*^9}, {30, 1.99339848`*^10}, {40, 
        6.39203664`*^10}, {50, 1.584`*^11}}\)], "Output"]
}, Open  ]],

Cell["flops per second per processor on Blue Horizon", "Text"],

Cell["K=50, 4 particles", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.584*10^11/{16*8*75, 8*8*75, 8*4*90, 8*2*133}\)], "Input"],

Cell[BoxData[
    \({1.65`*^7, 3.3`*^7, 5.5`*^7, 7.443609022556391`*^7}\)], "Output"]
}, Open  ]],

Cell["K=40, 4 particles", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(6.39*10^10/{4*8*39, 2*8*49, 8*77.5}\)], "Input"],

Cell[BoxData[
    \({5.120192307692308`*^7, 8.150510204081632`*^7, 
      1.0306451612903225`*^8}\)], "Output"]
}, Open  ]],

Cell["K=30, 4 particles", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.99*10^10*\((142/150)\)/{4*8*14.1, 2*8*17.9, 8*24.11, 
          4*38.3}\)], "Input"],

Cell[BoxData[
    \({4.175236406619386`*^7, 6.577746741154563`*^7, 9.76703995575833`*^7, 
      1.2296779808529158`*^8}\)], "Output"]
}, Open  ]],

Cell["K=20, 4 particles", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(3.8176872*10^9*\((130/150)\)/{2*8*4.1, 8*4.0, 4*6.3, 2*13.1, 
          24.25}\)], "Input"],

Cell[BoxData[
    \({5.04369243902439`*^7, 1.03395695`*^8, 1.3129612063492063`*^8, 
      1.2628481832061067`*^8, 1.3643968`*^8}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5flops = Map[{#[\([1]\)], 16.0*150*#[\([3]\)]} &, p5size]\)], "Input"],

Cell[BoxData[
    \({{10, 1.4452992`*^9}, {15, 1.30651656`*^10}, {18, 
        3.45438528`*^10}, {20, 5.98789248`*^10}}\)], "Output"]
}, Open  ]],

Cell["K=20, 5 particles", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(5.98789248*10^10*\((142/150)\)/{8*8*62, 4*8*60, 2*8*75}\)], "Input"],

Cell[BoxData[
    \({1.428563058064516`*^7, 2.9523636533333335`*^7, 
      4.723781845333333`*^7}\)], "Output"]
}, Open  ]],

Cell["K=18, 5 particles", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(3.45439*10^10/{4*8*38.5, 2*8*41.5, 8*62}\)], "Input"],

Cell[BoxData[
    \({2.8038879870129872`*^7, 5.202394578313254`*^7, 
      6.964495967741935`*^7}\)], "Output"]
}, Open  ]],

Cell["K=15, 5 particles", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.30652*10^10*\((122/150)\)/{8*18.69, 4*27.8, 2*50.0}\)], "Input"],

Cell[BoxData[
    \({7.106984126984124`*^7, 9.556081534772179`*^7, 
      1.0626362666666664`*^8}\)], "Output"]
}, Open  ]],

Cell["\<\
Communication data rate comes from the sparse matrix-vector \
multiply.
For each multiply, there is a global gather and scatter.  Each is equal to \
the number of states times the number of processors times the number of bytes \
(16 for double complex).  This is the total per processor:\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(p4com = Map[{#[\([1]\)], 150*2*#[\([2]\)]*16.0} &, p4size]\)], "Input"],

Cell[BoxData[
    \({{15, 3.68592`*^7}, {20, 9.1248`*^7}, {30, 3.20232`*^8}, {40, 
        7.73856`*^8}, {50, 1.52892`*^9}}\)], "Output"]
}, Open  ]],

Cell["\<\
Communication rate in bytes per second per processor (assuming \
communication dominates the time usage)\
\>", "Text"],

Cell["K=50, 4 particles (16*8, 8*8, 4*8, 2*8 processors)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.52892`*^9/{75, 75, 90, 133}\)], "Input"],

Cell[BoxData[
    \({2.03856`*^7, 2.03856`*^7, 1.6988`*^7, 
      1.149563909774436`*^7}\)], "Output"]
}, Open  ]],

Cell["K=40, 4 particles (4*8, 2*8, 8 processors)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(7.73856`*^8/{39, 49, 77.5}\)], "Input"],

Cell[BoxData[
    \({1.984246153846154`*^7, 1.5792979591836736`*^7, 
      9.985238709677419`*^6}\)], "Output"]
}, Open  ]],

Cell["K=30, 4 particles (4*8, 2*8, 8, 4 processors)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(3.20232`*^8/{14.1, 17.9, 24.11, 38.3}\)], "Input"],

Cell[BoxData[
    \({2.271148936170213`*^7, 1.7890055865921788`*^7, 1.3282123600165907`*^7, 
      8.361148825065275`*^6}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p5com = Map[{#[\([1]\)], 150*2*#[\([2]\)]*16.0} &, p5size]\)], "Input"],

Cell[BoxData[
    \({{10, 7.4424`*^7}, {15, 4.55784`*^8}, {18, 1.0049904`*^9}, {20, 
        1.578768`*^9}}\)], "Output"]
}, Open  ]],

Cell["K=20, 5 particles (8*8, 4*8, 2*8 processors)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.578768`*^9/{62, 60, 75}\)], "Input"],

Cell[BoxData[
    \({2.5464`*^7, 2.63128`*^7, 2.105024`*^7}\)], "Output"]
}, Open  ]],

Cell["K=18, 5 particles (4*8, 2*8, 8 processors)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(1.0049904`*^9/{38.5, 41.5, 62}\)], "Input"],

Cell[BoxData[
    \({2.6103646753246754`*^7, 2.4216636144578315`*^7, 
      1.620952258064516`*^7}\)], "Output"]
}, Open  ]],

Cell["K=15, 5 particles (8, 4, 2 processors)", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(4.55784`*^8/{18.69, 27.8, 50.0}\)], "Input"],

Cell[BoxData[
    \({2.438651685393258`*^7, 1.6395107913669065`*^7, 
      9.11568`*^6}\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Estimate scaling", "Section"],

Cell["Assume 500 Mbytes memory per node.", "Text"],

Cell[BoxData[
    \(nproc[kk_, 4] := 
      8*\((2*160*\((\(-5.760782132417235`\)\ kk\^2 + 
                    2.6636880705877792`\ kk\^3)\) + 
              3*\((\(-26.84932718150732`\)\ kk\^3 + 
                    11.094719984710897`\ kk\^4)\))\)/\((500*10^6)\)\)], \
"Input"],

Cell[BoxData[
    \(nproc[kk_, 5] := 
      8*\((2*160*2.66*kk^4 + 3*9.6*kk^5)\)/\((500*10^6)\)\)], "Input"],

Cell[BoxData[{
    \(comptime[kk_, npro_, 4] := 
      150*2*16*\((\(-5.760782132417235`\)\ kk\^2 + 
                2.6636880705877792`\ kk\^3)\)/\((2.5*10^7)\) + 
        16*150*\(\(\((\(-26.84932718150732`\)\ kk\^3 + 
                11.094719984710897`\ kk\^4)\)/\((npro*1.3*10^8)\)\)\(\
\[IndentingNewLine]\)\)\), "\[IndentingNewLine]", 
    \(comptime[kk_, npro_, 5] := 
      150*2*16*2.66*kk^4/\((2.0*10^7)\) + 
        16*150*9.5*kk^5/\((npro*1.3*10^8)\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(8*{2*160*\((\(-5.760782132417235`\)\ kk\^2 + 
                2.6636880705877792`\ kk\^3)\), 
          3*\((\(-26.84932718150732`\)\ kk\^3 + 
                11.094719984710897`\ kk\^4)\)} /. kk \[Rule] 100\)], "Input"],

Cell[BoxData[
    \({6.671565438114834`*^9, 2.598294411094998`*^10}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(nproc[100, 4]\)], "Input"],

Cell[BoxData[
    \(65.30901909812962`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(nproc[144, 4]\)], "Input"],

Cell[BoxData[
    \(265.24851783934133`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(comptime[144, 265, 4]\)], "Input"],

Cell[BoxData[
    \(1830.9398002639857`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(128/8\)], "Input"],

Cell[BoxData[
    \(16\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(42*8\)], "Input"],

Cell[BoxData[
    \(336\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(264/8\)], "Input"],

Cell[BoxData[
    \(33\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(comptime[100, 8*36, 4]\)], "Input"],

Cell[BoxData[
    \(569.7662970438422`\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1600}, {0, 1200}},
WindowSize->{959, 1111},
WindowMargins->{{285, Automatic}, {0, Automatic}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 41, 0, 132, "Subtitle"],
Cell[1783, 53, 109, 3, 60, "Text"],

Cell[CellGroupData[{
Cell[1917, 60, 35, 0, 106, "Section"],

Cell[CellGroupData[{
Cell[1977, 64, 134, 2, 82, "Input"],
Cell[2114, 68, 122, 2, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2273, 75, 76, 1, 52, "Input"],
Cell[2352, 78, 93, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2482, 84, 60, 1, 52, "Input"],
Cell[2545, 87, 55, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2637, 93, 211, 3, 142, "Input"],
Cell[2851, 98, 49279, 880, 372, 4630, 324, "GraphicsData", "PostScript", \
"Graphics"],
Cell[52133, 980, 130, 3, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52300, 988, 123, 2, 82, "Input"],
Cell[52426, 992, 111, 2, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52574, 999, 76, 1, 52, "Input"],
Cell[52653, 1002, 93, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[52783, 1008, 211, 3, 142, "Input"],
Cell[52997, 1013, 42792, 781, 372, 4265, 301, "GraphicsData", "PostScript", \
"Graphics"],
Cell[95792, 1796, 130, 3, 52, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[95971, 1805, 47, 0, 106, "Section"],

Cell[CellGroupData[{
Cell[96043, 1809, 177, 3, 112, "Input"],
Cell[96223, 1814, 154, 2, 127, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[96414, 1821, 81, 1, 52, "Input"],
Cell[96498, 1824, 118, 2, 96, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[96653, 1831, 63, 1, 52, "Input"],
Cell[96719, 1834, 114, 2, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[96870, 1841, 75, 1, 52, "Input"],
Cell[96948, 1844, 93, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[97078, 1850, 58, 1, 52, "Input"],
Cell[97139, 1853, 55, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[97231, 1859, 270, 5, 172, "Input"],
Cell[97504, 1866, 130, 3, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[97671, 1874, 144, 2, 82, "Input"],
Cell[97818, 1878, 134, 2, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[97989, 1885, 81, 1, 52, "Input"],
Cell[98073, 1888, 104, 2, 82, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[98214, 1895, 63, 1, 52, "Input"],
Cell[98280, 1898, 113, 2, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[98430, 1905, 75, 1, 52, "Input"],
Cell[98508, 1908, 92, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[98637, 1914, 270, 5, 172, "Input"],
Cell[98910, 1921, 130, 3, 52, "Output"]
}, Open  ]],
Cell[99055, 1927, 269, 5, 124, "Text"],

Cell[CellGroupData[{
Cell[99349, 1936, 127, 3, 82, "Input"],
Cell[99479, 1941, 150, 2, 137, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[99666, 1948, 61, 1, 52, "Input"],
Cell[99730, 1951, 87, 1, 55, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[99854, 1957, 127, 3, 82, "Input"],
Cell[99984, 1962, 131, 2, 98, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[100152, 1969, 61, 1, 52, "Input"],
Cell[100216, 1972, 88, 1, 55, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[100353, 1979, 40, 0, 106, "Section"],
Cell[100396, 1981, 290, 7, 156, "Text"],

Cell[CellGroupData[{
Cell[100711, 1992, 91, 1, 52, "Input"],
Cell[100805, 1995, 149, 2, 137, "Output"]
}, Open  ]],
Cell[100969, 2000, 62, 0, 60, "Text"],
Cell[101034, 2002, 33, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[101092, 2006, 79, 1, 52, "Input"],
Cell[101174, 2009, 85, 1, 59, "Output"]
}, Open  ]],
Cell[101274, 2013, 33, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[101332, 2017, 68, 1, 52, "Input"],
Cell[101403, 2020, 111, 2, 59, "Output"]
}, Open  ]],
Cell[101529, 2025, 33, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[101587, 2029, 106, 2, 82, "Input"],
Cell[101696, 2033, 133, 2, 59, "Output"]
}, Open  ]],
Cell[101844, 2038, 33, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[101902, 2042, 111, 2, 82, "Input"],
Cell[102016, 2046, 142, 2, 98, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[102195, 2053, 91, 1, 52, "Input"],
Cell[102289, 2056, 133, 2, 98, "Output"]
}, Open  ]],
Cell[102437, 2061, 33, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[102495, 2065, 88, 1, 82, "Input"],
Cell[102586, 2068, 111, 2, 59, "Output"]
}, Open  ]],
Cell[102712, 2073, 33, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[102770, 2077, 73, 1, 52, "Input"],
Cell[102846, 2080, 111, 2, 59, "Output"]
}, Open  ]],
Cell[102972, 2085, 33, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[103030, 2089, 86, 1, 52, "Input"],
Cell[103119, 2092, 111, 2, 59, "Output"]
}, Open  ]],
Cell[103245, 2097, 311, 6, 156, "Text"],

Cell[CellGroupData[{
Cell[103581, 2107, 91, 1, 52, "Input"],
Cell[103675, 2110, 137, 2, 137, "Output"]
}, Open  ]],
Cell[103827, 2115, 128, 3, 92, "Text"],
Cell[103958, 2120, 66, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[104049, 2124, 62, 1, 52, "Input"],
Cell[104114, 2127, 102, 2, 59, "Output"]
}, Open  ]],
Cell[104231, 2132, 58, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[104314, 2136, 59, 1, 52, "Input"],
Cell[104376, 2139, 111, 2, 59, "Output"]
}, Open  ]],
Cell[104502, 2144, 61, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[104588, 2148, 70, 1, 52, "Input"],
Cell[104661, 2151, 135, 2, 59, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[104833, 2158, 91, 1, 52, "Input"],
Cell[104927, 2161, 121, 2, 98, "Output"]
}, Open  ]],
Cell[105063, 2166, 60, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[105148, 2170, 58, 1, 52, "Input"],
Cell[105209, 2173, 73, 1, 59, "Output"]
}, Open  ]],
Cell[105297, 2177, 58, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[105380, 2181, 63, 1, 52, "Input"],
Cell[105446, 2184, 112, 2, 59, "Output"]
}, Open  ]],
Cell[105573, 2189, 54, 0, 60, "Text"],

Cell[CellGroupData[{
Cell[105652, 2193, 64, 1, 52, "Input"],
Cell[105719, 2196, 101, 2, 59, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[105869, 2204, 35, 0, 106, "Section"],
Cell[105907, 2206, 50, 0, 60, "Text"],
Cell[105960, 2208, 280, 6, 221, "Input"],
Cell[106243, 2216, 108, 2, 82, "Input"],
Cell[106354, 2220, 477, 9, 370, "Input"],

Cell[CellGroupData[{
Cell[106856, 2233, 240, 4, 217, "Input"],
Cell[107099, 2239, 81, 1, 59, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[107217, 2245, 46, 1, 52, "Input"],
Cell[107266, 2248, 52, 1, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[107355, 2254, 46, 1, 52, "Input"],
Cell[107404, 2257, 53, 1, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[107494, 2263, 54, 1, 52, "Input"],
Cell[107551, 2266, 53, 1, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[107641, 2272, 38, 1, 52, "Input"],
Cell[107682, 2275, 36, 1, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[107755, 2281, 37, 1, 52, "Input"],
Cell[107795, 2284, 37, 1, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[107869, 2290, 38, 1, 52, "Input"],
Cell[107910, 2293, 36, 1, 52, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[107983, 2299, 55, 1, 52, "Input"],
Cell[108041, 2302, 52, 1, 52, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

