(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     72227,       1913]*)
(*NotebookOutlinePosition[     72867,       1936]*)
(*  CellTagsIndexPosition[     72823,       1932]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["\<\
Profile laso with and
without constrained fields\
\>", "Title"],

Cell["Everything is for a three link truncation", "Text"],

Cell["Time (constrained fields)  vs. K", "Text"],

Cell[BoxData[
    \(\(data = {{9, 4.08}, {10, 11.11}, {11, 18.3}, {12, 36. }, {13, 
            70.85}, {14, 138. }};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ldat = Map[{Log[#[\([1]\)]], Log[#[\([2]\)]]} &, data]\)], "Input"],

Cell[BoxData[
    \({{Log[9], 1.4060969884160703`}, {Log[10], 
        2.4078456036515385`}, {Log[11], 2.9069010598473755`}, {Log[12], 
        3.58351893845611`}, {Log[13], 4.260564966136689`}, {Log[14], 
        4.927253685157205`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitting = Fit[ldat, {1, x}, x]\)], "Input"],

Cell[BoxData[
    \(\(-15.520649334443652`\) + 7.720506226092701`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[ListPlot[ldat, DisplayFunction \[Rule] Identity], 
      Plot[fitting, {x, 2, 2.8}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-2.35714 1.19048 0.0223044 0.0952988 [
[.2619 .0098 -9 -9 ]
[.2619 .0098 9 0 ]
[.5 .0098 -9 -9 ]
[.5 .0098 9 0 ]
[.7381 .0098 -9 -9 ]
[.7381 .0098 9 0 ]
[.97619 .0098 -9 -9 ]
[.97619 .0098 9 0 ]
[.01131 .1176 -6 -4.5 ]
[.01131 .1176 0 4.5 ]
[.01131 .2129 -6 -4.5 ]
[.01131 .2129 0 4.5 ]
[.01131 .3082 -6 -4.5 ]
[.01131 .3082 0 4.5 ]
[.01131 .4035 -6 -4.5 ]
[.01131 .4035 0 4.5 ]
[.01131 .4988 -6 -4.5 ]
[.01131 .4988 0 4.5 ]
[.01131 .5941 -6 -4.5 ]
[.01131 .5941 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .0223 m
.2619 .02855 L
s
[(2.2)] .2619 .0098 0 1 Mshowa
.5 .0223 m
.5 .02855 L
s
[(2.4)] .5 .0098 0 1 Mshowa
.7381 .0223 m
.7381 .02855 L
s
[(2.6)] .7381 .0098 0 1 Mshowa
.97619 .0223 m
.97619 .02855 L
s
[(2.8)] .97619 .0098 0 1 Mshowa
.125 Mabswid
.08333 .0223 m
.08333 .02605 L
s
.14286 .0223 m
.14286 .02605 L
s
.20238 .0223 m
.20238 .02605 L
s
.32143 .0223 m
.32143 .02605 L
s
.38095 .0223 m
.38095 .02605 L
s
.44048 .0223 m
.44048 .02605 L
s
.55952 .0223 m
.55952 .02605 L
s
.61905 .0223 m
.61905 .02605 L
s
.67857 .0223 m
.67857 .02605 L
s
.79762 .0223 m
.79762 .02605 L
s
.85714 .0223 m
.85714 .02605 L
s
.91667 .0223 m
.91667 .02605 L
s
.25 Mabswid
0 .0223 m
1 .0223 L
s
.02381 .1176 m
.03006 .1176 L
s
[(1)] .01131 .1176 1 0 Mshowa
.02381 .2129 m
.03006 .2129 L
s
[(2)] .01131 .2129 1 0 Mshowa
.02381 .3082 m
.03006 .3082 L
s
[(3)] .01131 .3082 1 0 Mshowa
.02381 .4035 m
.03006 .4035 L
s
[(4)] .01131 .4035 1 0 Mshowa
.02381 .4988 m
.03006 .4988 L
s
[(5)] .01131 .4988 1 0 Mshowa
.02381 .5941 m
.03006 .5941 L
s
[(6)] .01131 .5941 1 0 Mshowa
.125 Mabswid
.02381 .04136 m
.02756 .04136 L
s
.02381 .06042 m
.02756 .06042 L
s
.02381 .07948 m
.02756 .07948 L
s
.02381 .09854 m
.02756 .09854 L
s
.02381 .13666 m
.02756 .13666 L
s
.02381 .15572 m
.02756 .15572 L
s
.02381 .17478 m
.02756 .17478 L
s
.02381 .19384 m
.02756 .19384 L
s
.02381 .23196 m
.02756 .23196 L
s
.02381 .25102 m
.02756 .25102 L
s
.02381 .27008 m
.02756 .27008 L
s
.02381 .28914 m
.02756 .28914 L
s
.02381 .32726 m
.02756 .32726 L
s
.02381 .34632 m
.02756 .34632 L
s
.02381 .36538 m
.02756 .36538 L
s
.02381 .38444 m
.02756 .38444 L
s
.02381 .42256 m
.02756 .42256 L
s
.02381 .44162 m
.02756 .44162 L
s
.02381 .46068 m
.02756 .46068 L
s
.02381 .47974 m
.02756 .47974 L
s
.02381 .51786 m
.02756 .51786 L
s
.02381 .53692 m
.02756 .53692 L
s
.02381 .55598 m
.02756 .55598 L
s
.02381 .57504 m
.02756 .57504 L
s
.02381 .00324 m
.02756 .00324 L
s
.02381 .61316 m
.02756 .61316 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.2586 .1563 Mdot
.38403 .25177 Mdot
.49749 .29933 Mdot
.60108 .36381 Mdot
.69637 .42833 Mdot
.78459 .49187 Mdot
.5 Mabswid
.02381 .01472 m
.06244 .03859 L
.10458 .06463 L
.14415 .08909 L
.18221 .11261 L
.22272 .13765 L
.26171 .16175 L
.30316 .18736 L
.34309 .21204 L
.3815 .23578 L
.42237 .26104 L
.46172 .28536 L
.49955 .30874 L
.53984 .33364 L
.57861 .3576 L
.61984 .38308 L
.65954 .40762 L
.69774 .43123 L
.73838 .45635 L
.77751 .48053 L
.81909 .50623 L
.85916 .53099 L
.89771 .55482 L
.93871 .58016 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00A@3oool4000000<0oooo00<000000?ooo`3oool00P3oool400000380
oooo100000030?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0<@3oool4000000<0
oooo00<000000?ooo`3oool00`3oool2000003<0oooo100000030?ooo`030000003oool0oooo00<0
oooo0P0000060?ooo`00A@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo03<0oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo00T0oooo
00@000000?ooo`3oool00000<P3oool00`000000oooo0?ooo`090?ooo`040000003oool0oooo0000
00D0oooo00160?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0<`3oool00`000000
oooo0?ooo`070?ooo`D00000<`3oool00`000000oooo0?ooo`080?ooo`040000003oool0oooo0000
03<0oooo00<000000?ooo`3oool0203oool010000000oooo0?ooo`0000050?ooo`00A`3oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool01P3oool01000
0000oooo0?ooo`00000e0?ooo`030000003oool0oooo00L0oooo0`00000e0?ooo`030000003oool0
oooo00P0oooo0P0000060?ooo`00303oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0<`3oool00`000000oooo0?ooo`060?ooo`030000003oool00000
03H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0f0?ooo`030000003oool0oooo
00H0oooo00@000000?ooo`3oool000001@3oool000`0oooo0P00000g0?ooo`040000003oool0oooo
000000P0oooo00@000000?ooo`3oool00000<P3oool010000000oooo0?ooo`0000090?ooo`800000
<`3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo03<0oooo00@000000?ooo`3o
ool00000203oool010000000oooo0?ooo`0000050?ooo`00303oool00`000000oooo0?ooo`0g0?oo
o`8000002P3oool2000003@0oooo0P00000;0?ooo`030000003oool0oooo0380oooo0P00000:0?oo
o`<00000<`3oool2000000X0oooo0P0000060?ooo`00303oool00`000000oooo0?ooo`3o0?oooa80
oooo000<0?ooo`030000003oool0oooo0?l0oooo4P3oool000`0oooo0`00003o0?oooa80oooo0005
0?ooool000005P0000060?ooo`00303oool01@000000oooo0?ooo`3oool0000000/0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<00000
0?ooo`3oool03@3oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00d0oooo00<00000
0?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00h0oooo00<00000
0?ooo`3oool02P3oool000`0oooo00<000000?ooo`3oool00P3oool2000003X0oooo00<000000?oo
o`3oool0?`3oool00`000000oooo0?ooo`0o0?ooo`030000003oool0oooo03l0oooo00<000000?oo
o`3oool02P3oool000`0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`3o0?ooo`/0
oooo000<0?ooo`030000003oool0oooo00D0oooo0P00003o0?ooo`/0oooo000<0?ooo`800000203o
ool00`000000oooo0?ooo`3o0?ooo`P0oooo000<0?ooo`030000003oool0oooo00P0oooo0P00003o
0?ooo`P0oooo000<0?ooo`030000003oool0oooo00X0oooo0P00003o0?ooo`H0oooo000<0?ooo`03
0000003oool0oooo00`0oooo00<000000?ooo`3oool0o`3oool30?ooo`00303oool00`000000oooo
0?ooo`0=0?ooo`800000o`3oool30?ooo`00303oool00`000000oooo0?ooo`0?0?ooo`800000o`3o
ool10?ooo`00303oool200000180oooo0P00003n0?ooo`00303oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo0?/0oooo000<0?ooo`030000003oool0oooo01@0oooo0P00003k0?ooo`00
303oool00`000000oooo0?ooo`0F0?ooo`800000n@3oool000`0oooo00<000000?ooo`3oool0603o
ool200000?L0oooo000<0?ooo`8000006`3oool200000?D0oooo000<0?ooo`030000003oool0oooo
01`0oooo0P00003c0?ooo`00303oool00`000000oooo0?ooo`0N0?ooo`030000003oool0oooo0?00
oooo000<0?ooo`030000003oool0oooo01l0oooo0P00003`0?ooo`00303oool00`000000oooo0?oo
o`0Q0?ooo`030000003oool0oooo0>d0oooo000<0?ooo`8000008`3oool00`000000oooo0?ooo`3/
0?ooo`00303oool00`000000oooo0?ooo`0S0?ooo`800000k03oool000`0oooo00<000000?ooo`3o
ool09@3oool00`000000oooo0?ooo`3Y0?ooo`000`3oool4000000D0oooo00<000000?ooo`3oool0
9P3oool200000>T0oooo00050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0:03o
ool00`000000oooo0?ooo`3V0?ooo`001@3oool00`000000oooo0?ooo`040?ooo`800000:P3oool2
00000>H0oooo00050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0:`3oool20000
0>@0oooo00050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0;@3oool00`000000
oooo0?ooo`3Q0?ooo`000`3oool3000000H0oooo00<000000?ooo`3oool0;P3oool200000>40oooo
00050?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0<03oool200000=l0oooo000<
0?ooo`030000003oool0oooo0380oooo0P00003M0?ooo`00303oool2000003D0oooo00<000000?oo
o`3oool0fP3oool000`0oooo00<000000?ooo`3oool0=@3oool200000=X0oooo000<0?ooo`030000
003oool0oooo03L0oooo00<000000?ooo`3oool0e`3oool000`0oooo00<000000?ooo`3oool0>03o
ool00`000000oooo0?ooo`3F0?ooo`00303oool00`000000oooo0?ooo`0i0?ooo`800000eP3oool0
00`0oooo0P00000l0?ooo`040000003oool0000000000=80oooo000<0?ooo`030000003oool0oooo
03`0oooo0`00003B0?ooo`00303oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo0=00
oooo000<0?ooo`030000003oool0oooo03l0oooo0P00003@0?ooo`00303oool00`000000oooo0?oo
o`110?ooo`800000cP3oool000`0oooo0P0000140?ooo`030000003oool0oooo0</0oooo000<0?oo
o`030000003oool0oooo04@0oooo0P00003;0?ooo`00303oool00`000000oooo0?ooo`160?ooo`80
0000b@3oool000`0oooo00<000000?ooo`3oool0B03oool200000<L0oooo000<0?ooo`030000003o
ool0oooo04X0oooo00<000000?ooo`3oool0a03oool000`0oooo0P00001<0?ooo`800000a03oool0
00`0oooo00<000000?ooo`3oool0C@3oool200000<80oooo000<0?ooo`030000003oool0oooo04l0
oooo0P0000300?ooo`00303oool00`000000oooo0?ooo`1A0?ooo`800000_P3oool000<0oooo1000
00050?ooo`030000003oool0oooo05<0oooo0P00002l0?ooo`000`3oool00`000000oooo0?ooo`06
0?ooo`030000003oool0oooo05D0oooo00<000000?ooo`3oool0^@3oool000@0oooo00<000000?oo
o`3oool01@3oool2000005L0oooo0P00002i0?ooo`001@3oool00`000000oooo0?ooo`040?ooo`03
0000003oool0oooo05P0oooo00<000000?ooo`3oool0]P3oool000H0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`1I0?ooo`800000]P3oool000<0oooo00@000000?ooo`3oool00000
1@3oool00`000000oooo0?ooo`1K0?ooo`800000]03oool000@0oooo0P0000060?ooo`030000003o
ool0oooo05d0oooo00<000000?ooo`3oool0/@3oool000`0oooo0P00001O0?ooo`800000/@3oool0
00`0oooo00<000000?ooo`3oool0H03oool00`000000oooo0?ooo`2^0?ooo`00303oool00`000000
oooo0?ooo`1Q0?ooo`800000[P3oool000`0oooo00<000000?ooo`3oool0H`3oool00`000000oooo
0?ooo`2[0?ooo`00303oool00`000000oooo0?ooo`1T0?ooo`800000Z`3oool000`0oooo0P00001Q
0?ooo`800000103oool200000:T0oooo000<0?ooo`030000003oool0oooo0640oooo00<000000?oo
o`3oool0103oool00`000000oooo0?ooo`2V0?ooo`00303oool00`000000oooo0?ooo`1Y0?ooo`80
0000YP3oool000`0oooo00<000000?ooo`3oool0J`3oool00`000000oooo0?ooo`2S0?ooo`00303o
ool00`000000oooo0?ooo`1/0?ooo`800000X`3oool000`0oooo0P00001_0?ooo`030000003oool0
oooo0:00oooo000<0?ooo`030000003oool0oooo06l0oooo0P00002P0?ooo`00303oool00`000000
oooo0?ooo`1a0?ooo`800000WP3oool000`0oooo00<000000?ooo`3oool0L`3oool00`000000oooo
0?ooo`2K0?ooo`00303oool00`000000oooo0?ooo`1d0?ooo`800000V`3oool000`0oooo00<00000
0?ooo`3oool0MP3oool00`000000oooo0?ooo`2H0?ooo`00303oool2000007P0oooo0P00002H0?oo
o`00303oool00`000000oooo0?ooo`1i0?ooo`800000UP3oool000`0oooo00<000000?ooo`3oool0
N`3oool010000000oooo0?ooo`3oool200000900oooo00040?ooo`8000001P3oool00`000000oooo
0?ooo`1l0?ooo`8000000P3oool00`000000oooo0?ooo`2>0?ooo`000`3oool010000000oooo0?oo
o`0000050?ooo`030000003oool0oooo07h0oooo0P00002A0?ooo`001P3oool00`000000oooo0?oo
o`030?ooo`800000P@3oool00`000000oooo0?ooo`2>0?ooo`00103oool2000000H0oooo00<00000
0?ooo`3oool0P@3oool2000008h0oooo00060?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool0P`3oool00`000000oooo0?ooo`2;0?ooo`000`3oool010000000oooo0?ooo`0000050?oo
o`030000003oool0oooo08@0oooo0P00002;0?ooo`00103oool2000000H0oooo00<000000?ooo`3o
ool0QP3oool2000008T0oooo000<0?ooo`800000R@3oool00`000000oooo0?ooo`260?ooo`00303o
ool00`000000oooo0?ooo`290?ooo`800000QP3oool000`0oooo00<000000?ooo`3oool0R`3oool0
0`000000oooo0?ooo`230?ooo`00303oool00`000000oooo0?ooo`2<0?ooo`800000P`3oool000`0
oooo00<000000?ooo`3oool0SP3oool00`000000oooo0?ooo`200?ooo`00303oool200000900oooo
0P0000200?ooo`00303oool00`000000oooo0?ooo`2A0?ooo`800000OP3oool000`0oooo00<00000
0?ooo`3oool0T`3oool00`000000oooo0?ooo`1k0?ooo`00303oool00`000000oooo0?ooo`2D0?oo
o`800000N`3oool000`0oooo00<000000?ooo`3oool0UP3oool00`000000oooo0?ooo`1h0?ooo`00
303oool00`000000oooo0?ooo`2G0?ooo`8000000`3oool2000007<0oooo000<0?ooo`800000VP3o
ool01@000000oooo0?ooo`3oool0000007<0oooo000<0?ooo`030000003oool0oooo09X0oooo0P00
001e0?ooo`00303oool00`000000oooo0?ooo`2L0?ooo`800000L`3oool000`0oooo00<000000?oo
o`3oool0WP3oool00`000000oooo0?ooo`1`0?ooo`00303oool00`000000oooo0?ooo`2O0?ooo`80
0000L03oool000`0oooo0P00002R0?ooo`030000003oool0oooo06d0oooo000<0?ooo`030000003o
ool0oooo0:80oooo0P00001]0?ooo`00303oool00`000000oooo0?ooo`2T0?ooo`800000J`3oool0
00D0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2V0?ooo`800000J@3oool000D0
oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`2X0?ooo`800000I`3oool00080oooo
1@0000050?ooo`800000Z`3oool2000006D0oooo00020?ooo`040000003oool0oooo000000H0oooo
00<000000?ooo`3oool0[03oool00`000000oooo0?ooo`1R0?ooo`000`3oool00`000000oooo0000
00060?ooo`030000003oool0oooo0:d0oooo0P00001R0?ooo`00103oool2000000H0oooo00<00000
0?ooo`3oool0[`3oool00`000000oooo0?ooo`1O0?ooo`001@3oool00`000000oooo0?ooo`040?oo
o`030000003oool0oooo0;00oooo0P00001O0?ooo`00303oool00`000000oooo0?ooo`2b0?ooo`80
0000G@3oool000`0oooo0P00002e0?ooo`030000003oool0oooo05X0oooo000<0?ooo`030000003o
ool0oooo0;D0oooo0`00001I0?ooo`00303oool00`000000oooo0?ooo`2g0?ooo`030000003oool0
oooo05L0oooo000<0?ooo`030000003oool0oooo0;P0oooo0P00001G0?ooo`00303oool00`000000
oooo0?ooo`2j0?ooo`030000003oool0oooo05@0oooo000<0?ooo`800000_03oool2000005@0oooo
000<0?ooo`030000003oool0oooo0;d0oooo0P00001B0?ooo`00303oool00`000000oooo0?ooo`2o
0?ooo`030000003oool0oooo04l0oooo000<0?ooo`030000003oool0oooo0<00oooo0P00001?0?oo
o`00303oool00`000000oooo0?ooo`320?ooo`030000003oool0oooo04`0oooo000<0?ooo`800000
a03oool2000004`0oooo000<0?ooo`030000003oool0oooo0<D0oooo00<000000?ooo`3oool0B@3o
ool000`0oooo00<000000?ooo`3oool0aP3oool2000004T0oooo000<0?ooo`030000003oool0oooo
0<P0oooo0P0000170?ooo`00303oool00`000000oooo0?ooo`3:0?ooo`030000003oool0oooo04@0
oooo000<0?ooo`800000c03oool2000004@0oooo000<0?ooo`030000003oool0oooo0<d0oooo00<0
00000?ooo`3oool0@@3oool000`0oooo00<000000?ooo`3oool0cP3oool200000440oooo000<0?oo
o`030000003oool0oooo0<h0oooo0`0000100?ooo`000`3oool3000000H0oooo00<000000?ooo`3o
ool0c`3oool010000000oooo00000000000n0?ooo`001P3oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo0=<0oooo0P00000l0?ooo`001P3oool00`000000oooo0?ooo`030?ooo`800000
eP3oool00`000000oooo0?ooo`0i0?ooo`000`3oool3000000H0oooo00<000000?ooo`3oool0eP3o
ool2000003T0oooo00030?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0f03oool0
0`000000oooo0?ooo`0f0?ooo`000`3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo
0=T0oooo0P00000f0?ooo`000`3oool4000000D0oooo00<000000?ooo`3oool0f`3oool2000003@0
oooo000<0?ooo`800000gP3oool200000380oooo000<0?ooo`030000003oool0oooo0=l0oooo0P00
000`0?ooo`00303oool00`000000oooo0?ooo`3Q0?ooo`800000;P3oool000`0oooo00<000000?oo
o`3oool0h`3oool00`000000oooo0?ooo`0[0?ooo`00303oool00`000000oooo0?ooo`3T0?ooo`80
0000:`3oool000`0oooo0P00003W0?ooo`030000003oool0oooo02P0oooo000<0?ooo`030000003o
ool0oooo0>L0oooo0P00000X0?ooo`00303oool00`000000oooo0?ooo`3Y0?ooo`8000009P3oool0
00`0oooo00<000000?ooo`3oool0j`3oool00`000000oooo0?ooo`0S0?ooo`00303oool00`000000
oooo0?ooo`3/0?ooo`8000008`3oool000`0oooo0P00003_0?ooo`030000003oool0oooo0200oooo
000<0?ooo`030000003oool0oooo0>l0oooo0P00000P0?ooo`00303oool00`000000oooo0?ooo`3a
0?ooo`030000003oool0oooo01d0oooo000<0?ooo`030000003oool0oooo0?80oooo0P00000M0?oo
o`00303oool00`000000oooo0?ooo`3d0?ooo`8000006`3oool000`0oooo00<000000?ooo`3oool0
mP3oool00`000000oooo0?ooo`0H0?ooo`00303oool200000?P0oooo0P00000H0?ooo`00303oool0
0`000000oooo0?ooo`3i0?ooo`030000003oool0oooo01D0oooo000<0?ooo`030000003oool0oooo
0?X0oooo0P00000E0?ooo`00103oool2000000H0oooo00<000000?ooo`3oool0o03oool2000001<0
oooo00030?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool0oP3oool200000140
oooo00030?ooo`040000003oool0oooo000000D0oooo0P00003o0?ooo`80oooo0P00000?0?ooo`00
0`3oool3000000H0oooo00<000000?ooo`3oool0o`3oool30?ooo`8000003@3oool000<0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooo`D0oooo00<000000?ooo`3oool02P3o
ool000<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?oooa80oooo00040?oo
o`<000001@3oool00`000000oooo0?ooo`3o0?oooa80oooo000<0?ooo`800000o`3ooolC0?ooo`00
303oool00`000000oooo0?ooo`3o0?oooa80oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {1.96273, -0.473287, \
0.0030423, 0.0380047}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["Full basis size (constrained fields)  vs. K", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(ndata = {{9, 7214}, {10, 11715}, {11, 18057}, {12, 26682}, {13, 
          38000}, {14, 52801}}\)], "Input"],

Cell[BoxData[
    \(General::"spell1" \(\(:\)\(\ \)\) 
      "Possible spelling error: new symbol name \"\!\(ndata\)\" is similar to \
existing symbol \"\!\(data\)\"."\)], "Message"],

Cell[BoxData[
    \({{9, 7214}, {10, 11715}, {11, 18057}, {12, 26682}, {13, 38000}, {14, 
        52801}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(nfitting = Fit[ndata, {x^3, x^4}, x]\)], "Input"],

Cell[BoxData[
    \(\(-7.123031529716267`\)\ x\^3 + 1.8815165191636514`\ x\^4\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[
      ListPlot[Map[{#[\([1]\)], Log[#[\([2]\)]]} &, ndata], 
        DisplayFunction \[Rule] Identity], 
      Plot[Log[nfitting], {x, 8, 14}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-1.24603 0.15873 -1.89165 0.229438 [
[.18254 .16079 -3 -9 ]
[.18254 .16079 3 0 ]
[.34127 .16079 -6 -9 ]
[.34127 .16079 6 0 ]
[.5 .16079 -6 -9 ]
[.5 .16079 6 0 ]
[.65873 .16079 -6 -9 ]
[.65873 .16079 6 0 ]
[.81746 .16079 -6 -9 ]
[.81746 .16079 6 0 ]
[.97619 .16079 -6 -9 ]
[.97619 .16079 6 0 ]
[.01131 .05857 -18 -4.5 ]
[.01131 .05857 0 4.5 ]
[.01131 .28801 -18 -4.5 ]
[.01131 .28801 0 4.5 ]
[.01131 .40273 -12 -4.5 ]
[.01131 .40273 0 4.5 ]
[.01131 .51744 -24 -4.5 ]
[.01131 .51744 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.18254 .17329 m
.18254 .17954 L
s
[(9)] .18254 .16079 0 1 Mshowa
.34127 .17329 m
.34127 .17954 L
s
[(10)] .34127 .16079 0 1 Mshowa
.5 .17329 m
.5 .17954 L
s
[(11)] .5 .16079 0 1 Mshowa
.65873 .17329 m
.65873 .17954 L
s
[(12)] .65873 .16079 0 1 Mshowa
.81746 .17329 m
.81746 .17954 L
s
[(13)] .81746 .16079 0 1 Mshowa
.97619 .17329 m
.97619 .17954 L
s
[(14)] .97619 .16079 0 1 Mshowa
.125 Mabswid
.05556 .17329 m
.05556 .17704 L
s
.0873 .17329 m
.0873 .17704 L
s
.11905 .17329 m
.11905 .17704 L
s
.15079 .17329 m
.15079 .17704 L
s
.21429 .17329 m
.21429 .17704 L
s
.24603 .17329 m
.24603 .17704 L
s
.27778 .17329 m
.27778 .17704 L
s
.30952 .17329 m
.30952 .17704 L
s
.37302 .17329 m
.37302 .17704 L
s
.40476 .17329 m
.40476 .17704 L
s
.43651 .17329 m
.43651 .17704 L
s
.46825 .17329 m
.46825 .17704 L
s
.53175 .17329 m
.53175 .17704 L
s
.56349 .17329 m
.56349 .17704 L
s
.59524 .17329 m
.59524 .17704 L
s
.62698 .17329 m
.62698 .17704 L
s
.69048 .17329 m
.69048 .17704 L
s
.72222 .17329 m
.72222 .17704 L
s
.75397 .17329 m
.75397 .17704 L
s
.78571 .17329 m
.78571 .17704 L
s
.84921 .17329 m
.84921 .17704 L
s
.88095 .17329 m
.88095 .17704 L
s
.9127 .17329 m
.9127 .17704 L
s
.94444 .17329 m
.94444 .17704 L
s
.25 Mabswid
0 .17329 m
1 .17329 L
s
.02381 .05857 m
.03006 .05857 L
s
[(8.5)] .01131 .05857 1 0 Mshowa
.02381 .28801 m
.03006 .28801 L
s
[(9.5)] .01131 .28801 1 0 Mshowa
.02381 .40273 m
.03006 .40273 L
s
[(10)] .01131 .40273 1 0 Mshowa
.02381 .51744 m
.03006 .51744 L
s
[(10.5)] .01131 .51744 1 0 Mshowa
.125 Mabswid
.02381 .08151 m
.02756 .08151 L
s
.02381 .10446 m
.02756 .10446 L
s
.02381 .1274 m
.02756 .1274 L
s
.02381 .15034 m
.02756 .15034 L
s
.02381 .19623 m
.02756 .19623 L
s
.02381 .21918 m
.02756 .21918 L
s
.02381 .24212 m
.02756 .24212 L
s
.02381 .26506 m
.02756 .26506 L
s
.02381 .31095 m
.02756 .31095 L
s
.02381 .33389 m
.02756 .33389 L
s
.02381 .35684 m
.02756 .35684 L
s
.02381 .37978 m
.02756 .37978 L
s
.02381 .42567 m
.02756 .42567 L
s
.02381 .44861 m
.02756 .44861 L
s
.02381 .47156 m
.02756 .47156 L
s
.02381 .4945 m
.02756 .4945 L
s
.02381 .03563 m
.02756 .03563 L
s
.02381 .01268 m
.02756 .01268 L
s
.02381 .54039 m
.02756 .54039 L
s
.02381 .56333 m
.02756 .56333 L
s
.02381 .58628 m
.02756 .58628 L
s
.02381 .60922 m
.02756 .60922 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.18254 .14662 Mdot
.34127 .25786 Mdot
.5 .35713 Mdot
.65873 .44672 Mdot
.81746 .52785 Mdot
.97619 .60332 Mdot
.5 Mabswid
.02381 .01472 m
.06244 .04823 L
.10458 .08332 L
.14415 .11499 L
.18221 .14439 L
.22272 .17461 L
.26171 .20273 L
.30316 .23164 L
.34309 .25862 L
.3815 .28381 L
.42237 .30984 L
.46172 .33419 L
.49955 .35699 L
.53984 .38063 L
.57861 .4028 L
.61984 .42578 L
.65954 .44737 L
.69774 .46765 L
.73838 .48873 L
.77751 .50857 L
.81909 .52918 L
.85916 .5486 L
.89771 .5669 L
.93871 .58596 L
.97619 .60303 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0
oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool200000?l0oooo103o
ool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool200000?l0oooo103oool001/0
oooo00<000000?ooo`000000o`3oool30?ooo`006`3oool010000000oooo0?ooo`00003o0?ooo`80
oooo000K0?ooo`050000003oool0oooo0?ooo`000000o`3oool10?ooo`006`3oool2000000<0oooo
0P00003n0?ooo`006`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo0?/0oooo000K
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0nP3oool001/0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`3i0?ooo`00203oool2000000@0oooo00<000000?ooo`3o
ool00P3oool3000000D0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`3h0?ooo`00
1`3oool010000000oooo0?ooo`00000;0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3o
ool0203oool00`000000oooo0?ooo`3g0?ooo`001`3oool010000000oooo0?ooo`00000;0?ooo`03
0000003oool0oooo0080oooo0P00000:0?ooo`800000m`3oool000P0oooo0P0000090?ooo`<00000
1@3oool00`000000oooo0?ooo`0;0?ooo`030000003oool0oooo0?@0oooo00070?ooo`040000003o
ool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`0<0?ooo`030000
003oool0oooo0?<0oooo00070?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool0
1@3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo0?80oooo00080?ooo`8000002@3o
ool4000000@0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`3a0?ooo`006`3oool0
0`000000oooo0?ooo`0?0?ooo`800000l@3oool001/0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`3^0?ooo`006`3oool2000001<0oooo00<000000?ooo`3oool0k@3oool001/0oooo
00<000000?ooo`3oool04`3oool200000>d0oooo000K0?ooo`030000003oool0oooo01D0oooo00<0
00000?ooo`3oool0jP3oool001/0oooo00<000000?ooo`3oool05P3oool00`000000oooo0?ooo`3Y
0?ooo`006`3oool00`000000oooo0?ooo`0G0?ooo`800000j@3oool001/0oooo00<000000?ooo`3o
ool06@3oool00`000000oooo0?ooo`3V0?ooo`006`3oool2000001/0oooo00<000000?ooo`3oool0
i@3oool001/0oooo00<000000?ooo`3oool06`3oool200000>D0oooo000K0?ooo`030000003oool0
oooo01d0oooo00<000000?ooo`3oool0hP3oool001/0oooo00<000000?ooo`3oool07P3oool00`00
0000oooo0?ooo`3Q0?ooo`006`3oool00`000000oooo0?ooo`0O0?ooo`800000h@3oool001/0oooo
00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`3N0?ooo`006`3oool2000002<0oooo00<0
00000?ooo`3oool0g@3oool001/0oooo00<000000?ooo`3oool08`3oool00`000000oooo0?ooo`3L
0?ooo`006`3oool00`000000oooo0?ooo`0T0?ooo`@00000903oool4000000<0oooo0P00000Q0?oo
o`@000000P3oool400000240oooo100000020?ooo`@00000803oool4000000<0oooo0P00000Q0?oo
o`@00000103oool00`000000oooo0?ooo`020?ooo`006`3oool00`000000oooo0?ooo`0V0?ooo`03
0000003oool0000002D0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0R0?ooo`050000003oool0oooo
0?ooo`0000009@3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool0803o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo000K0?ooo`030000003oool0
oooo02H0oooo0`00000U0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?oo
o`0P0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool08P3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo0280oooo00<000000?ooo`3oool0103oool00`000000oooo0?oo
o`0P0?ooo`030000003oool0oooo00D000000`3oool001/0oooo00<000000?ooo`3oool09P3oool4
000002@0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0200oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool08@3oool00`000000oooo0?ooo`020?ooo`8000008`3oool010000000oooo0?oo
o`0000020?ooo`030000003oool0oooo0080oooo000K0?ooo`8000009P3oool01P000000oooo0?oo
o`000000oooo000002<0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo
0200oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo
00@0oooo00<000000?ooo`3oool0803oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0200oooo00L000000?ooo`3oool0oooo0000003oool0000000@0oooo000K0?ooo`030000003oool0
oooo02D0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`0N0?ooo`<000000`3o
ool010000000oooo0?ooo`00000P0?ooo`<000000`3oool300000280oooo0`0000030?ooo`040000
003oool0oooo00000200oooo0`0000030?ooo`040000003oool0oooo00000200oooo0`0000040?oo
o`800000103oool001/0oooo00<000000?ooo`3oool09P3oool2000000@0oooo0P00000P0?ooo`03
0000003oool0oooo0080oooo0P00000S0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool08P3oool00`000000oooo0?ooo`020?ooo`8000008`3oool00`000000oooo0?ooo`020?ooo`80
00008`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080oooo000K0?ooo`030000
003oool0oooo02h0oooo00<000000?ooo`3oool0d@3oool001/0oooo00<000000?ooo`3oool0;`3o
ool00`000000oooo0?ooo`3@0?ooo`006`3oool00`000000oooo0?ooo`0`0?ooo`800000d03oool0
01@0ooooo`00000=000000006`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0
oooo00<000000?ooo`3oool01@3oool01@000000oooo0?ooo`3oool0000000@0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool01@3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo000K0?ooo`03
0000003oool0oooo02L0oooo00<000000?ooo`3oool02P3oool2000001/0oooo00<000000?ooo`3o
ool09`3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3o
ool09`3oool00`000000oooo0?ooo`050?ooo`006`3oool00`000000oooo0?ooo`0f0?ooo`030000
003oool0oooo0<T0oooo000K0?ooo`030000003oool0oooo03L0oooo00<000000?ooo`3oool0b03o
ool001/0oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`370?ooo`006`3oool20000
03X0oooo0P0000370?ooo`006`3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo0<@0
oooo000K0?ooo`030000003oool0oooo03`0oooo00<000000?ooo`3oool0``3oool001/0oooo00<0
00000?ooo`3oool0?@3oool200000<<0oooo000K0?ooo`030000003oool0oooo03l0oooo00<00000
0?ooo`3oool0`03oool001/0oooo00<000000?ooo`3oool0@03oool200000<00oooo000K0?ooo`80
0000@`3oool200000;h0oooo000K0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0
^`3oool001/0oooo00<000000?ooo`3oool0A@3oool200000;/0oooo000K0?ooo`030000003oool0
oooo04L0oooo00<000000?ooo`3oool0^03oool001/0oooo00<000000?ooo`3oool0B03oool20000
0;P0oooo000K0?ooo`030000003oool0oooo04X0oooo00<000000?ooo`3oool0]@3oool001/0oooo
0P00001<0?ooo`030000003oool0oooo0;@0oooo000K0?ooo`030000003oool0oooo04`0oooo0P00
002d0?ooo`006`3oool00`000000oooo0?ooo`1>0?ooo`030000003oool0oooo0;40oooo000K0?oo
o`030000003oool0oooo04l0oooo00<000000?ooo`3oool0/03oool001/0oooo00<000000?ooo`3o
ool0D03oool300000:l0oooo000K0?ooo`030000003oool0oooo0580oooo00<000000?ooo`3oool0
[@3oool001/0oooo0P00001D0?ooo`800000[@3oool001/0oooo00<000000?ooo`3oool0E@3oool2
00000:/0oooo000K0?ooo`030000003oool0oooo05L0oooo00<000000?ooo`3oool0Z03oool001/0
oooo00<000000?ooo`3oool0F03oool200000:P0oooo00070?ooo`<00000103oool00`000000oooo
0?ooo`020?ooo`<000001@3oool00`000000oooo0?ooo`1J0?ooo`800000YP3oool000X0oooo00<0
00000?ooo`3oool02@3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo05`0oooo00<0
00000?ooo`3oool0X`3oool000X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`02
0?ooo`800000GP3oool200000:<0oooo00080?ooo`<00000203oool3000000D0oooo00<000000?oo
o`3oool0G`3oool00`000000oooo0?ooo`2P0?ooo`001`3oool010000000oooo0?ooo`0000080?oo
o`030000003oool0oooo00D0oooo00<000000?ooo`3oool0H03oool200000:00oooo00070?ooo`04
0000003oool0oooo000000P0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`1R0?oo
o`800000WP3oool000P0oooo0P0000090?ooo`@00000103oool00`000000oooo0?ooo`1T0?ooo`03
0000003oool0oooo09/0oooo000K0?ooo`030000003oool0oooo06D0oooo0P00002K0?ooo`006`3o
ool00`000000oooo0?ooo`1W0?ooo`030000003oool0oooo09P0oooo000K0?ooo`800000J@3oool2
000009P0oooo000K0?ooo`030000003oool0oooo06X0oooo00<000000?ooo`3oool0U@3oool001/0
oooo00<000000?ooo`3oool0J`3oool00`000000oooo0?ooo`2D0?ooo`006`3oool00`000000oooo
0?ooo`1/0?ooo`800000U03oool001/0oooo00<000000?ooo`3oool0KP3oool00`000000oooo0?oo
o`2A0?ooo`006`3oool00`000000oooo0?ooo`1_0?ooo`800000T@3oool001/0oooo0P00001b0?oo
o`030000003oool0oooo08h0oooo000K0?ooo`030000003oool0oooo0780oooo0P00002>0?ooo`00
6`3oool00`000000oooo0?ooo`1d0?ooo`800000S03oool001/0oooo00<000000?ooo`3oool0MP3o
ool00`000000oooo0?ooo`290?ooo`006`3oool00`000000oooo0?ooo`1g0?ooo`800000R@3oool0
01/0oooo00<000000?ooo`3oool0N@3oool4000008D0oooo000K0?ooo`800000O03oool2000008D0
oooo000K0?ooo`030000003oool0oooo07`0oooo0P0000240?ooo`006`3oool00`000000oooo0?oo
o`1n0?ooo`800000PP3oool001/0oooo00<000000?ooo`3oool0P03oool200000800oooo000K0?oo
o`030000003oool0oooo0880oooo0P00001n0?ooo`006`3oool00`000000oooo0?ooo`240?ooo`80
0000O03oool001/0oooo0P0000270?ooo`030000003oool0oooo07T0oooo000K0?ooo`030000003o
ool0oooo08L0oooo0P00001i0?ooo`006`3oool00`000000oooo0?ooo`290?ooo`800000M`3oool0
01/0oooo00<000000?ooo`3oool0R`3oool00`000000oooo0?ooo`1d0?ooo`003@3oool4000000<0
oooo0P0000050?ooo`030000003oool0oooo08`0oooo0P00001d0?ooo`003`3oool01@000000oooo
0?ooo`3oool000000080oooo00<000000?ooo`3oool00P3oool00`000000oooo0?ooo`2>0?ooo`80
0000LP3oool000l0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo0080
oooo0P00002A0?ooo`030000003oool0oooo06l0oooo000?0?ooo`050000003oool0oooo0?ooo`00
00000P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0940oooo0P00001_0?ooo`00
3`3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3oool00P3oool00`000000
oooo0?ooo`2C0?ooo`800000K@3oool000d0oooo0`0000030?ooo`040000003oool0oooo000000@0
oooo00<000000?ooo`3oool0U@3oool2000006/0oooo000?0?ooo`030000003oool0oooo0080oooo
0P0000050?ooo`030000003oool0oooo09L0oooo0P00001Y0?ooo`006`3oool00`000000oooo0?oo
o`2I0?ooo`800000I`3oool001/0oooo0P00002L0?ooo`030000003oool0oooo06@0oooo000K0?oo
o`030000003oool0oooo09`0oooo0P00001T0?ooo`006`3oool00`000000oooo0?ooo`2N0?ooo`80
0000HP3oool001/0oooo00<000000?ooo`3oool0X03oool200000600oooo000K0?ooo`030000003o
ool0oooo0:80oooo0P00001N0?ooo`006`3oool00`000000oooo0?ooo`2T0?ooo`<00000F`3oool0
01/0oooo0P00002W0?ooo`030000003oool0oooo05T0oooo000K0?ooo`030000003oool0oooo0:L0
oooo0P00001I0?ooo`006`3oool00`000000oooo0?ooo`2Y0?ooo`800000E`3oool001/0oooo00<0
00000?ooo`3oool0Z`3oool2000005D0oooo000K0?ooo`030000003oool0oooo0:d0oooo0P00001C
0?ooo`006`3oool00`000000oooo0?ooo`2_0?ooo`800000D@3oool001/0oooo0P00002b0?ooo`80
0000C`3oool001/0oooo00<000000?ooo`3oool0/`3oool2000004d0oooo000K0?ooo`030000003o
ool0oooo0;D0oooo0P00001;0?ooo`006`3oool00`000000oooo0?ooo`2g0?ooo`800000B@3oool0
01/0oooo00<000000?ooo`3oool0^@3oool2000004L0oooo000K0?ooo`030000003oool0oooo0;/0
oooo00<000000?ooo`3oool0A03oool001/0oooo0P00002m0?ooo`800000A03oool001/0oooo00<0
00000?ooo`3oool0_P3oool200000480oooo000K0?ooo`030000003oool0oooo0<00oooo0P000010
0?ooo`006`3oool00`000000oooo0?ooo`320?ooo`800000?P3oool000030?ooo`00000000000080
00000`3oool2000000@0oooo00<000000?ooo`3oool00P3oool3000000D0oooo00<000000?ooo`3o
ool0a03oool2000003`0oooo00030?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0aP3oool2000003X0
oooo00030?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo0080oooo0P0000390?ooo`800000>03oool000<0oooo00D000000?ooo`3oool0
oooo000000020?ooo`030000003oool0oooo00H0oooo0`0000050?ooo`030000003oool0oooo0<X0
oooo0P00000f0?ooo`000`3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?ooo`3o
ool01P3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0<`0oooo0P00000d0?ooo`00
00@0oooo00000000000000000`3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo
00D0oooo00<000000?ooo`3oool0cP3oool300000340oooo00030?ooo`030000003oool0oooo0080
oooo0P0000090?ooo`@00000103oool00`000000oooo0?ooo`3@0?ooo`800000<03oool001/0oooo
00<000000?ooo`3oool0dP3oool2000002h0oooo000K0?ooo`030000003oool0oooo0=@0oooo0P00
000/0?ooo`006`3oool200000=L0oooo0P00000Z0?ooo`006`3oool00`000000oooo0?ooo`3H0?oo
o`800000:03oool001/0oooo00<000000?ooo`3oool0fP3oool2000002H0oooo000K0?ooo`030000
003oool0oooo0=`0oooo0P00000T0?ooo`006`3oool00`000000oooo0?ooo`3N0?ooo`8000008P3o
ool001/0oooo00<000000?ooo`3oool0h03oool200000200oooo000K0?ooo`800000h`3oool20000
01h0oooo000K0?ooo`030000003oool0oooo0>@0oooo0`00000K0?ooo`006`3oool00`000000oooo
0?ooo`3W0?ooo`8000006@3oool001/0oooo00<000000?ooo`3oool0j@3oool2000001L0oooo000K
0?ooo`030000003oool0oooo0>/0oooo0P00000E0?ooo`006`3oool00`000000oooo0?ooo`3]0?oo
o`8000004`3oool001/0oooo0P00003`0?ooo`<00000403oool001/0oooo00<000000?ooo`3oool0
lP3oool2000000h0oooo000K0?ooo`030000003oool0oooo0?@0oooo0`00000;0?ooo`006`3oool0
0`000000oooo0?ooo`3g0?ooo`8000002@3oool001/0oooo00<000000?ooo`3oool0n@3oool30000
00H0oooo000K0?ooo`030000003oool0oooo0?/0oooo00<000000?ooo`3oool0103oool001/0oooo
0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<00000
0?ooo`3oool0o`3oool30?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3o
oolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {7.35281, 8.142, 0.0236837, \
0.0163849}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["Number of nonzero matrix elements (constrained fields) vs. K", "Text"],

Cell[BoxData[
    \(\(sdata = {{9, 39641}, {10, 68134}, {11, 110000}, {12, 171000}, {13, 
            256000}, {14, 372000}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lsdat = Map[{Log[#[\([1]\)]], Log[#[\([2]\)]]} &, sdata]\)], "Input"],

Cell[BoxData[
    \({{Log[9], Log[39641]}, {Log[10], Log[68134]}, {Log[11], 
        Log[110000]}, {Log[12], Log[171000]}, {Log[13], 
        Log[256000]}, {Log[14], Log[372000]}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(lsfitting = Fit[lsdat, {1, x}, x]\)], "Input"],

Cell[BoxData[
    \(\(-0.5325194771518474`\) + 5.062805005988084`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[ListPlot[lsdat, DisplayFunction \[Rule] Identity], 
      Plot[lsfitting, {x, 2, 2.8}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-2.35714 1.19048 -1.37941 0.145326 [
[.2619 .06135 -9 -9 ]
[.2619 .06135 9 0 ]
[.5 .06135 -9 -9 ]
[.5 .06135 9 0 ]
[.7381 .06135 -9 -9 ]
[.7381 .06135 9 0 ]
[.97619 .06135 -9 -9 ]
[.97619 .06135 9 0 ]
[.01131 .21917 -12 -4.5 ]
[.01131 .21917 0 4.5 ]
[.01131 .3645 -12 -4.5 ]
[.01131 .3645 0 4.5 ]
[.01131 .50983 -12 -4.5 ]
[.01131 .50983 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.2619 .07385 m
.2619 .0801 L
s
[(2.2)] .2619 .06135 0 1 Mshowa
.5 .07385 m
.5 .0801 L
s
[(2.4)] .5 .06135 0 1 Mshowa
.7381 .07385 m
.7381 .0801 L
s
[(2.6)] .7381 .06135 0 1 Mshowa
.97619 .07385 m
.97619 .0801 L
s
[(2.8)] .97619 .06135 0 1 Mshowa
.125 Mabswid
.08333 .07385 m
.08333 .0776 L
s
.14286 .07385 m
.14286 .0776 L
s
.20238 .07385 m
.20238 .0776 L
s
.32143 .07385 m
.32143 .0776 L
s
.38095 .07385 m
.38095 .0776 L
s
.44048 .07385 m
.44048 .0776 L
s
.55952 .07385 m
.55952 .0776 L
s
.61905 .07385 m
.61905 .0776 L
s
.67857 .07385 m
.67857 .0776 L
s
.79762 .07385 m
.79762 .0776 L
s
.85714 .07385 m
.85714 .0776 L
s
.91667 .07385 m
.91667 .0776 L
s
.25 Mabswid
0 .07385 m
1 .07385 L
s
.02381 .21917 m
.03006 .21917 L
s
[(11)] .01131 .21917 1 0 Mshowa
.02381 .3645 m
.03006 .3645 L
s
[(12)] .01131 .3645 1 0 Mshowa
.02381 .50983 m
.03006 .50983 L
s
[(13)] .01131 .50983 1 0 Mshowa
.125 Mabswid
.02381 .10291 m
.02756 .10291 L
s
.02381 .13198 m
.02756 .13198 L
s
.02381 .16104 m
.02756 .16104 L
s
.02381 .19011 m
.02756 .19011 L
s
.02381 .24824 m
.02756 .24824 L
s
.02381 .27731 m
.02756 .27731 L
s
.02381 .30637 m
.02756 .30637 L
s
.02381 .33544 m
.02756 .33544 L
s
.02381 .39357 m
.02756 .39357 L
s
.02381 .42263 m
.02756 .42263 L
s
.02381 .4517 m
.02756 .4517 L
s
.02381 .48076 m
.02756 .48076 L
s
.02381 .04478 m
.02756 .04478 L
s
.02381 .01572 m
.02756 .01572 L
s
.02381 .53889 m
.02756 .53889 L
s
.02381 .56796 m
.02756 .56796 L
s
.02381 .59702 m
.02756 .59702 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.2586 .15925 Mdot
.38403 .23796 Mdot
.49749 .30757 Mdot
.60108 .37168 Mdot
.69637 .43032 Mdot
.78459 .48463 Mdot
.5 Mabswid
.02381 .01472 m
.06244 .03859 L
.10458 .06463 L
.14415 .08909 L
.18221 .11261 L
.22272 .13765 L
.26171 .16175 L
.30316 .18736 L
.34309 .21204 L
.3815 .23578 L
.42237 .26104 L
.46172 .28536 L
.49955 .30874 L
.53984 .33364 L
.57861 .3576 L
.61984 .38308 L
.65954 .40762 L
.69774 .43123 L
.73838 .45635 L
.77751 .48053 L
.81909 .50623 L
.85916 .53099 L
.89771 .55482 L
.93871 .58016 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`003`3oool00`000000oooo0?ooo`3o0?ooo`l0oooo
000?0?ooo`030000003oool0oooo0?l0oooo3`3oool000l0oooo00<000000?ooo`3oool0o`3oool?
0?ooo`003`3oool00`000000oooo0?ooo`3o0?ooo`l0oooo000?0?ooo`800000o`3oool@0?ooo`00
3`3oool300000?l0oooo3`3oool000l0oooo00<000000?ooo`3oool00P00003o0?ooo`d0oooo000?
0?ooo`030000003oool0oooo0080oooo0P00003o0?ooo`/0oooo000?0?ooo`030000003oool0oooo
00@0oooo0P00003o0?ooo`T0oooo000?0?ooo`030000003oool0oooo00H0oooo0P00003o0?ooo`L0
oooo000?0?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3oool0;03oool4000000<0oooo
00<000000?ooo`3oool00P3oool400000340oooo100000030?ooo`030000003oool0oooo00@0oooo
00<000000?ooo`3oool0<@3oool4000000<0oooo00<000000?ooo`3oool00`3oool2000003<0oooo
100000030?ooo`030000003oool0oooo00<0oooo0P0000030?ooo`003`3oool00`000000oooo0?oo
o`090?ooo`800000;03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0380oooo00<0
00000?ooo`3oool02`3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo00T0oooo00@0
00000?ooo`3oool00000<P3oool00`000000oooo0?ooo`090?ooo`040000003oool0oooo00000080
oooo000?0?ooo`800000303oool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0<P3oool00`000000oooo0?ooo`070?ooo`D00000<`3oool00`000000oooo
0?ooo`080?ooo`040000003oool0oooo000003<0oooo00<000000?ooo`3oool0203oool010000000
oooo0?ooo`0000020?ooo`003`3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo02X0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo00H0
oooo00@000000?ooo`3oool00000=@3oool00`000000oooo0?ooo`070?ooo`<00000=@3oool00`00
0000oooo0?ooo`080?ooo`8000000`3oool000l0oooo00<000000?ooo`3oool03@3oool2000002/0
oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0b0?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`000000=P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03H0
oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`0000020?ooo`003`3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo02D0oooo00@000000?ooo`3oool00000203oool01000
0000oooo0?ooo`00000a0?ooo`040000003oool0oooo000000T0oooo0P00000c0?ooo`040000003o
ool0oooo000000P0oooo00<000000?ooo`3oool0<`3oool010000000oooo0?ooo`0000080?ooo`04
0000003oool0oooo00000080oooo000?0?ooo`030000003oool0oooo0100oooo00<000000?ooo`3o
ool09@3oool2000000X0oooo0P00000c0?ooo`8000002`3oool00`000000oooo0?ooo`0b0?ooo`80
00002P3oool3000003<0oooo0P00000:0?ooo`8000000`3oool000l0oooo00<000000?ooo`3oool0
4@3oool200000?/0oooo000?0?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0n03o
ool000l0oooo00<000000?ooo`3oool0503oool200000?P0oooo00080?ooool000005P0000030?oo
o`003`3oool00`000000oooo0?ooo`0=0?ooo`030000003oool0oooo00P0oooo0P0000040?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0=0?ooo`03
0000003oool0oooo00h0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0=0?ooo`03
0000003oool0oooo00h0oooo00<000000?ooo`3oool03@3oool00`000000oooo0?ooo`0>0?ooo`03
0000003oool0oooo00d0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`070?ooo`00
3`3oool00`000000oooo0?ooo`0J0?ooo`8000008`3oool00`000000oooo0?ooo`0n0?ooo`030000
003oool0oooo03l0oooo00<000000?ooo`3oool0?`3oool00`000000oooo0?ooo`070?ooo`003`3o
ool00`000000oooo0?ooo`0L0?ooo`800000l03oool000l0oooo00<000000?ooo`3oool07P3oool0
0`000000oooo0?ooo`3]0?ooo`003`3oool00`000000oooo0?ooo`0O0?ooo`800000k@3oool000l0
oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`3Z0?ooo`003`3oool00`000000oooo
0?ooo`0R0?ooo`800000jP3oool000l0oooo0P00000U0?ooo`800000j03oool000l0oooo00<00000
0?ooo`3oool09P3oool00`000000oooo0?ooo`3U0?ooo`003`3oool00`000000oooo0?ooo`0W0?oo
o`800000i@3oool000l0oooo00<000000?ooo`3oool0:@3oool00`000000oooo0?ooo`3R0?ooo`00
3`3oool00`000000oooo0?ooo`0Z0?ooo`800000hP3oool000l0oooo00<000000?ooo`3oool0;03o
ool00`000000oooo0?ooo`3O0?ooo`003`3oool00`000000oooo0?ooo`0]0?ooo`800000g`3oool0
00l0oooo00<000000?ooo`3oool0;`3oool200000=d0oooo000?0?ooo`800000<P3oool00`000000
oooo0?ooo`3J0?ooo`003`3oool00`000000oooo0?ooo`0b0?ooo`800000fP3oool000l0oooo00<0
00000?ooo`3oool0=03oool00`000000oooo0?ooo`3G0?ooo`003`3oool00`000000oooo0?ooo`0e
0?ooo`800000e`3oool000l0oooo00<000000?ooo`3oool0=`3oool200000=D0oooo000?0?ooo`03
0000003oool0oooo03T0oooo0P00003C0?ooo`003`3oool00`000000oooo0?ooo`0k0?ooo`800000
d@3oool000l0oooo00<000000?ooo`3oool0?@3oool200000<l0oooo000?0?ooo`800000?`3oool2
00000<h0oooo000?0?ooo`030000003oool0oooo0400oooo0P00003<0?ooo`003`3oool00`000000
oooo0?ooo`120?ooo`030000003oool0oooo0<T0oooo000?0?ooo`030000003oool0oooo04<0oooo
0P0000390?ooo`003`3oool00`000000oooo0?ooo`150?ooo`800000a`3oool000l0oooo00<00000
0?ooo`3oool0A`3oool00`000000oooo0?ooo`340?ooo`003`3oool00`000000oooo0?ooo`180?oo
o`800000a03oool000l0oooo00<000000?ooo`3oool0BP3oool00`000000oooo0?ooo`310?ooo`00
3`3oool2000004`0oooo0P0000310?ooo`003`3oool00`000000oooo0?ooo`1=0?ooo`030000003o
ool0oooo0;h0oooo000?0?ooo`030000003oool0oooo04h0oooo0P00002n0?ooo`003`3oool00`00
0000oooo0?ooo`1@0?ooo`800000_03oool000l0oooo00<000000?ooo`3oool0DP3oool00`000000
oooo0?ooo`2i0?ooo`003`3oool00`000000oooo0?ooo`1C0?ooo`800000^@3oool000030?ooo`00
00000000008000000P3oool4000000@0oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?oo
o`2f0?ooo`000`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool0EP3oool200000;H0oooo00030?ooo`030000003oool0oooo00<0oooo00<000000?oo
o`3oool00`3oool3000005P0oooo00<000000?ooo`3oool0/`3oool000<0oooo00<000000?ooo`3o
ool00`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo05T0oooo0P00002c0?ooo`00
0`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
F`3oool200000;40oooo0000103oool000000000000000030?ooo`<000001@3oool00`000000oooo
0?ooo`1M0?ooo`030000003oool0oooo0:h0oooo00030?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`1N0?ooo`800000[P3oool000l0oooo00<00000
0?ooo`3oool0H03oool200000:`0oooo000?0?ooo`030000003oool0oooo0640oooo0P00002[0?oo
o`003`3oool00`000000oooo0?ooo`1S0?ooo`030000003oool0oooo0:P0oooo000?0?ooo`800000
I@3oool200000:P0oooo000?0?ooo`030000003oool0oooo06H0oooo0P00002V0?ooo`003`3oool0
0`000000oooo0?ooo`1X0?ooo`030000003oool0oooo0:<0oooo000?0?ooo`030000003oool0oooo
06T0oooo0P00002S0?ooo`003`3oool00`000000oooo0?ooo`1[0?ooo`030000003oool0oooo0:00
oooo000?0?ooo`030000003oool0oooo06`0oooo0P00002P0?ooo`003`3oool00`000000oooo0?oo
o`1^0?ooo`030000003oool0oooo09d0oooo000?0?ooo`030000003oool0oooo06l0oooo0P00002M
0?ooo`003`3oool200000780oooo0P00002K0?ooo`003`3oool00`000000oooo0?ooo`1c0?ooo`03
0000003oool0oooo09P0oooo000?0?ooo`030000003oool0oooo07@0oooo0P00002H0?ooo`003`3o
ool00`000000oooo0?ooo`1f0?ooo`030000003oool0oooo09D0oooo000?0?ooo`030000003oool0
oooo07L0oooo0P00002E0?ooo`003`3oool00`000000oooo0?ooo`1i0?ooo`800000T`3oool000l0
oooo00<000000?ooo`3oool0N`3oool00`000000oooo0?ooo`2@0?ooo`003`3oool00`000000oooo
0?ooo`1l0?ooo`800000T03oool000l0oooo0P00001o0?ooo`<00000S@3oool000l0oooo00<00000
0?ooo`3oool0P03oool00`000000oooo0?ooo`2;0?ooo`003`3oool00`000000oooo0?ooo`210?oo
o`800000R`3oool000l0oooo00<000000?ooo`3oool0P`3oool00`000000oooo0?ooo`280?ooo`00
3`3oool00`000000oooo0?ooo`240?ooo`800000R03oool000l0oooo00<000000?ooo`3oool0QP3o
ool2000008H0oooo000?0?ooo`030000003oool0oooo08P0oooo00<000000?ooo`3oool0P`3oool0
00l0oooo00<000000?ooo`3oool0R@3oool2000008<0oooo000?0?ooo`800000S03oool00`000000
oooo0?ooo`200?ooo`003`3oool00`000000oooo0?ooo`2<0?ooo`800000P03oool000l0oooo00<0
00000?ooo`3oool0SP3oool2000007h0oooo000?0?ooo`030000003oool0oooo0900oooo0P00001l
0?ooo`003`3oool00`000000oooo0?ooo`2B0?ooo`800000NP3oool000l0oooo00<000000?ooo`3o
ool0U03oool2000007P0oooo00000`3oool000000000000200000080oooo100000040?ooo`030000
003oool0oooo09H0oooo00<000000?ooo`3oool0M@3oool000<0oooo00D000000?ooo`3oool0oooo
000000070?ooo`030000003oool0oooo09L0oooo0P00001e0?ooo`000`3oool00`000000oooo0?oo
o`020?ooo`030000003oool0oooo00@0oooo0`00002I0?ooo`030000003oool0oooo0780oooo0003
0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`2J
0?ooo`800000LP3oool000<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo09`0oooo0P00001`0?ooo`0000@0oooo00000000000000000`3oool01000
0000oooo0?ooo`0000040?ooo`030000003oool0oooo09d0oooo0P00001_0?ooo`000`3oool00`00
0000oooo0?ooo`020?ooo`8000001@3oool00`000000oooo0?ooo`2O0?ooo`800000K@3oool000l0
oooo00<000000?ooo`3oool0X@3oool00`000000oooo0?ooo`1Z0?ooo`003`3oool00`000000oooo
0?ooo`2R0?ooo`800000JP3oool000l0oooo00<000000?ooo`3oool0Y03oool00`000000oooo0?oo
o`1W0?ooo`003`3oool200000:H0oooo0P00001W0?ooo`003`3oool00`000000oooo0?ooo`2W0?oo
o`800000I@3oool000l0oooo00<000000?ooo`3oool0Z@3oool00`000000oooo0?ooo`1R0?ooo`00
3`3oool00`000000oooo0?ooo`2Z0?ooo`800000HP3oool000l0oooo00<000000?ooo`3oool0[03o
ool00`000000oooo0?ooo`1O0?ooo`003`3oool00`000000oooo0?ooo`2]0?ooo`800000G`3oool0
00l0oooo00<000000?ooo`3oool0[`3oool00`000000oooo0?ooo`1L0?ooo`003`3oool00`000000
oooo0?ooo`2`0?ooo`800000G03oool000l0oooo0P00002c0?ooo`800000FP3oool000l0oooo00<0
00000?ooo`3oool0]03oool00`000000oooo0?ooo`1G0?ooo`003`3oool00`000000oooo0?ooo`2e
0?ooo`<00000EP3oool000l0oooo00<000000?ooo`3oool0]`3oool00`000000oooo0?ooo`1D0?oo
o`003`3oool00`000000oooo0?ooo`2h0?ooo`800000E03oool000l0oooo00<000000?ooo`3oool0
^P3oool00`000000oooo0?ooo`1A0?ooo`003`3oool00`000000oooo0?ooo`2k0?ooo`800000D@3o
ool000l0oooo00<000000?ooo`3oool0_@3oool2000004l0oooo000?0?ooo`800000`03oool00`00
0000oooo0?ooo`1<0?ooo`003`3oool00`000000oooo0?ooo`300?ooo`800000C03oool000l0oooo
00<000000?ooo`3oool0`P3oool00`000000oooo0?ooo`190?ooo`003`3oool00`000000oooo0?oo
o`330?ooo`800000B@3oool000l0oooo00<000000?ooo`3oool0a@3oool2000004L0oooo000?0?oo
o`030000003oool0oooo0<L0oooo0P0000150?ooo`003`3oool00`000000oooo0?ooo`390?ooo`80
0000@`3oool000l0oooo00<000000?ooo`3oool0b`3oool200000440oooo000?0?ooo`800000cP3o
ool00`000000oooo0?ooo`0n0?ooo`003`3oool00`000000oooo0?ooo`3>0?ooo`800000?P3oool0
00l0oooo00<000000?ooo`3oool0c`3oool2000003d0oooo000?0?ooo`030000003oool0oooo0=40
oooo0P00000k0?ooo`003`3oool00`000000oooo0?ooo`3C0?ooo`800000>@3oool000l0oooo00<0
00000?ooo`3oool0e@3oool00`000000oooo0?ooo`0f0?ooo`0000<0oooo0000000000000P000003
0?ooo`8000001@3oool00`000000oooo0?ooo`3F0?ooo`800000=P3oool000<0oooo00D000000?oo
o`3oool0oooo000000020?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0f03oool0
0`000000oooo0?ooo`0c0?ooo`000`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo
0080oooo0`00003I0?ooo`800000<`3oool000<0oooo00<000000?ooo`3oool00P3oool2000000D0
oooo00<000000?ooo`3oool0f`3oool00`000000oooo0?ooo`0`0?ooo`000`3oool00`000000oooo
0?ooo`040?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0g03oool200000300oooo
0000103oool000000000000000030?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3o
ool0gP3oool2000002h0oooo00030?ooo`030000003oool0oooo0080oooo0P0000050?ooo`030000
003oool0oooo0>00oooo00<000000?ooo`3oool0:`3oool000l0oooo00<000000?ooo`3oool0h@3o
ool2000002/0oooo000?0?ooo`030000003oool0oooo0><0oooo00<000000?ooo`3oool0:03oool0
00l0oooo00<000000?ooo`3oool0i03oool2000002P0oooo000?0?ooo`800000i`3oool00`000000
oooo0?ooo`0U0?ooo`003`3oool00`000000oooo0?ooo`3W0?ooo`8000009@3oool000l0oooo00<0
00000?ooo`3oool0j@3oool2000002<0oooo000?0?ooo`030000003oool0oooo0>/0oooo00<00000
0?ooo`3oool0803oool000l0oooo00<000000?ooo`3oool0k03oool200000200oooo000?0?ooo`03
0000003oool0oooo0>h0oooo00<000000?ooo`3oool07@3oool000l0oooo00<000000?ooo`3oool0
k`3oool2000001d0oooo000?0?ooo`030000003oool0oooo0?40oooo00<000000?ooo`3oool06P3o
ool000l0oooo0P00003c0?ooo`8000006P3oool000l0oooo00<000000?ooo`3oool0m03oool20000
01P0oooo000?0?ooo`030000003oool0oooo0?H0oooo00<000000?ooo`3oool05@3oool000l0oooo
00<000000?ooo`3oool0m`3oool2000001D0oooo000?0?ooo`030000003oool0oooo0?T0oooo00<0
00000?ooo`3oool04P3oool000l0oooo00<000000?ooo`3oool0nP3oool200000180oooo000?0?oo
o`030000003oool0oooo0?`0oooo0P00000@0?ooo`003`3oool00`000000oooo0?ooo`3n0?ooo`80
00003P3oool000l0oooo0P00003o0?ooo`80oooo0P00000<0?ooo`003`3oool00`000000oooo0?oo
o`3o0?ooo`<0oooo0P00000:0?ooo`003`3oool00`000000oooo0?ooo`3o0?ooo`D0oooo00<00000
0?ooo`3oool01`3oool000l0oooo00<000000?ooo`3oool0o`3oool?0?ooo`003`3oool00`000000
oooo0?ooo`3o0?ooo`l0oooo000?0?ooo`030000003oool0oooo0?l0oooo3`3oool000l0oooo00<0
00000?ooo`3oool0o`3oool?0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00
\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {1.95292, 9.40997, \
0.00304701, 0.0249605}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["Time (no constraints)  vs. K", "Text"],

Cell[BoxData[
    \(\(olddat = {{13, 2.86}, {14, 4.37}, {15, 7.31}, {20, 41}};\)\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(lolddat = Log[N[olddat]]\)], "Input"],

Cell[BoxData[
    \({{2.5649493574615367`, 1.0508216248317612`}, {2.6390573296152584`, 
        1.4747630091074988`}, {2.70805020110221`, 
        1.9892432737616872`}, {2.995732273553991`, 
        3.713572066704308`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(lofitting = Fit[lolddat, {1, x}, x]\)], "Input"],

Cell[BoxData[
    \(\(-14.849383625119266`\) + 6.199783794146799`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[ListPlot[lolddat, DisplayFunction \[Rule] Identity], 
      Plot[lofitting, {x, 2.5, 3}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-4.7381 1.90476 -0.108721 0.189879 [
[.02381 .06866 -9 -9 ]
[.02381 .06866 9 0 ]
[.21429 .06866 -9 -9 ]
[.21429 .06866 9 0 ]
[.40476 .06866 -9 -9 ]
[.40476 .06866 9 0 ]
[.59524 .06866 -9 -9 ]
[.59524 .06866 9 0 ]
[.78571 .06866 -9 -9 ]
[.78571 .06866 9 0 ]
[.96369 .1761 -18 -4.5 ]
[.96369 .1761 0 4.5 ]
[.96369 .27104 -6 -4.5 ]
[.96369 .27104 0 4.5 ]
[.96369 .36598 -18 -4.5 ]
[.96369 .36598 0 4.5 ]
[.96369 .46092 -6 -4.5 ]
[.96369 .46092 0 4.5 ]
[.96369 .55586 -18 -4.5 ]
[.96369 .55586 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 .08116 m
.02381 .08741 L
s
[(2.5)] .02381 .06866 0 1 Mshowa
.21429 .08116 m
.21429 .08741 L
s
[(2.6)] .21429 .06866 0 1 Mshowa
.40476 .08116 m
.40476 .08741 L
s
[(2.7)] .40476 .06866 0 1 Mshowa
.59524 .08116 m
.59524 .08741 L
s
[(2.8)] .59524 .06866 0 1 Mshowa
.78571 .08116 m
.78571 .08741 L
s
[(2.9)] .78571 .06866 0 1 Mshowa
.125 Mabswid
.0619 .08116 m
.0619 .08491 L
s
.1 .08116 m
.1 .08491 L
s
.1381 .08116 m
.1381 .08491 L
s
.17619 .08116 m
.17619 .08491 L
s
.25238 .08116 m
.25238 .08491 L
s
.29048 .08116 m
.29048 .08491 L
s
.32857 .08116 m
.32857 .08491 L
s
.36667 .08116 m
.36667 .08491 L
s
.44286 .08116 m
.44286 .08491 L
s
.48095 .08116 m
.48095 .08491 L
s
.51905 .08116 m
.51905 .08491 L
s
.55714 .08116 m
.55714 .08491 L
s
.63333 .08116 m
.63333 .08491 L
s
.67143 .08116 m
.67143 .08491 L
s
.70952 .08116 m
.70952 .08491 L
s
.74762 .08116 m
.74762 .08491 L
s
.82381 .08116 m
.82381 .08491 L
s
.8619 .08116 m
.8619 .08491 L
s
.9 .08116 m
.9 .08491 L
s
.9381 .08116 m
.9381 .08491 L
s
.25 Mabswid
0 .08116 m
1 .08116 L
s
.97619 .1761 m
.98244 .1761 L
s
[(1.5)] .96369 .1761 1 0 Mshowa
.97619 .27104 m
.98244 .27104 L
s
[(2)] .96369 .27104 1 0 Mshowa
.97619 .36598 m
.98244 .36598 L
s
[(2.5)] .96369 .36598 1 0 Mshowa
.97619 .46092 m
.98244 .46092 L
s
[(3)] .96369 .46092 1 0 Mshowa
.97619 .55586 m
.98244 .55586 L
s
[(3.5)] .96369 .55586 1 0 Mshowa
.125 Mabswid
.97619 .10015 m
.97994 .10015 L
s
.97619 .11913 m
.97994 .11913 L
s
.97619 .13812 m
.97994 .13812 L
s
.97619 .15711 m
.97994 .15711 L
s
.97619 .19509 m
.97994 .19509 L
s
.97619 .21407 m
.97994 .21407 L
s
.97619 .23306 m
.97994 .23306 L
s
.97619 .25205 m
.97994 .25205 L
s
.97619 .29002 m
.97994 .29002 L
s
.97619 .30901 m
.97994 .30901 L
s
.97619 .328 m
.97994 .328 L
s
.97619 .34699 m
.97994 .34699 L
s
.97619 .38496 m
.97994 .38496 L
s
.97619 .40395 m
.97994 .40395 L
s
.97619 .42294 m
.97994 .42294 L
s
.97619 .44193 m
.97994 .44193 L
s
.97619 .4799 m
.97994 .4799 L
s
.97619 .49889 m
.97994 .49889 L
s
.97619 .51788 m
.97994 .51788 L
s
.97619 .53687 m
.97994 .53687 L
s
.97619 .06217 m
.97994 .06217 L
s
.97619 .04318 m
.97994 .04318 L
s
.97619 .02419 m
.97994 .02419 L
s
.97619 .00521 m
.97994 .00521 L
s
.97619 .57484 m
.97994 .57484 L
s
.97619 .59383 m
.97994 .59383 L
s
.97619 .61282 m
.97994 .61282 L
s
.25 Mabswid
.97619 0 m
.97619 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.14752 .09081 Mdot
.28868 .17131 Mdot
.4201 .26899 Mdot
.96806 .59641 Mdot
.5 Mabswid
.02381 .01472 m
.06244 .03859 L
.10458 .06463 L
.14415 .08909 L
.18221 .11261 L
.22272 .13765 L
.26171 .16175 L
.30316 .18736 L
.34309 .21204 L
.3815 .23578 L
.42237 .26104 L
.46172 .28536 L
.49955 .30874 L
.53984 .33364 L
.57861 .3576 L
.61984 .38308 L
.65954 .40762 L
.69774 .43123 L
.73838 .45635 L
.77751 .48053 L
.81909 .50623 L
.85916 .53099 L
.89771 .55482 L
.93871 .58016 L
.97619 .60332 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolI
0?ooo`030000003oool0oooo00D0oooo003o0?oooaT0oooo00<000000?ooo`3oool01@3oool00?l0
oooo6@3oool2000000H0oooo003o0?oooaT0oooo00<000000?ooo`3oool01@3oool000T0oooo00<0
00000?ooo`3oool0o`3oool=0?ooo`030000003oool0oooo00D0oooo000:0?ooo`800000o`3oool=
0?ooo`030000003oool0oooo00D0oooo000<0?ooo`030000003oool0oooo0?l0oooo2P3oool00`00
0000oooo0?ooo`050?ooo`003@3oool200000?l0oooo2P3oool2000000H0oooo000?0?ooo`800000
o`3oool80?ooo`030000003oool0oooo00D0oooo000A0?ooo`030000003oool0oooo0?l0oooo1@3o
ool00`000000oooo0?ooo`050?ooo`004P3oool200000?l0oooo1@3oool00`000000oooo0?ooo`05
0?ooo`00503oool00`000000oooo0?ooo`3o0?ooo`80oooo00<000000?ooo`3oool01@3oool001D0
oooo0P00003o0?ooo`80oooo0P0000060?ooo`0000<0oooo0000000000000P0000030?ooo`030000
003oool0oooo0080oooo0`0000070?ooo`8000007P3oool4000000<0oooo00<000000?ooo`3oool0
0`3oool2000002L0oooo100000030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0
9P3oool4000000<0oooo00<000000?ooo`3oool00`3oool2000002L0oooo100000030?ooo`030000
003oool0oooo0080oooo0`00000`0?ooo`030000003oool0oooo00D0oooo00000`3oool000000?oo
o`0=0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool06`3oool00`000000oooo0?oo
o`090?ooo`040000003oool0oooo000002H0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`0V0?ooo`030000003oool0oooo00T0oooo00@000000?ooo`3oool000009P3oool00`000000
oooo0?ooo`0<0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool01@3oool00080oooo
00<000000?ooo`3oool02`3oool00`000000oooo0?ooo`070?ooo`800000703oool00`000000oooo
0?ooo`080?ooo`040000003oool0oooo000002L0oooo00<000000?ooo`3oool02P3oool00`000000
oooo0?ooo`0V0?ooo`030000003oool0oooo00P0oooo00@000000?ooo`3oool000009`3oool00`00
0000oooo0?ooo`0;0?ooo`030000003oool0oooo02d0oooo00<000000?ooo`3oool01@3oool000<0
oooo00<000000?ooo`3oool01`3oool3000000`0oooo0P00000K0?ooo`030000003oool0oooo00L0
oooo0`00000Y0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool09`3oool00`000000
oooo0?ooo`080?ooo`800000:@3oool00`000000oooo0?ooo`080?ooo`<00000;`3oool00`000000
oooo0?ooo`050?ooo`00103oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00h0oooo
0P00000J0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0:P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo02L0oooo00<000000?ooo`3oool01P3oool010000000oooo
0?ooo`00000Y0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool00000;`3oool00`00
0000oooo0?ooo`050?ooo`0000D0oooo0000003oool0oooo000000080?ooo`030000003oool0oooo
0100oooo00<000000?ooo`3oool0503oool010000000oooo0?ooo`0000080?ooo`030000003oool0
oooo02L0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00000V0?ooo`040000
003oool0oooo000000P0oooo00@000000?ooo`3oool000009P3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo000002l0oooo0P0000060?ooo`000P3oool2000000T0oooo1000000@
0?ooo`8000005@3oool2000000X0oooo0`00000W0?ooo`8000002@3oool4000002L0oooo0P00000:
0?ooo`800000:03oool2000000X0oooo0P00000`0?ooo`030000003oool0oooo00D0oooo000S0?oo
o`030000003oool0oooo0?80oooo00<000000?ooo`3oool01@3oool002@0oooo0P00003b0?ooo`03
0000003oool0oooo00D0oooo000V0?ooo`800000l03oool00`000000oooo0?ooo`050?ooo`000P3o
oooo000001l0000000090?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0203oool0
0`000000oooo0?ooo`080?ooo`8000002@3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`080?ooo`030000003oool0
oooo00P0oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`050?ooo`002@3oool00`00
0000oooo0?ooo`0O0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0<`3oool00`00
0000oooo0?ooo`0c0?ooo`030000003oool0oooo03<0oooo00<000000?ooo`3oool0=03oool00`00
0000oooo0?ooo`050?ooo`00:`3oool300000>X0oooo00<000000?ooo`3oool01@3oool002`0oooo
00<000000?ooo`000000j@3oool00`000000oooo0?ooo`050?ooo`00;`3oool200000>L0oooo00<0
00000?ooo`3oool01@3oool00340oooo0P00003U0?ooo`8000001P3oool003<0oooo00<000000?oo
o`3oool0hP3oool00`000000oooo0?ooo`050?ooo`00=03oool200000>80oooo00<000000?ooo`3o
ool01@3oool003H0oooo00<000000?ooo`3oool0g`3oool00`000000oooo0?ooo`050?ooo`00=`3o
ool200000=l0oooo00<000000?ooo`3oool01@3oool003T0oooo00<000000?ooo`3oool0g03oool2
000000H0oooo000j0?ooo`800000g03oool00`000000oooo0?ooo`050?ooo`00?03oool200000=X0
oooo00<000000?ooo`3oool01@3oool003h0oooo00<000000?ooo`3oool0e`3oool00`000000oooo
0?ooo`050?ooo`00?`3oool200000=L0oooo00<000000?ooo`3oool01@3oool00440oooo00<00000
0?ooo`3oool0e03oool2000000H0oooo00120?ooo`800000e03oool00`000000oooo0?ooo`050?oo
o`00A03oool00`000000oooo0?ooo`3A0?ooo`030000003oool0oooo00D0oooo00150?ooo`800000
d@3oool00`000000oooo0?ooo`050?ooo`00A`3oool200000<l0oooo00<000000?ooo`3oool01@3o
ool004T0oooo00<000000?ooo`3oool0c03oool00`000000oooo0?ooo`050?ooo`00BP3oool20000
0<`0oooo0P0000060?ooo`00C03oool00`000000oooo0?ooo`390?ooo`030000003oool0oooo00D0
oooo001=0?ooo`800000b@3oool00`000000oooo0?ooo`050?ooo`00C`3oool200000080oooo0P00
002^0?ooo`@000000`3oool00`000000oooo0?ooo`020?ooo`<000001P3oool00`000000oooo0?oo
o`050?ooo`00D@3oool010000000oooo0?ooo`00002`0?ooo`030000003oool0oooo00X0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`050?ooo`00DP3oool200000;40oooo00<00000
0?ooo`3oool02P3oool00`000000oooo0?ooo`030?ooo`8000001P3oool005@0oooo0P00002_0?oo
o`030000003oool0oooo00L0oooo0`0000060?ooo`030000003oool0oooo00D0oooo001F0?ooo`80
0000[@3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3o
ool01@3oool005P0oooo00<000000?ooo`3oool0Z03oool3000000T0oooo00<000000?ooo`3oool0
1P3oool00`000000oooo0?ooo`050?ooo`00F@3oool200000:X0oooo00<000000?ooo`3oool01`3o
ool4000000D0oooo00<000000?ooo`3oool01@3oool005/0oooo00<000000?ooo`3oool0^P3oool0
0`000000oooo0?ooo`050?ooo`00G03oool200000;X0oooo0P0000060?ooo`00GP3oool200000;P0
oooo00<000000?ooo`3oool01@3oool00600oooo00<000000?ooo`3oool0]@3oool00`000000oooo
0?ooo`050?ooo`00H@3oool200000;D0oooo00<000000?ooo`3oool01@3oool006<0oooo00<00000
0?ooo`3oool0/P3oool00`000000oooo0?ooo`050?ooo`00I03oool200000;80oooo0P0000060?oo
o`00IP3oool00`000000oooo0?ooo`2_0?ooo`030000003oool0oooo00D0oooo001W0?ooo`800000
[`3oool00`000000oooo0?ooo`050?ooo`00J@3oool200000:d0oooo00<000000?ooo`3oool01@3o
ool006/0oooo00<000000?ooo`3oool0ZP3oool00`000000oooo0?ooo`050?ooo`00K03oool20000
0:X0oooo0P0000060?ooo`00KP3oool00`000000oooo0?ooo`2W0?ooo`030000003oool0oooo00D0
oooo001_0?ooo`800000Y`3oool00`000000oooo0?ooo`050?ooo`00L@3oool200000:D0oooo00<0
00000?ooo`3oool01@3oool007<0oooo00<000000?ooo`3oool0XP3oool00`000000oooo0?ooo`05
0?ooo`00M03oool200000:80oooo00<000000?ooo`3oool01@3oool007H0oooo0P00002P0?ooo`80
00001P3oool007P0oooo0P00002N0?ooo`030000003oool0oooo00D0oooo001j0?ooo`030000003o
ool0oooo09/0oooo00<000000?ooo`3oool01@3oool007/0oooo0P00002B0?ooo`@000001@3oool0
0`000000oooo0?ooo`050?ooo`00N@3oool200000080oooo00<000000?ooo`3oool0S`3oool00`00
0000oooo0?ooo`060?ooo`030000003oool0oooo00D0oooo001j0?ooo`040000003oool0oooo0?oo
o`800000T03oool00`000000oooo0?ooo`050?ooo`8000001P3oool00800oooo0P00002?0?ooo`03
0000003oool0oooo00@0oooo00<000000?ooo`3oool01@3oool00880oooo00<000000?ooo`3oool0
S@3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo00230?ooo`800000RP3o
ool010000000oooo0?ooo`0000050?ooo`030000003oool0oooo00D0oooo00250?ooo`030000003o
ool0oooo08P0oooo0P0000060?ooo`030000003oool0oooo00D0oooo00260?ooo`800000T03oool0
0`000000oooo0?ooo`050?ooo`00R03oool00`000000oooo0?ooo`2=0?ooo`8000001P3oool008T0
oooo0P00002=0?ooo`030000003oool0oooo00D0oooo002;0?ooo`800000R`3oool00`000000oooo
0?ooo`050?ooo`00S@3oool00`000000oooo0?ooo`280?ooo`030000003oool0oooo00D0oooo002>
0?ooo`800000R03oool00`000000oooo0?ooo`050?ooo`00T03oool00`000000oooo0?ooo`250?oo
o`8000001P3oool00940oooo0P0000250?ooo`030000003oool0oooo00D0oooo002C0?ooo`030000
003oool0oooo0880oooo00<000000?ooo`3oool01@3oool009@0oooo0P0000220?ooo`030000003o
ool0oooo00D0oooo002F0?ooo`800000P03oool00`000000oooo0?ooo`050?ooo`00V03oool00`00
0000oooo0?ooo`1m0?ooo`8000001P3oool009T0oooo0P00001m0?ooo`030000003oool0oooo00D0
oooo002K0?ooo`030000003oool0oooo07X0oooo00<000000?ooo`3oool01@3oool009`0oooo0P00
001j0?ooo`030000003oool0oooo00D0oooo002N0?ooo`030000003oool0oooo07L0oooo00<00000
0?ooo`3oool01@3oool009l0oooo0P00001g0?ooo`030000003oool0oooo00D0oooo002Q0?ooo`80
0000M@3oool2000000H0oooo002S0?ooo`030000003oool0oooo0780oooo00<000000?ooo`3oool0
1@3oool00:@0oooo0P00001b0?ooo`030000003oool0oooo00D0oooo002V0?ooo`030000003oool0
oooo05X0oooo100000030?ooo`030000003oool0oooo0080oooo0`0000060?ooo`030000003oool0
oooo00D0oooo002W0?ooo`800000FP3oool00`000000oooo0?ooo`0<0?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool01@3oool00:T0oooo0P00001I0?ooo`030000003oool0oooo00/0
oooo00<000000?ooo`3oool00`3oool2000000H0oooo002[0?ooo`030000003oool0oooo05L0oooo
00<000000?ooo`3oool01`3oool3000000H0oooo00<000000?ooo`3oool01@3oool00:`0oooo0P00
001H0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`050?ooo`00[P3oool2000005<0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo00D0oooo002`0?ooo`800000DP3oool2000000T0oooo10000005
0?ooo`030000003oool0oooo00D0oooo002b0?ooo`030000003oool0oooo06<0oooo00<000000?oo
o`3oool01@3oool00;<0oooo0P00001S0?ooo`8000001P3oool00;D0oooo0P00001Q0?ooo`030000
003oool0oooo00D0oooo002g0?ooo`030000003oool0oooo05h0oooo00<000000?ooo`3oool01@3o
ool00;P0oooo0P00001N0?ooo`030000003oool0oooo00D0oooo002j0?ooo`800000G03oool00`00
0000oooo0?ooo`050?ooo`00_03oool2000005X0oooo0P0000060?ooo`00_P3oool00`000000oooo
0?ooo`1G0?ooo`030000003oool0oooo00D0oooo002o0?ooo`800000E`3oool00`000000oooo0?oo
o`050?ooo`00`@3oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo00D0oooo00320?oo
o`030000003oool0oooo05<0oooo00<000000?ooo`3oool01@3oool00<<0oooo0P00001C0?ooo`80
00001P3oool00<D0oooo00<000000?ooo`3oool0D03oool00`000000oooo0?ooo`050?ooo`00aP3o
ool200000500oooo00<000000?ooo`3oool01@3oool00<P0oooo00<000000?ooo`3oool0C@3oool0
0`000000oooo0?ooo`050?ooo`00b@3oool2000004d0oooo00<000000?ooo`3oool01@3oool00</0
oooo0P00001;0?ooo`030000003oool0oooo00D0oooo003=0?ooo`030000003oool0oooo04P0oooo
0P0000060?ooo`00cP3oool2000004P0oooo00<000000?ooo`3oool01@3oool00=00oooo0P000016
0?ooo`030000003oool0oooo00D0oooo003B0?ooo`800000?03oool2000000H0oooo00<000000?oo
o`3oool01@3oool00=@0oooo00<000000?ooo`3oool0>03oool010000000oooo0?ooo`0000050?oo
o`030000003oool0oooo00D0oooo003E0?ooo`800000>`3oool00`000000oooo0?ooo`030?ooo`80
00001P3oool00=L0oooo00<000000?ooo`3oool0=P3oool2000000H0oooo00<000000?ooo`3oool0
1@3oool00=P0oooo0P00000h0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool01@3o
ool00=X0oooo0P00000c0?ooo`040000003oool0oooo000000D0oooo00<000000?ooo`3oool01@3o
ool00=`0oooo00<000000?ooo`3oool0<@3oool2000000H0oooo00<000000?ooo`3oool01@3oool0
0=d0oooo0P00000i0?ooo`030000003oool0oooo00D0oooo003O0?ooo`030000003oool0oooo03H0
oooo0P0000060?ooo`00h03oool2000003H0oooo00<000000?ooo`3oool01@3oool00>80oooo0P00
000d0?ooo`030000003oool0oooo00D0oooo003T0?ooo`030000003oool0oooo0340oooo00<00000
0?ooo`3oool01@3oool00>D0oooo0P00000a0?ooo`030000003oool0oooo00D0oooo003W0?ooo`80
0000;`3oool2000000H0oooo003Y0?ooo`800000;@3oool00`000000oooo0?ooo`050?ooo`00j`3o
ool00`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo00D0oooo003/0?ooo`800000:P3oool0
0`000000oooo0?ooo`050?ooo`00kP3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0oooo
00D0oooo003_0?ooo`8000009`3oool00`000000oooo0?ooo`050?ooo`00l@3oool2000002D0oooo
0P0000060?ooo`00l`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo00D0oooo003d
0?ooo`8000008P3oool00`000000oooo0?ooo`050?ooo`00mP3oool00`000000oooo0?ooo`0O0?oo
o`030000003oool0oooo00D0oooo003g0?ooo`8000007`3oool00`000000oooo0?ooo`050?ooo`00
n@3oool00`000000oooo0?ooo`0L0?ooo`8000001P3oool00?X0oooo0P00000L0?ooo`030000003o
ool0oooo00D0oooo003l0?ooo`8000006P3oool00`000000oooo0?ooo`050?ooo`00oP3oool00`00
0000oooo0?ooo`030?ooo`800000103oool00`000000oooo0?ooo`020?ooo`<000001P3oool00`00
0000oooo0?ooo`050?ooo`00o`3oool200000080oooo00@000000?ooo`3oool000002`3oool00`00
0000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo003o0?ooo`80oooo00<000000?ooo`3o
ool00P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00<0oooo0P0000060?ooo`00
o`3oool30?ooo`@000002@3oool3000000H0oooo00<000000?ooo`3oool01@3oool00?l0oooo1@3o
ool3000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`050?ooo`00o`3oool4
0?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`050?ooo`00o`3oool50?ooo`80000000<0oooo0000000000001P3oool4000000D0oooo00<00000
0?ooo`3oool01@3oool00?l0oooo2P3oool2000000d0oooo00<000000?ooo`3oool01@3oool00?l0
oooo303oool2000000/0oooo0P0000060?ooo`00o`3oool>0?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool01@3oool00?l0oooo3`3oool2000000P0oooo00<000000?ooo`3oool01@3o
ool00?l0oooo4@3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo00D0oooo003o0?oo
oa80oooo0P0000050?ooo`030000003oool0oooo00D0oooo003o0?oooa@0oooo100000000`3oool0
0000000000060?ooo`00o`3ooolF0?ooo`80000000<0oooo0000003oool01P3oool00?l0oooo5`3o
ool3000000L0oooo003o0?oooaT0oooo00<000000?ooo`3oool01@3oool00?l0oooo6@3oool00`00
0000oooo0?ooo`050?ooo`00o`3ooolI0?ooo`030000003oool0oooo00D0oooo003o0?oooaT0oooo
0P0000060?ooo`00o`3ooolI0?ooo`030000003oool0oooo00D0oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {2.48341, 0.563923, \
0.00184354, 0.0184934}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{520, 600},
WindowMargins->{{Automatic, 110}, {Automatic, 17}}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 73, 3, 156, "Title"],
Cell[1815, 56, 57, 0, 32, "Text"],
Cell[1875, 58, 48, 0, 32, "Text"],
Cell[1926, 60, 132, 2, 43, "Input"],

Cell[CellGroupData[{
Cell[2083, 66, 87, 1, 27, "Input"],
Cell[2173, 69, 248, 4, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2458, 78, 63, 1, 27, "Input"],
Cell[2524, 81, 82, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2643, 87, 205, 3, 59, "Input"],
Cell[2851, 92, 15858, 413, 186, 3584, 257, "GraphicsData", "PostScript", \
"Graphics"],
Cell[18712, 507, 130, 3, 27, "Output"]
}, Open  ]],
Cell[18857, 513, 59, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[18941, 517, 128, 2, 43, "Input"],
Cell[19072, 521, 182, 3, 46, "Message"],
Cell[19257, 526, 119, 2, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19413, 533, 69, 1, 27, "Input"],
Cell[19485, 536, 91, 1, 29, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[19613, 542, 265, 5, 75, "Input"],
Cell[19881, 549, 17236, 450, 186, 3913, 281, "GraphicsData", "PostScript", \
"Graphics"],
Cell[37120, 1001, 130, 3, 27, "Output"]
}, Open  ]],
Cell[37265, 1007, 76, 0, 32, "Text"],
Cell[37344, 1009, 140, 2, 43, "Input"],

Cell[CellGroupData[{
Cell[37509, 1015, 89, 1, 27, "Input"],
Cell[37601, 1018, 193, 3, 59, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37831, 1026, 66, 1, 27, "Input"],
Cell[37900, 1029, 82, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38019, 1035, 208, 3, 59, "Input"],
Cell[38230, 1040, 15372, 370, 186, 2981, 212, "GraphicsData", "PostScript", \
"Graphics"],
Cell[53605, 1412, 130, 3, 27, "Output"]
}, Open  ]],
Cell[53750, 1418, 44, 0, 32, "Text"],
Cell[53797, 1420, 93, 1, 27, "Input"],

Cell[CellGroupData[{
Cell[53915, 1425, 57, 1, 27, "Input"],
Cell[53975, 1428, 233, 4, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[54245, 1437, 68, 1, 27, "Input"],
Cell[54316, 1440, 82, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[54435, 1446, 210, 3, 59, "Input"],
Cell[54648, 1451, 17418, 453, 186, 3913, 282, "GraphicsData", "PostScript", \
"Graphics"],
Cell[72069, 1906, 130, 3, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

