(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     52737,       1357]*)
(*NotebookOutlinePosition[     53653,       1386]*)
(*  CellTagsIndexPosition[     53609,       1382]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Evaluate Kappa_5 scaling with K", "Title"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\(\ \)\(inin = {0.0517766953, 1, 
        0.8301399165, \(-0.05268293962\), \(-0.09507658562\), 104887723.7, 
        0.08065136258, 38591030.46, \(-1.794571426\), \(-2.333841248\), 
        0, \(-0.6578485781\), 
        0.5403484159, \(-0.1179405157\), \(-0.1172333778\), 0.02454314234, 
        0.5106455396, 0.5346726459, 0, 0, 0.7130496269, 0, 0, 0.09285197781, 
        0, 0, 0.05533136267, 0, 0, \(-0.09805250938\), 0, 
        0, \(-0.08668669943\), 0, 0, 0, 0, 0}\)\)\)], "Input"],

Cell[BoxData[
    \({0.0517766953`, 1, 
      0.8301399165`, \(-0.05268293962`\), \(-0.09507658562`\), 
      1.048877237`*^8, 0.08065136258`, 
      3.859103046`*^7, \(-1.794571426`\), \(-2.333841248`\), 
      0, \(-0.6578485781`\), 
      0.5403484159`, \(-0.1179405157`\), \(-0.1172333778`\), 0.02454314234`, 
      0.5106455396`, 0.5346726459`, 0, 0, 0.7130496269`, 0, 0, 
      0.09285197781`, 0, 0, 0.05533136267`, 0, 0, \(-0.09805250938`\), 0, 
      0, \(-0.08668669943`\), 0, 0, 0, 0, 0}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(kappalist = Take[inin, {12, 17}]\)], "Input"],

Cell[BoxData[
    \({\(-0.6578485781`\), 
      0.5403484159`, \(-0.1179405157`\), \(-0.1172333778`\), 0.02454314234`, 
      0.5106455396`}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(kappaf[kk_] := 
      Sum[kappalist[\([n]\)] LaguerreL[n - 1, 0, kk/10], {n, 
          Length[kappalist]}]\)], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(kklist = {20/2, 22/2, 24/2, 26/2, 30/2, 40/2}\)], "Input"],

Cell[BoxData[
    \({10, 11, 12, 13, 15, 20}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pp = Map[{#, kappaf[#]} &, kklist]\)], "Input"],

Cell[BoxData[
    \({{10, \(-0.7743634508258332`\)}, {11, \(-0.7658573840982952`\)}, {12, \
\(-0.7509923897562496`\)}, {13, \(-0.7322297285908506`\)}, {15, \
\(-0.6918790573135938`\)}, {20, \(-0.6585242425466666`\)}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[ListPlot[pp, DisplayFunction \[Rule] Identity], 
      Plot[kappaf[kk], {kk, 10, 20}, DisplayFunction \[Rule] Identity], 
      DisplayFunction \[Rule] $DisplayFunction]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.0952381 3.71065 4.77286 [
[.21429 .35714 -6 -9 ]
[.21429 .35714 6 0 ]
[.40476 .35714 -6 -9 ]
[.40476 .35714 6 0 ]
[.59524 .35714 -6 -9 ]
[.59524 .35714 6 0 ]
[.78571 .35714 -6 -9 ]
[.78571 .35714 6 0 ]
[.97619 .35714 -6 -9 ]
[.97619 .35714 6 0 ]
[.01131 .08327 -30 -4.5 ]
[.01131 .08327 0 4.5 ]
[.01131 .17873 -30 -4.5 ]
[.01131 .17873 0 4.5 ]
[.01131 .27418 -30 -4.5 ]
[.01131 .27418 0 4.5 ]
[.01131 .4651 -30 -4.5 ]
[.01131 .4651 0 4.5 ]
[.01131 .56056 -30 -4.5 ]
[.01131 .56056 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .36964 m
.21429 .37589 L
s
[(12)] .21429 .35714 0 1 Mshowa
.40476 .36964 m
.40476 .37589 L
s
[(14)] .40476 .35714 0 1 Mshowa
.59524 .36964 m
.59524 .37589 L
s
[(16)] .59524 .35714 0 1 Mshowa
.78571 .36964 m
.78571 .37589 L
s
[(18)] .78571 .35714 0 1 Mshowa
.97619 .36964 m
.97619 .37589 L
s
[(20)] .97619 .35714 0 1 Mshowa
.125 Mabswid
.07143 .36964 m
.07143 .37339 L
s
.11905 .36964 m
.11905 .37339 L
s
.16667 .36964 m
.16667 .37339 L
s
.2619 .36964 m
.2619 .37339 L
s
.30952 .36964 m
.30952 .37339 L
s
.35714 .36964 m
.35714 .37339 L
s
.45238 .36964 m
.45238 .37339 L
s
.5 .36964 m
.5 .37339 L
s
.54762 .36964 m
.54762 .37339 L
s
.64286 .36964 m
.64286 .37339 L
s
.69048 .36964 m
.69048 .37339 L
s
.7381 .36964 m
.7381 .37339 L
s
.83333 .36964 m
.83333 .37339 L
s
.88095 .36964 m
.88095 .37339 L
s
.92857 .36964 m
.92857 .37339 L
s
.25 Mabswid
0 .36964 m
1 .36964 L
s
.02381 .08327 m
.03006 .08327 L
s
[(-0.76)] .01131 .08327 1 0 Mshowa
.02381 .17873 m
.03006 .17873 L
s
[(-0.74)] .01131 .17873 1 0 Mshowa
.02381 .27418 m
.03006 .27418 L
s
[(-0.72)] .01131 .27418 1 0 Mshowa
.02381 .4651 m
.03006 .4651 L
s
[(-0.68)] .01131 .4651 1 0 Mshowa
.02381 .56056 m
.03006 .56056 L
s
[(-0.66)] .01131 .56056 1 0 Mshowa
.125 Mabswid
.02381 .10713 m
.02756 .10713 L
s
.02381 .131 m
.02756 .131 L
s
.02381 .15486 m
.02756 .15486 L
s
.02381 .20259 m
.02756 .20259 L
s
.02381 .22646 m
.02756 .22646 L
s
.02381 .25032 m
.02756 .25032 L
s
.02381 .29805 m
.02756 .29805 L
s
.02381 .32191 m
.02756 .32191 L
s
.02381 .34578 m
.02756 .34578 L
s
.02381 .39351 m
.02756 .39351 L
s
.02381 .41737 m
.02756 .41737 L
s
.02381 .44123 m
.02756 .44123 L
s
.02381 .48896 m
.02756 .48896 L
s
.02381 .51283 m
.02756 .51283 L
s
.02381 .53669 m
.02756 .53669 L
s
.02381 .05941 m
.02756 .05941 L
s
.02381 .03554 m
.02756 .03554 L
s
.02381 .01168 m
.02756 .01168 L
s
.02381 .58442 m
.02756 .58442 L
s
.02381 .60828 m
.02756 .60828 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .01472 Mdot
.11905 .05531 Mdot
.21429 .12626 Mdot
.30952 .21581 Mdot
.5 .4084 Mdot
.97619 .5676 Mdot
.5 Mabswid
.02381 .01472 m
.04262 .01974 L
.06244 .02673 L
.10458 .04689 L
.14264 .07053 L
.18314 .10046 L
.22214 .1331 L
.26358 .171 L
.30351 .20982 L
.34193 .24857 L
.38279 .29055 L
.42214 .33098 L
.45998 .36923 L
.50027 .40866 L
.53904 .44471 L
.58026 .48038 L
.61997 .51155 L
.65817 .53803 L
.69881 .56193 L
.73794 .58026 L
.75791 .5877 L
.77952 .5942 L
.78967 .59667 L
.80039 .59887 L
.81043 .60054 L
.81959 .60173 L
.82413 .6022 L
.82907 .60261 L
.83178 .6028 L
.83428 .60295 L
.83683 .60308 L
.83923 .60317 L
.84126 .60323 L
.84231 .60326 L
.84345 .60328 L
.84464 .6033 L
.84589 .60331 L
.84704 .60332 L
.84812 .60332 L
.84935 .60331 L
.85051 .6033 L
.85155 .60329 L
.85268 .60327 L
.85392 .60324 L
.85522 .60321 L
.85756 .60312 L
.86009 .60301 L
.86249 .60287 L
.867 .60256 L
.87185 .60212 L
Mistroke
.87713 .60154 L
.88664 .60018 L
.89545 .59858 L
.91601 .59351 L
.93463 .58729 L
.97475 .56842 L
.97619 .5676 L
Mfstroke
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`00803oool30000
0?d0oooo000Q0?ooo`<00000o03oool00240oooo00<000000?ooo`3oool01000003h0?ooo`008@3o
ool00`000000oooo0?ooo`040?ooo`800000mP3oool00240oooo00<000000?ooo`3oool01P3oool3
00000?<0oooo000Q0?ooo`030000003oool0oooo00T0oooo0P00003a0?ooo`008@3oool2000000`0
oooo0P00003_0?ooo`008@3oool00`000000oooo0?ooo`0=0?ooo`800000k@3oool00240oooo00<0
00000?ooo`3oool03`3oool200000>/0oooo000Q0?ooo`030000003oool0oooo0140oooo0P00003Y
0?ooo`008@3oool00`000000oooo0?ooo`0C0?ooo`800000i`3oool00240oooo00<000000?ooo`3o
ool05@3oool200000>D0oooo000Q0?ooo`8000005`3oool200000>@0oooo000Q0?ooo`030000003o
ool0oooo01P0oooo0P00003R0?ooo`008@3oool00`000000oooo0?ooo`0J0?ooo`800000h03oool0
0240oooo00<000000?ooo`3oool0703oool00`000000oooo0?ooo`3M0?ooo`00203oool2000000@0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`8000001@3oool00`000000
oooo0?ooo`0M0?ooo`030000003oool0oooo0=`0oooo00070?ooo`040000003oool0oooo000000T0
oooo00<000000?ooo`3oool00P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo
01h0oooo0P00003L0?ooo`001`3oool010000000oooo0?ooo`00000:0?ooo`050000003oool0oooo
0?ooo`0000000P3oool00`000000oooo0?ooo`020?ooo`8000008@3oool00`000000oooo0?ooo`3I
0?ooo`0000<0oooo0000000000000P0000020?ooo`040000003oool0oooo000000X0oooo00@00000
0?ooo`3oool0oooo0`0000050?ooo`030000003oool0oooo0240oooo00<000000?ooo`3oool0f03o
ool000L0oooo00@000000?ooo`3oool000002`3oool010000000oooo0?ooo`0000070?ooo`030000
003oool0oooo0280oooo00<000000?ooo`3oool0e`3oool000L0oooo00@000000?ooo`3oool00000
203oool010000000oooo0?ooo`0000020?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3o
ool08`3oool200000=L0oooo00080?ooo`8000002@3oool4000000<0oooo0`0000040?ooo`030000
003oool0oooo02D0oooo00<000000?ooo`3oool0e03oool00240oooo00<000000?ooo`3oool09P3o
ool00`000000oooo0?ooo`3C0?ooo`008@3oool00`000000oooo0?ooo`0W0?ooo`030000003oool0
oooo0=80oooo000Q0?ooo`800000:@3oool200000=80oooo000Q0?ooo`030000003oool0oooo02X0
oooo00<000000?ooo`3oool0c`3oool00240oooo00<000000?ooo`3oool0:`3oool00`000000oooo
0?ooo`3>0?ooo`008@3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo0<d0oooo000Q
0?ooo`030000003oool0oooo02d0oooo0`00003<0?ooo`008@3oool00`000000oooo0?ooo`0_0?oo
o`030000003oool0oooo0<X0oooo000Q0?ooo`800000<@3oool00`000000oooo0?ooo`390?ooo`00
8@3oool00`000000oooo0?ooo`0a0?ooo`030000003oool0oooo0<P0oooo000Q0?ooo`030000003o
ool0oooo0380oooo00<000000?ooo`3oool0a`3oool00240oooo00<000000?ooo`3oool0<`3oool0
0`000000oooo0?ooo`360?ooo`008@3oool00`000000oooo0?ooo`0d0?ooo`030000003oool0oooo
0<D0oooo000Q0?ooo`030000003oool0oooo03D0oooo0P0000350?ooo`008@3oool2000003P0oooo
00<000000?ooo`3oool0`P3oool00240oooo00<000000?ooo`3oool0>03oool00`000000oooo0?oo
o`310?ooo`008@3oool00`000000oooo0?ooo`0i0?ooo`030000003oool0oooo0<00oooo000Q0?oo
o`030000003oool0oooo03X0oooo00<000000?ooo`3oool0_`3oool000P0oooo0P0000040?ooo`03
0000003oool0oooo00<0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`03
0000003oool0oooo03/0oooo00<000000?ooo`3oool0_P3oool000L0oooo00@000000?ooo`3oool0
00002@3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool0?03oool00`000000oooo0?ooo`2m0?ooo`001`3oool010000000oooo0?ooo`00000:0?ooo`03
0000003oool0oooo00D00000103oool2000003h0oooo00<000000?ooo`3oool0_03oool000030?oo
o`0000000000008000000P3oool010000000oooo0?ooo`00000:0?ooo`040000003oool0oooo0000
0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`0n0?ooo`030000003oool0oooo
0;/0oooo00070?ooo`040000003oool0oooo000000/0oooo00H000000?ooo`3oool000000?ooo`00
00050?ooo`030000003oool0oooo03l0oooo00<000000?ooo`3oool0^P3oool000L0oooo00@00000
0?ooo`3oool00000203oool010000000oooo0?ooo`0000030?ooo`8000001@3oool00`000000oooo
0?ooo`100?ooo`030000003oool0oooo0;T0oooo00080?ooo`8000002@3oool4000000@0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo0;P0oooo000Q
0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool0]`3oool00240oooo0P0000140?oo
o`030000003oool0oooo0;H0oooo000Q0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3o
ool0]@3oool00240oooo00<000000?ooo`3oool0A@3oool00`000000oooo0?ooo`2d0?ooo`008@3o
ool00`000000oooo0?ooo`160?ooo`<00000/`3oool00240oooo00<000000?ooo`3oool0A`3oool2
00000;<0oooo000Q0?ooo`030000003oool0oooo04P0oooo00<000000?ooo`3oool0/@3oool00240
oooo00<000000?ooo`3oool0B@3oool00`000000oooo0?ooo`2`0?ooo`008@3oool2000004/0oooo
00<000000?ooo`3oool0[`3oool00240oooo00<000000?ooo`3oool0B`3oool00`000000oooo0?oo
o`2^0?ooo`008@3oool00`000000oooo0?ooo`1<0?ooo`030000003oool0oooo0:d0oooo000Q0?oo
o`030000003oool0oooo04d0oooo00<000000?ooo`3oool0[03oool00240oooo00<000000?ooo`3o
ool0CP3oool00`000000oooo0?ooo`2[0?ooo`008@3oool00`000000oooo0?ooo`1?0?ooo`030000
003oool0oooo0:X0oooo000Q0?ooo`800000D@3oool00`000000oooo0?ooo`2Y0?ooo`008@3oool0
0`000000oooo0?ooo`1A0?ooo`030000003oool0oooo0:P0oooo000Q0?ooo`030000003oool0oooo
0580oooo00<000000?ooo`3oool0Y`3oool00240oooo00<000000?ooo`3oool0D`3oool00`000000
oooo0?ooo`2V0?ooo`00203oool2000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`020?ooo`@00000103oool00`000000oooo0?ooo`1D0?ooo`030000003oool0oooo0:D0oooo
00070?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`050?ooo`030000003oool0oooo05D0oooo00<000000?ooo`3oool0Y03oool000L0oooo00@0
00000?ooo`3oool000002P3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo00@0oooo
0P00001G0?ooo`030000003oool0oooo0:<0oooo00000`3oool000000000000200000080oooo00@0
00000?ooo`3oool000002P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo
00<000000?ooo`3oool0E`3oool00`000000oooo0?ooo`2R0?ooo`001`3oool010000000oooo0?oo
o`00000;0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`1H0?ooo`030000003oool0oooo0:40oooo00070?ooo`040000003oool0oooo000000P0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo
05T0oooo00<000000?ooo`3oool0X03oool000P0oooo0P0000090?ooo`@000000`3oool2000000D0
oooo00<000000?ooo`3oool0FP3oool00`000000oooo0?ooo`2O0?ooo`008@3oool00`000000oooo
0?ooo`1K0?ooo`030000003oool0oooo09h0oooo000Q0?ooo`800000G@3oool00`000000oooo0?oo
o`2M0?ooo`008@3oool00`000000oooo0?ooo`1M0?ooo`030000003oool0oooo09`0oooo000Q0?oo
o`030000003oool0oooo05h0oooo00<000000?ooo`3oool0V`3oool00240oooo00<000000?ooo`3o
ool0G`3oool00`000000oooo0?ooo`2J0?ooo`008@3oool00`000000oooo0?ooo`1O0?ooo`030000
003oool0oooo09X0oooo000Q0?ooo`030000003oool0oooo0600oooo00<000000?ooo`3oool0V@3o
ool00240oooo0P00001R0?ooo`030000003oool0oooo09P0oooo000Q0?ooo`030000003oool0oooo
0680oooo00<000000?ooo`3oool0U`3oool00240oooo00<000000?ooo`3oool0H`3oool00`000000
oooo0?ooo`2F0?ooo`008@3oool00`000000oooo0?ooo`0Y0?ooo`@000000P3oool4000002P0oooo
100000040?ooo`8000009`3oool4000000<0oooo0P00000Y0?ooo`@000000`3oool2000002P0oooo
100000030?ooo`800000103oool00240oooo00<000000?ooo`3oool0:`3oool01@000000oooo0?oo
o`3oool0000002d0oooo00<000000?ooo`3oool00`3oool00`000000oooo0000000X0?ooo`050000
003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0X0?ooo`050000003oool0oooo0?oo
o`0000000P3oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo00<0oooo00@000000?oo
o`3oool000000`3oool00240oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?ooo`020?oo
o`030000003oool0oooo02X0oooo00<000000?ooo`3oool01@0000000`3oool000000?ooo`0V0?oo
o`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0X0?ooo`050000003oool0
oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0V0?ooo`030000003oool0oooo0080oooo00@0
00000?ooo`3oool000000`3oool00240oooo00<000000?ooo`3oool0:`3oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo02T0oooo00@000000?ooo`3oool000000P3oool01@000000oooo
0?ooo`3oool0000002H0oooo00@000000?ooo`3oool0oooo0`00000[0?ooo`030000003oool0oooo
0080oooo0P00000Z0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`01
0?ooo`008@3oool2000002`0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`0X0?oo
o`070000003oool0oooo0?ooo`000000oooo000000040?ooo`030000003oool0oooo02<0oooo00D0
00000?ooo`3oool0oooo0000000]0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`0X0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00@3oool00240
oooo00<000000?ooo`3oool0:@3oool3000000<0oooo00@000000?ooo`3oool00000:03oool30000
00@0oooo0P0000050?ooo`030000003oool0oooo0200oooo0`0000030?ooo`030000003oool0oooo
02T0oooo0`0000030?ooo`040000003oool0oooo000002L0oooo00@000000?ooo`3oool000000P3o
ool010000000oooo0?ooo`0000030?ooo`008@3oool00`000000oooo0?ooo`0[0?ooo`030000003o
ool0oooo0080oooo0P00000[0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0103o
ool00`000000oooo0?ooo`0Q0?ooo`030000003oool0oooo0080oooo0`00000Z0?ooo`030000003o
ool0oooo0080oooo0P00000Y0?ooo`800000103oool2000000@0oooo000Q0?ooo`030000003oool0
oooo06/0oooo00<000000?ooo`3oool0SP3oool00240oooo00<000000?ooo`3oool0K03oool00`00
0000oooo0?ooo`2=0?ooo`008@3oool00`000000oooo0?ooo`1]0?ooo`030000003oool0oooo08`0
oooo000K0?ooool000001P0000000240oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0:0?ooo`030000003oool0oooo00T0oooo00@000000?ooo`3oool000002@3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`090?ooo`030000003oool0oooo00D0oooo000Q0?ooo`030000003oool0oooo0700oooo00<0
00000?ooo`3oool0R@3oool00240oooo00<000000?ooo`3oool0L@3oool00`000000oooo0?ooo`28
0?ooo`008@3oool00`000000oooo0?ooo`1b0?ooo`030000003oool0oooo08L0oooo000Q0?ooo`03
0000003oool0oooo07<0oooo0P0000270?ooo`008@3oool2000007H0oooo00<000000?ooo`3oool0
Q03oool00240oooo00<000000?ooo`3oool0MP3oool00`000000oooo0?ooo`230?ooo`008@3oool0
0`000000oooo0?ooo`1g0?ooo`030000003oool0oooo0880oooo000Q0?ooo`030000003oool0oooo
07P0oooo0P0000220?ooo`008@3oool00`000000oooo0?ooo`1i0?ooo`030000003oool0oooo0800
oooo000Q0?ooo`030000003oool0oooo07X0oooo00<000000?ooo`3oool0O`3oool00240oooo0P00
001l0?ooo`030000003oool0oooo07h0oooo000Q0?ooo`030000003oool0oooo07`0oooo00<00000
0?ooo`3oool0O@3oool00240oooo00<000000?ooo`3oool0O@3oool00`000000oooo0?ooo`1l0?oo
o`008@3oool00`000000oooo0?ooo`1n0?ooo`800000O03oool00240oooo00<000000?ooo`3oool0
P03oool00`000000oooo0?ooo`1i0?ooo`008@3oool00`000000oooo0?ooo`210?ooo`030000003o
ool0oooo07P0oooo000Q0?ooo`800000P`3oool00`000000oooo0?ooo`1g0?ooo`008@3oool00`00
0000oooo0?ooo`230?ooo`030000003oool0oooo07H0oooo000Q0?ooo`030000003oool0oooo08@0
oooo00<000000?ooo`3oool0M@3oool00240oooo00<000000?ooo`3oool0Q@3oool00`000000oooo
0?ooo`1d0?ooo`008@3oool00`000000oooo0?ooo`260?ooo`030000003oool0oooo07<0oooo0008
0?ooo`800000103oool00`000000oooo0?ooo`030?ooo`800000103oool2000000D0oooo00<00000
0?ooo`3oool0Q`3oool00`000000oooo0?ooo`1b0?ooo`001`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo
0?ooo`280?ooo`030000003oool0oooo0740oooo00070?ooo`040000003oool0oooo000000P0oooo
00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000040?ooo`800000RP3oool00`00
0000oooo0?ooo`1`0?ooo`0000<0oooo0000000000000P0000020?ooo`040000003oool0oooo0000
00P0oooo0`0000040?ooo`8000001@3oool00`000000oooo0?ooo`2:0?ooo`030000003oool0oooo
06l0oooo00070?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool00`3oool01000
0000oooo0?ooo`0000040?ooo`030000003oool0oooo08/0oooo00<000000?ooo`3oool0KP3oool0
00L0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?ooo`030?ooo`040000003oool0
oooo000000@0oooo00<000000?ooo`3oool0S03oool00`000000oooo0?ooo`1]0?ooo`00203oool2
000000X0oooo0`0000030?ooo`8000001@3oool00`000000oooo0?ooo`2=0?ooo`030000003oool0
oooo06`0oooo000Q0?ooo`030000003oool0oooo08h0oooo0P00001/0?ooo`008@3oool200000940
oooo00<000000?ooo`3oool0J@3oool00240oooo00<000000?ooo`3oool0T@3oool00`000000oooo
0?ooo`1X0?ooo`008@3oool00`000000oooo0?ooo`2B0?ooo`800000J03oool00240oooo00<00000
0?ooo`3oool0U03oool00`000000oooo0?ooo`1U0?ooo`008@3oool00`000000oooo0?ooo`2E0?oo
o`030000003oool0oooo06@0oooo000Q0?ooo`030000003oool0oooo09H0oooo0P00001T0?ooo`00
8@3oool2000009T0oooo00<000000?ooo`3oool0H@3oool00240oooo00<000000?ooo`3oool0V@3o
ool200000640oooo000Q0?ooo`030000003oool0oooo09/0oooo00<000000?ooo`3oool0GP3oool0
0240oooo00<000000?ooo`3oool0W03oool00`000000oooo0?ooo`1M0?ooo`008@3oool00`000000
oooo0?ooo`2M0?ooo`800000G@3oool00240oooo00<000000?ooo`3oool0W`3oool00`000000oooo
0?ooo`1J0?ooo`008@3oool200000:40oooo0P00001J0?ooo`008@3oool00`000000oooo0?ooo`2R
0?ooo`030000003oool0oooo05L0oooo000Q0?ooo`030000003oool0oooo0:<0oooo0P00001G0?oo
o`008@3oool00`000000oooo0?ooo`2U0?ooo`800000E@3oool000P0oooo0P0000040?ooo`030000
003oool0oooo00<0oooo0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`2W0?ooo`030000
003oool0oooo0580oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0:P0oooo0P00001B0?oo
o`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080oooo00@00000
0?ooo`3oool00000103oool200000:/0oooo0P00001@0?ooo`0000<0oooo0000000000000P000002
0?ooo`040000003oool0oooo000000P0oooo0`0000030?ooo`<000001@3oool00`000000oooo0?oo
o`2/0?ooo`030000003oool0oooo04d0oooo00070?ooo`040000003oool0oooo000000P0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`050?ooo`030000003oool0oooo0:d0oooo0P00
00140?ooo`<000001P3oool000L0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?oo
o`030?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0[`3oool200000400oooo0P00
00020?ooo`030000003oool0oooo00@0oooo00080?ooo`8000002P3oool3000000<0oooo0`000004
0?ooo`030000003oool0oooo0;40oooo0P00000l0?ooo`8000002`3oool00240oooo00<000000?oo
o`3oool0/`3oool2000003P0oooo0P00000=0?ooo`008@3oool00`000000oooo0?ooo`2e0?ooo`@0
0000<P3oool2000000l0oooo000Q0?ooo`800000^P3oool5000002/0oooo0P00000A0?ooo`008@3o
ool00`000000oooo0?ooo`2n0?ooo`8000009`3oool2000001<0oooo000Q0?ooo`030000003oool0
oooo0<00oooo0`00000O0?ooo`D000005@3oool00240oooo00<000000?ooo`3oool0``3oool50000
01H0oooo1000000J0?ooo`008@3oool00`000000oooo0?ooo`380?ooo`X000000`3oool9000001h0
oooo000Q0?ooo`030000003oool0oooo0=40oooo1@00000V0?ooo`008@3oool200000?d0oooo000Q
0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo003o0?ooob40
oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40
oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {8.65687, -0.784012, \
0.0403944, 0.000806033}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[pp]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.0952381 3.94942 5.08121 [
[.21429 .38007 -6 -9 ]
[.21429 .38007 6 0 ]
[.40476 .38007 -6 -9 ]
[.40476 .38007 6 0 ]
[.59524 .38007 -6 -9 ]
[.59524 .38007 6 0 ]
[.78571 .38007 -6 -9 ]
[.78571 .38007 6 0 ]
[.97619 .38007 -6 -9 ]
[.97619 .38007 6 0 ]
[.01131 .0877 -30 -4.5 ]
[.01131 .0877 0 4.5 ]
[.01131 .18932 -30 -4.5 ]
[.01131 .18932 0 4.5 ]
[.01131 .29095 -30 -4.5 ]
[.01131 .29095 0 4.5 ]
[.01131 .4942 -30 -4.5 ]
[.01131 .4942 0 4.5 ]
[.01131 .59582 -30 -4.5 ]
[.01131 .59582 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .39257 m
.21429 .39882 L
s
[(12)] .21429 .38007 0 1 Mshowa
.40476 .39257 m
.40476 .39882 L
s
[(14)] .40476 .38007 0 1 Mshowa
.59524 .39257 m
.59524 .39882 L
s
[(16)] .59524 .38007 0 1 Mshowa
.78571 .39257 m
.78571 .39882 L
s
[(18)] .78571 .38007 0 1 Mshowa
.97619 .39257 m
.97619 .39882 L
s
[(20)] .97619 .38007 0 1 Mshowa
.125 Mabswid
.07143 .39257 m
.07143 .39632 L
s
.11905 .39257 m
.11905 .39632 L
s
.16667 .39257 m
.16667 .39632 L
s
.2619 .39257 m
.2619 .39632 L
s
.30952 .39257 m
.30952 .39632 L
s
.35714 .39257 m
.35714 .39632 L
s
.45238 .39257 m
.45238 .39632 L
s
.5 .39257 m
.5 .39632 L
s
.54762 .39257 m
.54762 .39632 L
s
.64286 .39257 m
.64286 .39632 L
s
.69048 .39257 m
.69048 .39632 L
s
.7381 .39257 m
.7381 .39632 L
s
.83333 .39257 m
.83333 .39632 L
s
.88095 .39257 m
.88095 .39632 L
s
.92857 .39257 m
.92857 .39632 L
s
.25 Mabswid
0 .39257 m
1 .39257 L
s
.02381 .0877 m
.03006 .0877 L
s
[(-0.76)] .01131 .0877 1 0 Mshowa
.02381 .18932 m
.03006 .18932 L
s
[(-0.74)] .01131 .18932 1 0 Mshowa
.02381 .29095 m
.03006 .29095 L
s
[(-0.72)] .01131 .29095 1 0 Mshowa
.02381 .4942 m
.03006 .4942 L
s
[(-0.68)] .01131 .4942 1 0 Mshowa
.02381 .59582 m
.03006 .59582 L
s
[(-0.66)] .01131 .59582 1 0 Mshowa
.125 Mabswid
.02381 .1131 m
.02756 .1131 L
s
.02381 .13851 m
.02756 .13851 L
s
.02381 .16392 m
.02756 .16392 L
s
.02381 .21473 m
.02756 .21473 L
s
.02381 .24014 m
.02756 .24014 L
s
.02381 .26554 m
.02756 .26554 L
s
.02381 .31635 m
.02756 .31635 L
s
.02381 .34176 m
.02756 .34176 L
s
.02381 .36717 m
.02756 .36717 L
s
.02381 .41798 m
.02756 .41798 L
s
.02381 .44338 m
.02756 .44338 L
s
.02381 .46879 m
.02756 .46879 L
s
.02381 .5196 m
.02756 .5196 L
s
.02381 .54501 m
.02756 .54501 L
s
.02381 .57041 m
.02756 .57041 L
s
.02381 .06229 m
.02756 .06229 L
s
.02381 .03689 m
.02756 .03689 L
s
.02381 .01148 m
.02756 .01148 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .01472 Mdot
.11905 .05794 Mdot
.21429 .13347 Mdot
.30952 .22881 Mdot
.5 .43384 Mdot
.97619 .60332 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`00803oool30000
0?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo
000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?oo
o`030000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo00<000000?ooo`3oool0
o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool0
0240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool05@3oool200000>D0
oooo000Q0?ooo`030000003oool0oooo01H0oooo00<000000?ooo`3oool0h`3oool00240oooo0P00
003m0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`00203o
ool2000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`030?ooo`8000001@3o
ool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`0000090?ooo`030000003o
ool0oooo0080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3l0?ooo`001`3o
ool010000000oooo0?ooo`00000:0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`020?ooo`800000o@3oool000030?ooo`0000000000008000000P3oool010000000oooo
0?ooo`00000:0?ooo`040000003oool0oooo0?ooo`<000001@3oool00`000000oooo0?ooo`3l0?oo
o`001`3oool010000000oooo0?ooo`00000;0?ooo`040000003oool0oooo000000L0oooo00<00000
0?ooo`3oool0o03oool000L0oooo00@000000?ooo`3oool00000203oool010000000oooo0?ooo`00
00020?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0o03oool000P0oooo0P000009
0?ooo`@000000`3oool3000000@0oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?oo
o`3oool0o03oool00240oooo0P00003m0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`00
0000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`0^0?ooo`800000c03oool00240oooo
00<000000?ooo`3oool0;`3oool00`000000oooo0?ooo`3:0?ooo`008@3oool200000?d0oooo000Q
0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`03
0000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003o
ool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo00<000000?ooo`3oool0o03oool00240
oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<0
00000?ooo`3oool0o03oool000P0oooo0P0000040?ooo`030000003oool0oooo00<0oooo00<00000
0?ooo`3oool0103oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0?`0oooo00070?oo
o`040000003oool0oooo000000T0oooo00<000000?ooo`3oool0103oool00`000000oooo0?ooo`03
0?ooo`030000003oool0oooo0?`0oooo00070?ooo`040000003oool0oooo000000X0oooo00<00000
0?ooo`3oool01@0000040?ooo`800000o@3oool000030?ooo`0000000000008000000P3oool01000
0000oooo0?ooo`00000:0?ooo`040000003oool0oooo00000080oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`00000;0?ooo`060000003o
ool0oooo0000003oool000001@3oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo
0?ooo`0000080?ooo`040000003oool0oooo000000<0oooo0P0000050?ooo`030000003oool0oooo
0?`0oooo00080?ooo`8000002@3oool4000000@0oooo00<000000?ooo`3oool00`3oool00`000000
oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?oo
o`3l0?ooo`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`03
0000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo04L0oooo0P00002c0?ooo`008@3o
ool00`000000oooo0?ooo`180?ooo`030000003oool0oooo0;40oooo000Q0?ooo`030000003oool0
oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo00<000000?ooo`3oool0o03oool00240oooo
00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<00000
0?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3o
ool0o03oool00240oooo0P00003m0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool0
0`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`00203oool2000000@0
oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`@00000103oool00`000000
oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`0000090?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo
0?ooo`00000:0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0103oool200000?d0
oooo00000`3oool000000000000200000080oooo00@000000?ooo`3oool000002P3oool00`000000
oooo0?ooo`030?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool0o03oool000L0oooo
00@000000?ooo`3oool000002`3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo0080
oooo00<000000?ooo`3oool0o03oool000L0oooo00@000000?ooo`3oool00000203oool010000000
oooo0?ooo`0000020?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0o03oool0
00P0oooo0P0000090?ooo`@000000`3oool2000000D0oooo00<000000?ooo`3oool0o03oool00240
oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00
003m0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool20000
0?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo02T0oooo
100000020?ooo`@00000:03oool4000000@0oooo00<000000?ooo`3oool09P3oool4000000<0oooo
0P00000Y0?ooo`@000000`3oool2000002P0oooo100000030?ooo`800000103oool00240oooo00<0
00000?ooo`3oool0:`3oool01@000000oooo0?ooo`3oool0000002d0oooo00<000000?ooo`3oool0
0`3oool00`000000oooo0?ooo`0X0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000
oooo0?ooo`0X0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0U0?oo
o`030000003oool0oooo00<0oooo00@000000?ooo`3oool000000`3oool00240oooo00<000000?oo
o`3oool0:`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo02X0oooo00<000000?oo
o`3oool01@00000Y0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0X
0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0V0?ooo`030000003o
ool0oooo0080oooo00@000000?ooo`3oool000000`3oool00240oooo00<000000?ooo`3oool0:`3o
ool00`000000oooo0?ooo`030?ooo`030000003oool0oooo02T0oooo00@000000?ooo`3oool00000
0P3oool00`000000oooo0?ooo`0X0?ooo`040000003oool0oooo0?ooo`<00000:`3oool00`000000
oooo0?ooo`020?ooo`800000:P3oool01@000000oooo0?ooo`3oool000000080oooo00<000000?oo
o`3oool00@3oool00240oooo0P00000/0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3o
ool0:03oool01`000000oooo0?ooo`3oool000000?ooo`000000:P3oool01@000000oooo0?ooo`3o
ool0000002d0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo02P0oooo
00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`010?ooo`008@3oool00`000000oooo
0?ooo`0Y0?ooo`<000000`3oool010000000oooo0?ooo`00000X0?ooo`<00000103oool2000002P0
oooo0`0000030?ooo`030000003oool0oooo02T0oooo0`0000030?ooo`040000003oool0oooo0000
02L0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`008@3oool0
0`000000oooo0?ooo`0[0?ooo`030000003oool0oooo0080oooo0P00000[0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0:03oool00`000000oooo0?ooo`020?ooo`<00000:P3oool0
0`000000oooo0?ooo`020?ooo`800000:@3oool2000000@0oooo0P0000040?ooo`008@3oool00`00
0000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo
0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`006`3ooooo000000H00000000Q0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00X0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0:0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`050?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3o
ool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool20000
0?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo
000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo07P0oooo0P000022
0?ooo`008@3oool00`000000oooo0?ooo`1i0?ooo`030000003oool0oooo0800oooo000Q0?ooo`03
0000003oool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo00<000000?ooo`3oool0o03o
ool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240
oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<0
00000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`008@3oool00`000000oooo0?ooo`3l0?oo
o`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`00203o
ool2000000@0oooo00<000000?ooo`3oool00`3oool2000000@0oooo0P0000050?ooo`030000003o
ool0oooo0?`0oooo00070?ooo`040000003oool0oooo000000P0oooo00@000000?ooo`3oool00000
0P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?`0oooo00070?ooo`040000
003oool0oooo000000P0oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`000004
0?ooo`800000o@3oool000030?ooo`0000000000008000000P3oool010000000oooo0?ooo`000008
0?ooo`<00000103oool2000000D0oooo00<000000?ooo`3oool0o03oool000L0oooo00@000000?oo
o`3oool00000203oool00`000000oooo0?ooo`030?ooo`040000003oool0oooo000000@0oooo00<0
00000?ooo`3oool0o03oool000L0oooo00@000000?ooo`3oool00000203oool00`000000oooo0?oo
o`030?ooo`040000003oool0oooo000000@0oooo00<000000?ooo`3oool0o03oool000P0oooo0P00
000:0?ooo`<000000`3oool2000000D0oooo00<000000?ooo`3oool0o03oool00240oooo00<00000
0?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo0P00003m0?ooo`00
8@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool0
0`000000oooo0?ooo`3l0?ooo`008@3oool00`000000oooo0?ooo`3l0?ooo`008@3oool00`000000
oooo0?ooo`3l0?ooo`008@3oool200000?d0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q
0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`03
0000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003o
ool0oooo0?`0oooo000Q0?ooo`800000o@3oool00240oooo00<000000?ooo`3oool0o03oool00240
oooo00<000000?ooo`3oool0o03oool00240oooo00<000000?ooo`3oool0o03oool00240oooo00<0
00000?ooo`3oool0o03oool000P0oooo0P0000040?ooo`030000003oool0oooo00<0oooo0P000004
0?ooo`8000001@3oool00`000000oooo0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`000008
0?ooo`040000003oool0oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo
0?ooo`3l0?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`040000003oool0oooo00000080
oooo00@000000?ooo`3oool00000103oool200000?d0oooo00000`3oool000000000000200000080
oooo00@000000?ooo`3oool00000203oool3000000<0oooo0`0000050?ooo`030000003oool0oooo
0?@0oooo0P0000060?ooo`001`3oool010000000oooo0?ooo`0000080?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool01@3oool00`000000oooo0?ooo`3e0?ooo`030000003oool0oooo
00@0oooo00070?ooo`040000003oool0oooo000000P0oooo00<000000?ooo`3oool00`3oool00`00
0000oooo0?ooo`050?ooo`030000003oool0oooo0?`0oooo00080?ooo`8000002P3oool3000000<0
oooo0`0000040?ooo`030000003oool0oooo0?`0oooo000Q0?ooo`030000003oool0oooo0?`0oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {8.65687, -0.783426, \
0.0403944, 0.000757119}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fpi = {{20/2, 0.307445874007}, {22/2, 0.313094050933}, {24/2, 
          0.316927779486}, {26/2, 0.319417858580}, {30/2, 
          0.322884122033}, {40/2, 0.348940506181}}\)], "Input"],

Cell[BoxData[
    \({{10, 0.307445874007`}, {11, 0.313094050933`}, {12, 
        0.316927779486`}, {13, 0.31941785858`}, {15, 0.322884122033`}, {20, 
        0.348940506181`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(meanfpi = Apply[Plus, Map[Last, fpi]]/Length[fpi]\)], "Input"],

Cell[BoxData[
    \(0.32145169853666666`\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[{#[\([1]\)], 5 \((#[\([2]\)]/meanfpi - 1)\)} &, fpi]\)], "Input"],

Cell[BoxData[
    \({{10, \(-0.217852706851836`\)}, {11, \(-0.12999849809027075`\)}, {12, \
\(-0.07036701114445432`\)}, {13, \(-0.03163523425020409`\)}, {15, 
        0.022280540169083984`}, {20, 0.4275729101676806`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(ListPlot[fpi]\)], "Input"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: .61803 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
-0.928571 0.0952381 -4.34642 14.1851 [
[.21429 .03845 -6 -9 ]
[.21429 .03845 6 0 ]
[.40476 .03845 -6 -9 ]
[.40476 .03845 6 0 ]
[.59524 .03845 -6 -9 ]
[.59524 .03845 6 0 ]
[.78571 .03845 -6 -9 ]
[.78571 .03845 6 0 ]
[.97619 .03845 -6 -9 ]
[.97619 .03845 6 0 ]
[.01131 .1928 -24 -4.5 ]
[.01131 .1928 0 4.5 ]
[.01131 .33465 -24 -4.5 ]
[.01131 .33465 0 4.5 ]
[.01131 .4765 -24 -4.5 ]
[.01131 .4765 0 4.5 ]
[ 0 0 0 0 ]
[ 1 .61803 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.21429 .05095 m
.21429 .0572 L
s
[(12)] .21429 .03845 0 1 Mshowa
.40476 .05095 m
.40476 .0572 L
s
[(14)] .40476 .03845 0 1 Mshowa
.59524 .05095 m
.59524 .0572 L
s
[(16)] .59524 .03845 0 1 Mshowa
.78571 .05095 m
.78571 .0572 L
s
[(18)] .78571 .03845 0 1 Mshowa
.97619 .05095 m
.97619 .0572 L
s
[(20)] .97619 .03845 0 1 Mshowa
.125 Mabswid
.07143 .05095 m
.07143 .0547 L
s
.11905 .05095 m
.11905 .0547 L
s
.16667 .05095 m
.16667 .0547 L
s
.2619 .05095 m
.2619 .0547 L
s
.30952 .05095 m
.30952 .0547 L
s
.35714 .05095 m
.35714 .0547 L
s
.45238 .05095 m
.45238 .0547 L
s
.5 .05095 m
.5 .0547 L
s
.54762 .05095 m
.54762 .0547 L
s
.64286 .05095 m
.64286 .0547 L
s
.69048 .05095 m
.69048 .0547 L
s
.7381 .05095 m
.7381 .0547 L
s
.83333 .05095 m
.83333 .0547 L
s
.88095 .05095 m
.88095 .0547 L
s
.92857 .05095 m
.92857 .0547 L
s
.25 Mabswid
0 .05095 m
1 .05095 L
s
.02381 .1928 m
.03006 .1928 L
s
[(0.32)] .01131 .1928 1 0 Mshowa
.02381 .33465 m
.03006 .33465 L
s
[(0.33)] .01131 .33465 1 0 Mshowa
.02381 .4765 m
.03006 .4765 L
s
[(0.34)] .01131 .4765 1 0 Mshowa
.125 Mabswid
.02381 .07932 m
.02756 .07932 L
s
.02381 .10769 m
.02756 .10769 L
s
.02381 .13606 m
.02756 .13606 L
s
.02381 .16443 m
.02756 .16443 L
s
.02381 .22117 m
.02756 .22117 L
s
.02381 .24954 m
.02756 .24954 L
s
.02381 .27791 m
.02756 .27791 L
s
.02381 .30628 m
.02756 .30628 L
s
.02381 .36302 m
.02756 .36302 L
s
.02381 .39139 m
.02756 .39139 L
s
.02381 .41976 m
.02756 .41976 L
s
.02381 .44813 m
.02756 .44813 L
s
.02381 .50487 m
.02756 .50487 L
s
.02381 .53324 m
.02756 .53324 L
s
.02381 .56161 m
.02756 .56161 L
s
.02381 .58998 m
.02756 .58998 L
s
.02381 .02258 m
.02756 .02258 L
s
.25 Mabswid
.02381 0 m
.02381 .61803 L
s
0 0 m
1 0 L
1 .61803 L
0 .61803 L
closepath
clip
newpath
.008 w
.02381 .01472 Mdot
.11905 .09483 Mdot
.21429 .14922 Mdot
.30952 .18454 Mdot
.5 .23371 Mdot
.97619 .60332 Mdot
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{288, 177.938},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004P0000/B000`400?l00000o`00003oo`3ooolQ
0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ0?ooo`00o`3ooolQ
0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0
oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006P3oool2000002`0oooo1000
00020?ooo`@00000:@3oool4000000@0oooo00<000000?ooo`3oool0:03oool4000000<0oooo0P00
000Y0?ooo`@000000`3oool2000002X0oooo100000030?ooo`800000103oool001/0oooo00<00000
0?ooo`3oool0;03oool01@000000oooo0?ooo`3oool0000002h0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`0Z0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo
0?ooo`0X0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0W0?ooo`03
0000003oool0oooo00<0oooo00@000000?ooo`3oool000000`3oool001/0oooo00<000000?ooo`3o
ool0;03oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo02/0oooo00<000000?ooo`3o
ool01@00000[0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0X0?oo
o`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`0X0?ooo`030000003oool0
oooo0080oooo00@000000?ooo`3oool000000`3oool001/0oooo0P00000]0?ooo`030000003oool0
oooo00<0oooo00<000000?ooo`3oool0:P3oool010000000oooo0?ooo`0000020?ooo`030000003o
ool0oooo02X0oooo00@000000?ooo`3oool0oooo0`00000[0?ooo`030000003oool0oooo0080oooo
0P00000/0?ooo`050000003oool0oooo0?ooo`0000000P3oool00`000000oooo0?ooo`010?ooo`00
6`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo00@0oooo00<000000?ooo`3oool0
:@3oool01`000000oooo0?ooo`3oool000000?ooo`000000;03oool01@000000oooo0?ooo`3oool0
000002d0oooo00D000000?ooo`3oool0oooo000000020?ooo`030000003oool0oooo02X0oooo00@0
00000?ooo`3oool000000P3oool00`000000oooo0?ooo`010?ooo`006`3oool00`000000oooo0?oo
o`0Z0?ooo`<000000`3oool010000000oooo0?ooo`00000Y0?ooo`<00000103oool2000002X0oooo
0`0000030?ooo`030000003oool0oooo02T0oooo0`0000030?ooo`040000003oool0oooo000002T0
oooo00@000000?ooo`3oool000000P3oool010000000oooo0?ooo`0000030?ooo`006`3oool00`00
0000oooo0?ooo`0/0?ooo`030000003oool0oooo0080oooo0P00000/0?ooo`030000003oool0oooo
00<0oooo00<000000?ooo`3oool0:P3oool00`000000oooo0?ooo`020?ooo`<00000:P3oool00`00
0000oooo0?ooo`020?ooo`800000:`3oool2000000@0oooo0P0000040?ooo`006`3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<0
00000?ooo`3oool0o`3oool30?ooo`00503ooooo000000d00000000K0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`0:0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool02P3oool00`000000oooo0?ooo`050?ooo`006`3oool00`000000
oooo0?ooo`0_0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool0<03oool00`000000
oooo0?ooo`0_0?ooo`030000003oool0oooo0300oooo00<000000?ooo`3oool01@3oool001/0oooo
00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K
0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?oo
o`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool40?ooo`006`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool0
01/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`0F0?ooo`80
0000jP3oool001/0oooo00<000000?ooo`3oool05`3oool00`000000oooo0?ooo`3X0?ooo`006`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool40?ooo`006`3oool00`00
0000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo
00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K
0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?oo
o`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool40?ooo`006`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool0
01/0oooo00<000000?ooo`3oool0;`3oool200000=40oooo000K0?ooo`030000003oool0oooo0300
oooo00<000000?ooo`3oool0c`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool0
01/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo
00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K
0?ooo`030000003oool0oooo04P0oooo0P00002h0?ooo`000P3oool2000000@0oooo00<000000?oo
o`3oool00`3oool2000000<0oooo100000040?ooo`030000003oool0oooo04T0oooo00<000000?oo
o`3oool0]P3oool000050?ooo`000000oooo0?ooo`000000203oool010000000oooo0?ooo`000002
0?ooo`030000003oool0oooo00D0oooo00<000000?ooo`3oool0o`3oool30?ooo`0000D0oooo0000
003oool0oooo0000000;0?ooo`050000003oool0oooo0?ooo`0000001P3oool200000?l0oooo103o
ool000050?ooo`000000oooo0?ooo`0000002@3oool2000000D0oooo00<000000?ooo`3oool00`3o
ool00`000000oooo0?ooo`3o0?ooo`<0oooo00001@3oool000000?ooo`3oool0000000/0oooo00<0
00000?ooo`3oool00`3oool00`000000oooo0?ooo`020?ooo`030000003oool0oooo0?l0oooo0`3o
ool000050?ooo`000000oooo0?ooo`000000203oool010000000oooo0?ooo`0000020?ooo`040000
003oool0oooo000000@0oooo00<000000?ooo`3oool0o`3oool30?ooo`000P3oool2000000X0oooo
0P0000040?ooo`8000001@3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003o
ool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`00
0000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool40?ooo`006`3oool00`000000oooo
0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<00000
0?ooo`3oool0N`3oool2000008D0oooo000K0?ooo`030000003oool0oooo07`0oooo00<000000?oo
o`3oool0P`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo
0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool40?ooo`006`3oool00`000000oooo0?ooo`3o
0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3o
ool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003o
ool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`00
0000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool40?ooo`006`3oool00`000000oooo
0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<00000
0?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`03
0000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3o
ool200000?l0oooo103oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`00
0000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo
00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo0002
0?ooo`800000103oool00`000000oooo0?ooo`030?ooo`800000103oool2000000D0oooo00<00000
0?ooo`3oool0o`3oool30?ooo`0000D0oooo0000003oool0oooo000000080?ooo`040000003oool0
oooo00000080oooo00@000000?ooo`3oool00000103oool00`000000oooo0?ooo`3o0?ooo`<0oooo
00001@3oool000000?ooo`3oool0000000/0oooo00<000000?ooo`3oool00`3oool00`000000oooo
0?ooo`020?ooo`800000o`3oool40?ooo`0000D0oooo0000003oool0oooo000000090?ooo`800000
103oool2000000D0oooo00<000000?ooo`3oool0o`3oool30?ooo`0000D0oooo0000003oool0oooo
0000000;0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3oool00P3oool00`000000oooo
0?ooo`3o0?ooo`<0oooo00001@3oool000000?ooo`3oool0000000P0oooo00@000000?ooo`3oool0
00000P3oool010000000oooo0?ooo`0000040?ooo`030000003oool0oooo0?l0oooo0`3oool00080
oooo0P00000:0?ooo`800000103oool2000000D0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
6`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3o
ool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0
oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo
000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool3
0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0
oooo0`3oool001/0oooo0P00003o0?ooo`@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3o
ool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?oo
o`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0
o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000o`3oool4
0?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0
oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?oo
o`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?oo
o`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000
o`3oool40?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0
oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool00080oooo0P00
00040?ooo`030000003oool0oooo00<0oooo0P0000050?ooo`030000003oool0oooo00<0oooo00<0
00000?ooo`3oool0o`3oool30?ooo`0000D0oooo0000003oool0oooo000000080?ooo`040000003o
ool0oooo000000@0oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo
00001@3oool000000?ooo`3oool0000000/0oooo00<000000?ooo`000000100000040?ooo`800000
o`3oool40?ooo`0000D0oooo0000003oool0oooo000000090?ooo`8000000P3oool010000000oooo
0?ooo`0000050?ooo`030000003oool0oooo0?l0oooo0`3oool000050?ooo`000000oooo0?ooo`00
00002`3oool01P000000oooo0?ooo`000000oooo000000D0oooo00<000000?ooo`3oool0o`3oool3
0?ooo`0000D0oooo0000003oool0oooo000000080?ooo`040000003oool0oooo000000<0oooo0P00
00050?ooo`030000003oool0oooo0?l0oooo0`3oool00080oooo0P00000:0?ooo`8000001@3oool0
0`000000oooo0?ooo`030?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?oo
o`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`800000
o`3oool40?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0
oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000
oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<0
00000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?oo
o`800000o`3oool40?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000
003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool0
0`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0
oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool200000?l0oooo103oool001/0oooo00<0
00000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?oo
o`030000003oool0oooo0?l0oooo0`3oool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`00
6`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3o
ool001/0oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool200000?l0oooo103oool001/0
oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo
000K0?ooo`030000003oool0oooo0?X0oooo0P0000060?ooo`006`3oool00`000000oooo0?ooo`3k
0?ooo`030000003oool0oooo00@0oooo000K0?ooo`030000003oool0oooo0?l0oooo0`3oool001/0
oooo00<000000?ooo`3oool0o`3oool30?ooo`006`3oool00`000000oooo0?ooo`3o0?ooo`<0oooo
003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo003o0?ooob40oooo
003o0?ooob40oooo0000\
\>"],
  ImageRangeCache->{{{0, 287}, {176.938, 0}} -> {8.92135, 0.304746, \
0.0394728, 0.000265019}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
WindowSize->{520, 600},
WindowMargins->{{Automatic, 53}, {Automatic, 50}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "bvds", \
"four"}, "kappa_5.nb.ps", CharacterEncoding -> "ISO8859-1"],
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 48, 0, 156, "Title"],

Cell[CellGroupData[{
Cell[1812, 55, 511, 8, 139, "Input"],
Cell[2326, 65, 511, 9, 95, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[2874, 79, 65, 1, 27, "Input"],
Cell[2942, 82, 154, 3, 43, "Output"]
}, Open  ]],
Cell[3111, 88, 140, 3, 43, "Input"],

Cell[CellGroupData[{
Cell[3276, 95, 78, 1, 27, "Input"],
Cell[3357, 98, 58, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3452, 104, 67, 1, 27, "Input"],
Cell[3522, 107, 230, 3, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3789, 115, 207, 3, 59, "Input"],
Cell[3999, 120, 18703, 466, 186, 4082, 281, "GraphicsData", "PostScript", \
"Graphics"],
Cell[22705, 588, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[22872, 596, 45, 1, 27, "Input"],
Cell[22920, 599, 14394, 359, 186, 3082, 215, "GraphicsData", "PostScript", \
"Graphics"],
Cell[37317, 960, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37484, 968, 205, 3, 59, "Input"],
Cell[37692, 973, 189, 3, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[37918, 981, 82, 1, 27, "Input"],
Cell[38003, 984, 54, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38094, 990, 89, 1, 27, "Input"],
Cell[38186, 993, 231, 3, 43, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[38454, 1001, 46, 1, 27, "Input"],
Cell[38503, 1004, 14073, 344, 186, 2794, 200, "GraphicsData", "PostScript", \
"Graphics"],
Cell[52579, 1350, 130, 3, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

