(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     89281,       2385]*)
(*NotebookOutlinePosition[     90632,       2426]*)
(*  CellTagsIndexPosition[     90588,       2422]*)
(*WindowFrame->Normal*)



Notebook[{
Cell[BoxData[
    \(<< Graphics`MultipleListPlot`\)], "Input",
  InitializationCell->True],

Cell["Teper ", "Text"],

Cell[BoxData[
    \(\(opp = 
        Map[{{1/#[\([1]\)]^2, #[\([2]\)]}, ErrorBar[#[\([3]\)]]} &, {{2, 
              3.78, 0.07}, {3, 3.55, 0.07}, {4, 3.36, 0.06}, {4, 3.56, 
              0.11}, {6, 3.25, 0.09}, {8, 3.55, 0.12}}];\)\)], "Input"],

Cell[BoxData[
    \(\(tpp = 
        Map[{{1/#[\([1]\)]^2, #[\([2]\)]}, ErrorBar[#[\([3]\)]]} &, {{2, 
              5.45, 0.11}, {3, 4.78, 0.09}, {4 - 0.05, 4.88, 
              0.11}, {4 + 0.05, 4.85, 0.16}, {6, 4.73, 0.15}, {8, 4.73, 
              0.22}}];\)\)], "Input"],

Cell["Morningstar and Peardon", "Text"],

Cell[BoxData[
    \(\(onepm = 
        Map[{{1/#[\([1]\)]^2, #[\([2]\)]}, ErrorBar[#[\([3]\)]]} &, {{3, 
              1.70*3.55, 
              Sqrt[\((0.05*3.55)\)^2 + \((0.07*1.70)\)^2]}}];\)\)], "Input"],

Cell["our results", "Text"],

Cell[BoxData[
    \(\(ours = 
        Map[{{#[\([1]\)], #[\([\(-2\)]\)]}, 
              ErrorBar[#[\([\(-1\)]\)]]} &, {{0, 3.50, 0.24}, {0.002, 4.97, 
              0.43}, {\(-0.002\), 5.57, 0.4}}];\)\)], "Input"],

Cell[BoxData[
    \(glue = 
      Block[{dash = {Dashing[{0.01, 0.015}]}, t = 2}, 
        Show[Plot[3.307 + 1.85\ x, {x, 0, 1/2^2}, PlotStyle -> dash, 
            DisplayFunction \[Rule] Identity], \[IndentingNewLine]Plot[
            4.80 + 0.25\ x, {x, 0, 1/2^2}, PlotStyle -> dash, 
            DisplayFunction \[Rule] Identity], 
          Plot[5.57 + 4.25\ x, {x, 0, 0.12}, PlotStyle -> dash, 
            DisplayFunction \[Rule] Identity], 
          MultipleListPlot[opp, tpp, onepm, ours, 
            SymbolShape \[Rule] {PlotSymbol[Box, t, Filled \[Rule] False], 
                PlotSymbol[Diamond, 2\ t, Filled \[Rule] False], 
                PlotSymbol[Star, 2  t], PlotSymbol[Triangle, 2\ t]}, 
            DisplayFunction \[Rule] Identity], 
          DisplayFunction \[Rule] $DisplayFunction, Axes \[Rule] False, 
          Frame \[Rule] True, AspectRatio \[Rule] 1.2, 
          TextStyle \[Rule] {FontSize \[Rule] 12, 
              FontFamily \[Rule] "\<Times\>"}, 
          FrameLabel \[Rule] {StyleForm["\<N\>", 
                FontSlant \[Rule] "\<Italic\>"], 
              StyleForm["\<M\>"/Sqrt["\<\[Sigma]\>"], 
                FontSlant \[Rule] "\<Italic\>"]}, RotateLabel \[Rule] False, 
          FrameTicks \[Rule] {Append[
                Table[{1/n^2, n}, {n, 2, 8}], {0, "\<\[Infinity]\>"}], 
              Automatic}]]\)], "Input"],

Cell[CellGroupData[{

Cell[TextData[{
  "\n\n\nGlueballs:  comparing our results to Euclidean Lattice\nat finite ",
  StyleBox["N",
    FontSlant->"Italic"]
}], "Subtitle",
  TextAlignment->Center],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1.2 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0276039 3.79435 -1.14067 0.370012 [
[.97619 -0.0125 -5 -12.75 ]
[.97619 -0.0125 5 0 ]
[.4492 -0.0125 -5 -12.75 ]
[.4492 -0.0125 5 0 ]
[.26475 -0.0125 -5 -12.75 ]
[.26475 -0.0125 5 0 ]
[.17938 -0.0125 -5 -12.8125 ]
[.17938 -0.0125 5 0 ]
[.133 -0.0125 -5 -12.75 ]
[.133 -0.0125 5 0 ]
[.10504 -0.0125 -5 -12.75 ]
[.10504 -0.0125 5 0 ]
[.08689 -0.0125 -5 -12.75 ]
[.08689 -0.0125 5 0 ]
[.0276 -0.0125 -7.09375 -12.75 ]
[.0276 -0.0125 7.09375 0 ]
[ 0 0 -0.125 0 ]
[.5 -0.0125 -6.4375 -25.5625 ]
[.5 -0.0125 6.4375 -12.8125 ]
[-0.0125 .15438 -19 -6.40625 ]
[-0.0125 .15438 0 6.40625 ]
[-0.0125 .33938 -10 -6.375 ]
[-0.0125 .33938 0 6.375 ]
[-0.0125 .52439 -19 -6.40625 ]
[-0.0125 .52439 0 6.40625 ]
[-0.0125 .70939 -10 -6.40625 ]
[-0.0125 .70939 0 6.40625 ]
[-0.0125 .8944 -19 -6.40625 ]
[-0.0125 .8944 0 6.40625 ]
[-0.0125 1.07941 -10 -6.375 ]
[-0.0125 1.07941 0 6.375 ]
[ 0 0 -0.125 0 ]
[-0.01875 .6 -49.375 -15.5312 ]
[-0.01875 .6 -19 15.5312 ]
[.97619 1.2125 -5 0 ]
[.97619 1.2125 5 12.75 ]
[.4492 1.2125 -5 0 ]
[.4492 1.2125 5 12.75 ]
[.26475 1.2125 -5 0 ]
[.26475 1.2125 5 12.75 ]
[.17938 1.2125 -5 0 ]
[.17938 1.2125 5 12.8125 ]
[.133 1.2125 -5 0 ]
[.133 1.2125 5 12.75 ]
[.10504 1.2125 -5 0 ]
[.10504 1.2125 5 12.75 ]
[.08689 1.2125 -5 0 ]
[.08689 1.2125 5 12.75 ]
[.0276 1.2125 -7.09375 0 ]
[.0276 1.2125 7.09375 12.75 ]
[ 0 1.2 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 1.2 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.97619 0 m
.97619 .00625 L
s
gsave
.97619 -0.0125 -66 -16.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.4492 0 m
.4492 .00625 L
s
gsave
.4492 -0.0125 -66 -16.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.26475 0 m
.26475 .00625 L
s
gsave
.26475 -0.0125 -66 -16.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.17938 0 m
.17938 .00625 L
s
gsave
.17938 -0.0125 -66 -16.8125 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.8125 translate 1 -1 scale
63.000 13.250 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.133 0 m
.133 .00625 L
s
gsave
.133 -0.0125 -66 -16.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.10504 0 m
.10504 .00625 L
s
gsave
.10504 -0.0125 -66 -16.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.08689 0 m
.08689 .00625 L
s
gsave
.08689 -0.0125 -66 -16.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.0276 0 m
.0276 .00625 L
s
gsave
.0276 -0.0125 -68.0938 -16.75 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.188 moveto
%%IncludeResource: font Math1
%%IncludeFont: Math1
/Math1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\245) show
73.188 13.188 moveto
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 0 m
1 0 L
s
gsave
.5 -0.0125 -67.4375 -29.5625 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Italic
%%IncludeFont: Times-Italic
%%BeginResource: font Times-Italic-MISO
%%BeginFont: Times-Italic-MISO
/Times-Italic /Times-Italic-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.188 13.188 moveto
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(N) show
71.875 13.188 moveto
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 .15438 m
.00625 .15438 L
s
gsave
-0.0125 .15438 -80 -10.4062 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.8125 translate 1 -1 scale
63.000 13.250 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3.5) show
1.000 setlinewidth
grestore
0 .33938 m
.00625 .33938 L
s
gsave
-0.0125 .33938 -71 -10.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
0 .52439 m
.00625 .52439 L
s
gsave
-0.0125 .52439 -80 -10.4062 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.8125 translate 1 -1 scale
63.000 13.250 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4.5) show
1.000 setlinewidth
grestore
0 .70939 m
.00625 .70939 L
s
gsave
-0.0125 .70939 -71 -10.4062 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.8125 translate 1 -1 scale
63.000 13.250 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
0 .8944 m
.00625 .8944 L
s
gsave
-0.0125 .8944 -80 -10.4062 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.8125 translate 1 -1 scale
63.000 13.250 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5.5) show
1.000 setlinewidth
grestore
0 1.07941 m
.00625 1.07941 L
s
gsave
-0.0125 1.07941 -71 -10.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.125 Mabswid
0 .19138 m
.00375 .19138 L
s
0 .22838 m
.00375 .22838 L
s
0 .26538 m
.00375 .26538 L
s
0 .30238 m
.00375 .30238 L
s
0 .37638 m
.00375 .37638 L
s
0 .41338 m
.00375 .41338 L
s
0 .45039 m
.00375 .45039 L
s
0 .48739 m
.00375 .48739 L
s
0 .56139 m
.00375 .56139 L
s
0 .59839 m
.00375 .59839 L
s
0 .63539 m
.00375 .63539 L
s
0 .67239 m
.00375 .67239 L
s
0 .7464 m
.00375 .7464 L
s
0 .7834 m
.00375 .7834 L
s
0 .8204 m
.00375 .8204 L
s
0 .8574 m
.00375 .8574 L
s
0 .9314 m
.00375 .9314 L
s
0 .9684 m
.00375 .9684 L
s
0 1.0054 m
.00375 1.0054 L
s
0 1.04241 m
.00375 1.04241 L
s
0 .11737 m
.00375 .11737 L
s
0 .08037 m
.00375 .08037 L
s
0 .04337 m
.00375 .04337 L
s
0 .00637 m
.00375 .00637 L
s
0 1.11641 m
.00375 1.11641 L
s
0 1.15341 m
.00375 1.15341 L
s
0 1.19041 m
.00375 1.19041 L
s
.25 Mabswid
0 0 m
0 1.2 L
s
gsave
-0.01875 .6 -110.375 -19.5312 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 39.0625 translate 1 -1 scale
70.875 12.812 moveto
%%IncludeResource: font Times-Italic
%%IncludeFont: Times-Italic
%%BeginResource: font Times-Italic-MISO
%%BeginFont: Times-Italic-MISO
/Times-Italic /Times-Italic-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
71.062 12.812 moveto
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(M) show
81.500 12.812 moveto
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
%%IncludeResource: font Math1
%%IncludeFont: Math1
/Math1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
64.625 21.062 moveto
(\\200\\200\\200\\200\\200\\200\\200\\200) show
78.125 21.062 moveto
(\\200\\200\\200\\200) show
84.875 21.062 moveto
(\\200) show
85.812 21.062 moveto
(\\200) show
0.000 0.000 0.000 setrgbcolor
%%IncludeResource: font Math2
%%IncludeFont: Math2
/Math2 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
65.938 25.312 moveto
(\\217) show
75.562 25.312 moveto
(!!) show
80.562 25.312 moveto
(!) show
82.625 25.312 moveto
(!) show
76.250 32.312 moveto
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
76.250 32.312 moveto
%%IncludeResource: font Math1
%%IncludeFont: Math1
/Math1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(s) show
84.375 32.312 moveto
%%IncludeResource: font Times-Italic-MISO
%%IncludeFont: Times-Italic-MISO
/Times-Italic-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
.97619 1.19375 m
.97619 1.2 L
s
gsave
.97619 1.2125 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.4492 1.19375 m
.4492 1.2 L
s
gsave
.4492 1.2125 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.26475 1.19375 m
.26475 1.2 L
s
gsave
.26475 1.2125 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.17938 1.19375 m
.17938 1.2 L
s
gsave
.17938 1.2125 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.8125 translate 1 -1 scale
63.000 13.250 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(5) show
1.000 setlinewidth
grestore
.133 1.19375 m
.133 1.2 L
s
gsave
.133 1.2125 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(6) show
1.000 setlinewidth
grestore
.10504 1.19375 m
.10504 1.2 L
s
gsave
.10504 1.2125 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(7) show
1.000 setlinewidth
grestore
.08689 1.19375 m
.08689 1.2 L
s
gsave
.08689 1.2125 -66 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(8) show
1.000 setlinewidth
grestore
.0276 1.19375 m
.0276 1.2 L
s
gsave
.0276 1.2125 -68.0938 -4 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 20.75 translate 1 -1 scale
63.000 13.188 moveto
%%IncludeResource: font Times-Roman
%%IncludeFont: Times-Roman
%%BeginResource: font Times-Roman-MISO
%%BeginFont: Times-Roman-MISO
/Times-Roman /Times-Roman-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
63.000 13.188 moveto
%%IncludeResource: font Math1
%%IncludeFont: Math1
/Math1 findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(\\245) show
73.188 13.188 moveto
%%IncludeResource: font Times-Roman-MISO
%%IncludeFont: Times-Roman-MISO
/Times-Roman-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
0.000 0.000 rmoveto
1.000 setlinewidth
grestore
0 1.2 m
1 1.2 L
s
.99375 .15438 m
1 .15438 L
s
.99375 .33938 m
1 .33938 L
s
.99375 .52439 m
1 .52439 L
s
.99375 .70939 m
1 .70939 L
s
.99375 .8944 m
1 .8944 L
s
.99375 1.07941 m
1 1.07941 L
s
.125 Mabswid
.99625 .19138 m
1 .19138 L
s
.99625 .22838 m
1 .22838 L
s
.99625 .26538 m
1 .26538 L
s
.99625 .30238 m
1 .30238 L
s
.99625 .37638 m
1 .37638 L
s
.99625 .41338 m
1 .41338 L
s
.99625 .45039 m
1 .45039 L
s
.99625 .48739 m
1 .48739 L
s
.99625 .56139 m
1 .56139 L
s
.99625 .59839 m
1 .59839 L
s
.99625 .63539 m
1 .63539 L
s
.99625 .67239 m
1 .67239 L
s
.99625 .7464 m
1 .7464 L
s
.99625 .7834 m
1 .7834 L
s
.99625 .8204 m
1 .8204 L
s
.99625 .8574 m
1 .8574 L
s
.99625 .9314 m
1 .9314 L
s
.99625 .9684 m
1 .9684 L
s
.99625 1.0054 m
1 1.0054 L
s
.99625 1.04241 m
1 1.04241 L
s
.99625 .11737 m
1 .11737 L
s
.99625 .08037 m
1 .08037 L
s
.99625 .04337 m
1 .04337 L
s
.99625 .00637 m
1 .00637 L
s
.99625 1.11641 m
1 1.11641 L
s
.99625 1.15341 m
1 1.15341 L
s
.99625 1.19041 m
1 1.19041 L
s
.25 Mabswid
1 0 m
1 1.2 L
s
0 0 m
1 0 L
1 1.2 L
0 1.2 L
closepath
clip
newpath
.5 Mabswid
[ .01 .015 ] 0 setdash
.0276 .08296 m
.06609 .08991 L
.10805 .09748 L
.14747 .10459 L
.18537 .11143 L
.22572 .1187 L
.26456 .12571 L
.30584 .13316 L
.34561 .14033 L
.38387 .14724 L
.42457 .15458 L
.46377 .16165 L
.50145 .16845 L
.54158 .17569 L
.5802 .18265 L
.62126 .19006 L
.66081 .1972 L
.69885 .20406 L
.73933 .21136 L
.7783 .21839 L
.81972 .22587 L
.85963 .23307 L
.89802 .23999 L
.93886 .24736 L
.97619 .25409 L
s
.0276 .63539 m
.06609 .63633 L
.10805 .63735 L
.14747 .63831 L
.18537 .63924 L
.22572 .64022 L
.26456 .64117 L
.30584 .64217 L
.34561 .64314 L
.38387 .64408 L
.42457 .64507 L
.46377 .64603 L
.50145 .64694 L
.54158 .64792 L
.5802 .64886 L
.62126 .64986 L
.66081 .65083 L
.69885 .65176 L
.73933 .65274 L
.7783 .65369 L
.81972 .6547 L
.85963 .65568 L
.89802 .65661 L
.93886 .65761 L
.97619 .65852 L
s
.0276 .9203 m
.04607 .92796 L
.06622 .93631 L
.08514 .94415 L
.10333 .95169 L
.1227 .95971 L
.14134 .96744 L
.16116 .97565 L
.18025 .98356 L
.19861 .99117 L
.21815 .99927 L
.23696 1.00707 L
.25505 1.01457 L
.27431 1.02255 L
.29285 1.03023 L
.31256 1.0384 L
.33154 1.04627 L
.3498 1.05383 L
.36923 1.06189 L
.38794 1.06964 L
.40782 1.07788 L
.42697 1.08582 L
.44541 1.09346 L
.46501 1.10158 L
.48293 1.10901 L
s
.001 w
[ ] 0 setdash
.97619 .28388 m
.97619 .23208 L
s
.97619 .28388 1.5 0 Mabsadd m
.97619 .28388 -1.5 0 Mabsadd L s
.97619 .23208 1.5 0 Mabsadd m
.97619 .23208 -1.5 0 Mabsadd L s
.4492 .19878 m
.4492 .14698 L
s
.4492 .19878 1.5 0 Mabsadd m
.4492 .19878 -1.5 0 Mabsadd L s
.4492 .14698 1.5 0 Mabsadd m
.4492 .14698 -1.5 0 Mabsadd L s
.26475 .12477 m
.26475 .08037 L
s
.26475 .12477 1.5 0 Mabsadd m
.26475 .12477 -1.5 0 Mabsadd L s
.26475 .08037 1.5 0 Mabsadd m
.26475 .08037 -1.5 0 Mabsadd L s
.26475 .21728 m
.26475 .13588 L
s
.26475 .21728 1.5 0 Mabsadd m
.26475 .21728 -1.5 0 Mabsadd L s
.26475 .13588 1.5 0 Mabsadd m
.26475 .13588 -1.5 0 Mabsadd L s
.133 .09517 m
.133 .02857 L
s
.133 .09517 1.5 0 Mabsadd m
.133 .09517 -1.5 0 Mabsadd L s
.133 .02857 1.5 0 Mabsadd m
.133 .02857 -1.5 0 Mabsadd L s
.08689 .21728 m
.08689 .12847 L
s
.08689 .21728 1.5 0 Mabsadd m
.08689 .21728 -1.5 0 Mabsadd L s
.08689 .12847 1.5 0 Mabsadd m
.08689 .12847 -1.5 0 Mabsadd L s
.0001 w
.97619 .25798 -2 2 Mabsadd m
.97619 .25798 2 2 Mabsadd L
.97619 .25798 2 -2 Mabsadd L
.97619 .25798 -2 -2 Mabsadd L
.97619 .25798 -2 2 Mabsadd L s
.4492 .17288 -2 2 Mabsadd m
.4492 .17288 2 2 Mabsadd L
.4492 .17288 2 -2 Mabsadd L
.4492 .17288 -2 -2 Mabsadd L
.4492 .17288 -2 2 Mabsadd L s
.26475 .10257 -2 2 Mabsadd m
.26475 .10257 2 2 Mabsadd L
.26475 .10257 2 -2 Mabsadd L
.26475 .10257 -2 -2 Mabsadd L
.26475 .10257 -2 2 Mabsadd L s
.26475 .17658 -2 2 Mabsadd m
.26475 .17658 2 2 Mabsadd L
.26475 .17658 2 -2 Mabsadd L
.26475 .17658 -2 -2 Mabsadd L
.26475 .17658 -2 2 Mabsadd L s
.133 .06187 -2 2 Mabsadd m
.133 .06187 2 2 Mabsadd L
.133 .06187 2 -2 Mabsadd L
.133 .06187 -2 -2 Mabsadd L
.133 .06187 -2 2 Mabsadd L s
.08689 .17288 -2 2 Mabsadd m
.08689 .17288 2 2 Mabsadd L
.08689 .17288 2 -2 Mabsadd L
.08689 .17288 -2 -2 Mabsadd L
.08689 .17288 -2 2 Mabsadd L s
.001 w
.97619 .9166 m
.97619 .8352 L
s
.97619 .9166 1.5 0 Mabsadd m
.97619 .9166 -1.5 0 Mabsadd L s
.97619 .8352 1.5 0 Mabsadd m
.97619 .8352 -1.5 0 Mabsadd L s
.4492 .66129 m
.4492 .59469 L
s
.4492 .66129 1.5 0 Mabsadd m
.4492 .66129 -1.5 0 Mabsadd L s
.4492 .59469 1.5 0 Mabsadd m
.4492 .59469 -1.5 0 Mabsadd L s
.27079 .70569 m
.27079 .62429 L
s
.27079 .70569 1.5 0 Mabsadd m
.27079 .70569 -1.5 0 Mabsadd L s
.27079 .62429 1.5 0 Mabsadd m
.27079 .62429 -1.5 0 Mabsadd L s
.25893 .71309 m
.25893 .59469 L
s
.25893 .71309 1.5 0 Mabsadd m
.25893 .71309 -1.5 0 Mabsadd L s
.25893 .59469 1.5 0 Mabsadd m
.25893 .59469 -1.5 0 Mabsadd L s
.133 .66499 m
.133 .55399 L
s
.133 .66499 1.5 0 Mabsadd m
.133 .66499 -1.5 0 Mabsadd L s
.133 .55399 1.5 0 Mabsadd m
.133 .55399 -1.5 0 Mabsadd L s
.08689 .69089 m
.08689 .52809 L
s
.08689 .69089 1.5 0 Mabsadd m
.08689 .69089 -1.5 0 Mabsadd L s
.08689 .52809 1.5 0 Mabsadd m
.08689 .52809 -1.5 0 Mabsadd L s
.0001 w
.97619 .8759 -3 0 Mabsadd m
.97619 .8759 0 4 Mabsadd L
.97619 .8759 3 0 Mabsadd L
.97619 .8759 0 -4 Mabsadd L
.97619 .8759 -3 0 Mabsadd L s
.4492 .62799 -3 0 Mabsadd m
.4492 .62799 0 4 Mabsadd L
.4492 .62799 3 0 Mabsadd L
.4492 .62799 0 -4 Mabsadd L
.4492 .62799 -3 0 Mabsadd L s
.27079 .66499 -3 0 Mabsadd m
.27079 .66499 0 4 Mabsadd L
.27079 .66499 3 0 Mabsadd L
.27079 .66499 0 -4 Mabsadd L
.27079 .66499 -3 0 Mabsadd L s
.25893 .65389 -3 0 Mabsadd m
.25893 .65389 0 4 Mabsadd L
.25893 .65389 3 0 Mabsadd L
.25893 .65389 0 -4 Mabsadd L
.25893 .65389 -3 0 Mabsadd L s
.133 .60949 -3 0 Mabsadd m
.133 .60949 0 4 Mabsadd L
.133 .60949 3 0 Mabsadd L
.133 .60949 0 -4 Mabsadd L
.133 .60949 -3 0 Mabsadd L s
.08689 .60949 -3 0 Mabsadd m
.08689 .60949 0 4 Mabsadd L
.08689 .60949 3 0 Mabsadd L
.08689 .60949 0 -4 Mabsadd L
.08689 .60949 -3 0 Mabsadd L s
.001 w
.4492 1.17143 m
.4492 1.01329 L
s
.4492 1.17143 1.5 0 Mabsadd m
.4492 1.17143 -1.5 0 Mabsadd L s
.4492 1.01329 1.5 0 Mabsadd m
.4492 1.01329 -1.5 0 Mabsadd L s
.0001 w
.4492 1.09236 0 4 Mabsadd m
.4492 1.09236 -0.90428 1.24464 Mabsadd L
.4492 1.09236 -3.80423 1.23607 Mabsadd L
.4492 1.09236 -1.46316 -0.47541 Mabsadd L
.4492 1.09236 -2.35114 -3.23607 Mabsadd L
.4492 1.09236 0 -1.53846 Mabsadd L
.4492 1.09236 2.35114 -3.23607 Mabsadd L
.4492 1.09236 1.46316 -0.47541 Mabsadd L
.4492 1.09236 3.80423 1.23607 Mabsadd L
.4492 1.09236 .90428 1.24464 Mabsadd L
.4492 1.09236 0 4 Mabsadd L closepath F
.001 w
.0276 .24318 m
.0276 .06557 L
s
.0276 .24318 1.5 0 Mabsadd m
.0276 .24318 -1.5 0 Mabsadd L s
.0276 .06557 1.5 0 Mabsadd m
.0276 .06557 -1.5 0 Mabsadd L s
.0314 .8574 m
.0314 .53919 L
s
.0314 .8574 1.5 0 Mabsadd m
.0314 .8574 -1.5 0 Mabsadd L s
.0314 .53919 1.5 0 Mabsadd m
.0314 .53919 -1.5 0 Mabsadd L s
.02381 1.06831 m
.02381 .7723 L
s
.02381 1.06831 1.5 0 Mabsadd m
.02381 1.06831 -1.5 0 Mabsadd L s
.02381 .7723 1.5 0 Mabsadd m
.02381 .7723 -1.5 0 Mabsadd L s
.0001 w
.0276 .15438 0 4 Mabsadd m
.0276 .15438 -3.464 -2 Mabsadd L
.0276 .15438 3.464 -2 Mabsadd L
.0276 .15438 0 4 Mabsadd L closepath F
.0314 .69829 0 4 Mabsadd m
.0314 .69829 -3.464 -2 Mabsadd L
.0314 .69829 3.464 -2 Mabsadd L
.0314 .69829 0 4 Mabsadd L closepath F
.02381 .9203 0 4 Mabsadd m
.02381 .9203 -3.464 -2 Mabsadd L
.02381 .9203 3.464 -2 Mabsadd L
.02381 .9203 0 4 Mabsadd L closepath F
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  TextAlignment->Center,
  ImageSize->{431.938, 518.125},
  ImageMargins->{{60, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40006_00021R000`400?l00000o`00003oo`3ooon`
0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`
0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`
0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00kP3oool3
000000<0oooo00<000000?ooo`3oool0^03oool00>l0oooo00<000000?ooo`3oool00P3oool00`00
0000oooo0?ooo`2h0?ooo`00k`3oool010000000oooo0?ooo`3oool200000;X0oooo003`0?ooo`06
0000003oool0oooo0000003oool00000^@3oool00?00oooo00<000000?ooo`0000000P3oool00`00
0000oooo0?ooo`2g0?ooo`00l03oool00`000000oooo000000020?ooo`030000003oool0oooo0;L0
oooo003a0?ooo`030000003oool0oooo0080oooo00<000000?ooo`3oool0]P3oool00?40oooo00<0
00000?ooo`3oool00P3oool00`000000oooo0?ooo`2f0?ooo`00l03oool2000000<0oooo0`00002g
0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00?`3oool2
000000<0oooo0P00000@0?ooo`<00000103oool00`000000oooo0?ooo`080?ooo`<000003P3oool3
000001l0oooo00<000000?ooo`3oool0@03oool300000<40oooo1@0000080?ooo`00?P3oool01P00
0000oooo0?ooo`000000oooo00000080oooo00<000000?ooo`3oool0303oool01@000000oooo0?oo
o`3oool0000000<0oooo00<000000?ooo`3oool01`3oool200000080oooo00<000000?ooo`3oool0
2P3oool00`000000oooo0?ooo`02000001h0oooo00<000000?ooo`3oool0?`3oool01@000000oooo
0?ooo`3oool000000<00oooo00D000000?ooo`3oool0oooo000000080?ooo`00?P3oool01@000000
oooo0?ooo`3oool0000000<0oooo00<000000?ooo`3oool0303oool01@000000oooo0?ooo`3oool0
000000<0oooo00<000000?ooo`3oool01`3oool01@000000oooo0?ooo`3oool000000100oooo00<0
00000?ooo`3oool06@3oool5000004@0oooo00<000000?ooo`3oool0_`3oool00`000000oooo0?oo
o`090?ooo`00?P3oool01P000000oooo0?ooo`000000oooo00000080oooo00<000000?ooo`3oool0
303oool00`000000oooo0?ooo`02000000@0oooo00<000000?ooo`3oool01P3oool01@000000oooo
0?ooo`3oool000000100oooo00<000000?ooo`3oool06@3oool010000000oooo0?ooo`0000150?oo
o`030000003oool0oooo0<00oooo00<000000?ooo`3oool0203oool003l0oooo0P0000030?ooo`80
0000403oool3000000D0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`02000000l0
oooo0P00000L0?ooo`030000003oool000000480oooo0`0000340?ooo`030000003oool0oooo00L0
oooo001E0?ooo`8000000P3oool00`000000oooo0?ooo`030?ooo`030000003oool0oooo00D0oooo
1000000>0?ooo`<000007@3oool00`000000oooo000000140?ooo`030000003oool0oooo0<<0oooo
00<000000?ooo`3oool01P3oool005D0oooo00D000000?ooo`3oool0oooo000000050?ooo`030000
003oool0oooo00H0oooo00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0N0?ooo`800000
A@3oool00`000000oooo0?ooo`320?ooo`030000003oool0oooo00H0oooo001E0?ooo`050000003o
ool0oooo0?ooo`0000000P3oool01@000000oooo0?ooo`3oool0000000L0oooo0P00000?0?ooo`03
0000003oool0oooo01h0oooo0P0000110?ooo`050000003oool0oooo0?ooo`000000`03oool01@00
0000oooo0?ooo`3oool0000000P0oooo001F0?ooo`<000000`3oool5000000T0oooo0P00000>0?oo
o`<000007P3oool00`000000oooo0?ooo`100?ooo`<00000`P3oool3000000T0oooo003o0?oook00
oooo003o0?oook00oooo003o0?oook00oooo003o0?oook00oooo000h0?ooool00000N000000003P0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo00@0
oooo00<000000?ooo`3oool0203oool00`000000oooo0?ooo`0>0?ooo`030000003oool0oooo01d0
oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`320?ooo`030000003oool0oooo00H0
oooo0@00000003P0oooo0P0000080?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
103oool00`000000oooo0?ooo`080?ooo`030000003oool0oooo00h0oooo00<000000?ooo`3oool0
7@3oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo0<80oooo00<000000?ooo`3oool0
1@3oool200000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<00000
0?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool10000
0000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0
o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool0
0`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0;@3oool40000
0?l0oooo@`3oool100000000>03oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0?l0
oooo@P3oool100000000>03oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0?l0oooo
@P3oool100000000>03oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0?l0oooo@P3o
ool100000000>03oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0?l0oooo@P3oool1
00000000>03oool00`000000oooo0?ooo`0_0?ooo`030000003oool0oooo0?l0oooo@P3oool10000
0000>03oool200000300oooo00<000000?ooo`3oool0o`3ooom10?ooo`800000000h0?ooo`030000
003oool0oooo02l0oooo00<000000?ooo`3oool0o`3ooom20?ooo`400000000h0?ooo`030000003o
ool0oooo02l0oooo00<000000?ooo`3oool0o`3ooom20?ooo`400000000h0?ooo`030000003oool0
oooo02l0oooo00<000000?ooo`3oool0o`3ooom20?ooo`400000000h0?ooo`030000003oool0oooo
02l0oooo00<000000?ooo`3oool0o`3ooom20?ooo`400000000h0?ooo`030000003oool0oooo02d0
oooo1@00003o0?oood80oooo0@00000003P0oooo00<000000?ooo`3oool0;@3oool01@000000oooo
0000003oool000000?l0oooo@P3oool100000000>03oool00`000000oooo0?ooo`0]0?ooo`050000
003oool000000?ooo`000000o`3ooom20?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo
1000000S0?ooo`050000003oool000000?ooo`000000o`3ooom20?ooo`400000000h0?ooo`030000
003oool0oooo00L0oooo00<000000?ooo`3oool08`3oool500000?l0oooo@P3oool100000000>03o
ool00`000000oooo0?ooo`070?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0o`3o
oom20?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool09@3oool0
0`000000oooo0?ooo`3o0?oood80oooo0@00000003P0oooo00<000000?ooo`3oool01`3oool00`00
0000oooo0?ooo`0U0?ooo`030000003oool0oooo0?l0oooo@P3oool100000000>03oool00`000000
oooo0?ooo`070?ooo`030000003oool0oooo02D0oooo00<000000?ooo`3oool0o`3ooom20?ooo`40
0000000h0?ooo`800000203oool00`000000oooo0?ooo`0U0?ooo`030000003oool0oooo02d0oooo
1000003o0?oooa00oooo0P00000003P0oooo00<000000?ooo`3oool01`3oool5000002<0oooo00<0
00000?ooo`3oool0;P3oool00`000000oooo0?ooo`3o0?oooa40oooo0@00000003P0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`060?ooo`8000007@3oool00`000000oooo0?ooo`0^
0?ooo`030000003oool0oooo0?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo00P0oooo0`00000J0?ooo`030000003oool0oooo02h0oooo00<000000?oo
o`3oool0o`3ooolA0?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool0403oool2000001<0oooo00<000000?ooo`3oool0;P3oool00`000000oooo0?ooo`3o0?oooa40
oooo0@00000003P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0B0?ooo`800000
3`3oool4000002l0oooo00<000000?ooo`3oool0o`3ooolA0?ooo`400000000h0?ooo`030000003o
ool0oooo00L0oooo00<000000?ooo`3oool06@3oool5000003H0oooo1@00003o0?oooa40oooo0@00
000003P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0R0?ooo`800000<03oool0
1@000000oooo0000003oool000000?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`07
0?ooo`030000003oool0oooo02@0oooo0`00000]0?ooo`050000003oool000000?ooo`000000o`3o
oolA0?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0:`3oool2
000002L0oooo00D000000?ooo`000000oooo0000003o0?oooa40oooo0@00000003P0oooo00<00000
0?ooo`3oool01`3oool00`000000oooo0?ooo`0]0?ooo`<00000903oool500000?l0oooo4@3oool1
00000000>03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo03@0oooo1@00000M0?oo
o`030000003oool0oooo0?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo03h0oooo0P00000F0?ooo`030000003oool0oooo0?l0oooo4@3oool100000000
>03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0400oooo0P00000D0?ooo`030000
003oool0oooo0?l0oooo4@3oool100000000>03oool2000000P0oooo00<000000?ooo`3oool0A`3o
ool2000000d0oooo00<000000?ooo`3oool0o`3oool@0?ooo`800000000h0?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool0B@3oool3000000X0oooo00<000000?ooo`3oool0o`3ooolA
0?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0D03oool90000
0?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo05T0
oooo0P00003o0?ooo`l0oooo0@00000003P0oooo00<000000?ooo`3oool01`3oool00`000000oooo
0?ooo`0B0?ooo`@00000A@3oool300000?l0oooo303oool100000000>03oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0C@3oool00`000000oooo0?oo
o`3o0?ooo`@0oooo0@00000003P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0C
0?ooo`030000003oool0oooo04h0oooo0`00003o0?ooo`<0oooo0@00000003P0oooo00<000000?oo
o`3oool01`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo03l0oooo1000000C0?oo
o`@00000n@3oool100000000>03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo01<0
oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`0L0?ooo`800000lP3oool100000000
>03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
@03oool00`000000oooo0?ooo`0N0?ooo`<00000k`3oool100000000>03oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?oo
o`0U0?ooo`800000j@3oool100000000>03oool00`000000oooo0?ooo`070?ooo`030000003oool0
oooo01<0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`0W0?ooo`<000005`3oool4
00000</0oooo0@00000002<0oooo0`0000030?ooo`030000003oool0oooo00<000002@3oool00`00
0000oooo0?ooo`050?ooo`H000004P3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo
02h0oooo1@00000?0?ooo`030000003oool0oooo0</0oooo0@0000000280oooo00D000000?ooo`3o
ool0oooo000000040?ooo`030000003oool0oooo00800000203oool3000000D0oooo1@00000C0?oo
o`030000003oool0oooo0400oooo00<000000?ooo`3oool0>03oool00`000000oooo0?ooo`070?oo
o`030000003oool0oooo0<T0oooo0`00000002H0oooo00<000000?ooo`3oool01P3oool00`000000
oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo0`00000D0?ooo`030000003oool0oooo0400
oooo00<000000?ooo`3oool0>@3oool3000000H0oooo00<000000?ooo`3oool0b`3oool100000000
9P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
1P3oool3000001@0oooo00<000000?ooo`3oool0@03oool00`000000oooo0?ooo`110?ooo`800000
c@3oool1000000008`3oool3000000P0oooo0P0000080?ooo`030000003oool0oooo00L0oooo00<0
00000?ooo`3oool04`3oool00`000000oooo0?ooo`100?ooo`030000003oool0oooo0480oooo0`00
003;0?ooo`400000000U0?ooo`030000003oool0oooo00@0oooo0`0000090?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`100?ooo`030000003oool0
oooo0480oooo00<000000?ooo`3oool01@3oool500000<40oooo0@00000002H0oooo00<000000?oo
o`3oool00`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool04@3oool500000400oooo00<000000?ooo`3oool0@03oool5000000h0oooo0P00002k0?oo
o`400000000R0?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool04@3oool01@000000oooo0000003oool0
00000400oooo00<000000?ooo`3oool0@03oool01@000000oooo0000003oool000000100oooo0`00
002h0?ooo`400000000S0?ooo`<000001`3oool3000000P0oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`0A0?ooo`050000003oool000000?ooo`000000?P3oool500000400oooo00D0
00000?ooo`000000oooo0000000G0?ooo`800000/P3oool100000000>03oool00`000000oooo0?oo
o`070?ooo`030000003oool0oooo0140oooo00D000000?ooo`000000oooo0000000n0?ooo`050000
003oool000000?ooo`000000@03oool01@000000oooo0000003oool0000001T0oooo0`00002_0?oo
o`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool04@3oool5000003h0
oooo00D000000?ooo`000000oooo000000100?ooo`D000008@3oool400000:H0oooo0@00000003P0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo03h0
oooo00D000000?ooo`000000oooo000000120?ooo`030000003oool0oooo02X0oooo0P00002O0?oo
o`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool04`3oool00`000000
oooo0?ooo`0n0?ooo`D00000@P3oool00`000000oooo0?ooo`0/0?ooo`<00000W03oool100000000
>03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
@03oool00`000000oooo0?ooo`120?ooo`030000003oool0oooo03<0oooo0P00002F0?ooo`400000
000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?oo
o`100?ooo`030000003oool0oooo0480oooo00<000000?ooo`3oool0=@3oool3000009<0oooo0@00
000003P0oooo0P0000080?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0@03oool0
0`000000oooo0?ooo`120?ooo`030000003oool0oooo03`0oooo1@0000290?ooo`800000000h0?oo
o`030000003oool0oooo00L0oooo00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`100?oo
o`030000003oool0oooo0480oooo00<000000?ooo`3oool0A@3oool2000008@0oooo0@00000003P0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0400
oooo00<000000?ooo`3oool0@P3oool00`000000oooo0?ooo`170?ooo`<00000P@3oool100000000
>03oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo01<0oooo00<000000?ooo`3oool0
@03oool00`000000oooo0?ooo`110?ooo`@00000C`3oool2000007X0oooo0@00000003P0oooo00<0
00000?ooo`3oool01`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0400oooo00<0
00000?ooo`3oool0UP3oool2000007P0oooo0@00000003P0oooo00<000000?ooo`3oool01`3oool0
0`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0W@3oool5
000006h0oooo0@00000003P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0C0?oo
o`030000003oool0oooo0400oooo00<000000?ooo`3oool0YP3oool2000006P0oooo0@00000003P0
oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0400
oooo00<000000?ooo`3oool0Z03oool3000006D0oooo0@00000003P0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`0C0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0
[`3oool2000005l0oooo0@00000003P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?oo
o`0C0?ooo`030000003oool0oooo0400oooo00<000000?ooo`3oool0/@3oool3000005`0oooo0@00
000003P0oooo00<000000?ooo`3oool01`3oool00`000000oooo0?ooo`0B0?ooo`@00000?`3oool4
00000;T0oooo1000001C0?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?oo
o`3oool0o`3ooolL0?ooo`800000C03oool100000000>03oool00`000000oooo0?ooo`070?ooo`03
0000003oool0oooo0?l0oooo7P3oool2000004X0oooo0@00000003P0oooo00<000000?ooo`3oool0
1`3oool00`000000oooo0?ooo`3o0?ooobD0oooo0`0000120?ooo`400000000h0?ooo`800000203o
ool00`000000oooo0?ooo`3o0?ooobP0oooo0P00000o0?ooo`800000000h0?ooo`030000003oool0
oooo00L0oooo00<000000?ooo`3oool0o`3oool^0?ooo`D00000=`3oool100000000>03oool00`00
0000oooo0?ooo`070?ooo`030000003oool0oooo0?l0oooo=`3oool2000002L0oooo100000060?oo
o`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3oooli0?ooo`<0
00009@3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool0o`3ooom10?ooo`8000007P3oool00`000000oooo0?ooo`060?ooo`400000
000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3ooom30?ooo`800000703o
ool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo1000003o
0?ooodX0oooo1000000C0?ooo`030000003oool0oooo00H0oooo0@00000003P0oooo00<000000?oo
o`3oool0o`3ooomM0?ooo`800000303oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`03
0000003oool0oooo0?l0ooooG`3oool3000000T0oooo00<000000?ooo`3oool01P3oool100000000
>03oool00`000000oooo0?ooo`3o0?ooofH0oooo0P0000000`3oool0000000000003000000H0oooo
0@00000003P0oooo00<000000?ooo`3oool0o`3ooomX0?ooo`@0000000<0oooo0000003oool01@3o
ool100000000>03oool00`000000oooo0?ooo`3o0?ooofT0oooo00D000000?ooo`000000oooo0000
00060?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooJ@3oool01@000000oooo0000003o
ool0000000H0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomY0?ooo`D000001P3oool1
00000000>03oool200000?l0ooooK03oool00`000000oooo0?ooo`050?ooo`800000000h0?ooo`03
0000003oool0oooo0?l0ooooJ`3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000
003oool0oooo0?l0ooooJ`3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003o
ool0oooo0?l0ooooJ`3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0
oooo0?l0ooooJ`3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo
0?l0ooooJ`3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo0?l0
ooooJ`3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo0?l0oooo
JP3oool4000000H0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h
0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?oo
og@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000
003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00
000003P0oooo0P00003o0?ooog@0oooo0P00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?oo
o`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo
0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h
0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?oo
og@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000
003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00
000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo
0?l0ooooM03oool100000000;P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0?l0
ooooM03oool100000000;P3oool00`000000oooo0?ooo`070?ooo`030000003oool0oooo0?l0oooo
M03oool100000000:`3oool5000000P0oooo0`00003o0?ooog80oooo0`00000002/0oooo00@00000
0?ooo`3oool000002@3oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000002`0oooo00<00000
0?ooo`0000002@3oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000002`0oooo00<000000?oo
o`0000002@3oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000002d0oooo0P0000090?ooo`03
0000003oool0oooo0?l0ooooM03oool100000000;@3oool2000000T0oooo00<000000?ooo`3oool0
o`3ooomd0?ooo`400000000^0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3oool0o`3o
oomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`00
0000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`40
0000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?oo
o`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?oo
o`030000003oool0oooo0?l0ooooM03oool100000000>03oool200000?l0ooooM03oool200000000
>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3o
oomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`00
0000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`40
0000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?oo
o`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?oo
o`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0
oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003o
ool0oooo0?l0ooooM03oool100000000>03oool200000?l0ooooM03oool200000000>03oool00`00
0000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`40
0000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?oo
o`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?oo
o`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0
oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003o
ool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@000000
03P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0
ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo0P00
003o0?ooog@0oooo0P00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?oo
o`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0
oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003o
ool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@000000
03P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0
ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<0
00000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool1
00000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3o
ool0o`3ooomd0?ooo`400000000h0?ooo`800000o`3ooomd0?ooo`800000000h0?ooo`030000003o
ool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@000000
03P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0
ooooM03oool100000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<0
00000?ooo`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool1
00000000>03oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3o
ool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03o
ool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000002D0oooo00D000000?ooo`3oool0oooo0000
00020?ooo`<000002@3oool00`000000oooo0?ooo`3o0?ooog@0oooo0@00000002D0oooo00<00000
0?ooo`3oool00`3oool00`000000oooo0?ooo`02000000P0oooo00<000000?ooo`3oool0o`3ooomd
0?ooo`400000000R0?ooo`D00000203oool00`000000oooo0?ooo`060?ooo`<00000o`3ooomb0?oo
o`<00000000R0?ooo`040000003oool0oooo000000T0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`0L0?ooo`@00000o`3ooomD0?ooo`400000000S0?ooo`030000003oool0000000P0
oooo0P0000080?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0o`3ooomD0?ooo`40
0000000S0?ooo`030000003oool0000000H0oooo0`0000090?ooo`030000003oool0oooo01d0oooo
00<000000?ooo`3oool0o`3ooomD0?ooo`400000000T0?ooo`8000001P3oool00`000000oooo0?oo
o`090?ooo`030000003oool0oooo01d0oooo00<000000?ooo`3oool0o`3ooomD0?ooo`400000000T
0?ooo`8000001P3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo01d0oooo00<00000
0?ooo`3oool0o`3ooomD0?ooo`400000000U0?ooo`030000003oool0oooo00D0oooo0`0000080?oo
o`030000003oool0oooo00L0oooo1000000B0?ooo`030000003oool0oooo0?l0ooooE03oool10000
0000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?ooo`3o
ool0o`3ooomD0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0
4@3oool00`000000oooo0?ooo`3o0?oooe@0oooo0@00000003P0oooo00<000000?ooo`3oool02@3o
ool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo0?l0ooooE03oool100000000>03oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0o`3ooomD
0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0=0?ooo`@00000o`3ooom30?ooo`400000000h0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0?l0
oooo@P3oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo
00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`3o0?oood80oooo0@00000003P0oooo0P00
000:0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool03`3oool00`000000oooo0?oo
o`3o0?oood40oooo0P00000000T0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`09
0?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`3o
0?oood80oooo0@00000000T0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`3o0?oo
od80oooo0@00000000P0oooo0P0000060?ooo`<000009@3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo0140oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`3o0?oood80
oooo0@00000000P0oooo0`0000040?ooo`050000003oool0oooo0?ooo`000000903oool00`000000
oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool03`3oool00`000000
oooo0?ooo`3o0?oood80oooo0@00000000L0oooo0P0000000`3oool000000?ooo`030?ooo`030000
003oool0oooo0080oooo00<000000?ooo`3oool08@3oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo0140oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`3o0?oood80oooo
0@00000000L0oooo0P0000000`3oool000000?ooo`030?ooo`030000003oool0oooo0080oooo00<0
00000?ooo`3oool08@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<0
00000?ooo`3oool03`3oool00`000000oooo0?ooo`3o0?oood80oooo0@00000000@0oooo00@00000
0?ooo`00000000000`3oool00`000000oooo0?ooo`020?ooo`050000003oool0oooo0?ooo`000000
8`3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0
3`3oool00`000000oooo0?ooo`3o0?oood80oooo0@00000000D0oooo0`0000030?ooo`030000003o
ool0oooo00<0oooo1P00000Q0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0?l0oooo@P3oool1000000002`3oool0
0`000000oooo0?ooo`0Z0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool0
0`000000oooo0?ooo`0?0?ooo`030000003oool0oooo0?l0oooo@P3oool100000000303oool00`00
0000oooo0?ooo`0Y0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`00
0000oooo0?ooo`0?0?ooo`030000003oool0oooo0?l0oooo@P3oool100000000303oool00`000000
oooo0?ooo`0Y0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`000000
oooo0?ooo`0?0?ooo`030000003oool0oooo0?l0oooo@P3oool100000000303oool00`000000oooo
0?ooo`0Y0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo02X0oooo100000140?ooo`@00000b`3oool1000000003@3o
ool00`000000oooo0?ooo`0X0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02`0oooo00<000000?ooo`3oool0A03o
ool00`000000oooo0?ooo`3;0?ooo`400000000=0?ooo`/00000803oool2000000X0oooo00<00000
0?ooo`3oool04@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02`0oooo00<00000
0?ooo`3oool0A03oool00`000000oooo0?ooo`3:0?ooo`800000000h0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0403oool3000000l0oooo0`00000]0?ooo`030000003oool0oooo
04@0oooo00<000000?ooo`3oool0b`3oool100000000>03oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo0100oooo0`00000?0?ooo`<00000;@3oool00`000000oooo0?ooo`140?ooo`03
0000003oool0oooo0</0oooo0@00000000<0oooo5`00000N0?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool03`3oool01@000000oooo0000003oool0000000d0oooo00D000000?ooo`00
0000oooo0000000/0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0b`3oool10000
0000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00h0oooo00@000000?ooo`3o
ool000000P3oool00`000000oooo0?ooo`090?ooo`040000003oool0oooo00000080oooo00<00000
0?ooo`3oool0:@3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo0</0oooo0@000000
03P0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0?0?ooo`050000003oool00000
0?ooo`0000003@3oool01@000000oooo0000003oool0000002`0oooo00<000000?ooo`3oool0A03o
ool00`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool03`3oool01@000000oooo0000003oool0000000d0oooo00D000000?ooo`000000oooo
0000000/0?ooo`030000003oool0oooo04@0oooo00<000000?ooo`3oool0b`3oool100000000>03o
ool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0100oooo0`00000?0?ooo`<00000;@3o
ool00`000000oooo0?ooo`140?ooo`030000003oool0oooo0</0oooo0@00000000T0oooo0`000000
103oool000000?ooo`3oool3000002D0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0A0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0;03oool00`000000oooo0?oo
o`130?ooo`<00000c03oool1000000002P3oool00`000000oooo0?ooo`0200000080oooo00<00000
0?ooo`3oool0903oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<00000
0?ooo`3oool03`3oool00`000000oooo0?ooo`0/0?ooo`030000003oool0oooo00@00000?`3oool3
00000<`0oooo0@00000000X0oooo00P000000?ooo`3oool000000?ooo`000000oooo000002H0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0;03oool01@000000oooo0?ooo`3oool000000400oooo00D000000?ooo`00
0000oooo0000003;0?ooo`400000000;0?ooo`070000003oool000000?ooo`000000oooo0000000V
0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0?
0?ooo`030000003oool0oooo02`0oooo00D000000?ooo`3oool0oooo0000000o0?ooo`040000003o
ool0oooo00000080oooo00<000000?ooo`3oool0b03oool1000000002`3oool00`000000oooo0000
00020?ooo`030000003oool0000002D0oooo00<000000?ooo`3oool02@3oool00`000000oooo0?oo
o`0A0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0;03oool01@000000oooo0?oo
o`3oool000000400oooo00D000000?ooo`000000oooo0000003;0?ooo`400000000;0?ooo`030000
003oool000000080oooo00<000000?ooo`0000009@3oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo0140oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0/0?ooo`050000
003oool0oooo0?ooo`000000@03oool01@000000oooo0000003oool000000</0oooo0@00000000`0
oooo0P0000030?ooo`8000009@3oool2000000P0oooo1@0000050?ooo`@000001@3oool5000000@0
oooo1@0000050?ooo`<00000;P3oool01@000000oooo0?ooo`3oool000000440oooo0`00003;0?oo
o`800000000<0?ooo`800000103oool2000002@0oooo00<000000?ooo`3oool02@3oool00`000000
oooo0?ooo`0A0?ooo`030000003oool0oooo00l0oooo0P0000050?ooo`D00000103oool5000000D0
oooo100000050?ooo`D000001`3oool01@000000oooo0?ooo`3oool000000480oooo00<000000?oo
o`3oool0b`3oool1000000002`3oool3000000@0oooo0`00000S0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02T0
oooo1@0000020?ooo`030000003oool0oooo00D00000103oool5000000@0oooo1@00000Y0?ooo`03
0000003oool0oooo0</0oooo0@00000003P0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`0A0?ooo`030000003oool0oooo00l0oooo00<000000?ooo`3oool0:`3oool300000080oooo
00<000000?ooo`3oool0703oool5000000@0oooo1@0000050?ooo`@000001@3oool5000000<0oooo
0`00003;0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3o
ool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02/0oooo0`0000020?ooo`030000003o
ool0oooo0400oooo00<000000?ooo`3oool00`0000050?ooo`@000001@3oool5000000@0oooo1@00
00050?ooo`@00000X`3oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo0140oooo00<000000?ooo`3oool03`3oool00`000000oooo0?ooo`0Z0?ooo`070000003oool0
00000?ooo`000000oooo000000120?ooo`030000003oool0oooo02d0oooo1@0000040?ooo`D00000
1@3oool5000000@0oooo1@00001m0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool04@3oool00`000000oooo0?ooo`0?0?ooo`030000003oool0oooo02T0oooo00@0
00000?ooo`3oool000000P3oool200000480oooo00<000000?ooo`3oool0DP3oool5000000D0oooo
1@0000040?ooo`D000001@3oool4000000D0oooo0P00001A0?ooo`400000000h0?ooo`030000003o
ool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`000000oooo0?ooo`0?0?ooo`030000003o
ool0oooo02X0oooo00L000000?ooo`000000oooo0000003oool000000480oooo00<000000?ooo`3o
ool0NP3oool3000000@0oooo1@0000050?ooo`@000001@3oool5000000@0oooo1@00000Y0?ooo`40
0000000h0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo02X0oooo00@000000?ooo`000000oooo100000110?ooo`03
0000003oool0oooo0:L0oooo100000050?ooo`D00000103oool5000000d0oooo0@00000003P0oooo
00<000000?ooo`3oool02@3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo00l0oooo
00<000000?ooo`3oool0:`3oool3000000040?ooo`000000000000000400oooo1000003;0?ooo`40
0000000h0?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool04@3oool00`000000oooo
0?ooo`0?0?ooo`030000003oool0oooo02`0oooo00L000000?ooo`000000oooo0000003oool00000
0?l0oooo3`3oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140
oooo00<000000?ooo`3oool03@3oool4000002d0oooo0P0000020?ooo`040000003oool0oooo0000
0?l0oooo3P3oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140
oooo00<000000?ooo`3oool0?P3oool01`000000oooo0000003oool000000?ooo`000000o`3oool?
0?ooo`400000000h0?ooo`8000002P3oool00`000000oooo0?ooo`0A0?ooo`030000003oool0oooo
03h0oooo00L000000?ooo`000000oooo0000003oool000000?l0oooo3P3oool200000000>03oool0
0`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0?P3oool0
0`000000oooo0?ooo`0300000?l0oooo403oool100000000>03oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool0?P3oool01@000000oooo0?ooo`3oool0
00000?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
0140oooo00<000000?ooo`3oool0?P3oool01@000000oooo0?ooo`3oool000000?l0oooo4@3oool1
00000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?oo
o`3oool0?P3oool01@000000oooo0?ooo`3oool000000?l0oooo4@3oool100000000>03oool00`00
0000oooo0?ooo`090?ooo`030000003oool0oooo0140oooo00<000000?ooo`3oool0?P3oool01@00
0000oooo0?ooo`3oool000000?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo0140oooo00<000000?ooo`3oool0?P3oool01@000000oooo0?ooo`3oool0
00000?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
0100oooo1000000n0?ooo`050000003oool0oooo0?ooo`000000o`3ooolA0?ooo`400000000h0?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool0DP3oool01@000000oooo0?ooo`3oool0
00000?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`060?ooo`H00000DP3oool01@00
0000oooo0?ooo`3oool000000?l0oooo4@3oool100000000>03oool00`000000oooo0?ooo`070?oo
o`@00000D`3oool01@000000oooo0?ooo`3oool000000?l0oooo4@3oool100000000>03oool00`00
0000oooo0?ooo`070?ooo`@00000D`3oool01@000000oooo0?ooo`3oool000000?l0oooo4@3oool1
00000000;03oool3000000T0oooo00<000000?ooo`3oool0203oool2000005@0oooo00D000000?oo
o`3oool0oooo0000003o0?oooa40oooo0@00000002/0oooo00<000000?ooo`3oool00P0000080?oo
o`030000003oool0oooo00T0oooo00<000000?ooo`3oool0DP3oool00`000000oooo0?ooo`040000
0?l0oooo3`3oool100000000;`3oool00`000000oooo0?ooo`060?ooo`<000002@3oool00`000000
oooo0?ooo`1B0?ooo`030000003oool0oooo0?l0oooo4@3oool300000000;`3oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3oool0DP3oool00`000000oooo
0?ooo`3o0?oooa<0oooo0@00000002h0oooo0P0000080?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool0D03oool400000?l0oooo503oool100000000;03oool3000000T0oooo00<00000
0?ooo`3oool02@3oool00`000000oooo0?ooo`3o0?ooofP0oooo0@00000002`0oooo00<000000?oo
o`3oool02@3oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0?l0ooooJ03oool10000
0000;03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo00T0oooo00<000000?ooo`3o
ool0o`3ooomX0?ooo`400000000]0?ooo`<00000203oool00`000000oooo0?ooo`090?ooo`030000
003oool0oooo0?l0ooooJ03oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003o
ool0oooo0?l0ooooJ03oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0
oooo0?l0ooooJ03oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo
0?l0ooooJ03oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0?l0
ooooJ03oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0?l0oooo
J03oool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0?l0ooooJ03o
ool100000000>03oool00`000000oooo0?ooo`090?ooo`030000003oool0oooo0?l0ooooJ03oool1
00000000>03oool2000000X0oooo00<000000?ooo`3oool0o`3ooomW0?ooo`800000000h0?ooo`03
0000003oool0oooo00T0oooo00<000000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000
003oool0oooo00T0oooo00<000000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003o
ool0oooo00T0oooo00<000000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003oool0
oooo00T0oooo00<000000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003oool0oooo
00T0oooo00<000000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003oool0oooo00T0
oooo00<000000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo
00<000000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo00<0
00000?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003oool0oooo00T0oooo00<00000
0?ooo`3oool0o`3ooomX0?ooo`400000000h0?ooo`030000003oool0oooo00@0oooo100000000`3o
ool000000?ooo`3o0?ooofT0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool010000000
oooo0?ooo`00003o0?ooofX0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool010000000
oooo0?ooo`00003o0?ooofX0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool010000000
oooo0?ooo`00003o0?ooofX0oooo0@00000003P0oooo0P0000070?ooo`040000003oool0oooo0000
0?l0ooooJ@3oool200000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooJP3oool100000000>03oool2000000L0oooo00@000000?ooo`3oool00000o`3ooomY0?oo
o`800000000h0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool00000o`3ooomZ0?oo
o`400000000h0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool00000o`3ooomZ0?oo
o`400000000h0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool00000o`3ooomZ0?oo
o`400000000h0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool00000o`3ooomZ0?oo
o`400000000h0?ooo`030000003oool0oooo00H0oooo00@000000?ooo`3oool00000o`3ooomP0?oo
o`@000001P3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooH@3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo00H0
oooo00@000000?ooo`3oool00000o`3ooomQ0?ooo`030000003oool0oooo00H0oooo0@00000003P0
oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`00003o0?ooof40oooo00<000000?oo
o`3oool01P3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooH@3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo00H0
oooo00@000000?ooo`3oool00000o`3ooomQ0?ooo`030000003oool0oooo00H0oooo0@00000003P0
oooo00<000000?ooo`3oool01P3oool010000000oooo0?ooo`00003o0?ooof40oooo00<000000?oo
o`3oool01P3oool100000000>03oool00`000000oooo0?ooo`060?ooo`040000003oool0oooo0000
0?l0ooooH@3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo00H0
oooo00@000000?ooo`3oool00000o`3ooomQ0?ooo`030000003oool0oooo00H0oooo0@00000003P0
oooo0P0000070?ooo`D00000o`3ooomP0?ooo`030000003oool0oooo00D0oooo0P00000003P0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooof80oooo00<000000?ooo`3oool0
1P3oool100000000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooHP3o
ool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool0o`3ooomR0?ooo`030000003oool0oooo00H0oooo0@00000003P0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`3o0?ooof40oooo0`0000070?ooo`400000000h0?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomQ0?ooo`<000001`3oool100000000
>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooH03oool01@000000oooo
0000003oool0000000H0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`3o0?oooel0oooo00@000000?ooo`3oool000000P3oool00`000000oooo0?ooo`030?ooo`40
0000000h0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomP0?ooo`050000
003oool000000?ooo`0000001P3oool100000000>03oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo0?l0ooooH03oool01@000000oooo0000003oool0000000H0oooo0@00000003P0oooo
00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooof40oooo0`0000070?ooo`400000
000h0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomR0?ooo`030000003o
ool0oooo00H0oooo0@00000002<0oooo0`0000030?ooo`030000003oool0oooo00<000002@3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooHP3oool00`000000oooo0?ooo`06
0?ooo`400000000R0?ooo`030000003oool0oooo00800000103oool00`000000oooo0?ooo`020000
00P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooof80oooo00<000000?oo
o`3oool01P3oool1000000009P3oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo00H0
oooo0`0000060?ooo`030000003oool0oooo0?l0ooooHP3oool00`000000oooo0?ooo`040?ooo`<0
0000000V0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool01P3oool00`000000oooo
0?ooo`060?ooo`030000003oool0oooo0?l0ooooHP3oool00`000000oooo0?ooo`060?ooo`400000
000U0?ooo`8000001`3oool2000000P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`3o0?ooof80oooo00<000000?ooo`3oool01P3oool1000000008`3oool3000000H0oooo0`000009
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomR0?ooo`030000003oool0
oooo00H0oooo0@00000002<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`090?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomR0?ooo`030000003oool0oooo
00H0oooo0@00000002<0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`090?ooo`03
0000003oool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomR0?ooo`030000003oool0oooo00H0
oooo0@00000002@0oooo0`0000060?ooo`<00000203oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo0?l0ooooHP3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0o`3ooomR0?ooo`030000003oool0oooo00H0oooo0@00
000003P0oooo00<000000?ooo`3oool00`3oool600000?l0ooooH@3oool4000000H0oooo0@000000
03P0oooo00<000000?ooo`3oool0103oool400000?l0ooooK03oool100000000>03oool00`000000
oooo0?ooo`040?ooo`H00000o`3ooomZ0?ooo`400000000h0?ooo`030000003oool0oooo00D0oooo
0P0000030?ooo`800000o`3ooomX0?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool0o`3ooom[0?ooo`400000000h0?ooo`8000001`3oool00`000000oooo0?ooo`07
0?ooo`800000o`3ooomQ0?ooo`800000000h0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool02@3oool200000?l0ooooH03oool100000000>03oool00`000000oooo0?ooo`060?ooo`03
0000003oool0oooo0?l0ooooJ`3oool100000000>03oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo00l0oooo00<000000?ooo`3oool0o`3ooomI0?ooo`400000000h0?ooo`030000003o
ool0oooo00H0oooo00<000000?ooo`3oool0403oool200000?l0ooooF@3oool100000000>03oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo0180oooo0P00003o0?oooeL0oooo0@000000
03P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooof/0oooo0@00000003P0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0H0?ooo`800000o`3ooomA0?ooo`40
0000000h0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool06P3oool300000?l0oooo
CP3oool100000000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooJ`3o
ool100000000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0?l0ooooJ`3oool1
00000000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo0240oooo0P00003o0?oo
odP0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0S0?ooo`80
0000o`3ooom60?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
o`3ooom[0?ooo`400000000h0?ooo`8000001`3oool00`000000oooo0?ooo`0Y0?ooo`030000003o
ool0oooo0?l0oooo?P3oool200000000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo02X0oooo0P00003o0?ooocl0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`0/0?ooo`800000o`3ooolm0?ooo`400000000h0?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0o`3ooom[0?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo
00<000000?ooo`3oool0<P3oool200000?l0oooo=`3oool100000000>03oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo03@0oooo0`00003o0?oooc@0oooo0@00000003P0oooo00<00000
0?ooo`3oool01P3oool00`000000oooo0?ooo`3o0?ooof/0oooo0@00000003P0oooo00<000000?oo
o`3oool01P3oool00`000000oooo0?ooo`0k0?ooo`030000003oool0oooo0?l0oooo;@3oool10000
0000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo03`0oooo0P00003o0?ooobd0
oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`0n0?ooo`030000
003oool0oooo0?l0oooo:P3oool100000000>03oool00`000000oooo0?ooo`060?ooo`030000003o
ool0oooo0?l0ooooJ`3oool100000000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0
oooo04<0oooo0P00003o0?ooobH0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`00
0000oooo0?ooo`150?ooo`<00000o`3ooolS0?ooo`400000000h0?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0o`3ooom[0?ooo`400000000h0?ooo`8000001`3oool00`000000oooo
0?ooo`3o0?ooofX0oooo0P00000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?oo
o`1<0?ooo`800000o`3ooolM0?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<00000
0?ooo`3oool0CP3oool200000?l0oooo6`3oool100000000>03oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo09/0oooo1000003;0?ooo`400000000h0?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0E@3oool00`000000oooo0?ooo`140?ooo`030000003oool0oooo0</0
oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1F0?ooo`800000
A03oool00`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<0
00000?ooo`3oool0F03oool00`000000oooo0?ooo`110?ooo`030000003oool0oooo0</0oooo0@00
000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`2L0?ooo`030000003oool0
oooo0</0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1M0?oo
o`800000?@3oool00`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo00H0
oooo00<000000?ooo`3oool0G`3oool3000003X0oooo00<000000?ooo`3oool0b`3oool100000000
>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo09`0oooo00<000000?ooo`3oool0
b`3oool100000000>03oool00`000000oooo0?ooo`060?ooo`030000003oool0oooo06H0oooo0P00
000d0?ooo`030000003oool0oooo0</0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool0
0`000000oooo0?ooo`1X0?ooo`800000<P3oool00`000000oooo0?ooo`3;0?ooo`400000000h0?oo
o`030000003oool0oooo00H0oooo00<000000?ooo`3oool0J@3oool00`000000oooo0?ooo`0`0?oo
o`030000003oool0oooo0</0oooo0@00000003P0oooo0P0000070?ooo`030000003oool0oooo09`0
oooo00<000000?ooo`3oool0bP3oool200000000>03oool00`000000oooo0?ooo`060?ooo`030000
003oool0oooo06l0oooo0P00000[0?ooo`030000003oool0oooo0</0oooo0@00000003P0oooo00<0
00000?ooo`3oool01P3oool00`000000oooo0?ooo`1a0?ooo`800000:@3oool00`000000oooo0?oo
o`3;0?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0W03oool0
0`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<000000?oo
o`3oool0M`3oool00`000000oooo0?ooo`0R0?ooo`030000003oool0oooo0</0oooo0@00000003P0
oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`1h0?ooo`8000008P3oool00`000000
oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool0
NP3oool200000200oooo00<000000?ooo`3oool0b`3oool100000000>03oool00`000000oooo0?oo
o`060?ooo`030000003oool0oooo09`0oooo00<000000?ooo`3oool0b`3oool100000000>03oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo0800oooo0P00000J0?ooo`030000003oool0
oooo0</0oooo0@00000003P0oooo00<000000?ooo`3oool01P3oool00`000000oooo0?ooo`220?oo
o`800000603oool00`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo00@0
oooo1000002M0?ooo`030000003oool0oooo0</0oooo0@00000003P0oooo00<000000?ooo`3oool0
Y@3oool00`000000oooo0?ooo`3;0?ooo`400000000/0?ooo`<000002@3oool00`000000oooo0?oo
o`2B0?ooo`8000004@3oool00`000000oooo0?ooo`3;0?ooo`400000000[0?ooo`8000000P3oool0
0`000000oooo0?ooo`060?ooo`030000003oool0oooo09@0oooo0P00000?0?ooo`030000003oool0
oooo0</0oooo0@00000002/0oooo00D000000?ooo`3oool0oooo000000080?ooo`<00000Y@3oool0
0`000000oooo0?ooo`390?ooo`<00000000[0?ooo`050000003oool0oooo0?ooo`000000203oool0
0`000000oooo0?ooo`2J0?ooo`8000002@3oool00`000000oooo0?ooo`3;0?ooo`400000000[0?oo
o`030000003oool0oooo00800000203oool00`000000oooo0?ooo`2L0?ooo`8000001`3oool20000
0<`0oooo0@00000002/0oooo100000090?ooo`030000003oool0oooo09h0oooo00<000000?ooo`3o
ool00`3oool300000<`0oooo0@00000002`0oooo00<000000?ooo`3oool02@3oool00`000000oooo
0?ooo`2T0?ooo`<00000c03oool100000000;03oool2000000X0oooo00<000000?ooo`3oool0X`3o
ool500000</0oooo0@00000002h0oooo0P0000080?ooo`030000003oool0oooo0:40oooo2000003:
0?ooo`400000000h0?ooo`030000003oool0oooo0:D0oooo00<000000?ooo`3oool0b`3oool10000
0000>03oool00`000000oooo0?ooo`2U0?ooo`030000003oool0oooo00<0oooo00<000000?ooo`3o
ool0a@3oool100000000>03oool00`000000oooo0?ooo`2U0?ooo`030000003oool0oooo00@0oooo
0P0000350?ooo`400000000h0?ooo`030000003oool0oooo0:D0oooo00<000000?ooo`3oool01P3o
ool200000<<0oooo0@00000003P0oooo00<000000?ooo`3oool0Y@3oool00`000000oooo0?ooo`3;
0?ooo`400000000h0?ooo`030000003oool0oooo0:D0oooo00<000000?ooo`3oool0b`3oool10000
0000>03oool00`000000oooo0?ooo`2U0?ooo`030000003oool0oooo0</0oooo0@00000003P0oooo
0P00002V0?ooo`030000003oool0oooo0<X0oooo0P00000003P0oooo00<000000?ooo`3oool0Y@3o
ool00`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo0:D0oooo00<00000
0?ooo`3oool0b`3oool100000000>03oool00`000000oooo0?ooo`2U0?ooo`030000003oool0oooo
0</0oooo0@00000003P0oooo00<000000?ooo`3oool0Y@3oool00`000000oooo0?ooo`3;0?ooo`40
0000000h0?ooo`030000003oool0oooo0:D0oooo00<000000?ooo`3oool0b`3oool100000000>03o
ool00`000000oooo0?ooo`2U0?ooo`030000003oool0oooo0</0oooo0@00000003P0oooo00<00000
0?ooo`3oool0Y@3oool00`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo
0:D0oooo00<000000?ooo`3oool0b`3oool100000000>03oool00`000000oooo0?ooo`2U0?ooo`03
0000003oool0oooo0</0oooo0@00000003P0oooo00<000000?ooo`3oool0Y@3oool00`000000oooo
0?ooo`3;0?ooo`400000000h0?ooo`030000003oool0oooo0:D0oooo00<000000?ooo`3oool0b`3o
ool100000000>03oool00`000000oooo0?ooo`2U0?ooo`030000003oool0oooo0</0oooo0@000000
03P0oooo00<000000?ooo`3oool0Y@3oool00`000000oooo0?ooo`3;0?ooo`400000000h0?ooo`80
0000YP3oool00`000000oooo0?ooo`3:0?ooo`800000000h0?ooo`030000003oool0oooo0:D0oooo
00<000000?ooo`3oool0b`3oool100000000>03oool00`000000oooo0?ooo`2U0?ooo`030000003o
ool0oooo0</0oooo0@00000003P0oooo00<000000?ooo`3oool0Y@3oool00`000000oooo0?ooo`3;
0?ooo`400000000h0?ooo`030000003oool0oooo0:D0oooo00<000000?ooo`3oool0b`3oool10000
0000>03oool00`000000oooo0?ooo`2U0?ooo`030000003oool0oooo0</0oooo0@00000003P0oooo
00<000000?ooo`3oool0Y03oool400000</0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3o
oomd0?ooo`400000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`00
0000oooo0?ooo`3o0?ooog@0oooo0@00000003P0oooo00<000000?ooo`3oool0o`3ooomd0?ooo`40
0000000h0?ooo`030000003oool0oooo0?l0ooooM03oool100000000>03oool00`000000oooo0?oo
o`3o0?ooog@0oooo0@00000003P0oooo0P00003o0?ooog@0oooo0P00000003P0oooo00<000000?oo
o`3oool0o`3ooomd0?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo00<000000?ooo`3o
ool04`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00P0oooo00<000000?ooo`3o
ool03P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0480oooo00<000000?ooo`3o
ool0`P3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooo`030000003oool0oooo00L0oooo
00<000000?ooo`3oool04`3oool00`000000oooo0?ooo`040?ooo`030000003oool0oooo00P0oooo
00<000000?ooo`3oool03P3oool00`000000oooo0?ooo`0M0?ooo`030000003oool0oooo0480oooo
00<000000?ooo`3oool0`P3oool00`000000oooo0?ooo`060?ooo`400000000h0?ooool00000N000
00000?l0oooo/03oool00?l0oooo/03oool00?l0oooo/03oool00?l0oooo/03oool00?l0oooo/03o
ool00?l0oooo/03oool00?l0oooo/03oool00?l0oooo/03oool003l0oooo0P0000030?ooo`800000
403oool3000000@0oooo00<000000?ooo`3oool0203oool3000000h0oooo0`00000O0?ooo`030000
003oool0oooo0400oooo0`0000310?ooo`D00000203oool003h0oooo00H000000?ooo`3oool00000
0?ooo`0000020?ooo`030000003oool0oooo00`0oooo00D000000?ooo`3oool0oooo000000030?oo
o`030000003oool0oooo00L0oooo0P0000020?ooo`030000003oool0oooo00X0oooo00<000000?oo
o`3oool00P00000N0?ooo`030000003oool0oooo03l0oooo00D000000?ooo`3oool0oooo00000030
0?ooo`050000003oool0oooo0?ooo`000000203oool003h0oooo00D000000?ooo`3oool0oooo0000
00030?ooo`030000003oool0oooo00`0oooo00D000000?ooo`3oool0oooo000000030?ooo`030000
003oool0oooo00L0oooo00D000000?ooo`3oool0oooo0000000@0?ooo`030000003oool0oooo01T0
oooo1@0000140?ooo`030000003oool0oooo0;l0oooo00<000000?ooo`3oool02@3oool003h0oooo
00H000000?ooo`3oool000000?ooo`0000020?ooo`030000003oool0oooo00`0oooo00<000000?oo
o`3oool00P0000040?ooo`030000003oool0oooo00H0oooo00D000000?ooo`3oool0oooo0000000@
0?ooo`030000003oool0oooo01T0oooo00@000000?ooo`3oool00000A@3oool00`000000oooo0?oo
o`300?ooo`030000003oool0oooo00P0oooo000o0?ooo`8000000`3oool200000100oooo0`000005
0?ooo`030000003oool0oooo00H0oooo00<000000?ooo`3oool00P00000?0?ooo`800000703oool0
0`000000oooo000000120?ooo`<00000a03oool00`000000oooo0?ooo`070?ooo`00E@3oool20000
0080oooo00<000000?ooo`3oool00`3oool00`000000oooo0?ooo`050?ooo`@000003P3oool30000
01d0oooo00<000000?ooo`000000A03oool00`000000oooo0?ooo`330?ooo`030000003oool0oooo
00H0oooo001E0?ooo`050000003oool0oooo0?ooo`0000001@3oool00`000000oooo0?ooo`060?oo
o`030000003oool0oooo00h0oooo00<000000?ooo`3oool07P3oool2000004D0oooo00<000000?oo
o`3oool0`P3oool00`000000oooo0?ooo`060?ooo`00E@3oool01@000000oooo0?ooo`3oool00000
0080oooo00D000000?ooo`3oool0oooo000000070?ooo`8000003`3oool00`000000oooo0?ooo`0N
0?ooo`800000@@3oool01@000000oooo0?ooo`3oool000000<00oooo00D000000?ooo`3oool0oooo
000000080?ooo`00EP3oool3000000<0oooo1@0000090?ooo`8000003P3oool3000001h0oooo00<0
00000?ooo`3oool0@03oool300000<80oooo0`0000090?ooo`00o`3ooon`0?ooo`00o`3ooon`0?oo
o`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?oo
o`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00o`3ooon`0?ooo`00\
\>"],
  ImageRangeCache->{{{105.188, 449.688}, {596.5, 183}} -> {-0.139629, \
4.44384, 0.000704478, 0.00722418}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"],

Cell["Graph with width 432 and offset 60", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Export["\<glue_nc.eps\>", glue, "\<EPS\>", 
      ImageSize \[Rule] 6.5*72]\)], "Input"],

Cell[BoxData[
    \("glue_nc.eps"\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(6\ 72\)], "Input"],

Cell[BoxData[
    \(432\)], "Output"]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 1024}, {0, 768}},
AutoGeneratedPackage->Automatic,
WindowSize->{641, 661},
WindowMargins->{{Automatic, 93}, {Automatic, 4}},
PrintingPageRange->{Automatic, Automatic},
PageHeaders->{{Cell[ 
        TextData[ {
          CounterBox[ "Page"]}], "PageNumber"], Inherited, Cell[ 
        TextData[ {
          ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
        TextData[ {
          ValueBox[ "FileName"]}], "Header"], Inherited, Cell[ 
        TextData[ {
          CounterBox[ "Page"]}], "PageNumber"]}},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"FirstPageHeader"->False,
"FirstPageFooter"->False,
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "bvds", \
"four", "talk"}, "glueball_plot.nb.ps", CharacterEncoding -> "ISO8859-1"],
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{
Cell[1717, 49, 90, 2, 27, "Input",
  InitializationCell->True],
Cell[1810, 53, 22, 0, 32, "Text"],
Cell[1835, 55, 246, 4, 59, "Input"],
Cell[2084, 61, 275, 5, 59, "Input"],
Cell[2362, 68, 39, 0, 32, "Text"],
Cell[2404, 70, 207, 4, 43, "Input"],
Cell[2614, 76, 27, 0, 32, "Text"],
Cell[2644, 78, 214, 4, 43, "Input"],
Cell[2861, 84, 1370, 24, 267, "Input"],

Cell[CellGroupData[{
Cell[4256, 112, 175, 5, 180, "Subtitle"],
Cell[4434, 119, 84335, 2237, 527, 33536, 1605, "GraphicsData", "PostScript", \
"Graphics"],
Cell[88772, 2358, 130, 3, 27, "Output"],
Cell[88905, 2363, 50, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[88980, 2367, 108, 2, 27, "Input"],
Cell[89091, 2371, 47, 1, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[89175, 2377, 38, 1, 27, "Input"],
Cell[89216, 2380, 37, 1, 27, "Output"]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

