(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[     71112,       2550]*)
(*NotebookOutlinePosition[     72029,       2579]*)
(*  CellTagsIndexPosition[     71985,       2575]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Dispersion Relations", "Subtitle"],

Cell["\<\
Brett van de Sande
September 13,1999\
\>", "Subsubtitle"],

Cell[BoxData[
    \(\(data = 
        Block[\n\t\t{x, fp = OpenRead["\<~/three/monster.out\>"], 
            info}, \n\t\tinfo = 
            Read[fp, Record, RecordSeparators -> "\<\n\n\>"]; \n\t\tx = 
            ReadList[fp, Number, 
              RecordLists -> True, \n\t\t\tRecordSeparators -> "\<\n\n\>"]; 
          Close[fp]; \n\t\t{info, Chop[\ x]}\n\ ];\)\)], "Input"],

Cell[CellGroupData[{

Cell["Results from Sept 24, 1999", "Section"],

Cell[BoxData[
    \(\(data = {"\<****** Eigenvalues for the 3+1 transverse lattice  ******\n\
Couplings: m^2 G^2 N box la1 la2 la3 la4\n la5 tau\n 0.001968 1.000000 \
0.428624 0.011618 -0.067586 436.679535 0.097118 181.795676 -0.795151 \
-0.701519\nOverall scale G^2 N/sigma = 1.202238e+01\nWinding number ( 0 0), \
o=1, multiplet=9\n along with o=-1 and multiplet=8\nExtrapolation using (K,p) \
= (16/2,8)  (16/2,6)  (20/2,6) \n  (26/2,6) \nEigenvalues are in units of \
sigma (or sqrt{sigma})\>", {{0, 0, 28.8063952495855`, 54.4142947216977`, 
              64.1066489163109`, 70.4169456911413`}, {0.013963`, 0, 
              28.8064686544906`, 54.41444830629629`, 64.1067402837252`, 
              70.4168981438754`}, {0.055851`, 0, 28.807569439694`, 
              54.4167516698204`, 64.108110451451`, 
              70.4161850987179`}, {0.125664`, 0, 28.8123332822556`, 
              54.4267241124258`, 64.1140418868779`, 
              70.4130950041748`}, {0.223402`, 0, 28.825108806694104`, 
              54.4535024357466`, 64.1299628627223`, 
              70.4047736919805`}, {0.349066`, 0, 28.8518079176741`, 
              54.5096282375259`, 64.1633004454032`, 
              70.3872224029875`}, {0.502655`, 0, 28.8995338897953`, 
              54.6105134548103`, 64.2230978762814`, 
              70.3553106775488`}, {0.684169`, 0, 28.9758429543625`, 
              54.773343736101594`, 64.3191848782443`, 
              70.30287638772191`}, {0.893609`, 0, 29.0874937021167`, 
              55.015112246521596`, 64.4605667271816`, 
              70.2231240238138`}, {1.130973`, 0, 29.2385949801778`, 
              55.34940133141261`, 64.6525786515358`, 
              70.1097736332286`}, {1.396263`, 0, 29.428205721623797`, 
              55.7814579906038`, 64.8924844946768`, 
              69.95962033279069`}, {1.689479`, 0, 29.6476922551499`, 
              56.3010825179189`, 65.1642486756354`, 
              69.7768337335471`}, {2.010619`, 0, 29.8785040795117`, 
              56.873143133462406`, 65.4359230413572`, 
              69.5776477810692`}, {2.359685`, 0, 30.091412767637703`, 
              57.427223004401704`, 65.6657794513764`, 
              69.3914983145216`}, {2.736676`, 0, 30.2485033006273`, 
              57.8536745960177`, 65.81811078207289`, 
              69.2551521993863`}, {3.141593`, 0, 30.309088124213098`, 
              58.022164233847995`, 65.8723750482896`, 69.2032252837806`}, {0, 
              0, 12.2245395753304`, 24.6879777773419`, 24.7012364301445`, 
              31.5932182528574`}, {0.013963`, 0, 12.2246486744401`, 
              24.688050034216097`, 24.701326714843603`, 
              31.593128069085502`}, {0.055851`, 0, 12.2262848657569`, 
              24.689132405102598`, 24.7026821525361`, 
              31.5917751197213`}, {0.125664`, 0, 12.233368010153601`, 
              24.6937894742562`, 24.708582299196298`, 
              31.5859045440172`}, {0.223402`, 0, 12.2523814157178`, 
              24.706060921512602`, 24.724680978539403`, 
              31.5700396888799`}, {0.349066`, 0, 12.2922022312287`, 
              24.730691399701698`, 24.7596202333131`, 
              31.536337379004998`}, {0.502655`, 0, 12.3636757449062`, 
              24.771552397994498`, 24.826230609575603`, 
              31.474384987728897`}, {0.684169`, 0, 12.478749216227701`, 
              24.830807415714`, 24.941640270679798`, 
              31.371260384644998`}, {0.893609`, 0, 12.6489392771363`, 
              24.913254693058203`, 25.1217199531889`, 
              31.2124625176508`}, {1.130973`, 0, 12.8828798123066`, 
              25.0301770049`, 25.3753400217996`, 
              30.9841736485914`}, {1.396263`, 0, 13.182718391394701`, 
              25.1905214610157`, 25.710286801828303`, 
              30.6767856839573`}, {1.689479`, 0, 13.5392731812722`, 
              25.393345310012002`, 26.1362881990419`, 
              30.2893781224613`}, {2.010619`, 0, 13.9263255871316`, 
              25.6262866234853`, 26.658871717776602`, 
              29.834766033536`}, {2.359685`, 0, 14.295608129433399`, 
              25.8612043136488`, 27.2671989661843`, 
              29.342839925674703`}, {2.736676`, 0, 14.576437874185`, 
              26.0489771024791`, 27.885080380166`, 
              28.850583645316902`}, {3.141593`, 0, 14.6867961810832`, 
              26.125114196789298`, 28.2063569037712`, 
              28.388933307593497`}, {0, 0, 28.8063952513307`, 
              33.0171095219595`, 54.4142947198176`, 
              64.1066489249001`}, {0.013963`, 0, 28.8065015207032`, 
              33.0172188586185`, 54.4142755722261`, 
              64.1067248618312`}, {0.055851`, 0, 28.8080952607562`, 
              33.0188588035722`, 54.4139882205871`, 
              64.1078636289941`}, {0.125664`, 0, 28.8149943548521`, 
              33.0259563582048`, 54.4127425914542`, 
              64.1127914968954`}, {0.223402`, 0, 28.8335113836597`, 
              33.0449949362503`, 54.4093854116933`, 
              64.1260043943736`}, {0.349066`, 0, 28.8722811746738`, 
              33.084804380324904`, 54.402290178612404`, 
              64.1536135452895`}, {0.502655`, 0, 28.941826472604202`, 
              33.1560403359837`, 54.3893355745983`, 
              64.202999081332`}, {0.684169`, 0, 29.0536697234613`, 
              33.2701477271601`, 54.36787772544341`, 
              64.282237800272`}, {0.893609`, 0, 29.218753633223898`, 
              33.4375979032555`, 54.3347523624157`, 
              64.3993232232408`}, {1.130973`, 0, 29.444917946266898`, 
              33.6652444484817`, 54.2864203044407`, 
              64.5610161729123`}, {1.396263`, 0, 29.733255524916`, 
              33.9527890967716`, 54.219514377872`, 
              64.7705253843852`}, {1.689479`, 0, 30.073448724702303`, 
              34.2886195910642`, 54.1322632176989`, 
              65.0226812191546`}, {2.010619`, 0, 30.4388270932275`, 
              34.6457386507159`, 54.0274116331552`, 
              65.2968809116026`}, {2.359685`, 0, 30.783016724952898`, 
              34.9792772416762`, 53.9167658050986`, 
              65.55341155336569`}, {2.736676`, 0, 31.0415074254403`, 
              35.2282235998737`, 53.8251740576359`, 
              65.74115465819841`}, {3.141593`, 0, 31.1422528479914`, 
              35.324936962856704`, 53.787323275601004`, 
              65.8125023943292`}, {0, 0, 31.5932182419047`, 
              36.8110826424311`, 60.665204323550405`, 
              63.771367140725204`}, {0.013963`, 0, 31.593296924386397`, 
              36.8110385133837`, 60.6652759201061`, 
              63.771423012936395`}, {0.055851`, 0, 31.594476994864902`, 
              36.8103765439044`, 60.6663496442254`, 
              63.772261052888304`}, {0.125664`, 0, 31.5995881793571`, 
              36.8075075417955`, 60.6709980254696`, 
              63.7758920768146`}, {0.223402`, 0, 31.6133290728568`, 
              36.799779587069004`, 60.6834770565864`, 
              63.78566405417659`}, {0.349066`, 0, 31.642207348827398`, 
              36.7834670953144`, 60.709618349870496`, 
              63.8062506421383`}, {0.502655`, 0, 31.694389882608`, 
              36.7537451843447`, 60.756555120512495`, 
              63.843622062196204`}, {0.684169`, 0, 31.7793994634455`, 
              36.7046445358161`, 60.8321519633861`, 
              63.9049842506303`}, {0.893609`, 0, 31.907583077429603`, 
              36.6289938201536`, 60.9439549696907`, 
              63.9986610031723`}, {1.130973`, 0, 32.0892747435603`, 
              36.518386337055006`, 61.0974027239139`, 
              64.1338526088845`}, {1.396263`, 0, 32.3335863047699`, 
              36.3632626568247`, 61.2929440546258`, 
              64.3200553871719`}, {1.689479`, 0, 32.646785675063896`, 
              36.1532942849992`, 61.5216721635247`, 
              64.56543766982941`}, {2.010619`, 0, 33.0302214618004`, 
              35.8784156939173`, 61.759614406337704`, 
              64.8720925576097`}, {2.359685`, 0, 33.4774433224575`, 
              35.5313405260074`, 61.964101375895396`, 
              65.222916165599`}, {2.736676`, 0, 33.9665488925264`, 
              35.1161380169444`, 62.0869486829453`, 
              65.55074089356759`}, {3.141593`, 0, 34.3489725483915`, 
              34.7622200408598`, 62.120561565196404`, 65.7019642934776`}, {0, 
              0, 12.2245395780715`, 24.7012364326116`, 31.593218240810003`, 
              32.468296683420796`}, {0.013963`, 0.013963`, 12.2247577682963`, 
              24.7014169825618`, 31.5930950836495`, 
              32.468267067836`}, {0.055851`, 0.055851`, 12.228030219077901`, 
              24.7041248295703`, 31.5912487704973`, 
              32.4678228737617`}, {0.125664`, 0.125664`, 12.2421980085344`, 
              24.715850179252`, 31.5832721040397`, 
              32.4658971174364`}, {0.223402`, 0.223402`, 12.280238584532698`, 
              24.747348701207898`, 31.5619887394774`, 
              32.4607054919255`}, {0.349066`, 0.349066`, 12.3599556468392`, 
              24.813432115191397`, 31.5180155693209`, 
              32.4497290527705`}, {0.502655`, 0.502655`, 12.5031977794889`, 
              24.9324395974282`, 31.4411019425954`, 
              32.429688140383604`}, {0.684169`, 0.684169`, 
              12.734260856623202`, 25.1251499163939`, 31.322593680792103`, 
              32.3965445948357`}, {0.893609`, 0.893609`, 13.077033709308`, 
              25.412808921490104`, 31.159187868737`, 
              32.345589856448605`}, {1.130973`, 1.130973`, 
              13.550360289971499`, 25.813816103481102`, 30.9582189666843`, 
              32.2713738448046`}, {1.396263`, 1.396263`, 14.161034364451199`, 
              26.3383600978457`, 30.7472518234272`, 
              32.164671365785`}, {1.689479`, 1.689479`, 14.8939055676461`, 
              26.979785120008103`, 30.6135292974656`, 
              31.981030207846`}, {2.010619`, 2.010619`, 15.6991124812658`, 
              27.7006232093714`, 30.9582166779307`, 
              31.3948659274747`}, {2.359685`, 2.359685`, 16.4785860589013`, 
              28.410218412777102`, 31.6935942906618`, 
              30.605147992058`}, {2.736676`, 2.736676`, 17.0801611623842`, 
              28.9336912551307`, 31.8733128885334`, 
              30.6838860345899`}, {3.141593`, 3.141593`, 17.3189625483066`, 
              29.087265705418602`, 31.964416214335`, 
              30.854258018790798`}, {0, 0, 28.8063951977449`, 
              54.414294720749695`, 64.1066489164713`, 
              70.0273998878148`}, {0.013963`, 0.013963`, 28.8065636538159`, 
              54.4143977400876`, 64.1067581967443`, 
              70.02764363207`}, {0.055851`, 0.055851`, 28.809088956373003`, 
              54.4159425693219`, 64.1083972785884`, 
              70.03129995206021`}, {0.125664`, 0.125664`, 28.8200174657543`, 
              54.422631840399404`, 64.1154972590376`, 
              70.0471492779274`}, {0.223402`, 0.223402`, 28.8493235567859`, 
              54.4406012350416`, 64.1345903244758`, 
              70.08986187840739`}, {0.349066`, 0.349066`, 
              28.910560907984898`, 54.478297674865`, 64.1747423646233`, 
              70.18010536054601`}, {0.502655`, 0.502655`, 
              29.019996891863002`, 54.5461655674362`, 64.2473801277513`, 
              70.3447205151397`}, {0.684169`, 0.684169`, 29.194889481055803`, 
              54.6559777420195`, 64.3659232978129`, 
              70.6166833953497`}, {0.893609`, 0.893609`, 29.4505678089379`, 
              54.819555589656005`, 64.5450783677555`, 
              71.0337754763649`}, {1.130973`, 1.130973`, 29.7961104415184`, 
              55.0464947526741`, 64.7995449946061`, 
              71.6332874441247`}, {1.396263`, 1.396263`, 30.228775875397602`, 
              55.340390166021`, 65.1416479979156`, 
              72.43810993262029`}, {1.689479`, 1.689479`, 
              30.728001647392098`, 55.6931687762203`, 65.57683856997029`, 
              73.4290780904172`}, {2.010619`, 2.010619`, 31.25069222435`, 
              56.078073528069005`, 66.0946466323966`, 
              74.49112071115539`}, {2.359685`, 2.359685`, 
              31.730320741972097`, 56.4443662658881`, 66.65013312282069`, 
              75.2434821547825`}, {2.736676`, 2.736676`, 32.0823987992921`, 
              56.7200586526478`, 67.13146905169569`, 
              75.5039319626157`}, {3.141593`, 3.141593`, 32.217730340606195`, 
              56.8272353755214`, 67.3404645616717`, 75.5646765069806`}, {0, 
              0, 24.687977787797003`, 31.593218227870203`, 32.5635931593796`, 
              50.4886914477777`}, {0.013963`, 0.013963`, 24.6881223081386`, 
              31.5933184211986`, 32.5634706850453`, 
              50.4888107240457`}, {0.055851`, 0.055851`, 24.6902897723688`, 
              31.594820479819`, 32.5616343214352`, 
              50.4905946686535`}, {0.125664`, 0.125664`, 24.6996718941445`, 
              31.6013156692026`, 32.5536875580123`, 
              50.4982143685178`}, {0.223402`, 0.223402`, 24.7248500587753`, 
              31.6186926007286`, 32.532379527873296`, 
              50.517888818662904`}, {0.349066`, 0.349066`, 24.7775736111114`, 
              31.65481449672`, 32.4878581077135`, 
              50.5558882616688`}, {0.502655`, 0.502655`, 24.8722896231431`, 
              31.718739335499603`, 32.408276104469294`, 
              50.6156152697766`}, {0.684169`, 0.684169`, 25.0253715275037`, 
              31.8191892851703`, 32.280975445414704`, 
              50.696128917127695`}, {0.893609`, 0.893609`, 
              25.253913043768698`, 31.9617730919286`, 32.0946988194562`, 
              50.7936193022086`}, {1.130973`, 1.130973`, 25.573734632439404`, 
              32.1437049364418`, 31.844117356853`, 
              50.9035383721352`}, {1.396263`, 1.396263`, 25.996131181147398`, 
              32.343113231855895`, 31.5398379057793`, 
              51.0207532062319`}, {1.689479`, 1.689479`, 26.522762343260098`, 
              32.5015292912643`, 31.2261552606003`, 
              51.138389287257596`}, {2.010619`, 2.010619`, 
              27.137172214207503`, 32.5241557999312`, 30.984441426882`, 
              51.247356240286905`}, {2.359685`, 2.359685`, 27.7877014735029`, 
              32.357566838693`, 30.8697494900556`, 
              51.3372704044475`}, {2.736676`, 2.736676`, 28.3467761987311`, 
              32.0939912381781`, 30.849612005882`, 
              51.3979683978867`}, {3.141593`, 3.141593`, 28.578578566108497`, 
              31.9644162152624`, 30.854258023607102`, 
              51.420193949149706`}, {0, 0, 28.806395269903604`, 
              33.0171095038056`, 54.41429472377`, 
              64.106648924051`}, {0.013963`, 0.013963`, 28.806586211885097`, 
              33.0173282443378`, 54.414460573592706`, 
              64.106874224376`}, {0.055851`, 0.055851`, 28.8094501118953`, 
              33.0206079964478`, 54.41694729838589`, 
              64.11024846915309`}, {0.125664`, 0.125664`, 
              28.821851428178704`, 33.0348019716321`, 54.427699389461104`, 
              64.1247556433566`}, {0.223402`, 0.223402`, 28.8551671323108`, 
              33.0728681795075`, 54.456456891978`, 
              64.162918407915`}, {0.349066`, 0.349066`, 28.9250659704322`, 
              33.1524294166218`, 54.5161874746534`, 
              64.2394264271324`}, {0.502655`, 0.502655`, 29.0509332699442`, 
              33.2946907588807`, 54.6216782607424`, 
              64.3666632531959`}, {0.684169`, 0.684169`, 29.254625660297002`, 
              33.5223256003519`, 54.7867677454639`, 
              64.5499710409955`}, {0.893609`, 0.893609`, 29.5580678289217`, 
              33.8559753933214`, 55.0198798028024`, 
              64.7868344210933`}, {1.130973`, 1.130973`, 29.9790276425562`, 
              34.309153997661596`, 55.3185171641894`, 
              65.0721589574744`}, {1.396263`, 1.396263`, 30.5243509106409`, 
              34.8815779819027`, 55.665916897859596`, 
              65.4047244750001`}, {1.689479`, 1.689479`, 31.1802387445212`, 
              35.5512677939935`, 56.0339473567757`, 
              65.78619347506401`}, {2.010619`, 2.010619`, 
              31.900195318204002`, 36.266345748317605`, 56.3826901312613`, 
              66.21857428230891`}, {2.359685`, 2.359685`, 32.593893342654`, 
              36.9387152472519`, 56.649753100976895`, 
              66.7030816043151`}, {2.736676`, 2.736676`, 33.1253922906881`, 
              37.4446651463357`, 56.790045774676`, 
              67.1637246193592`}, {3.141593`, 3.141593`, 33.3351161807483`, 
              37.6424317012254`, 56.827235351747696`, 
              67.3404645670626`}}};\)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["Analysis", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Short[Partition[data[\([2]\)], 16], 20]\)], "Input"],

Cell[BoxData[
    TagBox[\({\[LeftSkeleton]1\[RightSkeleton], {\[LeftSkeleton]1\
\[RightSkeleton]}, \[LeftSkeleton]4\[RightSkeleton], {\[LeftSkeleton]1\
\[RightSkeleton]}, {{0, 0, 28.806395269903604`, 33.0171095038056`, 
            54.41429472377`, 64.106648924051`}, {0.013963`, 0.013963`, 
            28.806586211885097`, 33.0173282443378`, 54.414460573592706`, 
            64.106874224376`}, {0.055851`, 0.055851`, 28.8094501118953`, 
            33.0206079964478`, 54.41694729838589`, 
            64.11024846915309`}, {0.125664`, 0.125664`, 28.821851428178704`, 
            33.0348019716321`, 54.427699389461104`, 
            64.1247556433566`}, {0.223402`, 0.223402`, 28.8551671323108`, 
            33.0728681795075`, 54.456456891978`, 
            64.162918407915`}, \[LeftSkeleton]7\[RightSkeleton], {2.010619`, 
            2.010619`, 31.900195318204002`, 36.266345748317605`, 
            56.3826901312613`, 66.21857428230891`}, {2.359685`, 2.359685`, 
            32.593893342654`, 36.9387152472519`, 56.649753100976895`, 
            66.7030816043151`}, {2.736676`, 2.736676`, 33.1253922906881`, 
            37.4446651463357`, 56.790045774676`, 
            67.1637246193592`}, {3.141593`, 3.141593`, 33.3351161807483`, 
            37.6424317012254`, 56.827235351747696`, 67.3404645670626`}}}\),
      (Short[ #, 20]&)]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(p1 = 
      Block[{dd, x, dim, dp = Partition[data[\([2]\)], 16], 
          winding = 0.171298, 
          rescale = 
            12.02238135}, \[IndentingNewLine] (*i\ is\ the\ loop\ through\ \
the\ various\ multiplets\[IndentingNewLine]\ 
            j\ is\ the\ loop\ through\ the\ states\ in\ a\ \(\(multiplet\)\(.\
\)\)\ *) Print[dim = Dimensions[dp]]; \[IndentingNewLine]Show[
          Sort[Flatten[
              Table[\[IndentingNewLine]dd = 
                  Map[{Sqrt[#[\([1]\)]^2 + #[\([2]\)]^2], #[\([2 + i]\)]} &, 
                    dp[\([j]\)]]; \[IndentingNewLine] (*\(Print[{i, j, 
                        dd}];\)*) \[IndentingNewLine]{Plot[
                    x^2\ /\((rescale\ winding)\) + dd[\([1, 2]\)], {x, 0, 
                      dd[\([\(-1\), 1]\)]}, 
                    PlotStyle \[Rule] {GrayLevel[0.9], Thickness[0.015]}, 
                    DisplayFunction \[Rule] Identity], 
                  ListPlot[dd, PlotJoined \[Rule] True, 
                    PlotStyle \[Rule] {If[
                          dp[\([j, \(-1\), 2]\)] \[Equal] 0.0, 
                          Hue[0, 0.75, 1], Hue[0.6, 0.75, 1]], 
                        Thickness[
                          0.0075]}, \[IndentingNewLine]DisplayFunction \
\[Rule] Identity]}, \[IndentingNewLine]{j, 
                  dim[\([1]\)]}, \[IndentingNewLine]{i, 
                  dim[\([3]\)] - 
                    2}]]], \[IndentingNewLine]PlotRange \[Rule] {12, 44}, 
          AspectRatio \[Rule] 1.0, DisplayFunction \[Rule] $DisplayFunction, 
          Axes \[Rule] 
            False, \[IndentingNewLine]TextStyle -> {FontFamily -> \
"\<Courier\>", FontSize -> 12}, 
          Frame \[Rule] True]\[IndentingNewLine]]\)], "Input"],

Cell[BoxData[
    \({8, 16, 6}\)], "Print"],

Cell[GraphicsData["PostScript", "\<\
%!
%%Creator: Mathematica
%%AspectRatio: 1 
MathPictureStart
/Mabs {
Mgmatrix idtransform
Mtmatrix dtransform
} bind def
/Mabsadd { Mabs
3 -1 roll add
3 1 roll add
exch } bind def
%% Graphics
%%IncludeResource: font Courier
%%IncludeFont: Courier
/Courier findfont 10  scalefont  setfont
% Scaling calculations
0.0238095 0.214361 -0.375 0.03125 [
[.02381 -0.0125 -5.59375 -11.375 ]
[.02381 -0.0125 5.59375 0 ]
[.23817 -0.0125 -5.59375 -11.375 ]
[.23817 -0.0125 5.59375 0 ]
[.45253 -0.0125 -5.59375 -11.375 ]
[.45253 -0.0125 5.59375 0 ]
[.66689 -0.0125 -5.59375 -11.375 ]
[.66689 -0.0125 5.59375 0 ]
[.88125 -0.0125 -5.59375 -11.375 ]
[.88125 -0.0125 5.59375 0 ]
[ 0 0 -0.125 0 ]
[-0.0125 .09375 -18.375 -5.6875 ]
[-0.0125 .09375 0 5.6875 ]
[-0.0125 .25 -18.375 -5.6875 ]
[-0.0125 .25 0 5.6875 ]
[-0.0125 .40625 -18.375 -5.6875 ]
[-0.0125 .40625 0 5.6875 ]
[-0.0125 .5625 -18.375 -5.6875 ]
[-0.0125 .5625 0 5.6875 ]
[-0.0125 .71875 -18.375 -5.6875 ]
[-0.0125 .71875 0 5.6875 ]
[-0.0125 .875 -18.375 -5.6875 ]
[-0.0125 .875 0 5.6875 ]
[ 0 0 -0.125 0 ]
[ 0 1 .125 0 ]
[ 1 0 .125 0 ]
[ 0 0 0 0 ]
[ 1 1 0 0 ]
] MathScale
% Start of Graphics
1 setlinecap
1 setlinejoin
newpath
0 g
.25 Mabswid
[ ] 0 setdash
.02381 0 m
.02381 .00625 L
s
gsave
.02381 -0.0125 -66.5938 -15.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(0) show
1.000 setlinewidth
grestore
.23817 0 m
.23817 .00625 L
s
gsave
.23817 -0.0125 -66.5938 -15.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(1) show
1.000 setlinewidth
grestore
.45253 0 m
.45253 .00625 L
s
gsave
.45253 -0.0125 -66.5938 -15.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(2) show
1.000 setlinewidth
grestore
.66689 0 m
.66689 .00625 L
s
gsave
.66689 -0.0125 -66.5938 -15.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(3) show
1.000 setlinewidth
grestore
.88125 0 m
.88125 .00625 L
s
gsave
.88125 -0.0125 -66.5938 -15.375 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(4) show
1.000 setlinewidth
grestore
.125 Mabswid
.06668 0 m
.06668 .00375 L
s
.10955 0 m
.10955 .00375 L
s
.15243 0 m
.15243 .00375 L
s
.1953 0 m
.1953 .00375 L
s
.28104 0 m
.28104 .00375 L
s
.32391 0 m
.32391 .00375 L
s
.36679 0 m
.36679 .00375 L
s
.40966 0 m
.40966 .00375 L
s
.4954 0 m
.4954 .00375 L
s
.53828 0 m
.53828 .00375 L
s
.58115 0 m
.58115 .00375 L
s
.62402 0 m
.62402 .00375 L
s
.70976 0 m
.70976 .00375 L
s
.75264 0 m
.75264 .00375 L
s
.79551 0 m
.79551 .00375 L
s
.83838 0 m
.83838 .00375 L
s
.92413 0 m
.92413 .00375 L
s
.967 0 m
.967 .00375 L
s
.25 Mabswid
0 0 m
1 0 L
s
0 .09375 m
.00625 .09375 L
s
gsave
-0.0125 .09375 -79.375 -9.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(15) show
1.000 setlinewidth
grestore
0 .25 m
.00625 .25 L
s
gsave
-0.0125 .25 -79.375 -9.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(20) show
1.000 setlinewidth
grestore
0 .40625 m
.00625 .40625 L
s
gsave
-0.0125 .40625 -79.375 -9.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(25) show
1.000 setlinewidth
grestore
0 .5625 m
.00625 .5625 L
s
gsave
-0.0125 .5625 -79.375 -9.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(30) show
1.000 setlinewidth
grestore
0 .71875 m
.00625 .71875 L
s
gsave
-0.0125 .71875 -79.375 -9.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(35) show
1.000 setlinewidth
grestore
0 .875 m
.00625 .875 L
s
gsave
-0.0125 .875 -79.375 -9.6875 Mabsadd m
1 1 Mabs scale
currentpoint translate
/MISOfy
{
    /newfontname exch def
    /oldfontname exch def

    oldfontname findfont
    dup length dict begin
        {1 index /FID ne {def} {pop pop} ifelse} forall
        /Encoding ISOLatin1Encoding def
        currentdict
    end

    newfontname exch definefont pop
} def

0 19.375 translate 1 -1 scale
63.000 12.500 moveto
%%IncludeResource: font Courier
%%IncludeFont: Courier
%%BeginResource: font Courier-MISO
%%BeginFont: Courier-MISO
/Courier /Courier-MISO MISOfy
%%EndFont
%%EndResource
%%IncludeResource: font Courier-MISO
%%IncludeFont: Courier-MISO
/Courier-MISO findfont 12.000 scalefont
[1 0 0 -1 0 0 ] makefont setfont
0.000 0.000 0.000 setrgbcolor
(40) show
1.000 setlinewidth
grestore
.125 Mabswid
0 .125 m
.00375 .125 L
s
0 .15625 m
.00375 .15625 L
s
0 .1875 m
.00375 .1875 L
s
0 .21875 m
.00375 .21875 L
s
0 .28125 m
.00375 .28125 L
s
0 .3125 m
.00375 .3125 L
s
0 .34375 m
.00375 .34375 L
s
0 .375 m
.00375 .375 L
s
0 .4375 m
.00375 .4375 L
s
0 .46875 m
.00375 .46875 L
s
0 .5 m
.00375 .5 L
s
0 .53125 m
.00375 .53125 L
s
0 .59375 m
.00375 .59375 L
s
0 .625 m
.00375 .625 L
s
0 .65625 m
.00375 .65625 L
s
0 .6875 m
.00375 .6875 L
s
0 .75 m
.00375 .75 L
s
0 .78125 m
.00375 .78125 L
s
0 .8125 m
.00375 .8125 L
s
0 .84375 m
.00375 .84375 L
s
0 .0625 m
.00375 .0625 L
s
0 .03125 m
.00375 .03125 L
s
0 .90625 m
.00375 .90625 L
s
0 .9375 m
.00375 .9375 L
s
0 .96875 m
.00375 .96875 L
s
.25 Mabswid
0 0 m
0 1 L
s
.02381 .99375 m
.02381 1 L
s
.23817 .99375 m
.23817 1 L
s
.45253 .99375 m
.45253 1 L
s
.66689 .99375 m
.66689 1 L
s
.88125 .99375 m
.88125 1 L
s
.125 Mabswid
.06668 .99625 m
.06668 1 L
s
.10955 .99625 m
.10955 1 L
s
.15243 .99625 m
.15243 1 L
s
.1953 .99625 m
.1953 1 L
s
.28104 .99625 m
.28104 1 L
s
.32391 .99625 m
.32391 1 L
s
.36679 .99625 m
.36679 1 L
s
.40966 .99625 m
.40966 1 L
s
.4954 .99625 m
.4954 1 L
s
.53828 .99625 m
.53828 1 L
s
.58115 .99625 m
.58115 1 L
s
.62402 .99625 m
.62402 1 L
s
.70976 .99625 m
.70976 1 L
s
.75264 .99625 m
.75264 1 L
s
.79551 .99625 m
.79551 1 L
s
.83838 .99625 m
.83838 1 L
s
.92413 .99625 m
.92413 1 L
s
.967 .99625 m
.967 1 L
s
.25 Mabswid
0 1 m
1 1 L
s
.99375 .09375 m
1 .09375 L
s
.99375 .25 m
1 .25 L
s
.99375 .40625 m
1 .40625 L
s
.99375 .5625 m
1 .5625 L
s
.99375 .71875 m
1 .71875 L
s
.99375 .875 m
1 .875 L
s
.125 Mabswid
.99625 .125 m
1 .125 L
s
.99625 .15625 m
1 .15625 L
s
.99625 .1875 m
1 .1875 L
s
.99625 .21875 m
1 .21875 L
s
.99625 .28125 m
1 .28125 L
s
.99625 .3125 m
1 .3125 L
s
.99625 .34375 m
1 .34375 L
s
.99625 .375 m
1 .375 L
s
.99625 .4375 m
1 .4375 L
s
.99625 .46875 m
1 .46875 L
s
.99625 .5 m
1 .5 L
s
.99625 .53125 m
1 .53125 L
s
.99625 .59375 m
1 .59375 L
s
.99625 .625 m
1 .625 L
s
.99625 .65625 m
1 .65625 L
s
.99625 .6875 m
1 .6875 L
s
.99625 .75 m
1 .75 L
s
.99625 .78125 m
1 .78125 L
s
.99625 .8125 m
1 .8125 L
s
.99625 .84375 m
1 .84375 L
s
.99625 .0625 m
1 .0625 L
s
.99625 .03125 m
1 .03125 L
s
.99625 .90625 m
1 .90625 L
s
.99625 .9375 m
1 .9375 L
s
.99625 .96875 m
1 .96875 L
s
.25 Mabswid
1 0 m
1 1 L
s
0 0 m
1 0 L
1 1 L
0 1 L
closepath
clip
newpath
.9 g
.015 w
.02381 .00702 m
.02464 .00702 L
.0254 .00702 L
.02627 .00702 L
.0271 .00702 L
.02856 .00702 L
.03016 .00703 L
.03191 .00704 L
.03377 .00705 L
.03711 .00708 L
.04055 .00711 L
.04378 .00715 L
.05113 .00726 L
.05862 .00742 L
.06548 .00759 L
.08092 .00809 L
.09435 .00866 L
.109 .00941 L
.13774 .0113 L
.16541 .01364 L
.19481 .01667 L
.22314 .02014 L
.2504 .02397 L
.2794 .02859 L
.30732 .03356 L
.33417 .03883 L
.36275 .04495 L
.39027 .05136 L
.41951 .05872 L
.44769 .06635 L
.47479 .07418 L
.50363 .08304 L
.53139 .0921 L
.55809 .10128 L
.58652 .11158 L
.61387 .12199 L
.64296 .13361 L
.67098 .14533 L
.69724 .15678 L
s
.02381 .3965 m
.02464 .3965 L
.0254 .3965 L
.02627 .3965 L
.0271 .3965 L
.02856 .39651 L
.03016 .39651 L
.03191 .39652 L
.03377 .39653 L
.03711 .39656 L
.04055 .39659 L
.04378 .39663 L
.05113 .39675 L
.05862 .3969 L
.06548 .39707 L
.08092 .39758 L
.09435 .39814 L
.109 .3989 L
.13774 .40079 L
.16541 .40312 L
.19481 .40616 L
.22314 .40962 L
.2504 .41345 L
.2794 .41807 L
.30732 .42304 L
.33417 .42831 L
.36275 .43444 L
.39027 .44085 L
.41951 .44821 L
.44769 .45583 L
.47479 .46366 L
.50363 .47253 L
.53139 .48158 L
.55809 .49076 L
.58652 .50106 L
.61387 .51148 L
.64296 .52309 L
.67098 .53481 L
.69724 .54626 L
s
.02381 .39691 m
.02464 .39691 L
.0254 .39691 L
.02627 .39692 L
.0271 .39692 L
.02856 .39692 L
.03016 .39693 L
.03191 .39694 L
.03377 .39695 L
.03711 .39697 L
.04055 .39701 L
.04378 .39705 L
.05113 .39716 L
.05862 .39731 L
.06548 .39749 L
.08092 .39799 L
.09435 .39856 L
.109 .39931 L
.13774 .4012 L
.16541 .40354 L
.19481 .40657 L
.22314 .41004 L
.2504 .41387 L
.2794 .41849 L
.30732 .42346 L
.33417 .42872 L
.36275 .43485 L
.39027 .44126 L
.41951 .44862 L
.44769 .45625 L
.47479 .46408 L
.50363 .47294 L
.53139 .48199 L
.55809 .49118 L
.58652 .50148 L
.61387 .51189 L
.64296 .52351 L
.67098 .53522 L
.69724 .54668 L
s
.02381 .5252 m
.02464 .5252 L
.0254 .5252 L
.02627 .5252 L
.0271 .5252 L
.02856 .52521 L
.03016 .52521 L
.03191 .52522 L
.03377 .52523 L
.03711 .52526 L
.04055 .52529 L
.04378 .52533 L
.05113 .52545 L
.05862 .5256 L
.06548 .52577 L
.08092 .52628 L
.09435 .52684 L
.109 .5276 L
.13774 .52949 L
.16541 .53182 L
.19481 .53486 L
.22314 .53832 L
.2504 .54216 L
.2794 .54677 L
.30732 .55174 L
.33417 .55701 L
.36275 .56314 L
.39027 .56955 L
.41951 .57691 L
.44769 .58453 L
.47479 .59236 L
.50363 .60123 L
.53139 .61028 L
.55809 .61946 L
.58652 .62976 L
.61387 .64018 L
.64296 .65179 L
.67098 .66351 L
.69724 .67496 L
s
.02381 .5252 m
.02464 .5252 L
.0254 .5252 L
.02627 .5252 L
.0271 .5252 L
.02856 .52521 L
.03016 .52521 L
.03191 .52522 L
.03377 .52523 L
.03711 .52526 L
.04055 .52529 L
.04378 .52533 L
.05113 .52545 L
.05862 .5256 L
.06548 .52577 L
.08092 .52628 L
.09435 .52684 L
.109 .5276 L
.13774 .52949 L
.16541 .53182 L
.19481 .53486 L
.22314 .53832 L
.2504 .54216 L
.2794 .54677 L
.30732 .55174 L
.33417 .55701 L
.36275 .56314 L
.39027 .56955 L
.41951 .57691 L
.44769 .58453 L
.47479 .59236 L
.50363 .60123 L
.53139 .61028 L
.55809 .61946 L
.58652 .62976 L
.61387 .64018 L
.64296 .65179 L
.67098 .66351 L
.69724 .67496 L
s
.02381 .61229 m
.02464 .61229 L
.0254 .61229 L
.02627 .61229 L
.0271 .61229 L
.02856 .6123 L
.03016 .6123 L
.03191 .61231 L
.03377 .61232 L
.03711 .61235 L
.04055 .61238 L
.04378 .61242 L
.05113 .61253 L
.05862 .61269 L
.06548 .61286 L
.08092 .61337 L
.09435 .61393 L
.109 .61468 L
.13774 .61657 L
.16541 .61891 L
.19481 .62194 L
.22314 .62541 L
.2504 .62924 L
.2794 .63386 L
.30732 .63883 L
.33417 .6441 L
.36275 .65023 L
.39027 .65663 L
.41951 .664 L
.44769 .67162 L
.47479 .67945 L
.50363 .68832 L
.53139 .69737 L
.55809 .70655 L
.58652 .71685 L
.61387 .72727 L
.64296 .73888 L
.67098 .7506 L
.69724 .76205 L
s
.02381 .61229 m
.02464 .61229 L
.0254 .61229 L
.02627 .61229 L
.0271 .61229 L
.02856 .6123 L
.03016 .6123 L
.03191 .61231 L
.03377 .61232 L
.03711 .61235 L
.04055 .61238 L
.04378 .61242 L
.05113 .61253 L
.05862 .61269 L
.06548 .61286 L
.08092 .61337 L
.09435 .61393 L
.109 .61468 L
.13774 .61657 L
.16541 .61891 L
.19481 .62194 L
.22314 .62541 L
.2504 .62924 L
.2794 .63386 L
.30732 .63883 L
.33417 .6441 L
.36275 .65023 L
.39027 .65663 L
.41951 .664 L
.44769 .67162 L
.47479 .67945 L
.50363 .68832 L
.53139 .69737 L
.55809 .70655 L
.58652 .71685 L
.61387 .72727 L
.64296 .73888 L
.67098 .7506 L
.69724 .76205 L
s
.02381 .65678 m
.02464 .65678 L
.0254 .65679 L
.02627 .65679 L
.0271 .65679 L
.02856 .65679 L
.03016 .6568 L
.03191 .65681 L
.03377 .65682 L
.03711 .65684 L
.04055 .65688 L
.04378 .65692 L
.05113 .65703 L
.05862 .65718 L
.06548 .65736 L
.08092 .65786 L
.09435 .65843 L
.109 .65918 L
.13774 .66107 L
.16541 .66341 L
.19481 .66644 L
.22314 .66991 L
.2504 .67374 L
.2794 .67836 L
.30732 .68333 L
.33417 .68859 L
.36275 .69472 L
.39027 .70113 L
.41951 .70849 L
.44769 .71612 L
.47479 .72395 L
.50363 .73281 L
.53139 .74187 L
.55809 .75105 L
.58652 .76135 L
.61387 .77176 L
.64296 .78338 L
.67098 .79509 L
.69724 .80655 L
s
.02381 .77535 m
.02464 .77535 L
.0254 .77535 L
.02627 .77535 L
.0271 .77535 L
.02856 .77535 L
.03016 .77536 L
.03191 .77537 L
.03377 .77538 L
.03711 .7754 L
.04055 .77544 L
.04378 .77548 L
.05113 .77559 L
.05862 .77575 L
.06548 .77592 L
.08092 .77642 L
.09435 .77699 L
.109 .77774 L
.13774 .77963 L
.16541 .78197 L
.19481 .785 L
.22314 .78847 L
.2504 .7923 L
.2794 .79692 L
.30732 .80189 L
.33417 .80716 L
.36275 .81328 L
.39027 .81969 L
.41951 .82705 L
.44769 .83468 L
.47479 .84251 L
.50363 .85137 L
.53139 .86043 L
.55809 .86961 L
.58652 .87991 L
.61387 .89032 L
.64296 .90194 L
.67098 .91366 L
.69724 .92511 L
s
.02381 .00702 m
.02499 .00702 L
.02605 .00702 L
.02729 .00702 L
.02846 .00702 L
.03053 .00703 L
.03279 .00704 L
.03527 .00706 L
.0379 .00708 L
.04262 .00713 L
.04749 .0072 L
.05205 .00728 L
.06244 .00751 L
.07305 .00782 L
.08274 .00816 L
.10458 .00917 L
.12357 .0103 L
.14429 .01181 L
.18493 .01559 L
.22406 .02026 L
.26565 .02633 L
.30571 .03326 L
.34426 .04093 L
.38527 .05016 L
.42475 .0601 L
.46273 .07063 L
.50315 .08289 L
.54206 .09571 L
.58342 .11043 L
.62326 .12568 L
.66159 .14134 L
.70238 .15907 L
.74164 .17718 L
.77939 .19555 L
.8196 .21614 L
.85828 .23697 L
.89942 .2602 L
.93905 .28364 L
.97619 .30654 L
s
.02381 .3965 m
.02499 .3965 L
.02605 .3965 L
.02729 .3965 L
.02846 .39651 L
.03053 .39651 L
.03279 .39653 L
.03527 .39654 L
.0379 .39656 L
.04262 .39662 L
.04749 .39668 L
.05205 .39676 L
.06244 .39699 L
.07305 .3973 L
.08274 .39765 L
.10458 .39865 L
.12357 .39979 L
.14429 .40129 L
.18493 .40507 L
.22406 .40974 L
.26565 .41581 L
.30571 .42274 L
.34426 .43041 L
.38527 .43964 L
.42475 .44959 L
.46273 .46012 L
.50315 .47238 L
.54206 .48519 L
.58342 .49991 L
.62326 .51517 L
.66159 .53083 L
.70238 .54855 L
.74164 .56666 L
.77939 .58503 L
.8196 .60563 L
.85828 .62645 L
.89942 .64969 L
.93905 .67312 L
.97619 .69603 L
s
.02381 .39691 m
.02499 .39691 L
.02605 .39692 L
.02729 .39692 L
.02846 .39692 L
.03053 .39693 L
.03279 .39694 L
.03527 .39696 L
.0379 .39698 L
.04262 .39703 L
.04749 .3971 L
.05205 .39718 L
.06244 .39741 L
.07305 .39771 L
.08274 .39806 L
.10458 .39907 L
.12357 .4002 L
.14429 .40171 L
.18493 .40549 L
.22406 .41016 L
.26565 .41623 L
.30571 .42316 L
.34426 .43083 L
.38527 .44006 L
.42475 .45 L
.46273 .46053 L
.50315 .47279 L
.54206 .48561 L
.58342 .50033 L
.62326 .51558 L
.66159 .53124 L
.70238 .54897 L
.74164 .56708 L
.77939 .58544 L
.8196 .60604 L
.85828 .62687 L
.89942 .6501 L
.93905 .67353 L
.97619 .69644 L
s
.02381 .5252 m
.02499 .5252 L
.02605 .5252 L
.02729 .5252 L
.02846 .52521 L
.03053 .52521 L
.03279 .52523 L
.03527 .52524 L
.0379 .52527 L
.04262 .52532 L
.04749 .52539 L
.05205 .52546 L
.06244 .52569 L
.07305 .526 L
.08274 .52635 L
.10458 .52735 L
.12357 .52849 L
.14429 .52999 L
.18493 .53377 L
.22406 .53844 L
.26565 .54451 L
.30571 .55144 L
.34426 .55911 L
.38527 .56834 L
.42475 .57829 L
.46273 .58882 L
.50315 .60108 L
.54206 .61389 L
.58342 .62862 L
.62326 .64387 L
.66159 .65953 L
.70238 .67725 L
.74164 .69536 L
.77939 .71373 L
.8196 .73433 L
.85828 .75515 L
.89942 .77839 L
.93905 .80182 L
.97619 .82473 L
s
.02381 .5252 m
.02499 .5252 L
.02605 .5252 L
.02729 .5252 L
.02846 .52521 L
.03053 .52521 L
.03279 .52523 L
.03527 .52524 L
.0379 .52527 L
.04262 .52532 L
.04749 .52539 L
.05205 .52546 L
.06244 .52569 L
.07305 .526 L
.08274 .52635 L
.10458 .52735 L
.12357 .52849 L
.14429 .52999 L
.18493 .53377 L
.22406 .53844 L
.26565 .54451 L
.30571 .55144 L
.34426 .55911 L
.38527 .56834 L
.42475 .57829 L
.46273 .58882 L
.50315 .60108 L
.54206 .61389 L
.58342 .62862 L
.62326 .64387 L
.66159 .65953 L
.70238 .67725 L
.74164 .69536 L
.77939 .71373 L
.8196 .73433 L
.85828 .75515 L
.89942 .77839 L
.93905 .80182 L
.97619 .82473 L
s
.02381 .61229 m
.02499 .61229 L
.02605 .61229 L
.02729 .61229 L
.02846 .6123 L
.03053 .6123 L
.03279 .61231 L
.03527 .61233 L
.0379 .61235 L
.04262 .6124 L
.04749 .61247 L
.05205 .61255 L
.06244 .61278 L
.07305 .61309 L
.08274 .61344 L
.10458 .61444 L
.12357 .61557 L
.14429 .61708 L
.18493 .62086 L
.22406 .62553 L
.26565 .6316 L
.30571 .63853 L
.34426 .6462 L
.38527 .65543 L
.42475 .66537 L
.46273 .67591 L
.50315 .68816 L
.54206 .70098 L
.58342 .7157 L
.62326 .73095 L
.66159 .74662 L
.70238 .76434 L
.74164 .78245 L
.77939 .80082 L
.8196 .82141 L
.85828 .84224 L
.89942 .86547 L
.93905 .88891 L
.97619 .91182 L
s
.02381 .61229 m
.02499 .61229 L
.02605 .61229 L
.02729 .61229 L
.02846 .6123 L
.03053 .6123 L
.03279 .61231 L
.03527 .61233 L
.0379 .61235 L
.04262 .6124 L
.04749 .61247 L
.05205 .61255 L
.06244 .61278 L
.07305 .61309 L
.08274 .61344 L
.10458 .61444 L
.12357 .61557 L
.14429 .61708 L
.18493 .62086 L
.22406 .62553 L
.26565 .6316 L
.30571 .63853 L
.34426 .6462 L
.38527 .65543 L
.42475 .66537 L
.46273 .67591 L
.50315 .68816 L
.54206 .70098 L
.58342 .7157 L
.62326 .73095 L
.66159 .74662 L
.70238 .76434 L
.74164 .78245 L
.77939 .80082 L
.8196 .82141 L
.85828 .84224 L
.89942 .86547 L
.93905 .88891 L
.97619 .91182 L
s
.02381 .63963 m
.02499 .63963 L
.02605 .63964 L
.02729 .63964 L
.02846 .63964 L
.03053 .63965 L
.03279 .63966 L
.03527 .63968 L
.0379 .6397 L
.04262 .63975 L
.04749 .63982 L
.05205 .6399 L
.06244 .64013 L
.07305 .64043 L
.08274 .64078 L
.10458 .64179 L
.12357 .64292 L
.14429 .64443 L
.18493 .64821 L
.22406 .65288 L
.26565 .65895 L
.30571 .66588 L
.34426 .67355 L
.38527 .68278 L
.42475 .69272 L
.46273 .70325 L
.50315 .71551 L
.54206 .72833 L
.58342 .74305 L
.62326 .7583 L
.66159 .77396 L
.70238 .79169 L
.74164 .8098 L
.77939 .82816 L
.8196 .84876 L
.85828 .86959 L
.89942 .89282 L
.93905 .91625 L
.97619 .93916 L
s
.02381 .64261 m
.02499 .64261 L
.02605 .64261 L
.02729 .64262 L
.02846 .64262 L
.03053 .64263 L
.03279 .64264 L
.03527 .64266 L
.0379 .64268 L
.04262 .64273 L
.04749 .6428 L
.05205 .64288 L
.06244 .64311 L
.07305 .64341 L
.08274 .64376 L
.10458 .64477 L
.12357 .6459 L
.14429 .64741 L
.18493 .65119 L
.22406 .65586 L
.26565 .66193 L
.30571 .66886 L
.34426 .67652 L
.38527 .68576 L
.42475 .6957 L
.46273 .70623 L
.50315 .71849 L
.54206 .73131 L
.58342 .74603 L
.62326 .76128 L
.66159 .77694 L
.70238 .79467 L
.74164 .81277 L
.77939 .83114 L
.8196 .85174 L
.85828 .87257 L
.89942 .8958 L
.93905 .91923 L
.97619 .94214 L
s
.02381 .65678 m
.02499 .65679 L
.02605 .65679 L
.02729 .65679 L
.02846 .65679 L
.03053 .6568 L
.03279 .65681 L
.03527 .65683 L
.0379 .65685 L
.04262 .6569 L
.04749 .65697 L
.05205 .65705 L
.06244 .65728 L
.07305 .65759 L
.08274 .65793 L
.10458 .65894 L
.12357 .66007 L
.14429 .66158 L
.18493 .66536 L
.22406 .67003 L
.26565 .6761 L
.30571 .68303 L
.34426 .6907 L
.38527 .69993 L
.42475 .70987 L
.46273 .7204 L
.50315 .73266 L
.54206 .74548 L
.58342 .7602 L
.62326 .77545 L
.66159 .79111 L
.70238 .80884 L
.74164 .82695 L
.77939 .84531 L
.8196 .86591 L
.85828 .88674 L
.89942 .90997 L
.93905 .9334 L
.97619 .95631 L
s
1 .25 .25 r
.0075 w
.02381 .00702 m
.0268 .00702 L
.03578 .00707 L
.05075 .00729 L
.0717 .00789 L
.09864 .00913 L
.13156 .01136 L
.17047 .01496 L
.21536 .02028 L
.26625 .02759 L
.32311 .03696 L
.38597 .0481 L
.45481 .0602 L
.52963 .07174 L
.61045 .08051 L
.69724 .08396 L
s
.02381 .3965 m
.0268 .3965 L
.03578 .39654 L
.05075 .39668 L
.0717 .39706 L
.09864 .39783 L
.13156 .39911 L
.17047 .40096 L
.21536 .40354 L
.26625 .40719 L
.32311 .4122 L
.38597 .41854 L
.45481 .42582 L
.52963 .43316 L
.61045 .43903 L
.69724 .44141 L
s
.02381 .39691 m
.0268 .39692 L
.03578 .39696 L
.05075 .39714 L
.0717 .39765 L
.09864 .39874 L
.13156 .40082 L
.17047 .40443 L
.21536 .41005 L
.26625 .41798 L
.32311 .42845 L
.38597 .44176 L
.45481 .45809 L
.52963 .4771 L
.61045 .49641 L
.69724 .50645 L
s
.02381 .5252 m
.0268 .5252 L
.03578 .52524 L
.05075 .52539 L
.0717 .52578 L
.09864 .52662 L
.13156 .52811 L
.17047 .5305 L
.21536 .53398 L
.26625 .53871 L
.32311 .54463 L
.38597 .55149 L
.45481 .5587 L
.52963 .56536 L
.61045 .57027 L
.69724 .57216 L
s
.02381 .5252 m
.0268 .5252 L
.03578 .52525 L
.05075 .52547 L
.0717 .52605 L
.09864 .52726 L
.13156 .52943 L
.17047 .53293 L
.21536 .53809 L
.26625 .54515 L
.32311 .55416 L
.38597 .5648 L
.45481 .57621 L
.52963 .58697 L
.61045 .59505 L
.69724 .5982 L
s
.02381 .61229 m
.0268 .61229 L
.03578 .61233 L
.05075 .61249 L
.0717 .61292 L
.09864 .61382 L
.13156 .61545 L
.17047 .61811 L
.21536 .62211 L
.26625 .62779 L
.32311 .63542 L
.38597 .64521 L
.45481 .65719 L
.52963 .67117 L
.61045 .68645 L
.69724 .69841 L
s
.02381 .61229 m
.0268 .61229 L
.03578 .61224 L
.05075 .61206 L
.0717 .61156 L
.09864 .61051 L
.13156 .60857 L
.17047 .60535 L
.21536 .60039 L
.26625 .59326 L
.32311 .58365 L
.38597 .57154 L
.45481 .55734 L
.52963 .54196 L
.61045 .52658 L
.69724 .51215 L
s
.02381 .65678 m
.0268 .65679 L
.03578 .65684 L
.05075 .65706 L
.0717 .65766 L
.09864 .6589 L
.13156 .66113 L
.17047 .66469 L
.21536 .66992 L
.26625 .67704 L
.32311 .68602 L
.38597 .69652 L
.45481 .70768 L
.52963 .7181 L
.61045 .72588 L
.69724 .7289 L
s
.02381 .77535 m
.0268 .77534 L
.03578 .77532 L
.05075 .77523 L
.0717 .77499 L
.09864 .77448 L
.13156 .77355 L
.17047 .77202 L
.21536 .76966 L
.26625 .7662 L
.32311 .76135 L
.38597 .75479 L
.45481 .7462 L
.52963 .73535 L
.61045 .72238 L
.69724 .71132 L
s
.25 .55 1 r
.02381 .00702 m
.02804 .00702 L
.04074 .00713 L
.0619 .00757 L
.09153 .00876 L
.12963 .01125 L
.17619 .01572 L
.23122 .02295 L
.29471 .03366 L
.36667 .04845 L
.44709 .06753 L
.53598 .09043 L
.63333 .1156 L
.73915 .13996 L
.85344 .15876 L
.97619 .16622 L
s
.02381 .3965 m
.02804 .3965 L
.04074 .39657 L
.0619 .39686 L
.09153 .39765 L
.12963 .3993 L
.17619 .40226 L
.23122 .40704 L
.29471 .41418 L
.36667 .42418 L
.44709 .43738 L
.53598 .45384 L
.63333 .47304 L
.73915 .49337 L
.85344 .51084 L
.97619 .51808 L
s
.02381 .39691 m
.02804 .39692 L
.04074 .397 L
.0619 .39737 L
.09153 .39835 L
.12963 .40042 L
.17619 .40414 L
.23122 .41016 L
.29471 .41915 L
.36667 .43168 L
.44709 .44807 L
.53598 .46812 L
.63333 .49064 L
.73915 .51282 L
.85344 .52918 L
.97619 .53398 L
s
.02381 .5252 m
.02804 .52521 L
.04074 .52528 L
.0619 .52563 L
.09153 .52654 L
.12963 .52846 L
.17619 .53187 L
.23122 .53734 L
.29471 .54533 L
.36667 .55613 L
.44709 .56965 L
.53598 .58525 L
.63333 .60158 L
.73915 .61657 L
.85344 .62757 L
.97619 .6318 L
s
.02381 .5252 m
.02804 .52521 L
.04074 .5253 L
.0619 .52568 L
.09153 .52672 L
.12963 .52891 L
.17619 .53284 L
.23122 .53921 L
.29471 .54869 L
.36667 .56184 L
.44709 .57889 L
.53598 .59938 L
.63333 .62188 L
.73915 .64356 L
.85344 .66017 L
.97619 .66672 L
s
.02381 .61229 m
.02804 .61229 L
.04074 .61234 L
.0619 .61254 L
.09153 .61308 L
.12963 .61421 L
.17619 .61621 L
.23122 .61935 L
.29471 .62381 L
.36667 .62949 L
.44709 .63572 L
.53598 .64067 L
.63333 .64138 L
.73915 .63617 L
.85344 .62794 L
.97619 .62389 L
s
.02381 .61229 m
.02804 .61228 L
.04074 .61223 L
.0619 .61198 L
.09153 .61131 L
.12963 .60994 L
.17619 .60753 L
.23122 .60383 L
.29471 .59872 L
.36667 .59244 L
.44709 .58585 L
.53598 .58167 L
.63333 .59244 L
.73915 .61542 L
.85344 .62104 L
.97619 .62389 L
s
.02381 .63963 m
.02804 .63963 L
.04074 .63962 L
.0619 .63956 L
.09153 .6394 L
.12963 .63905 L
.17619 .63843 L
.23122 .63739 L
.29471 .6358 L
.36667 .63348 L
.44709 .63015 L
.53598 .62441 L
.63333 .60609 L
.73915 .58141 L
.85344 .58387 L
.97619 .5892 L
s
.02381 .64261 m
.02804 .64261 L
.04074 .64255 L
.0619 .6423 L
.09153 .64164 L
.12963 .64025 L
.17619 .63776 L
.23122 .63378 L
.29471 .62796 L
.36667 .62013 L
.44709 .61062 L
.53598 .60082 L
.63333 .59326 L
.73915 .58968 L
.85344 .58905 L
.97619 .5892 L
s
.02381 .65678 m
.02804 .65679 L
.04074 .65689 L
.0619 .65734 L
.09153 .65853 L
.12963 .66101 L
.17619 .66546 L
.23122 .67257 L
.29471 .683 L
.36667 .69716 L
.44709 .71505 L
.53598 .73598 L
.63333 .75832 L
.73915 .77933 L
.85344 .79515 L
.97619 .80133 L
s
% End of Graphics
MathPictureEnd
\
\>"], "Graphics",
  ImageSize->{292, 292},
  ImageMargins->{{43, 0}, {0, 0}},
  ImageRegion->{{0, 1}, {0, 1}},
  ImageCache->GraphicsData["Bitmap", "\<\
CF5dJ6E]HGAYHf4PAg9QL6QYHg<PAVmbKF5d0`40004T000191000`40n007h00Ooooo9Ooo003ooolU
ool00?ooobGoo`00oooo9Ooo003ooolUool00?ooobGoo`00oooo9Ooo003ooolUool001[oo`<003Ko
o`D003Coo`D003Koo`<003Soo`<001ooo`006Ooo00D00?ooooooo`0003Ooo`03003ooooo03Coo`05
003oooooool0000eool01@00oooooooo0000>?oo00<00?ooool07_oo000Iool01@00oooooooo0000
=ooo00<00?ooool0=Ooo00<00?ooool0>_oo00<00?ooool0<_oo1P007ooo000Iool01@00oooooooo
0000=ooo00<00?ooool0=_oo00<00?ooool0>Ooo00<00?ooool0<_oo00D00?ooooooo`00023oo`00
6Ooo00D00?ooooooo`0003Ooo`03003ooooo03Ooo`03003ooooo03Koo`8003Koo`04003ooooo000P
ool001Woo`05003oooooool0000gool00`00ooooo`0dool01@00oooooooo0000>Ooo00<00?ooool0
=?oo00<00?oo00008?oo000Iool01@00oooooooo0000=ooo00<00?ooool0=?oo00D00?ooooooo`00
03Woo`03003ooooo03Coo`03003oo`00023oo`006Ooo00D00?ooooooo`0003Goo`<003Koo`05003o
ooooool0000eool01@00oooooooo0000=ooo0P008?oo000Jool3000hool00`00ooooo`0eool3000g
ool3000iool00`00ooooo`0Nool00?ooobGoo`00oooo9Ooo000Eoooo000?0001ool001Goo`03003o
oooo00;oob7W?0?oo`03003ooooo00Woo`03003ooooo00Soo`03003ooooo00Woo`03003ooooo00So
o`03003ooooo00Woo`03003ooooo00Soo`03003ooooo00Woo`03003ooooo00Woo`03003ooooo00So
o`03003ooooo00Woo`03003ooooo00Soo`03003ooooo00Woo`03003ooooo00Soo`03003ooooo00Wo
o`03003ooooo00Soo`03003ooooo00Woo`03003ooooo00Soo`03003ooooo00Woo`03003ooooo00So
o`03003ooooo00Koo`40007oo`005Ooo00<00?ooool00_oo00?W?3ao?7l073ao00?iinLlic`03nLl
eooo0@000Ooo000Eool00`00ooooo`02ool00nLl?7llO`0Y?7l=icc?ool10001ool001Goo`03003o
oooo00;ooakW?1DlO`?ii`[W?<Soo`40007oo`005Ooo00<00?ooool07_oo3NLl0_WW3cao0oWW2^Ll
`Ooo0@000Ooo000Eool00`00ooooo`0_ool5ic`>?7l4nNL7icbmool10001ool001Goo`03003ooooo
03Woo`;W?0dlO`?ii`KW?;Woo`40007oo`005Ooo0P00@Ooo00?W?3ao?7l02cao0_WW2>Ll/Ooo0P00
0Ooo000Eool00`00ooooo`15ool2ic`;?7l3nNL7icb^ool10001ool001Goo`03003ooooo04_oo`;W
?0XlO`?ii`KW?:[oo`40007oo`005Ooo00<00?ooool0D?oo0^Ll2Sao1?WW1^LlY?oo0@000Ooo000E
ool00`00ooooo`1Eool2ic`:?7l5nNL3icbQool10001ool001Goo`03003ooooo05[oo`;W?0TlO`Oi
i`03iccooooo09_oo`40007oo`005Ooo00<00?ooool0Gooo00?W?3ao?7l01cao2OWWV?oo0@000Ooo
000Eool00`00ooooo`1Sool2ic`9?7l;nNNAool10001ool001Goo`03003ooooo06Koo`?W?0TlO`gi
ih_oo`40007oo`005Ooo0P00Jooo1>Ll2Cao00?W??WWnNL03?WWPooo0P000Ooo000Eool00`00oooo
o`1^ool4ic`8?7l4ic`00ooonNOii`0<nNMmool10001ool001Goo`03003ooooo07;oo`CW?0PlO`CW
?0Cooa;iig;oo`40007oo`005Ooo00<00?ooool0M_oo1>Ll23ao1>Ll1_oo5oWWIooo0@000Ooo000E
ool00`00ooooo`1jool4ic`8?7l2ic`?oolSnNM@ool10001ool001Goo`03003ooooo07goo`GW?0Pl
O`03iccooooo01GooaWiidooo`40007oo`000ooo1@000_oo10001ooo00<00?ooool0POoo1NLl23ao
:ooo00?iioooool0C_oo0@000Ooo0005ool01@00oooooooo00001?oo00<00?ooool01?oo00<00?oo
ool0QOoo1NLl1caoNOoo0@000Ooo0005ool00`00ooooo`06ool00`00ooooo`04ool30027ool6ic`8
?7mdool20001ool000Goo`03003ooooo00Koo`03003ooooo00Coo`03003ooooo08[oo`OW?0PlOg7o
o`40007oo`001Ooo00<00?ooool00_oo10001ooo00<00?ooool0S?oo2NLl23aoKOoo0@000Ooo0005
ool00`00ooooo`02ool00`00ooooo`08ool00`00ooooo`2?ool:ic`8?7mYool10001ool000Goo`03
003ooooo00;oo`03003ooooo00Soo`03003ooooo09;oo`_W?0PlOfGoo`40007oo`000ooo0`001?oo
00<00?ooool02?oo00<00?ooool0UOoo3>Ll23aoHOoo0@000Ooo0005ool00`00ooooo`02ool50006
ool00`00ooooo`2Gool<ic`2ool8?7mMool10001ool001Goo`03003ooooo09[oo`cW?0;oo`XlOeSo
o`40007oo`005Ooo0P00W_oo2nLl1Ooo2SaoD_oo0P000Ooo000Eool00`00ooooo`2Pool;ic`7ool9
?7m?ool10001ool001Goo`03003ooooo0:;oo`cW?0Soo`XlOd[oo`40007oo`005Ooo00<00?ooool0
YOoo2nLl2ooo2SaoAOoo0@000Ooo000Eool00`00ooooo`2Wool<ic`=ool:?7m0ool10001ool001Go
o`03003ooooo0:[oo`_W?0ooo`/lOc_oo`40007oo`005Ooo00<00?ooool0[Ooo2nLl4_oo2Sao=_oo
0@000Ooo000Eool00`00ooooo`2_ool;ic`Eool:?7laool10001ool001Goo`03003ooooo0;7oo`_W
?1Soo`XlObcoo`40007oo`005Ooo0P00]?oo2nLl6ooo2cao9Ooo0P000Ooo000Eool00`00ooooo`2f
ool:ic`NoolF?7lFool10001ool001Goo`03003ooooo0;Soo`_W?23oob8lO`Goo`40007oo`005Ooo
00<00?ooool0^_oo3>Ll;_oo4Sao1?oo0@000Ooo000Eool00`00ooooo`2mool;ic`lool00caooooo
o`03ool10001ool001Goo`03003ooooo0<3oo`[W?43oo`40007oo`005Ooo00<00?ooool0`_oo2^Ll
?_oo0@000Ooo000Eool00`00ooooo`35ool9ic`lool10001ool001Goo`800<Soo`WW?3Woo`80007o
o`005Ooo00<00?ooool0bOoo2NLl>?oo0@000Ooo000Eool00`00ooooo`3;ool9ic`fool10001ool0
01Goo`03003ooooo0<goo`WW?3Coo`40007oo`005Ooo00<00?ooool0cooo2>Ll<ooo0@000Ooo000E
ool00`00ooooo`3Aool8ic`aool10001ool001Goo`03003ooooo0=?oo`SW?2ooo`40007oo`005Ooo
00<00?ooool0e?oo2NLl;Ooo0@000Ooo000Eool00`00ooooo`3Fool8ic`/ool10001ool001Goo`80
0=Woo`SW?2Woo`80007oo`005Ooo00<00?ooool0f_oo2>Ll:?oo0@000Ooo000Eool00`00ooooo`3L
ool7ic`Wool10001ool001Goo`03003ooooo0=goo`SW?2Goo`40007oo`005Ooo00<00?ooool0gooo
2>Ll8ooo0@000Ooo000Eool00`00ooooo`3Qool8ic`Qool10001ool000?oo`D000?oo`<000Ooo`03
003ooooo0>;oo`WW?1ooo`40007oo`000ooo00D00?ooooooo`0000;oo`05003oooooool00006ool0
0`00ooooo`3Tool8ic`Nool10001ool000Coo`03003ooooo00?oo`05003oooooool00006ool3003V
ool8ic`Kool20001ool000Goo`03003ooooo00;oo`05003oooooool00006ool00`00ooooo`3Xool8
ic`Jool10001ool000Koo`05003oooooool00003ool00`00ooooo`04ool00`00ooooo`3Yool9ic`H
ool10001ool000?oo`05003oooooool00002ool01@00oooooooo00001_oo00<00?ooool0jooo2NLl
5_oo0@000Ooo0003ool01@00oooooooo00000_oo00D00?ooooooo`0000Koo`03003ooooo0>goo`WW
?1Coo`40007oo`000ooo00D00?ooooooo`0000;oo`05003oooooool00006ool00`00ooooo`3_ool8
ic`Cool10001ool000Coo`<000Coo`<000Ooo`03003ooooo0?7oo`SW?17oo`40007oo`005Ooo00<0
0?ooool0looo2>Ll3ooo0@000Ooo000Eool2003eool9ic`<ool20001ool001Goo`03003ooooo0?Ko
o`SW?0coo`40007oo`005Ooo00<00?ooool0n?oo2>Ll2_oo0@000Ooo000Eool00`00ooooo`3jool8
ic`8ool10001ool001Goo`03003ooooo0?coo`OW?0Ooo`40007oo`005Ooo00<00?ooool0oOoo2>Ll
1Ooo0@000Ooo000Eool00`00ooooo`3oool8ic`3ool10001ool001Goo`03003ooooo0?ooo`;oo`KW
?0?oo`40007oo`005Ooo00<00?ooool0oooo0ooo1>Ll1?oo0@000Ooo000Eool2003oool6ool2ic`3
ool20001ool001Goo`03003ooooo0?ooo`_oo`40007oo`005Ooo00<00?ooool0oooo2ooo0@000Ooo
000Eool00`00ooooo`3oool;ool10001ool001Goo`03003ooooo0?ooo`_oo`40007oo`005Ooo00<0
0?ooool0oooo2ooo0@000Ooo000Eool00`00ooooo`3oool;ool10001ool001Goo`03003ooooo0?oo
o`_oo`40007oo`005Ooo0P00oooo2ooo0P000Ooo000Eool00`00ooooo`3oool;ool10001ool001Go
o`03003ooooo0?ooo`_oo`40007oo`005Ooo00<00?ooool0oooo2ooo0@000Ooo000Eool00`00oooo
o`3oool;ool10001ool001Goo`03003ooooo0?ooo`_oo`40007oo`005Ooo00<00?ooool0oooo2ooo
0@000Ooo000Eool00`00ooooo`3oool;ool10001ool001Goo`03003ooooo0?ooo`_oo`40007oo`00
5Ooo0P00oooo2ooo0P000Ooo000Eool00`00ooooo`3oool;ool10001ool001Goo`03003ooooo0?oo
o`_oo`40007oo`005Ooo00<00?ooool0oooo2ooo0@000Ooo000Eool00`00ooooo`3oool;ool10001
ool001Goo`03003ooooo00;oob?W?>Goo`40007oo`000ooo1@000_oo10001ooo00<00?ooool00_oo
00?W?3ao?7l0:Cao1NLleooo0@000Ooo0003ool01`00oooooooo003oo`0000Coo`03003ooooo00Co
o`03003ooooo00;oo`03ic`lOcao03LlO`[iilCoo`40007oo`001?oo00<00?ooool01ooo00<00?oo
ool01?oo0`000_oo7^Ll9Cao2?WW_?oo0P000Ooo0005ool00`00ooooo`06ool00`00ooooo`04ool0
0`00ooooo`0Nool=ic`2nNLQ?7l7nNNeool10001ool000Koo`04003oooooool40007ool00`00oooo
o`0_ool8ic`4nNLI?7lBnNNTool10001ool000?oo`05003oooooool00002ool00`00ooooo`08ool0
0`00ooooo`0iool5ic`3nNLI?7lEnNNKool10001ool000?oo`05003oooooool00002ool00`00oooo
o`08ool00`00ooooo`10ool5ic`2nNLJ?7l4oolDnNNAool10001ool000?oo`05003oooooool00002
ool00`00ooooo`08ool00`00ooooo`15ool5ic`3nNLI?7l9oolDnNN7ool10001ool000Coo`<000?o
o`D000Koo`03003ooooo04_oo`CW?0GiiaPlO`cooaGiiggoo`40007oo`005Ooo00<00?ooool0D?oo
1>Ll1_WW5cao4Ooo5_WWL_oo0@000Ooo000Eool00`00ooooo`1Eool4ic`7nNLG?7lEoolGnNMWool1
0001ool001Goo`8005_oo`?W?0WiiaHlOa_oob?iidooo`80007oo`005Ooo00<00?ooool0Gooo0^Ll
2OWW00?W?3ao?7l05Cao8?oo6OWWCooo0@000Ooo000Eool00`00ooooo`1Sool2ic`:nNL2ic`9?7l2
ool<?7laool00oWWooooo`1>ool10001ool001Goo`03003ooooo06Koo`CW?0[ii`;W?0PlO`Coo``l
Ogcoo`40007oo`005Ooo00<00?ooool0J_oo1NLl2_WW00?W?3ao?7l01Sao1_oo2caoMooo0@000Ooo
000Eool00`00ooooo`1^ool6ic`9nNL00nLl?7llO`06?7l7ool;?7mbool10001ool001Goo`03003o
oooo07;oo`KW?0Wii`03ic`lOcao00HlO`Woo`/lOfcoo`40007oo`005Ooo00<00?ooool0M_oo1^Ll
2OWW00?W?3ao?7l01Sao2_oo2caoIooo0@000Ooo000Eool2001kool6ic`9nNL00ooo?7llO`06?7l<
ool;?7mPool20001ool001Goo`03003ooooo07goo`OW?0Wii`XlO`coo`XlOegoo`40007oo`005Ooo
00<00?ooool0POoo1nLl2OWW00?oocao?7l01cao3Ooo2SaoF?oo0@000Ooo000Eool00`00ooooo`25
ool7ic`9nNL00ooo?7llO`08?7l=ool:?7mCool10001ool001Goo`03003ooooo08Ooo`[W?0Wii`03
oollOcao00LlO`koo`TlOdooo`40007oo`005Ooo00<00?ooool0R_oo2nLl2OWW00?oocao?7l023ao
3Ooo2SaoB_oo0@000Ooo000Eool00`00ooooo`2<ool>ic`9nNL00ooo?7llO`07?7l>ool:?7m5ool1
0001ool001Goo`03003ooooo093oo`kW?0[ii`XlO`koo``lOckoo`40007oo`005Ooo0P00U?oo3NLl
0_oo2oWW2Sao3Ooo43ao=Ooo0P000Ooo000Eool00`00ooooo`2Fool=ic`7ool8nNL9?7lAool@?7l^
ool10001ool001Goo`03003ooooo09Soo`kW?0coo`Cii`XlOaCooa0lObKoo`40007oo`005Ooo00<0
0?ooool0Vooo3NLl4Ooo00?iiooo?7l02Cao5ooo63ao5_oo0@000Ooo000Eool00`00ooooo`2Mool=
ic`:ool7nNL5ool<?7lGoolR?7l5ool10001ool001Goo`03003ooooo0:3oo`cW?0;oo`cii`[ooa0l
Ob3ooa8lO`Coo`40007oo`005Ooo00<00?ooool00_oo6>LlR?oo1^Ll3?WW6?oo43ao:?oo00<lOooo
ool00ooo0@000Ooo000Eool00`00ooooo`02ool00nLl?7llO`0B?7l2nNLGicabool<nNL2ic`Tool@
?7lVool10001ool001Goo`03003ooooo00;oo`03ic`lOcao02TlO`OW?6Soo`_ii`_W?2WooaPlOaKo
o`40007oo`005Ooo0P000ooo5>Ll9SaoFooo3?WW1ooo2nLl;_oo8Sao1?oo0P000Ooo000Eool00`00
ooooo`0GoolDic`2nNLE?7l4nNM<ool;nNL@ool;ic`loolB?7l4ool10001ool001Goo`03003ooooo
02[oo`OW?0?iia@lO`giicOoo`ciiaOoo`cW?4Woo`03?7oooooo00?oo`40007oo`005Ooo00<00?oo
ool0<_oo1NLl1?WW4cao3oWW:_oo2oWW7ooo3>LlCOoo0@000Ooo000Eool00`00ooooo`0iool5ic`6
nNLC?7l?nNLLool;nNLVool<ica;ool10001ool001Goo`03003ooooo047oo`CW?0Siia@lO`kii`ko
o`_iibkoo`cW?4Soo`40007oo`001?oo0`001?oo0`001ooo00<00?ooool0B?oo1NLl1OWW53ao7OWW
=Ooo3>LlA_oo0@000Ooo0003ool01@00oooooooo00000_oo00D00?ooooooo`0000Koo`03003ooooo
053oo`CW?0?iiaDlO`?ooaCiicOoo`cW?4Coo`40007oo`001ooo00@00?ooool000?oo`03003ooooo
00Coo`<005Coo`KW?0;ii`TlO`03nNLlOcao00TlOaciic3oo`_W?47oo`80007oo`001ooo00@00?oo
ool000?oo`03003ooooo00Coo`03003ooooo05Ooo`WW?0TlO`;ii``lO`_oob7iiagoo`[W?43oo`40
007oo`001Ooo0P000ooo00D00?ooooooo`0000Koo`03003ooooo05koo`OW?0TlO`?ii`/lOa3oobki
i`Soo`[W?3koo`40007oo`001ooo00@00?ooool000?oo`03003ooooo00Coo`03003ooooo063oo`Wi
i`TlO`Cii``lOb3ooaWii`[oo`WW?3coo`40007oo`001ooo00@00?ooool000?oo`03003ooooo00Co
o`03003ooooo05[oo`cii`SW?0TlO`Gii``lOc7oo`03nNOooooo00_oo`WW?3[oo`40007oo`000ooo
00D00?ooooooo`0000;oo`05003oooooool00006ool00`00ooooo`1Dool<nNL:ool8ic`U?7lYoolT
?7lVool10001ool000Coo`<000Coo`<000Ooo`03003ooooo04goo`giia7oocDlOacoodTlO`Goo`40
007oo`005Ooo00<00?ooool0AOoo4?WW2ooo5cao1>Ll2Cao0_oo1oWW73ao3ooo2Cao0ooo@Sao1?oo
0@000Ooo000Eool00`00ooooo`0nool?nNL:oolE?7l:ool:ic`9?7l3ool7nNL;?7l00oWW?7llO`1T
?7l5ool10001ool001Goo`8003Soo`oii`Oooa@lOaWoo`[W?0XlO`SoobllO`coo`SW?33oo`80007o
o`005Ooo00<00?ooool0<Ooo2_WW73ao9_oo3>Ll83ao0oWW2cao1?WW6?oo2>Ll;ooo0@000Ooo000E
ool00`00ooooo`0[ool2nNLQ?7lbool2ic`E?7l<ool>?7l00ooo?7llO`07?7lIool9ic`]ool10001
ool001Goo`03003ooooo023ooa`lOc[ooaPlO`;W?0;oo`TlO`SooadlOaKoo`WW?2_oo`40007oo`00
5Ooo00<00?ooool00_oo2NLl0oWW83ao@Ooo4cao0ooo3^Ll0ooo4cao1_oo5Sao4ooo2NLl:Ooo0@00
0Ooo000Eool00`00ooooo`02ool00nLl?7llO`0Y?7l5ic`eool??7lBool<ic`3ool<?7lBoolN?7l6
ool9ic`Wool10001ool001Goo`03003ooooo00;oo`03ic`lOcao040lOa_oo`llOagoo`OW?0/lO`03
oollOcao00PlOaCoobLlO`03iccooooo02?oo`40007oo`005Ooo00<00?ooool00_oo:NLl0_WW8Cao
2Ooo4Cao9Ooo2cao1>Ll2?oo2Cao5ooo@Cao1Ooo0@000Ooo000Eool2000SoolEic`=nNLM?7lEoolM
?7l;ic`:ool:?7lMoolg?7l3ool20001ool001Goo`03003ooooo02ooo`cW?5<lO`Goo`kW?0coo`Xl
Oagooc4lO`Goo`40007oo`005Ooo00<00?ooool0;OooBSao8?oo3>Ll3ooo2Cao2Ooo@Sao1?oo0@00
0Ooo000Eool00`00ooooo`02oolHic`6oom1?7l:oolS?7l<ool<ic`2ool/?7l@ool9ic`Gool00cao
ooooo`03ool10001ool001Goo`03003ooooo00;oo`03ic`lOcao04TlO`KW?1;iia3oodllOb7oo`WW
?1_oo`40007oo`005Ooo00<00?ooool00_oo00?W?3ao?7l0:Cao1nLl5_oo4^Ll3OWW8ooo73ao0^Ll
5Ooo33ao7?oo2>Ll6_oo0@000Ooo000Eool00`00ooooo`02ool00nLl?7llO`0:?7l/ic`EoolEic`:
nNLcool<ic`Fool@?7lEool9ic`Hool10001ool001Goo`03003ooooo00;oodCW?0oooaCW?003oooi
ioWW00Siic7oo`_W?1cooa0lO`ooo`WW?1Koo`40007oo`005Ooo0P000oooBNLl3ooo4nLl0_oo2_WW
;_oo3>Ll8Ooo43ao2Ooo2NLl4ooo0P000Ooo000Eool00`00ooooo`02ool00nLl?7llO`0L?7l00oWW
iccW?00]ic`>oolBic`3ool;nNL[ool;ic`WoolH?7l3ic`Cool10001ool001Goo`03003ooooo00;o
o`03ic`lOcao02TlObSW?0gooa7W?0Coo`kiibOoo`_W?2_oob8lO`Goo`40007oo`005Ooo00<00?oo
ool00_oo7^Ll5Cao0oWW8nLl2ooo4NLl2?oo3_WW8_oo2nLl>Ooo00?W?3ao?7l043ao1?oo0@000Ooo
000Eool00`00ooooo`0Rool9ic`2nNL??7l3nNLOic`<oolAic`;ool;nNLPool;ic`hool9ic`7ool0
0caoooooo`03ool10001ool001Goo`03003ooooo02ooo`GW?0hlO`CiiacW?0cooa3W?0koo`Wiiako
o`[W?3Woo`SW?0coo`40007oo`005Ooo00<00?ooool0>Ooo0^Ll3Cao1OWW6NLl3?oo4>Ll3ooo2OWW
7?oo2NLl>Ooo2>Ll2_oo0@000Ooo000Eool00`00ooooo`10ool00nLl?7llO`0;?7l7nNLFic`;ool@
ic`?ool9nNLJool:ic`hool8ic`8ool10001ool001Goo`03003ooooo04Goo`;W?0dlO`KiiaOW?0Wo
o`oW?17oo`WiiaOoo`[W?3Soo`OW?0Ooo`40007oo`005Ooo0P00C?oo0^Ll3Cao1_WW5>Ll2Ooo4>Ll
4Ooo3?WW4_oo2^Ll=ooo2>Ll1?oo0P000Ooo000Eool00`00ooooo`1@ool4ic`=?7l5nNLAic`:ool?
ic`Bool@nNL<ool:ic`gool8ic`3ool10001ool001Goo`03003ooooo05Goo`GW?0/lO`Oii`oW?0[o
o`kW?1Oooa3ii`Ooo`WW?3Ooo`KW?0?oo`40007oo`005Ooo00<00?ooool0F_oo1^Ll2Cao2OWW3>Ll
2ooo3>Ll7Ooo2OWW2?oo2NLl=_oo1>Ll1?oo0@000Ooo000Eool00`00ooooo`1Oool6ic`9?7l;nNL9
ic`:ool<ic`Qool00oWWooooo`09ool9ic`fool2ic`4ool10001ool001Goo`03003ooooo06Goo`CW
?0TlO`gii`OW?0Soo`gW?1koo`03nNOooooo00_oo`WW?3[oo`40007oo`001?oo0`000ooo10001ooo
00<00?ooool0JOoo1NLl2Cao00?W??WWnNL03?WW0^Ll2Ooo3>Ll5Ooo2OWW3_oo2NLl>?oo0@000Ooo
0003ool01`00oooooooo003oo`0000Coo`03003ooooo00Coo`03003ooooo06goo`GW?0PlO`GW?0ki
i`Koo`cW?0_ooa3iia7oo`WW?3Koo`40007oo`001ooo00<00?ooool01?oo00<00?ooool01?oo0`00
L?oo1^Ll23ao2>Ll4_WW2^Ll4?WW6ooo2^Ll<_oo0P000Ooo0007ool00`00ooooo`04ool00`00oooo
o`04ool00`00ooooo`1cool7ic`8?7l:ic`NnNLUool:ic`aool10001ool000Goo`8000?oo`@000Oo
o`03003ooooo07Koo`SW?0PlO`gW?0Coob?iiaOoo`[W?2ooo`40007oo`001ooo00@00?ooool000[o
o`03003ooooo07[oo`SW?0PlO`SW?0_ii`GW?1WiiaSoo`[W?2goo`40007oo`001ooo00@00?ooool0
00[oo`03003ooooo07goo`WW?0PlO`[ii`Soo`_W?0koo`03nNOooooo01[oo`SW?2coo`40007oo`00
0ooo00D00?ooooooo`0000;oo`03003ooooo00Soo`03003ooooo087oo`GW?0Cii`PlO`WW?0Ooo`cW
?2[oo`SW?2[oo`40007oo`001?oo0`000ooo1@001_oo00<00?ooool0Oooo3_WW2Sao1nLl1ooo2nLl
:_oo2>Ll:?oo0@000Ooo000Eool00`00ooooo`1hool>nNL3ool9ic`9?7l5ic`7ool<ic`Yool7ic`W
ool10001ool001Goo`03003ooooo06oooa3ii`goo`[W?0XlO`?W?0Ooo`_W?2Soo`SW?2Goo`40007o
o`005Ooo0P00I_oo5?WW5Ooo3NLl2Cao0^Ll1ooo2nLl9ooo2>Ll8_oo0P000Ooo000Eool00`00oooo
o`1MoolBnNLRool>ic`:?7l6ool;ic`Wool8ic`Qool10001ool001Goo`03003ooooo05Cooa;iibgo
oa7W?0TlO`Coo`_W?2Koo`WW?1ooo`40007oo`005Ooo00<00?ooool0AOoo6?WW>Ooo4^Ll2Sao00?o
onLlic`02NLl9_oo2>Ll7_oo0@000Ooo000Eool00`00ooooo`0goolNnNM3oolEic`:?7l9ic`Vool8
ic`Lool10001ool001Goo`03003ooooo00;oo`SW?27ooa_iieGooaOW?0TlO`SW?2Goo`SW?1[oo`40
007oo`005Ooo00<00?ooool00_oo00?W??WWnNL0<oWWIOoo5nLl0_oo2Sao1^Ll8ooo2NLl6?oo0@00
0Ooo000Eool00`00ooooo`02ool00nLlnNOii`0WnNL7ica]oolGic`4ool:?7l3ic`Sool8ic`Gool1
0001ool001Goo`8000?oocSW?6SooaOW?0Ooo``lOb7oo`SW?1Coo`80007oo`005Ooo00<00?ooool0
2Ooo>NLlHooo5^Ll1ooo0^Ll43ao6ooo1nLl5?oo0@000Ooo000Eool00`00ooooo`0RoolWicaNoolF
ic`8ool7ic`@?7lDool8ic`Bool10001ool001Goo`03003ooooo03;ooa_W?5gooaGW?0Soo`WW?0Co
oa0lO`koo`SW?13oo`40007oo`005Ooo00<00?ooool0>Ooo6>LlG?oo5NLl1ooo2NLl2_oo:Cao1Ooo
0@000Ooo000Eool00`00ooooo`11oolGicaGoolEic`7ool9ic`?oolS?7l4ool10001ool001Goo`03
003ooooo04SooaCW?5KooaCW?0Ooo`WW?27oo`OW?0Koo`03?7oooooo00?oo`40007oo`005Ooo00<0
0?ooool0C?oo5>LlE?oo5>Ll1ooo2>Ll8Ooo2>Ll2_oo0@000Ooo000Eool2001AoolGica@oolCic`7
ool8ic`Qool8ic`7ool20001ool001Goo`03003ooooo05OooaCW?4kooa?W?0Ooo`SW?27oo`OW?0Oo
o`40007oo`005Ooo00<00?ooool0Fooo5>LlCOoo4^Ll1_oo2NLl8?oo2>Ll1Ooo0@000Ooo000Eool0
0`00ooooo`1OoolDica;oolBic`6ool9ic`Pool8ic`3ool10001ool001Goo`03003ooooo06Kooa7W
?4[ooa7W?0Koo`WW?23oo`KW?0?oo`40007oo`005Ooo00<00?ooool0J_oo3nLlB_oo4NLl1_oo2NLl
7ooo1>Ll1?oo0@000Ooo000Eool00`00ooooo`1^ool>ica9oolBic`5ool9ic`Oool2ic`4ool10001
ool001Goo`03003ooooo07;oo`cW?4Wooa;W?0Goo`WW?2?oo`40007oo`005Ooo00<00?ooool0M_oo
3>LlAooo4^Ll1Ooo2>Ll8_oo0@000Ooo000Eool2001iool>ica5oolBic`5ool8ic`Oool20001ool0
01Goo`03003ooooo07_oo`kW?4Cooa7W?0Koo`OW?1ooo`40007oo`005Ooo00<00?ooool0OOoo4>Ll
@_oo4NLl1Ooo2>Ll7Ooo0@000Ooo000Eool00`00ooooo`21ool>ica2oolAic`5ool8ic`Kool10001
ool001Goo`03003ooooo08Goo`gW?47ooa3W?0Koo`OW?1[oo`40007oo`005Ooo00<00?ooool0ROoo
2nLl@?oo4NLl1Ooo2>Ll6?oo0@000Ooo0005ool30003ool30007ool00`00ooooo`2<ool;ic`ooolA
ic`5ool8ic`Fool10001ool000Koo`05003oooooool00003ool00`00ooooo`04ool00`00ooooo`2>
ool;ic`ooolAic`4ool9ic`Dool10001ool000;oo`H000;oo`05003oooooool00006ool3002Aool;
ic`noolAic`4ool8ic`Bool20001ool000;oo`05003oooooool00003ool01@00oooooooo00001_oo
00<00?ooool0Tooo3>Ll?Ooo4>Ll1Ooo2>Ll4Ooo0@000Ooo0003ool01000ooooo`000ooo00D00?oo
ooooo`0000Koo`03003ooooo09Koo`gW?3_ooa3W?0Goo`SW?0ooo`40007oo`001?oo00<00?oo0000
0ooo00D00?ooooooo`0000Koo`03003ooooo09Soo`gW?3_ooa3W?0Coo`WW?0goo`40007oo`001?oo
00<00?oo00000ooo00D00?ooooooo`0000Koo`03003ooooo09_oo`cW?3_ooa3W?0Coo`SW?0coo`40
007oo`001Ooo0P000ooo00D00?ooooooo`0000Koo`03003ooooo09ooo`[W?3_ooa3W?0Coo`SW?0[o
o`40007oo`001_oo00<00?ooool00_oo0`001ooo00<00?ooool0X_oo2NLl>_oo4NLl1?oo2>Ll2?oo
0@000Ooo000Eool00`00ooooo`2Tool:ic`iool@ic`5ool7ic`7ool10001ool001Goo`03003ooooo
0:Koo`[W?3Wooa3W?0Coo`SW?0Goo`40007oo`005Ooo0P00ZOoo2nLl=ooo4NLl1?oo2>Ll0_oo0P00
0Ooo000Eool00`00ooooo`2Zool;ic`goolAic`4ool6ic`3ool10001ool001Goo`03003ooooo0:go
o`_W?3Gooa7W?0Coo`CW?0Coo`40007oo`005Ooo00<00?ooool0[ooo2nLl=Ooo4>Ll1Ooo0^Ll1?oo
0@000Ooo000Eool00`00ooooo`2bool:ic`eool@ic`9ool10001ool001Goo`03003ooooo0;Coo`SW
?3Ooo`oW?0Soo`40007oo`005Ooo00<00?ooool0]ooo1>Ll>Ooo4>Ll1_oo0@000Ooo000Eool00`00
ooooo`2iool2ic`kool?ic`5ool10001ool001Goo`800?Woo`oW?0;oo`80007oo`005Ooo00<00?oo
ool0n_oo3NLl0ooo0@000Ooo000Eool00`00ooooo`3lool:ic`4ool10001ool001Goo`03003ooooo
0?goo`WW?0Coo`40007oo`005Ooo00<00?ooool0oooo2>Ll0ooo0@000Ooo000Eool00`00ooooo`3o
ool2ool6ic`3ool10001ool001Goo`03003ooooo0?ooo`?oo`CW?0Coo`40007oo`005Ooo00<00?oo
ool0oooo1Ooo0^Ll1?oo0@000Ooo000Eool00`00ooooo`3oool;ool10001ool001Goo`800?ooo`_o
o`80007oo`005Ooo00<00?ooool0oooo2ooo0@000Ooo000Eool00`00ooooo`3oool;ool10001ool0
01Goo`03003ooooo0?ooo`_oo`40007oo`005Ooo00<00?ooool0oooo2ooo0@000Ooo000Eool00`00
ooooo`3oool;ool10001ool001Goo`03003ooooo00Coo`03003ooooo03Koo`03003ooooo03Ooo`03
003ooooo03Ooo`03003ooooo03Koo`03003ooooo01goo`40007oo`005Ooo00<00?ooool01?oo00<0
0?ooool02?oo00<00?ooool02Ooo00<00?ooool02?oo00<00?ooool02Ooo00<00?ooool02?oo00<0
0?ooool02Ooo00<00?ooool02?oo00<00?ooool02Ooo00<00?ooool02?oo00<00?ooool02Ooo00<0
0?ooool02Ooo00<00?ooool02?oo00<00?ooool02Ooo00<00?ooool02?oo00<00?ooool02Ooo00<0
0?ooool02?oo00<00?ooool02Ooo00<00?ooool02?oo00<00?ooool02Ooo00<00?ooool02?oo00<0
0?ooool02Ooo00<00?ooool02?oo00<00?ooool01_oo0@000Ooo000Eoooo000?0001ool00?ooobGo
o`00oooo9Ooo003ooolUool00001\
\>"],
  ImageRangeCache->{{{0, 291}, {291, 0}} -> {-0.487912, 9.82376, 0.0173335, \
0.1189}}],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Export["\<~/three/disperse0++.eps\>", p1]\)], "Input"],

Cell[BoxData[
    \("~/three/disperse0++.eps"\)], "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 800}, {0, 600}},
WindowSize->{520, 455},
WindowMargins->{{57, Automatic}, {Automatic, 45}},
PrintingPageRange->{Automatic, Automatic},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"PostScriptOutputFile":>FrontEnd`FileName[{$RootDirectory, "home", "bvds", \
"three"}, "disperse.nb.ps", CharacterEncoding -> "ISO8859-1"],
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 40, 0, 64, "Subtitle"],
Cell[1782, 53, 67, 3, 71, "Subsubtitle"],
Cell[1852, 58, 379, 7, 123, "Input"],

Cell[CellGroupData[{
Cell[2256, 69, 45, 0, 54, "Section"],
Cell[2304, 71, 16711, 259, 5195, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[19052, 335, 27, 0, 34, "Section"],

Cell[CellGroupData[{
Cell[19104, 339, 72, 1, 27, "Input"],
Cell[19179, 342, 1351, 20, 200, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[20567, 367, 1745, 32, 411, "Input"],
Cell[22315, 401, 43, 1, 23, "Print"],
Cell[22361, 404, 48405, 2127, 300, 29840, 1893, "GraphicsData", "PostScript", \
"Graphics"],
Cell[70769, 2533, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[70936, 2541, 74, 1, 27, "Input"],
Cell[71013, 2544, 59, 1, 27, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

