(***********************************************************************

                    Mathematica-Compatible Notebook

This notebook can be used on any computer system with Mathematica 4.0,
MathReader 4.0, or any compatible application. The data for the notebook 
starts with the line containing stars above.

To get the notebook into a Mathematica-compatible application, do one of 
the following:

* Save the data starting with the line of stars above into a file
  with a name ending in .nb, then open the file inside the application;

* Copy the data starting with the line of stars above to the
  clipboard, then use the Paste menu command inside the application.

Data for notebooks contains only printable 7-bit ASCII and can be
sent directly in email or through ftp in text mode.  Newlines can be
CR, LF or CRLF (Unix, Macintosh or MS-DOS style).

NOTE: If you modify the data for this notebook not in a Mathematica-
compatible application, you must delete the line below containing the 
word CacheID, otherwise Mathematica-compatible applications may try to 
use invalid cache data.

For more information on notebooks and Mathematica-compatible 
applications, contact Wolfram Research:
  web: http://www.wolfram.com
  email: info@wolfram.com
  phone: +1-217-398-0700 (U.S.)

Notebook reader applications are available free of charge from 
Wolfram Research.
***********************************************************************)

(*CacheID: 232*)


(*NotebookFileLineBreakTest
NotebookFileLineBreakTest*)
(*NotebookOptionsPosition[   3599156,      72342]*)
(*NotebookOutlinePosition[   3600355,      72381]*)
(*  CellTagsIndexPosition[   3600311,      72377]*)
(*WindowFrame->Normal*)



Notebook[{

Cell[CellGroupData[{
Cell["Spectra for 3+1 transverse lattice", "Subtitle"],

Cell["Brett van de Sande", "Subsubtitle"],

Cell["\<\
All of the following are for spectra computed in 1999.  These all \
have the new form of the tau-interactions.\
\>", "Text"],

Cell[BoxData[
    \(cross[x_, y_, z_] := {Line[{{x, y - z}, {x, y + z}}], 
        Line[{{x - 0.1, y}, {x + 0.1, y}}]}\)], "Input",
  InitializationCell->True],

Cell[CellGroupData[{

Cell[BoxData[
    \(data = 
      Block[\n\t\t{x, fp = OpenRead["\<~/three/ttraj60.out\>"], 
          info}, \n\t\tinfo = 
          Read[fp, Record, RecordSeparators -> "\<\n\n\>"]; \n\t\tx = 
          ReadList[fp, Number, 
            RecordLists -> True, \n\t\t\tRecordSeparators -> "\<\n\n\>"]; 
        Close[fp]; \n\t\t{info, Chop[\ x]}\n\ ]\)], "Input"],

Cell[BoxData[
    \(OpenRead::"noopen" \(\(:\)\(\ \)\) 
      "Cannot open \!\(\"/home/bvds/three/ttraj60.out\"\)."\)], "Message"],

Cell[BoxData[
    \(General::"stream" \(\(:\)\(\ \)\) 
      "\!\($Failed\) is not a string, InputStream[ ], or OutputStream[ \
]."\)], "Message"],

Cell[BoxData[
    \(General::"stream" \(\(:\)\(\ \)\) 
      "\!\($Failed\) is not a string, InputStream[ ], or OutputStream[ \
]."\)], "Message"],

Cell[BoxData[
    \(General::"stream" \(\(:\)\(\ \)\) 
      "\!\($Failed\) is not a string, InputStream[ ], or OutputStream[ \
]."\)], "Message"],

Cell[BoxData[
    \(General::"stop" \(\(:\)\(\ \)\) 
      "Further output of \!\(General :: \"stream\"\) will be suppressed \
during this calculation."\)], "Message"],

Cell[BoxData[
    \({Read[$Failed, Record, RecordSeparators \[Rule] "\n\n"], 
      ReadList[$Failed, Number, RecordLists \[Rule] True, 
        RecordSeparators \[Rule] "\n\n"]}\)], "Output"]
}, Open  ]],

Cell[BoxData[
    \(\(d3 = data; \)\)], "Input"],

Cell[BoxData[
    \(\(d5 = data; \)\)], "Input"],

Cell[BoxData[
    \(data = {d3[\([1]\)], 
        Table[If[d3[\([2, i, 3]\)] < d5[\([2, i, 3]\)], d3[\([2, i]\)], 
            d5[\([2, i]\)]], {i, Length[d3[\([2]\)]]}]}\)], "Input"],

Cell[CellGroupData[{

Cell["data three/cbig41.out (old tau interactions)", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<******* Eigenvalues for the 3+1 transverse lattice  \
*******\\nCouplings:  m^2, G^2 N, t/a^2, la_1/a^2, la_2/a^2\\n             0  \
   1       2      3         4    \\n           la_3/a^2, la_4/a^2, la_5/a^2, \
tau     \\n             5        6         7         8      \\nUse chi^2 fit \
with 39 criteria and tolerance 0.01.\\nOverall scale from minimizing \
chi^2.\\nParity doublets (o,multi,state) with error for difference\\n  over \
average.\\n  ( 1, 5,0) and ( 1, 6,0), error 0.5\\n  (-1, 5,0) and (-1, 6,0), \
error 0.5\\n  ( 1, 7,0) and (-1, 4,0), error 0.5\\nSpectrum for P_perp a = \
(0,0), ( 0.25 0)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  \
(4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  \
(4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 2 \
2)\\nSpectrum for P_perp a = (0,0), ( 0.25 0.25)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4, 11 & 12,  1 & -1, 0.25 2 2 2)\\n  \
(4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & 13,  1 & -1, 0.25 2 2 2)\\n  \
(4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary spectra multiplets, 4 states, \
(o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  \
5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) .\\nAll spectra extrapolated \
using (K,p) = (16/2,8)  (16/2,6) \\n  (20/2,6)  (26/2,6) .\\nWinding \
potential using (n,K,p) = ( 2 0,20/2,4)  ( 2 0,20/2,6) \\n  ( 2 0,24/2,4)  ( \
2 0,32/2,4)  ( 3 0,19/2,5)  ( 3 0,19/2,7) \\n  ( 3 0,25/2,5)  ( 3 0,33/2,5)  \
( 4 0,18/2,6)  ( 4 0,18/2,8) \\n  ( 4 0,24/2,6)  ( 4 0,32/2,6) .\\nRoundness \
of winding using n = (2,2) and (K,p) = (16/2,6) \\n  (16/2,8)  (24/2,6)  \
(28/2,6) \\n  with error 2 (in G^2 N^2 units).\\nHeavy potential determined \
using (n,K,p,K_max) = ( 0 0,-34/2,2,4) \\n  ( 0 0,-34/2,4,4)  ( 0 \
0,-34/2,2,5)  ( 0 0,-40/2,2,4) \\n  ( 0 0,-50/2,2,5)  ( 0 0,-60/2,2,4)  ( 0 \
0,-60/2,2,6) ,\\n  L = 3 4 6 (all in G^2 N^2 units); with relative \
error=0.25.\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-17/2,3,4) \\n \
 ( 1 0,-17/2,5,4)  ( 1 0,-17/2,3,5)  ( 1 0,-33/2,3,4) \\n  ( 1 0,-33/2,3,5)  \
( 1 0,-55/2,3,4)  ( 1 0,-55/2,3,6) ,\\n  L=3 and error 0.5\\n  ( 1 \
1,-30/2,2,4)  ( 1 1,-30/2,4,4)  ( 1 1,-30/2,2,5) \\n  ( 1 1,-40/2,2,4)  ( 1 \
1,-50/2,2,5)  ( 1 1,-60/2,2,4) \\n  ( 1 1,-60/2,2,6) ,\\n  with L=3 and error \
0.5 (all in G^2 N^2 units).\\np-extrapolation using n=( 1 0) and (K,p) = \
(13/2,3)  (35/2,3) \\n  (13/2,5)  (29/2,5)  (13/2,7)  (17/2,7) .\\nResult \
format:\\n fit info, # steps, chi^2, and p damping, scale g^2 N/(a^2 \
sigma);\\n the 9 couplings  (G^2 N units);\\n   which couplings -- if any -- \
were fit;\\n winding and longitudinal string tension fits;\\n the n=(2,2) \
winding eigenvalue and\\n   the n=(1,0) (1,1) longitudinal eigenvalues (G^2 N \
units)\\n   showing measured value and derived value for each.\\n In each \
direction, the spectra for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["26.5882712499999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.938173839599999936`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.87142496099999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.595101999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0693890000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.207834999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.8611469999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0987579999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["3.50826999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.89617900000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", 
                    StyleBox["0.190481000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.894130000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.520561000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.195718999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.14688999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.607654999999999922`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.43988300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.694786999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.54333499999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.387461999999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0436570000000000035`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.135755999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["6.57126199999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.62508400000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29116300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.0541059999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.0908349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.881131000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.6805889999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.7096529999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.697239999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.8128890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7601050000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.26626599999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["22.5064110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5364630000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.720937000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.5767439999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6050379999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.678753000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.4225760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4593190000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.881449999999999889`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.606095999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.6112370000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.123337999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.5064110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5295190000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.554351000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1613840000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1894920000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.674301999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.5767439999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.5976169999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.500732999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.4225760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4316209999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.216966999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.8128890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.843052000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.723601000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.2636879999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.251066999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.302773999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.2128970000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.213614999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0172329999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["46.2723450000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3081120000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.85805699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["6.57126199999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.67893299999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29149099999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.6805889999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.739074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.701521999999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.8128890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7551650000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.692378999999999944`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.7933989999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7484410000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.539267000000000074`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.5064110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5585630000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.625553000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.5767439999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6168069999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.480546999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.4225760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4593739999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.441382999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6837830000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6738250000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.119439000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.5064110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5606419999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.650495000000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1613840000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2176230000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.674568999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.5767439999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6348439999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.696900999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.4225760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4773430000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.656916000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.0541059999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.1272109999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.876889999999999858`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.8128890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.825933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.156463`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.9371159999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8856830000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.61693200000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["36.2876290000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.3231609999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.426206999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["6.57126199999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.6805889999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7933989999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7911539999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.6993020000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8622829999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.0592310000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.8665160000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7049829999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.9513290000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.2045880000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.89403900000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1613840000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5509269999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.3731659999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.6950610000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.0541059999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9371159999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.2876290000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3297959999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.606095999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5881100000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.8159469999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9545470000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2636879999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9246469999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8816790000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.4281039999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6837830000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.0847280000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1359900000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.6591259999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5064110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.5767439999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4225760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3772490000000097`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.8128890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2723450000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2128970000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.318857000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "18", ",", 
                    StyleBox["23.0359151100000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.1743395270000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.0998200520000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.758426131100000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0762305991399999971`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.145899189099999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.88979676399999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.160810446500000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.65799560699999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["3.26840391300000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", 
                    StyleBox["0.234270000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.817809000000000096`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.253379999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.198641000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["2.52331599999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.887517000000000066`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.81913499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.08802700000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["1.9862210000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.72249300000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.12648999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.41188399999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["10.6711700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.7133109999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2794049999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.7955989999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8193340000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.720601999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.4475160000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4707630000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.70579199999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8009380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8215450000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.625642000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.6803419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6989530000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.565059999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.4980990000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5256720000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.837149999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.778280999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.806216999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.848168000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.8445939999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8405839999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.121771000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["24.6803419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7061080000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.782282999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.5279019999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5598800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.970872999999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.4980990000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5047160000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.200887999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.778280999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7926500000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.436258999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5177089999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5436319999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.787065000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.8670169999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8524540000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.442136999999999957`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.9474250000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9549409999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.228209000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9724800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9978989999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.771757000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.6711700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.7554839999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27991300000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.4475160000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4931699999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.693039999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8009380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7956089999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0808980000000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["29.5177089999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5731520000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.841644999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.6803419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7166360000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.55096500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.4980990000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5276590000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448726000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.778280999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8051099999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.407270999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.0993200000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1127030000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.203157999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.6803419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7328349999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.796869000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.5279019999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5918720000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.971086000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.4980990000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5368470000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.58821399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.778280999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8357299999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.87209500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.7955989999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8439620000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.734163999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.0409439999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.060119000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.291078999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5177089999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4953320000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.339679999999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["33.1550760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2568729999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.545317`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.6711700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4475160000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8009380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6911610000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4154680000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0079790000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.0850479999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.7624090000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.7815459999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.9401150000000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.4075270000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.437128000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.5279019999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5332419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9958210000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.2776039999999895`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.7955989999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1550760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0409439999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5719789999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8445939999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.9484029999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.0762540000000129`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.2535469999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8670169999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.2406229999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.5349590000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.261016999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["62.0993200000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.688837000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.5919289999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.187228000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6803419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4980990000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.778280999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.9073479999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5177089999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9724800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9474250000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6019500000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "19", ",", 
                    StyleBox["27.066448430000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02286874699999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.33848661700000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.784152312899999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00692483705899999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.217671824600000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.7517073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.081854579300000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["3.79561307800000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["2.23665398699999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", 
                    StyleBox["0.274681999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.794641000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0280279999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.190230000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.13448700000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.708281000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.10772499999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.40631900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.567814000000000085`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.441230000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00472299999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.20117799999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["9.85586600000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.90581700000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.39148300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.7480539999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7832110000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.979382000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.3023940000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.3005240000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0521009999999999973`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["27.9681110000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0335719999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82354100000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.1667190000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1828929999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.45056200000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.3558889999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3748649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.528617999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.8445739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8656080000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.585960999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.1658680000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.1731910000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.20399799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1667190000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1889390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.61897000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7013309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7264739999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.700420000000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.3558889999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3679409999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.335724`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.8445739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8416599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0811619999999999919`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["29.1439920000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1666290000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.63059099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8714390000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8609470000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.292260000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["44.9622830000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9866089999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.677627999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.6682389999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6634360000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.133801000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["9.85586600000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.95575700000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.39133200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.3023940000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2982329999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0579530000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["29.1439920000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1719639999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.389604000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9531719999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9586660000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0765229999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["21.1667190000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2019409999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490592999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.3558889999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3871869999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.435939999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.8445739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8535839999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.125503000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0950010000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1591809999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.893935999999999886`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1667190000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2082860000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.578960000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7013309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7516289999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.700581000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.3558889999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3866790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.42885800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.8445739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.871895999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.380551999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.7480539999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.8182749999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.978075999999999901`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9681110000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0976610000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.80443599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1439920000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1308459999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.183100000000000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.9429819999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9404429999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0353659999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["9.85586600000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.3023940000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9531719999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.113444000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0162620000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2282420000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.6387239999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3914699999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9637110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.446031000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.1739810000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.849492000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7013309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8829679999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1517199999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.1462389999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7480539999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9681110000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9429819999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7528329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.1658680000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.059555999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.2461360000000105`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.541149000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8714390000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5753099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2085819999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.2998249999999913`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0950010000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.202968000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.2141830000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.1456069999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1667190000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3558889999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8445739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6590369999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1439920000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9622830000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6682389999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5763890000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["30.9886416799999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.06664984999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["5.88022053300000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.865871999999999886`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0327389999999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.173139999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["14.0199790000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0607650000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["2.96450099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["2.30286999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", 
                    StyleBox["0.335779000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.678548999999999935`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.321636999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.190663`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.06948899999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.690517000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.7701690000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.96747399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.481474000000000046`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.356009999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.112968000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.108877000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.0515620000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.0962710000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.4124179999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.6624039999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.6918310000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.929629999999999867`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7706250000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7664590000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.131607999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.2931579999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.307468`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.452054000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.8122930000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8234489999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.352414000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.7540249999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.7707680000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.528932000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.7073759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7333789999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.82145500000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.6726039999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6829869999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.328017000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.8122930000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8333930000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.666570000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9338299999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9562719999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.708948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.7540249999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.7615699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.238361`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.7073759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7015899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.182789000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.2666739999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2848930000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.575574999999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.0502469999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0399290000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.325944999999999973`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.0349879999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0568579999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.690892999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4744080000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4577560000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.526059000000000054`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.0515620000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.140978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41236999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7706250000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7594940000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.175823999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.8444830000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8020040000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.670978999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.2666739999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3355490000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08792500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.8122930000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8406300000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.447599999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.7540249999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.7794349999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.401368999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.7073759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7100530000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0422789999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["54.0422519999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0392160000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.047956000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["21.8122930000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8484539999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571184000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9338299999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.978721000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.709080000000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.7540249999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.7772349999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.366617000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.7073759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7457649999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.606380999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.6624039999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7213509999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.931095999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2931579999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3247029999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.498266000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.2666739999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.225605999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.648690999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.8708329999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9101690000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.621341000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.0515620000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8444830000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7706250000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9949760000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.424637999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7488079999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5045010000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.9378319999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1421310000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.1520160000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.4532530000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.170047999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9338299999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.6221980000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3000119999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.7953129999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.6624039999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2931579999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8708329999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9866909999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6726039999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.661055000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3878559999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.5977580000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0502469999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5632999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.2113190000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1198510000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6793659999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.1915330000000103`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0860359999999893`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.5239150000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8122930000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.7540249999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7073759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0422519999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2666739999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0349879999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4744080000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.0246769999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["data three/tbig41.out (old tau interactions)", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<******* Eigenvalues for the 3+1 transverse lattice  \
*******\\nCouplings:  m^2, G^2 N, t/a^2, la_1/a^2, la_2/a^2\\n             0  \
   1       2      3         4    \\n           la_3/a^2, la_4/a^2, la_5/a^2, \
tau     \\n             5        6         7         8      \\nUse chi^2 fit \
with 39 criteria and tolerance 0.01.\\nOverall scale from fitting lowest \
state to lattice value.\\nParity doublets (o,multi,state) with error for \
difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error 0.5\\n  (-1, \
5,0) and (-1, 6,0), error 0.5\\n  ( 1, 7,0) and (-1, 4,0), error \
0.5\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  \
(4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  \
(4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 \
0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, 11 & \
12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & \
13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary \
spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  \
4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) \
.\\nAll spectra extrapolated using (K,p) = (16/2,8)  (16/2,6) \\n  (20/2,6)  \
(26/2,6) .\\nWinding potential using (n,K,p) = ( 2 0,20/2,4)  ( 2 0,20/2,6) \
\\n  ( 2 0,24/2,4)  ( 2 0,32/2,4)  ( 3 0,19/2,5)  ( 3 0,19/2,7) \\n  ( 3 \
0,25/2,5)  ( 3 0,33/2,5)  ( 4 0,18/2,6)  ( 4 0,18/2,8) \\n  ( 4 0,24/2,6)  ( \
4 0,32/2,6) .\\nRoundness of winding using n = (2,2) and (K,p) = (16/2,6) \\n \
 (16/2,8)  (24/2,6)  (28/2,6) \\n  with error 2 (in G^2 N^2 units).\\nHeavy \
potential determined using (n,K,p,K_max) = ( 0 0,-34/2,2,4) \\n  ( 0 \
0,-34/2,4,4)  ( 0 0,-34/2,2,5)  ( 0 0,-40/2,2,4) \\n  ( 0 0,-50/2,2,5)  ( 0 \
0,-60/2,2,4)  ( 0 0,-60/2,2,6) ,\\n  L = 3 4 6 (all in G^2 N^2 units); with \
relative error=0.25.\\nRoundness determined using (n,K,p,K_max) = ( 1 \
0,-17/2,3,4) \\n  ( 1 0,-17/2,5,4)  ( 1 0,-17/2,3,5)  ( 1 0,-33/2,3,4) \\n  ( \
1 0,-33/2,3,5)  ( 1 0,-55/2,3,4)  ( 1 0,-55/2,3,6) ,\\n  L=3 and error 0.5\\n \
 ( 1 1,-30/2,2,4)  ( 1 1,-30/2,4,4)  ( 1 1,-30/2,2,5) \\n  ( 1 1,-40/2,2,4)  \
( 1 1,-50/2,2,5)  ( 1 1,-60/2,2,4) \\n  ( 1 1,-60/2,2,6) ,\\n  with L=3 and \
error 0.5 (all in G^2 N^2 units).\\np-extrapolation using n=( 1 0) and (K,p) \
= (13/2,3)  (35/2,3) \\n  (13/2,5)  (29/2,5)  (13/2,7)  (17/2,7) .\\nResult \
format:\\n fit info, # steps, chi^2, and p damping, scale g^2 N/(a^2 \
sigma);\\n the 9 couplings  (G^2 N units);\\n   which couplings -- if any -- \
were fit;\\n winding and longitudinal string tension fits;\\n the n=(2,2) \
winding eigenvalue and\\n   the n=(1,0) (1,1) longitudinal eigenvalues (G^2 N \
units)\\n   showing measured value and derived value for each.\\n In each \
direction, the spectra for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "18", ",", 
                    StyleBox["214.699261099999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01198365400000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.919884919999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.595299971899999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0639569783900000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.191768653899999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["106.711571900000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0953655594700000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["32.3894997299999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.42095518300000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", 
                    StyleBox["0.20234399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.861983000000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.474835999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.199446000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.659332000000000029`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.409949999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.57183600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.816127000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0118120000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.499358000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.439956999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.916823999999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.2799999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.3561759999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.9397000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.9470769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9964819999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.90657600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.0041919999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0418790000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.45436100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.2315929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1576989999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.85161100000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.7089849999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7499599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.58125399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.5905039999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6317460000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.59154299999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["71.4271089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4794269999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.01899899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["80.1318649999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1369949999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.197956999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.7089849999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7440769999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35421199999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.1844909999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2252990000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.57478500000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.5905039999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6170810000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02560699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["71.4271089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4409919999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.53573700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.2315929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2744309999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.65317200000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["48.3534180000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3340489999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.747476999999999947`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["71.4495560000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4966050000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.81567499999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["72.6034199999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.6087990000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.207569999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.2799999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.432361999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.93988100000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.0041919999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0806649999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.47556500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.2315929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1549029999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.47974999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["41.8658739999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.8117949999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.043466`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.7089849999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7824540000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41761300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.5905039999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6477710000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10497700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["71.4271089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4774139999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.970640999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["88.5302390000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.5226929999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.145609999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.7089849999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7877230000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.51928100000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.1844909999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2661349999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.57534100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.5905039999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6686709999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.50826200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["71.4271089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.5091500000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.58300499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.9470769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0448049999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.88570400000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.2315929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2467889999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.293217999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.9770909999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9210429999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08148099999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["57.5569560000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5865969999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571931000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.2799999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0041919999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.8658739999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5441629999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.5500770000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.2107899999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["124.996930000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["120.92569099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["85.5291320000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["117.551081000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["121.547568999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["147.307730999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["45.1844909999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.8229310000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.0661590000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["136.714679999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.9470769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9770909999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5569560000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.471561000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1318649999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.391300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["121.193279000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["125.910886999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["48.3534180000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.60782399999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.877957000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["135.459302000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["88.5302390000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.565062000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["123.48695300000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["113.672093000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.7089849999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5905039999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4271089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.2341249999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2315929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4495560000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.6034199999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.8325530000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "35", ",", 
                    StyleBox["25.0849001800000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.25713627900000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.0538321340000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.746252149100000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0768335992599999961`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.166150237899999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.68339646899999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.173049981499999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.83874484799999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["3.97580190200000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", 
                    StyleBox["0.228262000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.792787000000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.257031000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.20712600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["3.4792679999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.973105999999999937`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.9655899999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.06543600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["2.92254399999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["2.66811100000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.821218`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["2.34881699999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["12.2799999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.322016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23585300000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.5556899999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.583044000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.804595999999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.8200889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8499750000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.8790519999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2792489999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.318736000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16148000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.7726539999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7932659999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.606272000000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1663569999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1951579999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.847153000000000133`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1744889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2035780000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.855631999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.0131910000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.011502999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0496530000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["24.7726539999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7957880000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.680474000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4219419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4519960000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.884035000000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1663569999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1802049999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.407336000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1744889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1867269999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.359980000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9425209999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9693029999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.78777499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.5219930000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5071599999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.43629800000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.4297860000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.438675000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.261462000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.7671729999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7924029999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.742124000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.2799999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.3640700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23642800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.8200889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8778509999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.849502000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2792489999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2718249999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.109186000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.9425209999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9399590000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0376750000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["24.7726539999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.807193999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.507972999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1663569999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2004990000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.502130999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1744889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2053330000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.453625999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.0745099999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0798479999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0784939999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["24.7726539999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.8256520000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.779437000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4219419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4820690000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.88429599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1663569999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2173609999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.750114999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1744889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2260180000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.757852999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.5556899999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.6124170000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.834281000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9211419999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9293130000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.120172999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9425209999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9822010000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.583578999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6863359999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7187600000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.476864000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.2799999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8200889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2792489999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0191420000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.7588040000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.1103939999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.3003429999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.8823689999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.290859000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.4462619999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.2663860000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.507973000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["35.4219419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1305580000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5051200000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.2410160000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.5556899999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6863359999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9211419999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.7144720000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0131910000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.4597720000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.0929639999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.3270930000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5219930000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3151520000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.0978790000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.516999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["63.0745099999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.4254149999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.7697019999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.4661210000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7726539999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1663569999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1744889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.7515199999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9425209999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7671729999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4297860000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.8237369999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["data three/straj1*.out", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 41 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nParity doublets (o,multi,state) with \
error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error \
0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, 4,0), \
error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  \
(4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  \
(4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 \
0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, 11 & \
12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & \
13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary \
spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  \
4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) \
.\\nAll spectra extrapolated using (K,p) = (16/2,8)  (16/2,6) \\n  (20/2,6)  \
(26/2,6) .\\nWinding potential using (n,K,p) = ( 2 0,20/2,4)  ( 2 0,20/2,6) \
\\n  ( 2 0,24/2,4)  ( 2 0,32/2,4)  ( 3 0,19/2,5)  ( 3 0,19/2,7) \\n  ( 3 \
0,25/2,5)  ( 3 0,33/2,5)  ( 4 0,18/2,6)  ( 4 0,18/2,8) \\n  ( 4 0,24/2,6)  ( \
4 0,32/2,6) .\\nRoundness of winding using (n,K,p) = ( 2 2,16/2,6) \\n  ( 2 \
2,16/2,8)  ( 2 2,24/2,6)  ( 2 2,28/2,6) \\n  with error 1; in G^2 N \
units.\\nHeavy potential determined using (n,K,p,K_max) =\\n  ( 0 \
0,-34/2,2,3)  ( 0 0,-34/2,4,3)  ( 0 0,-34/2,2,4.5) \\n  ( 0 0,-50/2,2,3)  ( 0 \
0,-50/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 0,-60/2,2,4.5) ,\\n L = 3 4 6 (all \
in G^2 N units); relative scale error=0.1.\\nRoundness determined using \
(n,K,p,K_max) = ( 1 0,-17/2,3,3) \\n  ( 1 0,-17/2,5,3)  ( 1 0,-17/2,3,4.5)  ( \
1 0,-33/2,3,3) \\n  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3)  ( 1 0,-55/2,3,4.5) \
\\n L=0 and error 0.1;\\n  ( 1 0,-17/2,3,3)  ( 1 0,-17/2,5,3)  ( 1 \
0,-17/2,3,4.5) \\n  ( 1 0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3) \
\\n  ( 1 0,-55/2,3,4.5) \\n L=2.5 and error 0.1;\\n  ( 1 0,-17/2,3,3)  ( 1 \
0,-17/2,5,3)  ( 1 0,-17/2,3,4.5) \\n  ( 1 0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( \
1 0,-55/2,3,3) \\n  ( 1 0,-55/2,3,4.5) \\n L=5 and error 0.1;\\n  ( 1 \
1,-30/2,2,3)  ( 1 1,-30/2,4,3)  ( 1 1,-30/2,2,4.5) \\n  ( 1 1,-40/2,2,3)  ( 1 \
1,-50/2,2,4.5)  ( 1 1,-60/2,2,3) \\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error \
0.1; all in G^2 N units.\\np-extrapolation using n=( 1 0) and (K,p) = \
(13/2,3) \\n  (35/2,3)  (45/2,3)  (13/2,5)  (29/2,5)  (13/2,7) \\n  (17/2,7) \
.\\nResult format:\\n Fit info, # steps, chi^2, and p damping, scale G^2 \
N/sigma.\\n The 10 couplings  (G^2 N units);\\n   which couplings -- if any \
-- were fit.\\n Winding potential and heavy souce potential fits.\\n \
Roundness of winding potential, 1 values, and roundness of\\n   heavy source \
potential, 4 values, (G^2 N units)\\n   showing measured value and derived \
value for each.\\n The rescaled spectrum for each P_perp*a and c^2 values.\\n \
Finally come the states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "39", ",", 
                    StyleBox["41.4422445300000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["7.54428482500000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.5452864500000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.180731414200000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0653762533299999937`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0507091459799999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.10238678300000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0191133503699999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.98134904340000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.453505627500000052`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.369015581599999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.180391999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.37498800000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.423221999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0966520000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.255193999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.215135999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.82355599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.01524799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.571353000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.68525999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.685706999999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.748087999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.957090999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.901346999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.18006600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.894422000000000139`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.703624`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12046099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.8658350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8928459999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.900065000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.2550219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.244119999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.363309000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.1913489999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1509089999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.34758899999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.0092159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.037846`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.95402199999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4717559999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4974549999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.856373999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.2206270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2374029999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.559045000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.8020709999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.7979250000000082`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.138152000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.0092159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0261029999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.56272599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.2838780000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.289191999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.177076000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4717559999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.470874000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.029407`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["63.2206270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2196369999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0329660000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["27.1913489999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2018479999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.349873000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.2157669999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2061449999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.320616000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.2790299999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.299475000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.681294999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.273540999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2655999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.264620999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7372329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12019599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.2550219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.233071999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.365721000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.1913489999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1411500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.836383000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.2256220000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2509249999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.421577000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0092159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0729770000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.06234800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["56.4717559999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4964069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.410716000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.2206270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.235524999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.248228000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["78.5841010000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.7576240000000105`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.89115600000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.0092159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0364390000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.453568000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.2838780000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2945549999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.177896999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4717559999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4967219999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.415972000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.2206270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2375169999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.281411999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.8658350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9196109999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.895985999999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1913489999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1814420000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.165065999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.2151599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2182710000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0518419999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["32.4001719999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6079369999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.4616699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.2550219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2256220000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3478240000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.927901999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.254605000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.360530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["114.032814999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["64.1046790000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.9999520000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.8379029999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.688081999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.2838780000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0342049999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.2878400000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.086246999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["17.8658350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2151599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4001719999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7859190000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.8020709999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.9161669999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.193990000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["107.114076000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.2157669999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.095339999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.3407030000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.620690000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["81.5528360000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.5556439999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.767607999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.191438000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.0092159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4717559999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2206270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5841010000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1913489999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2790299999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.273540999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5596730000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["166.542366899999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["7.45699075000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["7.06553017800000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.235472288799999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0883890923999999955`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0362607634100000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["16.1283887999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0235328831700000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.75062679249999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.737944007099999943`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.693740703899999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.215843000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.420680000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.240612000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0784080000000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.243893000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.182157000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.41435699999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2759879999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.602611000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.445781000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.665331000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.523271000000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.913410999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.682416`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.26200800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.568644000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6815250000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.281217000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.6677479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6716259999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0946250000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["14.8187110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8225519999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0937069999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["19.0823450000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0800079999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0570360000000000066`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["20.8798150000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.891411999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.282972000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.1976500000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2167730000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.466612000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7859740000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.791705999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.139853000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2569080000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.251992999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.119911000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.8798150000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.8887050000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.216908999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1969220000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2015299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.112424999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.1976500000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1951139999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0618710000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["42.7859740000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7837060000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0553310000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["19.8748369999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8811430000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.153878999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3941259999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3886269999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.134182999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["39.4932000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.503098999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.241556999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1089879999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1094430000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0111050000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6930260000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.280928000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.8187110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8263919999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0937119999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["19.0963749999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0900749999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0768639999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["19.8748369999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8657460000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.110909999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.8798150000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.9026220000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.278249000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.1976500000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2092600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.141654999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7859740000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7990830000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.159932999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.5389510000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6132369999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.906319000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.8798150000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.8979880000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.221714000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1969220000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2061400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.112457000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.1976500000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2190590000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.261206000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7859740000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7797120000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0763999999999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["13.6677479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6755329999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0949760000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["19.0823450000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0772599999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0620340000000000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["19.8748369999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8754980000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00807000000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["30.4536430000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4582029999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0556349999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8187110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0963749999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9489219999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8059069999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8258479999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5302839999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.5895759999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.4024059999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0591929999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.0235799999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4821819999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1969220000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9447410000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.7156219999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.9320010000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6677479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0823450000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4536430000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.0679420000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2569080000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3873329999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.7778420000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6302979999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3941259999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.0491080000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.8783609999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3337379999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4489220000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.4992290000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.7898249999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.874667000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.8798150000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1976500000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7859740000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5389510000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8748369999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4932000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1089879999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3086620000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "20", ",", 
                    StyleBox["21.7028857599999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.61733119600000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.2026711099999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.484410333800000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0236843751400000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0719196455499999931`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["297.390539299999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.101769289799999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["118.941264499999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.808167870800000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.716652990199999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.194029000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.843271999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.661498000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0984860000000000113`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.190045999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.12754399999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.34583699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.79164999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.582138000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.650190999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.646354999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.71179199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.897055999999999897`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.863752999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.05564400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.859065999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7043499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19464999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.1698849999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.191783`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.761569999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.3882580000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4122470000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.834315999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.500558999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4927880000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.270251000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.200790999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.222456000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.753499999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.7125849999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.755457999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.49104299999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["63.7430439999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7722570000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01601099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["69.6693149999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6544020000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.51864100000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.200790999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2335390000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13894699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.2152269999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.2482230000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14754700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.7125849999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7064159999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.214549999999999974`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["63.7430439999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7676420000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.855499999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8190460000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8432260000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.84093599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.9494419999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.9351959999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.495467999999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["60.3791610000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4014130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.773877000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.5240719999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.539655999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.541977000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7387179999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19494699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.3882580000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4353109999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818220999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.500558999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6052329999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82019999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.8190460000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6711069999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.57253700000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["29.200790999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2498569999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.853220999999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.7125849999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7425860000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.52168599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.7430439999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7742640000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542904000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["72.8202830000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8629489999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.741913999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.200790999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2605920000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03989200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.2152269999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.2812180000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14752999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.7125849999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7558519999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.752368999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.7430439999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.818052999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3043610000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.1698849999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.214544`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.776581999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5240380000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6060279999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42574899999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.8190460000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7276649999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.58903499999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["49.5960389999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6296330000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.584163999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.3882580000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.500558999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8759200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.6299599999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.3184010000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.208645000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["108.89549599999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["69.4239890000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.7064580000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.744629999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["108.816307000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["35.2152269999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.8493889999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.7415840000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.389000999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.1698849999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5240380000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5960389999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8436490000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6693149999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0761870000000115`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.169771999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.894273000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["36.9494419999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.691888000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.711601000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["94.5496469999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8202830000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.3652399999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.1360759999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.2299990000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.200790999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7125849999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7430439999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.180510999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8190460000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.3791610000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5240719999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.5656709999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "30", ",", 
                    StyleBox["44.4601612100000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.16928480900000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.3778703899999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.404631168199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.111933477999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.160150639399999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["27.7184680500000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0673882047399999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0562354913199999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.736828107799999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.833978677700000048`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.196095000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.776456999999999908`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.62191200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.111132999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.186251999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.131390000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.16388399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.870040999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.635183999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.668382000000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.69121699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.742537000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.945826999999999884`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.921621000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.16012399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.888302999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7023470000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05325399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.7900790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8359439999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.49339400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.3554390000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.4017519999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.50799199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.7575719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7221870000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.15217199999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.1789799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2202089999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34244699999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.6526539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6945229999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36328500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["59.5191530000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.553704000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12502499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["67.6110670000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6166019999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.180217999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1789799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1965380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571708000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.3772850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.396459999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.62436000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6526539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6810709999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.92528100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.5191530000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.526507000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.239454000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.4826810000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5093339999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.867853000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.2249049999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.2095509999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.499934999999999973`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["59.0294119999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0175970000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.384719999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["59.8264780000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8733689999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.52679300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.751462`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.32622700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.3554390000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.447980000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.50661099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.7575719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.718475999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.636493999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.4826810000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4037140000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.28561900000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.1789799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.236606`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.938175000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6526539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6961030000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.70736699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.5191530000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.570646000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.838323000000000106`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["78.147283999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1320790000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.247545999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.1789799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2390029999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.977195999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.3772850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.4156549999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.624673999999999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6526539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7496589999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.57927100000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["59.5191530000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5513750000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.524582000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.7900790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8651350000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22194099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.7614570000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7281229999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.542684999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.4826810000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.469977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.206827000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.5833250000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5922940000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.146023999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.3554390000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7575719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.9159139999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5055069999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1061240000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.921432999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["97.206809000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.8559259999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.7425510000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.231486000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.369812`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["40.3772850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.8032869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.1960890000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.986515999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["12.7900790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7614570000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5833250000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9647530000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6110670000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.4520430000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.554440000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.516001000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.2249049999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6685679999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.647569000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["100.327777999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["78.1623519999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.6558239999999884`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.1340859999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.849520999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.1789799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6526539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5191530000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.147283999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4826810000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0294119999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8264780000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.3338440000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "49", ",", 
                    StyleBox["22.5862717199999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.40678542599999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.90053331500000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.69245481600000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0346556240600000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0883859887200000038`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["166.021692699999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.157232505299999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["62.9247741399999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.966591793299999935`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.844006813499999886`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.223857000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.863447000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.446769000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.113812999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.145966000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0834889999999999865`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.53939099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.983256000000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.62113700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.661275999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.681093999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.734550999999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.943401000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.913565999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.12204900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.887326999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7039199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.20283300000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.3652679999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.3867699999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.762487000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.7096340000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7321799999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.799522999999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1358570000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1491440000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.471180999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9711880000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9882829999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.606207999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.1048879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1403790000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2585710000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["62.2289340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2574770000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01217800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["68.4881060000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4726540000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.547963000000000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.9711880000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0036720000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15190999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.3896959999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4280230000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35909699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.1048879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0980749999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.24159600000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["62.2289340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.253191000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.860191000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.3094090000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3333799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.850065999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.4961490000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.4821030000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.498085000000000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["59.4377279999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4561760000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.654190999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.1051569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.122816000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.626208000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7378599999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.20318900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.7096340000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7544499999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.794614000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1358570000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.130850999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0887640000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["33.3094090000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2745839999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.617446000000000072`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.9711880000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.010963000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.70523100000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.1048879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.130228000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.449305999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.2289340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2550889999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.463734000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["70.4994630000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.5281389999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.508441999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9711880000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0305999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05339500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.3896959999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4663540000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35917700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.1048879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1368560000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.56681000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.2289340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3072930000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38933700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.3652679999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4085089999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.766677000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1556569999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1765469999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.370387999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.3094090000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2825550000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.476119000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["47.047825999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0834589999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.631794000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7096340000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1358570000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.880039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6320639999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9138359999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.495037999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.839999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["68.247434999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.555442999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.092526999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["128.923922999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.3896959999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6874959999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.5652759999999901`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.527409000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.3652679999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1556569999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.047825999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4516890000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4881060000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.2157550000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.444553999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.043076999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.4961490000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.1299700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.5913709999999881`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.918798999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["70.4994630000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.3301419999999879`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.31016499999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["97.4344840000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9711880000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1048879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2289340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.0386830000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3094090000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4377279999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.1051569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.8114599999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "28", ",", 
                    StyleBox["30.1652828699999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.31787540299999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.03357399999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.78246610039999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0888917302800000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0802933580600000063`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.32225913799999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.180829520200000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.65444344599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.977586967899999947`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.850381601900000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.249855999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.79457399999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.209277999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.126373999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.126139000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0673750000000000071`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.91607299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23043100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.649894999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.681859999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.719099999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.765348999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.99793699999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.967546000000000105`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.1715930000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.922597000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7016130000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1416710000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.4287969999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4453139999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.596496000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.5476600000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.5748899999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.983380000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7522239999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7405170000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.422780999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.5937169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6074779999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.496950999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9127360000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9432079999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10044499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["60.1273089999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.151962000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.890310999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.144784999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.1302919999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.523398000000000074`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.5937169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6227810000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04959000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["38.8198670000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8551629999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2746599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.9127360000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9052489999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.270398000000000049`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["60.1273089999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1493270000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.795141000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4816190000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5019319999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.733558999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.2369419999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.2240340000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.46614399999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["57.419992999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4349819999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.541317000000000092`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.7650370000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7813900000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.590580000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7332519999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14212800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.4287969999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4616630000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.593461000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7528520000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7508160000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0367510000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["32.4816190000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4030470000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.41876099999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["27.5937169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6252819999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.569964000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9127360000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9334240000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.373560999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.1273089999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1498920000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.40778799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["68.0775409999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.1053499999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.502144999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5937169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6478219999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.976956000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.8198670000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.890467000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27481099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.9127360000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.937975999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.455749000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.1273089999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1970410000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25913699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.5476600000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.601234999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.967396999999999884`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7522239999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7494760000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0496180000000000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.5440359999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.758617`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.87462499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.4816190000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4819089999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00522799999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4287969999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7528520000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.4924370000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.2592470000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.4480369999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.3537730000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.2299780000000097`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.4691539999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.939873000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["97.3734669999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["122.017796999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.8198670000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2095659999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9893979999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.254599000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.5476600000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5440359999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7522239999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.689521999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.144784999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.729601999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.5580710000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.202887000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.2369419999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.858787000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.4418450000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.063504999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["68.0775409999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9589710000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.7338010000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.797674`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["27.5937169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9127360000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1273089999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7208760000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4816190000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.419992999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7650370000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.9367029999999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "20", ",", 
                    StyleBox["171.330935100000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.1092847939999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.60035421999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.817593710399999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.131231380799999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.107521814600000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.93319453600000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.137376490099999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.189084529599999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.896775599299999903`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.801970184800000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.289320999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.722248000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.055846`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.144484000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.111812`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0635229999999999961`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.38360599999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.58533499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.697355999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.766464000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.787570999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.859474999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.09430099999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.08667500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23038699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.04733999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7212349999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.03978500000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.5179149999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.5411290000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.92420100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.7679860000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7724059999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.175954999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1984110000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6955650000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.7927789999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1803209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1948369999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.577941000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.4192570000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4446030000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00905599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["63.2423069999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2653979999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.919266999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["68.1060779999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.1015890000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.178702000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.1803209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2088340000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13519999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.8617110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.8937760000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27657400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.4192570000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4170350000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0884670000000000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["63.2423069999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2516410000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.371593000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1304510000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1528250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.890756000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1399540000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.125377000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.580334000000000038`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["58.9411119999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.9621750000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.838568000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.5506930000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5549750000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.170456999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7725189999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.04075499999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.7679860000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.776651000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.172486000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1984110000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2240999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.511368000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.2418860000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2194909999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.445793000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.1803209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2148990000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.688320000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.4192570000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4430559999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.473744999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.2423069999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2562159999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.276861000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["70.9650340000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.2386259999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["5.44613100000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1803209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2318059999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02486499999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.8617110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9258529999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27681299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.4192570000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4417619999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.447975000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.2423069999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2930550000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01018999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.5179149999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.564559`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.928500000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.2402019999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2210260000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.381713000000000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.2241649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2508830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.531836000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1304510000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1459430000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.308399`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7679860000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1984110000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2418860000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.7701480000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.5577750000000136`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.024826999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["100.463528000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["67.2836000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.692900999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.073186000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.812555000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["41.8617110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.0701890000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.4677039999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.5483369999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.5179149999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2241649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2402019999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8747120000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.1060779999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.1823919999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6901510000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.935073999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["40.1399540000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.1091319999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.9260490000000132`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.14430900000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["70.9650340000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.9144780000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.1838469999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["118.963226999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.1803209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4192570000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2423069999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7615519999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1304510000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.9411119999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5506930000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.8517350000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["35.6706183200000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.14307622199999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.86332907099999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.00999469099999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00729168205999999941`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.143581886700000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["60.6832776500000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.162551990700000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["9.60935070999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.78831969079999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.734265937400000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.305400999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.723479000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.347901999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.170094999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0823980000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0480330000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.22803800000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.67623699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.716974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.714883000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.82674000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.844510000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.15786199999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14222800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2469920000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.985821999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7107030000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3650580000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.0196970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0436639999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.803781999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1877889999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1857490000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0684100000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["32.9737300000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0292499999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.861965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.4857009999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4966300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.366505000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.967643000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.987667`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.671559000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.2237950000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2484159999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.825701000000000107`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.6456789999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.6439000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0596780000000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["23.4857009999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5124129999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.895829999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1047110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.137630999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10403800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.967643000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9680009999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0120120000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["56.2237950000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.247221000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.785630000000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8660199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8863559999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.682027000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.1120239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.1003019999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.393116999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.6714980000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6918869999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.683757999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.6575690000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6530520000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.151501000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7513910000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36479900000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.1877889999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1838399999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0662199999999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["32.9737300000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9908519999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.287115999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8660199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8962840000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.507492000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.4857009999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5148909999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.489470000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.967643000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9888759999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.356053999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.2237950000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2423640000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.311380999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.1345740000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.1743630000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.667209000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.4857009999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.531784`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.772743999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1047110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.170558999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10417000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.967643000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.987250000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.328780000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.2237950000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.3022709999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31592299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.0196970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0681629999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.812702999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8660199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.805613000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01292599999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.4776480000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5366030000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.988583000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.5448560000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5329260000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.20004900000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1877889999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9737300000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5816900000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.5369759999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.3247829999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.3573219999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6841670000000092`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.2722110000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.5769509999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.903444999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["100.130382999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["35.1047110000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8122360000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.9404540000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.2803519999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0196970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5448560000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.4776480000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5259829999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.6456789999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.2649020000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0467820000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.8174450000000135`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.1120239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.309353999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.1577379999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7573670000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.1345740000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.2687679999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.3702640000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.3001230000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4857009999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.967643000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2237950000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.9921679999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8660199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6714980000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6575690000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3041769999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["54.4883153199999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.2634149269999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.49555625500000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.26007000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.176242000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.22054800000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["10.7990889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.262786000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.78172899999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.1`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->1]}], ",", 
                    StyleBox["0.1`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->1], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.287080000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.707030000000000047`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.664456000000000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.212943999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0438889999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0415140000000000064`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.83600700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.50655300000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.715244000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.773073000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.961219000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.946701000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.38122199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.33433299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24994000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.08354499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7206240000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.51042300000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.7941879999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8131140000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.564662000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9576369999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9966420000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16375399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.1954730000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1974430000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.058785999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["21.3023580000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3129199999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.315139000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.6394919999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6576889999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542918000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.4879239999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4825689999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.159782000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.7506280000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7507560000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00381400000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["21.3023580000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.327790000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.758793000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.647623000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6871670000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17984399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.6394919999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6443540000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.145060999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.4879239999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4839429999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.118786999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.5758309999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5985810000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.678756000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1345870000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1229799999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.346314999999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.2436069999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2623829999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.560189999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.6659390000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6691109999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0946319999999999872`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7713079999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.51130399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.7941879999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8059930000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.176101000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8963019999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9181349999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325709999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.5758309999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5658090000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.149512`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.3023580000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3283349999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387527000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.6394919999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6615570000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.329158999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.4879239999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4781300000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.146110999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["55.9062089999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9202310000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.209189000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3023580000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3483789999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.686536999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.647623000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7267120000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17984899999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.6394919999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6635879999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.359468000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.4879239999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4792220000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.129820999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.9576369999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0352839999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15833800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.1954730000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2255550000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448765000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.5758309999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5682579999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.112982000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["38.859893999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8555259999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0651609999999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8963019999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7941879999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.7023769999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.882650999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.6946520000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.4049059999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6783080000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.5839589999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.9796539999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.520364999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.936885000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.647623000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4836529999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.9631760000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.475198000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9576369999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1954730000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.859893999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1525410000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7506280000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2861610000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5427339999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.4551710000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1345870000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6148929999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5089289999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.9158400000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9062089999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.3598130000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.4932940000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0419919999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3023580000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6394919999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.926135999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4879239999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5758309999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2436069999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6659390000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.7337720000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["95.5900296199999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.832426787300000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.02285342099999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.778543369199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.22636313320000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.280394894600000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["19.1783872899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.104598752299999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.75240642700000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.305927931699999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0426069891599999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.442850000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.496142000000000038`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.732365999999999939`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.215409999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0480719999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0532859999999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["4.56656499999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.95510999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.869518000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.752149`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.10832599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.934436999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.54126800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.33476700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.48645699999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.0550600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7222030000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.85788200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3754710000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4014200000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.923498999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1486209999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0865919999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.20758600000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.408735`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4344020000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.913457000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.6901319999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7026480000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.445441999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8355890000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8491510000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.48269700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.6271569999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5967479999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08224399999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["52.6935209999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7011189999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.270419000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.6901319999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7027739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.449901000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.7182770000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7308119999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.446112999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8355890000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8564200000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.741396000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.6271569999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6037740000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.832185999999999914`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.514615`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5311629999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.588942999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.7865939999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7763729999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.363739999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["47.0949300000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1143119999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.689771`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.1185580000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.100562`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.640460000000000029`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7743790000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.85741200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.1486209999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0191570000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.30379500000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.408735`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4644329999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.991136000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.514615`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5458489999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555797000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.6901319999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7181430000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.49845600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8355890000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8716530000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.641770999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.6271569999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6181270000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.160691000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["52.6935209999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7033869999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.175580000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.6901319999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7124289999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.396766000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.7182770000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7433509999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.446192999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8355890000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8683280000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.582590000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.6271569999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5369310000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.60557100000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["23.3754710000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4274700000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.925314999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.6531680000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6923900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.697954999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.514615`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4899679999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.438602999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.8400719999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8603489999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.360831999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1486209999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.408735`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.851084000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2630500000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.6085470000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.7257289999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.7229980000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.1117920000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3641789999999893`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.6560089999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.7888889999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7182770000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6182260000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.8894690000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4761519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3754710000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6531680000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8400719999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3177620000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8764739999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.4146259999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9383330000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.207476999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7865939999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.338363000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8573509999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.283164999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3284570000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.4773639999999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8354930000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.6686540000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.6901319999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8355890000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6935209999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6271569999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.514615`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0949300000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1185580000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.139052000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "28", ",", 
                    StyleBox["72.4609029899999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.37843103199999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.22439921199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.71173170199999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.405273038099999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.220108553699999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.66124153999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.369570938800000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.17806391599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00170824526199999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0767567215299999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.329274000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.429511999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.84531799999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.221760000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0333719999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0355670000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.94639800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.97401800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.765480000000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.686320999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.993994999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.889902000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.41513099999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32010399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32061899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.965169999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7216759999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42232800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.5765320000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.6194170000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18036600000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.4188599999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4147450000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.113270000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.3275760000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.320228000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.202233000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["18.2701190000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.2760029999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.161951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.3206989999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3332619999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.345777000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.9874360000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9928029999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.147728999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.1616369999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.165792000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.114346000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.2701190000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.2915570000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.59006400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.3359429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.375377000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0853950000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.3206989999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.321640000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0259099999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["46.9874360000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9847999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0725409999999999932`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["35.6413869999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6580479999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.458562000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.0101470000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.001089999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.249282000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.3493320000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.3624849999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.362026000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.1756840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.175206000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.013173999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7733889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42284600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.4188599999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4104740000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.11540999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.3275760000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3131329999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.198760000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.6413869999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6958959999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.750156000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.2701190000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.2878830000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.244467999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.3206989999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3331439999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.171267000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.9874360000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9749060000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.172433000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["47.759406000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7835060000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.331660999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.2701190000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3070050000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.507624999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.3359429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4148009999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08524599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.3206989999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3353030000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.200987999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.9874360000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0060020000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.255512000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.5765320000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.6618789999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17455500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.5420079999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5500099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.110126999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6413869999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.892409999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.45459400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["40.9451379999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.7919330000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.10842099999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4188599999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3275760000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2127459999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2803309999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.9938169999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6382129999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5948620000000079`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0471470000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5473170000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5827410000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.8985660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3359429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4874269999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4849969999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.1913140000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5765320000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5420079999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.9451379999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9232139999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7282140000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1013200000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2759149999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8792260000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.0101470000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6074180000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.3186240000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4250190000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.759406000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4934229999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.1715449999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9368589999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.2701190000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3206989999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1616369999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9874360000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6413869999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.3493320000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.1756840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2948609999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["data three/ttraj3*.out", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 41 criteria and tolerance 0.01.\\nOverall scale from \
minimizing chi^2.\\nParity doublets (o,multi,state) with error for difference\
\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error 0.25\\n  (-1, 5,0) and \
(-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, 4,0), error 0.25\\nSpectrum for \
P_perp a = (0,0), ( 0.25 0)\\n  using (# states, multiplet, o, c^2 error for \
each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 \
2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 \
2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 0.25)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4, 11 & 12,  1 & -1, 0.25 2 2 2)\\n  \
(4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & 13,  1 & -1, 0.25 2 2 2)\\n  \
(4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary spectra multiplets, 4 states, \
(o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  \
5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) .\\nAll spectra extrapolated \
using (K,p) = (16/2,8)  (16/2,6) \\n  (20/2,6)  (26/2,6) .\\nWinding \
potential using (n,K,p) = ( 2 0,20/2,4)  ( 2 0,20/2,6) \\n  ( 2 0,24/2,4)  ( \
2 0,32/2,4)  ( 3 0,19/2,5)  ( 3 0,19/2,7) \\n  ( 3 0,25/2,5)  ( 3 0,33/2,5)  \
( 4 0,18/2,6)  ( 4 0,18/2,8) \\n  ( 4 0,24/2,6)  ( 4 0,32/2,6) .\\nRoundness \
of winding using (n,K,p) = ( 2 2,16/2,6) \\n  ( 2 2,16/2,8)  ( 2 2,24/2,6)  ( \
2 2,28/2,6) \\n  with error 1; in G^2 N units.\\nHeavy potential determined \
using (n,K,p,K_max) =\\n  ( 0 0,-34/2,2,3)  ( 0 0,-34/2,4,3)  ( 0 \
0,-34/2,2,4.5) \\n  ( 0 0,-50/2,2,3)  ( 0 0,-50/2,2,4.5)  ( 0 0,-60/2,2,3) \
\\n  ( 0 0,-60/2,2,4.5) ,\\n L = 3 4 6 (all in G^2 N units); relative scale \
error=0.1.\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-17/2,3,3) \\n  \
( 1 0,-17/2,5,3)  ( 1 0,-17/2,3,4.5)  ( 1 0,-33/2,3,3) \\n  ( 1 \
0,-33/2,3,4.5)  ( 1 0,-55/2,3,3)  ( 1 0,-55/2,3,4.5) \\n L=0 and error \
0.1;\\n  ( 1 0,-17/2,3,3)  ( 1 0,-17/2,5,3)  ( 1 0,-17/2,3,4.5) \\n  ( 1 \
0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3) \\n  ( 1 0,-55/2,3,4.5) \
\\n L=2.5 and error 0.1;\\n  ( 1 0,-17/2,3,3)  ( 1 0,-17/2,5,3)  ( 1 \
0,-17/2,3,4.5) \\n  ( 1 0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3) \
\\n  ( 1 0,-55/2,3,4.5) \\n L=5 and error 0.1;\\n  ( 1 1,-30/2,2,3)  ( 1 \
1,-30/2,4,3)  ( 1 1,-30/2,2,4.5) \\n  ( 1 1,-40/2,2,3)  ( 1 1,-50/2,2,4.5)  ( \
1 1,-60/2,2,3) \\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error 0.1; all in G^2 N \
units.\\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \\n  (35/2,3)  \
(45/2,3)  (13/2,5)  (29/2,5)  (13/2,7) \\n  (17/2,7) .\\nResult format:\\n \
Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\\n The 10 \
couplings  (G^2 N units);\\n   which couplings -- if any -- were fit.\\n \
Winding potential and heavy souce potential fits.\\n Roundness of winding \
potential, 1 values, and roundness of\\n   heavy source potential, 4 values, \
(G^2 N units)\\n   showing measured value and derived value for each.\\n The \
rescaled spectrum for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "20", ",", 
                    StyleBox["40.5403410200000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["7.49834429399999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.5486223999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.179818001100000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0659772840299999963`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0528543260300000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.13167108399999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0159458962299999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.961262676900000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.459300856700000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.396951357000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.179685000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.379110000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.397165999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0960299999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.255049000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.214125000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.84360600000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.00872000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.571504000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.681411999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.680308000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.743951999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.948351000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.89641699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.18137699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.888945999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.0057800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.0390960000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10613199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.773575000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.7998900000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.87372000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.9329040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9267209999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.205282000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.3221770000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2773239999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.48919599999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.071181000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1001510000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.961862999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.715131000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7412559999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.867415000000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.0784569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0956830000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571934999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.9618090000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9578929999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.130025999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.071181000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0876689999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.547457999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.6023109999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6075839999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.175072000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.715131000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7154230000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00970999999999999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["63.0784569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0787869999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0109610000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["27.3221770000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3327769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.351947999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4227239999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4130829999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.320091000000000036`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.5367689999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5568009999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.665096000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.1395749999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.1348610000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.156515999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["13.0057800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.0723959999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10588700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9329040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9203860000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.207810000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.3221770000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2665140000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.924047000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.2236350000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2444309999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.345245999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.071181000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1339450000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04194000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["56.715131000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7400540000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.413743000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.0784569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0951420000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.276982000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["78.9970390000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.1083770000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.84831099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.071181000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0993070000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.466929999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.6023109999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6128880000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.175594000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.715131000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.742991000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.4625`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.0784569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0970850000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.309238999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.773575000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8260269999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.87074700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.3221770000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3091049999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.216996000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.2166350000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2192609999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0436010000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["33.0025190000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.200968000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.294435`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.0057800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9329040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2236350000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3750119999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.7528549999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.3785409999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.596374999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["113.785091000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["64.2800729999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.0718429999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.7501209999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.910103000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.6023109999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2233669999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.5529909999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.469078000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["17.773575000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2166350000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0025190000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7613559999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9618090000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.2166180000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.101606999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["107.471361000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.4227239999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.3160110000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.5552200000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.045306999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["81.9943929999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.3771470000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.082121999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.020252`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.071181000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.715131000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0784569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.9970390000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3221770000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5367689999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.1395749999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.7216540000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "56", ",", 
                    StyleBox["16.3212029700000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.76420277099999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.4617270999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.390983952200000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0125028237800000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0642123112300000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["353.249252899999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0704912752200000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["160.627383500000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.712352071900000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.651935586899999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.181945999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.805984000000000122`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.689808999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0929620000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.211745999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.151139000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.26661599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.735812000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.564128999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.635325999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.63087200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.694690000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.877256999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.840221000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.01911499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.832638000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.3231519999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.3579600000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1614279999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.7829279999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8055799999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.755824000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.2804490000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2982889999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.595237000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3985720000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3706429999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.931907999999999958`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.775649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7987290000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.770068000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.5375330000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5807400000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.44166499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["62.5370340000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5640030000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.899870999999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["67.8319699999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.8195510000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.414385000000000047`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.775649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8068929999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04247700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.5845010000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6129450000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.949106000000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.5375330000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5305129999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.234228999999999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["62.5370340000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5582240000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.70702499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3985720000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4211380000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.752932000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1435590000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.130201999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.445671999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["58.4852660000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.5083770000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.771120999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.7746309999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7860690000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.381653999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.3231519999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.3927720000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16150200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.2804490000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.3156460000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.587203999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3985720000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3740489999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.409135000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.9416029999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9290179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.209960000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.775649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8289210000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.888733000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.5375330000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.568213`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.511847999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.5370340000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5646339999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460454999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["68.6218580000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6838920000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03494100000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.775649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8310560000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.924347999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5845010000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6413829999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.948990000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.5375330000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5790900000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.69331100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.5370340000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6045629999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12660699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.7829279999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8283190000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.757280999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3985720000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4128590000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.23834900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.9724709999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9490109999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.391382999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.405970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5230750000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.95370299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.3231519999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2804490000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9416029999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.498904999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.0721530000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.1409559999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.628817999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["114.934519999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["66.3843789999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.3875450000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.588262999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.024977999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.5845010000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8460690000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7391049999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.3593039999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7829279999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9724709999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.405970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4503040000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.8319699999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.0212790000000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.1299209999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.855251999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["35.1435590000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.678703999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.5331699999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.712173000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6218580000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.1063200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.6865439999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.5032949999999871`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.775649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5375330000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5370340000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.7931499999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3985720000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4852660000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7746309999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3260639999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{\(-2\), ",", "11", ",", 
                    StyleBox["21.6380875400000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.57296374800000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.8196690899999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.484410333800000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0236843751400000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0719196455499999931`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["297.390539299999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.101769289799999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["118.941264499999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.808167870800000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.716652990199999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.192898999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.852525999999999939`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.672690000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0984629999999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.18899799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.125715999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.30578799999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.774750000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.580776000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.630441999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.644778999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.694284999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.895120000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.849967000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.05210000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.83200099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.7526529999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.7861989999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1202129999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.0700100000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.091355`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.712783000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.3258839999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3485699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.757553999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1299920000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1148179999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.506728999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.0426390000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0636979999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.703234000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.453555000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4950179999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38459500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["61.2429160000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2713650000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.950019999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.9498200000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.9352480000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.486638000000000037`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.0426390000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0748080000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0742529999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.7029390000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7355040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08744499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["52.453555000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4468889999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.222603999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["61.2429160000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2671659999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.809787000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4377850000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4613339999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.786392999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4319130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.418156000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.45938800000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["57.9122970000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9337899999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.71770599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.0848549999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1001329999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.510196999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.7526529999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.8197600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12047199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3258839999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3705539999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.745847999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1299920000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2253970000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.59295800000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.4377850000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.301906999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.26872899999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["28.0426390000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0909910000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.807328000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.453555000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4822119999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.47848000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.2429160000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2727330000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.497841999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["69.8627339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.9072899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.74394600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0426390000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1007810000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.970781000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7029390000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7680659999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0874029999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["52.453555000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4943660000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.681414000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.2429160000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.3171520000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23950399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.0700100000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1133470000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.723577000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1529880000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2199170000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11750700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.4377850000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3624420000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.25798399999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["47.7997050000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8322339999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.543130000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.7526529999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3258839999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1299920000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.2567390000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5851920000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0246030000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.250094999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.489138999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["66.6860060000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.1587459999999865`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.498249000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.578475999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.7029390000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.1687029999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.1768790000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.5728690000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0700100000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1529880000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7997050000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5185590000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.9498200000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.968575000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.218052999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["101.873901999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["35.4319130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.3329650000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.731675`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["90.9070329999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.8627339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.8172720000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.4037110000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7503800000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0426390000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.453555000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2429160000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0359629999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4377850000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9122970000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.0848549999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6285729999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "29", ",", 
                    StyleBox["20.1174912699999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.43646350200000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.3711990100000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.600475960499999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0310396335500000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0773642064199999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["1615.4611270000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.135396084800000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["730.160331100000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.899210910200000057`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.810959006200000054`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.203383000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.893374000000000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.619376000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.105174000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.163912000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0981419999999999959`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.300991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.811111999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.594986000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.634848999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.650352999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.703188000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.900795000000000101`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.869664000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.0775539999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.844754999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.011782000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.0446409999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10894200000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.1154870000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1371720000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.73184199999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.3067530000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3310040000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.81847600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.8445719999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8577629999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.445204000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5330560000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.552048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.640972000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.7221129999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7614410000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.32727900000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["60.7166899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7460570000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.991104999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.8382789999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8213919999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.569918999999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.5330560000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5665760000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13128000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.81881`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8565600000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27403299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.7221129999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.713654`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.285496999999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["60.7166899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7435710000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.907226999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8745080000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8985480000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.811330000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.0684290000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.054592999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.466949999999999931`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["57.697415000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7167069999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.651086999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.3834250000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.402001000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.626927000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.011782000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.0775179999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10926300000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3067530000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3547320000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.809637000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.8445719999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8416299999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0496419999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["30.8745080000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8388200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.602205000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.5330560000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5779800000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.758071000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.7221129999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7480100000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.436990999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.7166899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7457530000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490423000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["69.206644999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.237055999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.513173000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5330560000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5931950000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01482699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.81881`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8943080000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27399400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.7221129999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7578680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.603342000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.7166899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7986649999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38330299999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.1154870000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1592719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738840000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.863135999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8939939999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.520723000000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8745080000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8376629999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.621729999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["47.5751240000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.6037279999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.482669999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.011782000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3067530000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8445719999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.2915380000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1375240000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9248760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.41797800000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["97.916154000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5277909999999916`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.5450409999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.614301000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["108.88659599999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.81881`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9831130000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3569399999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.383770999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["23.1154870000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.863135999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5751240000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.3814270000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8382789999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.9968389999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.196914000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.242608999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["36.0684290000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.4519580000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.1134599999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.000705999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["69.206644999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.2052549999999868`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.7706479999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.1020189999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5330560000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.7221129999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7166899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8412639999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8745080000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.697415000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.3834250000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.1267890000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "32", ",", 
                    StyleBox["22.6748494500000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.24351090999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["9.66978533600000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.731776675800000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0332740646100000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0880960124499999963`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["220.866642899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.166909766399999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["94.36589102000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.968862613800000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.873501691099999888`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.210286000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.946480000000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.541819000000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.114294000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.134299999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0649239999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.16998500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.803533000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.606564999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.626465999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.658897999999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.70335099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.913978000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.88841000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.08919699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.840681000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["8.73845099999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["8.77294200000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12215299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2544189999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2768009999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.728184999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.7178919999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7397999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.712769999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7361690000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7523319999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.525884000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8978609999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9152570000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.565990999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.5759580000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6113920000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15284800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.8136209999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8426759999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.945279999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.0594669999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.043215`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.52875399999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["25.8978609999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9325649999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12908399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.9603820000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0037769999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41182199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["48.5759580000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5654240000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.342729000000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["57.8136209999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8404900000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.874160000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0075320000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0321700000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.80158100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.354072000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3405130000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.441155000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["54.8428849999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8604360000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571025999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.7818209999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8016390000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.644772999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["8.73845099999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["8.80745199999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12245599999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.7178919999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.761597`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.710963000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7361690000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7337789999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.038879999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["30.0075320000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9773250000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.491394000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["25.8978609999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9418470000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.71554599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.5759580000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5981189999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.360508000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.8136209999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8391120000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.414658000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.3286250000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.3625459999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.551811000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8978609999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.958110999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.98011499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.9603820000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.047164000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41170200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["48.5759580000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6035910000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.449519999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.8136209999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8988230000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38599399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2544189999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2992519999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.729316999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7620690000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7838689999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.354627999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0075320000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9837739999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.386473999999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["44.8327100000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9074479999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21577899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["8.73845099999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.7178919999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7361690000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6146340000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.0872899999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.8535660000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.3607189999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.1434439999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9265910000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.7530620000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.5043790000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["123.601097999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.9603820000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2644599999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.8888799999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.675601`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["22.2544189999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7620690000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8327100000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.7726190000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0594669999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.420850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.9210900000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.5512879999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.354072000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.8665000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.2295610000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.751418999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["65.3286250000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.417972000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.827143999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["90.3397490000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8978609999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5759580000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8136209999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.2225119999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0075320000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8428849999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7818209999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.4925319999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"3", ",", "31", ",", 
                    StyleBox["27.057134920000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.13743370399999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.56539793900000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.804788429499999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0810667240799999966`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0723188350399999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.83154487300000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.164666067400000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.48149205499999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.948730016500000061`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.865007506499999934`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.246487999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.870401999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.265776999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.12987099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.117572999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0556050000000000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.57678199999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.13472700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.642576000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.656773999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.708061000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.746945000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.983366999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.961551000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.13932600000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.889364999999999916`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["8.58226799999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["8.61567999999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12866299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.5949750000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.6232489999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.955097999999999913`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.7909689999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.799920000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.302356999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1692360000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1523180000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.571480999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["25.2930680000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.3059730000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.435916000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.8300759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8582379999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.951346000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.9737999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9969260000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.781200000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.9375450000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.9226389999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.503556999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["25.2930680000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.3245250000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.062616`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.4741730000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5117339999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26879900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.8300759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.816355000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.463492999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["55.9737999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.994041000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.683749000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.3185669999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3371229999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.626841999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8894850000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.878256999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.379276999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.8499089999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.863241999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.450412999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.2421379999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2557370000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.459379999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["8.58226799999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["8.64911299999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12901899999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.7909689999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8088189999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.301495000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1698560000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1649570000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0827380000000000137`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["29.3185669999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3833020000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09339300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.2930680000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.3289959999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.606822000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.8300759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8453639999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.258224000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.9737999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9870609999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.223974000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.9437270000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9843329999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.685841999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.2930680000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.3458700000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.891821999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.4741730000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5492949999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26881599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.8300759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8437429999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.230849999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.9737999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0464900000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22774399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.5949750000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.650544`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.938569000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1692360000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1653259999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0660349999999999948`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["28.6537169999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8332979999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.03314899999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.3185669999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.327974000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.158900000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["8.58226799999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.7909689999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1698560000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4874880000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.6021929999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.5696750000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.5241689999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.9629899999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6813169999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.1563320000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.7530770000000117`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.373434000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.4741730000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.945725000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.646047999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.7537070000000092`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5949750000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6537169999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1692360000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2192940000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.9375450000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.860902999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.1022430000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.7367779999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8894850000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3475880000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.0659049999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.086579999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["61.9437270000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5558570000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.0966860000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.697470999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.2930680000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8300759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9737999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.9280499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3185669999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8499089999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2421379999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.6114340000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "57", ",", 
                    StyleBox["37.0017636499999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.997548784900000029`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.71770726499999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.9565412993999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0497583666899999954`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.127186915899999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["34.5272719299999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.188817288699999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["10.3443841299999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.946543730500000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.870192088900000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.247901000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.902072000000000073`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0812069999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.144466000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0887909999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0275519999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.3920079999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.09128399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.659924999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.636749000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.732972999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.745056000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.02359500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.995426999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14691600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.868791000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["7.28998699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["7.330241`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2322280000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.4373179999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4513460000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.429429000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.4086820000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4158929999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.220718000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5740779999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5782670000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.128214999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.0447179999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0588609999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.432943000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7445759999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7692470000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.755214000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9264849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9479440000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.656919000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.9980300000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9953100000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0832620000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["23.0447179999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0757879999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.951104999999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4835450000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5248390000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26408399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.7445759999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7396259999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.151545999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.9264849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9371099999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325258000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.130098000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1538530000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.727177000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1316219999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1187740000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.393283000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.4070610000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4267469999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.602604000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8780860000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8854810000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.226360999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["7.28998699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["7.37049700000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23226600000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.4086820000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4229860000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.218927000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5740779999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5353069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.593428999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.130098000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1349150000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0737290000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["23.0447179999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0822600000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.574613999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7445759999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7643579999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.302777999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9264849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9373410000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.166164000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.4967580000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5471270000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.770943000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.0447179999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.097612999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.809595999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4835450000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5661320000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26406799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.7445759999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7643280000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.302306000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9264849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9796160000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.813222000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.4373179999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.465976000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.438630999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.130098000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.159956000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.456994999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5824909999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.447089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.07243200000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.6764050000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8521539999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.68998900000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["7.28998699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.4086820000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5740779999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3730029999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1820169999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6673420000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.1777990000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.4508919999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7604149999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.9369109999999878`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.2433259999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.4291509999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4835450000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9289749999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.2576590000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4276820000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4373179999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6764050000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5824909999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.772829999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9980300000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.3612939999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.2152669999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.7948670000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1316219999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.7969640000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.0815939999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.870930000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["57.4967580000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.9821450000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.1430729999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.907218000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["23.0447179999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7445759999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9264849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9785209999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.130098000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4070610000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8780860000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0093499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["36.8072737299999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.11795189399999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.65132200900000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.00999469099999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00729168205999999941`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.143581886700000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["60.6832776500000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.162551990700000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["9.60935070999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.78831969079999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.734265937400000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.30268299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.738755000000000094`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.335523000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.170077000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0812090000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0459019999999999939`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.14928100000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.64077099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.714620999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.691034999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.824024999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.824598000000000119`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.15463899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12760400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23988300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.952502999999999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.6980360000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.7379370000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28528400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7270299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7502010000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.746392000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.8517450000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.847159999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.147696000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.8557929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8879550000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03600099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.5858479999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5965449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.344575999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.0846589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.1041549999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.627990999999999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0007409999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0235299999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.734091000000000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4142309999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.412962000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0408639999999999936`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["22.5858479999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6121499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.847260999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6290290000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6616310000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05017599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["43.0846589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.0847610000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0032709999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["54.0007409999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0225050000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.701076999999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4532529999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4731080000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.639571000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.5922460000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5809199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.36483500000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.6067319999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.626781999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.64582499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.5541469999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5490789999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.163251000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["11.6980360000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.777822`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28502000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.8517450000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8428070000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.143958000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.8557929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8737180000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.288704999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4532529999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4868319999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.540817000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.5858479999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6148140000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.466532999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.0846589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.105089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.32905000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0007409999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0165330000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.254342999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.8035319999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8463180000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.689111000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.5858479999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6308730000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.725184999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6290290000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6942409999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05028800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["43.0846589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.1034999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.303445000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0007409999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0750550000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19690099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7270299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7738860000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.75465800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4532529999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3894280000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02795900000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.0371689999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1005890000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02144799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.3269579999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3153569999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.186857999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["11.6980360000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8517450000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8557929999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1517160000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9815109999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8167310000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.2968050000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6433320000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.0221889999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.4912089999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.132161000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["96.668447000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6290290000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.586388000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.1427759999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.1345519999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7270299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3269579999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0371689999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5674790000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4142309999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.769125000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.037999000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.7809019999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5922460000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.5817710000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.0461329999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9528629999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8035319999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.3875569999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3251730000000101`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.2628270000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5858479999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.0846589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0007409999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0113389999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4532529999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6067319999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5541469999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9715720000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["53.4946027300000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.23475593700000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.10461809899999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.24391000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.130230000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.169090999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.0093000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.231558000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["6.79891999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.526116000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.515095999999999953`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.306864999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.69060699999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.70986400000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.198200999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0524220000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0344380000000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.97958799999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.67557700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.724446999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.712489000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.874993000000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.877754999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.23963099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24309699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.25694700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.993098999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.1415669999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.1809060000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17911300000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.2593199999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2756730000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.49016099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9499709999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9259899999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.718794999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.2769289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.291701999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.442797000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.5692530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5778380000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.257290000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.8616140000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8787409999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.513337999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2512210000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2476229999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.107855999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["54.1266689999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1271769999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0152200000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["20.5692530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5943840000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.753218999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1856209999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2219089999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08762599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.8616140000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8615980000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.000458000000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->3]}], ",", 
                    StyleBox["51.2512210000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.251660999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0131830000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["33.5508650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5695999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.561525999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.3728860000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.362592999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.308514999999999961`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.5444450000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5614210000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.508800999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0815679999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0782919999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0982000000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.1415669999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.2202429999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17907600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.2593199999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.233314`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.389731000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.2769289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3062299999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.439107999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.5508650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5807650000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448097000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.5692530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5937090000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.366503000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.8616140000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8786640000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.255514999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2512210000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2420499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.137448999999999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["52.9637850000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.992745999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.434020000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.5692530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6122240000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.643966999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1856209999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2581970000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08764400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.8616140000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8788499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.258299999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2512210000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2542619999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0455730000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["29.9499709999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9612900000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.169625000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0023979999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0278989999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.382168999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.5508650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5265389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.364559000000000033`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.5243239999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5480919999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.356192000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.1415669999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2769289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2593199999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5774619999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6904869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.031576999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.7199109999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.184179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7508560000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.9992040000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.9125339999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.849592000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.1856209999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3043999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.4039549999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2412709999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0023979999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9499709999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5243239999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8702899999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1266689999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5250860000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.7267480000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.9200610000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3728860000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1997470000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.8561349999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6663649999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.9637850000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6805399999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.7307650000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.0009849999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5692530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8616140000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4863810000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2512210000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5508650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5444450000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0815679999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.7617649999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{\(-2\), ",", "10", ",", 
                    StyleBox["58.1720072900000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.2752004320000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.72237991400000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.47781999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.267751000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.19459999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["25.3352999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.300565000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.98849000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.263911999999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.295926000000000044`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.307377999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.621396999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.18170200000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.214212999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0372950000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0312259999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.72081900000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.68991299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.734712000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.707061000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.924108000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.894818000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.31599899999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30050500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.267544`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.991446999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.6567620000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.698942000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18707699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1204159999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1300610000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.271446999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.8443059999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.830290999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.39443800000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.9257029999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9365710000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.30586000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.0897159999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0970419999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.206163000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.7864220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8015049999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.424486000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.3473820000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3505170000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0882440000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["51.5929210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.6001409999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.203195999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.0897159999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.1137489999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.676359000000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0515070000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.091953000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13827600000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["36.7864220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7865290000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0030129999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["48.3473820000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.346157999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0344290000000000029`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["34.1962529999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2144199999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.511276999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.8559869999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8462429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.274226999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["44.3447590000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.3601469999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.433065999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.6781250000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.675542`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0726849999999999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["11.6567620000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.7411519999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18750099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1204159999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1395479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.269225000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.8443059999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8167800000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.387332`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.1962529999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2214119999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.35403500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.0897159999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.1118279999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.311153000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.7864220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8007609999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.201773999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.3473820000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3351090000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.172694999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.6481489999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.676758000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.402571000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.0897159999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.1303240000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571417999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0515070000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1323909999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.138158`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["36.7864220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8025179999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.226499000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.3473820000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3639259999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.232799000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9257029999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9475969999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.308086999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.2246829999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2438569999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.26980599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1962529999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1771659999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.26857599999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["37.3144670000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3338310000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.272477999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.6567620000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1204159999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8443059999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.2028090000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.9716010000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7956169999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8497220000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.5291650000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5991269999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.1277999999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.4886699999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.5787210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0515070000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4563389999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.4694810000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4030000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2246829999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9257029999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3144670000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.008544999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0097640000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.9192690000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.1361370000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.0029500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8559869999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4172849999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.8633750000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4092969999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6481489999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6210800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.2758789999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.5154370000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0897159999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7864220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5929210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3473820000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1962529999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.3447590000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6781250000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2444220000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["77.3978427499999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.38605453100000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.86929392299999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.71173170199999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.405273038099999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.220108553699999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.66124153999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.369570938800000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.17806391599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00170824526199999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0767567215299999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.329382999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.426497999999999954`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.84719799999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.221760000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0333839999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0355839999999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.95948300000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.9776629999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.765596999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.640376999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.994132000000000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.855410000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.41529400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29740699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32184199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.9008049999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.8824719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.9305579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23396100000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.9939670000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0336640000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01867200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.699059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.6951139999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.101224999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.2128219999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2069199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.151461000000000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.0393110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.0447810000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.140391999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.9696989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9813959999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.300161000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8144289999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8195840000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.132298999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8995299999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9034029999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0993759999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["17.0393110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.059235000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.511287999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2589900000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2956579999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.940958000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.9696989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9705950000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0229980000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["43.8144289999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8129709999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0373980000000000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["33.250759000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2662819999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.398357000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.392110999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.3836530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.217047999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["40.4556800000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.4678619999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.312619999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.7920909999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.7919419999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00382300000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["11.8824719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.9786809999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23443900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.699059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.6910240000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.103088000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.2128219999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2012260000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.148780000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["33.250759000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3010140000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.644819999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.0393110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.0557440000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.210853000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.9696989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.981319`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.149094999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8144289999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8044450000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.128100999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["44.5606680000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.5814159999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.266211999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.0393110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.0736730000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.44089400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2589900000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3323150000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.940831000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.9696989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9833029999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.174553999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8144289999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8322520000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.228691000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.9939670000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.072970999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01367899999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.4161210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4239959999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.101034000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.250759000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4830770000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.98084900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["38.1941890000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.0522630000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.82103199999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["11.8824719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.699059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2128219999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5138799999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3648039999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9163370000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9999139999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0873000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3320389999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.3056729999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4949340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.7924289999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2589900000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.022916999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4210760000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.1805180000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9939670000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4161210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.1941890000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1059970000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3196939999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1674949999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.8812589999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3519450000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.392110999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8733060000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7043729999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.3874270000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.5606680000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.4905250000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.4904200000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.9885699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.0393110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9696989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8995299999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8144289999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.250759000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.4556800000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.7920909999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4168450000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ttraj5*.out, large basis, n=(2,0) can be tachyonic, no \
constraint on lattice spacing\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 41 criteria and tolerance 0.01.\\nOverall scale from \
minimizing chi^2.\\nParity doublets (o,multi,state) with error for difference\
\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error 0.25\\n  (-1, 5,0) and \
(-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, 4,0), error 0.25\\nSpectrum for \
P_perp a = (0,0), ( 0.25 0)\\n  using (# states, multiplet, o, c^2 error for \
each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 \
2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 \
2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 0.25)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4, 11 & 12,  1 & -1, 0.25 2 2 2)\\n  \
(4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & 13,  1 & -1, 0.25 2 2 2)\\n  \
(4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary spectra multiplets, 4 states, \
(o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  \
5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) .\\nAll spectra extrapolated \
using (K,p) = (16/2,8)  (16/2,6) \\n  (20/2,6)  (26/2,6) .\\nWinding \
potential using (n,K,p) = ( 2 0,20/2,4)  ( 2 0,20/2,6) \\n  ( 2 0,24/2,4)  ( \
2 0,32/2,4)  ( 3 0,19/2,5)  ( 3 0,19/2,7) \\n  ( 3 0,25/2,5)  ( 3 0,33/2,5)  \
( 4 0,18/2,6)  ( 4 0,18/2,8) \\n  ( 4 0,24/2,6)  ( 4 0,32/2,6) .\\nRoundness \
of winding using (n,K,p) = ( 2 2,16/2,6) \\n  ( 2 2,16/2,8)  ( 2 2,24/2,6)  ( \
2 2,28/2,6) \\n  with error 1; in G^2 N units.\\nHeavy potential determined \
using (n,K,p,K_max) =\\n  ( 0 0,-34/2,2,3)  ( 0 0,-34/2,4,3)  ( 0 \
0,-34/2,2,4.5) \\n  ( 0 0,-50/2,2,3)  ( 0 0,-50/2,2,4.5)  ( 0 0,-60/2,2,3) \
\\n  ( 0 0,-60/2,2,4.5) ,\\n L = 3 4 6 (all in G^2 N units); relative scale \
error=0.1.\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-17/2,3,3) \\n  \
( 1 0,-17/2,5,3)  ( 1 0,-17/2,3,4.5)  ( 1 0,-33/2,3,3) \\n  ( 1 \
0,-33/2,3,4.5)  ( 1 0,-55/2,3,3)  ( 1 0,-55/2,3,4.5) \\n L=0 and error \
0.1;\\n  ( 1 0,-17/2,3,3)  ( 1 0,-17/2,5,3)  ( 1 0,-17/2,3,4.5) \\n  ( 1 \
0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3) \\n  ( 1 0,-55/2,3,4.5) \
\\n L=2.5 and error 0.1;\\n  ( 1 0,-17/2,3,3)  ( 1 0,-17/2,5,3)  ( 1 \
0,-17/2,3,4.5) \\n  ( 1 0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3) \
\\n  ( 1 0,-55/2,3,4.5) \\n L=5 and error 0.1;\\n  ( 1 1,-30/2,2,3)  ( 1 \
1,-30/2,4,3)  ( 1 1,-30/2,2,4.5) \\n  ( 1 1,-40/2,2,3)  ( 1 1,-50/2,2,4.5)  ( \
1 1,-60/2,2,3) \\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error 0.1; all in G^2 N \
units.\\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \\n  (35/2,3)  \
(45/2,3)  (13/2,5)  (29/2,5)  (13/2,7) \\n  (17/2,7) .\\nResult format:\\n \
Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\\n The 10 \
couplings  (G^2 N units);\\n   which couplings -- if any -- were fit.\\n \
Winding potential and heavy souce potential fits.\\n Roundness of winding \
potential, 1 values, and roundness of\\n   heavy source potential, 4 values, \
(G^2 N units)\\n   showing measured value and derived value for each.\\n The \
rescaled spectrum for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{\(-2\), ",", "10", ",", 
                    StyleBox["43712.4993599999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.25`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->2]}], ",", 
                    StyleBox["3.82986057899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "0", ",", "1", ",", 
                    StyleBox["0.461547141299999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0285715473200000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.235374258000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.10553386360000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.996237314399999895`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0738477899599999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.00833000000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    RowBox[{"-", 
                      StyleBox["1.99131499999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["2.10796800000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0362019999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0758700000000000063`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.320664000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.8597649999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.66117600000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.426149000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.854136000000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.581142000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.142544000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.867948999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.169556000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.516305000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.59069199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["7.81794100000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.78355599999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.0175520000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["7.34129400000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.30279100000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.0196539999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["7.25091000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.22477299999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.0133420000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["3.045134`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["5.33161899999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.1671689999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["3.69512600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.72679600000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0161660000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["5.16325400000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.39103499999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.394190000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["5.42348400000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.19969299999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.11423700000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["6.75361000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.76998700000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.00835999999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["0.183847000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.8032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.826622000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.4896180000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.82747499999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.848464000000000062`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["3.69512600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.12693600000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.800505000000000066`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["5.16325400000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.16394199999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.000351000000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->3], ",", 
                    RowBox[{"-", 
                      StyleBox["0.850682000000000115`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.818303000000000047`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0165280000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["2.93458700000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.95143900000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.00860200000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["4.35184700000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.25526200000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.049302999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["5.89059299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.33406700000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.794551000000000051`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.81794100000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.74919299999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.0175469999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["7.34129400000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.27579699999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.0167169999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.850682000000000115`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.859002000000000087`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00212400000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.659816999999999964`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0272990000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.175374000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.69512600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.83231199999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.475450000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["5.16325400000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.76263099999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.357484000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["5.19906600000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.18334000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.259245999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["5.42348400000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.17184000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0642279999999999962`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.183847000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.81788299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.417058999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.4896180000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.1597590000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.339422999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["3.69512600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.22891999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.39147400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["5.16325400000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.77480300000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.411318999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["7.25091000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.18689300000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.0163389999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["3.045134`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["5.3254809999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.582018000000000057`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.850682000000000115`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.34361599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.560055000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.70889300000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.70611699999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.000708000000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->3]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.81794100000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["7.34129400000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.350600000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.659816999999999964`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["13.3467690000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["5.42348400000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.5163769999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.5863620000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["7.45540299999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.8275159999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.3742430000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.1794199999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.183847000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.4896180000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.0230309999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.4332890000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["7.25091000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["3.045134`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["4.45533399999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.70889300000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["8.38189599999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.2221069999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.1143180000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8440130000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.93458700000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["7.11984100000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.7156380000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.7182600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["5.19906600000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.0393819999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["8.79339300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.4535509999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.69512600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.16325400000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.75361000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["11.3669459999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.850682000000000115`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["4.35184700000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.89059299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.15610400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{\(-2\), ",", "19", ",", 
                    StyleBox["468.65126220000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.636644429800000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.86231474900000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.43619963859999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0750297188600000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.245434502700000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["1529.79781899999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.085330792389999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["731.759076200000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.268360466399999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.931129931599999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.0836500000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["1.115842`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.11424400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.173111999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.115192000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.127732000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.107623000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.307364000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.51130399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.452669999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.867952999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.662424000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.28247899999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.04280700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.885281999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.632176999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.34878399999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.28931400000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.625797000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.84273400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.89606999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.561247999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["4.54015599999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.58104699999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.430292999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.1150239999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.0521410000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.661707`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["14.7078029999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7510879999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.455485000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1672160000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2118619999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.46980599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8664680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9093240000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.450966000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.528176000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5392950000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.117000999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.3299540000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.3780710000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.506322999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.7078029999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7193409999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.121405999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1672160000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1926549999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.267697999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8664680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6075160000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.72492499999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["15.1150239999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.150074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.368829999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2028570000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2057139999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0300570000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["31.7462290000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4031550000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["3.61013500000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.5046690000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5377750000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.34836800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.34878399999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.22980700000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.62599499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["4.54015599999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.62897099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.467295999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.1150239999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.0331329999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.430865000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.8727639999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.9406439999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.35714699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.7078029999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7854460000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.408516000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1672160000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2135339999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.243703000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8664680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9160980000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.261126000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.7066060000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6071519999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.523273999999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["14.3299540000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.4257039999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.503781000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.7078029999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7405150000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.172109000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1672160000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2608180000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.49248099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8664680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9195559999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.279317999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.84273400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.94169899999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.520699000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.1150239999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.142644999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.145325000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.211483000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3583940000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.772961000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.9085649999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9114509999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0151849999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["1.34878399999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["4.54015599999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.8727639999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5794930000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.937228000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5580410000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2705190000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5753169999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.4397739999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9803279999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8865730000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9262959999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.3299540000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9071199999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8858979999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6245550000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.84273400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.9085649999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.211483000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9978570000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.528176000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3914310000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9912769999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6811799999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2028570000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.0746800000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0515180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4603799999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7066060000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8714789999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5338049999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4992310000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7078029999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1672160000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8664680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3452949999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.1150239999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5046690000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2489249999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7462290000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "13", ",", 
                    StyleBox["17.7006782200000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.47722671500000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.1723962799999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.494193281500000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0435257308999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0624265033300000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["177.459468799999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.10577167919999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["77.0152308199999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.820502739500000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.751063647900000042`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.19208400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.865090999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.692537999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0959399999999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.187260000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.119755999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.26911799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.758148999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.577567000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.632582000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.634309000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.692943999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.879001000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.841568999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.04667700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.834333999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.9055020000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.9363840000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0603800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.6234070000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.6462980000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.786019000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.7968380000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8196499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.783279999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3713359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3636529999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.263806999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.8234959999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8445290000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.722189000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.1169220000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1601429999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.4840720000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["61.9920589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0206429999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.981486999999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["67.8163019999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.7991009999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.590643000000000029`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.8234959999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8572179999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15787700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.4726480000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5069689999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17845399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.1169220000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1068590000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.345542000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["61.9920589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0196559999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.947578000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7172090000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.740207999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.789724000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.8100219999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7961990000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.474621000000000048`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["58.3414759999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3618900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.700964000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.8347500000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.851983999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.591736000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.9055020000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.967289`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.06077500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.7968380000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.841952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.774537000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3713359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.368234000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0532610000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["29.7172090000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.684923000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.554281000000000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.8234959999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8731440000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.852365999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.1169220000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1433460000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.453652999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.9920589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0229370000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.530126000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["70.6363949999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.6941459999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.991478000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8234959999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8833990000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.028424`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.4726480000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5412839999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1783539999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.1169220000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1566729999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.682462000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.9920589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0715799999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36524700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.6234070000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.6693740000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.789191999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3747000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3805049999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.099654000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["29.7172090000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7043340000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.221039000000000029`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.4269660000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5341440000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.84006299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.9055020000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.7968380000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3713359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.0369809999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6407820000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.3553150000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.894424999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.460289999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["66.6629979999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.8484250000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.529566000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.076368999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.4726480000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.817978999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.6228909999999885`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6388990000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.6234070000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3747000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4269660000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4677130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.8163019999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.0175069999999877`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.47622999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.790087000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.8100219999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.2936239999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.640631000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["91.2022550000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.6363949999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.0608150000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.285304`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.3961730000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8234959999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1169220000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9920589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.3270119999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7172090000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3414759999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8347500000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.637242000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "39", ",", 
                    StyleBox["22.4718008899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.57296656399999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.475988490000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.685156910699999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0757677949899999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0873152966900000038`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["134.04203240000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.164387683199999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["35.528274719999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.973646936399999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.793146801099999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.173478999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.11345500000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.942093999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.105076999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.142465000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.068689`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.464841999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.392135999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.556535000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.585210000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.610361999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.657217000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.855859000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.829424000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.01446900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.779732000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["5.90816400000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.94778300000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.15201400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3634470000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3859890000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.655471000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.9298779999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9509429999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.612496000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6774789999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6548750000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.657255000000000055`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.5143840000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5335040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555966999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.9967789999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0377539999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19147699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["56.8882069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.917895000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.863241000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.7104569999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6922610000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.529089000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.5143840000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5530440000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1241509999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.6349569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6898929999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.59740799999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.9967789999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.9796099999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.499209000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.8882069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9175820000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.854141999999999868`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6774789999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7041500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.775556`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.0456470000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0335520000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.351709000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.2000570000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2174920000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.506965000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.4631260000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4878209999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.718072000000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["5.90816400000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.98741400000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.15220300000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.9298779999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9720399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.612986000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6774789999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6489229999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.415167999999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.8552029999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8595250000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0628340000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["23.5143840000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5690359999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.794572999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.9967789999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0178969999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.307045999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.8882069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9095040000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.309622999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.9851359999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0388020000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.780255999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.5143840000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5753849999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.886875000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.6349569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7447510000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.59627600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.9967789999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0233209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.385892000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.8882069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9839059999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.39135399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3634470000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4085229999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.655360999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6774789999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7146509999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.540449999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9261429999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8804009999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.665038000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["44.6230409999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.6546489999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.459553999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["5.90816400000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.9298779999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8552029999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.9410260000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3121469999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.1439189999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.112132999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["95.6640600000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6699169999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.0154150000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.062731999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["120.711396000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["28.6349569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4862589999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.5654710000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.955409999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["23.3634470000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9261429999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.6230409999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.595975000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7104569999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5811250000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.8971829999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.3118000000000122`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0456470000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.9102529999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.1435969999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.948727999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["62.9851359999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.2714000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.0455890000000138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.0338179999999894`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5143840000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.9967789999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8882069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1720829999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6774789999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2000570000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4631260000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4176710000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "30", ",", 
                    StyleBox["38.0997178100000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.28933441599999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.2085541519999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.646794183799999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0209879255199999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.205561835199999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["59.5812266699999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.141125155499999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["23.0090448800000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.72889687520000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.259845836800000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.197698000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.856006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.466903999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.138627000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.137437000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0925359999999999871`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.52104999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.783940999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.626942000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.618043000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.791610000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.729793000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.13222599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.980644999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.13332300000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.835044000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.4643130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.5130430000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26528299999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.3071659999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.3405430000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.866624000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.691319`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.725797`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.89524000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6512229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6147839999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.946147999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.084131000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1088540000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.641943000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8843699999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9150269999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.796011000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.4965729999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5312940000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.901535999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.9077530000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9090149999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0327700000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["23.084131000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1076630000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.611000999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1638510000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1942399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.789046000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8843699999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9032509999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490258000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.4965729999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5080280000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.297435000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6512229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6798779999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.744028000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.7681800000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7559979999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.316297000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.3652949999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3952570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.777954999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.2919520000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2986410000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.17368800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.4643130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.5617979999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26559700000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.691319`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.756888`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.85125200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6512229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5777150000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.954327999999999931`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["33.7432280000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8002940000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.740863000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.084131000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1263210000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.547737000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8843699999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9245260000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.521328000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.4965729999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5331010000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.474227000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.2188290000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2141760000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0604089999999999971`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["23.084131000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1385070000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.70593300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1638510000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2246459999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.789267999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8843699999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9431259999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.762804000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.4965729999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5522500000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.722832000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.3071659999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.3772139999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.909389000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6512229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7103770000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.767957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.2687090000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3523500000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08586999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.4887459999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4469970000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.542009999999999969`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["11.4643130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.691319`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7432280000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0865569999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5509919999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.3808089999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.9902270000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.8313120000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.3117849999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.4549830000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6152819999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.922392999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.1638510000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8953609999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.0890430000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.6085260000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.3071659999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4887459999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.2687090000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.736390999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9077530000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4812500000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7253610000000101`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.0589479999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7681800000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.3592280000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.7097449999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.801156000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["61.2188290000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5657700000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.9108750000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.287865`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.084131000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8843699999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.4965729999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3485880000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6512229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3652949999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2919520000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9913039999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "39", ",", 
                    StyleBox["29.481338560000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.25855856600000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.25765071800000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.813093905500000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0110271838700000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.107214400600000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["87.7151950800000079`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.156287194499999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.22887215700000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.933233455100000064`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.838683276599999949`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.242430000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.883718000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.29408000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.135765000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.119542999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0661719999999999952`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.52530999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.09248100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.645361999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.655263000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.720559999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.753674999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.00381300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.984203000000000116`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14562199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.888674999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.8582319999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.8972139999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.24863499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.9057009999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.92511`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.62166200000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.9473159999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9532649999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.190566999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8827529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8881900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.17416999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1337350000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.148217999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.463886999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.3167829999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3440579999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.873610000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.828603999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8516630000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738596999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.7845790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7772600000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.234434999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["24.1337350000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1641720000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.974913000000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.1145200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1515449999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18592300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.3167829999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.312097999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.150075999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["55.828603999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8402400000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.372703999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8827529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9053770000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.724666000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.5427079999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5304729999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.391901999999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["52.3194479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.3386009999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.613492999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.547982000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5558769999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.25285700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.8582319999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.9361890000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2484980000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.9473159999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9592900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.191772000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8827529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8969890000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.227993000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.5112700000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5330020000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.348038999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1337350000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1708539999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.594463000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.3167829999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3396479999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.366185999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.828603999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8399640000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.181938999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.6661489999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.704661000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.616793000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1337350000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.186462999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.844457000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.1145200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1885729999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18597100000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.3167829999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3391649999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.358451999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.828603999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8864329999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.926139000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.9057009999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9446170000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.623248000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8827529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.936198`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.855945999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.5852629999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.4865179999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.58141099999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["38.8247289999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8699059999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.723531999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.8582319999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9473159999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5621739999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5112700000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.5747130000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.1929089999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.6699499999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.7559999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.167867000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.3237419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.0297330000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.331181000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.1145200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4726240000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.9843319999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.441216999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9057009999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5852629999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8247289999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.3235799999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7845790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.8998110000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.9986249999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.2744730000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5427079999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.1356669999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.6136060000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.093719999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["61.6661489999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4796640000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.6351769999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.511244999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.1337350000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3167829999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.828603999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6252620000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8827529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.3194479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.547982000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9343520000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["53.707946169999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.66131001600000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.0136802979999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.901553774100000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.112208428100000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.133064238000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["27.94252277`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.187396310200000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["8.94655963800000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.250628024000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.214874339999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.272426000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.771302999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0174029999999999969`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.20500499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0601469999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0639799999999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.99916599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.40592699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.677150999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.683232999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.863704999999999856`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.86683299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.24009999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.25956800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.21434599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.955736999999999881`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.9703749999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.0139580000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14240399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.1826019999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.3011879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.10842600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.3078150000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3549840000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2364250000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.9919839999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0167830000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.650039000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.8495969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8583570000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.229634999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.7648269999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7832480000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.482845000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8259150000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8398859999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.366211999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4054829999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4048519999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0165350000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["18.8495969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8702469999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.541305999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.7669839999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.793555999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.696524999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.7648269999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7638760000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.024939`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["45.8259150000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8357909999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.258872999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8696369999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8854840000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.415378999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1144970000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1056209999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.232684999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.1815969999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.193975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.324441999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1801289999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1857989999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.148616999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.9703749999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.0570069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13541099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.1826019999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2195789999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.48462499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.3078150000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.400825000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21901499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.8696369999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8635820000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0793599999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["18.8495969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8710239999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.280831000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.7648269999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7821289999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.226759999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8259150000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8387459999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.168162000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.5143950000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6946789999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.36284999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.8495969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8869959999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490167999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.7669839999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.8201330000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.696594000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.7648269999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7824939999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.231542000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8259150000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8607169999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.45611600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.9919839999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0416409999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.650812999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7565899999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7330210000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.308905999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.8696369999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8698200000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00238900000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["30.818903999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.814007000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0641929999999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["11.9703749999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3078150000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.1826019999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7997120000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3721990000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.0486220000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.4534469999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.0936430000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2659369999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.8167880000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.3064789999999888`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.1227729999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7669839999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0955480000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.294400999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0658869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9919839999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7565899999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.818903999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.5137720000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4054829999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8761579999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.9545179999999913`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.1812809999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1144970000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6699150000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.7730820000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.0666820000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5143950000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7150629999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5060050000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.6733020000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.8495969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7648269999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8259150000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4581500000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8696369999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.1815969999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1801289999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1151980000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["38.7603742200000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.237652207`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.20682071400000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.05801363600000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00731168174799999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.176491356899999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["65.843876330000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.244496145599999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["19.0194822300000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.95469863539999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.511968747299999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.276934000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.70676300000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.352942`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.158540999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0819650000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0370250000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.13249900000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.46459399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.701241000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.673479999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.845242000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.793975000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.19926400000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.07101200000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24297999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.925397000000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.7790680000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.8186819999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2649840000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.6397979999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6623699999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.720778000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.8639849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.8897149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.821624000000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.3020649999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3388809999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.175624`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.8505089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8633469999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.409968999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1801149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2017439999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.690678000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.9110899999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9323389999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.678542000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.2143719999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.2103219999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.129353999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.8505089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8760780000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.816511000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.9060759999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.9421850000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15309900000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.1801149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1849489999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.154380999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.9110899999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9274539999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.522540000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.3020649999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3263279999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.774773000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.2945559999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2807869999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.439700000000000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["52.9768540000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.9962800000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.620319999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.9820059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9919210000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.316632000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.7790680000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.8583119999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26525299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.8639849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9141219999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.800498999999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.3020649999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2818320000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.323060999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.3218040000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.355724000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.541575000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.8505089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.877486000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.430736999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1801149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2051480000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.399697000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.9110899999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.937863999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.427482000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.066091999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0897489999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.377719000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.8505089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9003640000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.796008999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.9060759999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.9783039999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15324399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.1801149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2080180000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.445518999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.9110899999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9594830000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.772665000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.6397979999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6865179999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.745944999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.3020649999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3143859999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.196717999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.6322449999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6014520000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.491652999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["36.787711999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8134089999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.41029100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.7790680000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.8639849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3218040000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5690380000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.1955779999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.3405850000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.5080980000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.649235000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.8004249999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6021150000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.304702999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.009916000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["36.9060759999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6097839999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.064915999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.4650439999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6397979999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.787711999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6322449999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5815019999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.2143719999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4132180000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.2344010000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.2179730000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2945559999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.166959000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1112009999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9719650000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.066091999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.97822600000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5894650000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.113943999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["23.8505089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1801149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9110899999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0561880000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3020649999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.9768540000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9820059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.862083999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["55.7140605299999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02710222799999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.03085039100000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.27447359599999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0329003338499999964`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.19457651740000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.278154174500000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.127598811299999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.51710475339999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.283951999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.689235000000000042`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.735794999999999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.214562000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0447639999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0476849999999999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.88571799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.49040400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.717825000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.719458000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.866785999999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.906657000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.22924900000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.31203599999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.237989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.009417`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.26176099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.29985199999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.04365400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.0296259999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0519710000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.612245000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.3890990000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.3957639999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.182636999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7697199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7777219999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.219239000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.2400439999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2507009999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.291992999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.8214120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8386900000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.473407`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.9040150000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9397199999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.978312000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.8737409999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.8717519999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0545139999999999957`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["20.2400439999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2642629999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.663590000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8943930000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9310969999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00566599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.8214120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.824753000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0915460000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["48.9040150000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9495349999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.24723300000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1625279999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1849980000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.615674999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7805990000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7679799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.345764000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.8722289999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8905049999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.500764999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.4186229999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4248059999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.169388000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["9.26176099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.33794699999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.04372299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.0296259999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0737960000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.605119999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7697199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7857120000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.219084000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.993787000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9871440000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0910040000000000048`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["20.2400439999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2653179999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.346245000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.8214120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8412319999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.271525999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.9040150000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9559280000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.711200999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.7556280000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7728570000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.236024000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.2400439999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2845329999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.609492000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8943930000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9678010000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.005668`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.8214120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8428800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.294115999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.9040150000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0148820000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.51885799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.3890990000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4041719999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.206503000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9914799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0430969999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.707149999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1625279999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0984700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.877575000000000038`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.4655990000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5552489999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22818500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.26176099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.0296259999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7697199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.993787000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.7000119999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6111250000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.8471530000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.3734680000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.3167759999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.0435990000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.304784000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.2419620000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8943930000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4355079999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.8487640000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4376550000000101`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.3890990000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4655990000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9914799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.145944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.8737409999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9940009999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4236879999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.5223079999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7805990000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6143440000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.5200659999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2407429999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7556280000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5665489999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7369570000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4252819999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2400439999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8214120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9040150000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.467672000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1625279999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8722289999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4186229999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6944159999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["46.607583469999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.922120534899999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.06522791600000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.53001593399999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0473714894999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.174893743500000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["62.9909622400000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.331763698600000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["21.8057091000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.587711152400000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.634575239100000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.298629999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.621388999999999924`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.29031000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.208167999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0503479999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0537309999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.67496599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.60636599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.734970000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.724103999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.871096000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.901634999999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.22943899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29015199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23133099999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.01464599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["7.59524000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["7.63361100000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.11199399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.4910340000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5159519999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.722134999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.6457529999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6405430000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.150968999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.9211769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9365079999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.444287000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.6479830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6569219999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.25906699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.1763069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1929540000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.482439999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.2303049999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2273339999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0860849999999999937`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["52.0556909999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0551320000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0162029999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["20.6479830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6747600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.776001000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.3485209999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3921810000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26527600000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.1763069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1755489999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0219759999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["48.2303049999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2285479999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0508990000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["30.2585209999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2799909999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.622202999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.9272869999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9146519999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.366176000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.7427929999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.7607950000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.521703000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.4737689999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.4764639999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0781030000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["7.59524000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["7.67197300000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.11186800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.4910340000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5406879999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.71949500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.6457529999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6353490000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.15075400000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.1935769999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1782250000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.222459999999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.6479830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6735999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.371199999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.1763069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1911100000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.214493`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.2303049999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2193969999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.158050999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.367790999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3928909999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.363704999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.6479830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6938059999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.663975999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.3485209999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4358220000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26500100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.1763069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1933709999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.24726300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.2303049999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.231906999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0232249999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["27.9211769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9527049999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.456843999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.2019349999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2530780000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.741061000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1768019999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1232000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.776695000000000046`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.2585209999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3076930000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.712508000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["7.59524000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.4910340000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6457529999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1935769999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8514419999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.4430449999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5914010000000082`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.7087919999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0211040000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.4286350000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.4239300000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.394331000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3485209999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4040329999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5367849999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.9030640000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9211769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2019349999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1768019999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3305379999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0556909999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.3801350000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8760140000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9994940000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9272869999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1842370000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0408649999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.6193209999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.367790999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.0680040000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2445840000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.881259`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6479830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1763069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0336779999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2303049999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2585209999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.7427929999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.4737689999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8696449999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "48", ",", 
                    StyleBox["39.9010224299999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.792860947099999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.19297076400000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.84119371400000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0980506783400000081`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.172015285299999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["57.7883757499999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.41827732950000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["20.0376207700000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.11279333099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.926860005200000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.298032000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.512812000000000089`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["2.03032300000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.189480000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0344529999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0134499999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.33784199999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.6176569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.748561999999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.671084000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.844195000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.827979999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.17926799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17587799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.201187`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.937598999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["4.73534100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.77531000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.180342`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.1164340000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1041449999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.362897999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.1720809999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2038139999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.937115000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.986578999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0151810000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.844677000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1608010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1690909999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.244813999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.8442769999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8606699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.484103999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.546778999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5523059999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.163229999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.683756000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6846710000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0270260000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["21.1608010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1892849999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.84119299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.111876999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1632650000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.51757699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.8442769999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8428120000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0432760000000000033`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["47.546778999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5505050000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.110030000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4692499999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4912740000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.650373000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6344390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6209119999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.399453000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.0938040000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.1124629999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.551020999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0526659999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0543230000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.048926999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["4.73534100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.81525499999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17998099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.1164340000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0919409999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.361650999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.986578999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0161209999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.43621300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0278379999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0436620000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.233648999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1608010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1872829999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.391029999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.8442769999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8556609999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.168083000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.546778999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5391890000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.112064999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.5931709999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.624845999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.467696000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1608010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2078830000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.695202000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.111876999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.2145700000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.51633700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.8442769999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8629000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.274971999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.546778999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.572877`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.385348000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.1720809999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2336970000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.909811000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0226810000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9979660000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.364925999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.7603339999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7889620000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.422707999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4692499999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4926340000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.34527000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["4.73534100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.986578999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1164340000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0278379999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1934259999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6539540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.3331029999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4463690000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1084390000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1381489999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4898789999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.2746669999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.111876999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1406650000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1914600000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9504189999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7603339999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1720809999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0226810000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1939840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.683756000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8735909999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.7241060000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8841100000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6344390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.3669969999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0159419999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.0687779999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5931709999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1537830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5631409999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.2435750000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1608010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8442769999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7980560000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.546778999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4692499999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.0938040000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0526659999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0134380000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["data minimum of ttraj3*.out and ttraj5*.out", "Section"],

Cell[BoxData[
    \(\(data = {
        "\<********* Eigenvalues for the 3+1 transverse lattice *********\n\
Couplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\n             0     1   \
   2     3     4     5     6  \n           la_5, tau_1, tau_2   (2-9 divided \
by a^2) \n             7      8      9                         \nUse chi^2 \
fit with 41 criteria and tolerance 0.01.\nOverall scale from minimizing \
chi^2.\nParity doublets (o,multi,state) with error for difference\n  over \
average.\n  ( 1, 5,0) and ( 1, 6,0), error 0.25\n  (-1, 5,0) and (-1, 6,0), \
error 0.25\n  ( 1, 7,0) and (-1, 4,0), error 0.25\nSpectrum for P_perp a = \
(0,0), ( 0.25 0)\n  using (# states, multiplet, o, c^2 error for each) =\n  \
(4,  9 &  8,  1 & -1, 0.25 2 2 2)\n  (4,  8 &  9,  1 & -1, 0.25 2 2 2)\n  (4, \
 7 & 10,  1 & -1, 0.25 2 2 2)\n  (4, 10 &  7,  1 & -1, 0.25 2 2 2)\nSpectrum \
for P_perp a = (0,0), ( 0.25 0.25)\n  using (# states, multiplet, o, c^2 \
error for each) =\n  (4, 11 & 12,  1 & -1, 0.25 2 2 2)\n  (4, 12 & 11,  1 & \
-1, 0.25 2 2 2)\n  (4, 14 & 13,  1 & -1, 0.25 2 2 2)\n  (4, 13 & 14,  1 & -1, \
0.25 2 2 2).\nOrdinary spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \
\n  (-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \n  (-1,  6)  \
( 1,  7)  (-1,  7) .\nAll spectra extrapolated using (K,p) = (16/2,8)  \
(16/2,6) \n  (20/2,6)  (26/2,6) .\nWinding potential using (n,K,p) = ( 2 \
0,20/2,4)  ( 2 0,20/2,6) \n  ( 2 0,24/2,4)  ( 2 0,32/2,4)  ( 3 0,19/2,5)  ( 3 \
0,19/2,7) \n  ( 3 0,25/2,5)  ( 3 0,33/2,5)  ( 4 0,18/2,6)  ( 4 0,18/2,8) \n  \
( 4 0,24/2,6)  ( 4 0,32/2,6) .\nRoundness of winding using (n,K,p) = ( 2 \
2,16/2,6) \n  ( 2 2,16/2,8)  ( 2 2,24/2,6)  ( 2 2,28/2,6) \n  with error 1; \
in G^2 N units.\nHeavy potential determined using (n,K,p,K_max) =\n  ( 0 \
0,-34/2,2,3)  ( 0 0,-34/2,4,3)  ( 0 0,-34/2,2,4.5) \n  ( 0 0,-50/2,2,3)  ( 0 \
0,-50/2,2,4.5)  ( 0 0,-60/2,2,3) \n  ( 0 0,-60/2,2,4.5) ,\n L = 3 4 6 (all in \
G^2 N units); relative scale error=0.1.\nRoundness determined using \
(n,K,p,K_max) = ( 1 0,-17/2,3,3) \n  ( 1 0,-17/2,5,3)  ( 1 0,-17/2,3,4.5)  ( \
1 0,-33/2,3,3) \n  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3)  ( 1 0,-55/2,3,4.5) \n\
 L=0 and error 0.1;\n  ( 1 0,-17/2,3,3)  ( 1 0,-17/2,5,3)  ( 1 0,-17/2,3,4.5) \
\n  ( 1 0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3) \n  ( 1 \
0,-55/2,3,4.5) \n L=2.5 and error 0.1;\n  ( 1 0,-17/2,3,3)  ( 1 0,-17/2,5,3)  \
( 1 0,-17/2,3,4.5) \n  ( 1 0,-33/2,3,3)  ( 1 0,-33/2,3,4.5)  ( 1 0,-55/2,3,3) \
\n  ( 1 0,-55/2,3,4.5) \n L=5 and error 0.1;\n  ( 1 1,-30/2,2,3)  ( 1 \
1,-30/2,4,3)  ( 1 1,-30/2,2,4.5) \n  ( 1 1,-40/2,2,3)  ( 1 1,-50/2,2,4.5)  ( \
1 1,-60/2,2,3) \n  ( 1 1,-60/2,2,4.5) \n L=0 and error 0.1; all in G^2 N \
units.\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \n  (35/2,3)  \
(45/2,3)  (13/2,5)  (29/2,5)  (13/2,7) \n  (17/2,7) .\nResult format:\n Fit \
info, # steps, chi^2, and p damping, scale G^2 N/sigma.\n The 10 couplings  \
(G^2 N units);\n   which couplings -- if any -- were fit.\n Winding potential \
and heavy souce potential fits.\n Roundness of winding potential, 1 values, \
and roundness of\n   heavy source potential, 4 values, (G^2 N units)\n   \
showing measured value and derived value for each.\n The rescaled spectrum \
for each P_perp*a and c^2 values.\n Finally come the states for the ordinary \
spectra.\>", {{2, 20, 40.5403410200000013`, \(-7.49834429399999979`\), 
            11.5486223999999992`, 0, 1, \(-0.179818001100000017`\), 
            \(-0.0659772840299999963`\), \(-0.0528543260300000028`\), 
            4.13167108399999971`, \(-0.0159458962299999988`\), 
            0.961262676900000023`, \(-0.459300856700000004`\), 
            \(-0.396951357000000015`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.179685000000000005`, \(-0.379110000000000013`\), 
            \(-0.397165999999999996`\), 0.0960299999999999975`, 
            0.255049000000000036`, \(-0.214125000000000031`\), 
            1.84360600000000012`, 1.00872000000000006`, 
            0.571504000000000011`, 0.681411999999999995`, 
            0.680308000000000046`, 0.743951999999999991`, 
            0.948351000000000077`, 0.89641699999999993`, 
            1.18137699999999989`, 0.888945999999999969`, 
            13.0057800000000001`, 13.0390960000000011`, 1.10613199999999989`, 
            17.773575000000001`, 17.7998900000000004`, 0.87372000000000014`, 
            22.9329040000000006`, 22.9267209999999987`, 
            \(-0.205282000000000008`\), 27.3221770000000008`, 
            27.2773239999999983`, \(-1.48919599999999991`\), 
            31.071181000000001`, 31.1001510000000003`, 0.961862999999999956`, 
            56.715131000000003`, 56.7412559999999999`, 0.867415000000000091`, 
            63.0784569999999966`, 63.0956830000000046`, 
            0.571934999999999948`, 65.9618090000000023`, 
            65.9578929999999985`, \(-0.130025999999999997`\), 
            31.071181000000001`, 31.0876689999999999`, 0.547457999999999955`, 
            31.6023109999999984`, 31.6075839999999974`, 
            0.175072000000000009`, 56.715131000000003`, 56.7154230000000048`, 
            0.00970999999999999907`, 63.0784569999999966`, 
            63.0787869999999983`, 0.0109610000000000006`, 
            27.3221770000000008`, 27.3327769999999992`, 
            0.351947999999999971`, 30.4227239999999987`, 
            30.4130829999999985`, \(-0.320091000000000036`\), 
            56.5367689999999978`, 56.5568009999999965`, 
            0.665096000000000042`, 61.1395749999999971`, 
            61.1348610000000025`, \(-0.156515999999999984`\), 
            13.0057800000000001`, 13.0723959999999994`, 1.10588700000000006`, 
            22.9329040000000006`, 22.9203860000000014`, 
            \(-0.207810000000000005`\), 27.3221770000000008`, 
            27.2665140000000016`, \(-0.924047000000000018`\), 
            28.2236350000000015`, 28.2444309999999987`, 
            0.345245999999999986`, 31.071181000000001`, 31.1339450000000006`, 
            1.04194000000000008`, 56.715131000000003`, 56.7400540000000042`, 
            0.413743000000000016`, 63.0784569999999966`, 
            63.0951420000000062`, 0.276982000000000017`, 
            78.9970390000000044`, 79.1083770000000008`, 1.84831099999999999`, 
            31.071181000000001`, 31.0993070000000004`, 0.466929999999999978`, 
            31.6023109999999984`, 31.6128880000000034`, 
            0.175594000000000001`, 56.715131000000003`, 56.742991000000007`, 
            0.4625`, 63.0784569999999966`, 63.0970850000000016`, 
            0.309238999999999997`, 17.773575000000001`, 17.8260269999999998`, 
            0.87074700000000007`, 27.3221770000000008`, 27.3091049999999979`, 
            \(-0.216996000000000011`\), 28.2166350000000001`, 
            28.2192609999999977`, 0.0436010000000000008`, 
            33.0025190000000012`, 33.200968000000004`, 3.294435`, 
            13.0057800000000001`, 22.9329040000000006`, 28.2236350000000015`, 
            37.3750119999999963`, 80.7528549999999967`, 87.3785409999999984`, 
            103.596374999999985`, 113.785091000000004`, 64.2800729999999997`, 
            92.0718429999999976`, 98.7501209999999929`, 103.910103000000009`, 
            31.6023109999999984`, 65.2233669999999943`, 93.5529909999999986`, 
            101.469078000000001`, 17.773575000000001`, 28.2166350000000001`, 
            33.0025190000000012`, 55.7613559999999974`, 65.9618090000000023`, 
            85.2166180000000039`, 104.101606999999996`, 107.471361000000009`, 
            30.4227239999999987`, 93.3160110000000031`, 98.5552200000000055`, 
            102.045306999999985`, 81.9943929999999987`, 86.3771470000000007`, 
            103.082121999999998`, 102.020252`, 31.071181000000001`, 
            56.715131000000003`, 63.0784569999999966`, 78.9970390000000044`, 
            27.3221770000000008`, 56.5367689999999978`, 61.1395749999999971`, 
            75.7216540000000026`}, {2, 56, 16.3212029700000016`, 
            \(-1.76420277099999989`\), 11.4617270999999987`, 
            0.00196754267099999999`, 1, 0.390983952200000004`, 
            \(-0.0125028237800000008`\), \(-0.0642123112300000009`\), 
            353.249252899999977`, 0.0704912752200000003`, 
            160.627383500000009`, \(-0.712352071900000005`\), 
            \(-0.651935586899999997`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.181945999999999958`, \(-0.805984000000000122`\), 
            0.689808999999999983`, 0.0929620000000000068`, 
            0.211745999999999989`, \(-0.151139000000000001`\), 
            1.26661599999999996`, 0.735812000000000043`, 
            0.564128999999999969`, 0.635325999999999968`, 
            0.63087200000000001`, 0.694690000000000029`, 
            0.877256999999999997`, 0.840221000000000017`, 
            1.01911499999999999`, 0.832638000000000033`, 
            12.3231519999999994`, 12.3579600000000011`, 1.1614279999999999`, 
            23.7829279999999965`, 23.8055799999999972`, 
            0.755824000000000051`, 24.2804490000000017`, 
            24.2982889999999995`, 0.595237000000000016`, 
            30.3985720000000014`, 30.3706429999999993`, 
            \(-0.931907999999999958`\), 28.775649999999997`, 
            28.7987290000000015`, 0.770068000000000019`, 
            53.5375330000000015`, 53.5807400000000022`, 1.44166499999999997`, 
            62.5370340000000002`, 62.5640030000000013`, 
            0.899870999999999909`, 67.8319699999999947`, 
            67.8195510000000023`, \(-0.414385000000000047`\), 
            28.775649999999997`, 28.8068929999999987`, 1.04247700000000009`, 
            32.5845010000000012`, 32.6129450000000042`, 
            0.949106000000000094`, 53.5375330000000015`, 
            53.5305129999999973`, \(-0.234228999999999976`\), 
            62.5370340000000002`, 62.5582240000000044`, 0.70702499999999997`, 
            30.3985720000000014`, 30.4211380000000009`, 
            0.752932000000000023`, 35.1435590000000042`, 35.130201999999997`, 
            \(-0.445671999999999979`\), 58.4852660000000046`, 
            58.5083770000000047`, 0.771120999999999945`, 
            61.7746309999999976`, 61.7860690000000012`, 
            0.381653999999999982`, 12.3231519999999994`, 
            12.3927720000000007`, 1.16150200000000003`, 24.2804490000000017`, 
            24.3156460000000018`, 0.587203999999999926`, 
            30.3985720000000014`, 30.3740489999999985`, 
            \(-0.409135000000000026`\), 30.9416029999999997`, 
            30.9290179999999992`, \(-0.209960000000000013`\), 
            28.775649999999997`, 28.8289210000000029`, 0.888733000000000039`, 
            53.5375330000000015`, 53.568213`, 0.511847999999999991`, 
            62.5370340000000002`, 62.5646339999999945`, 
            0.460454999999999969`, 68.6218580000000066`, 
            68.6838920000000019`, 1.03494100000000011`, 28.775649999999997`, 
            28.8310560000000002`, 0.924347999999999991`, 
            32.5845010000000012`, 32.6413829999999993`, 
            0.948990000000000044`, 53.5375330000000015`, 
            53.5790900000000025`, 0.69331100000000001`, 62.5370340000000002`, 
            62.6045629999999952`, 1.12660699999999991`, 23.7829279999999965`, 
            23.8283190000000022`, 0.757280999999999959`, 
            30.3985720000000014`, 30.4128590000000009`, 0.23834900000000001`, 
            30.9724709999999969`, 30.9490109999999996`, 
            \(-0.391382999999999992`\), 48.405970000000007`, 
            48.5230750000000021`, 1.95370299999999996`, 12.3231519999999994`, 
            24.2804490000000017`, 30.9416029999999997`, 41.498904999999997`, 
            80.0721530000000036`, 84.1409559999999956`, 101.628817999999987`, 
            114.934519999999995`, 66.3843789999999955`, 87.3875450000000064`, 
            108.588262999999995`, 109.024977999999993`, 32.5845010000000012`, 
            66.8460690000000035`, 86.7391049999999985`, 91.3593039999999945`, 
            23.7829279999999965`, 30.9724709999999969`, 48.405970000000007`, 
            53.4503040000000062`, 67.8319699999999947`, 81.0212790000000104`, 
            96.1299209999999959`, 105.855251999999988`, 35.1435590000000042`, 
            84.678703999999989`, 92.5331699999999912`, 90.712173000000007`, 
            68.6218580000000066`, 88.1063200000000001`, 90.6865439999999978`, 
            89.5032949999999871`, 28.775649999999997`, 53.5375330000000015`, 
            62.5370340000000002`, 74.7931499999999971`, 30.3985720000000014`, 
            58.4852660000000046`, 61.7746309999999976`, 
            67.3260639999999987`}, {2, 13, 17.7006782200000012`, 
            \(-1.47722671500000002`\), 11.1723962799999987`, 
            0.00791922201599999997`, 1, 0.494193281500000036`, 
            \(-0.0435257308999999992`\), \(-0.0624265033300000027`\), 
            177.459468799999964`, 0.10577167919999999`, 77.0152308199999957`, 
            \(-0.820502739500000011`\), \(-0.751063647900000042`\), 2, 3, 4, 
            5, 6, 7, 8, 9, 0.19208400000000001`, \(-0.865090999999999965`\), 
            0.692537999999999964`, 0.0959399999999999941`, 
            0.187260000000000008`, \(-0.119755999999999996`\), 
            1.26911799999999996`, 0.758148999999999961`, 
            0.577567000000000074`, 0.632582000000000022`, 
            0.634309000000000011`, 0.692943999999999959`, 
            0.879001000000000054`, 0.841568999999999967`, 
            1.04667700000000007`, 0.834333999999999953`, 
            10.9055020000000002`, 10.9363840000000012`, 1.0603800000000001`, 
            21.6234070000000011`, 21.6462980000000015`, 
            0.786019000000000023`, 21.7968380000000028`, 
            21.8196499999999993`, 0.783279999999999976`, 
            28.3713359999999994`, 28.3636529999999975`, 
            \(-0.263806999999999991`\), 28.8234959999999986`, 
            28.8445290000000031`, 0.722189000000000014`, 
            53.1169220000000041`, 53.1601429999999997`, 1.4840720000000001`, 
            61.9920589999999993`, 62.0206429999999997`, 
            0.981486999999999909`, 67.8163019999999949`, 
            67.7991009999999949`, \(-0.590643000000000029`\), 
            28.8234959999999986`, 28.8572179999999978`, 1.15787700000000004`, 
            34.4726480000000012`, 34.5069689999999962`, 1.17845399999999989`, 
            53.1169220000000041`, 53.1068590000000018`, 
            \(-0.345542000000000015`\), 61.9920589999999993`, 
            62.0196559999999941`, 0.947578000000000031`, 
            29.7172090000000022`, 29.740207999999999`, 0.789724000000000003`, 
            34.8100219999999982`, 34.7961990000000032`, 
            \(-0.474621000000000048`\), 58.3414759999999965`, 
            58.3618900000000007`, 0.700964000000000009`, 
            59.8347500000000032`, 59.851983999999998`, 0.591736000000000039`, 
            10.9055020000000002`, 10.967289`, 1.06077500000000002`, 
            21.7968380000000028`, 21.841952`, 0.774537000000000031`, 
            28.3713359999999994`, 28.368234000000001`, 
            \(-0.0532610000000000027`\), 29.7172090000000022`, 
            29.684923000000003`, \(-0.554281000000000023`\), 
            28.8234959999999986`, 28.8731440000000016`, 
            0.852365999999999957`, 53.1169220000000041`, 
            53.1433460000000046`, 0.453652999999999995`, 
            61.9920589999999993`, 62.0229370000000024`, 
            0.530126000000000008`, 70.6363949999999896`, 
            70.6941459999999999`, 0.991478000000000037`, 
            28.8234959999999986`, 28.8833990000000007`, 1.028424`, 
            34.4726480000000012`, 34.5412839999999965`, 1.1783539999999999`, 
            53.1169220000000041`, 53.1566729999999942`, 
            0.682462000000000035`, 61.9920589999999993`, 
            62.0715799999999973`, 1.36524700000000009`, 21.6234070000000011`, 
            21.6693740000000012`, 0.789191999999999982`, 
            28.3747000000000006`, 28.3805049999999994`, 
            0.099654000000000007`, 29.7172090000000022`, 
            29.7043340000000011`, \(-0.221039000000000029`\), 
            48.4269660000000001`, 48.5341440000000012`, 1.84006299999999995`, 
            10.9055020000000002`, 21.7968380000000028`, 28.3713359999999994`, 
            42.0369809999999954`, 79.6407820000000032`, 83.3553150000000009`, 
            104.894424999999991`, 105.460289999999989`, 66.6629979999999999`, 
            89.8484250000000095`, 111.529566000000013`, 105.076368999999991`, 
            34.4726480000000012`, 66.817978999999994`, 86.6228909999999885`, 
            98.6388990000000021`, 21.6234070000000011`, 28.3747000000000006`, 
            48.4269660000000001`, 51.4677130000000015`, 67.8163019999999949`, 
            80.0175069999999877`, 102.47622999999999`, 103.790087000000008`, 
            34.8100219999999982`, 77.2936239999999941`, 105.640631000000007`, 
            91.2022550000000009`, 70.6363949999999896`, 90.0608150000000051`, 
            93.285304`, 88.3961730000000045`, 28.8234959999999986`, 
            53.1169220000000041`, 61.9920589999999993`, 77.3270119999999927`, 
            29.7172090000000022`, 58.3414759999999965`, 59.8347500000000032`, 
            67.637242000000004`}, {2, 29, 20.1174912699999985`, 
            \(-1.43646350200000005`\), 10.3711990100000006`, 0.01800590693`, 
            1, 0.600475960499999938`, \(-0.0310396335500000031`\), 
            \(-0.0773642064199999968`\), 1615.4611270000001`, 
            0.135396084800000005`, 730.160331100000004`, 
            \(-0.899210910200000057`\), \(-0.810959006200000054`\), 2, 3, 4, 
            5, 6, 7, 8, 9, 0.203383000000000002`, \(-0.893374000000000023`\), 
            0.619376000000000015`, 0.105174000000000011`, 
            0.163912000000000013`, \(-0.0981419999999999959`\), 1.300991`, 
            0.811111999999999966`, 0.594986000000000014`, 
            0.634848999999999996`, 0.650352999999999958`, 
            0.703188000000000013`, 0.900795000000000101`, 
            0.869664000000000037`, 1.0775539999999999`, 
            0.844754999999999967`, 11.011782000000001`, 11.0446409999999994`, 
            1.10894200000000009`, 23.1154870000000034`, 23.1371720000000014`, 
            0.73184199999999997`, 23.3067530000000022`, 23.3310040000000018`, 
            0.81847600000000007`, 29.8445719999999994`, 29.8577629999999984`, 
            0.445204000000000021`, 27.5330560000000001`, 27.552048`, 
            0.640972000000000008`, 51.7221129999999984`, 
            51.7614410000000013`, 1.32727900000000009`, 60.7166899999999998`, 
            60.7460570000000021`, 0.991104999999999947`, 
            66.8382789999999982`, 66.8213919999999994`, 
            \(-0.569918999999999975`\), 27.5330560000000001`, 
            27.5665760000000004`, 1.13128000000000006`, 34.81881`, 
            34.8565600000000008`, 1.27403299999999997`, 51.7221129999999984`, 
            51.713654`, \(-0.285496999999999978`\), 60.7166899999999998`, 
            60.7435710000000028`, 0.907226999999999961`, 
            30.8745080000000005`, 30.8985480000000034`, 
            0.811330000000000062`, 36.0684290000000018`, 36.054592999999997`, 
            \(-0.466949999999999931`\), 57.697415000000003`, 
            57.7167069999999959`, 0.651086999999999971`, 
            59.3834250000000007`, 59.402001000000002`, 0.626927000000000056`, 
            11.011782000000001`, 11.0775179999999995`, 1.10926300000000011`, 
            23.3067530000000022`, 23.3547320000000002`, 
            0.809637000000000028`, 29.8445719999999994`, 
            29.8416299999999967`, \(-0.0496419999999999994`\), 
            30.8745080000000005`, 30.8388200000000001`, 
            \(-0.602205000000000012`\), 27.5330560000000001`, 
            27.5779800000000019`, 0.758071000000000072`, 
            51.7221129999999984`, 51.7480100000000042`, 
            0.436990999999999996`, 60.7166899999999998`, 
            60.7457530000000023`, 0.490423000000000008`, 69.206644999999991`, 
            69.237055999999999`, 0.513173000000000012`, 27.5330560000000001`, 
            27.5931950000000014`, 1.01482699999999992`, 34.81881`, 
            34.8943080000000005`, 1.27399400000000007`, 51.7221129999999984`, 
            51.7578680000000002`, 0.603342000000000044`, 
            60.7166899999999998`, 60.7986649999999961`, 1.38330299999999994`, 
            23.1154870000000034`, 23.1592719999999996`, 
            0.738840000000000074`, 29.863135999999999`, 29.8939939999999992`, 
            0.520723000000000091`, 30.8745080000000005`, 
            30.8376629999999973`, \(-0.621729999999999982`\), 
            47.5751240000000041`, 47.6037279999999984`, 
            0.482669999999999976`, 11.011782000000001`, 23.3067530000000022`, 
            29.8445719999999994`, 41.2915380000000009`, 78.1375240000000026`, 
            80.9248760000000011`, 103.41797800000001`, 97.916154000000013`, 
            66.5277909999999916`, 93.5450409999999976`, 108.614301000000001`, 
            108.88659599999999`, 34.81881`, 65.9831130000000065`, 
            75.3569399999999944`, 111.383770999999986`, 23.1154870000000034`, 
            29.863135999999999`, 47.5751240000000041`, 52.3814270000000004`, 
            66.8382789999999982`, 77.9968389999999978`, 100.196914000000014`, 
            103.242608999999996`, 36.0684290000000018`, 79.4519580000000047`, 
            94.1134599999999998`, 105.000705999999999`, 69.206644999999991`, 
            93.2052549999999868`, 94.7706479999999906`, 88.1020189999999914`, 
            27.5330560000000001`, 51.7221129999999984`, 60.7166899999999998`, 
            77.8412639999999989`, 30.8745080000000005`, 57.697415000000003`, 
            59.3834250000000007`, 71.1267890000000058`}, {1, 32, 
            22.6748494500000008`, \(-1.24351090999999991`\), 
            9.66978533600000034`, 0.0324919696199999963`, 1, 
            0.731776675800000031`, \(-0.0332740646100000025`\), 
            \(-0.0880960124499999963`\), 220.866642899999998`, 
            0.166909766399999988`, 94.36589102000001`, 
            \(-0.968862613800000005`\), \(-0.873501691099999888`\), 2, 3, 4, 
            5, 6, 7, 8, 9, 0.210286000000000017`, \(-0.946480000000000032`\), 
            0.541819000000000094`, 0.114294000000000006`, 
            0.134299999999999997`, \(-0.0649239999999999994`\), 
            1.16998500000000005`, 0.803533000000000008`, 
            0.606564999999999976`, 0.626465999999999922`, 
            0.658897999999999939`, 0.70335099999999997`, 
            0.913978000000000001`, 0.88841000000000001`, 
            1.08919699999999997`, 0.840681000000000011`, 
            8.73845099999999952`, 8.77294200000000046`, 1.12215299999999995`, 
            22.2544189999999986`, 22.2768009999999971`, 
            0.728184999999999948`, 22.7178919999999973`, 
            22.7397999999999989`, 0.712769999999999992`, 
            28.7361690000000002`, 28.7523319999999991`, 
            0.525884000000000018`, 25.8978609999999997`, 
            25.9152570000000004`, 0.565990999999999999`, 
            48.5759580000000035`, 48.6113920000000021`, 1.15284800000000009`, 
            57.8136209999999994`, 57.8426759999999973`, 
            0.945279999999999986`, 64.0594669999999943`, 64.043215`, 
            \(-0.52875399999999999`\), 25.8978609999999997`, 
            25.9325649999999985`, 1.12908399999999997`, 33.9603820000000045`, 
            34.0037769999999994`, 1.41182199999999991`, 48.5759580000000035`, 
            48.5654240000000037`, \(-0.342729000000000016`\), 
            57.8136209999999994`, 57.8404900000000044`, 
            0.874160000000000003`, 30.0075320000000012`, 
            30.0321700000000024`, 0.80158100000000001`, 35.354072000000003`, 
            35.3405130000000022`, \(-0.441155000000000008`\), 
            54.8428849999999989`, 54.8604360000000035`, 
            0.571025999999999989`, 56.7818209999999989`, 
            56.8016390000000015`, 0.644772999999999996`, 
            8.73845099999999952`, 8.80745199999999961`, 1.12245599999999989`, 
            22.7178919999999973`, 22.761597`, 0.710963000000000011`, 
            28.7361690000000002`, 28.7337789999999984`, 
            \(-0.038879999999999999`\), 30.0075320000000012`, 
            29.9773250000000004`, \(-0.491394000000000019`\), 
            25.8978609999999997`, 25.9418470000000001`, 0.71554599999999997`, 
            48.5759580000000035`, 48.5981189999999951`, 
            0.360508000000000006`, 57.8136209999999994`, 
            57.8391120000000036`, 0.414658000000000015`, 
            65.3286250000000023`, 65.3625459999999947`, 
            0.551811000000000007`, 25.8978609999999997`, 25.958110999999997`, 
            0.98011499999999998`, 33.9603820000000045`, 34.047164000000003`, 
            1.41170200000000001`, 48.5759580000000035`, 48.6035910000000015`, 
            0.449519999999999964`, 57.8136209999999994`, 
            57.8988230000000037`, 1.38599399999999995`, 22.2544189999999986`, 
            22.2992519999999982`, 0.729316999999999993`, 
            28.7620690000000003`, 28.7838689999999974`, 
            0.354627999999999987`, 30.0075320000000012`, 
            29.9837739999999985`, \(-0.386473999999999975`\), 
            44.8327100000000022`, 44.9074479999999987`, 1.21577899999999994`, 
            8.73845099999999952`, 22.7178919999999973`, 28.7361690000000002`, 
            39.6146340000000041`, 75.0872899999999976`, 76.8535660000000042`, 
            99.3607189999999995`, 97.1434439999999987`, 63.9265910000000037`, 
            94.7530620000000034`, 96.5043790000000001`, 123.601097999999987`, 
            33.9603820000000045`, 63.2644599999999979`, 73.8888799999999967`, 
            109.675601`, 22.2544189999999986`, 28.7620690000000003`, 
            44.8327100000000022`, 49.7726190000000023`, 64.0594669999999943`, 
            74.420850000000005`, 95.9210900000000066`, 98.5512879999999924`, 
            35.354072000000003`, 79.8665000000000002`, 75.2295610000000003`, 
            116.751418999999989`, 65.3286250000000023`, 77.417972000000006`, 
            104.827143999999994`, 90.3397490000000047`, 25.8978609999999997`, 
            48.5759580000000035`, 57.8136209999999994`, 77.2225119999999964`, 
            30.0075320000000012`, 54.8428849999999989`, 56.7818209999999989`, 
            69.4925319999999935`}, {3, 31, 27.057134920000001`, 
            \(-1.13743370399999998`\), 8.56539793900000034`, 
            0.0517766953000000018`, 1, 0.804788429499999935`, 
            \(-0.0810667240799999966`\), \(-0.0723188350399999979`\), 
            6.83154487300000035`, 0.164666067400000004`, 
            1.48149205499999991`, \(-0.948730016500000061`\), 
            \(-0.865007506499999934`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.246487999999999995`, \(-0.870401999999999986`\), 
            0.265776999999999974`, 0.12987099999999998`, 
            0.117572999999999994`, \(-0.0556050000000000022`\), 
            1.57678199999999986`, 1.13472700000000004`, 
            0.642576000000000036`, 0.656773999999999968`, 
            0.708061000000000007`, 0.746945000000000014`, 
            0.983366999999999968`, 0.961551000000000044`, 
            1.13932600000000006`, 0.889364999999999916`, 
            8.58226799999999911`, 8.61567999999999933`, 1.12866299999999997`, 
            23.5949750000000024`, 23.6232489999999994`, 
            0.955097999999999913`, 23.7909689999999995`, 23.799920000000001`, 
            0.302356999999999986`, 27.1692360000000032`, 
            27.1523180000000019`, \(-0.571480999999999994`\), 
            25.2930680000000007`, 25.3059730000000016`, 
            0.435916000000000014`, 46.8300759999999982`, 
            46.8582379999999965`, 0.951346000000000024`, 
            55.9737999999999935`, 55.9969260000000002`, 
            0.781200000000000027`, 60.9375450000000018`, 
            60.9226389999999984`, \(-0.503556999999999987`\), 
            25.2930680000000007`, 25.3245250000000021`, 1.062616`, 
            34.4741730000000012`, 34.5117339999999961`, 1.26879900000000001`, 
            46.8300759999999982`, 46.816355000000005`, 
            \(-0.463492999999999977`\), 55.9737999999999935`, 
            55.994041000000001`, 0.683749000000000073`, 29.3185669999999998`, 
            29.3371229999999982`, 0.626841999999999988`, 
            33.8894850000000014`, 33.878256999999996`, 
            \(-0.379276999999999997`\), 51.8499089999999984`, 
            51.863241999999996`, 0.450412999999999996`, 54.2421379999999953`, 
            54.2557370000000016`, 0.459379999999999988`, 
            8.58226799999999911`, 8.64911299999999982`, 1.12901899999999999`, 
            23.7909689999999995`, 23.8088189999999988`, 
            0.301495000000000024`, 27.1698560000000011`, 
            27.1649570000000029`, \(-0.0827380000000000137`\), 
            29.3185669999999998`, 29.3833020000000022`, 1.09339300000000005`, 
            25.2930680000000007`, 25.3289959999999991`, 
            0.606822000000000016`, 46.8300759999999982`, 
            46.8453639999999982`, 0.258224000000000009`, 
            55.9737999999999935`, 55.9870609999999935`, 
            0.223974000000000028`, 61.9437270000000061`, 
            61.9843329999999959`, 0.685841999999999973`, 
            25.2930680000000007`, 25.3458700000000014`, 
            0.891821999999999981`, 34.4741730000000012`, 
            34.5492949999999998`, 1.26881599999999994`, 46.8300759999999982`, 
            46.8437429999999999`, 0.230849999999999999`, 
            55.9737999999999935`, 56.0464900000000021`, 1.22774399999999994`, 
            23.5949750000000024`, 23.650544`, 0.938569000000000031`, 
            27.1692360000000032`, 27.1653259999999985`, 
            \(-0.0660349999999999948`\), 28.6537169999999985`, 
            28.8332979999999992`, 3.03314899999999987`, 29.3185669999999998`, 
            29.327974000000001`, 0.158900000000000023`, 8.58226799999999911`, 
            23.7909689999999995`, 27.1698560000000011`, 33.4874880000000008`, 
            71.6021929999999962`, 72.5696750000000001`, 93.5241689999999969`, 
            91.9629899999999977`, 59.6813169999999981`, 93.1563320000000061`, 
            91.7530770000000117`, 109.373434000000013`, 34.4741730000000012`, 
            59.945725000000003`, 73.646047999999995`, 99.7537070000000092`, 
            23.5949750000000024`, 28.6537169999999985`, 27.1692360000000032`, 
            48.2192940000000014`, 60.9375450000000018`, 70.860902999999995`, 
            90.1022430000000085`, 92.7367779999999974`, 33.8894850000000014`, 
            78.3475880000000035`, 72.0659049999999989`, 107.086579999999997`, 
            61.9437270000000061`, 73.5558570000000067`, 87.0966860000000053`, 
            101.697470999999994`, 25.2930680000000007`, 46.8300759999999982`, 
            55.9737999999999935`, 71.9280499999999989`, 29.3185669999999998`, 
            51.8499089999999984`, 54.2421379999999953`, 
            66.6114340000000026`}, {2, 57, 37.0017636499999991`, 
            \(-0.997548784900000029`\), 7.71770726499999959`, 
            0.0764288174200000014`, 1, 0.9565412993999999`, 
            \(-0.0497583666899999954`\), \(-0.127186915899999997`\), 
            34.5272719299999986`, 0.188817288699999998`, 
            10.3443841299999994`, \(-0.946543730500000002`\), 
            \(-0.870192088900000015`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.247901000000000015`, \(-0.902072000000000073`\), 
            0.0812069999999999936`, 0.144466000000000001`, 
            0.0887909999999999932`, \(-0.0275519999999999987`\), 
            1.3920079999999999`, 1.09128399999999992`, 0.659924999999999961`, 
            0.636749000000000009`, 0.732972999999999963`, 
            0.745056000000000029`, 1.02359500000000003`, 
            0.995426999999999928`, 1.14691600000000004`, 
            0.868791000000000046`, 7.28998699999999999`, 7.330241`, 
            1.2322280000000001`, 22.4373179999999994`, 22.4513460000000009`, 
            0.429429000000000016`, 23.4086820000000006`, 
            23.4158929999999987`, 0.220718000000000014`, 
            28.5740779999999983`, 28.5782670000000003`, 
            0.128214999999999989`, 23.0447179999999995`, 
            23.0588609999999993`, 0.432943000000000033`, 
            42.7445759999999985`, 42.7692470000000035`, 
            0.755214000000000051`, 51.9264849999999977`, 
            51.9479440000000014`, 0.656919000000000075`, 
            56.9980300000000017`, 56.9953100000000034`, 
            \(-0.0832620000000000004`\), 23.0447179999999995`, 
            23.0757879999999993`, 0.951104999999999911`, 
            32.4835450000000003`, 32.5248390000000009`, 1.26408399999999998`, 
            42.7445759999999985`, 42.7396259999999994`, 
            \(-0.151545999999999985`\), 51.9264849999999977`, 
            51.9371099999999952`, 0.325258000000000002`, 29.130098000000002`, 
            29.1538530000000015`, 0.727177000000000006`, 
            34.1316219999999992`, 34.1187740000000028`, 
            \(-0.393283000000000004`\), 48.4070610000000023`, 
            48.4267469999999988`, 0.602604000000000006`, 
            51.8780860000000032`, 51.8854810000000021`, 
            0.226360999999999989`, 7.28998699999999999`, 
            7.37049700000000029`, 1.23226600000000008`, 23.4086820000000006`, 
            23.4229860000000034`, 0.218927000000000004`, 
            28.5740779999999983`, 28.5353069999999995`, 
            \(-0.593428999999999984`\), 29.130098000000002`, 
            29.1349150000000012`, 0.0737290000000000045`, 
            23.0447179999999995`, 23.0822600000000033`, 
            0.574613999999999958`, 42.7445759999999985`, 
            42.7643579999999978`, 0.302777999999999991`, 
            51.9264849999999977`, 51.9373410000000035`, 
            0.166164000000000005`, 57.4967580000000033`, 
            57.5471270000000068`, 0.770943000000000022`, 
            23.0447179999999995`, 23.097612999999999`, 0.809595999999999982`, 
            32.4835450000000003`, 32.5661320000000031`, 1.26406799999999996`, 
            42.7445759999999985`, 42.7643280000000025`, 
            0.302306000000000008`, 51.9264849999999977`, 
            51.9796160000000018`, 0.813222000000000022`, 
            22.4373179999999994`, 22.465976000000003`, 0.438630999999999993`, 
            29.130098000000002`, 29.159956000000001`, 0.456994999999999951`, 
            32.5824909999999956`, 32.447089`, \(-2.07243200000000005`\), 
            32.6764050000000016`, 32.8521539999999978`, 2.68998900000000018`, 
            7.28998699999999999`, 23.4086820000000006`, 28.5740779999999983`, 
            34.3730029999999953`, 67.1820169999999983`, 67.6673420000000014`, 
            87.1777990000000002`, 84.4508919999999996`, 57.7604149999999982`, 
            91.9369109999999878`, 93.2433259999999997`, 91.4291509999999973`, 
            32.4835450000000003`, 56.9289749999999994`, 72.2576590000000074`, 
            75.4276820000000025`, 22.4373179999999994`, 32.6764050000000016`, 
            32.5824909999999956`, 44.772829999999999`, 56.9980300000000017`, 
            66.3612939999999973`, 83.2152669999999972`, 85.7948670000000035`, 
            34.1316219999999992`, 72.7969640000000062`, 69.0815939999999972`, 
            102.870930000000004`, 57.4967580000000033`, 71.9821450000000062`, 
            72.1430729999999975`, 105.907218000000002`, 23.0447179999999995`, 
            42.7445759999999985`, 51.9264849999999977`, 65.9785209999999988`, 
            29.130098000000002`, 48.4070610000000023`, 51.8780860000000032`, 
            63.0093499999999995`}, {2, 11, 36.8072737299999985`, 
            \(-1.11795189399999994`\), 6.65132200900000025`, 
            0.107240137899999998`, 1, 1.00999469099999994`, 
            \(-0.00729168205999999941`\), \(-0.143581886700000005`\), 
            60.6832776500000026`, 0.162551990700000015`, 
            9.60935070999999929`, \(-0.78831969079999995`\), 
            \(-0.734265937400000012`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.30268299999999999`, \(-0.738755000000000094`\), 
            \(-0.335523000000000015`\), 0.170077000000000015`, 
            0.0812090000000000067`, \(-0.0459019999999999939`\), 
            2.14928100000000021`, 1.64077099999999997`, 
            0.714620999999999995`, 0.691034999999999932`, 
            0.824024999999999963`, 0.824598000000000119`, 
            1.15463899999999997`, 1.12760400000000005`, 1.23988300000000006`, 
            0.952502999999999921`, 11.6980360000000005`, 
            11.7379370000000005`, 1.28528400000000008`, 28.7270299999999991`, 
            28.7502010000000005`, 0.746392000000000077`, 
            29.8517450000000028`, 29.847159999999997`, 
            \(-0.147696000000000005`\), 31.8557929999999966`, 
            31.8879550000000033`, 1.03600099999999994`, 22.5858479999999994`, 
            22.5965449999999989`, 0.344575999999999993`, 
            43.0846589999999984`, 43.1041549999999951`, 
            0.627990999999999921`, 54.0007409999999943`, 
            54.0235299999999973`, 0.734091000000000093`, 
            56.4142309999999991`, 56.412962000000002`, 
            \(-0.0408639999999999936`\), 22.5858479999999994`, 
            22.6121499999999997`, 0.847260999999999953`, 
            33.6290290000000036`, 33.6616310000000007`, 1.05017599999999999`, 
            43.0846589999999984`, 43.0847610000000003`, 
            0.0032709999999999999`, 54.0007409999999943`, 
            54.0225050000000006`, 0.701076999999999905`, 
            32.4532529999999974`, 32.4731080000000016`, 
            0.639571000000000022`, 36.5922460000000038`, 
            36.5809199999999989`, \(-0.36483500000000002`\), 
            48.6067319999999991`, 48.626781999999995`, 0.64582499999999996`, 
            53.5541469999999986`, 53.5490789999999972`, 
            \(-0.163251000000000008`\), 11.6980360000000005`, 11.777822`, 
            1.28502000000000005`, 29.8517450000000028`, 29.8428070000000023`, 
            \(-0.143958000000000012`\), 31.8557929999999966`, 
            31.8737180000000019`, 0.288704999999999998`, 
            32.4532529999999974`, 32.4868319999999988`, 
            0.540817000000000014`, 22.5858479999999994`, 
            22.6148140000000008`, 0.466532999999999997`, 
            43.0846589999999984`, 43.105089999999997`, 0.32905000000000002`, 
            54.0007409999999943`, 54.0165330000000043`, 
            0.254342999999999985`, 56.8035319999999988`, 
            56.8463180000000001`, 0.689111000000000029`, 
            22.5858479999999994`, 22.6308730000000002`, 
            0.725184999999999924`, 33.6290290000000036`, 
            33.6942409999999981`, 1.05028800000000011`, 43.0846589999999984`, 
            43.1034999999999968`, 0.303445000000000009`, 
            54.0007409999999943`, 54.0750550000000007`, 1.19690099999999999`, 
            28.7270299999999991`, 28.7738860000000009`, 0.75465800000000005`, 
            32.4532529999999974`, 32.3894280000000023`, 
            \(-1.02795900000000006`\), 33.0371689999999995`, 
            33.1005890000000002`, 1.02144799999999991`, 34.3269579999999985`, 
            34.3153569999999996`, \(-0.186857999999999986`\), 
            11.6980360000000005`, 29.8517450000000028`, 31.8557929999999966`, 
            33.1517160000000021`, 65.9815109999999993`, 66.8167310000000025`, 
            83.2968050000000026`, 80.6433320000000009`, 58.0221889999999973`, 
            78.4912089999999995`, 105.132161000000001`, 96.668447000000004`, 
            33.6290290000000036`, 56.586388000000003`, 72.1427759999999995`, 
            73.1345519999999993`, 28.7270299999999991`, 34.3269579999999985`, 
            33.0371689999999995`, 46.5674790000000005`, 56.4142309999999991`, 
            65.769125000000006`, 79.037999000000001`, 81.7809019999999975`, 
            36.5922460000000038`, 69.5817710000000033`, 73.0461329999999975`, 
            81.9528629999999935`, 56.8035319999999988`, 74.3875569999999974`, 
            73.3251730000000101`, 93.2628270000000014`, 22.5858479999999994`, 
            43.0846589999999984`, 54.0007409999999943`, 59.0113389999999959`, 
            32.4532529999999974`, 48.6067319999999991`, 53.5541469999999986`, 
            61.9715720000000036`}, {2, 11, 53.4946027300000004`, 
            \(-1.23475593700000008`\), 6.10461809899999963`, 
            0.145308505599999993`, 1, 1.24391000000000007`, 
            0.130230000000000023`, \(-0.169090999999999986`\), 
            43.0093000000000014`, 0.231558000000000019`, 
            6.79891999999999985`, \(-0.526116000000000028`\), 
            \(-0.515095999999999953`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.306864999999999987`, \(-0.69060699999999997`\), 
            \(-0.70986400000000005`\), 0.198200999999999982`, 
            0.0524220000000000041`, \(-0.0344380000000000041`\), 
            1.97958799999999985`, 1.67557700000000009`, 
            0.724446999999999974`, 0.712489000000000061`, 
            0.874993000000000087`, 0.877754999999999974`, 
            1.23963099999999992`, 1.24309699999999989`, 1.25694700000000003`, 
            0.993098999999999954`, 12.1415669999999997`, 
            12.1809060000000002`, 1.17911300000000007`, 29.2593199999999988`, 
            29.2756730000000011`, 0.49016099999999998`, 29.9499709999999996`, 
            29.9259899999999987`, \(-0.718794999999999983`\), 
            31.2769289999999999`, 31.291701999999999`, 0.442797000000000018`, 
            20.5692530000000006`, 20.5778380000000016`, 
            0.257290000000000018`, 39.8616140000000029`, 
            39.8787409999999997`, 0.513337999999999983`, 
            51.2512210000000045`, 51.2476229999999954`, 
            \(-0.107855999999999996`\), 54.1266689999999961`, 
            54.1271769999999996`, 0.0152200000000000006`, 
            20.5692530000000006`, 20.5943840000000033`, 
            0.753218999999999994`, 32.1856209999999975`, 
            32.2219089999999974`, 1.08762599999999999`, 39.8616140000000029`, 
            39.8615980000000025`, \(-0.000458000000000000007`\), 
            51.2512210000000045`, 51.251660999999995`, 
            0.0131830000000000002`, 33.5508650000000008`, 
            33.5695999999999994`, 0.561525999999999925`, 
            37.3728860000000029`, 37.362592999999995`, 
            \(-0.308514999999999961`\), 46.5444450000000031`, 
            46.5614210000000028`, 0.508800999999999969`, 
            52.0815679999999936`, 52.0782919999999993`, 
            \(-0.0982000000000000028`\), 12.1415669999999997`, 
            12.2202429999999995`, 1.17907600000000001`, 29.2593199999999988`, 
            29.233314`, \(-0.389731000000000005`\), 31.2769289999999999`, 
            31.3062299999999993`, 0.439107999999999965`, 
            33.5508650000000008`, 33.5807650000000013`, 
            0.448097000000000011`, 20.5692530000000006`, 
            20.5937090000000022`, 0.366503000000000023`, 
            39.8616140000000029`, 39.8786640000000005`, 
            0.255514999999999981`, 51.2512210000000045`, 
            51.2420499999999989`, \(-0.137448999999999976`\), 
            52.9637850000000032`, 52.992745999999995`, 0.434020000000000027`, 
            20.5692530000000006`, 20.6122240000000012`, 
            0.643966999999999956`, 32.1856209999999975`, 
            32.2581970000000017`, 1.08764400000000005`, 39.8616140000000029`, 
            39.8788499999999999`, 0.258299999999999974`, 
            51.2512210000000045`, 51.2542619999999971`, 
            0.0455730000000000057`, 29.9499709999999996`, 
            29.9612900000000017`, 0.169625000000000003`, 
            32.0023979999999985`, 32.0278989999999996`, 
            0.382168999999999989`, 33.5508650000000008`, 
            33.5265389999999996`, \(-0.364559000000000033`\), 
            35.5243239999999982`, 35.5480919999999978`, 
            0.356192000000000019`, 12.1415669999999997`, 
            31.2769289999999999`, 29.2593199999999988`, 35.5774619999999952`, 
            62.6904869999999991`, 64.031576999999995`, 77.7199109999999926`, 
            75.184179999999996`, 56.7508560000000006`, 73.9992040000000095`, 
            94.9125339999999972`, 102.849592000000011`, 32.1856209999999975`, 
            54.3043999999999993`, 67.4039549999999998`, 74.2412709999999975`, 
            32.0023979999999985`, 29.9499709999999996`, 35.5243239999999982`, 
            44.8702899999999971`, 54.1266689999999961`, 62.5250860000000052`, 
            73.7267480000000041`, 75.9200610000000075`, 37.3728860000000029`, 
            64.1997470000000003`, 73.8561349999999983`, 67.6663649999999972`, 
            52.9637850000000032`, 68.6805399999999899`, 73.7307650000000069`, 
            68.0009849999999982`, 20.5692530000000006`, 39.8616140000000029`, 
            54.4863810000000015`, 51.2512210000000045`, 33.5508650000000008`, 
            46.5444450000000031`, 52.0815679999999936`, 
            59.7617649999999933`}, {2, 21, 46.607583469999998`, 
            \(-0.922120534899999988`\), 6.06522791600000044`, 
            0.192168154199999996`, 1, 1.53001593399999986`, 
            \(-0.0473714894999999991`\), \(-0.174893743500000002`\), 
            62.9909622400000035`, 0.331763698600000012`, 
            21.8057091000000013`, 0.587711152400000003`, 
            \(-0.634575239100000043`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.298629999999999995`, \(-0.621388999999999924`\), 
            \(-1.29031000000000005`\), 0.208167999999999997`, 
            0.0503479999999999972`, \(-0.0537309999999999998`\), 
            1.67496599999999995`, 1.60636599999999996`, 
            0.734970000000000034`, 0.724103999999999992`, 
            0.871096000000000003`, 0.901634999999999919`, 
            1.22943899999999994`, 1.29015199999999996`, 1.23133099999999995`, 
            1.01464599999999993`, 7.59524000000000043`, 7.63361100000000014`, 
            1.11199399999999992`, 27.4910340000000008`, 27.5159519999999968`, 
            0.722134999999999926`, 27.6457529999999973`, 
            27.6405430000000018`, \(-0.150968999999999997`\), 
            27.9211769999999992`, 27.9365079999999998`, 
            0.444287000000000009`, 20.6479830000000008`, 
            20.6569219999999997`, 0.25906699999999998`, 37.1763069999999995`, 
            37.1929540000000002`, 0.482439999999999979`, 
            48.2303049999999977`, 48.2273339999999972`, 
            \(-0.0860849999999999937`\), 52.0556909999999994`, 
            52.0551320000000039`, \(-0.0162029999999999985`\), 
            20.6479830000000008`, 20.6747600000000009`, 
            0.776001000000000029`, 33.3485209999999998`, 
            33.3921810000000007`, 1.26527600000000006`, 37.1763069999999995`, 
            37.1755489999999966`, \(-0.0219759999999999999`\), 
            48.2303049999999977`, 48.2285479999999999`, 
            \(-0.0508990000000000009`\), 30.2585209999999982`, 
            30.2799909999999972`, 0.622202999999999928`, 
            34.9272869999999979`, 34.9146519999999949`, 
            \(-0.366176000000000012`\), 43.7427929999999953`, 
            43.7607950000000034`, 0.521703000000000027`, 
            47.4737689999999989`, 47.4764639999999982`, 
            0.0781030000000000068`, 7.59524000000000043`, 
            7.67197300000000037`, 1.11186800000000007`, 27.4910340000000008`, 
            27.5406879999999976`, 0.71949500000000004`, 27.6457529999999973`, 
            27.6353490000000023`, \(-0.15075400000000001`\), 
            29.1935769999999994`, 29.1782250000000011`, 
            \(-0.222459999999999968`\), 20.6479830000000008`, 
            20.6735999999999986`, 0.371199999999999974`, 
            37.1763069999999995`, 37.1911100000000027`, 0.214493`, 
            48.2303049999999977`, 48.2193969999999971`, 
            \(-0.158050999999999985`\), 50.367790999999995`, 
            50.3928909999999952`, 0.363704999999999989`, 
            20.6479830000000008`, 20.6938059999999968`, 
            0.663975999999999988`, 33.3485209999999998`, 
            33.4358220000000017`, 1.26500100000000004`, 37.1763069999999995`, 
            37.1933709999999972`, 0.24726300000000001`, 48.2303049999999977`, 
            48.231906999999996`, 0.0232249999999999978`, 
            27.9211769999999992`, 27.9527049999999999`, 
            0.456843999999999983`, 28.2019349999999988`, 
            28.2530780000000003`, 0.741061000000000014`, 
            29.1768019999999985`, 29.1232000000000024`, 
            \(-0.776695000000000046`\), 30.2585209999999982`, 
            30.3076930000000022`, 0.712508000000000052`, 
            7.59524000000000043`, 27.4910340000000008`, 27.6457529999999973`, 
            29.1935769999999994`, 59.8514419999999969`, 61.4430449999999961`, 
            74.5914010000000082`, 71.7087919999999989`, 53.0211040000000011`, 
            72.4286350000000034`, 76.4239300000000021`, 95.394331000000001`, 
            33.3485209999999998`, 52.4040329999999965`, 66.5367849999999982`, 
            75.9030640000000023`, 27.9211769999999992`, 28.2019349999999988`, 
            29.1768019999999985`, 40.3305379999999935`, 52.0556909999999994`, 
            59.3801350000000027`, 71.8760140000000014`, 72.9994940000000003`, 
            34.9272869999999979`, 62.1842370000000066`, 70.0408649999999965`, 
            66.6193209999999957`, 50.367790999999995`, 66.0680040000000001`, 
            74.2445840000000067`, 69.881259`, 20.6479830000000008`, 
            37.1763069999999995`, 54.0336779999999983`, 48.2303049999999977`, 
            30.2585209999999982`, 43.7427929999999953`, 47.4737689999999989`, 
            58.8696449999999948`}, {2, 48, 39.9010224299999993`, 
            \(-0.792860947099999968`\), 6.19297076400000001`, 0.25`, 1, 
            1.84119371400000009`, \(-0.0980506783400000081`\), 
            \(-0.172015285299999991`\), 57.7883757499999983`, 
            0.41827732950000005`, 20.0376207700000019`, 1.11279333099999999`, 
            \(-0.926860005200000003`\), 2, 3, 4, 5, 6, 7, 8, 9, 
            0.298032000000000039`, \(-0.512812000000000089`\), 
            \(-2.03032300000000009`\), 0.189480000000000003`, 
            0.0344529999999999958`, \(-0.0134499999999999997`\), 
            1.33784199999999997`, 1.6176569999999999`, 0.748561999999999905`, 
            0.671084000000000013`, 0.844195000000000028`, 
            0.827979999999999982`, 1.17926799999999998`, 
            1.17587799999999997`, 1.201187`, 0.937598999999999982`, 
            4.73534100000000002`, 4.77531000000000016`, 1.180342`, 
            27.1164340000000025`, 27.1041449999999972`, 
            \(-0.362897999999999987`\), 27.1720809999999968`, 
            27.2038139999999994`, 0.937115000000000009`, 27.986578999999998`, 
            28.0151810000000001`, 0.844677000000000077`, 
            21.1608010000000001`, 21.1690909999999998`, 
            0.244813999999999998`, 35.8442769999999999`, 
            35.8606699999999989`, 0.484103999999999956`, 47.546778999999999`, 
            47.5523059999999997`, 0.163229999999999986`, 52.683756000000006`, 
            52.6846710000000051`, 0.0270260000000000033`, 
            21.1608010000000001`, 21.1892849999999999`, 0.84119299999999999`, 
            35.111876999999998`, 35.1632650000000035`, 1.51757699999999999`, 
            35.8442769999999999`, 35.8428120000000038`, 
            \(-0.0432760000000000033`\), 47.546778999999999`, 
            47.5505050000000029`, 0.110030000000000005`, 
            30.4692499999999988`, 30.4912740000000015`, 
            0.650373000000000001`, 35.6344390000000021`, 
            35.6209119999999979`, \(-0.399453000000000013`\), 
            43.0938040000000022`, 43.1124629999999964`, 
            0.551020999999999983`, 47.0526659999999985`, 
            47.0543230000000001`, 0.048926999999999996`, 
            4.73534100000000002`, 4.81525499999999961`, 1.17998099999999994`, 
            27.1164340000000025`, 27.0919409999999993`, 
            \(-0.361650999999999989`\), 27.986578999999998`, 
            28.0161209999999982`, 0.43621300000000005`, 28.0278379999999991`, 
            28.0436620000000011`, 0.233648999999999995`, 
            21.1608010000000001`, 21.1872829999999989`, 
            0.391029999999999979`, 35.8442769999999999`, 
            35.8556609999999986`, 0.168083000000000009`, 47.546778999999999`, 
            47.5391890000000039`, \(-0.112064999999999992`\), 
            49.5931709999999981`, 49.624845999999998`, 0.467696000000000022`, 
            21.1608010000000001`, 21.2078830000000007`, 
            0.695202000000000008`, 35.111876999999998`, 35.2145700000000028`, 
            1.51633700000000004`, 35.8442769999999999`, 35.8629000000000042`, 
            0.274971999999999994`, 47.546778999999999`, 47.572877`, 
            0.385348000000000023`, 27.1720809999999968`, 
            27.2336970000000011`, 0.909811000000000014`, 
            28.0226810000000003`, 27.9979660000000007`, 
            \(-0.364925999999999994`\), 28.7603339999999985`, 
            28.7889620000000014`, 0.422707999999999994`, 
            30.4692499999999988`, 30.4926340000000006`, 0.34527000000000001`, 
            4.73534100000000002`, 27.986578999999998`, 27.1164340000000025`, 
            28.0278379999999991`, 60.1934259999999987`, 62.6539540000000005`, 
            74.3331029999999959`, 71.4463690000000006`, 53.1084390000000006`, 
            78.1381489999999967`, 71.4898789999999983`, 92.2746669999999902`, 
            35.111876999999998`, 53.1406650000000002`, 67.1914600000000028`, 
            81.9504189999999965`, 28.7603339999999985`, 27.1720809999999968`, 
            28.0226810000000003`, 39.1939840000000003`, 52.683756000000006`, 
            59.8735909999999993`, 71.7241060000000096`, 72.8841100000000086`, 
            35.6344390000000021`, 61.3669969999999942`, 70.0159419999999954`, 
            72.0687779999999911`, 49.5931709999999981`, 65.1537830000000006`, 
            77.5631409999999998`, 76.2435750000000034`, 21.1608010000000001`, 
            35.8442769999999999`, 55.7980560000000025`, 47.546778999999999`, 
            30.4692499999999988`, 43.0938040000000022`, 47.0526659999999985`, 
            61.0134380000000042`}}}; \)\)], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ttraj6*.out, large basis, n=(2,0) can be tachyonic, no \
constraint on lattice spacing, new k_max cutoffs.\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 40 criteria and tolerance 0.01.\\nOverall scale from \
minimizing chi^2.\\nParity doublets (o,multi,state) with error for difference\
\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error 0.25\\n  (-1, 5,0) and \
(-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, 4,0), error 0.25\\nSpectrum for \
P_perp a = (0,0), ( 0.25 0)\\n  using (# states, multiplet, o, c^2 error for \
each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 \
2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 \
2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 0.25)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4, 11 & 12,  1 & -1, 0.25 2 2 2)\\n  \
(4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & 13,  1 & -1, 0.25 2 2 2)\\n  \
(4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary spectra multiplets, 4 states, \
(o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  \
5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) .\\nAll spectra extrapolated \
using (K,p) = (16/2,8)  (16/2,6) \\n  (20/2,6)  (26/2,6) .\\nWinding \
potential using (n,K,p) = ( 2 0,20/2,4)  ( 2 0,20/2,6) \\n  ( 2 0,24/2,4)  ( \
2 0,32/2,4)  ( 3 0,19/2,5)  ( 3 0,19/2,7) \\n  ( 3 0,25/2,5)  ( 3 0,33/2,5)  \
( 4 0,18/2,6)  ( 4 0,18/2,8) \\n  ( 4 0,24/2,6)  ( 4 0,32/2,6) .\\nRoundness \
of winding using (n,K,p) = ( 2 2,16/2,6) \\n  ( 2 2,16/2,8)  ( 2 2,24/2,6)  ( \
2 2,28/2,6) \\n  with error 1; in G^2 N units.\\nHeavy potential determined \
using (n,K,p,K_max) =\\n  ( 0 0,-40/2,2,4)  ( 0 0,-40/2,4,4)  ( 0 \
0,-40/2,2,3.5) \\n  ( 0 0,-50/2,2,3.75)  ( 0 0,-50/2,2,4.25)  ( 0 \
0,-70/2,2,4) \\n  ( 0 0,-70/2,2,4.5) ,\\n L = 3.577-2.726*m 5.058-3.856*m \
7.154-5.452*m\\n (all in G^2 N units); relative scale error=0.1.\\nRoundness \
determined using (n,K,p,K_max) = ( 1 0,-19/2,3,4) \\n  ( 1 0,-19/2,5,4)  ( 1 \
0,-19/2,3,3.5)  ( 1 0,-33/2,3,4) \\n  ( 1 0,-33/2,3,5)  ( 1 0,-69/2,3,5)  ( 1 \
0,-69/2,3,6) \\n L=1.265-0.964*m and error 0.1;\\n  ( 1 0,-19/2,3,4)  ( 1 \
0,-19/2,5,4)  ( 1 0,-19/2,3,3.5) \\n  ( 1 0,-33/2,3,4)  ( 1 0,-33/2,3,5)  ( 1 \
0,-69/2,3,5) \\n  ( 1 0,-69/2,3,6) \\n L=5.058-3.856*m and error 0.1;\\n  ( 1 \
1,-34/2,2,5.5)  ( 1 1,-34/2,4,5.5)  ( 1 1,-34/2,2,5) \\n  ( 1 1,-48/2,2,5.5)  \
( 1 1,-48/2,2,6.5)  ( 1 1,-70/2,2,6) \\n  ( 1 1,-70/2,2,7) \\n L=0+0*m and \
error 0.2; all in G^2 N units.\\np-extrapolation using n=( 1 0) and (K,p) = \
(13/2,3) \\n  (35/2,3)  (45/2,3)  (13/2,5)  (29/2,5)  (13/2,7) \\n  (17/2,7) \
.\\nResult format:\\n Fit info, # steps, chi^2, and p damping, scale G^2 \
N/sigma.\\n The 10 couplings  (G^2 N units);\\n   which couplings -- if any \
-- were fit.\\n Winding potential and heavy souce potential fits.\\n \
Roundness of winding potential, 1 values, and roundness of\\n   heavy source \
potential, 3 values, (G^2 N units)\\n   showing measured value and derived \
value for each.\\n The rescaled spectrum for each P_perp*a and c^2 values.\\n \
Finally come the states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["32.8575454500000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["7.47613349299999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.7440918199999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.179818001100000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0659772840299999963`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0528543260300000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.13167108399999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0159458962299999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.961262676900000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.459300856700000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.396951357000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.179682000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.37907099999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.397280999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0896189999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.339656000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.413802999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.84360499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.00872800000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.592802000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.719411000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.959964000000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.917361999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.20766700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.911814999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.2258889999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.2597679999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14388`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.0743690000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.1011300000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.903542999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.3210469999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3147599999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.212286999999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.7846079999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7389960000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.5400100000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.597432000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6268919999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.994675999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6748290000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7013960000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.897011999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.1458180000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1633359999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.591479999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["67.0780120000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.0740299999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.134461999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.597432000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6141989999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.566117999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1371800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1425430000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.181074000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6748290000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6751270000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0100609999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["64.1458180000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1461529999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0113270000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["27.7846079999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7953880000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.363958000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.9376359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9278319999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.331015000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["57.4934799999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5138510000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.687791999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.1741909999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1693980000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.161855999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["13.2258889999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.2936330000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14362699999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3210469999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3083170000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.214901000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.7846079999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7280039999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.955577000000000076`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.7013270000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7224760000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.35702499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.597432000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.661258000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.07749099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.6748290000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7001739999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.427876000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.1458180000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1627849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.286438000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["80.333906000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.4471260000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.9113430000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.597432000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6260329999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.482837000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1371800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1479380000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.181613999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6748290000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7031599999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.478285999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.1458180000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1647619999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.319806999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.0743690000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.1277089999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.900468000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.7846079999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.771315999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.22439899999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.6942090000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6968800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0450870000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["33.5610769999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7628860000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.40686299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.2258889999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3210469999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7013270000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.0075810000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.1192879999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.8571430000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.349798000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["115.711122999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["65.367835000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.6301969999999883`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.421504999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.668826000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.1371800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.3271180000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.1364140000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.186435999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["18.0743690000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6942090000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5610769999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7049560000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.0780120000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.6586560000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.863549000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.290401999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.9376359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.8954219999999892`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.223288999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.772358999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["83.3819049999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.839115999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.826774`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.746924000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.597432000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6748290000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1458180000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.333906000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7846079999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4934799999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1741909999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0031130000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "39", ",", 
                    StyleBox["13.3577166599999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["2.21241866800000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["12.0223813499999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.428623598899999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0116181788900000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0675857449099999918`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["436.679535400000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0971179942300000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["181.795675600000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.79515137849999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.70151919230000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.171297999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.850411000000000072`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.758889999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0840739999999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.258734000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.265163999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.07298500000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.614835000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.540436999999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.637754000000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.838107000000000113`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.807071000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.0515239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.812668999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.224374`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.2592119999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14792000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.6872219999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.709778`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.743215999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.7009709999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7304330000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.970794000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5928660000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5638139999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.957292999999999949`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.8092199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8326279999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.771326`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.4128129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4618779999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.61670300000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.1048859999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.134063999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.96142000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["70.4156270000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4003830000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.502301000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.8092199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.843147`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11790900000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.0167519999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0516409999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14963799999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.4128129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4066660000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.202554999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["64.1048859999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1291059999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.798073000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5928660000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6180410000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.829513000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8106670000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7965110000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.46646099999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["60.6637950000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6866600000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.753407000000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.7700319999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7879340000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.589891999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.224374`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.2940729999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14831599999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.7009709999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7586819999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.950799999999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5928660000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.553852`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.642773000000000038`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.4679300000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4584199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.156676000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.8092199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8629230000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.884783000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.4128129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4457389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542459000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.1048859999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1398700000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.576375999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["70.0251910000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.1034339999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28908000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.8092199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8702509999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00550399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.0167519999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.086511999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14932499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.4128129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4655209999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.868379999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.1048859999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1749449999999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15424799999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.6872219999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7334319999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.761317000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5928660000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6247170000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.524745000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5632370000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.524185000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.64339100000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.4780689999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5161280000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.627037999999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.224374`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7009709999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4679300000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6157610000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.2470610000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.1911889999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.520560000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["121.861191000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["67.8437330000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.149721999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["117.592387000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["115.705966000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.0167519999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.1938520000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.0395610000000132`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.4212610000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6872219999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5632370000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.4780689999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0631340000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4156270000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1104880000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.948950999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["107.493098999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["36.8106670000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.9992880000000141`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.712800999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["93.5092009999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0251910000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.1145900000000139`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.413843000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.1301349999999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8092199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4128129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1048859999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6849440000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5928660000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6637950000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7700319999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.8151299999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "29", ",", 
                    StyleBox["14.2810904699999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.79227342799999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.1778378200000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.504034936000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00495857724099999952`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0746509748100000081`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["425.706951300000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.117559800599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["195.673975700000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.90834316269999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.864243938399999933`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.18782399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.862326000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.690837000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0910480000000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.199165999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.154300999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.25062300000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.72661800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.551096000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.62216199999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.816604000000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.791821000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.10108699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.80040300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.573649`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6075169999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13768699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.2931089999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.322313000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.981020999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.3027240000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.3278369999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.843603000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.856327000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8599239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.120846999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.4576220000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4789689999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.71704800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.8635399999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.908068999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.49578799999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["62.9808509999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0105170000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.99653899999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["69.3336970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.3179899999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.527634000000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.4576220000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.490482`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10379899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.6215090000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6567349999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18329700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.8635399999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8589949999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.152652000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["62.9808509999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.005873999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.840572000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8722899999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8972530000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.838530000000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.1028209999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.0885409999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.479687000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["60.136857999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1588040000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.737176999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.154575000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1725399999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.603473999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.573649`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6414139999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13816500000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.2931089999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.349873999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.953401999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.856327000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8367630000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.328586`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.8722899999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8432680000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.487443000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.4576220000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5050950000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.797339000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.8635399999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8946820000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.523048999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.9808509999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0150300000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.574073999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["71.97474699999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.0166600000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.703961999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.4576220000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5186129999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02437599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.6215090000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6919570000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18322700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.8635399999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9121939999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.817181000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.9808509999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0544569999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23627400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.3027240000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.3539299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.860044999999999859`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8722899999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8450279999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.457885000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.9114800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9295760000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.30393399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7405570000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8932969999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.56538600000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.573649`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2931089999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.856327000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3536599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6952610000000092`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7919920000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.698022999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.946419000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["69.2057599999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.1412590000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["119.095967000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["106.556773000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.6215090000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4344750000000079`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.4900759999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.509534999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.3027240000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9114800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7405570000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0612579999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.3336970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.1201699999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.656250000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.93122800000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.1028209999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.645431999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.889281999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["94.3552670000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.97474699999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.3063510000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.461871999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.9902090000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4576220000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8635399999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.9808509999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.2616589999999874`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8722899999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.136857999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.154575000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4919689999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "29", ",", 
                    StyleBox["15.9934481000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["1.577933099`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.5333872900000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.57534732850000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0352843427200000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0792923125599999956`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["463.008527900000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.131832078800000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["210.609294200000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.998579259599999957`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00815711299999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.210297`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.839869000000000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.559247000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0978299999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.156936999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0837950000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.54349299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.91241399999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.569856000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.625497000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.810657999999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.792861000000000082`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.15315900000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.812974999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.7243160000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.7567309999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14887099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.5960740000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6188140000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.805963000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.629086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.655323`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.92989499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.7908499999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8019129999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.39210600000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9532960000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9724979999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.680571000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.757005000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7966210000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40406800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["63.3741790000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.4030570000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02348499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["69.656760000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.641206999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.551223000000000062`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.9532960000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9845250000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10681300000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.1903530000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.2245280000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21124699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.757005000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7528389999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.147680000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["63.3741790000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3980869999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.847358999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.8760969999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8999379999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.844989999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.9987450000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.9844360000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.507150000000000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["60.7406470000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7613800000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.734811000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.8687330000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.885159999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.582207000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.7243160000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.7891720000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14931899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.629086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6795300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.893932999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.7908499999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7847999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.107213000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.8760969999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8369440000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.693837000000000081`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.9532960000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9949270000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.737741999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.757005000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7857329999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.509082000000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.3741790000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.4048859999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.544170000000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["72.7407740000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.7641839999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.414847000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9532960000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0125659999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05031999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.1903530000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.2587090000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21133899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.757005000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7990380000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.744859999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.3741790000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.4476740000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30240700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.5960740000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6431909999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.83497299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8052160000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8277520000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.399361000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.8760969999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.843431999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.578861999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.4927479999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.5873699999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.67682400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.7243160000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.629086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7908499999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7991909999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8113520000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.2034340000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.503429999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["101.594525000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["69.253442000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.1075920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.387535000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.407582999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.1903530000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.8618139999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.0649370000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.442348999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.5960740000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8052160000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4927479999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.3725359999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.656760000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9162850000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.920184000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["106.735248999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.9987450000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6988769999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.3661500000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.583552999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["72.7407740000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.8303460000000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6341550000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.4997780000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9532960000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.757005000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3741790000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.5386069999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8760969999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7406470000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.8687330000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.235830000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "30", ",", 
                    StyleBox["18.7759397899999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.42759922800000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.83175778899999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.688016913200000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0377660634000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0904457402500000107`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["374.319544099999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.157845206399999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["143.014214100000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08557062299999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.09371213500000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.223885999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.852040000000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.437352999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.106014000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.128638999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0519159999999999932`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.58968199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.993717999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.584096999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.624343999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.808880999999999872`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.796638999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.18787799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.818214000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.0707020000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.1042389999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18113599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.0207230000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0419910000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.749019000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.2406089999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2645959999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.844821999999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0071769999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0196200000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.438248999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9447270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9620010000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.608379000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.106270999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1417300000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.24882899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["61.8747830000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9032750000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00348700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["68.2284489999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.2136809999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.520110999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.9447270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9762360000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10969800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.5327089999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5700050000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31352699999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.106270999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1013309999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.173971999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["61.8747830000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.8982540000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.826641000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.2356260000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2597409999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.849301999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.4218469999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.4076319999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.50061100000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["59.4126249999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4317500000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.673571000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.6614219999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6784940000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.601288000000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.0707020000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.1377969999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18149799999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.2406089999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2878720000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.832278999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0071769999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0013050000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.103405999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["33.2356260000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1986049999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.651921999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.9447270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9834380000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.681684999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.106270999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1325819999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.463338000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.8747830000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9021329999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.48162199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["70.4618480000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4873390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448883000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9447270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0036130000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03694700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.5327089999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6073069999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3136350000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.106270999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.140925000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.610249999999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.8747830000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9502910000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.32966300000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.0207230000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0639300000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.760857000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.024303000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0438770000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.344694999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.2356260000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2084970000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.477730999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["47.1892369999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2061099999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.297123000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.0707020000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2406089999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0071769999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.761216000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.1089909999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.5918489999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.791708999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.330721999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["67.975601000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.09693799999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["101.154152999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["128.242430000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.5327089999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.5127339999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6069549999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.107395999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.0207230000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.024303000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1892369999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2572749999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.2284489999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.7568499999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.137399000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.481486999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.4218469999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.0636009999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.6338839999999876`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.134106000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["70.4618480000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.5751779999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.433843000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["96.9617979999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9447270000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.106270999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.8747830000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6125820000000103`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2356260000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4126249999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6614219999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5242419999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "67", ",", 
                    StyleBox["21.1439729800000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.23889483199999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.43974735499999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.858378530599999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0368337163900000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.101166501600000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["62.4269964600000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.212365050699999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["18.8472165599999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.20519851699999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.18936645099999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.220942000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.917026000000000074`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.333033000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.110884000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.103662000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0321079999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.269714`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.892135999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.580782000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.60209999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.781763999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.774380999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.19688700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.794344000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["9.5172270000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.55239800000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.1736470000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.4869850000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5095320000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.752397000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.8845269999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9095389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.834654000000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1653560000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1809349999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.519859999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.259424`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.275552000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.538206999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4304249999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.464036999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12163600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["58.7571900000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.7857249999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.95221`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.7405009999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.7261909999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.477526000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.259424`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2935030000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1372279999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["36.4636160000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5106520000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.56960699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["49.4304249999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4223980000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.267865000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["58.7571900000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.7831029999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.864714999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9084129999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.934098999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.857146000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.4872769999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4729460000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.478213000000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.4862749999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5034409999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.572842999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6939849999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7150919999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.704366999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["9.5172270000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.58759700000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17411799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.8845269999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9345000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.83378899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1653560000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1628839999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0412410000000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.9084129999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8708370000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.626949999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.259424`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2988169999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.657286999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4304249999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4529510000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.375850000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.7571900000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.7838800000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.44531900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.4068280000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4380000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.520093000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.259424`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3204850000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01881099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["36.4636160000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5576829999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.56952599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["49.4304249999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4590559999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.477717999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.7571900000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8383619999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35435700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.4869850000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.5321259999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.753181999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.2002149999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2185619999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.306118000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9084129999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8869129999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.358723999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["44.7725479999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8026929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.502967999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["9.5172270000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.8845269999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1653560000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8780900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.1989860000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1022059999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.326972999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["99.028735000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4740110000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.728419999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.468639000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.288056999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["36.4636160000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9431529999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.4979750000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.873082999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["23.4869850000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2002149999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.7725479999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.8973030000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.7405009999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3195680000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.8427710000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.0399640000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4872769999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.0090969999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5745490000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.534143000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["66.4068280000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.9525260000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.0673440000000127`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.790049999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["26.259424`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4304249999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.7571900000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.9740680000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9084129999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4862749999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6939849999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.7438240000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["25.2794219899999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.06663814300000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.1518885240000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.962137902299999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0481608818199999966`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.137238055500000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["111.626991399999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.207601163300000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.3638750400000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.14731873399999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.18515368699999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.242955999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.871067000000000035`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0573960000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.129730000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0924100000000000143`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0385580000000000033`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.46757099999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.07975700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.619168999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.620222000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.821986000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.82039799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.23542599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.822813000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["8.93726599999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["8.97781299999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.28487799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.8543330000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.8776089999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.737577000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.770443000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7880450000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.557768999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1367900000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1819639999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.43150700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.3868240000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4021080000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.484306999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.604414000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.630916999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.839836999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.487369000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5120720000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.782814000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.4836550000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4817430000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0606010000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["24.3868240000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4179719999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.987012999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.9633860000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0062329999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35776199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.604414000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6020749999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0741340000000000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["54.487369000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5030039999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.495481999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0333889999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0594709999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.826486000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.4501890000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.4359350000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.451689000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.9969639999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0171040000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.638208000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.2515509999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2637100000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.385299999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["8.93726599999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.01836400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2849410000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.770443000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8056359999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.557610000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1367900000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1234959999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.210638999999999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.0333889999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9962629999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.588246000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["24.3868240000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4238920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.587312999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.604414000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6273890000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.364014999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.487369000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5067150000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.30653999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.2875380000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.3413139999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.852057999999999893`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.3868240000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4426390000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.88435100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.9633860000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0490820000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35779399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.604414000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6298159999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.402472999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.487369000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5483359999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.965999000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.8543330000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9009509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738634000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4320039999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4214530000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.167172999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.0333889999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0603419999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.427045999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.8729480000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.8540360000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.299655000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["8.93726599999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.770443000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1367900000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8426929999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.6384539999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.5167129999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.6647449999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.3758190000000141`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2673850000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.984530000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.8538020000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.712018000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9633860000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4986800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5750730000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.0100649999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.8543330000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4320039999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.8729480000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3549400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4836550000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7135480000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.4603099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.3905059999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.4501890000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5129960000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.3811199999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.627000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["61.2875380000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.5425539999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.6500269999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.242481999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.3868240000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.604414000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.487369000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7391619999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0333889999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9969639999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2515509999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.689980000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["31.8701620299999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.11796151300000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.61742604899999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.00999469099999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00729168205999999941`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.143581886700000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["60.6832776500000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.162551990700000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["9.60935070999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.78831969079999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.734265937400000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.302684999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.738809000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.33525999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.173064999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0794220000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0583709999999999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.14927599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.64076500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.71179199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.715050999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.989382999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.978495000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30768400000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.959146999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.6383910000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.6780890000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27223099999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.5807739999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.603828`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738830000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6996970000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6951350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.146196999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.694030999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7260339999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02562299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.4713649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4820080000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.341075000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.8649229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8843189999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.62160700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.7256829999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7483559999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.72664799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.1265539999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.1252919999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0404440000000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["22.4713649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4975340000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.838667000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.4576119999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4900480000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03952500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.8649229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8650239999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00324299999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["53.7256829999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7473409999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.69409200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2878359999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3075899999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.633072999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.4057489999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.3944810000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.361132000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.3588620000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3788090000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.639264999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.2810589999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2760159999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.161593999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["11.6383910000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.7177700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27197000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.6996970000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6908040000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.142496`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.694030999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7118659999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.285782999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2878359999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3212449999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.535337999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.4713649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5001849999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.46180399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.8649229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8852490000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325708000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.7256829999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7413960000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.251797000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.5138139999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5563910000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.682258999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.4713649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.5161619999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.717818999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.4576119999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5224920000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03963500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.8649229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8836680000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.300364999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.7256829999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7996249999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18485499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.5807739999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6273920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.747011000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2878359999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2243369999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.017517`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.8687929999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.931891000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01107400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.1525839999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.141041000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.18496500000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["11.6383910000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6996970000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.694030999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9827670000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.6450300000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4759770000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.8724270000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.2324739999999891`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7263340000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.0911370000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.596372999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["96.1763780000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4576119999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2979180000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.7751109999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.7617889999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5807739999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1525839999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8687929999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3300399999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.1265539999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4337210000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6349989999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.3642609999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.4057489999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.2270649999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.6739319999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.5350849999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5138139999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.0086390000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9513960000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.7877340000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4713649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8649229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7256829999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.7117880000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2878359999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3588620000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2810589999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.6556459999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["49.8930156299999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.23476961200000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.07368105000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.24391000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.130230000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.169090999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.0093000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.231558000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["6.79891999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.526116000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.515095999999999953`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.306867`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.690667000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.709570999999999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.200532999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0501259999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.041224999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.97958300000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.67557`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.73626699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.736582999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.02799499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02812900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.33127100000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.995635000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.0800280000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.1191680000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16720599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1110509999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1273200000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.485167000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7982820000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7744220000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.711520000000000063`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.1191139999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.133812999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.438338999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.4656349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4741749999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.254691999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.6594399999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6764799999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.508150000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.9915919999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9880080000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.106867`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.8521909999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8526959999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0150709999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["20.4656349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4906379999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.745620999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.022469`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0585730000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.07665799999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.6594399999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.659424999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.000451999999999999957`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->3]}], ",", 
                    StyleBox["50.9915919999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9920270000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0129929999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["33.3808030000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3994420000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555853000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.1834700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1732280000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.305400999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.3084049999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3252949999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.503662000000000098`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8174620000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.814201999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0972090000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.0800280000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.1583059999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1671689999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1110509999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0851760000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.385799999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.1191139999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1482670000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.434687000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.3808030000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4105520000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.443574999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.4656349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.489967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.362810999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.6594399999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6764030000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.252931000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.9915919999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9824650000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.13608`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["52.6951549999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7239689999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.429642000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.4656349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.508386999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.63746400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.022469`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0946780000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.07667500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.6594399999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6765880000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.255691999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.9915919999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9946080000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0449760000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["29.7982820000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8095420000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.167888999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8408489999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8662240000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.378356000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.3808030000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3565990000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.360881999999999969`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.344281000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3679289999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.352594999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.0800280000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1191139999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1110509999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3971549999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3725949999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7068820000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.326106999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.8032569999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4630950000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.6241650000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.4320060000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.328448000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.022469`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0291130000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.0623329999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.8650049999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8408489999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7982820000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.344281000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.6427589999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8521909999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2080279999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3529379999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5353989999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1834700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.8743179999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.4817599999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3234799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6951549999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.3326030000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3570349999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6566150000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4656349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6594399999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2115249999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9915919999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3808030000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3084049999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8174620000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4588010000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["43.3530442999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.894861568500000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.97277099799999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.53001593399999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0473714894999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.174893743500000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "50", ",", 
                    StyleBox["0.331763698600000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["12.5`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->3], ",", 
                    StyleBox["0.587711152400000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.634575239100000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.294293000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.646447000000000038`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.27612299999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.211011000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0381310000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0368409999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.55261000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.54838199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.73447300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.733563999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.986275999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.01636199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.3098209999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.997000000000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["6.65624400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.69486500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.08616899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7404740000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7645069999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.675911000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.7909269999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.863169`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.03171699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.8391709999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9050270000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.85214799999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.0915279999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.1004380000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.250593000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.9230519999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9395260000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.463325999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0337780000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0290620000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.132635000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.6556789999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6556240000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00153999999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["20.0915279999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.1182270000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.750875999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2643739999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3083669999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23724400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.9230519999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9220169999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0291080000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["47.0337780000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0299259999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.108341999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.2581459999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.279427`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.598507000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.886254`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.873871000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.348270000000000035`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["42.3702920000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3883719999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.508492999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.2059290000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.207836999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0536439999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["6.65624400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.73347599999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.08603399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7404740000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7777439999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.524093000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.7909269999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7883799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0358139999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["28.2123300000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1967640000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.21889700000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.0915279999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.1175769999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.366303`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.9230519999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9372339999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.19942499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0337780000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0204980000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.186737999999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.8836829999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9107130000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.380101000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.0915279999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.1367049999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.63527900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2643739999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3523369999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23692099999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.9230519999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9398430000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.236108000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0337780000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0301529999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0509700000000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["26.8391709999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.887751999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.683143999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9965749999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9986610000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0293339999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["28.1879699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1293840000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.823831999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["29.2581459999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3137079999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.781310999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["6.65624400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7404740000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7909269999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2123300000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3142799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.9643589999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8634320000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.9710120000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.6461859999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.2877100000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.6033549999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.2778049999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2643739999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.0059590000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.8276680000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.6948200000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8391709999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9965749999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1879699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.0768229999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6556789999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9132729999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0952630000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.2777159999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.886254`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.5360349999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.3538040000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3930100000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8836829999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3614059999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.5786320000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.2140349999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.0915279999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9230519999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8333379999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0337780000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2581459999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3702920000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2059290000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4413909999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["36.6591310600000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.822426769099999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.40572601900000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.84012046300000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0645856124499999939`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.188248401799999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["57.8447583099999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.4213921676`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["19.9419828000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["1.55679840599999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.40864644200000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.297818000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.510494000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["2.00579600000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.166212999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0162309999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.024719000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["1.37318300000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.62132300000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.707655999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.618571999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.836195000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.801415000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.31181299999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.84295100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["5.8360479999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.87925800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.3189280000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.727940000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7182199999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.296670999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.0877529999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1141340000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.805228999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4009969999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4294790000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.869357000000000113`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.9230750000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9319339999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.270428999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.5862309999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6031630000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.516826000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.6973950000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.7042930000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.21054400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.143500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1449649999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.044692999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["21.9230750000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.952389000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.894786000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.6058099999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6590870000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62623300000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.5862309999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5862669999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00107400000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["49.6973950000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.7023740000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.151973000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.547448000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5713859999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.730670000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.9338479999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.9193429999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.442748000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["45.4410769999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4611140000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.611584000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.6272939999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6297190000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0740019999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["5.8360479999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.92244599999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.3185960000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.727940000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7085569999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.295823`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.4009969999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4577149999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.865619000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.6389880000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6264480000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.191387`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.9230750000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9502810000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.415219000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.5862309999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5997730000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.206668999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.6973950000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.692816000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.06988900000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["52.0225120000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0499659999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.418994999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.9230750000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.972233000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.750243999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.6058099999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7122870000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62504500000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.5862309999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6067660000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.313398999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.6973950000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.7256799999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.431686000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0877529999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1391360000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.78419799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.6296770000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5925869999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.566068000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.9764729999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0224579999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.70181300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.547448000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5802970000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.501337999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["5.8360479999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.4009969999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.727940000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6389880000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.9820530000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4441600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.4810200000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4889370000000106`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.130551999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.080068999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.7174840000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.0785389999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6058099999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7964040000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0331869999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.3990090000000101`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9764729999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0877529999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6296770000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.3424719999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.143500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6071499999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.8496439999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.7802649999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.9338479999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.937778999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5309610000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.0581490000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0225120000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.9637299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6907279999999893`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1056990000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9230750000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5862309999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8498010000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6973950000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.547448000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4410769999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6272939999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6835590000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj1*.out; small basis, lattice spacing fixed to 1+1.5 \
m by chi^2 criterion\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 42 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nIncludes 1 nonstandard fit criteria \
(such as a \\nspecific lattice spacing\\nParity doublets (o,multi,state) with \
error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error \
0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, 4,0), \
error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  \
(4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  \
(4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 \
0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, 11 & \
12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & \
13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary \
spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  \
4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) \
.\\nAll spectra extrapolated using (K,p) = (12/2,8)  (12/2,6) \\n  (14/2,6)  \
(18/2,6) .\\nWinding potential using (n,K,p) = ( 2 0,14/2,6)  ( 2 0,14/2,4) \
\\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( 3 0,23/2,5) \\n  ( 4 \
0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of winding using \
(n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  with error 1; \
in G^2 N units.\\nHeavy potential determined using (n,K,p,K_max) =\\n  ( 0 \
0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \\n  ( 0 0,-32/2,2,3)  ( 0 \
0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 0,-60/2,2,4.5) ,\\n L = 3 4 6 (all \
in G^2 N units); relative scale error=0.1.\\nRoundness determined using \
(n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( \
1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \
\\n L=0 and error 0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 \
0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \
\\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error 0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=5 and error 0.1;\\n  ( 1 \
1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 \
1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error \
0.1; all in G^2 N units.\\np-extrapolation using n=( 1 0) and (K,p) = \
(13/2,3) \\n  (21/2,3)  (45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) \
.\\nResult format:\\n Fit info, # steps, chi^2, and p damping, scale G^2 \
N/sigma.\\n The 10 couplings  (G^2 N units);\\n   which couplings -- if any \
-- were fit.\\n Winding potential and heavy souce potential fits.\\n \
Roundness of winding potential, 1 values, and roundness of\\n   heavy source \
potential, 4 values, (G^2 N units)\\n   showing measured value and derived \
value for each.\\n The rescaled spectrum for each P_perp*a and c^2 values.\\n \
Finally come the states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "48", ",", 
                    StyleBox["448.883264399999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.33757705799999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.50747788600000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.24408725040000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0191463863099999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.171813390700000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["18.6992846200000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0401974100400000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.30207503300000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0658330563400000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.194527873500000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.130410000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.582564999999999955`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.281874000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.142036999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.251727999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.307601000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.50906199999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.495952000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.561875999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.587979999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.709010999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.736664000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.998462999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.03285099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.21889599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.798057000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.7339219999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.7845179999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.898154000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.9295719999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.9660490000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.647518999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7102400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.714325000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.8609150000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8019559999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.0465899999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["21.0578179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0996169999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.741994000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.9799079999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0236459999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.776425999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5927489999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6282240000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.629723000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.5128819999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5212620000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.148763000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.0578179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0716800000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.246065999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.6355879999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6459839999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.184534000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.9799079999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.009013000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.516669000000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5927489999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.597942999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0921959999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["23.8609150000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8790930000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.322697000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9490030000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9422169999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.120460999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["45.8204270000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8330940000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.224851`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.0474979999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0653719999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.317295000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.7339219999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.8142060000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.712582000000000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7499289999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.709430000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.8609150000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7718130000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.790836000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.1666249999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2103070000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387710000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.0578179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1141529999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.500017000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.9799079999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.024579000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.396488999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5927489999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6501299999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.509299999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.5323739999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.367844999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["28.0874120000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["21.0578179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1128749999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.488672000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.6355879999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6564130000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.184835999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.9799079999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0808719999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.896131000000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5927489999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6166769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.212374000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.9295719999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.0236339999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.834858000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.8609150000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8698000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0788600000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["28.4053559999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4311500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.228937999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9750509999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0618139999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.770084999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.7339219999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1666249999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9672939999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9200569999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5370399999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.8975060000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6783039999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.8041549999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6105960000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.6052109999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.749892999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6355879999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.543689000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.7029940000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4145610000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.9295719999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4053559999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9750509999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1475199999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5128819999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.7373619999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7065800000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.1068149999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9490030000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6749580000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.0125189999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4667830000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0115370000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5323739999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.2780700000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.0918850000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0578179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.9799079999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5927489999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3882929999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8609150000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0474979999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8204270000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7959790000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "86", ",", 
                    StyleBox["80.1415944100000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.51373755399999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.64032799499999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.350724788299999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0725812764999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.199236571700000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.2009600900000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107925701299999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.64100670100000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.170421108200000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.143078754499999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.141237000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.634515999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.270952000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.147920999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.225668000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.265819999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.64900299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.529248000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.571405000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.557824000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.734166000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.719008999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.01825399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.03245000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29264000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.760869000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7099960000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.690544000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.9580349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0123350000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.937523000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.7955900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8329559999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.64513600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.8968500000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.9982289999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.75037500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.2626470000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.2947859999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.554895999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.4243140000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4675900000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.747170000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4113050000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4408370000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.509885000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.002737999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0098199999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.122284999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.2626470000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.2758029999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.227154999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.1347629999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.1482800000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.23337699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.4243140000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4537559999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.508319000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4113050000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4152789999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0686250000000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["25.0596050000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0787139999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.329940999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.6467`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6396729999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.121318999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["45.1582300000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1743749999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.278751999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.4496200000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4611069999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.198322000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7504519999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.694521999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.7955900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8689610000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.633392999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.0596050000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.9647839999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.818567`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.1948839999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2875380000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.799854999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.2626470000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.2995449999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.318535000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.4243140000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4721199999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.412694999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4113050000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4591070000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.412667999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.350665999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5185949999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.44968800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.2626470000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.3164149999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.464168000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.1347629999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.1618250000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.233611999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.4243140000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.5218410000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.841925999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4113050000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4303300000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.164239999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.9580349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0664560000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.93596900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.8968500000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0719479999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.511585`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.0596050000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.1866009999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09633200000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.9901390000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9775920000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.108319999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7955900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1948839999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.331847999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.3861920000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4724970000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4435100000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1146400000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1319630000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5270199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.8551740000000123`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.3510909999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.1347629999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.586943999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.0988179999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.9908999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.9580349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.8968500000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9901390000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.9139539999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.002737999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8577550000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.904797000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7895840000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6467`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5909349999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.3391740000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6815629999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7741180000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.4906530000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.0964349999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5202019999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.2626470000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4243140000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4113050000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.350665999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0596050000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1582300000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4496200000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9075279999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "75", ",", 
                    StyleBox["120.968952700000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.54185130199999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.01175411899999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.359087088099999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00741336611699999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.115045963500000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["125.604844300000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.114211489099999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["52.7190985399999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.100790682800000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.212327540199999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.230236000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.81062100000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.922053999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.171145999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.172239999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.215729000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.76612999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14651999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.627993000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.494099999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.788100000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.703730000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.07834300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.08291599999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.18320599999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.690852000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.688511`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.34175399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.9994510000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.305520999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.4342810000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.4490079999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.271891000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6356169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6063930000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.539533999999999913`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["15.2647359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2775440000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.236460999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.664070999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6860000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.404858000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1469090000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1604209999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.249458000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.5393189999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5376069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0316149999999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["15.2647359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2722589999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.13888600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.4216119999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4280760000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.119352999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.664070999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6773689999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.245509000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1469090000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1472130000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00561399999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["19.6356169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6447900000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.169345999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.9462549999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9404600000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.106994999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["33.5540850000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5596000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.101820999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.8107789999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8202169999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.174236000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7070700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.342198000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.4342810000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.4633330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.268183000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6356169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6089370000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.246288000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.9005130000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8867289999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.12723899999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["15.2647359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2779399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.121882000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.664070999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6855839999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.198586000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1469090000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1684929999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.199243000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0971369999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0890909999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0742720000000000091`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["15.2647359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.292218`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.253682000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.4216119999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4345479999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.119418000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.664070999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7129269999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.450987999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1469090000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1524709999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0513419999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["13.9994510000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0324939999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.305018000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6356169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6194640000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.149106999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.8965010000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8997059999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0295809999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["22.7430960000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.8103200000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.620547999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.4342810000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.9005130000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3884669999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.2883829999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.930973999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5195589999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.7879480000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.191085000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6945130000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.717353000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.4812439999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4216119999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7984269999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9622299999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1377450000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.9994510000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8965010000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7430960000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9345630000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5393189999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.1502569999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.630809000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9341440000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9462549999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.153456000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5858050000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0822069999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0971369999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.1853970000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7164030000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7294529999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2647359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.664070999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1469090000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.5605279999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6356169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5540850000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8107789999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.0449509999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "30", ",", 
                    StyleBox["317.39833759999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.16962968899999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.91399986199999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.442708381400000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0812167329799999926`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.148639358800000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["43.8918904199999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0950813057999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["14.4657209899999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.15478048310000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0993356814400000054`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.229049000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.907628000000000056`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.01161499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.175927999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.171989999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.22433200000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.5062129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.05122000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.642020000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.590676000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.82388899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.77695899999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.10260299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14374500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.1982569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.820146000000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.6262130000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.6786239999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13595000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.2665219999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.2643649999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0467579999999999973`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6937140000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.513961000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1319159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1358200000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0846149999999999913`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["18.4129630000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.4322860000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.418810999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.628459999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.653758999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.548327000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.589503999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.6116230000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.479403000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.225566999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.2252810000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00619399999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["18.4129630000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.4252150000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.265541000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.4936620000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.5045490000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.235970999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.628459999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6454520000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.368284999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.589503999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5948769999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.116446000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3812179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3965650000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.332618999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.0019919999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.9929489999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.195985999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["38.638505000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.6569999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.400839999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.6657360000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.6693920000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0792449999999999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["11.6262130000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.6866669999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.655126000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7177150000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.517074999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1319159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1921859999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.65313800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3812179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2566560000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.34984999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["18.4129630000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.4381480000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.27293099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.628459999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6563319999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.302049999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.589503999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.61904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.320076999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.4133390000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.408338000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0541889999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["18.4129630000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.450963999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.411810999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.4936620000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.5154499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.236108999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.628459999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6850539999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.613299000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.589503999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.614697999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.273026999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.2665219999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.3060600000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.42846099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1438579999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2026040000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.636617000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3812179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2992459999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.888314000000000092`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.5229659999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5289839999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0652219999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.6262130000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1319159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.5835019999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0125350000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.600893000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.3010279999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.0584570000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.3300110000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5708699999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.2988459999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.2895709999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4936620000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4475300000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0336999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.316011999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.2665219999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1438579999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5229659999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3443409999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.225566999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4064589999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.7047639999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.0720139999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0019919999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6513119999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4305870000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.4948929999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4133390000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.2852930000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0643870000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6307320000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.4129630000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.628459999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.589503999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.1689390000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3812179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.6657360000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.638505000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.6871490000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "57", ",", 
                    StyleBox["58.4140778799999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02198857300000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.58161405300000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.586997214300000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0530049813199999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.313089862100000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["161.121499199999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.135645661499999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["56.0674428399999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.244558622000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.155646262899999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.193930999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.05342299999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.10025700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.171713000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.162387999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.187345000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.91093700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.635556000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.636057000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.595439000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.812931999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.770692000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.09019400000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12235499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.19406900000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.820520999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7166060000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.951787999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.6067250000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6911229999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.72357999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.0404149999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0424810000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0421930000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["26.2575059999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3539829999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.97025900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.0461980000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0759049999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.60668299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1995449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2299629999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.621189000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.3354509999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3724529999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.755657000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7211529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7288100000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.156368000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.0461980000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0625250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.333432999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.4196540000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.4390169999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.395432000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1995449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2298970000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.619839999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.3354509999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3429430000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.15301400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.2575059999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2811449999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.482762000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5568170000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.550842000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.122008000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["45.337404999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3485680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.227976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.2485700000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2685339999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.407709999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7631779999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.951443000000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.6067250000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6959990000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.91157900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.2575059999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3273469999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.713147000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5345590000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4584320000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.777339000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.0461980000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.084074000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.386753000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1995449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2450570000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.464721000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.3354509999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3803640000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.458610000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.8965749999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8816520000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.152383999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.0461980000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.1004509999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.55398000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.4196540000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.4584090000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.395725000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1995449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2754529999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.775089999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.3354509999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3793719999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448475999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.0404149999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.1240619999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.854119000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.2575059999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3645830000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09336300000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.2743670000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2120629999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.636185000000000044`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.1754030000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1252380000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.512230999999999969`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6067250000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5345590000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.594761`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2493819999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5820139999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.3427410000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.3154659999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9244470000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.0679800000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1998540000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.325706999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["27.4196540000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1018230000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7645849999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1848820000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0404149999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2743670000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1754030000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.9292999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7211529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.3954960000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.7661150000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.9704609999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5568170000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.1962749999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.1074019999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.9487740000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8965749999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.0148659999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.7876160000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8720550000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0461980000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1995449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3354509999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2982760000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2575059999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2485700000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.337404999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7747650000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "30", ",", 
                    StyleBox["107.06981980000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.16450331900000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.27459050499999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.721374182000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0709832895599999957`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.163721945799999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.2167717499999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.191760761199999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.96474868399999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0416243527099999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.255973083499999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.262718000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.943205000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.833790000000000119`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.191022999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.115390999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.135604999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.69590599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2627600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.669236999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.581671000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.922147000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.781962000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.2522359999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17732799999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2620929999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.810276999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6944889999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542966999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.4641950000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.5061979999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.931291000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.6279830000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.6497140000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.481801000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.199701000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2899479999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.00092999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.2671300000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2801399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.288453000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.1416249999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1619129999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.449814999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.5031880000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.526606000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.519213000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4928999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4891499999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0831540000000000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["17.2671300000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2818150000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325585999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.4886089999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5042920000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.347714000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.1416249999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1539799999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.273923000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.5031880000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5134159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.22675799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.7167070000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7324329999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.348689000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.0020969999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9935550000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.189385000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["38.4948979999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.509922000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.333102000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.2390180000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.247326000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.184204000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7189150000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542257999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.6279830000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.6709999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.476869999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2659060000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2122889999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.594389999999999929`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.7167070000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7361440000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.215478000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.2671300000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.283816999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.184985999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.1416249999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1673949999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.285681999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.5031880000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5262370000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.255520999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.7524769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.7850430000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.361021999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.2671300000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3058569999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.429321999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.4886089999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5199870000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.347855999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.1416249999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1810090000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.436595999999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.5031880000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5466750000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.482092999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.4641950000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.5471949999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.920124999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.199701000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3788910000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.98647299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.8782480000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9087439999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.338071999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.7167070000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6689760000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.529126999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.6279830000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2659060000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0854789999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.593831999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9890120000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2167239999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9899449999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6552069999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2887099999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1654470000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.7478610000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.4886089999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6175840000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.0788860000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.1090940000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.4641950000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.199701000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8782480000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6548310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4928999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3085400000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9895370000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4385549999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0020969999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.645147000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4056310000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4009510000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.7524769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1265509999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.4689919999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8115439999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2671300000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1416249999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5031880000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7372640000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7167070000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2390180000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.4948979999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.400263000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["68.5118871500000103`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.946879167600000037`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.17001872600000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.777293850299999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0927059649000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.424993796600000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["51.9313709899999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.150240786999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["17.6141108300000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0320429573300000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0619955877000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.229105000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07429499999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.852442000000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.198066999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.101692000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.12250399999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.15816000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.865097000000000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.683730999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.645157999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.891264999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.836423000000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.23060299999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23078299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2662580000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.899601000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7274049999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.29834300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.1903480000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2362619999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03845699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.8619759999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9099129999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08421400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.3311700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3341209999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0667439999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["19.5937799999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.620279`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.599321999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.2037260000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2207449999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.384923999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4767920000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.5202380000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.98261699999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.8747330000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.909184999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.779218999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.5937799999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6119489999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.410925999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7484129999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7706370000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.502646999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.2037260000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.234588000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.69802900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4767920000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4837170000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.156628999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.452872000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4771129999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.548263999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.1155179999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1117440000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0853659999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["48.3315219999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3334529999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0436829999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["48.6251570000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6527460000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.623981999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7848410000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2986979999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.8619759999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9526490000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02538299999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.3311700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3372060000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0682580000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["29.452872000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4094429999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.491124999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.5937799999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6302200000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.412080999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.2037260000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2472729999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.492460999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4767920000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.5181419999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.467609999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.261694000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2837699999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.249644000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.5937799999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6467150000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.598615999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7484129999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7928889999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.502967999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.2037260000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2557479999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.588302999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4767920000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.5361549999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.671309000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.1903480000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2873289999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09672600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.452872000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4677599999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.168358000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0099729999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0858549999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.858119999999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.7376080000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6874190000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.567568999999999945`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8619759999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3311700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6317609999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5975219999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8250600000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1706369999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.867721000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6284059999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.5028140000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.0887479999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.182282999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.7484129999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3730910000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.2051239999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7871049999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.1903480000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0099729999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7376080000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2594139999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.8747330000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0648730000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.0181460000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.7666739999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1155179999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.6537459999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.771519999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.9450489999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6040210000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.1507679999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.1095389999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7185530000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.5937799999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2037260000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4767920000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.261694000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.452872000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6251570000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3315219999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1560249999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "57", ",", 
                    StyleBox["54.1454082999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.963304021300000101`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.61888247200000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.970930413399999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.249640348799999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.40768468379999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["41.657322790000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.170170623200000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["9.12881499100000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.157084581499999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.1556912611`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.265375000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07248000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.639549999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.20281699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0951679999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.118741000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.02187200000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.13046700000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.695267999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.641206999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.895200999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.839836000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.26407899999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24636799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27400000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.896391000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7243980000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2978289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.4329610000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4706689999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.899645999999999901`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.4702159999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.471925999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0407790000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["25.7457789999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7886370000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02249600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.9292879999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9457169999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.391952000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.0870960000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1003449999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.316089999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8226729999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8832020000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.44407899999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["49.4744120000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4770459999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0628409999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["17.9292879999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9496060000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.484731999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.4313569999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.4559180000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.585970999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.0870960000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1063419999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.459177000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8226729999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8693940000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11464800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.2908329999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3102800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.463978999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1181600000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1165360000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0387450000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["45.0211580000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0358820000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.351283000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.8426809999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8480550000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.128198999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7788229999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.29813599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.4329610000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4715489999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.46031499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.4702159999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.5068589999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.437098999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.2908329999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2280360000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.749099999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.9292879999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9571250000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.332059000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.0870960000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1211679999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.406440999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8226729999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8991330000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.912083999999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.1320890000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.0910609999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.489426999999999967`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.9292879999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9749580000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.544791000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.4313569999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.4804959999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.586169999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.0870960000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1180159999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.36884800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8226729999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.9626789999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.67011799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.7457789999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8330599999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04116000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.6585409999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.654800999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0446110000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["30.2908329999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2986369999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0930949999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["35.9775130000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9519939999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.304421000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4329610000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4702159999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8250310000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4802510000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2919959999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1219410000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.8729950000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3475899999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.7615249999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.2232240000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.994011000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["27.4313569999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.813940999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7238760000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.173963000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7457789999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.6585409999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9775130000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.1421789999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4744120000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.326889000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.5773180000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.2811989999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1181600000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2888690000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.182446999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.3329489999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8055799999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.9274920000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.6493219999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.1775789999999872`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9292879999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.0870960000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8226729999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.1320890000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2908329999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0211580000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8426809999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7727149999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["71.1965789999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00925935300000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.23054955300000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.26007000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.176242000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.22054800000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["10.7990889999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.262786000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.78172899999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.1`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->1]}], ",", 
                    StyleBox["0.1`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->1], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.305559000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.864522999999999974`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0902420000000000044`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.206761000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0817660000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0977559999999999895`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.20125599999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.56866700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.716199999999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.645765000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.963293999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.846484000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.35982099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2590460000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30384100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.903289000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7129999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09959099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.608213000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6453200000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.948891000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.7576189999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7686310000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.281617999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.2418219999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2470579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.133911000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.4958379999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5041559999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.212690000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.6346639999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6472010000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.320589000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0839370000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0976039999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.349483999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.8186169999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.829292999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.272992999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.4958379999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.519127000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.595542000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.1685440000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1961189999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.705154999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.6346639999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6374769999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0719290000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["45.0839370000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0927710000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.225907999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.4274619999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4429160000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.395175000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2955869999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2900769999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.140897999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.1767520000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.1837409999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.178716999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.3129439999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3238430000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.278696999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7560839999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10067000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.7576189999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7790679999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.274249999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.2418219999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2522279999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.133054000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.4274619999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4084660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.242886999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.4958379999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5146270000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.240223999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.6346639999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6539599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.246707000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0839370000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0837929999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00184000000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["48.6239109999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6420269999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.231621999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.4958379999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5402600000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.567968000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.1685440000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2237019999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.705242999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.6346639999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6461719999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.14712900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0839370000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1283820000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.568264000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.608213000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.6820410000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.943947999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.4203730000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4412470000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.266893000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.4274619999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.426209`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0160250000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.5805340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5717209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.112681000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2418219999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7576189999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2644620000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.607257999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8335879999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.9985719999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8928860000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8237210000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.9378499999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.234793999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["100.731689000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["28.1685440000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.6802599999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2918189999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.3200049999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.608213000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4203730000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5805340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.3196380000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2455439999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9855409999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.1459670000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.0392370000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2955869999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3527519999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.7262329999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.4199870000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6239109999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.877860999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7701359999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.2929489999999894`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4958379999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6346639999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8186169999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0839370000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4274619999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.1767520000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3129439999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4650009999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "40", ",", 
                    StyleBox["156.427831400000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00322137299999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["3.44790706499999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.750456800200000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.207763698099999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.251175306099999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["20.1773592499999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0899362471200000079`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.43372891699999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.298895631099999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.3397702039999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.485412999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.532751000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.385339000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.208479999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0889960000000000128`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.114307000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["5.43538399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.30238500000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.876079000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.542225999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.925240999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.778843999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.2150479999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.22485599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.57443799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.763607000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7018429999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.852702999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.9854100000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.0162200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.825032999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.0319039999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0371059999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.139297000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.3872120000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3956480000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.225920999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["16.8582040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.8654660000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.194452999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.134464000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1511959999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448071000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8586010000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8550440000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0952340000000000053`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["39.1465999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1406709999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.15876599999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["16.8582040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.866816`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.230610000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.7031699999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7094880000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.169171999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.134464000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1642700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.798177000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8586010000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8482639999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.27681`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["24.7509529999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7602079999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.247855999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.2104109999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2042490000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.165017999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.765718999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7766019999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.291449000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.4257369999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4132040000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.335628999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7336740000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.852552999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.0319039999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0422219999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.138159000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.6972510000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6463720000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.681239999999999934`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["24.7509529999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7653020000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.192126999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["16.8582040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.8740909999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.21271399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.134464000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1780690000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.583841999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8586010000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.844701999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.186091000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["39.1465999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1417689999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0646889999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["16.8582040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.8740610000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.21230199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.7031699999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7158089999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.169216000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.134464000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1841440000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.665179999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8586010000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.844496999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.188834999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.9854100000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.046526`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.81829900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.3872120000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4047829999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.235268999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.7509529999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7355329999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.206464000000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.0302230000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0433230000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.175397999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0319039999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6972510000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0341929999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.070427000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7340280000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.794131999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6746240000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.9410390000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.498344000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4327609999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.7069330000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7031699999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.6206439999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2020919999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7460299999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9854100000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3872120000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0302230000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3722329999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.5356280000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8812319999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.3904900000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1643699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2104109999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2514490000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2016389999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9670450000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.2385110000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8213659999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8636720000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0016810000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.8582040000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.134464000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8586010000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.1465999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7509529999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.765718999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4257369999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8690349999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "48", ",", 
                    StyleBox["93.9604827500000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01318806300000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.22661141499999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.7017309410000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.427391605000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0365839536700000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.11495527399999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.214593643800000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.75752040600000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0724753628500000068`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.25193149560000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.335294999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.417439999999999944`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.79425799999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.216063000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0645229999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0796400000000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.76205699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.04063999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.755991999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.692112999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.959158000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.892387000000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.35773100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.31370000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.333156`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.970675999999999916`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7170539999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31935399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.0300609999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0370609999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.196269000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.113770999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.1567459999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.20499200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.9256050000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9534580000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.78097499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.8625599999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.865742`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0892399999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["36.6964139999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7161389999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.553065999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0311000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0201440000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.307186000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.733145999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7266059999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.183389999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.8625599999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8908699999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.793799999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.6520449999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6876989999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.999710999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.6964139999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6989810000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0719560000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["47.0311000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.337612`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["8.59440400000000082`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.2932569999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2955200000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0634549999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["34.0227720000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0233059999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0149859999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["42.1028190000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.1099469999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.199878`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1119929999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1859809999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.07457700000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7640719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31885500000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.0300609999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0438249999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.192962999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.9256050000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6650920000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["3.6522960000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.2932569999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4975420000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.86400699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.8625599999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8813519999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.26345900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.6964139999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7030480000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0930030000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["47.0311000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.074517999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.608704`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3536849999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3226239999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.435460000000000047`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.8625599999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9067350000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.619327999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.6520449999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7233440000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.999589999999999889`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.6964139999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7368000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.566200000000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0311000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3505830000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.4790460000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.113770999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.1992720000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19869500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.2932569999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3435739999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.705428999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.4516809999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.607787`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.18854900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["38.1725399999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.0310449999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.98370800000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0300609999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9256050000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.5365820000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7851380000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2287400000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.560384999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.0540859999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.0872140000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.4813369999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.853449000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.734498`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["28.6520449999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3234100000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2000890000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.9829280000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.113770999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.1725399999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4516809999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5160780000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5386909999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0941040000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.0798969999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0873689999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0227720000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.697695000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.6012929999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.633753000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["47.3536849999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4601349999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2000800000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.8825609999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8625599999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6964139999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.733145999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0311000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2932569999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.1028190000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1119929999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0246879999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj2*.out; small basis, lattice spacing fixed to 0.5+3 \
m by chi^2 criterion\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 42 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nIncludes 1 nonstandard fit criteria \
(such as a \\n specific lattice spacing).\\nParity doublets (o,multi,state) \
with error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), \
error 0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, \
4,0), error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# \
states, multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 \
2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 \
2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( \
0.25 0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, \
11 & 12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, \
14 & 13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 \
2).\\nOrdinary spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  \
(-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( \
1,  7)  (-1,  7) .\\nAll spectra extrapolated using (K,p) = (12/2,8)  \
(12/2,6) \\n  (14/2,6)  (18/2,6) .\\nWinding potential using (n,K,p) = ( 2 \
0,14/2,6)  ( 2 0,14/2,4) \\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( \
3 0,23/2,5) \\n  ( 4 0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of \
winding using (n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  \
with error 1; in G^2 N units.\\nHeavy potential determined using \
(n,K,p,K_max) =\\n  ( 0 0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \
\\n  ( 0 0,-32/2,2,3)  ( 0 0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 \
0,-60/2,2,4.5) ,\\n L = 3 4 6 (all in G^2 N units); relative scale error=0.1.\
\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( 1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \\n L=0 and error 0.1;\\n  ( 1 \
0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 \
0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error \
0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 \
0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \
\\n L=5 and error 0.1;\\n  ( 1 1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 \
1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \
\\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error 0.1; all in G^2 N \
units.\\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \\n  (21/2,3)  \
(45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) .\\nResult format:\\n \
Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\\n The 10 \
couplings  (G^2 N units);\\n   which couplings -- if any -- were fit.\\n \
Winding potential and heavy souce potential fits.\\n Roundness of winding \
potential, 1 values, and roundness of\\n   heavy source potential, 4 values, \
(G^2 N units)\\n   showing measured value and derived value for each.\\n The \
rescaled spectrum for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "69", ",", 
                    StyleBox["1449.29554999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.936112025200000097`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.7737578999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.183965354000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0153526376899999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.176961493399999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.13901197499999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0219480630400000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.17580756499999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0175421955100000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.25669744799999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.128290999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.692185000000000094`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.685878999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.151850000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.211617999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.253400000000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.74347099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.419880999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.571152999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.909398999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.970317999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.00564199999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.25086499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24216199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.19669099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23474900000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.1662999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.2371830000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.0040779999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.753333`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.35607200000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.8799260000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.9373310000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62301300000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["36.8472569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7568550000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.5559210000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.8713849999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9570629999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.42236599999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.4873989999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5697430000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.32809100000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["69.5888269999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6302619999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17150299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["78.2604910000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.2725690000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.341460000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.8713849999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8850689999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.386906999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.137636000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.1484309999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.305198999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.4873989999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5066029999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542952000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["69.5888269999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6234179999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.977988000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8472569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8687969999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.608989000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1235479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1153110000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.232887000000000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["69.6319299999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6320259999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00270500000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["73.4973970000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5366779999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11058900000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8170490000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.07875100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.8799260000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.9946480000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62175899999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["36.8472569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.703032999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.03882299999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["43.290835000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.3259780000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.49679599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.8713849999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9777649999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.50383700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.4873989999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5617230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05067200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["69.5888269999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6753790000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22353299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["91.44920299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.1556570000000121`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.14968700000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.8713849999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9638429999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30702999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.137636000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.1592550000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.305601999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.4873989999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.6158649999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.81604800000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["69.5888269999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6545179999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.928641000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.1662999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.3275909999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.28008699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["36.8472569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8560500000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.124299000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.8909819999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.9376490000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.659703999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.9216389999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9540989999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.458867000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.8799260000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.290835000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.9674300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.44920299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.6558040000000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.002353999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["134.450295000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["88.4734749999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.459148999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["114.622352000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["127.36444`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["41.137636000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9378580000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.315811999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["115.451774999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["12.1662999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8909819999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9216389999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.0943370000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.2604910000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.780116999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["118.921549999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["130.263777000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["47.1235479999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.862363000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["112.453650000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["116.571406999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["95.7357310000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.9920200000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.109985999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["118.670983000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.8713849999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4873989999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.5888269999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.4493560000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8472569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6319299999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.4973970000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.731227000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "57", ",", 
                    StyleBox["312.64691149999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.24257286700000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.76518204299999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.297953864999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["0.0785410859100000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.255433264499999967`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.5865039099999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0970729053400000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["3.05314436600000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0230620010099999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.457910741899999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.122544999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.743761000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.657448999999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.16343700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.179466999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.214019000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.74306399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.318778999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.571814`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.675558999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.839719000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.821096999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.10753799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.13404900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27356200000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.9253169999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7292620000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13468400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.1487259999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.2165650000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.29888800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.8719310000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9265970000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04667299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.6200189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5145110000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.02013800000000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["24.1876889999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2461329999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11899900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["48.774993000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8429730000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30159399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.2440690000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2789080000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.667063999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.0634399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0775820000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.270764000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1876889999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1987489999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.211748000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4688980000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4825099999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.260639999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.774993000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8014689999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.506928999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.2440690000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2653620000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.407695000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.6200189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6409099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.39999800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.2308250000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2252480000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.106784000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.0608410000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0651279999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0820840000000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["59.305935999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.3350319999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.557101999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7934940000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18225800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.8719310000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.981041000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0445549999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.6200189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4435919999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.6890039999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.1180639999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2828299999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.57736600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.1876889999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2470249999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.568045000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.774993000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8452070000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.672184999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.2440690000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3117479999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.647916999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.9317139999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1018069999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62837100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.1876889999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2674579999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.763656000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4688980000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4961569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.260960000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.774993000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8935990000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13545699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.2440690000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2885470000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.425808000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.1487259999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.2795409999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25233799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.6200189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6328910000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.123228000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6199060000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6902300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.673239999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.8750599999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0059609999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25316800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8719310000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1180639999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.3205690000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.7432720000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.8495989999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.1568060000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.400600999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["70.5553589999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.6868859999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.899427000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["118.213451000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.4688980000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.0143410000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.988326999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.7398599999999859`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.1487259999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6199060000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.8750599999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4886000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0634399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.908603999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.1088190000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.483080000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2308250000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.5685389999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.2727330000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.79956000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["76.409375999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.3942959999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.771495999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.8635299999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1876889999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.774993000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2440690000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.9317139999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6200189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0608410000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.305935999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.1241849999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"5", ",", "103", ",", 
                    StyleBox["377.025482899999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01988343700000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["9.85366414599999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.45533727000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00357112586700000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.206744174800000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["35.8668211399999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.125977022900000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.93067235960000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0770203684400000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.885178891099999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.157430999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02038399999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.25549899999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.171472000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.167891000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.207919000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.55947100000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.395998999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.586879000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.785114`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.927962999999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.918830999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.22620299999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.22348400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.10579300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.07837999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7252419999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.37111500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.153760000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.2025869999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21189999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.9535019999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0100759999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40418899999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.3741720000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3074470000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.6561209999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["25.6566969999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7035100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16191599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["50.3644230000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.4233759999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.46323299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.9261860000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9691710000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0669059999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["63.1011659999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1093949999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.204245000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.6566969999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6781879999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.533413000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.6580980000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6832360000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.623948999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.3644230000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.4053530000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01589799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.9261860000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9375310000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.281590000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3741720000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4075980000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.829649999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.3669300000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.354550000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.307296999999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.3877249999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.3980830000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.257104999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.8836429999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9194790000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.889453999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7814209999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38275400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.9535019999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0650770000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38466000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.3741720000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2828890000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.13283299999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.8467800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8242699999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.279343999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["25.6566969999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7124169999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.691494000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.3644230000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.4342639999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.86674199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.9261860000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9874269999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.760010999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.5078290000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2288929999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["3.46163499999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["25.6566969999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7377189999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00550300000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.6580980000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7084150000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.62444500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.3644230000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.494197999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.61052799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.9261860000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9731219999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.582478000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.153760000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.2520630000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21994899999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.3741720000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4000570000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.321243999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.2305040000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1669750000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.788414999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["41.3705760000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.5766360000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.55724099999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.9535019999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8467800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4786190000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.9235890000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0098299999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.8699290000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["119.688934999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["63.6099100000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.805582999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.887318999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["116.136324000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.6580980000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.2777070000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.76959200000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.678496999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.153760000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2305040000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.3705760000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7744550000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1011659999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8987060000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.2091499999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.2439750000000131`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.3669300000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.5045080000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.1020950000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.174468999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["66.5078290000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.0176089999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.8739920000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.5050440000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6566969999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3644230000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9261860000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.4483989999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3741720000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.3877249999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8836429999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.2265460000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["889.468777699999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.87078258919999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.8614254600000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.398090429700000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.115704736899999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.180161388799999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["14.0087173800000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0628637410500000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.24799874500000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.10378755770000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.25581748700000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.207441999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.999815000000000075`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.2237579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.17749100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.147100000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.173073999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.29672000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.812691000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.640599999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.990150000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.027204`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.09966399999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.38303799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.37090299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.18526799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.36409099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.4681069999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.5157329999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.71691900000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7167059999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.683746`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.1374050000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.1933520000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.01687500000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.4340970000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3704639999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.29396699999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.2673399999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3165520000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.77408699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["63.554138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6046630000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82142800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.2588939999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2991659999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.45182600000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["74.2633399999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2705009999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.258128000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.2673399999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2879610000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.743407999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.5001550000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.518891000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.67541600000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.554138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.5869259999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18200700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.2588939999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2715259999999908`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.455374000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.6864789999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7167249999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09034399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.5493499999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.5325050000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.607228000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["64.9145910000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9025570000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.433844999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["66.2894170000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.3415959999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.88104500000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7642279999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.6984440000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.1374050000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.2492739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.01642799999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.4340970000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.370468999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.14689299999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.6864789999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6087649999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.40080099999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.2673399999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3326589999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17737200000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["63.554138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6070449999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.953648000000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.2588939999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.3212910000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12470500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["84.0729229999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.3775590000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["5.49105000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.2673399999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3417770000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34172800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.5001550000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.5376539999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.675912999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.554138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6678009999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.04878299999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.2588939999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.3020650000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.778157000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.4681069999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.5625739999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.70276099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.4449869999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3963689999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.87634299999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.6864789999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6786489999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.141143`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.1326339999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.1597989999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.489640999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.1374050000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.4340970000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4633309999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.7431300000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.1520239999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.015525999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["135.397404999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["77.8425040000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.89450899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["118.339189999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["126.077861000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["44.5001550000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5788019999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.690023999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["112.071780999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["12.4681069999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.4449869999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.1326339999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3043449999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2633399999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.5295039999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.063650999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["117.246195999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["42.5493499999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.009882000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.167408`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.579391000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["84.6295770000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.589783999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["101.157523999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["113.307139000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.2673399999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.554138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2588939999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.0729229999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6864789999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9145910000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2894170000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.3340210000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["102.896194200000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.889064739600000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.62610074999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.560436158599999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0827869489000000058`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.242808062199999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.6140946700000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.1097280507`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.04101502600000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0415146355399999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.32403084350000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.203216000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07108500000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.18316599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.185896000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.129560000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.15612899999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.04952500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.70253899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.646173000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.723218000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.90182399999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.883018000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.20551199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2318119999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.19866099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.00123300000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.2372560000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.3048889999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.67701799999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.4775079999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.5571640000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.97514300000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6633060000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.165995000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.9625400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9137799999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.2090479999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["23.075941000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1113180000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.877219999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8119889999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8481939999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.897715999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3020909999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3391029999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.917747999999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.7745190000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7811219999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.163742000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.075941000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0951260000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.475724999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.6202449999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6411530000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.518412999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8119889999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8425840000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.758627999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3020909999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3118980000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.243172999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.9625400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9907329999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.699080000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7185320000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7066759999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.293976000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.8559270000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.896001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.99366500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.7286759999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.724307999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.108321000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["10.2372560000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.3740679999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.69618699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7206200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.627580000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.9625400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8809370000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01171499999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["28.8856329999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8110510000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.924664000000000108`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.075941000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1228699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.581827000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8119889999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8599499999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.594612999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3020909999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3492590000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.584786000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.8665669999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8598790000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0829150000000000098`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["23.075941000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1382109999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.772028999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.6202449999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6620909999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.518804000000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.8119889999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8975280000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.06050700000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["47.3020909999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.348334000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.573316999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.4775079999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.5712189999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16181500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.9625400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.006597000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.546212999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.638323999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5538679999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.04708299999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.9448830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0300949999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05645499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.2372560000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8856329999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7204450000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2894229999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0692350000000097`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.6349340000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.2719839999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.2345839999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.1224449999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.2462960000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.3771229999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6202449999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3502360000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.2784010000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.5982599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.4775079999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.638323999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9448830000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4468530000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7745190000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1969519999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.4388390000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.9996940000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7185320000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.9188549999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.0305319999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.1740269999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8665669999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.0225320000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.2750390000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.613606000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.075941000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8119889999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3020909999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.7621120000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9625400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.7286759999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8559270000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9170739999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["69.3216885599999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.96379416529999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.98159180500000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.830279744499999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0915367997300000091`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.191624783599999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.4881545100000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.252137570699999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.17740162400000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.359618134300000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.332885468500000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.206797999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.13871000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.21062399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.173016000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.152165999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.17107000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.88257600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.667002000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.629024000000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.816945000000000121`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.892750000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.944974000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.23269600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24269000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.20078299999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12192200000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7190999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.45916099999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.6967340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7358309999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16188500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.1842969999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2275849999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28642699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7460640000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8170989999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.11102400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.1954280000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2242730000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.857222999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.2154740000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2589860000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.293107`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["56.4489329999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4941949999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34509499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["66.4967290000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4905339999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.184078999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.1954280000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2215530000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.776378000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.3081499999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3451439999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09938500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.2154740000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2449900000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.877168999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4489329999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4687940000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.590226000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5420389999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.575169999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.984612999999999871`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.0563110000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.0417580000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.432484999999999963`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["57.1546660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1945359999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18487100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.7387120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7454960000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.201623000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7686490000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.46583199999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.1842969999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2700530000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27425100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.8172169999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8696759999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.779491000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5420389999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6645989999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82112000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.1954280000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2291209999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.500643999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.2154740000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2744829999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.876820999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4489329999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4909119999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.623758999999999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["72.6046419999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.6235499999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.280944000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.1954280000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2717579999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13418599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["40.3081499999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.3821450000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09948500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.2154740000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.3023399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.29074200000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["56.4489329999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5350109999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27902399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.6967340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7752090000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16605500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7460640000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7647249999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.277278000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4636670000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6676010000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.03024700000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.5420389999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4957960000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.687123999999999934`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.1842969999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8172169999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.205773999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.7856299999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.4536180000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.359911999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["100.700277999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["66.8993769999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.129082999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.97151899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["136.798836999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["40.3081499999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1785049999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.3559079999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.002322999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["14.6967340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4636670000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7460640000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5853459999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4967290000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.0662619999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.769449999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.864317000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.0563110000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.9123759999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.8434360000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["123.279706`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["72.6046419999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.9186149999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.542241000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["87.558946000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.1954280000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2154740000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4489329999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5279170000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5420389999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7387120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1546660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.6736369999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "85", ",", 
                    StyleBox["41.6830279900000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.952849181000000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["6.56422114699999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.880475217900000117`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.000677297322999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.253051290799999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["15.4927869400000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.183064155099999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.35178400299999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.21214435039999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0895158541200000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.261319999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.03553099999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.731578999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.196077000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.114240999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.145355000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.15466500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14647999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.68068900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.728878000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.912854000000000098`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.899986999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.26419600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2708029999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.25129599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.01409900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7171999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.29544700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.6701830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.7081480000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04198499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.0199390000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0516090000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.869191000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7779249999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8567589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.16365400000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.1238279999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1420289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.499528000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4272739999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4464210000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.525492999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.0393049999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0752349999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.986143999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.1343249999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1972240000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.72630799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.1238279999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1480409999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.664546999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0081270000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0350380000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738590999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4272739999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.442301000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.412422999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.0393049999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0538329999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.398735000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0569880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0820350000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.687434999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1803159999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1707930000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.261353999999999953`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.3356769999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3445870000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.244537000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.642598999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.665059999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.616458999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7644210000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.29573599999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.0199390000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0820520000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.852374000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9437670000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9595410000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.21647400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0569880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0415220000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.212247999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.1238279999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1541880000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.416628000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4272739999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4619179999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.475412999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.0393049999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0688790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.405844000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.3276990000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.346897000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.263463000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1238279999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.178315999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.747729999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0081270000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0619689999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738875999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.4272739999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4609219999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.461751999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.0393049999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.1102410000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.97345499999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.6701830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.746875000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05244099999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7779249999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9335839999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.13609699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.0569880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0699329999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.177634999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.3825530000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3445680000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.521263000000000076`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0199390000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9437670000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3305849999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.8250939999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.7910140000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.0115310000000121`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.8982180000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7405319999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.5567180000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.1816999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.894871999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.0081270000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8447519999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.3189339999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.5556849999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.6701830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7779249999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3825530000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2379969999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1343249999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.653073999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.3350330000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.4191359999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1803159999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.7447200000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8195900000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.584862000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["58.3276990000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.1896239999999913`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.013903999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.753317999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1238279999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4272739999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.0393049999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1406380000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0569880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.642598999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3356769999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.9301049999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "49", ",", 
                    StyleBox["40.8331638699999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.929093183200000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.05939017399999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.01660989600000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0683079228000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.237663564700000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["66.5336490199999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.160673373299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["19.0249796599999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.1102626769`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.102776544399999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.301639999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00364900000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.436831999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.203202999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0932339999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.115172999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.23117400000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.46407700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.709242000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.73486899999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.918390999999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.911362000000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.28927100000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29454500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27880400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02511499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7167099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.365985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.3577600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3907799999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.965643999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5193420000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5493379999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.87720299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7901659999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8121079999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.641673999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.4009229999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4138259999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.377339000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.8531649999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8693179999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.472380000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1756749999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2236879999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40408299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.7129059999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7079170000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.145891999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.4009229999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4271970000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.768355000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1698150000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1973540000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.805355000000000131`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.8531649999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8615499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.245226999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1756749999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2416500000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.9293689999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.599206999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6201690000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.613037000000000098`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6791410000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.671286000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.229730999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.4753290000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4912139999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.464534999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.2383180000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2415319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0940069999999999872`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7634120000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36587900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.5193420000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5184630000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0128550000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["28.7901659999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8335170000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.633879999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.599206999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5974159999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0261860000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["20.4009229999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4287710000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.407193000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.8531649999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8815979999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.415754000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1756749999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2373540000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.901872999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.1043829999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0632289999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.601752999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.4009229999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4514249999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738438999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1698150000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2249080000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.805564000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.8531649999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8739090000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.303319999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1756749999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.3424770000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.43898700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.3577600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4246759999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.978439999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3961859999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3980539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.027315999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["31.599206999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5930379999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0901919999999999966`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["34.150210000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1469960000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0469909999999999961`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7901659999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5193420000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1737019999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0761980000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9780969999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.8141889999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.4163600000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8267070000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.7846820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.8733529999999873`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.325646000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.1698150000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4046439999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.0194099999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.8137799999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3577600000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3961859999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.150210000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0723139999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7129059999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6752809999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6072439999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1049239999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6791410000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.530465000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.7952659999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.7297969999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.869238000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.1504759999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1659939999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.8231120000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4009229999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8531649999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1756749999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1043829999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.599206999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4753290000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2383180000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2966460000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["61.4890828099999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.909611598799999931`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.10618811800000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.24979638999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00359577690699999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.190306254400000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.1380612499999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.245029414499999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.70427532199999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.410707515200000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.215292854700000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.315359999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.849324000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.143418999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.195547000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.100729000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.115508999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.32972499999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.65562499999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.725879999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.737582999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.923988999999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.903337999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30931899999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26725200000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30501599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02519599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7160270000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41810799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.8179790000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8261010000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.25024099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9692229999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9798469999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.327339000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3888929999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4286569999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22513699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.203422999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2134290000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.308292999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0105620000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0254540000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.458854999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5830299999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.593507000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.322797`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.7642129999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7506640000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.417452999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.203422999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.231743999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.872581999999999879`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8374329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8693240000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.98255700000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0105620000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0113610000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0246469999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["52.5830299999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5875640000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.139690000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1146770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1339169999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.592801000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.7845989999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7759270000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.267189999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.8582120000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8680499999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.303106000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1387390000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1501889999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.352764000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.762100999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41882799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.8179790000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8339900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.246649999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5125530000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5346479999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.340370999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1146770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1098070000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0750230000000000085`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["21.203422999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2269469999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.362392000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0105620000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0317999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.327179000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5830299999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5756800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.113237000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.8320139999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8618859999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460175`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.203422999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2565459999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818375999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8374329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9012230000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.982701000000000135`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0105620000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0208490000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.158476000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5830299999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6197370000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.565478000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9692229999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9906290000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.329764999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3888929999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4682360000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22229699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.1146770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0964790000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.280345000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.2777409999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.289222999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.176883000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5125530000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8179790000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2642990000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4897669999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3735629999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.2369979999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.1891489999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.587259999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.3327890000000124`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.190290000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["124.918536999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.8374329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0774329999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3471179999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7403319999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3888929999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9692229999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2777409999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.272786000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7642129999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6504150000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.8336879999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.8427099999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7845989999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.1804800000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.784046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.855666000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["56.8320139999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.849566999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9905729999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.464853000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.203422999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0105620000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1210210000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5830299999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1146770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8582120000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1387390000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.2136759999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "75", ",", 
                    StyleBox["84.978378370000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.816626999100000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.25812051900000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.818867696300000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.282247316000000036`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.401946255500000049`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["31.1648761699999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00334369671099999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.18906526199999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0912764928800000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.908365840699999971`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.385946999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.711477000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.101028999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.212292000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0746909999999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0924339999999999939`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["4.54915100000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.36347100000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.848099000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.739864999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.957611999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.92547599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30825799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32712500000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.5197799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.03539800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7244599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.768297`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.3626220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3987979999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17464699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.0521059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0741379999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.715362999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9131300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9166570000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.114516000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.971916000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9913099999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.629719999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.741604999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7551849999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.440944999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0497099999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0323149999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.564803999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.8494489999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8972180000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.55105200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.971916000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9851789999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.430637999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.2079799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.2201060000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.393733999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.741604999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7743520000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.06327900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["52.0497099999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0467119999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0973419999999999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.9748920000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9937320000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.611721999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.7169299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7066739999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.332986000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.3040429999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3131440000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.295516000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.7483280000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7601139999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.382711999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7790749999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.77081099999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.0521059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.095911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.711153999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9131300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9193199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.100502000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9748920000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9200449999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.890430999999999883`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.971916000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0031619999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.507279999999999908`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.741604999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7913319999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.807319999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0497099999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0330980000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.269693999999999967`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.8494489999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.885752`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.589379000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.971916000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.0059919999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.553220999999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.2079799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.2322449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.393942000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.741604999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7850410000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.705188000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0497099999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0256030000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.391374999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.3626220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4351100000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17682799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.9748920000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.957399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.283986000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.9239119999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9338449999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.161263999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.5155009999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4946509999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.338500999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0521059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9131300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5313620000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.724296000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0904089999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9934649999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.4961620000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8120019999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9939729999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.57109500000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.292783999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.2079799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7279430000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5355250000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.4082159999999888`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3626220000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9239119999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5155009999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1180080000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1079869999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.5045689999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.2831999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.6108100000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.7169299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.0176320000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.3833049999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.1888979999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0233690000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.2078620000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.1727999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.8851469999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.971916000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.741604999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8494489999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0497099999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9748920000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3040429999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7483280000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6842840000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"3", ",", "75", ",", 
                    StyleBox["90.2002019400000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.948675829000000092`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["5.06585270800000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.63703296600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.191083355299999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0217472400599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["8.09735247699999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.162498359000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["1.39802444700000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.701445059899999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.0668173139999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.394066000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.360634000000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.88091999999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.197201999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0913959999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.106265999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.54408399999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.55677600000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.792915999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.685095000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.877857999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.862825999999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.23202300000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24200200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.37735999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.954641999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7124489999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35584999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.7413579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7535850000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.390546999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.9369830000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.9751119999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21787800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.9646320000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9852289999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.657874999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.2783850000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.2806519999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0724130000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["38.8409609999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8570139999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.512739999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4439769999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4410900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.092223000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["49.7117080000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6819750000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.949693000000000075`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.2783850000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.3076059999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.933342000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.2690720000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2997499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.979870000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.8409609999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8368839999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.130241000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.4439769999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4649170000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.66881699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.4154639999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4109449999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.144324000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.2981639999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3037429999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.178197999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5686359999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5783770000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.311129999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.2992659999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2052710000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["3.00224499999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7549499999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35667000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.7413579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7656099999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.38731500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9646320000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6880499999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.4170720000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.4154639999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3595459999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.893022000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.2783850000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.2965690000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.290401000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.8409609999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8464450000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0875779999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["49.4439769999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4471210000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0502120000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["49.4784829999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4522949999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.418229999999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["19.2783850000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.3231490000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.714890000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.2690720000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3304269999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.979861000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.8409609999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8606470000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.314381000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4439769999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.481073000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.592427999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.9369830000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0128200000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21113599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.4154639999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4876489999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15281799999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.3384769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.2579369999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.286246`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["35.991594`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.0160059999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.389869000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.7413579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9646320000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3408710000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0931659999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6971389999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8396280000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5515379999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.0916939999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.4951029999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.432518000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.507873000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.2690720000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6224800000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2920630000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.4700790000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.9369830000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3384769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.991594`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4198040000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8854280000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.467787000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.1915809999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.004175`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2981639999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.8348989999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.3900000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.597356999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["49.4784829999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5932080000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.5153140000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.6924910000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.2783850000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.8409609999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4439769999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.7117080000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4154639999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5686359999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2992659999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0137300000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj3*.out; small basis, n=(2,0) can be tachyonic, \
lattice spacing fixed to 0.5+3 m (chi^2 criterion error=0.01)\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 42 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nIncludes 1 nonstandard fit criteria \
(such as a \\n specific lattice spacing).\\nParity doublets (o,multi,state) \
with error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), \
error 0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, \
4,0), error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# \
states, multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 \
2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 \
2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( \
0.25 0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, \
11 & 12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, \
14 & 13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 \
2).\\nOrdinary spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  \
(-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( \
1,  7)  (-1,  7) .\\nAll spectra extrapolated using (K,p) = (12/2,8)  \
(12/2,6) \\n  (14/2,6)  (18/2,6) .\\nWinding potential using (n,K,p) = ( 2 \
0,14/2,6)  ( 2 0,14/2,4) \\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( \
3 0,23/2,5) \\n  ( 4 0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of \
winding using (n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  \
with error 1; in G^2 N units.\\nHeavy potential determined using \
(n,K,p,K_max) =\\n  ( 0 0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \
\\n  ( 0 0,-32/2,2,3)  ( 0 0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 \
0,-60/2,2,4.5) ,\\n L = 3 4 6 (all in G^2 N units); relative scale error=0.1.\
\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( 1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \\n L=0 and error 0.1;\\n  ( 1 \
0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 \
0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error \
0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 \
0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \
\\n L=5 and error 0.1;\\n  ( 1 1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 \
1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \
\\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error 0.1; all in G^2 N \
units.\\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \\n  (21/2,3)  \
(45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) .\\nResult format:\\n \
Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\\n The 10 \
couplings  (G^2 N units);\\n   which couplings -- if any -- were fit.\\n \
Winding potential and heavy souce potential fits.\\n Roundness of winding \
potential, 1 values, and roundness of\\n   heavy source potential, 4 values, \
(G^2 N units)\\n   showing measured value and derived value for each.\\n The \
rescaled spectrum for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "57", ",", 
                    StyleBox["289.845704300000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08950435500000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["12.7984318699999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.258509855899999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.106170575499999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.268304377599999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.8870911999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0494814539099999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.26073200799999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0942751683699999887`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.333458182800000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.0791459999999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.683915999999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.442537999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.150479999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.239737`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.313911000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.864596000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.00456899999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["0.52855300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.694366999999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.769792999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.827735999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.04363099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.1159730000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.1854199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.944330000000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.2447280000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.4200000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.84064899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.6913640000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.777508`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.39614100000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6915519999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.349299999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.0254549999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9781339999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.76695000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.0607119999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1488009999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42767800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.1199600000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2072829999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41526400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["58.3840279999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.442841999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.953195999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["67.8996089999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.9192000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.317508000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0607119999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0781579999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.282753999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4996430000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5231859999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.381571000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.1199600000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1658170000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.74321899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.3840279999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3992160000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.246138999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.0254549999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0565259999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.503562999999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.4374069999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4370199999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00627200000000000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["64.592912999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.629057999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.585801000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.5082139999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5111050000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0468649999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["10.6913640000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.8601919999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36810399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8338920000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.32810800000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.0254549999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7542270000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.19791500000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["37.6094590000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8760969999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.16071100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.0607119999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1717310000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.899648000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.1199600000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2075179999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.709531000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.3840279999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4839839999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.8099969999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["75.839388999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.0152449999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["6.6784939999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["27.0607119999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.1609200000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.812044999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.4996430000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5468319999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.382403000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.1199600000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2988580000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.44971399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["58.3840279999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.431829000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387351999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.2447280000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.4766920000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.87973199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.0254549999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3713419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.80291099999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.8688479999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.0940110000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82461999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.6777110000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3307460000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.81164399999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.6913640000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6094590000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0439229999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8060859999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.3420989999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["117.709264000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["107.279590000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["92.6989839999999887`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.5964119999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["118.195439999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["146.548860999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.4996430000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0949289999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6731299999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.5160730000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.2447280000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8688479999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6777110000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.299183999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.8996089999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.4043540000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.056488000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.276996999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["45.4374069999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.6657499999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6287880000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["117.041151000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["82.5049139999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.0339980000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.498443000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["98.8454729999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0607119999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1199600000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3840279999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.839388999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0254549999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.592912999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5082139999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.529087999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "85", ",", 
                    StyleBox["156.566628799999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.2288049270000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.0024376499999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.342110684300000045`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0768826471499999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.251768894700000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.4590996799999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.105890941199999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.56035025100000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0423494497499999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.793233573600000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.112536999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.733087999999999961`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.528932000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.163739999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.180791000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.218365000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.43558800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.233325000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.560998999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.725983000000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.885713999999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.861745999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14477000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.16325600000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27383000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.993642000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7377439999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34206699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.3231959999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.3955899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.43419500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.7383559999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.8049849999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31999500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.5155730000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4048649999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.19322699999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["26.2550309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3197679999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.282505`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["52.5550769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6303320000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.4908619999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["58.4156090000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4602300000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.883990999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.6595030000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.6759150000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325131999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.2550309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2711070000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.318487000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.5562189999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5766339999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.404436999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5550769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5951330000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.793534999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.4156090000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4336069999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.356563000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.5155730000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5450489999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.583949999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.3643240000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.357133000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.142449999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["61.2033979999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2128730000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.187721999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.9548270000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9879789999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.656769000000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8090469999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.37732600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.7383559999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.8709719999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31362099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.5155730000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.336486999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.77393`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["37.1169360000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.2948140000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.76196799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.2550309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3243760000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.686899999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5550769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6373659999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.815108999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.4156090000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4936179999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.772719000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["75.6786450000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.0247760000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.4285890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.2550309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3474569999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.915527999999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.5562189999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5971019999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.404959000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5550769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7033089999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.46830599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["58.4156090000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4626339999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.465803000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.3231959999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.4650130000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40476299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.5155730000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5368330000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.210584999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.4826350000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.5307609999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.476712000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.1810199999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.3600399999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.77327900000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.7383559999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1169360000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6007979999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.7590909999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1438280000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.494528000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.155950000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["80.0460419999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.0972020000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["117.744713999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["132.074870999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.5562189999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.1658649999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.3204419999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.3074300000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.3231959999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.4826350000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.1810199999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.4503879999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.6595030000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.9382460000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.262761000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.071581999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["43.3643240000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.0982889999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.531346`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.414128000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["82.9794810000000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.7251470000000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.064082000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["91.9807160000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.2550309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5550769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4156090000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.6786450000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5155730000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2033979999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9548270000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5623279999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "84", ",", 
                    StyleBox["69.0668097999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01655442300000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.53868277599999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.382347386399999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.178360639999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.341067312599999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["2768.36492600000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0844406038899999877`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["356.087998299999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0758512488299999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.443903246899999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.133966000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.04276799999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.28377699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.172166999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.163224999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.200395999999999974`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.23414599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.18942899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.572756000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.637172999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.839706999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.802193999999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.11131399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14440199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.09036400000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.878828999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7259270000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02358799999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.3671070000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.473012999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.93832899999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.7061329999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7230399999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.309425999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8923329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9812970000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62823699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.4426400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4886389999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.841882000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8658239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9115940000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.837678999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.8765539999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9235290000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.859756999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.765464000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.779097999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.249531999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.4426400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4571490000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.265541000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.7432559999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7621250000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.345343999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8658239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9039739999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.698219999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.8765539999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8829809999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.117637999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8923329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9149689999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.414291000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.4988079999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4989879999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.00329700000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["51.3106149999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3342019999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.431700999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.7807719999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7842529999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0637159999999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7817360000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02250599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.3671070000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.4937780000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15918000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.8923329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8816279999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.097958999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.3652909999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3609790000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0394619999999999961`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["20.4426400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5004769999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.529269000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8658239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9227379999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.520821999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.8765539999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9439569999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.616820000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.8195690000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5751890000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.23634699999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["20.4426400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5059080000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.578976000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.7432559999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7810320000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.345696000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8658239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9767179999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01480100000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.8765539999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9158460000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.359569999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.7061329999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8251920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08952500000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.8923329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9192189999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.246035000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.7304439999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7460900000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.143175000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.554332000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.6060860000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.473602999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.3671070000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3652909999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.275295999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3578439999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4519690000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.1871160000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.6808150000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1241139999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.8866260000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.057003000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.564239000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.7432559999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5301350000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.3432780000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.579880000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.7061329999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7304439999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.554332000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.7365860000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.765464000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7921060000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.5666520000000119`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6012120000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4988079999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.9502090000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.766596000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.9189070000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8195690000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.080332000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.6702939999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.8137700000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4426400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8658239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8765539999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4690089999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8923329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3106149999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7807719999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5501720000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "29", ",", 
                    StyleBox["904.537379699999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.865595415800000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.0124207899999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.397064258499999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.117889578800000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.177363155299999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["14.9242955100000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0629082977200000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.10894745899999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0307695015000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.976163774599999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.20740099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00277499999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.23104999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.178408000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.147472999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.17721300000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.29431299999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.810312000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.640410000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.00689000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.995809000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.11560700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32323999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.38590400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.18481999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.38785800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.4701819999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.5283640000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.12620599999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7066219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.33832299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.2800820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3367819999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.07202399999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.6735919999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6470150000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.971213999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["33.7220870000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7719919999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82371999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.3420229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3932599999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.87239399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["66.0695860000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.1102340000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.48543800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["75.1889220000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.1961139999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.262814000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7220870000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7429879999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.763804999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0855349999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1045270000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.694049999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.3420229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3751020000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.20884900000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["66.0695860000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.082446000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.469939000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.0327619999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0634289999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1206879999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.9873800000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.9702390000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.626387000000000071`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["65.6407719999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.628662000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.442543000000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["67.067994999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1207050000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.92623199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7647899999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73198300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.2800820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3934640000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.07169399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.6735919999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6356320000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.693599999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.0327619999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9283959999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.90695399999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.7220870000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7883369999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21050499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.3420229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.395534999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.97776499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["66.0695860000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.1326560000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15240600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["85.0487959999999887`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.383224000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.11062499999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.7220870000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7975410000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.37867399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.0855349999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1235470000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.694561000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.3420229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.4570860000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.10242400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["66.0695860000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.1132879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.798506999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.4701819999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.5650269999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73299500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.6836059999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7360239999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.957779000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.0327619999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.923248`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.00102100000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["50.0018880000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.027588000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.469586999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.2800820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6735919999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1050910000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.8141050000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.297391000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["113.309137999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["137.439445000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["78.7378719999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.174480999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.683592999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["127.594442000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["45.0855349999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.5464180000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.063167999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["113.525833000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["12.4701819999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6836059999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.0018880000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8959600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.1889220000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6084870000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["115.451375999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["118.755155000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["42.9873800000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.334080999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.296775999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["112.106404999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["85.6668529999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.960425000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.360156000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["115.038032000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.7220870000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3420229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.0695860000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.0487959999999887`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0327619999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.6407719999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.067994999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.1210649999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["104.268356999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.890356885699999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.61064052499999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.560007703200000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0827845081200000088`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.242688959999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["10.6190722100000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.109682336899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.0345987459999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0396597164500000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.318529331199999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.203390000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07001100000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.18157`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.185885999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.129438999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.155818000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.05414200000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.704802000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.646314000000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.722057999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.901069999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.88206300000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.20440299999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.23109099999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.19903099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.999629999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.254004000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.3219989999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.68400199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.485203999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.5662000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.00599799999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6612030000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.217885999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.9324619999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8835820000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.21057999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["23.0407880000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.076070999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.873830000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.749335999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7854669999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.894854999999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.2352440000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2721450000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.913902999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.6910220000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6976040000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.163014999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.0407880000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0599060000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.473480999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5785770000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.599399`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.515692000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.749335999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7798480000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.755692999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.2352440000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2450300000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.242358999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.9324619999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9605570000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.695829999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6697759999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.657944999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.293020000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.7887520000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8287270000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.990034999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.6497339999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6453589999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.108343999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["10.254004000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.3918009999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.70638700000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7191300000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.608392000000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.9324619999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8509850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00895800000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["28.8474379999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7730139999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.921620000000000061`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.0407880000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0875610000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.57920000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.749335999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7971670000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.592315999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.2352440000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2823119999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.582850999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.7684970000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.7616209999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0851559999999999917`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["23.0407880000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.102889000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.769016999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5785770000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6202520000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.516080000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.749335999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8346940000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05701800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["47.2352440000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2813220000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.570598999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.485203999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.578616999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15676099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.9324619999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9759010000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.537922000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.5863009999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5013630000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.05181499999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.9180179999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0034469999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05789399999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.254004000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8474379999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6656380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1833250000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9667969999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.4830749999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.1200809999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.1361209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9934050000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.072168000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.2114250000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5785770000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2564670000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.1793129999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.4301460000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.485203999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5863009999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9180179999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4068599999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6910220000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0935599999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.2893839999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.8501480000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6697759999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.8038839999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.8590920000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0621799999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.7684970000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.8968639999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.1306049999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.5025429999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0407880000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.749335999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2352440000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.6392610000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9324619999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6497339999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7887520000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8458680000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "65", ",", 
                    StyleBox["51.8850098099999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01276457699999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.35690937000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.805363889400000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0829371909299999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.175127452100000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.20564442399999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.227662174399999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.52572061199999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0419630576299999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.387657512999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.227249999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07317700000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.05388900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.191185999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.113868999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.133469000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.06105999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.876557999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.64112`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.746319999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.914508000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.906306999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.25736399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2596560000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.21412499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.03519999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7078550000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01260499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.1099920000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.1431760000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.887655999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.433460000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.4672549999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.904009999999999891`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.744239000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8141040000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.86885100000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2172389999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2378220000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.550579000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.5828800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6146329999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.849373000000000111`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.654263000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6908290000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.978133000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.3462389999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.3394460000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.181702000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.2172389999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2397530000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.602231999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7932059999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8214099999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.754441999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.5828800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.602576999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.526890999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.654263000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6713519999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.457117000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5278700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5532429999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.678730000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5728110000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5607570000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.322440999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.7023519999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7292729999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.720131999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.9178690000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9277749999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.264973999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.745744000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01306699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.1099920000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.1753619999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.874318000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8528290000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8662290000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.179221999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5278700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6700940000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.90222499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2172389999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2438420000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.355806999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.5828800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6245119999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.556822999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.654263000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.688482000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.457672999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.7664429999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.787899000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.286976999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2172389999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2768799999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.797690000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7932059999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8496269999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.75462100000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.5828800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6439709999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.817081999999999908`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.654263000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7257910000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.956673999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.433460000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.5016890000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.912546000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.744239000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7730760000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.385683000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.7837020000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9697490000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.48834199999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.5278700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.4773280000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.675985999999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.1099920000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8528290000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9009280000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0224389999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.749503000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.449195999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.0636409999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5391900000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.3434119999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.306445`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["113.188108000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.7932059999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5681350000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.9144380000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.5907409999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.433460000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7837020000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.744239000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0568429999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.3462389999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3721290000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.7114919999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.9364189999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5728110000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.4186830000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.1255149999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.898533000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["60.7664429999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7345940000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.9342399999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3468520000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2172389999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.5828800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.654263000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0174580000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5278700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9178690000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7023519999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.5590950000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "76", ",", 
                    StyleBox["44.1465236700000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.95165917499999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["6.33318058800000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.834763788099999892`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0318748142299999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.294875562999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["19.8143360000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.150647278699999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.98862931000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.122235243599999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00499806041400000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.263139999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.03161600000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.730773000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.197810000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.105977999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.131364999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.2257579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.16485400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.688645999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.708178000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.905841999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.884817999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.24977399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26343999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26099500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.986209000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7215459999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.37442299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.3745649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4110129999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.971876999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2583660000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2890209999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.817385999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6588439999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6654990000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.177458000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.6597169999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6792160000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.519920000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5781949999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5955700000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.463309000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.1530539999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1893089999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.966699999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.7131459999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7747490000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.64259099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.6597169999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6823380000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.603177999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0462029999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0706239999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.651166`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5781949999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5969470000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.500027000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.1530539999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1636720000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.283104999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1962820000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2207230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.651695000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.549930999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5418939999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.214304000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.482336`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5050359999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.605262999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.4961660000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5024780000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.168310999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7731060000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.37462799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2583660000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3181340000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.796825000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.6588439999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6723870000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.18055299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1962820000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1733569999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.305642999999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.6597169999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6919200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.429328999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5781949999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6149660000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490235999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.1530539999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1824929999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.392476000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.4070829999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4103399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0434199999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["20.6597169999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.7117739999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.694033000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0462029999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0950680000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.651463999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5781949999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.613628000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.472395999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.1530539999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2171329999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.854311000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3745649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4490340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.992838000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1962820000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2050669999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.117118999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3030750000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3808889999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03742599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.9310469999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8946099999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.485781000000000062`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2583660000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6588439999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8762410000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8011050000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.4610710000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.1047370000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8756740000000107`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6400679999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.7432130000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.8062879999999879`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.564876000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.0462029999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.2050440000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.1916299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.9619210000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3745649999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3030750000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9310469999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.6533239999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.7131459999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.770472999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6117120000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.8202489999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.549930999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8550129999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0600979999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.8336999999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4070829999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.310236000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.418160000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.3968729999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6597169999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5781949999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1530539999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2685170000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1962820000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.482336`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.4961660000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6237750000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "40", ",", 
                    StyleBox["41.7406672600000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.929803799599999969`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.01739139599999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.0102993469999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0637760107800000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.237912885999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["66.6064677899999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.156974587999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["19.0731295600000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.064148927329999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0899575276599999895`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.303342999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.997822000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.428974999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.203371000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0915240000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.111766000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.26595900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.48254400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.711021000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.731805999999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.922325999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.908865000000000122`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.29372299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29283999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2816019999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02086499999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7165710000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36010800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.0966710000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1293509999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.95443800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5002479999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5311400000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.902221000000000117`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5924849999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6135349999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.614768999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.3644789999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3773589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.376180999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7307069999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7467370000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.468160000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9055070000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9531730000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.39208700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.4511970000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4465160000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.136703999999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.3644789999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3904819999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.75943700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1119750000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1390179999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.789803999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7307069999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7392690000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.250056999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9055070000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9694999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.86894500000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.4709240000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4917740000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.608940000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.5439930000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5360820000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.231045999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.2756169999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2916860000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.469293000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0225220000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0252570000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0798700000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7631329999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35999099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.5002479999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4998310000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00608000000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["28.5924849999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6340600000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.607103999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.4709240000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4698069999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0163170000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["20.3644789999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.392216000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.405034000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7307069999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7591419999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.415228999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9055070000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9661240000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.88516300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.884333999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8442020000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.586026999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.3644789999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.4145049999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.730519999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1119750000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1660760000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.790017999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.7307069999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7515540000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.304425999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9055070000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0687820000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.38425099999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.0966710000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.162908999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.967261000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.3661020000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3683970000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0335119999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["31.4709240000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.464398`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0953049999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["33.9946490000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9916529999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0437429999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5924849999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5002479999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0223670000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7897289999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7187090000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.3548239999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.9731919999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5832930000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.1606499999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.1730050000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["115.823823000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.1119750000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1989520000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.720130000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.6799259999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0966710000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3661020000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9946490000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8898390000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4511970000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4227340000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.2237559999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.6941400000000115`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5439930000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.2022319999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.4521419999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.0127860000000126`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6855619999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.7960960000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.9158960000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.1380460000000098`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3644789999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7307069999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9055070000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.884333999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4709240000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2756169999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0225220000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.0564609999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["61.797716540000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.910271219400000042`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.09697197399999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.24980216600000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0028650199719999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.190401826599999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.1332720899999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.245136835599999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.70469086500000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.409552052300000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.211394000599999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.315382000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.849094000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.14368800000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.195610000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.100625000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.115409000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.33056200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.65599899999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.725886000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.736685999999999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.924611999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.902699999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.3100179999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26697999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.3051299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02398499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7159709999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41433099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7897120000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7978780000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.251249000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9379099999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9485250000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.32658999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3531710000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3929210000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22296300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.1710660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1810540000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.307275000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.9528110000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9676810000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.457473000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5098490000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5203800000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.324002999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.6907519999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6772220000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.416256000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.1710660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1993389999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.869825999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7899979999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.821835`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.979489000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.9528110000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9536200000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0248910000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["52.5098490000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5144670000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.14208499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0840729999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1032780000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.590864999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.746639`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.7379880000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.266159999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.7956890000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8055000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.301852000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0770860000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0885329999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.352176`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7619879999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41505299999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7897120000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8058079999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.24760200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.4762309999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.498196`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.337889000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0840729999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0791419999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0758449999999999935`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["21.1710660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1945400000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.361086000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.9528110000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9740239999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.326313999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5098490000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5025969999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.111552000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.7550159999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7847979999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.458135000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.1710660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2241059999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.81590600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7899979999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8536809999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.979632999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.9528110000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9630950000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.15819399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5098490000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5467320000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.567372999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9379099999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9593019999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.329079999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3531710000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4324849999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22009100000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.0840729999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0661770000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.275285000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.2562499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2674359999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.172072000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4762309999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7897120000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2423480000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4021050000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.2895200000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.1141970000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0813779999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.517463999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.2138639999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.059481000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["124.735684000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.7899979999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0054080000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.2428699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6319109999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3531710000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9379099999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2562499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.2413889999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6907519999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.5651920000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.7144350000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7239809999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.746639`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.0756509999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.6847249999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.754125000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["56.7550159999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.7419159999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.90325300000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.278163000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.1710660000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9528110000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0402520000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5098490000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0840729999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.7956890000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0770860000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1299209999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "75", ",", 
                    StyleBox["84.9028865600000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.816930836299999896`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.25519678499999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.820231256799999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.281863188300000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.401650740499999958`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["31.1694639500000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00298068926899999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.19849575000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0958559504900000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.907302112100000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.385960999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.710964999999999935`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.103648000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.212264000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0748770000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0927719999999999878`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["4.54522799999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.36376600000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.847992999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.739466999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.957651999999999858`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.925159999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30848699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32688000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.5194840000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.03484200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7244659999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.76756399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.3817120000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4178390000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17242899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.0486389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0705710000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.71176200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8900019999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8935400000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.114813999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.9527890000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9721450000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.628152000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.7011629999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7146449999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.437535000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0091449999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9920910000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.553424999999999922`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.8309830000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.878465000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.54092399999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.9527890000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9660820000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.43137799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.1787410000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.1908940000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.394398999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.7011629999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7337279999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05682900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["52.0091449999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0061620000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0967910000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.9599240000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9787800000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.611918999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.6953320000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6850709999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.332991999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.2767770000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2858829999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.295516000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.7198520000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7316270000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.382133000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7790839999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.770038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.0486389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0922420000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.707528000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8900019999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8970030000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.113602000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9599240000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9044490000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.900155999999999956`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.9527890000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9839990000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.506418999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.7011629999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7506210000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.802529000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0091449999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9927980000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.265254000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.8309830000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8671830000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.587394999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.9527890000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.986885`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.55325299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.1787410000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.2030590000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.394606999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.7011629999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7443000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.69996899999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.0091449999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9854869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.383871999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.3817120000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4541049999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.17467999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.9599240000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9423959999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.284410000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.9007160000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9106760000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.161610999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.4996120000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4788939999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.336177999999999954`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0486389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8900019999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5154899999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6903279999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0527400000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9563610000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.4485199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7759649999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9374540000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.561268999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.254553999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.1787410000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6880300000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4820849999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.3625020000000098`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3817120000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9007160000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4996120000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0925079999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0787629999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.4686299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.2411689999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.5591370000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6953320000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.963317000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.3342920000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.1250509999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9716900000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.2095560000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0695350000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.8216240000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9527890000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7011629999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8309830000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0091449999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9599240000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.2767770000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7198520000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6464029999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "39", ",", 
                    StyleBox["125.758780900000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01387574699999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.83679355700000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.69580836600000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.228589077800000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00500555167999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["7.2803749480000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.249640613200000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.04720676099999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.875762339399999945`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.32767185999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.374715000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.310775000000000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.99354399999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.188652999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.102540999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.118381000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.45049699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.43775200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.780580000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.621121000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.822470000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.80303899999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14205299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17840900000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.37615400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.864195999999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7112950000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19750899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9017230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9054530000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.108174999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.1227279999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1549289999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.933784999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7600589999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7961659999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04706600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.8961329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8981759999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0592400000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["36.8873340000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.9160580000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.832964000000000126`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1779850000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1784890000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0146360000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["46.341619000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3248109999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.487413000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.8961329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9229729999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.778322000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5722750000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6025179999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.876994000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8873340000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8959020000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.248479999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1779850000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3498430000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.98366000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.5823180000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5808019999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0439869999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["32.4472400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4501980000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0857779999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["41.3471479999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.3519989999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.140695999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.2257820000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1798989999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.33055499999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.752717`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19933800000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9017230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9089640000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.104991999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7600589999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5517679999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["3.02007499999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.5823180000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6091230000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.388641999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.8961329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.911283`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.219659000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8873340000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8894810000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0311359999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["46.1779850000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2093160000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.454283000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.341619000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3449850000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0488030000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["17.8961329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.9387280000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.617592999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5722750000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.632757999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.876963000000000114`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.8873340000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.9637180000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.107518`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.1779850000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.3172329999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.01901600000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.1227279999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1868009999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.929016999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5823180000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1128349999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["7.69214500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.7077439999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2717749999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["6.32125800000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["34.6454299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6148019999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.444091000000000057`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9017230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7600589999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8659400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0155040000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8835320000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.304314000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.3856839999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.9486550000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.9858759999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.639232999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["107.019285999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.5722750000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6683160000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6341989999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.7151680000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1227279999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6857370000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7077439999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6454299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9778110000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.3025620000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.1305279999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.399719000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4472400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.4558710000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.2767570000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.111627000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["46.4911150000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0859159999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1119530000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.3850570000000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.8961329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.8873340000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.341619000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1779850000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5823180000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.3471479999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2257820000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0049849999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj4*.out; small basis, n=(2,0) can be tachyonic\
\>", 
  "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 41 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nParity doublets (o,multi,state) with \
error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error \
0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, 4,0), \
error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  \
(4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  \
(4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 \
0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, 11 & \
12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & \
13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary \
spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  \
4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) \
.\\nAll spectra extrapolated using (K,p) = (12/2,8)  (12/2,6) \\n  (14/2,6)  \
(18/2,6) .\\nWinding potential using (n,K,p) = ( 2 0,14/2,6)  ( 2 0,14/2,4) \
\\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( 3 0,23/2,5) \\n  ( 4 \
0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of winding using \
(n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  with error 1; \
in G^2 N units.\\nHeavy potential determined using (n,K,p,K_max) =\\n  ( 0 \
0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \\n  ( 0 0,-32/2,2,3)  ( 0 \
0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 0,-60/2,2,4.5) ,\\n L = 3 4 6 (all \
in G^2 N units); relative scale error=0.1.\\nRoundness determined using \
(n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( \
1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \
\\n L=0 and error 0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 \
0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \
\\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error 0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=5 and error 0.1;\\n  ( 1 \
1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 \
1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error \
0.1; all in G^2 N units.\\np-extrapolation using n=( 1 0) and (K,p) = \
(13/2,3) \\n  (21/2,3)  (45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) \
.\\nResult format:\\n Fit info, # steps, chi^2, and p damping, scale G^2 \
N/sigma.\\n The 10 couplings  (G^2 N units);\\n   which couplings -- if any \
-- were fit.\\n Winding potential and heavy souce potential fits.\\n \
Roundness of winding potential, 1 values, and roundness of\\n   heavy source \
potential, 4 values, (G^2 N units)\\n   showing measured value and derived \
value for each.\\n The rescaled spectrum for each P_perp*a and c^2 values.\\n \
Finally come the states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "29", ",", 
                    StyleBox["85.3949286099999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.21927669999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["9.56410988100000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.214841307500000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0680130925100000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.227295031199999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.8729093899999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0379472428800000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.18834024299999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.450940761900000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.453586680100000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.11129`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.649256000000000099`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.51016300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0904889999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.339044999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.363553000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.45154099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.304832999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.554140999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.513816000000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.650433999999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.616143000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.920426999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.814467999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.19984000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.66677900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.4232460000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.5022519999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34547900000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7294569999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01255800000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.6248030000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6715509999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.796133999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5228859999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.4242190000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.68030900000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["22.6474730000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7054979999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.988172000000000139`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2692850000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3301149999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03594300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["48.0803039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1170260000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.625398000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.8467569999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8591180000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.21051700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.6474730000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6586299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.190005000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.7214649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7316179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.172902000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2692850000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2949229999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.436622000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.0803039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0959369999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.266234999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5228859999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5398480000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.288866999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6862849999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6827019999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0610110000000000063`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["52.2487970000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2626420000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.235792000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.2527980000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.268264000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.263386999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7858429999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.986415000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.6248030000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.7190189999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.802256999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5228859999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3531419999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.44538499999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.8544519999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0048140000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2803469999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.6474730000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7182439999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.602615000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2692850000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3268490000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490163999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.0803039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.150390999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.596798000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.0303960000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.0453490000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.12732699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.6474730000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7151479999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.576254999999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.7214649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7418049999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.173198999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2692850000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3847310000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.983034999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.0803039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1147810000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.293581000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["11.4232460000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.5824710000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35581599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.5228859999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5329590000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0857699999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["29.1421339999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4872459999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.93867000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.6382449999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6259629999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.104586000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6248030000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8544519999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7481280000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0593419999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.9722210000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.994285000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7160599999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.4499270000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.1551989999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.5623620000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.344283999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["26.7214649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1220479999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.077523999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.0469109999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.4232460000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1421339999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.6382449999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4746680000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8467569999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.3248229999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.2640719999999916`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.2382860000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6862849999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.6009030000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.1264939999999867`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.8344909999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.5452719999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9524219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.594144`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.7287939999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6474730000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2692850000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0803039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.0303960000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5228859999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2527980000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2487970000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0332419999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["126.734031400000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.24412085399999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.7149267199999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.342110684300000045`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0768826471499999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.251768894700000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.4590996799999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.105890941199999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.56035025100000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0423494497499999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.793233573600000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.113753999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.726309000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.510360000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.163734000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.180851000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.218450999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.44145400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.247520000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.561564999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.712118999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.886341000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.850640999999999891`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14521000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.15556600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27463700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.97492099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7354420000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27624000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.3121069999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.3818219999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35956600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.3917569999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.4564540000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2616989999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6408109999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.0965410000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.699554`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21257199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4655739999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41752099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.063927999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.849617999999999895`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.0664680000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0822569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.307925999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6532179999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.308935000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6818069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7016569999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387116999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4322959999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.768536000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.037135000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.327093000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7769619999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.558660000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.279599000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2725059999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.138339999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["59.8295949999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8395339999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.193813999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.3710310000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4025419999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.614523999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8041739999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3083229999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.3917569999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.5204449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25482800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5744800000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.69506099999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["36.2298220000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.4020969999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.67984299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7043880000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.653426999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4723899999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.775221999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0961899999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.739390000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["73.7160169999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4401780000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["7.06126300000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7265419999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.869443000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6818069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7215580000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387612000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5374819999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40993799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0650089999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.435343999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.3121069999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.4488980000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3338350000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7689310000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.201017000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.5297120000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5763310000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.454581999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.4443999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.6178659999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.69146599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.3917569999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.2298220000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.581948999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.9815320000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.1289569999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.034766000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["108.062515000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["77.9682269999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.9089940000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.754222000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["128.683944999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.6818069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.3973919999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.8488799999999869`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.8067020000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.3121069999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5297120000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.4443999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6430409999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0664680000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.097747`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.641124999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.585918000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["42.279599000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.7340710000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.9127550000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.571269999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["80.7578510000000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.839958999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.537540000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.6285469999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.7160169999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8295949999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3710310000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1020449999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["67.8251997600000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02291893599999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.44970387300000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.382347386399999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.178360639999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.341067312599999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["2768.36492600000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0844406038899999877`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["356.087998299999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0758512488299999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.443903246899999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.135323999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.03943399999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.27780000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.172172999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.163201000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.200342999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.24817700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.202884000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.573360000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.633919999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.840384000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.799767000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.11205400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14282700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.09126499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.874472999999999878`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7251469999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00892000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.493392`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.5865540000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.70441299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.8175400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8446359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.495723999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8182179999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82093900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3329849999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.823215000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6043149999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818538000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6189140000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.851493999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.3691570000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.3824599999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.243387999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3024080000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.263805999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.5656460000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.5842239999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.339876999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5972749999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.689748999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5785339999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.112725000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7409940000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.408115000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.1768440000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.176878000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.000624000000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->3], ",", 
                    StyleBox["50.8839079999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9071039999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.424375000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.4038199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4073170000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0639679999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7801829999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00790500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.493392`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.6174150000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1345130000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7161709999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0230149999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.1161470000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1029759999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.120484999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.344679000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.518575000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6154969999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.511557999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6387760000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.607432000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.2768159999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0448019999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.12237600000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3502179999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.569247999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.5656460000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6028389999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.340220000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6684919999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.996335999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6112799999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.355912999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.8175400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.9341290000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0665119999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7455609999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.245830999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4095390000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4243499999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.135488000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.2948420000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2787230000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.147449999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.493392`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1161470000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9981110000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8590500000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9223010000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.4552790000000115`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.9626980000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5176260000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.1779070000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.097364000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.401469000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.5656460000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.1361830000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5378879999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.9004129999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8175400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4095390000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2948420000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4762520000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.3691570000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.2754340000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7887389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.8608039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1768440000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2949210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.9069719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.9922349999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2768159999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.4718900000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.8728380000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2111680000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.962104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.8839079999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4038199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2158319999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["212.836659000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.876258919900000066`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.7033275700000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.397064258499999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.117889578800000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.177363155299999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["14.9242955100000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0629082977200000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.10894745899999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0307695015000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.976163774599999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.208321000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.995056000000000118`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.21873600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.178404000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.147534000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.177300000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.32636999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.823856999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.641319999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.982789000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.996747000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.0942670000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32382500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.36928699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.1874499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.3544259999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.436239`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.5081520000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.56553399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.689842`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.707895000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.1212340000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.1764599999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.97021399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.9945189999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9660790000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01461599999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.8756369999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9239710000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.72438299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["62.839229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8891479999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.78084400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.5285350000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.567717`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3978520000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["73.3812460000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3882129999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.248563`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.8756369999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8956110000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.712616999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0596359999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0777660000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.646793999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.839229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.871011000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13382699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.5285350000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.541309`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.455743000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.3367020000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.366118000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0494460000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["42.0304829999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.0139780000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.58881799999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["64.0594920000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0481879999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.40327200000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["65.5467620000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5971980000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.79933000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7613629999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62971299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.1212340000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.2316789999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.97009300000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.9945189999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9556230000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.69382400000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.3367020000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2367470000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.782972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.8756369999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9393880000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13719799999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["62.839229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.891016000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.923755000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.5285350000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5899840000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09611900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["83.119764000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.2642219999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.57681300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.8756369999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9485910000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30134400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.0596359999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0959220000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.647269999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.839229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.9507899999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.98998899999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["64.5285350000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.570760000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.753204999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.436239`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.5283990000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.64393300000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.0044579999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0456179999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.73420500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.3367020000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.239818999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.72817500000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["48.656807999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.681548999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.441338000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.1212340000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9945189999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9531399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.6094249999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.0413820000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.597688000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["133.477215000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["76.8114620000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.635381999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["116.657910000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["124.336650999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["44.0596359999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5961070000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.438315000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.68381599999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["12.436239`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0044579999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.656807999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7498360000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3812460000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.4052379999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.610940000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["115.755757000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["42.0304829999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.844840999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["108.571662000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.362570000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["83.7181860000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.233011999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["99.4487160000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.308312999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.8756369999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.839229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5285350000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.119764000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3367020000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0594920000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5467620000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5669309999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["75.755564289999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.895894680399999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.47998785800000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.560007703200000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0827845081200000088`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.242688959999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["10.6190722100000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.109682336899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.0345987459999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0396597164500000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.318529331199999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.204450999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.06607300000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.17389199999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.185885999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.129453000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.15583400000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.06441300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.716269999999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.646642000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.712075000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.901433000000000106`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.874206000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.20473999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.22573200000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.19974399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.985984000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.1267250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.1875990000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.48950699999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.4847199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.6116680000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.10623499999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6190489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.24669199999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.4920510000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.15693800000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7139829999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.840543999999999869`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0917639999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.862270999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5786549999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.888061000000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.8474200000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8537149999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.154036000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6984530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460564999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0696849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0900919999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.499350000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0863859999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.730678999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5518840000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.233023999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5668350000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.672937000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.1218039999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1101340000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.28555299999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.0179150000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0567030000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.949092000000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.9089620000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9050920000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0946899999999999941`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["10.1267250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.2474179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.47659699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7318529999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.756735000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.4596270000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.975154000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.3735600000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3011629999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.885731000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7252650000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.558300000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.103276000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571976000000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5884059999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.563328000000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.7402479999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7327970000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0911589999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7404170000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.74367700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0696849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1105309999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.499723000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1398739999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01973599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5877300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555058999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.4847199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.5758700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11515699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5830680000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.535064000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0913399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0055920000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.04906799999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.4067439999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4919730000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04271599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.1267250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3735600000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1617330000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1967599999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9469859999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.1186129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.691917999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1532699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6973710000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.490043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.5990649999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0696849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3013510000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0622569999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.8715680000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.4847199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0913399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4067439999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8291100000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8474200000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1081329999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.9246849999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.4115929999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1218039999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5798010000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.3310000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8411320000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7402479999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6274430000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7094819999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.3570569999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5446199999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9089620000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0179150000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9991210000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["51.3240321500000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01045629300000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.36575478399999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.805363889400000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0829371909299999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.175127452100000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.20564442399999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.227662174399999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.52572061199999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0419630576299999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.387657512999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.228106000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07279600000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.049493`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.191183999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.113877000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.133476000000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.0556589999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.883241999999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.641356999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.748504999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.914745000000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.908052999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.25757099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.260861`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.21351199999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.03820500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7076340000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01170099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.2318069999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2650320000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.89320200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.5792000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.6130370000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.909634000000000142`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8006840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8653030000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73713800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2750370000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.548920999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.679627000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.846975999999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8080870000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.986389999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4306580000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4236059999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.189569999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2773329999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.610641000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7877820000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8160560000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.760105000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6673370000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.516592000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7887910000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.467640999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5876929999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.681562000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.6012229999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5891429999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.324746999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.7540189999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7805040000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.711987000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.049241000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.0596040000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.278594000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7452910000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01201199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.2318069999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2972350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.879445000000000121`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.9031849999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9161539999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.174323000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7182609999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.09580700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2813470000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.359278999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6892860000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.553324999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8056899999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460975000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.7990929999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.8211099999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.295939999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3142070000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.800961000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7877820000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8443449999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.760287000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7082229999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.807855999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8437169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.972109999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.5792000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.6475419999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.918614999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8006840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8301349999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.395852000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8363120000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0216950000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.49181100000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5113680000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.685127999999999914`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2318069999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9031849999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9591059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1830550000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.847210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.6452840000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.0826449999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6080719999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.4344909999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.4561470000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["113.26532600000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.7877820000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6238580000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.9193700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6410580000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.5792000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8363120000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8006840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.1987189999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4306580000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5145839999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.9314339999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.9640930000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6012229999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.4512600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.1297679999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.998864999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["60.7990929999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.740301999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.0739020000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.496976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1038590000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.049241000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7540189999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6589039999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["44.1385801500000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.954283924599999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.30069893399999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.834763788099999892`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0318748142299999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.294875562999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["19.8143360000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.150647278699999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.98862931000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.122235243599999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00499806041400000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.263989999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02952700000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.727237000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.197812999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.105963999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.131336000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.2347030000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17329599999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.688899999999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.705771999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.906120999999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.882955999999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.25004200000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.262189`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26153300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.982907999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7210549999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35871999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.3902660000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4263359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.959945000000000092`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2636330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2939020000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.805550000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5185379999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5253890000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.182336999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5931860000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.51232299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4218290000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460287999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0287319999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.954999000000000108`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.5041969999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5722879999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.81209799999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5964539999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.59931700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.9257470000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9499950000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.645319999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.422963000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490445000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0034389999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.281887000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1137370000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.644704000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.3867580000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3787189999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.213962999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.2684929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2909079999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.596528999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.3063649999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3127190000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.169120999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7721250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35892699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2636330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3226550000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.785371999999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5185379999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5324670000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.185343000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0664789999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.30648799999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6058030000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.42405999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4409400000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.48444199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0219090000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.386703999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.1437949999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1473019999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0466659999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6256269999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.687838999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.9257470000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9742650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.645612999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4395259999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.465621999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0565110000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.847146000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3902660000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4639559999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.980560999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0981450000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.114868999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1868720000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2622139999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00253999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.7684399999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7325129999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.478059000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2636330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5185379999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7150620000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5425659999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2120510000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7390199999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.5284669999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3652899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.3501329999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.3413030000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.026205999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.9257470000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9520470000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8692429999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.5643440000000126`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3902660000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1868720000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7684399999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.501128999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5041969999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.515727`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.2454810000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.451149000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3867580000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.5113740000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7861469999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.3127229999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1437949999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.0310669999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.9661990000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.053884`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.989771000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2684929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3063649999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3772959999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "12", ",", 
                    StyleBox["40.9033080199999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.931519516200000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.99837899699999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.0102993469999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0637760107800000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.237912885999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["66.6064677899999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.156974587999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["19.0731295600000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.064148927329999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0899575276599999895`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.303849999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.996314000000000099`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.426424999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.203371000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0915109999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.111733999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.27162499999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.487786`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.711148999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.730156000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.922467999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.907568000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.29387300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29195499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.28195600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.01858599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7162360000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34832200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.0922209999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1246240000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.944931000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3967759999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.439665999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25073699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.5858810000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6066840000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.606624000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3232390000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.372116000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234109999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6393999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.46628999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8844309999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.37868199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.3161490000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3113690000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.139399000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3364049999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.756051000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0356270000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0625509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.785151000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234109999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6317919999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.244419999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9007780000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.85541099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4170860000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.603749999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4379189999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4300190000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.230360000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.1454450000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1613850000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.464808999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8899690000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8926609999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0785139999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.762464`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34820699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.3967759999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3961879999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00857499999999999928`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["28.5858810000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.626971000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.599120000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3957930000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00859500000000000063`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3380310000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.401736999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234109999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6516220000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.411341000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8969940000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.872527000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.6713779999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6317189999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.578258000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3602950000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.726363000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0356270000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0894899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.785362000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234109999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6440410000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.300812000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9995999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.36860299999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.0922209999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.157886999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.957469000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.258083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2603789999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0334730000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3896810000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0977190000000000047`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["33.8883640000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8857410000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0382489999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5858810000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3967759999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.916485999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6197649999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5621930000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.1190049999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.7592960000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4113940000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.8930120000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.881939999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["115.490627000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.0356270000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0413449999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.5188900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.4375040000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0922209999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.258083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8883640000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7882679999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3161490000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2578209999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.9977760000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.4617939999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4379189999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.9935939999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.2738899999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6900600000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5251819999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5708110000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.7668759999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.8324309999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6234109999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6713779999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1454450000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8899690000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9004850000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["50.8062558299999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.90921523749999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.10871918099999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.24980216600000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0028650199719999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.190401826599999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.1332720899999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.245136835599999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.70469086500000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.409552052300000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.211394000599999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.315010999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.85025700000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.141512999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.195607000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.100614999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.11538600000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.32679899999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.65213900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.72581199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.737612000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.924529000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.903428000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30991799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26746800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30489799999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02526199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7161959999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42233999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.8194599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8276000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.250626000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9611279999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9719080000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.33189099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3631220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.403379000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23944699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2155200000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.309838999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0358099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.458464999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6034049999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.318593999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.7763029999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7628670000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.413675000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2337789999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.87200400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8419969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8739199999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.982858000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0218620000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0290039999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5974020000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.133746000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1502619999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.595035000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.8143260000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8056440000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.267320999999999964`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.8808020000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8907209999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.305401999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1545229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1659810000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.352762000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7624390000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42305799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.8194599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8355089999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.247069000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5084629999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5308670000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.344903000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1257050000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0805189999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2290400000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.363053000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0422910000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.329000999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5856259999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.114413000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.8570229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8866539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.456156999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2586370000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818683000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8419969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9058520000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.983004000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0313530000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.160611000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6292209999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.556722000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9611279999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9828399999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.334235000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3631220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4434439999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23650499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1135340000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.267879999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.3210260000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.331569`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.162301000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5084629999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8194599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3068930000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5063339999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3867750000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.2610120000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.212259000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6248569999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.3909419999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.232344999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["124.968025999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.8419969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1048459999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.371719999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7547200000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3631220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9611279999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3210260000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3377789999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7763029999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6656669999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.8600760000000136`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.8669079999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8143260000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.209618000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8337590000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.951888999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["56.8570229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8853600000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.0028499999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.526645999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1296779999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8808020000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1545229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.228817999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["84.8006314499999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.820903540299999967`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.20224617800000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.820231256799999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.281863188300000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.401650740499999958`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["31.1694639500000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00298068926899999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.19849575000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0958559504900000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.907302112100000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.387456999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.705829000000000039`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.112383999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.212265000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0748709999999999897`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0927550000000000096`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["4.56188699999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.3797830000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.848338000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.733582`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.95804399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.920562999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30886199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32376300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.52059000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02668300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7237219999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73256300000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.3656429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4011190000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14412200000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9439260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9652430000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.687495999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5863210000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5899229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.116182999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7575460000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.612485999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.320189999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.432493999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4840379999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.468613999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.4158609999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4602169999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.43050000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.751717000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.424495000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.8528770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8648730000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.386884000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3392780000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04809299999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4958280000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0883830000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7262529999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.599975000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.3487829999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.338602999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.328295000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["47.8779680000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.887000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.291307999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.2676039999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2791430000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.372154000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7775879999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73488400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9439260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9863019999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.68332499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5863210000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5935470000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.116528999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.652534000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.888743999999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7692520000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.495014999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3558439999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.791176000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4843950000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.228543999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.4158609999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4491400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.536622000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7721720000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542103000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.8528770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8768820000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387087999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3500379999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.697555000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4782660000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.327383999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.3656429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4367399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14645299999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6897399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.288795999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.5699809999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5801110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.163348999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.2003300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1807439999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.315838000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9439260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5863210000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2155190000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1513830000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.5003039999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.2361149999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7600829999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2308150000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.2373559999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.4564049999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.361036999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.8528770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1556670000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.794050999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.66480799999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3656429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5699809999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2003300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.732367000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.6254380000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.9226129999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5455050000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.7992010000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3487829999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2580279999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.6050539999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.4534450000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.3975859999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5102959999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.3297929999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1776040000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4158609999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8779680000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2676039999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1011439999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "20", ",", 
                    StyleBox["106.0673258`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01673659399999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["4.77538231000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.70111796700000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.249416804900000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0451525751700000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.82846509899999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.271462767200000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.05312564499999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.321006079600000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.180517899799999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.366232999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.326210000000000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.94467600000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.214029999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0730370000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0935130000000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.42910400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.36056800000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.778996000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.659209000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.99512400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.866419000000000139`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.40199000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29288699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.37760900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.92489100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7136350000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22100300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.8785110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9172900000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08511599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.4708150000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4718850000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0299429999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["29.2029389999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5164179999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["8.77191200000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.5815230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5843090000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0779529999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["36.617434000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6535030000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00931999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.2651380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2688980000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.105215000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.4948619999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4707620000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.674367000000000071`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.5815230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6075300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.727737999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2307370000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2607369999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.839462999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.617434000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.6431040000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.718304999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2651380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4882199999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.24235900000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.3368279999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3403719999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0991760000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["32.4473559999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4465689999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.022027000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["41.0191700000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0242430000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.141970000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6171470000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.5910849999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.729272000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7573289999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22183799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.4708150000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4727489999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0270639999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["29.2029389999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0286089999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.4390900000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.3368279999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4722219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.89432500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.5815230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5966289999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.211351000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.617434000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.628860000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.159868000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2651380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3056489999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.566799999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.4948619999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4913809999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0487009999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["17.5815230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6239839999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.594084999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2307370000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2907350000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.839439999999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.617434000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7329289999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.61592200000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.2651380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3045400000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.55127600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.8785110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9557469999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08062100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.0883589999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0698110000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.259502999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.3368279999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4673300000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.825882`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.6880250000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7488089999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.850438000000000116`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4708150000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2029389999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1705749999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6234600000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.396531000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.0980949999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.6767600000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5999010000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.8126559999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.148223999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["107.083404999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.2307370000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2665620000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.9012979999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.2491239999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8785110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.168954999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0883589999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6880250000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2299120000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3748020000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2303009999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.2253529999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4473559999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.7934350000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.2691290000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.275476999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["46.0537740000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4877129999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.147259`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.757363999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5815230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.617434000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.4948619999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2651380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3368279999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0191700000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6171470000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0732360000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj5*.out; small basis, n=(2,0) can be tachyonic, \
lattice spacing fixed to 0.9+2.6 m (chi^2 criterion error=0.1)\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 42 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nIncludes 1 nonstandard fit criteria \
(such as a \\n specific lattice spacing).\\nParity doublets (o,multi,state) \
with error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), \
error 0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, \
4,0), error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# \
states, multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 \
2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 \
2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( \
0.25 0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, \
11 & 12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, \
14 & 13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 \
2).\\nOrdinary spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  \
(-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( \
1,  7)  (-1,  7) .\\nAll spectra extrapolated using (K,p) = (12/2,8)  \
(12/2,6) \\n  (14/2,6)  (18/2,6) .\\nWinding potential using (n,K,p) = ( 2 \
0,14/2,6)  ( 2 0,14/2,4) \\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( \
3 0,23/2,5) \\n  ( 4 0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of \
winding using (n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  \
with error 1; in G^2 N units.\\nHeavy potential determined using \
(n,K,p,K_max) =\\n  ( 0 0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \
\\n  ( 0 0,-32/2,2,3)  ( 0 0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 \
0,-60/2,2,4.5) ,\\n L = 3 4 6 (all in G^2 N units); relative scale error=0.1.\
\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( 1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \\n L=0 and error 0.1;\\n  ( 1 \
0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 \
0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error \
0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 \
0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \
\\n L=5 and error 0.1;\\n  ( 1 1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 \
1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \
\\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error 0.1; all in G^2 N \
units.\\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \\n  (21/2,3)  \
(45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) .\\nResult format:\\n \
Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\\n The 10 \
couplings  (G^2 N units);\\n   which couplings -- if any -- were fit.\\n \
Winding potential and heavy souce potential fits.\\n Roundness of winding \
potential, 1 values, and roundness of\\n   heavy source potential, 4 values, \
(G^2 N units)\\n   showing measured value and derived value for each.\\n The \
rescaled spectrum for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "20", ",", 
                    StyleBox["87.074949660000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.16658633200000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.5611247899999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "0", ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.242347191299999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0974323318999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.256599730900000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.8853739499999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0411036098399999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.31225469399999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.509236470699999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.356193387999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.0910890000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.65818600000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.423597000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.125496999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.278258999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.345167000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.04403299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.123472999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.537715000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.569984000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.784108999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.701426999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.06047399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.964190999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.19036000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.767391999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.4677960000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.5630279999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.46580899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.5298950000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.6154930000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31753300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7141059999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.678879000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5227200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4510350000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.1033790000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["23.269352999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3376539999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0512840000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.792492000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8600580000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03997099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["49.8341160000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8822920000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.741537000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.6559280000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6712040000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.235116999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.269352999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.2838840000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.223655999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.3680849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3842420000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.248693000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.792492000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8290930000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.563359999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.8341160000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8458070000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.179947999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5227200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5457719999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.354800999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.3314909999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.3299310000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0240159999999999973`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["54.8467609999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8780589999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.481752000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.7629700000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7637189999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0115290000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["10.5298950000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.6806149999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15994200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7781169999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.832065000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.5227200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3006840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.70879000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.0954490000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3045479999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.60922400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.269352999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3564979999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.670665999999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.792492000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.859630000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.516692000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.8341160000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.916444000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.633600000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.3946210000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.639701000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.88612800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.269352999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3479759999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.605083000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.3680849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.4004709999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.249238999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.792492000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.9338190000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08765`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["49.8341160000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8713020000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.286187000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.4677960000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.6575439999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.46030299999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.5227200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7148879999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.47892099999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.2527459999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5331989999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.15836100000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.2393069999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3432779999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.800159999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.5298950000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0954490000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1442649999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.4689680000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7714589999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.6072319999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.5233690000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.9974960000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.7216810000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.4088360000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.741655999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["26.3680849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7664050000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5497560000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.7358950000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.4677960000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2527459999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.2393069999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.4125569999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6559280000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.7032070000000079`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.3612689999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.5343169999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.3314909999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.4898780000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.0350410000000138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.0726699999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.8926610000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.3904600000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.5461209999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6083600000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.269352999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.792492000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8341160000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3946210000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5227200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8467609999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7629700000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.4426089999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["131.433080999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["1.24412085899999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["10.7149267300000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    RowBox[{"-", 
                      StyleBox["0.342110684300000045`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0768826471499999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.251768894700000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.4590996799999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.105890941199999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.56035025100000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0423494497499999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.793233573600000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.113753999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.726309000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.510360000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.163734000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.180851000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.218450999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.44145400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.247520000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.561564999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.712118999999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.886341000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.850640999999999891`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14521000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.15556600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27463700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.97492099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7354420000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27624000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["13.3121069999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.3818219999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35956600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.3917569999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.4564540000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.26170000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6408109999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.0965419999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.699554`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2125729999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4655739999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41752199999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.063927999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.849615999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.0664680000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0822569999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.307927000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6532179999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.308935000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6818069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7016569999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387116999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4322959999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.76853700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.037135000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.327093000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7769619999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.558660000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.279599000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2725059999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.138341000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["59.8295949999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8395339999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.193813999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.3710310000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4025419999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.614523999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8041739999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30832400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.3917569999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.5204449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25482800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5744800000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.69506099999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["36.2298220000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.4020969999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.67984299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7043880000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.653426999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4723899999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.775221999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0961899999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.739390000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["73.7160169999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4401780000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["7.06126300000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.7265419999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.869443000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.6818069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7215580000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387612000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5374819999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40993799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0650089999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.435343999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["13.3121069999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.4488980000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.33383600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7689310000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.201017000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.5297120000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5763310000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.454581999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.4443999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.6178669999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.69146599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.3917569999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.2298220000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.581948999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.9815320000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.1289569999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.034766000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["108.062515000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["77.9682269999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.9089940000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.754222000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["128.683944999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.6818069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.3973919999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.8488809999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.8067020000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.3121069999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5297120000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.4443999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6430409999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0664680000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.097747`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.641124999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.585918000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["42.279599000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.7340710000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.9127550000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.571269999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["80.7578510000000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.839958999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.537540000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.6285469999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6373769999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3928869999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0203620000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.7160169999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7483160000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8295949999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3710310000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1020449999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["67.840873540000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02291893200000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.44970387300000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.382347386399999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.178360639999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.341067312599999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["2768.36492600000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0844406038899999877`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["356.087998299999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.0758512488299999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.443903246899999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.135323999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.03943399999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.27780000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.172172999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.163201000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.200342999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.24817700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.202884000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.573360000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.633919999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.840384000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.799767000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.11205400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14282700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.09126499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.874472999999999878`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7251469999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00892000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.493392`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.5865540000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.70441200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.8175400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8446359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.495723999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8182179999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82093900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3329849999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.823216000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6043149999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818538000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6189140000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.851493999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.3691570000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.3824599999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.243387999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3024080000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.263806999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.5656460000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.5842239999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.339876999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5972749999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.689748999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5785339999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.112725000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7409940000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.408115000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.1768440000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.176878000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.000622000000000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->3], ",", 
                    StyleBox["50.8839079999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9071039999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.424375000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.4038199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4073170000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0639679999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7801829999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00790500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["14.493392`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.6174150000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13451199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7161709999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0230159999999999964`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.1161470000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1029759999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.120484999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.344679000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.518576000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6154969999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.511557999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6387760000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.607432000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.2768159999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0448019999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.12237600000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3502179999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.569249000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.5656460000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.6028389999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.340219000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.6684919999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.996335999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6112799999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.355912999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["14.8175400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.9341290000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.06651099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7455609999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.245830999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4095390000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4243499999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.135488000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.2948420000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2787230000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.147449999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.493392`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1161470000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9981110000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8590500000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9223010000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.4552790000000115`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.9626980000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5176260000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.1779070000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.097364000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.401469000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.5656460000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.1361830000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5378879999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.9004129999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.8175400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4095390000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2948420000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4762520000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.3691570000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.2754340000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7887389999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.8608039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1768440000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2949210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.9069719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.9922349999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2768159999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.4718900000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.8728370000000111`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2111680000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2879889999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.5595739999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5723719999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.962104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7186869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.8839079999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4038199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2158319999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "84", ",", 
                    StyleBox["58.6825113399999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.956750022599999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.43898911999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.443492252199999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0914131780599999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.177453031099999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.4306318400000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.078411771090000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["3.69257661400000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.267430078100000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.132619221399999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.208098000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.986411000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.13988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.152849000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.223734999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.26583899999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.12687900000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.820861000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.634637000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.664089999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.809333999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.804916000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.08350999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.103383`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17362100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.901885000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.6437589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.683187999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.976603000000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.7312080000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.8087650000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.92096700000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.663622000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.157969000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["24.4843710000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4468599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.929096999999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.3573130000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3877630000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.754194000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.3956330000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4284370000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.812514999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.269963999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3015430000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.782172`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.3981010000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4016299999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0873970000000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["22.3573130000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.374293999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.420599999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9764359999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9919569999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.38441399999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.3956330000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4202020000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.608550000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.269963999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2771390000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.177717999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.4843710000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.5070109999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.560764999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9023509999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8904939999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.293670000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["45.5592560000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.5920769999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.812922000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.2257600000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2235640000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0543949999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["10.6437589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.719672`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.940128999999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.736653`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.825459000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.4843710000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4344740000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.617931000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["25.0447180000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0015760000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.534286999999999956`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.3573130000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3997530000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.525591000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.3956330000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4342570000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.478331000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.269963999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.311369999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.512783999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.9159420000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9961720000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.99359800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.3573130000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4097940000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.649946000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9764359999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0074979999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.384682000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.3956330000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4716180000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.941028999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.269963999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.3059250000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.445350999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.7312080000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.8096569999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.971537999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.4843710000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.5057159999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.264351999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.0965050000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0358069999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.751707000000000036`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.7742760000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.91615`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.75700900000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.6437589999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0447180000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6246949999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5102430000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.0438419999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.0993480000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.6593550000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1887309999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.6006419999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.3368919999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.6124739999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9764359999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0190500000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.2476869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.6233070000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.7312080000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.0965050000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7742760000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2019999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3981010000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.8729909999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6666050000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.3189090000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9023509999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.3372899999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1636850000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.0864349999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9159420000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.0076470000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4523700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.340170999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3573130000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.3956330000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.269963999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.2310280000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4843710000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2257600000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.5592560000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8192770000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["78.9690355099999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.895894679299999907`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.47998786199999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.560007703200000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0827845081200000088`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.242688959999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["10.6190722100000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.109682336899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["2.0345987459999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0396597164500000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.318529331199999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.204450999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.06607300000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.17389199999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.185885999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.129453000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.15583400000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.06441300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.716269999999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.646642000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.712075000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.901433000000000106`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.874206000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.20473999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.22573200000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.19974399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.985984000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.1267250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.1875990000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.48950699999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.4847199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.6116680000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.10623499999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.6190489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.24669199999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.4920510000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.1569370000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7139829999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.840545000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0917639999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.862270999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5786549999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.888061000000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.8474200000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8537149999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.154036000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6984530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460564999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0696849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0900919999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.499350000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0863859999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.730678999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.551884999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.233023999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5668350000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.672937000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.1218039999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1101340000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.285555000000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.0179150000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0567030000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.949092000000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.9089620000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9050920000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0946899999999999941`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["10.1267250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.2474179999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.47659599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7318529999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.756735000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.4596270000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.975154000000000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.3735600000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3011629999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.885731000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7252650000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.558300000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.103276000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571976000000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5884059999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.563328000000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.7402479999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7327970000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0911589999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7404170000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.74367700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.0696849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1105309999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.499723000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1398739999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01973599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5877300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555058999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["10.4847199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.5758700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11515699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5830680000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.535064000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0913399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0055920000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.04906699999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.4067439999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4919730000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04271599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.1267250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3735600000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1617330000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1967599999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9469859999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.1186129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.691917999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1532699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6973710000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.490043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.5990649999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0696849999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3013510000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.0622569999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.8715680000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.4847199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0913399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.4067439999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8291100000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8474200000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1081329999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.9246849999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.4115939999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1218039999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5798010000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.3310000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8411320000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.7402479999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6274430000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7094819999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.3570569999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6796310000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0565240000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5423610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5446199999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5393329999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9089620000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0179150000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9991210000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["54.8993677599999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01045628200000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.36575478500000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.805363889400000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0829371909299999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.175127452100000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.20564442399999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.227662174399999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.52572061199999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0419630576299999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.387657512999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.228106000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07279600000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.049493`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.191183999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.113877000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.133476000000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.0556589999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.883241999999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.641356999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.748504999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.914745000000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.908052999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.25757099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.260861`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.21351199999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.03820500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7076340000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01170099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.2318069999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2650320000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.89320200000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.5792000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.6130370000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.909634000000000142`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8006840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8653030000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73713800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2750370000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.548922000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.679627000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.846975999999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8080870000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.986391000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.4306580000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4236059999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.189571999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2773329999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.610641000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7877820000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8160560000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.760102999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6673370000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.516592000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7887910000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.467639000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5876929999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.681562000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.6012229999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5891420000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.324746999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.7540189999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7805040000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.711984999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.049241000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.0596040000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.278594000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7452910000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01201099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["15.2318069999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2972350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.879445000000000121`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.9031849999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9161539999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.174323000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.7182609999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.09580700000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2813470000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.359278999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6892860000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.553324999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8056899999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460975000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.7990929999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.8211099999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.295938999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3142070000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.800961999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.7877820000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8443449999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.760287000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7082229999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.807855999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8437169999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.972109999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.5792000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.6475419999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.918613999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8006840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8301349999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.395852000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.8363120000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0216950000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.49181100000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5113680000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.685128999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.2318069999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9031849999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9591059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1830550000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.847210000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.6452840000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.0826449999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6080719999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.4344909999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.4561470000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["113.26532600000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.7877820000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6238580000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.9193700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6410580000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.5792000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8363120000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8006840000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.1987189999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4306580000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5145839999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.9314339999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.9640930000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6012229999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.4512600000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.1297679999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.998864999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["60.7990929999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.740301999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.0739020000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.496976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2546180000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6481210000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7713950000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1038590000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5623400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.049241000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7540189999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6589039999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["44.3670817000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.954283921000000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["6.30069894000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.834763788099999892`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0318748142299999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.294875562999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["19.8143360000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.150647278699999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["4.98862931000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.122235243599999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00499806041400000022`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.263989999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02952700000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.727237000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.197812999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.105963999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.131336000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.2347030000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17329599999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.688899999999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.705771999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.906120999999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.882955999999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.25004200000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.262189`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26153300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.982907999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7210549999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35871999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.3902660000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4263359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.959943999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.2636330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2939020000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.805548999999999892`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5185379999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5253890000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.182336999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5931860000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.512324000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4218290000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.460287999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0287319999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.954999000000000108`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.5041969999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5722879999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.81209699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5964539999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.599315999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.9257470000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9499950000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.645317000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.422963000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.490446000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0034389999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.281887000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1137370000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.644704000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.3867580000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3787189999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.21395900000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.2684929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2909079999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.596528999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.3063649999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3127199999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.169120999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7721250000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35892699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.2636330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3226550000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.785371999999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5185379999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5324670000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.185343000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0664789999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.30648799999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6058030000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.42405999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4409400000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.48444199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0219090000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.386703999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.1437949999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1473019999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0466650000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6256269999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.687838999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.9257470000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.9742650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.645611000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4395259999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.465621999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.0565110000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.847146000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3902660000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4639559999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.980560999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0981450000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.114868999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.1868720000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2622139999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00253999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.7684399999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7325129999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.478059000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2636330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5185379999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7150620000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5425659999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.2120510000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7390199999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.5284669999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3652899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.3501329999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.3413030000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.026205999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.9257470000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9520470000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8692429999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.5643450000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3902660000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1868720000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7684399999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.501128999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.5041969999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5157280000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.2454810000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.451149000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3867580000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.5113740000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7861469999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.3127229999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1437949999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.0310669999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.9661990000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.053884`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.5739349999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.4045339999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.992846999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.989771000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0895119999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.2684929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3063649999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3772959999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "12", ",", 
                    StyleBox["41.4493519400000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.931519517200000102`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.99837897899999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.0102993469999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0637760107800000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.237912885999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["66.6064677899999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.156974587999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["19.0731295600000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.064148927329999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0899575276599999895`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.303849999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.996314000000000099`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.426424999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.203371000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0915109999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.111733999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.27162499999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.487786`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.711148999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.730156000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.922467999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.907568000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.29387300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29195499999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.28195600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.01858599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7162360000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34832200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.0922209999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.1246240000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.944930000000000092`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3967759999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.439665999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25073600000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.5858810000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6066830000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.606624000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3232390000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.372116000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234100000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6393999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.466291000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8844300000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3786799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.3161490000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3113690000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.139402000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3364049999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.756051000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0356270000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0625509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.785149000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234100000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6317919999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.244420999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9007780000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.85541099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4170860000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.603749999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4379189999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4300190000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.230363000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.1454450000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1613839999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.464808000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8899679999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8926609999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0785139999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.762464`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.34820600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.3967759999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3961879999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00857499999999999928`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["28.5858810000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.626971000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.599120000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3957930000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00859500000000000063`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3380310000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.401736000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234100000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6516209999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.411341000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8969940000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.872527000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.6713770000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6317189999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.578258000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.3602950000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.726363000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.0356270000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0894890000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.785360999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.6234100000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6440410000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.300812000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9995990000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.36860399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.0922209999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.157886999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.957469000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.258083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2603789999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0334730000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3896799999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0977190000000000047`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["33.8883640000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8857410000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0382489999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5858810000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3967759999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.916485999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6197649999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5621930000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.1190049999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.7592949999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4113929999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.8930110000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.881939999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["115.490627000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.0356270000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0413449999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.5188900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.4375040000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0922209999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.258083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8883640000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7882679999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.3161490000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.2578200000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.9977760000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.4617939999999904`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4379189999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.9935939999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.2738899999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6900590000000121`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5251810000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5708110000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.7668759999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.8324309999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.310478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.6234100000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8371530000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.6713770000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3963819999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.1454450000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8899679999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9004850000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["50.9170856599999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.909215229600000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.10871918199999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.24980216600000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0028650199719999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.190401826599999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["11.1332720899999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.245136835599999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.70469086500000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.409552052300000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.211394000599999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.315010999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.85025700000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.141512999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.195607000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.100614999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.11538600000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.32679899999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.65213900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.72581199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.737612000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.924529000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.903428000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30991799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26746800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30489799999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02526199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7161959999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42233900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.8194599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8276000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.250626000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9611279999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9719080000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.33189099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3631220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.403379000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23944600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2155200000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.309839999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0358099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.458465999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6034049999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.318597000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.7763029999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7628670000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.413675000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2337789999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.87200400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8419969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8739199999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.982858000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0218620000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0290050000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5974020000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.133747000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1502619999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.595035999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.8143260000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8056440000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.267317000000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.8808020000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8907209999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.305400999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1545229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1659810000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.352761000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7624390000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.42305799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.8194599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8355089999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.24706800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5084629999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5308670000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.344903000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1257050000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0805189999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2290400000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.363053000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0422910000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.329000999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5856259999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.114410999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.8570229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8866539999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.456156999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2586370000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818683000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8419969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9058520000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.983004000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0313530000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.160611000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6292209999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.556722999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.9611279999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9828399999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.334235000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3631220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4434439999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23650499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1135340000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.267879999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.3210260000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.331569`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.162301000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5084629999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8194599999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3068930000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5063339999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.3867750000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.2610120000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.212259000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6248569999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.3909419999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.232344999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["124.968025999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.8419969999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1048459999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.371719999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7547200000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3631220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9611279999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3210260000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3377789999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7763029999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6656669999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.8600760000000136`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.8669079999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8143260000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.209618000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8337590000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.951888999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["56.8570229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8853600000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.0028499999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.526645999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.2054570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0209199999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1296779999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5930579999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1309350000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.8808020000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1545229999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.228817999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["84.813385789999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.820903539999999942`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["5.20224618299999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.820231256799999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.281863188300000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.401650740499999958`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["31.1694639500000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00298068926899999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5.19849575000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0958559504900000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.907302112100000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.387456999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.705829000000000039`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.112383999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.212265000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0748709999999999897`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0927550000000000096`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["4.56188699999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.3797830000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.848338000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.733582`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.95804399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.920562999999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.30886199999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32376300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.52059000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02668300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7237219999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73256300000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.3656429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4011190000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14412099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9439260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9652430000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.687495999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5863210000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5899229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.116182999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7575460000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.612486999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.320189999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.432493999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4840379999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.468613999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.4158609999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4602169999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.430499`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.751717000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.424497999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.8528770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8648730000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.386884999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3392780000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04809299999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4958280000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.088382000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7262529999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.599975000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.3487829999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.338602999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.328293999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["47.8779680000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.887000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.291307999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.2676039999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2791430000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.372154000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7775879999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.73488400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9439260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9863019999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.68332499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5863210000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5935470000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.116528999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.652534000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.888743999999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7692520000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.495016000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3558439999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.791177000000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4843950000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.228543999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.4158609999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4491400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.536621000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7721720000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.542104000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.8528770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.8768820000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.387087999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3500379999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.697555999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4782660000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.327383999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["17.3656429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4367399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14645200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6897399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.288795999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.5699809999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5801110000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.163348999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.2003300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1807439999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.315838000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9439260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5863210000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2155190000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1513830000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.5003039999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.2361159999999884`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7600829999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2308150000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.2373559999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.4564049999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.361036999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.8528770000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1556670000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.794050999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.66480799999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3656429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5699809999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2003300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.732367000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.6254380000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.9226129999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5455059999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.7992010000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3487829999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.2580279999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.6050539999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.4534450000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.3975859999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.5102959999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.3297929999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1776040000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7385540000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3067789999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4158609999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4985680000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7076489999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8779680000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2676039999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1011439999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "19", ",", 
                    StyleBox["125.455705500000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00392375999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["5.00794136699999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.71880797200000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.219783518499999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00736250424399999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.99363794300000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.26931139690000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.06495591200000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00559246880299999915`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.531788240100000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.36815199999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.317836000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["2.00455300000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.21644899999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0646570000000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0802369999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["2.34253199999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.37680699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.775553999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.695950999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.939006999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.895958999999999861`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.3231219999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.31736399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.36718099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.976112999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7123509999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2493209999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.215703999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.2533369999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.110128`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3092420000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.312368000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0921879999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["30.1102820000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2448739999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.97029299999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.3002509999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3023130000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0608269999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["37.4556650000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4779169999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.65642100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1220440000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1250709999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0892889999999999872`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["47.8647509999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8547209999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.295891000000000037`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["18.3002509999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.328125`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.822236999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.2198460000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2519619999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.947372999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.4556650000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4561750000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0150609999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["47.1220440000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.4654540000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.1302230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.086903999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0850549999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0545540000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["32.9851230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9884259999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0974480000000000146`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["42.2203499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2246189999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.125914999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.2002019999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1567959999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.28043200000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.754782`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25048800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3092420000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.315273000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0889480000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["30.1102820000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9144359999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.888626`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.086903999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0792030000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.113595000000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["18.3002509999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3158530000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.230115999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.4556650000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4574259999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0259719999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["47.1220440000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1527099999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.452313999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.4710940000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.4603549999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.158386000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["18.3002509999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3445`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.652637`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.2198460000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2840730000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.947312999999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.4556650000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5027669999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.694733000000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.1220440000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.6805289999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["8.23735399999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.215703999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.2906250000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10503700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.086903999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1090769999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.327035000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.4145219999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5017990000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28727999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.7801710000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8535400000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08214000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3092420000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1102820000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3285759999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5006589999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.9868240000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.4991450000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5727749999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9329329999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.2688670000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.929479000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.834239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.2198460000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.6805379999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.121029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.8599109999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.215703999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.0467939999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4145219999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7801710000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.1902309999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.520355999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.9431620000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3608279999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9851230000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1016630000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.9827319999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.418700999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["47.4710940000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7146829999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.7711319999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.0028709999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3002509999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4556650000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.8647509999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.1220440000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.086903999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.2203499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2002019999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2187779999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj6*.out; small basis, n=(2,0) can be tachyonic, \
lattice spacing fixed to 0.9+2.6 m (chi^2 criterion error=0.1)\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 42 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nIncludes 1 nonstandard fit criteria \
(such as a \\n specific lattice spacing).\\nParity doublets (o,multi,state) \
with error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), \
error 0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, \
4,0), error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# \
states, multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 \
2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 \
2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( \
0.25 0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, \
11 & 12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, \
14 & 13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 \
2).\\nOrdinary spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  \
(-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( \
1,  7)  (-1,  7) .\\nAll spectra extrapolated using (K,p) = (12/2,8)  \
(12/2,6) \\n  (14/2,6)  (18/2,6) .\\nWinding potential using (n,K,p) = ( 2 \
0,14/2,6)  ( 2 0,14/2,4) \\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( \
3 0,23/2,5) \\n  ( 4 0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of \
winding using (n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  \
with error 1; in G^2 N units.\\nHeavy potential determined using \
(n,K,p,K_max) =\\n  ( 0 0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \
\\n  ( 0 0,-32/2,2,3)  ( 0 0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 \
0,-60/2,2,4.5) ,\\n L = 3 4 6 (all in G^2 N units); relative scale error=0.1.\
\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( 1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \\n L=0 and error 0.1;\\n  ( 1 \
0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 \
0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error \
0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 \
0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \
\\n L=5 and error 0.1;\\n  ( 1 1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 \
1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \
\\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error 0.1; all in G^2 N \
units.\\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \\n  (21/2,3)  \
(45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) .\\nResult format:\\n \
Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\\n The 10 \
couplings  (G^2 N units);\\n   which couplings -- if any -- were fit.\\n \
Winding potential and heavy souce potential fits.\\n Roundness of winding \
potential, 1 values, and roundness of\\n   heavy source potential, 4 values, \
(G^2 N units)\\n   showing measured value and derived value for each.\\n The \
rescaled spectrum for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["1.17218165600000001`*^7",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.25`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->2]}], ",", "50", ",", "0", ",", "1", 
                    ",", 
                    StyleBox["0.0391382092000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.161939395799999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.171024925100000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["23.6380704299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0408261873600000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.19694939199999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0818215667900000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.193420260599999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.0771959999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["5.22902199999999961`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["6.78029399999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0719429999999999925`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["1.58348399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["2.46148899999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.387148000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["3.76391700000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.491626999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.406859999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.673765999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.393606999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.895537000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.354567000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.950506000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0447769999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["310.403232999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["309.521600999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["54.4467590000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["309.039665000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["309.394319000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["21.9023150000000033`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["192.604039999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["130.632332999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["3827.17310499999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["183.679854000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["130.00602699999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["3314.72277999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["12.0374820000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["11.1040120000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["57.6481339999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2506340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.8805990000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["825.690303000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["80.0023649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1123600000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.79293800000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["101.732647999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["129.550421000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["1717.93610900000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["12.0374820000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["12.0375509999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00425399999999999955`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    StyleBox["27.2506340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3029459999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.23062199999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["80.0023649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.8136940000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["605.916053000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.627637999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["117.806933999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["381.613423000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["44.9715630000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["44.9779830000000035`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.396479000000000034`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["37.9059400000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["37.9037549999999967`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["0.134982999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["10.4944900000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["10.4886689999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["0.359536000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.329994000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.3258970000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.253022000000000035`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["309.039665000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["308.511177999999963`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["16.3188120000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["192.604039999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["130.625549000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["1913.79604399999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["129.992167999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["60.366344999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["2149.93333299999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["59.7869039999999962`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["59.3742210000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["12.7430010000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["12.0374820000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["11.1543379999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["27.2700679999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2506340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.103767000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.534999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["80.0023649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1481150000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.50051199999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["101.732647999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.236214999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["15.5493309999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["12.0374820000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["11.0538519999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["30.3729229999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2506340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.0479900000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["407.676390000000044`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["80.0023649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.9330870000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["306.644701000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.627637999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["117.724727000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["188.268313000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["310.403232999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["309.877587999999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["16.2310909999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["183.679854000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["130.639360000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["1637.80507100000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["130.019631000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["119.473841999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["325.636973000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["44.9715630000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["106.22749600000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1891.48461799999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["309.039665000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["129.992167999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["59.7869039999999962`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["192.604039999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["101.732647999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["258.939609000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["159.716776999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["313.535932000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["74.6317190000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["190.703078000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["198.154885000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["276.495275999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["127.657852000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["111.627637999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["237.351934000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["248.808988999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["310.403232999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["130.019631000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["183.679854000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["33.8250820000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["116.318078999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.469468`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["277.618418`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["296.370057999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["26.329994000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["135.646633000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["199.748342`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["186.976082999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["152.694685999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["223.027599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["183.471770999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["327.289368000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["12.0374820000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["80.0023649999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2506340000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["220.747894000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["10.4944900000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["37.9059400000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["33.1990339999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["44.9715630000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "76", ",", 
                    StyleBox["281203.050700000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.25`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->2]}], ",", "50", ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.137190451299999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.137865619399999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.201986091099999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["1.79519746199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.000297777635900000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.975211065200000071`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.940052342799999962`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.49784861899999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.104584999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["2.97250000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["4.53596399999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0233630000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.13683200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0528429999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.993662999999999918`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.56882400000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.568339999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.517867999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.469411999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.522317999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.614615000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.53536999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.968919999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.673388000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["151.063846000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["150.717392999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["28.9871049999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["127.060798000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["126.964666000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["8.04318100000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["69.4171510000000058`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["67.9468490000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["123.017320000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["4.31185500000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["4.17408300000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["11.5271250000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.5987769999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.365298999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["64.1334149999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["139.835083999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.967371000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["11.0681870000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["167.628127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["167.710379999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["6.88186300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["193.260167999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["192.63287`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["52.4847930000000051`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["99.5987769999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.6097050000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.914355000000000117`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["126.126965000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["126.163135999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["3.02639300000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["139.835083999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.860359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["2.11477499999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["167.628127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["167.189581000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["36.6923969999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["45.7871519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8606990000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.15359600000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["95.1259130000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.0920469999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.83351499999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["119.528823000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.609769`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["6.77257700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["120.695935999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["120.695755999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0151059999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    RowBox[{"-", 
                      StyleBox["127.060798000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["126.856250999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["8.55701999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["69.4171510000000058`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["66.4812240000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["122.821656000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["4.31185500000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["4.03661600000000042`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["11.5143620000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6792979999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.9219399999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["261.15489300000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["99.5987769999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.457826999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["35.9375369999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["139.835083999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.998997000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["6.85713900000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["167.628127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["167.566620000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["2.57314599999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["211.800473`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["201.187294999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["443.992004000000051`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["99.5987769999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.295011999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.126341`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["126.126965000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["126.199572000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["3.03744699999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["139.835083999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.986335999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["6.32748099999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["167.628127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["167.724674`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["4.0389090000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["151.063846000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["150.389301999999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["28.218914999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["3.70610000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["2.63885000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["44.6473889999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5688570000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.0922950000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["231.067686000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["45.7871519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8487999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["248.425181999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["127.060798000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["69.4171510000000058`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["4.31185500000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["30.6792979999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["249.297435999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["234.768046999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["431.790060999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["343.414178000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["175.623456000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["300.772554000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["306.069790000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["320.820387999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["126.126965000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["217.71740799999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["288.620356000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["297.292193999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["151.063846000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["30.5688570000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["3.70610000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["65.0285810000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["193.260167999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["255.948044000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["381.045632000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["350.423916999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["95.1259130000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["232.996736999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["294.322406`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["311.520267999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["260.706512999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["211.800473`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["382.590202999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["304.541170000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["99.5987769999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["139.835083999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["167.628127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["242.184082999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["45.7871519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.695935999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.528823000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["204.258039999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["390876.57189999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.423590109800000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "50", ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.313208220199999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.113829994499999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.185603528100000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["23.6380704299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0840838513499999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.19694939199999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0899784055800000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["0.126131372699999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "2", ",", "3", ",", "4", ",", 
                    "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.156686999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.29324200000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.97601899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.159782000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.200141999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.239589000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.22952800000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.207257999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.607340999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.35041399999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.817900999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["3.37563799999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.09087500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["3.45013600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.11908999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["4.66385999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["6.37307600000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["6.05623799999999956`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["39.7156189999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.09571299999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["3.89178399999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["25.5625120000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8166039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.0575369999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2009749999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.188700999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.942433000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["30.8696659999999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["139.06652399999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.418521999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["44.1228320000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["238.849985000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["239.122893999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.2090779999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["278.587081000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["278.759652000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.6317879999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["303.286976999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["307.954882999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["585.120970000000095`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.06652399999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.114152999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["5.97031799999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["195.521737999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["195.589231000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["8.46020099999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["238.849985000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["238.886429999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["4.5682999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["278.587081000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["278.792295000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.7235909999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["135.938230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["136.059914999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["15.2532060000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["173.308672999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["173.247473000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["7.67145600000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["237.139553000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["237.138581999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.121674000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["269.884356000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["270.039044999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["19.3902350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.09571299999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["3.59473799999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.3985619999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8166039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.2983950000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1962019999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.188700999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.894659999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["18.4289950000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["135.938230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["135.565775999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["23.3434719999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["139.06652399999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.410886999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.5829309999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["238.849985000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["239.13864199999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["18.0915099999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["278.587081000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["278.878822000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["18.2848709999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["303.286976999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["314.094123000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["677.336663000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.06652399999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.521952999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["28.5439830000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["195.521737999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["195.656859`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["8.46870400000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["238.849985000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["239.178564000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["20.5936260000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["278.587081000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["279.050565999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.0488720000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["6.37307600000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["5.83293000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.8535969999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.192970999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.956216999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["14.8385090000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["135.938230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["135.853725999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["5.29625900000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["163.160347999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["163.767749000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.0688109999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.09571299999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["77.8166039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.188700999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["174.997389999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["340.813246999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["372.430190999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["456.326453000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["541.311783000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["315.464446000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["406.653442999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["457.977287000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["495.079626000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["195.521737999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["334.123414000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["434.551792999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["444.902640000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["6.37307600000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["120.192970999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["163.160347999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["228.689081000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["307.93104200000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["345.515633999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["429.61756400000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["523.83670500000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["173.308672999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["430.359133999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["426.25597699999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["476.222574999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["351.687430999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["428.471418999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["450.22593999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["440.387415999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.06652399999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["238.849985000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["278.587081000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["303.286976999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["135.938230000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["237.139553000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["269.884356000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["358.266582000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"5", ",", "104", ",", 
                    StyleBox["46.0576921500000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.03543208500000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.01009462799999916`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.579979605200000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0645369576300000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.226042892099999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["163.225527999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.158232671800000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["68.9796439699999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.490420271099999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.191060518000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.182797999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.09166500000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.25644500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.139010999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.229259999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.254755999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.47699800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.527773000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.598018000000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.630943999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.761383000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.758600999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.02774100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02968900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.12558500000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.849926999999999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7175130000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11310799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.8775979999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.9293799999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.2131400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.3399409999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3714919999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.73916700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.4001750000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3481430000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.21898299999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["21.1819950000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2105429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.668803000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.2438779999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.2825169999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.905210999999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.757052999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7971480000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.93933099999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.6450420000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6469000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0435400000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["21.1819950000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2044690000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.526506999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1734809999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1997360000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.615073999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.2438779999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.2734000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.691632000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.757052999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7680739999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.258191000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.4001750000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4286480000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.667050000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.6741310000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6652899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.207123999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.3553649999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3810750000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.602323000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4477759999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4597760000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.281146000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7650649999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11356900000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.8775979999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.9636870000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00842600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.4001750000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3011370000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.16011200000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.7424589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8540769999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30747499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.1819950000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2214219999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.461841999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.2438779999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.2948740000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.597358999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.757052999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8040859999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.550930999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.1153509999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.2338790000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38841499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.1819950000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.244689000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.734379999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1734809999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2260160000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.615381`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.2438779999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.3289829999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.996907999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.757052999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.811757`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.640788000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.3399409999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4201349999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.939370999999999867`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.4001750000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.453990000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.630383000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1816310000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1957700000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.165629000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1262970000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1291569999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0335119999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.8775979999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7424589999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4324110000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.835721000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2488019999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.4817009999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6872260000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.4179469999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.4160579999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.9703430000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.646236000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.1734809999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8760470000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.83596`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.143456000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.3399409999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1816310000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1262970000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.343667000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6450420000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.093605999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.3650140000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.7495389999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6741310000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.316354000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.2138400000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.8063820000000063`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1153509999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.4809329999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.8642379999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4482179999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1819950000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.2438779999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.757052999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5890320000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4001750000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3553649999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4477759999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.3490389999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "20", ",", 
                    StyleBox["50.161928910000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.968120162499999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.6733427599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.633209631299999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00404870463200000063`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.22951899`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["50.3103044200000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.134505871899999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["12.6253880699999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.733660211000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.240882091599999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.214219999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07186399999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.09902100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.123045000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.236897000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.245294999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.79970600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.77927199999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.635453000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.604825999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.79782099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.714827000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.06974499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.951532000000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.17664499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.80606599999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7186069999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27839799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.5754469999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6018129999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.693437999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.6210939999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6703769999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.29617599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1047399999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0521190000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.3839570000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["22.4337570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4607640000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.710304000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1260020000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1561489999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.792891000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.9867989999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.028478999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09620199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["56.7046440000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7060129999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0360089999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["22.4337570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4577409999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.630812000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5027970000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.528309000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.670977000000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1260020000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1506729999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.648869999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.9867989999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.999778999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.341364`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1047399999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1333349999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.752071999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.294730000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.2840869999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.279911999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.4849360000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.492426`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.196988999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5429119999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5730070000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.79152199999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7672399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27872499999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.6210939999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6983829999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01637400000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.1047399999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0181320000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.13891800000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.4840639999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5646520000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05975899999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.4337570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4747689999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.539328999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1260020000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1709429999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.590991999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.9867989999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.029659999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.563630999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.1026179999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1108390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.108103999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.4337570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4947799999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.802479000000000119`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.5027970000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.5538479999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.671332999999999913`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1260020000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1904929999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.848072999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.9867989999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.0529590000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.870009999999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.5754469999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6494280000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.972865999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.1047399999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1459130000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.541440999999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.6260230000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5847630000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.542581000000000024`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.8014139999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.801485999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.000940000000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->3], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6210939999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4840639999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1094920000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9022659999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.6002399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.2835059999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.9041570000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0053109999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.451205999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.3568580000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.853275999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.5027970000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.9130389999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.2575929999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.6532490000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5754469999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6260230000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.8014139999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6697410000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7046440000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5094409999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.5144260000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.2414489999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.294730000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3801480000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.6422139999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.5005660000000133`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1026179999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.4574870000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.9143439999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0170690000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.4337570000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1260020000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9867989999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9008919999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1047399999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5429119999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4849360000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0733639999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "12", ",", 
                    StyleBox["52.2710088899999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.970198971800000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.99791387999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.751079922799999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0360283326799999947`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.221699867500000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["23.3606048199999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.163364345399999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.34351958199999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.833181888200000031`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.262539019699999975`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.24867300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.04314799999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.921968999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.188816000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.119470999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.138535999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.10713799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.06148500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.662233999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.738677000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.875794999999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.897741000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.18845599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24802999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.221225`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02323199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7129499999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19586900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.0605820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0910580000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.848549000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6442599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6746729999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.846802999999999883`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9047410000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0605970000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.33952199999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.9479539999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9680449999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.559394999999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2384910000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2618059999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.64917599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4871079999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5238159999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02206700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["55.5468299999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5448699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0545939999999999958`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["21.9479539999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9719029999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.666803999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.991681999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0165670000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.692880000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2384910000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.253779999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.425702000000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4871079999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5023070000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.423186999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9047410000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9300369999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.704323000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1097139999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0985099999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.31196299999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.9484769999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9558999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.206661000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.9996340000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.0252939999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.714444999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7559299999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.19628099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.6442599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.7032050000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.820608999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9047410000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9416399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.513688000000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.723060000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6975489999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.355150999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.9479539999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9809289999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.459065999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2384910000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2741150000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.495950999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4871079999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.5198109999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.455276999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.6171300000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6601519999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.59893799999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.9479539999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.0030869999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.767526999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.991681999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0414740000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.693181000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.2384910000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2799589999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.577308999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4871079999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.557758999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.983558999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.0605820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.1233649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.874029999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9047410000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.0428810000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.92313000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.803246999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7672680000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.500886999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["33.2553579999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1990190000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.784323999999999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6442599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3427599999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.723060000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.3208420000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1487129999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7130719999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.5855679999999878`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.8819129999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.6690899999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.5287580000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["108.813318999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.991681999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5383499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.6940660000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.821548000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0605820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2553579999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.803246999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.1572299999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5468299999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.4924789999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7733659999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.016249000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1097139999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.0626539999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.2023590000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.2377510000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6171300000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.9886300000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.8171229999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.0699999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9479539999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.2384910000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4871079999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5342869999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9047410000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.9996340000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9484769999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.7287180000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["143.015427100000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.93897671460000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.77881410799999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.890567972799999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0124820508100000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.216315018699999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["23.6380704299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.175211056700000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.19694939199999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.107161717299999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0156203481699999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.270786999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.04045199999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.724061999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.195313999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.104925000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.122290999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.12954599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.21635399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.680745000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.759229999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.895761000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.921096999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.23954300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.28008699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24529599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.05476600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7150300000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.32254000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.1654369999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1923810000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.791317999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.7848449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8110070000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.768359000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.7396620000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4127020000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.7670910000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.865329`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8818860000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.486277999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.598623000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6182909999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.57764899999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2384810000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2729720000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01301400000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.0227539999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.093398999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.07482299999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.865329`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8917230000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.775182999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.8173739999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8456219999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.829635999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.598623000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6085299999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.290985000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2384810000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2543360000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.465683999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.7396620000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7642449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.721979000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6020389999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5916959999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.303785000000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.6621359999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.6818799999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.579896999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1921769999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.2032350000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.324777000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7600840000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.32287200000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.7848449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.8361`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.752669999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.7396620000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7361770000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0511850000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["31.4035850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4222979999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.274797000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.865329`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.8958419999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448085999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.598623000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6304040000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.466699000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2384810000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2641339999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.376717000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["59.6261819999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6851060000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.865301000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.865329`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.9207299999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.813560000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.8173739999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8738879999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.829908999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.598623000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6260010000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.402045999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2384810000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.313019999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0946119999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.1654369999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.2205419999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.809212000000000131`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.7396620000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7491029999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.138630999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.3822649999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3507129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.463338000000000072`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.8103049999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8888790000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.15384599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.7848449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.4035850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.356195999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.2444949999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.869551000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.2640220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.6395709999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.8740929999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.0331379999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.449391000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["124.569182999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.8173739999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1523540000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.2826699999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.8165329999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1654369999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8103049999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3822649999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.7859960000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0227539999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9036040000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.7243889999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.3982189999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6020389999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.6153189999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.5732680000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.679659000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["59.6261819999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5482509999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.0469210000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.3865239999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.865329`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.598623000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2384810000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.1651289999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7396620000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.6621359999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1921769999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.8765550000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["40.2772940000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.92974794100000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["6.23172816900000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.04769170700000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0150989630599999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.224672899699999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["23.6380704299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.200010580299999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.19694939199999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.11183801499999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.054196919500000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.293279999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.979682999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.39067400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.201078000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0928519999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.109139999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.23978900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.415395`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.703933999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.739114000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.920426999999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.911378000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.29284700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.28773399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27758299999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.029671`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.714493`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30106499999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7457999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7727139999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.787034000000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.7948869999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8302629999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03448500000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.9612020000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9682700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.20669599999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.8732210000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.8864189999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.385955000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.7810309999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.7973610000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.477529999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2897139999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3278350000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11475400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["55.5471380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5378020000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.273023999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.8732210000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.8996479999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.772782999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.3420700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.3710420000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.847211000000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.7810309999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.7878640000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.199817`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2897139999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3436789999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.57805499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.1165039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1385200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.643808000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.3752920000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3662769999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.263622999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.6733219999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6879190000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.426869999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.4916479999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5025840000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.319822000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7590029999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.30132500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7457999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7990800000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.779016000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9612020000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9753949999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.207513000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1165039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.0979139999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.271799999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.8732210000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.8998550000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.389423999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.7810309999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.808391999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.400060999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2897139999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3465740000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.831354999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.9187699999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9389330000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.294810999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.8732210000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.9258390000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.769341000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.3420700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.4000290000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.847428999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.7810309999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8000779999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.278498000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.2897139999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4184809999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.88272100000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.7948869999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8661990000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04267799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.3383029999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3905090000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.763310000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.1165039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1179680000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0214009999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["32.6117219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5953700000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.239087000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7457999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9612020000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5961860000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.4890440000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5295700000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.665820999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.7948840000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8547250000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.9102489999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.0098080000000138`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["120.840951000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.3420700000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9846950000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9485959999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.7278479999999927`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.7948869999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3383029999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6117219999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.9856070000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5471380000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8967839999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0262349999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.0711510000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3752920000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.4308850000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5138639999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.921598999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["56.9187699999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8583840000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.032392000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.781481999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["20.8732210000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.7810309999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.2897139999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4397269999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1165039999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6733219999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4916479999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.0214330000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["37.8249039299999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.890923784099999949`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.42136690199999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.26857550699999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0604551469799999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.161575117299999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["43.2116749099999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.265278228200000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["14.5900107300000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.661644888200000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.590550204799999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.311342000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.833187999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.179739000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.180787999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.122876000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.136561999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.30336499999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.63508199999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.720956999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.73252600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.858847999999999878`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.881476999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.22466399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.21274900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2982579999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.01200200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7063640000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1632070000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.2157320000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2427189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.863244000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7477130000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7564789999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.280401999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0651769999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0964230000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.999492000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.1857399999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.1955470000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.313701999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6054199999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6210480000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.499922999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.4912550000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4994439999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.261946000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.6552309999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.6359940000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.615334999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.1857399999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2152869999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.945150000000000112`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4283250000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4622180000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0841559999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.6054199999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6025189999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0927979999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["54.4912550000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4875189999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.119531999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.059185999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.078297`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.611324999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.8287300000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8194749999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.296057000000000023`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["51.5625990000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5701729999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.242269000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.5887299999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.6059509999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.550865000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7427299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16324699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.2157320000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2695170000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.860233000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.7477130000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7652070000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.279802000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8767799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8671249999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.154422000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["22.1857399999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2090869999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.373423999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.6054199999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6245109999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.305347999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.4912550000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4769099999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.229441000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["58.7505629999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.7853780000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.556834999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.1857399999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.2410940000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.885333999999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4283250000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4961180000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.08427600000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["45.6054199999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6119319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.104163000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.4912550000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5135259999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.356200000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.0651769999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1273769999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.994828000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.2198939999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.300319`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28631099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.8915650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8809060000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.170479000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["32.059185999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.0619459999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0441420000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2157320000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7477130000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8767799999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.4530610000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.3115500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.3487209999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.3289160000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5186289999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7906629999999879`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["115.884867000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["126.362463999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["35.4283250000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5438400000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.5073670000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.361512999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0651769999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2198939999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8915650000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.7881469999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.6552309999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.4367830000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.9334639999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6889440000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8287300000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.4436679999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.6381010000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.283331000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["58.7505629999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8876180000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.5452949999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.513905999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["22.1857399999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.6054199999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.3752089999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.4912550000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.059185999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5625990000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5887299999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4030590000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "95", ",", 
                    StyleBox["38.1344127099999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.846336021000000116`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["6.84592304299999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.54888223800000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0390758307599999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.195159003899999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["67.4195991099999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.361613915499999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["24.7383417999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["1.08382846599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.77243019059999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.295542000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.68301500000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.853220999999999918`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.173668999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.129882000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.154803999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.0078269999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.57467200000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.729299999999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.734631999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.844993999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.873985000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.2099740000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.18753599999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30082499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.01453900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.711732`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.3509580000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.7326919999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7426139999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.321180000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.6100629999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6424270000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04769899999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.5111360000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5486699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.21505400000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.3901249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4004909999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.335576000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.5643480000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5793160000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.484536000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.6486850000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6753209999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.862283000000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.6801809999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6590730000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.683319000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.3901249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4232240000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.07151200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["38.5093910000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5527019999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40207199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["47.5643480000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5614599999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0934890000000000043`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["55.6486850000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6732099999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.793932999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.7537980000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7753560000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.697900999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.7989120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.7895030000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.304591000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["54.876516000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8817090000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.168123000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.0396390000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0639739999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.787784000000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7534659999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35099100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.7326919999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7525290000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.321082`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.5111360000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5858899999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.20996199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.1674640000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1920420000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.39782099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.3901249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.4143420000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.391979000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.5643480000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.584439000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325191999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.6486850000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6574809999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.142379999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.8062230000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.8405670000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555893000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.3901249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.452837999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.01508200000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["38.5093910000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.5960079999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.4019919999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["47.5643480000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5685979999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0687900000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["55.6486850000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7403400000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.48353599999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.6100629999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6726610000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0132239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.224505999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.3086249999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36155800000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.6813939999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6588360000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.365122999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.7537980000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7696910000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.257255000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.5111360000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.7326919999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1674640000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4424750000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.0040180000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.0987389999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.166595000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0219870000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.3976640000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["136.713550000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["130.506711999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["38.5093910000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.9683169999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.9043379999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.5246630000000109`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6813939999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6100629999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.224505999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.2297530000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.6801809999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.8690459999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.3226729999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.7676620000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.7989120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.3070569999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.6718359999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["131.251136999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["61.8062230000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.0705470000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6399040000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.480804999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["23.3901249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.5643480000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0754920000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6486850000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.7537980000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.876516000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0396390000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.7439679999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["206.23621019999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.99133147810000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["3.71999055499999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.57903020699999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.108368478600000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.252936382499999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["23.6380704299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.283874050899999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["6.19694939199999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.127651647700000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.184649633699999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.383054999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.334335000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.73994500000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.21530499999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0656319999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0799439999999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["3.30366299999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.51261299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.813490999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.526618999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.03227200000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.773857000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.44296700000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.2362820000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.44783699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.742118000000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7061829999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.824941000000000101`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.898165999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.9013570000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0727369999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["21.4256109999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4574920000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.72686799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.6312179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6266020000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.105241000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["15.0424220000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.0476739999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.119731999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.0867980000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1161689999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.669641000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6156519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5966069999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.434203999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["37.0990200000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.1093640000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.235830000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["15.0424220000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.0608219999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.419512000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.9258440000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9456679999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.451973999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.0867980000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1426140000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.272567`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.6156519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5832649999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.738403999999999971`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.0875490000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0986809999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.253800000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.2377919999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2328130000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.113529999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.3566840000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3644269999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.176536999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.9468990000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.9463950000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0115040000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7423970000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.825304999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.898165999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.9044339999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0714540000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["22.6312179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6209209999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.117383999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.0875490000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0929870000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0619819999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["15.0424220000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.0551729999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.145359999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.0867980000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1327309999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.523615999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6156519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5867179999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.32983699999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["37.0990200000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.0979000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.012770999999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["15.0424220000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.0769660000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.393791000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.9258440000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9654990000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.452055999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.0867980000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2173129999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.48782999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.6156519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5356889999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.91154799999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.4256109999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4886329999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.718435999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.7985119999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.8126870000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.161586000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.0875490000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0715669999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.182200000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.2686330000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.263736999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0558140000000000036`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.898165999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.6312179999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0169889999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.7920810000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0345620000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.3946230000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8035000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.4698119999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.9132919999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.2419649999999897`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.5848560000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.9258440000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.3983630000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.6274050000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8465019999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.4256109999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.7985119999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2686330000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.012475000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.2550700000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.8208970000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.2016200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.0396399999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2377919999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.8369659999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8095130000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.8827730000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.9228939999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.5110179999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.261772999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.4332140000000102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.0424220000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0867980000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6156519999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.0990200000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.0875490000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.3566840000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.9468990000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.7660000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj7*.out; small basis, n=(2,0) can be tachyonic, \
lattice spacing fixed to 1+2 m (chi^2 criterion error=0.1)\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 42 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nIncludes 1 nonstandard fit criteria \
(such as a \\n specific lattice spacing).\\nParity doublets (o,multi,state) \
with error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), \
error 0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, \
4,0), error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# \
states, multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 \
2 2)\\n  (4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 \
2)\\n  (4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( \
0.25 0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, \
11 & 12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, \
14 & 13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 \
2).\\nOrdinary spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  \
(-1,  3)  ( 1,  4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( \
1,  7)  (-1,  7) .\\nAll spectra extrapolated using (K,p) = (12/2,8)  \
(12/2,6) \\n  (14/2,6)  (18/2,6) .\\nWinding potential using (n,K,p) = ( 2 \
0,14/2,6)  ( 2 0,14/2,4) \\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( \
3 0,23/2,5) \\n  ( 4 0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of \
winding using (n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  \
with error 1; in G^2 N units.\\nHeavy potential determined using \
(n,K,p,K_max) =\\n  ( 0 0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \
\\n  ( 0 0,-32/2,2,3)  ( 0 0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 \
0,-60/2,2,4.5) ,\\n L = 3 4 6 (all in G^2 N units); relative scale error=0.1.\
\\nRoundness determined using (n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( 1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \\n L=0 and error 0.1;\\n  ( 1 \
0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 \
0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error \
0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 \
0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \
\\n L=5 and error 0.1;\\n  ( 1 1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 \
1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \
\\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error 0.1; all in G^2 N \
units.\\np-extrapolation using n=( 1 0) and (K,p) = (13/2,3) \\n  (21/2,3)  \
(45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) .\\nResult format:\\n \
Fit info, # steps, chi^2, and p damping, scale G^2 N/sigma.\\n The 10 \
couplings  (G^2 N units);\\n   which couplings -- if any -- were fit.\\n \
Winding potential and heavy souce potential fits.\\n Roundness of winding \
potential, 1 values, and roundness of\\n   heavy source potential, 4 values, \
(G^2 N units)\\n   showing measured value and derived value for each.\\n The \
rescaled spectrum for each P_perp*a and c^2 values.\\n Finally come the \
states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "28", ",", 
                    StyleBox["403488.413000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.25`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->2]}], ",", "50", ",", "0", ",", "1", 
                    ",", 
                    StyleBox["0.468735683500000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.119993746899999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.319386631099999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["21576.3235399999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.157107416199999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1469.129401`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.0737792960000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["76.7665317099999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.00720400000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    RowBox[{"-", 
                      StyleBox["2.15798099999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["3.59821200000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0372279999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.0614079999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.110963000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.09917400000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.6505749999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.428596999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.245541000000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["23.4310240000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["0.267298999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["43.0668300000000048`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["0.322475000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.664283999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.303322000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["86.7919900000000055`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["86.2803940000000046`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["2.94827399999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["77.7383090000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["77.2697349999999971`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["2.70034200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["66.4285260000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["65.9104489999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["2.98562700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["12.8266009999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["38.4544830000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["147.690830999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["57.331947999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9195300000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.38617599999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["90.2382010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.6552850000000098`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.40361100000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["114.462462000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.528182000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["63.0131230000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["121.974433000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["122.463834999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["2.82037000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["37.9659679999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.0739269999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.38504900000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.331947999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4816770000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["62.5289859999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["81.850586000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.6246790000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["145.374290999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["90.2382010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.3798420000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.81626100000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.9879129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.3672080000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.18583600000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["82.0990809999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.1939889999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.546947999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["103.264569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["103.246411999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.10464199999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["106.13905400000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.565792000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["9.06654999999999944`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["77.7383090000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["76.7728089999999951`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["2.78203699999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["66.4285260000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["65.3954169999999912`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["2.97685099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["12.8266009999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["21.3928450000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["24.6831880000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["22.9879129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["16.182741`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["112.868211999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["57.331947999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6672509999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["30.7297719999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["90.2382010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.9969909999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["92.9013750000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["114.462462000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["90.5180069999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["68.99470599999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["121.974433000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["157.506547000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["102.383946000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.9659679999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.0831569999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.10057000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.331947999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5325780000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.30334199999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["81.850586000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.0755539999999896`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.5812669999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.2382010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.168726999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.2586420000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["86.7919900000000055`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["85.7927789999999923`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["2.87917600000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9879129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["37.331291000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["173.806662999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["24.1326790000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.5172069999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["119.247372999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["65.1241030000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.4870839999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.9119790000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["77.7383090000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["66.4285260000000032`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["12.8266009999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["25.9541019999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["199.959666999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["114.462462000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["271.461918000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["395.790921000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["174.382333999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["217.353039999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["387.295577999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["381.605680000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.9659679999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.850586000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["309.735482000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["136.342329000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["86.7919900000000055`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["24.1326790000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.4154119999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1241030000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["156.506473000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["206.281090000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["246.194018000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["237.715589999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["82.0990809999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["172.896420000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["279.643689999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["280.17787399999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["140.19342700000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["210.928718999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["256.776300999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["305.850112000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["57.331947999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.2382010000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["121.974433000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["240.565538000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["22.9879129999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.264569999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["106.13905400000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["216.872165000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["96897.8669000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.477055653499999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "50", ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.475552809099999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0278352853499999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.234874033600000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["60.1183962300000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107989452099999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["21.3859734999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00488134800000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.724052629999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.0964279999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["1.41595699999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.9634409999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0426790000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.216661999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.114020999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0119530000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.399100999999999963`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.519699000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.871974999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.566024999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.88060299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.793630999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.905841000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.912976000000000098`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14860699999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["1.20914600000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.843567999999999962`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.2015810000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.5622480000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.00730800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.3330950000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["9.38311099999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["9.62362899999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["18.5542289999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.9318270000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.7004380000000089`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["17.8499070000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["97.231790999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.5306300000000092`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0531609999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["180.155021000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["180.509798000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["27.3683839999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["205.568509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["205.834830000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["20.5446190000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["242.87352499999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["242.905179999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["2.44196200000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["97.231790999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.3479910000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["8.96396299999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["104.072545000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.365661999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["22.6117489999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["180.155021000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["180.356286000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["15.5260940000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["205.568509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["201.00762900000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["351.838220999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["93.1897850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.4572460000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6325760000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["142.453700999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["142.460748999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.54371400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["217.040000999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["217.042323999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.179214000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["217.631011000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["217.772634999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["10.9252729999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.20914600000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.478162999999999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.1949530000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.5622480000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["5.26294000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.0266209999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.1897850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.7766480000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["15.9352409999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["126.624318999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["126.714056000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["3.4612750000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["97.231790999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.7253299999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.0364070000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["180.155021000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["180.515403999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["13.900418000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["205.568509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["201.004692000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["176.032374000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["263.655104000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["258.434181000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["201.377760000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["97.231790999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.5726930000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.1490229999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.072545000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.656437000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["22.5214399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["180.155021000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["180.905584000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["28.9501920000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["205.568509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["205.83508199999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["10.2820129999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["9.38311099999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["10.0537379999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.8669480000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.9318270000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.5562039999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["14.4882510000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["93.1897850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.4246940000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["9.06073100000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["174.213291999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["175.035079999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.6974290000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.20914600000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["4.5622480000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["126.624318999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["144.939124999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["300.772408000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["263.655104000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["436.33729799999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["483.717817000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["310.555648000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["295.454879999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["459.604622999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["507.707295999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["104.072545000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["227.265874999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["369.556994999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["367.644438999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["9.38311099999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["89.9318270000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["221.463103999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["174.213291999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["242.87352499999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["302.484317999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["370.450639000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["406.553514999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["142.453700999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["322.654849000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["372.171891000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["428.758227999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["286.704217000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["290.676538999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["370.769493000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["411.316223999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["97.231790999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["180.155021000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["205.568509999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["356.535686000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["93.1897850000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["217.631011000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["217.040000999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["267.480617000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["267.360564800000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.017776644`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["13.9544127600000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.554158971400000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.08680046582000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.218698297499999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["510.577044400000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.217091111600000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["173.353321000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.888173355700000044`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.654802023400000088`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.132132000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.16385300000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.57747499999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0852720000000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.267708999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.251186000000000042`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.11023899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0903840000000000109`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.547641000000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.650724999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.619155000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.705508000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.858002999999999893`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.839789999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.06930600000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.844392000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7625229999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.72954199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.5398400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.603714`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.88434699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.1587509999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.2212770000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.84458400000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.8145310000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.7367579999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.29439100000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.049751999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1102849999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.78578499999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.1257719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2162720000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.66983900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["75.4016639999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.463161000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.81424999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["86.7411230000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7516870000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.311634999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.049751999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.07824`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.840413000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.8899109999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9377410000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41103399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.1257719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1886159999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.85397099999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["75.4016639999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4121350000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.30891099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.8145310000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.8646219999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.47774500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["52.7485969999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7357470000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.379099999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["76.6900859999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.7113959999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.628652999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["81.0992729999999895`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.3279100000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.74505700000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.855339000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.73385500000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["23.1587509999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.282455999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.82471999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.8145310000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.7091730000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.55408799999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["48.7190269999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.852840000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.973808`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.049751999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1108040000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.900544000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.1257719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2398270000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.68236399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["75.4016639999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.478082999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.12723299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["87.5393910000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.2478599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.30023599999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.049751999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1669919999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.72934499999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.8899109999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9855879999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.41128699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["65.1257719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.3181419999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.83755200000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["75.4016639999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4668700000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.961824999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.5398400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6685909999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.89914399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.8145310000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.863715999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.725500000000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.1163350000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.0939810000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.329739999999999966`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.233970999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5168899999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.17320699999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1587509999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7190269999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9736219999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.3158139999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.188887000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["132.483332999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["164.29601299999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["84.1558449999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["136.28031100000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["166.371035000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["179.271620000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["44.8899109999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.5304639999999913`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["122.819428000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["137.511866000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["19.5398400000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.1163350000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.233970999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.4473900000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7411230000000088`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.0088439999999891`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["138.517745999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.220093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["52.7485969999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["122.076454999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["142.980349999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["133.037611999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["87.5393910000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["127.830547999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["136.243261999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["108.118749000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.049751999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1257719999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4016639999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.831056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["41.8145310000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.6900859999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.2885409999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.0992729999999895`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "21", ",", 
                    StyleBox["41.0032999700000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.997723938699999912`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.3595808869999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.568956826299999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0458799754200000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.225016749399999982`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["78.5430496400000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.139597601900000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["32.1155985899999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.570317805200000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.223741162800000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.185045999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08891099999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.23619699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.128781999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.243420000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.263338999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.46525100000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.545981000000000094`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.602188999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.63329500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.760001999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.747314999999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.02565400000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.993812999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.124676`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.846567999999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7202389999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.24344999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.0830809999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.1368549999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.33093299999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.4402170000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4775929999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.925085999999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2376550000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1827439999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.35907500000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["22.3336599999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3642990000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.758333000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1496840000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1885839999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.962786000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.6838989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7271690000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.07094500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.7547560000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7571630000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0595769999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["22.3336599999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3580840000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.604490000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.337909999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.365183`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.675037999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1496840000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1795679999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.739627000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.6838989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6962020000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.304499999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.2376550000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2680210000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.751592999999999911`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.9040880000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.8944789999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.237813000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["53.2331500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2439719999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.267857000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.3809440000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.4105459999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.732651999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7705160000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.24390500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.0830809999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.1732410000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11576000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.2376550000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1388040000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.22330000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["32.9732359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.0766479999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.27974900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.3336599999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3781590000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.550682000000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1496840000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.201825000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.645253999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.6838989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7337069999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.616379000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.3148400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.444746000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.60762900000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.3336599999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3993649999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.813105999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.337909999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3924860000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.675397000000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1496840000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.2348740000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.05424099999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["50.6838989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.744851999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.754307999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.4402170000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.5317849999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13317500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.2376550000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2888090000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.63305100000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.0387819999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0811539999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.524370000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.0722620000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.1126599999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.499936000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.0830809999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9732359999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6459010000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8675219999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.8458219999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.361750999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.0261550000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6867789999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.0184469999999912`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.015214999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.985691999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.337909999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.3006120000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.8328280000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.5651890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.4402170000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.0387819999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.0722620000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.1501430000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.7547560000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.9716320000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.6367539999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.6346099999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.9040880000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1256470000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.4932430000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.038923000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3148400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.3730599999999881`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.2477970000000091`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.123822999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.3336599999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1496840000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.6838989999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.3316509999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2376550000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.3809440000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2331500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.3510550000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "57", ",", 
                    StyleBox["40.3296696199999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.985402906399999878`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.53767080200000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.654345616600000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0050417508169999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.226941505899999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["90.1215974499999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.153060514999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["36.8752543100000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.489956593800000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.205494641499999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.210445999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08415900000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.12660399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.149082999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.207873999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.232330000000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.75383099999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.740237000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.629856999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.656196000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.797855999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.789556000000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.07123900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.07596699999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17257999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.889405999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7157420000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16094199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.9935949999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.039522999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16567799999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.2087290000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2434310000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.88076799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.4581410000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4485770000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.242729999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.724774`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.7506360000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.656378000000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9424370000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9735269999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.789066000000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7905929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8309049999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02315599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["55.5943490000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5946089999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0065940000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->4], ",", 
                    StyleBox["21.724774`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.7482630000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.596161000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8096220000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8357029999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.661964000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9424370000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9668909999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.620655999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7905929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8039730000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.339592999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.4581410000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4862919999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.714488000000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.4492059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.4388870000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.261898000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.2974239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3083100000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.276285000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.389944999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.4164109999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.671720000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7615159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16135100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.9935949999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.072814000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.00530499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.4581410000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3725449999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08623099999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["31.7994300000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8827539999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0573920000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["21.724774`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.7629699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.484712999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9424370000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9872509999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.568698999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7905929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8326810000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.534105999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["60.6152950000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6247320000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.119748999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.724774`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.785334999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.768530999999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.8096220000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8618099999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.662286000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9424370000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0085080000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.838457000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.7905929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8554639999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.823227999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["17.2087290000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2902440000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03444800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.4581410000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.5766129999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.50342799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.1721840000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.2303860000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738592000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.8077499999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.7519539999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.708065000000000033`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.9935949999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7994300000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.1882499999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.1765879999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1562229999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.2469659999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0762060000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.5469939999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.0508539999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.6330950000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.079598`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.8096220000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.5084820000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.0418700000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.3192889999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2087290000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8077499999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.1721840000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.4807560000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5943490000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.8107200000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.0463369999999905`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.058636000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.4492059999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.015197999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.095675000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.080410999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.6152950000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.0372049999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1608999999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3036759999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.724774`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9424370000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.7905929999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5637020000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4581410000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.389944999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.2974239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6427719999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["347.730585000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02495526199999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.27178183499999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.751211157600000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00666773069400000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.220837103499999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.167042370599999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.595789175400000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.231790235500000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.247063999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.03586700000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.910346999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.151790000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.195265000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.216351000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.1265489999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.0544389999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.659658999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.599056999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.831596000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.74768100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.12189500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.05292600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.22404299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.81538699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7077019999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.934727999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.7429419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.7685899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.635866000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.9313949999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.9624389999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.769661999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4348180000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5016669999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.4984010000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.435572999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0278019999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.52659400000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9992069999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818517000000000116`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.5487149999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5477160000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.024780000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.5017479999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.518558999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7995939999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8220109999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555756000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0214429999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.368937000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9797449999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.336014999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0654320000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.551149999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.6681519999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6590449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.225776999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.0434270000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0520720000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.214340000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5876339999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6086570000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.521222999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7454350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.935107999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.9313949999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.9895040000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.720330000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3895449999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.29336599999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.668792999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3361419999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.12362800000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.5084419999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.342257999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0394229999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.407353999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9962390000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.372466000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.8780410000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9773649999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23124499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.5302180000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.612202000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7995939999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8444460000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555992999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0458259999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.486723000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0288359999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.776545999999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.7429419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.7981459999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.684312999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0784890000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.437431000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.424951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3886709999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.449737000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.7732289999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8280930000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.68010299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.9313949999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.668792999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1927619999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1481989999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2031989999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3965390000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.5545059999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0060339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6722460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.330016000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.482189000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["28.7995939999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.330252999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.6496290000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.744335000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.7429419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7732289999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.424951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.5006649999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5487149999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4834099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.624244000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5527060000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6681519999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6316829999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.0212350000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.159205`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8780410000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.2161100000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.4753819999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6153340000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.996301000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5876339999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0434270000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8424410000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["167.275780300000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.99134323179999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.06977465800000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.889127118899999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00376119991699999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.213915616900000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.196328040900000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.405126245499999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.306990408799999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.270701999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01038099999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.687082000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.179084999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.140082000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.159640000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.24245500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24111900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.680378999999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.65508999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.847823999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.821767000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.16014799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17216300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.25467700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.90415700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.706773`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.966748999999999902`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.0463589999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0662219999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.522209999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3086130000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3354469999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.705447000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7154850000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3675700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6546599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.378959000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4578640000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.472473999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1323699999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.811731999999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.5917880000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1320369999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.2029239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6628480000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.594203999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9603730000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9850640000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.649113000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4492700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.246552999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1167260000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.400471000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0381940000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.56186499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2709680000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2618230000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.240420999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.8228829999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8340010000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.292283000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0746339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0918189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.451771999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7435729999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.967100999999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3086130000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3606310000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.683762999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9999360000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.221950000000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.7004880000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7307749999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.398118999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6651300000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.327096000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4682559999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.372833000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1262540000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325477000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.9089379999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9374200000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.37439`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6894099999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.646256000000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9603730000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0097720000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.649332000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4661990000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.345801000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1684439999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.880049999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.0463589999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0880340000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.547818999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0320450000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.200105999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.3562389999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3209909999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.463335000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.6729800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7614430000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16283399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3086130000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7004880000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.267852999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.3402099999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.5606999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.9219309999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.2633090000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0252549999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.2535699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7060249999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.312363000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.9603730000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5488020000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.031949999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.5915600000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0463589999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6729800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3562389999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.4059329999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5917880000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2343199999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5733589999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.2242380000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2709680000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.2383970000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3253380000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.3363710000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9089379999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4773659999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.9130729999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.1550739999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7351499999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0746339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8228829999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7756309999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "40", ",", 
                    StyleBox["36.3259149499999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.932424448799999971`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.30339489500000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.19340074600000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0831018770000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.231010109500000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["76.0759609599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.32893468819999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["24.0402123299999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.864278211200000079`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.55071314719999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.242486000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.0718510000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.535240999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.159254000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.149995999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.158668000000000013`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.56036200000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.934941000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.659962999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.678617000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.791931999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.811294999999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.11441300000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.10508800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.22440900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.928775000000000083`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.713295`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22677499999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.9464989999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9987570000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.48074400000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.2706920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.294024000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.661115999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.157452000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1907040000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.942201000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.6376040000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.6526780000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.427141999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.6350089999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6554780000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.579985999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0394709999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0678250000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.803409000000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.0423660000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0256279999999939`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.474258999999999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.6376040000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.6672550000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.840176999999999907`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.2276690000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2695289999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18610499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.6350089999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.641849999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.193827999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0394709999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0944059999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.55660599999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.8305319999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8565219999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.736442999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.5664469999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5583930000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.228196000000000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["54.1192959999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1460980000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.759461999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.9190729999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9308979999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.335043999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7566390000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22748699999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["26.9464989999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0317739999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.20816100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.157452000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.2235649999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.936674999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.8305319999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7597420000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.00293000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["21.6376040000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.6642940000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.378139000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.6350089999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.666660000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.448411000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0394709999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0996949999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.85322899999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["61.3925410000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.4180450000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.361331999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.6376040000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.7003909999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.889551999999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.2276690000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3113880000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.18610199999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.6350089999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6579819999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325469000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["54.0394709999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1464470000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.515606`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.2706920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3372449999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.942910000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.8305319999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.860737000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.427941000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.9923900000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0210480000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.40601199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.3254790000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2753459999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.710269999999999956`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9464989999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.157452000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.008307000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.2548180000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.9769859999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.8834489999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.3991440000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5041590000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["107.931810000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.75147999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["136.711972000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.2276690000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.3066899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.6407160000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.3077489999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.2706920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9923900000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.3254790000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.8242039999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.0423660000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3848090000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.4845370000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.0729029999999895`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.5664469999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0973739999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.9874860000000111`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["123.067652000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["61.3925410000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.9057090000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.9617309999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["119.455712000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.6376040000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6350089999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0394709999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7703089999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.8305319999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.9190729999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1192959999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.8839310000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["44.0946890100000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.905605287800000091`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.1519174190000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.27447359599999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0329003338499999964`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.19457651740000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.278154174500000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.127598811299999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.51710475339999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.30230699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.839088999999999884`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.157082999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.207810000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0840360000000000084`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.104829000000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.27759100000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.55973199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.718868999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.755955000000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.868346999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.933178000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.24771699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32114500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30028900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.0561879999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7072819999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10936300000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.5430470000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5744239999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.933681999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.6210790000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6313949999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.306967999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.6915619999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7183199999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.796224999999999916`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.088013000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0985399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.313261000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8124680000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.827215000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.438816000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1156880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1205539999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.144771`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.2371959999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.220920999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.484269000000000016`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.088013000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1156750000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.823142999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.9663910000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9991280000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.974126000000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8124680000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.813203000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0218690000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["52.1156880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1070250000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.257774999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.1409249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1610209999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.597987999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.9759939999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9669320000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.269649999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["49.9432760000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9522880000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.268164000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.3370120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3543460000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.515805999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7445760000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.10955000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.5430470000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.6053579999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.92708200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.6210790000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6416700000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.306357999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.6138770000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.5987450000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.225141999999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.088013000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.1105759999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.335704999999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8124680000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8338120000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.317546000000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1156880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.097882000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.264931000000000027`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.4559769999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4931759999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.553452000000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.088013000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.141829000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.800681999999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.9663910000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.0318729999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.974250999999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.8124680000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8222049999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.144865999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.1156880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1250929999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.139917999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.6915619999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7455600000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.803386000000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.3995039999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4762570000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14193300000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.6516510000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6223869999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.435397999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.1409249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1582209999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.257334999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.5430470000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6210790000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6138770000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.4590789999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4917600000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.2903479999999909`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.0186149999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.6886890000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.8721939999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.641873000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["124.509599000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.9663910000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.5098440000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.4267229999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.0242639999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.6915619999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3995039999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6516510000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8057069999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.2371959999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5167680000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.5363800000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6754900000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9759939999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4470589999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.0106149999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.251461999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["56.5803119999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.8970029999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4550409999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.099503999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.088013000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.8124680000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.4559769999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1156880000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.1409249999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.9432760000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.3370120000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.6806839999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "20", ",", 
                    StyleBox["84.7968385300000093`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.848735203900000101`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.26739369799999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.65327339099999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.125661509599999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.226188320099999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["810.289934300000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.421297143800000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["324.077461599999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.79762186000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.839078181999999905`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.254234000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.808605000000000018`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.695733000000000068`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.124665000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.143257999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.146631`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.2199549999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.13829599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.694693000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.627754000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.795669000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.719054999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.14647100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.932270000000000109`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.24391999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.853312000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7231070000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.78597099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.190928999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2164470000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.858155999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.9878860000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9893769999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0501460000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["39.2885020000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.3301820000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.40168200000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.2474700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2602610000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.430154999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9945900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0123420000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.59700299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.4271809999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4603079999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11405400000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["71.8523289999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8265509999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.866920999999999963`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["25.2474700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2870229999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.33016299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.1265400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.1879949999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.06668299999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.9945900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9919639999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0882959999999999922`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["62.4271809999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4569140000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.999914000000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.1679209999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1939410000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.875025000000000119`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.6366930000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.6286240000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.271361999999999969`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["61.8543459999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.8564859999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0719740000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["63.5025689999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.5399469999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25699800000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7762410000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.7864180000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.190928999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2418499999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.856234000000000072`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.2885020000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.3707649999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.38323200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["40.1679209999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1022310000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.10456799999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["25.2474700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.2777669999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.509438999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9945900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0197149999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.422475000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.4271809999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4381040000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.183673999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["68.9757179999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.0108120000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.590111000000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.2474700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.3218770000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25114600000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.1265400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.2494139999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.06608899999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.9945900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9999549999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0902250000000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["62.4271809999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5396319999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.89084000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.9878860000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9906149999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0458769999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["40.1679209999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1913710000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.394293000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.7296570000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.6986530000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.521314999999999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["43.8511209999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9087660000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.969280000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.2885020000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.190928999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.4431510000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.7869500000000115`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.5837300000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["114.665964999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["109.837576999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["70.2989400000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["123.147315999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["162.052410000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["161.104567000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["41.1265400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.1671259999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.6299910000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["116.950452000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["43.8511209999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.9878860000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.7296570000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.7033309999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8523289999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3946130000000085`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.621272999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["107.434169000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["44.6366930000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.447109000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["102.980141000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["165.477298999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["68.9757179999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.029745000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["95.3434150000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["136.270462000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["25.2474700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9945900000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.4615839999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.4271809999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.1679209999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.8543459999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.5025689999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4387179999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "19", ",", 
                    StyleBox["1330.83843000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.789975526800000071`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.09248054100000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.87177359599999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0204181373399999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.178031055599999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["189.894574400000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.423411899599999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["76.956857240000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.25569303999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["0.982740948100000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.289998999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.481085000000000029`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.80024699999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.173692000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.115755999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.136770999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.5194399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.613877`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.740934000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.841307000000000115`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.830433999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.96117600000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.17657100000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24716300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.28478399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.16403199999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7220169999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.95318699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.8294599999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.837792000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.312856000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.4726989999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4849849999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.461319999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.9833679999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6540469999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.7323049999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.249127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2590019999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.370791000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.1824150000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.2011570000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.703727999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.5795920000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6105299999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16166299999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["73.6306010000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.6056480000000057`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.936946000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["27.249127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.292364`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.62348500000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.9530030000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0148900000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.32382799999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.1824150000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.174784000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.286521999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["64.5795920000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.6635779999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.1535829999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.9497950000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9716679999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.821335999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["45.9902869999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.9812430000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.339569000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["61.9902409999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9927760000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.09517100000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["65.0788790000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1019620000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.866760999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7740169999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.95287000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.8294599999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8462320000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.314877999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["39.9833679999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.435098000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["8.48100400000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.6309919999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4953799999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.54605099999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["27.249127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.2787690000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.556512999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.1824150000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1996000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.322642000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.5795920000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7012749999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.284532`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["70.0826809999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.014182000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.28603500000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["27.249127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3257050000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.43769999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.9530030000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0767399999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.323102`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["53.1824150000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1879180000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.103320999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["64.5795920000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.7015999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.29063300000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.4726989999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4968829999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.454039000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["40.0732619999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.8010919999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6646479999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9497950000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.2214689999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["13.6739399999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["45.7831540000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8562950000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.37318399999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.6309919999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.8294599999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.9833679999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7590400000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["81.0786109999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["117.490950999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["112.628122000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["70.7661590000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["128.021330999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["170.26385300000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["159.875327999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["44.9530030000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7111679999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.1262160000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["121.867717000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["45.7831540000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.4726989999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["40.0732619999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.5520010000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.6306010000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.5228130000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.270934999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["110.947265999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["45.9902869999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.9492050000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.778112999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["163.433830999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["70.0826809999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.7873809999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.0758909999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["146.381845999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["27.249127999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.1824150000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.8693879999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5795920000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9497950000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.9902409999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.0788790000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.8242020000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["\<\
data three/ytraj8*.out; small basis, n=(2,0) can be tachyonic, no \
constraint on lattice spacing\
\>", "Section"],

Cell[BoxData[
    RowBox[{
      RowBox[{"data", "=", 
        RowBox[{"{", 
          RowBox[{
          "\"\<********* Eigenvalues for the 3+1 transverse lattice *********\
\\nCouplings:  m^2, G^2 N, beta, la_1, la_2, la_3, la_4,\\n             0     \
1      2     3     4     5     6  \\n           la_5, tau_1, tau_2   (2-9 \
divided by a^2) \\n             7      8      9                         \
\\nUse chi^2 fit with 41 criteria and tolerance 0.01.\\nOverall scale from \
fitting lowest state to lattice value.\\nParity doublets (o,multi,state) with \
error for difference\\n  over average.\\n  ( 1, 5,0) and ( 1, 6,0), error \
0.25\\n  (-1, 5,0) and (-1, 6,0), error 0.25\\n  ( 1, 7,0) and (-1, 4,0), \
error 0.25\\nSpectrum for P_perp a = (0,0), ( 0.25 0)\\n  using (# states, \
multiplet, o, c^2 error for each) =\\n  (4,  9 &  8,  1 & -1, 0.25 2 2 2)\\n  \
(4,  8 &  9,  1 & -1, 0.25 2 2 2)\\n  (4,  7 & 10,  1 & -1, 0.25 2 2 2)\\n  \
(4, 10 &  7,  1 & -1, 0.25 2 2 2)\\nSpectrum for P_perp a = (0,0), ( 0.25 \
0.25)\\n  using (# states, multiplet, o, c^2 error for each) =\\n  (4, 11 & \
12,  1 & -1, 0.25 2 2 2)\\n  (4, 12 & 11,  1 & -1, 0.25 2 2 2)\\n  (4, 14 & \
13,  1 & -1, 0.25 2 2 2)\\n  (4, 13 & 14,  1 & -1, 0.25 2 2 2).\\nOrdinary \
spectra multiplets, 4 states, (o,multiplet) = ( 1,  3) \\n  (-1,  3)  ( 1,  \
4)  (-1,  4)  ( 1,  5)  (-1,  5)  ( 1,  6) \\n  (-1,  6)  ( 1,  7)  (-1,  7) \
.\\nAll spectra extrapolated using (K,p) = (12/2,8)  (12/2,6) \\n  (14/2,6)  \
(18/2,6) .\\nWinding potential using (n,K,p) = ( 2 0,14/2,6)  ( 2 0,14/2,4) \
\\n  ( 2 0,22/2,4)  ( 3 0,15/2,7)  ( 3 0,15/2,5)  ( 3 0,23/2,5) \\n  ( 4 \
0,14/2,8)  ( 4 0,14/2,6)  ( 4 0,22/2,6) .\\nRoundness of winding using \
(n,K,p) = ( 2 2,12/2,8) \\n  ( 2 2,12/2,6)  ( 2 2,20/2,6) \\n  with error 1; \
in G^2 N units.\\nHeavy potential determined using (n,K,p,K_max) =\\n  ( 0 \
0,-20/2,2,3)  ( 0 0,-20/2,4,3)  ( 0 0,-20/2,2,4.5) \\n  ( 0 0,-32/2,2,3)  ( 0 \
0,-32/2,2,4.5)  ( 0 0,-60/2,2,3) \\n  ( 0 0,-60/2,2,4.5) ,\\n L = 3 4 6 (all \
in G^2 N units); relative scale error=0.1.\\nRoundness determined using \
(n,K,p,K_max) = ( 1 0,-13/2,3,3) \\n  ( 1 0,-13/2,5,3)  ( 1 0,-13/2,3,4.5)  ( \
1 0,-23/2,3,3) \\n  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3)  ( 1 0,-29/2,3,4.5) \
\\n L=0 and error 0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 0,-13/2,5,3)  ( 1 \
0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( 1 0,-29/2,3,3) \
\\n  ( 1 0,-29/2,3,4.5) \\n L=2.5 and error 0.1;\\n  ( 1 0,-13/2,3,3)  ( 1 \
0,-13/2,5,3)  ( 1 0,-13/2,3,4.5) \\n  ( 1 0,-23/2,3,3)  ( 1 0,-23/2,3,4.5)  ( \
1 0,-29/2,3,3) \\n  ( 1 0,-29/2,3,4.5) \\n L=5 and error 0.1;\\n  ( 1 \
1,-20/2,2,3)  ( 1 1,-20/2,4,3)  ( 1 1,-20/2,2,4.5) \\n  ( 1 1,-30/2,2,3)  ( 1 \
1,-44/2,2,4.5)  ( 1 1,-60/2,2,3) \\n  ( 1 1,-60/2,2,4.5) \\n L=0 and error \
0.1; all in G^2 N units.\\np-extrapolation using n=( 1 0) and (K,p) = \
(13/2,3) \\n  (21/2,3)  (45/2,3)  (13/2,5)  (23/2,5)  (11/2,7) \\n  (13/2,7) \
.\\nResult format:\\n Fit info, # steps, chi^2, and p damping, scale G^2 \
N/sigma.\\n The 10 couplings  (G^2 N units);\\n   which couplings -- if any \
-- were fit.\\n Winding potential and heavy souce potential fits.\\n \
Roundness of winding potential, 1 values, and roundness of\\n   heavy source \
potential, 4 values, (G^2 N units)\\n   showing measured value and derived \
value for each.\\n The rescaled spectrum for each P_perp*a and c^2 values.\\n \
Finally come the states for the ordinary spectra.\>\"", ",", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{"2", ",", "38", ",", 
                    StyleBox["1.38243401399999999`*^6",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.342881193699999986`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "50", ",", "0", ",", "1", 
                    ",", 
                    StyleBox["0.467237275200000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0509387387499999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.247769650600000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["5104.45789700000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.134337856499999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["866.532571699999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.07119182700000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.52948368699999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.0414219999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["1.74270600000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["2.73078500000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0231749999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.150690999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00469099999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->4]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.760244999999999926`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.06997999999999993`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.458084000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.38606600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.324087999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.393092000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.431247999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.41304299999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.772555000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.483887999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["48.120674000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["47.6768440000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["14.7075460000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["46.2970829999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["45.9197420000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["12.5042560000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["42.5624249999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["42.163421999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["13.2220840000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.291108000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.6632449999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["915.52615700000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["72.3168830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.7180409999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.2934859999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["118.155015000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["118.599315999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["14.7231729999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["155.183960000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["138.27049899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["560.474600000000044`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["183.125181999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["155.454643000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["916.940346999999889`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["62.1622940000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1077840000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3314670000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.3168830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.8199709999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["16.466577`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["118.155015000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["87.4462349999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1017.62089099999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["140.727593000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["118.326489000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["742.322927000000021`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["46.1529680000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4978479999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.4285460000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.021048000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["101.077601999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["1.87404399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["133.600289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["122.410229999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["370.813787999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["139.664872999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["133.562351999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["202.224022000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    RowBox[{"-", 
                      StyleBox["48.120674000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["47.2550880000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["14.3417929999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["42.5624249999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["41.7567049999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["13.3498859999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.291108000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.3296030000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.2067039999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1529680000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.8568350000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.90660200000000035`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["72.3168830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.9129420000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["9.87603000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["118.155015000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["87.5482260000000067`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["507.120572000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["155.183960000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["118.482961999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["608.094861000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["188.060037999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["230.795868000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["708.085350999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["62.1622940000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9292470000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.2764570000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.3168830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.6583509999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["10.9111460000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["118.155015000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["119.058145999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["14.9638859999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["140.727593000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["138.184456000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["42.1369550000000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["46.2970829999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["45.5269670000000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["12.7599719999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1529680000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.4880139999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["524.653192999999973`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["68.3989030000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.4645499999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["382.172208000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["91.6494150000000118`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.280327999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["159.573554999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["42.5624249999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    RowBox[{"-", 
                      StyleBox["48.120674000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["41.291108000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.19408799999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["233.573341`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["203.405688000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["329.178232999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["368.880523999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["214.795545999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["241.555893999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["378.306155999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["441.552990000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["62.1622940000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["140.727593000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["318.671623999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["196.967766000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["46.2970829999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["68.3989030000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.6494150000000118`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["110.896129000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["183.125181999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["239.288875999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["302.217393000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["315.065181999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["101.021048000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["246.98644999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["268.073409000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["315.738519999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["188.060037999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["234.955104000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["282.108140999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["359.477239000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["72.3168830000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["118.155015000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["155.183960000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["269.771755999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["46.1529680000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["133.600289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["139.664872999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["239.815955999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["90309.0458199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.486003898600000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "50", ",", 
                    StyleBox["0.00196754267099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.47464626980000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.027362614439999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.23317252719999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["65.2532385199999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107759708399999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["23.5297079899999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02620832300000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["2.17078780800000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.0976250000000000106`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["1.40380900000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.94160500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0393409999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.218868000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.115295999999999998`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.0110810000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.380108999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.520540000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.826097999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.276700999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.834010999999999924`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.306675999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.857160999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.916606999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.08284000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0746499999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.288410999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3549870000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.2122250000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.65376999999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.484653999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.9658309999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.2035799999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.5682240000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.4569769999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.2944729999999893`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["12.6915359999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["97.7418650000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.0379049999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.1207079999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["181.346383000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["181.698903000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["27.5317999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["206.815555999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["207.08134199999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["20.757916999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["244.135517999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["244.167893000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["2.5284629999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["97.7418650000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.8612239999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["9.32190899999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["105.07746899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.364769999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["22.4382159999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["181.346383000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["181.547465999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["15.7045980000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["206.815555999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["202.730970999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["319.005762000000014`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["94.2443019999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.5092479999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.6922780000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["143.25204600000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["143.256252999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.328519000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["218.274207999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["218.278762000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.355683000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["218.954105999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["219.099449000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["11.3513300000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0746499999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["0.651321999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.3491919999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["6.2122250000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["6.90659899999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.1152920000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.2443019999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.831869000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["16.1055049999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["127.368506000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["127.449405999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["3.15913999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["97.7418650000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.2310509999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.1026810000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["181.346383000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["181.706081000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["14.0462120000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["206.815555999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["202.724839999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["159.742313999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["266.326614000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["260.87648699999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    RowBox[{"-", 
                      StyleBox["212.827228000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["97.7418650000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.087610000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["13.5013450000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.07746899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.649918000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["22.3541020000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["181.346383000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["182.092747999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.1455209999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["206.815555999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["207.083109999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["10.448002999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["10.9658309999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["11.6301429999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.941358000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.4569769999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.2227500000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["9.14653500000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["94.2443019999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.4768200000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["9.07982900000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["175.689230000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["176.538398`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["33.1599999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0746499999999999985`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["6.2122250000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["127.368506000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["146.262664000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["301.938533999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["266.326614000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["436.913631000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["485.732242999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["312.392767000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["296.340012000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["461.109849999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["507.947040999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["105.07746899999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["229.258542999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["370.559228000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["368.983531000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["10.9658309999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.4569769999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["222.515681000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["175.689230000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["244.135517999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["303.679355000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["372.498866000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["408.320958000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["143.25204600000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["325.002759000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["373.069745000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["430.242373000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["288.510087000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["291.908781999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["372.314375999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["413.22598199999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["97.7418650000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["181.346383000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["206.815555999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["356.864196999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["94.2443019999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["218.954105999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["218.274207999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["269.15344000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "10", ",", 
                    StyleBox["576.230947100000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.777935730499999955`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["15.7818986299999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00791922201599999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.505851120899999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0252213685200000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.233150806799999976`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.114941561799999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.934988953499999908`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0980050152400000129`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.140414000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.181856`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.47387800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.0678340000000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["0.259853999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.209736000000000011`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.818210999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.125686999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.566547`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.625539999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.737581000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.662711000000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.0014289999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.75808699999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.04317999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.802089999999999925`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7747330000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.71338500000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.4792470000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.6015259999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.33553799999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.5684399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.6367590000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.42230999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["43.0177239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8987929999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.21680800000000033`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["37.291808000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3683670000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.71445800000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["73.2453440000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3354389999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.19437799999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["80.7696859999999894`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8546319999999951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.01183500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["93.8073400000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.8225579999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.539587000000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.291808000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.339007000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.67347800000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.4113759999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.4697020000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.06800499999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["73.2453440000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3115389999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.34699999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["80.7696859999999894`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.7894289999999948`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.699988999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.0177239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.0848730000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.38084400000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["57.3040929999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2903789999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.486235999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["85.2551240000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.2765660000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.76022400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["86.4559940000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.5169619999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.16167100000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.8794640000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.71335900000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["16.4792470000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.6726929999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.42940200000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["43.0177239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.8586430000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["2.82017000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["52.0810149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1167140000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.632868999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.291808000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.407653999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.05370199999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["73.2453440000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.3566579999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.97335900000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["80.7696859999999894`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.8751789999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.87016600000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["93.3837409999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.0546039999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["5.83492700000000041`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["37.291808000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4237660000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.33934299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["46.4113759999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5280830000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["2.068975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["73.2453440000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.446207999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.56089499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["80.7696859999999894`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.873166999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.83449599999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["17.5684399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["17.7559779999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["3.324662`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["43.0177239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.0756310000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02657700000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["54.1553470000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.0469519999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.921631`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["58.5382779999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.9656239999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["7.57596799999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["16.4792470000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.0810149999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.6495490000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.596153000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["115.594609999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["148.594900999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["187.211687000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["100.086977999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["136.602181000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["174.893065000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["188.418311999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["46.4113759999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.154436999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["133.734372000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["137.990992999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["17.5684399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1553470000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.5382779999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.8123310000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.8073400000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.097259999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["149.831176999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["153.001677000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["57.3040929999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["119.606725000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["154.388538000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["154.859143999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["93.3837409999999934`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["136.627709000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["147.123011999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["124.953011000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["37.291808000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.2453440000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.7696859999999894`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.841787999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["43.0177239999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.4559940000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.2551240000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.1020019999999917`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "29", ",", 
                    StyleBox["27.994260070000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.989434160499999926`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["8.46446293500000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.01800590693`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.565415331300000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0410893412500000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.20005081979999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["60.1290653399999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.124075900799999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["23.7592147400000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.610060744500000051`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.366083088900000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.199235000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.08588400000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.21279099999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.123948999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.249595000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.266820000000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.49029900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.65959500000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.607155000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.647273999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.741038999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.752238999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.0028729999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.983800000000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.12316499999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.861935000000000073`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.718874`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31874399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.8191009999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8570220000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02321499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.9656410000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.0077529999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.13630499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.067938999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.021823000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.24435600000000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["22.9780130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0052110000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.733854000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3200300000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3552369999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.949977999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.7972899999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8399339999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1506369999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["59.2710640000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.2701190000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0255149999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["22.9780130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0049959999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.728059000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.675937000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7032859999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.737959999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3200300000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3421909999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.597973999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.7972899999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.812992000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.423675000000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.067938999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0974080000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.795131000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.2793890000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.2688789999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.283596999999999965`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["54.2235460000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2532060000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.800313000000000052`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.0919009999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.1021379999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.276219999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7677850000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.31925599999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.9656410000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.0425900000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03814399999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.067938999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9794400000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.19398099999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["33.5750930000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.6655689999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.22065099999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["22.9780130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0225260000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.600531000000000059`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3200300000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3665779999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.627997999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.7972899999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8428150000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.614191999999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.597355000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.6540899999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.765419999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["22.9780130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.0419170000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.86213999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.675937000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7306610000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.738302000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.3200300000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3879999999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.917011000000000109`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.7972899999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.8680510000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.954662000000000077`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.8191009999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.9017359999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.11486200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.067938999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.1239239999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.755304999999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.6412120000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6733410000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.433455000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.263156000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.3164290000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.718728000000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.9656410000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5750930000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.194023999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.2118929999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.4279570000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.1557509999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.9631799999999941`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.3776250000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.4367700000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.112444999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["112.681755999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["30.675937000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.167946999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.0329399999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.7872780000000076`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.8191009999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6412120000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.263156000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.2784470000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.2710640000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.0537199999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.7490929999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.950843000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.2793890000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.1802660000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.2902949999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6917349999999906`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.597355000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.4094400000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["88.014808999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.7609389999999898`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["22.9780130000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.3200300000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7972899999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7724160000000104`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.067938999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.2235460000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0919009999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5336610000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"1", ",", "56", ",", 
                    StyleBox["25.2897241100000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.969918919999999928`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["8.43840842800000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0324919696199999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.704518250000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0199490064299999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.13337356119999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["148.473548999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["0.14829134220000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["13.1480999799999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.704777239600000093`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.289307344700000044`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.237795999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.1519649999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["1.20645000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.129634999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.226723000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.238933000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["1.56903299999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.901208000000000097`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.623589999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.702096000000000053`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.777228999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.80126899999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.04509699999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.02928099999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.14615599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.940061000000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7099089999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28130100000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.8774080000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.9006170000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.745124999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["25.4415130000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4660820000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.788834999999999908`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8123539999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8016960000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.342200999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.9274659999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9450560000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.564749999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4417609999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4718720000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.966731000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.2715469999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3105649999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.25268800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["63.1354349999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1199319999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.497757000000000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["23.9274659999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9604870000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.06019299999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.8834850000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9159780000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04319500000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["49.4417609999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.442086000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0104349999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["57.2715469999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2989019999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.878237000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8123539999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8377879999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.816571000000000069`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["36.7396719999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7281950000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.368503999999999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.0280800000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0458809999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.571521999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["58.1109330000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1308450000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.639287999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7498339999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.28157600000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["25.4415130000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4905939999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.787907000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8123539999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7609940000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.824490999999999907`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.1896819999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2117039999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.353522999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.9274659999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.965071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.603676000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["49.4417609999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4732320000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.505196999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.2715469999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3010069999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.472920000000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["65.1326569999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1787179999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.739414000000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["23.9274659999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9910990000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.02149500000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.8834850000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.9484819999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.04338599999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["49.4417609999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.471159999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.471945999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.2715469999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.3734589999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.63597900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.8774080000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.9238859999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.746094999999999952`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.8123539999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8948940000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.32500100000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.6779579999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.5577439999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.92978899999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["38.9863619999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.0258899999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.634530999999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["25.4415130000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1896819999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.2184549999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.7323869999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.2280080000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["100.411640999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["96.8212749999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.5595890000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.2453519999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.925950000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["123.507632000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["32.8834850000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.5666960000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.6786699999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["103.746962999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.8774080000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.6779579999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.9863619999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.3561379999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1354349999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.6066509999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.9812529999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.6912219999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["36.7396719999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.7551430000000074`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.3071019999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["97.5560789999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.1326569999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.6954039999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["91.3686929999999897`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.6197250000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["23.9274659999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["49.4417609999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.2715469999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.437844999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8123539999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0280800000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1109330000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8038700000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["346.645163099999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["1.02495525200000003`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.27178183599999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0517766953000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", "1", ",", 
                    StyleBox["0.751211157600000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.00666773069400000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.220837103499999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.167042370599999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.595789175400000026`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.231790235500000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.247063999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.03586700000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.910346999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.151790000000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.195265000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.216351000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.1265489999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.05443799999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.659658999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.599056999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.831596000000000046`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.74768100000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.12189500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.05292600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.22404299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.81538699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7077019999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.934727999999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.7429419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.7685899999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.635866000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.9313949999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.9624389999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.769661999999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.4348180000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.5016660000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.4984010000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.435572999999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0278019999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.526595000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9992069999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.818517000000000116`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.5487160000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5477160000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0247819999999999973`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.5017479999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.518558999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7995939999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8220109999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.555756000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0214429999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.368937000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9797449999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.336014999999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0654320000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.551149000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.6681519999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6590449999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.225776999999999983`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.0434270000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0520720000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.214340000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.5876339999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.6086570000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.521222999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7454350000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.935107999999999961`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.9313949999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.9895040000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.720330000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.3895449999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["4.29336599999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["28.668792999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.3361419999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["4.12362800000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.5084419999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.342257999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0394229999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.407353999999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9962390000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.37246699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.8780410000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9773649999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.23124499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.5302180000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.612202000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.7995939999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8444460000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.55599400000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0458259999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.486723000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["45.0288359999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.776545999999999914`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["18.7429419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.7981459999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.684312000000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0784890000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.437431000000000036`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.424951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3886709999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.449738000000000059`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.7732289999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8280930000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.68010299999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.9313949999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.668792999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.1927619999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.1481989999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2031989999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3965390000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.5545059999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0060339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.6722460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.330016000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["105.482189000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["28.7995939999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.330252999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.6496290000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.744335000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.7429419999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7732289999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.424951`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.5006649999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.5487160000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.4834099999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.624244000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5527060000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.6681519999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6316829999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.0212350000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.159205`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8780410000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.2161100000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.4753819999999926`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.6153340000000078`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.4808319999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.0065620000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.9661919999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9962999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.0432009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.5876339999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0434270000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.8424410000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["167.019858300000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.991343237000000065`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->9]}], ",", 
                    StyleBox["6.06977465900000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.0764288174200000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["0.889127118899999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.00376119991699999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.213915616900000005`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.196328040900000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.405126245499999981`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.306990408799999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.270701999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["1.01038099999999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.687082000000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.179084999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.140082000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.159640000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.24245500000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.24111900000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.680378999999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.65508999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.847823999999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.821767000000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.16014799999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.17216300000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.25467700000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.90415700000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.706773`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.966750000000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.0463589999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0662219999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.522209999999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3086130000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3354469999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.705447000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7154850000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["18.3675700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6546599999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.378959000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4578640000000042`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.472475000000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1323699999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.811733000000000082`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.5917880000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.1320369999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["14.2029259999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6628480000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.594203999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9603730000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.9850640000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.649113999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4492700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.246552999999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1167260000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.400471000000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0381940000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.56186499999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.2709680000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2618230000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.240420999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["46.8228829999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8340010000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.292283000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["47.0746339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0918189999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.451771999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7435729999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.967100999999999899`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.3086130000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3606310000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.683762999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.9999360000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.221951000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["28.7004880000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7307749999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.398118999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6651300000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.327096000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4682559999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.37283400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1262540000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.325477000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.9089379999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9374200000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.37439`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6894099999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.646255000000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.9603730000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.0097720000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.649332000000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4661990000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.345801999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1684439999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.880049999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.0463589999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0880340000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.547818999999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0320450000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.200105999999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.3562389999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3209909999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.463335000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.6729800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7614430000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16283399999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.3086130000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7004880000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.267852999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["59.3402099999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.5606999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.9219309999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.2633090000000066`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.0252549999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.2535699999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.7060249999999932`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.312363000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["29.9603730000000023`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5488020000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.031949999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.5915600000000047`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.0463589999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.6729800000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.3562389999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.4059329999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.5917880000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.2343199999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5733589999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.2242380000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.2709680000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.2383970000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.3253380000000056`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["93.3363710000000068`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.9089379999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4773659999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.9130729999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.1550739999999919`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["19.6402460000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.4398920000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.1014929999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.7351499999999955`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.0168209999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["47.0746339999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.8228829999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.7756309999999935`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["49.6696687199999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.948864284300000093`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.05821807600000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.107240137899999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.06150063199999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0167957420099999987`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.20526483449999997`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.23293057629999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.1668272215`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.400978935500000055`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.28905700000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.951690999999999931`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.34894999999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.199458000000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0956670000000000086`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.111515999999999992`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.28581499999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.40438200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.699698999999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.711092999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.859883999999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.88747600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.20229099999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.26721100000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.27942399999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.990220000000000055`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7068420000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03227800000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.1333519999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1605990000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.763417000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.4353209999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4509970000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.439219000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8631260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8800489999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.474165999999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.2303150000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2425480000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.342745000000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.5094390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.5254789999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.449439999999999972`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.881843000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9116499999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.835153000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["53.670270999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.6579240000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.345947000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.2303150000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2552809999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.699509999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.7483970000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.7766349999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.791173000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.5094390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.5142349999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.134383000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.881843000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9235299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.16801700000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["29.451046999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4718599999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.583168000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["33.4724200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4632569999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.256716999999999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["48.3501400000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3632320000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.366819999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.4319699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4462520000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.400177000000000049`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.743705999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.03256799999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.1333519999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1868790000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.749878999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.8631260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8969960000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.474498999999999959`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.451046999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4244810000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.372165999999999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["20.2303150000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.253766999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.328549999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.5094390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.5341769999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.346573000000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.881843000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9281549999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.648808999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.0116349999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0330959999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.300661999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["20.2303150000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2812649999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.713780999999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.7483970000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.8048859999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.791361000000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["42.5094390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.5264250000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.237969000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.881843000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.9791609999999977`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36336400000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.4353209999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4683610000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.462865000000000037`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.451046999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.4660639999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.210384999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.8918090000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8604920000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.438731999999999988`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["30.2504740000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.3478329999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.36393800000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1333519999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8631260000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8442160000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.6781470000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.2003649999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["83.1903209999999937`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.182516000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.1257120000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.5140969999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["89.057352999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["117.981765999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["31.7483970000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.7907860000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.9532130000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["76.1238830000000099`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.4353209999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.2504740000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.8918090000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.9793809999999929`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["53.670270999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.1352229999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.1890750000000096`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["80.5579580000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4724200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.4257970000000064`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.6218109999999938`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["96.9087440000000022`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.0116349999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.4501949999999954`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.0729659999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.0963200000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["20.2303150000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["42.5094390000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.881843000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.8936369999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.451046999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.3501400000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.4319699999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.9122029999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "11", ",", 
                    StyleBox["42.7986607199999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.902945202199999918`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.1923731670000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.145308505599999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.27447359599999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0329003338499999964`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.19457651740000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["61.8609636199999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.278154174500000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["22.2456422600000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.127598811299999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.51710475339999995`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.302761000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.841619000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.154892999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.207808999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.0840399999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    RowBox[{"-", 
                      StyleBox["0.104838000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.26873300000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.56110799999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.718888999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.76133399999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.868366999999999933`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.937443999999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.2477450000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.32407800000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.29936600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.0636350000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.707583`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1273709999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.8178109999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.8491089999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.938845000000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.782141000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.7920079999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.295968999999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9448340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.971985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.814438999999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.2213420000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2318880000000032`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.316354999999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0510329999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0658960000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.445834999999999936`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.449640000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.454698000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.151733000000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["56.5893580000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5730060000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.490521999999999991`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.2213420000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2492970000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.838560999999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1382600000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.1712770000000043`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.990407000000000081`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0510329999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0515979999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0169650000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["52.449640000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4413760000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.247904000000000035`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.3250530000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3452190000000019`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.604910999999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["35.1743469999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1652440000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.273052000000000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["50.1952529999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.2042490000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.26984300000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["50.7102189999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7274699999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.517480000000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7451770000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1275409999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["27.8178109999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.8799829999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.932492000000000054`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.782141000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.8018360000000015`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.295396`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["30.7996729999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7850299999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.219620000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["21.2213420000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2441719999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.342409000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0510329999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0723779999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.320149000000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.449640000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.4321199999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.262767999999999979`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["56.8583869999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8949270000000062`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.54804699999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["21.2213420000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["21.2755129999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.812483999999999895`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.1382600000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.2043019999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.990531999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["44.0510329999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0606640000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.144455`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["52.449640000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.459958999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.154766999999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["28.9448340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9995780000000014`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.821071000000000061`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["29.5682109999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.6446329999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.14622099999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.835233999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8102600000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.374574000000000006`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["31.3250530000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3383879999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.199997000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["27.8178109999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.782141000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7996729999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["64.9038199999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.8980979999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.8989209999999943`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.5233900000000097`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0322960000000058`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.3930459999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["112.33771400000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["125.291273999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.1382600000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["54.8373869999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["73.8579890000000016`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.4869489999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["28.9448340000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["29.5682109999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.835233999999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["46.0989489999999957`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.5893580000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["62.9462899999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.0026579999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.272165999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1743469999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["74.8764939999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.4874939999999945`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.871494999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["56.9018379999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3510150000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["71.9103960000000075`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["106.773069000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["21.2213420000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0510329999999949`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.8583869999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["52.449640000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.3250530000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.1952529999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["50.7102189999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.0655099999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "23", ",", 
                    StyleBox["42.5231685899999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.836905430900000091`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["6.92772660299999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.192168154199999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", "1", ",", 
                    StyleBox["1.52539570600000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0817579216499999894`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.171784043099999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["71.8643213899999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.340892415900000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["25.9141059799999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.37327896900000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.762505076700000028`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.306684999999999963`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.663328999999999968`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.88206199999999999`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["0.15281900000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.139230999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.152989999999999977`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.13754799999999978`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.67989199999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.735437000000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.685646999999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.85340600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.805607999999999968`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.22066600000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.0780670000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.30756399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.940177999999999869`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7097780000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35222099999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.7902309999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.798072000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.266548000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["31.9404630000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9704329999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.0187759999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["32.6927889999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7274229999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1773690000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["24.1439909999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1538170000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.334023999999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.6543170000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6696659999999958`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.521785999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.0316959999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.057878000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.890010000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.740572000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.7182559999999931`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.758591000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["24.1439909999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1777439999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.1474200000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.5574179999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.5998870000000025`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.4437120000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["48.6543170000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6493100000000033`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.170190000000000019`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["57.0316959999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0565980000000028`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.846509999999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["34.9597360000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9803149999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.699563999999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["38.9840680000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.974359999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.330038000000000009`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["55.5637619999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5686329999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.165602999999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["55.9820820000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.0047009999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.768930000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7495510000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35213300000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["30.7902309999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.8058910000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.266175000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.6927889999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7109840000000051`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.309274000000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.7196659999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7618160000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.716427999999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1439909999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.1683700000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.414367000000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["48.6543170000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6725950000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.310667000000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["57.0316959999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0378839999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.105163000000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["62.9907620000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0308319999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.681064000000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["24.1439909999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["24.2067659999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.06698399999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["39.5574179999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6423539999999974`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.4436679999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["48.6543170000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6569189999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.0442260000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->5], ",", 
                    StyleBox["57.0316959999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.1256580000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.5970740000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["31.9404630000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9983780000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.984370999999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["32.7401950000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7330529999999964`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.121395000000000008`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["34.5821510000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.6466059999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.09553499999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["34.9597360000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9587119999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0174079999999999994`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->5]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.6927889999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["30.7902309999999967`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7196659999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["72.8268809999999966`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.3917589999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.736507999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.1220639999999946`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["61.6774040000000045`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["98.5925890000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["134.082076999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["135.847862999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["39.5574179999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["60.899321000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["82.4682739999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["101.270590000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["34.5821510000000031`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9404630000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["32.7401950000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.1186360000000039`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.740572000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["70.3011359999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.8184939999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.6928949999999858`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["38.9840680000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["84.7252560000000087`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["86.1812160000000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["129.019484999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["62.9907620000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.3593589999999942`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["85.3122209999999903`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["113.074558999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["24.1439909999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["48.6543170000000024`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["65.2831060000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["57.0316959999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["34.9597360000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.5637619999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["55.9820820000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["68.1625810000000065`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}], ",", 
                RowBox[{"{", 
                  RowBox[{"2", ",", "28", ",", 
                    StyleBox["2624.47344500000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.774016689800000001`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["7.25832388700000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.25`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->2], ",", "1", ",", 
                    StyleBox["1.74159331899999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.0934371298399999972`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    RowBox[{"-", 
                      StyleBox["0.157205107899999996`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", 
                    StyleBox["476.84531579999998`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["0.321127014099999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["203.177595200000027`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    StyleBox["1.15214427299999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->10], ",", 
                    RowBox[{"-", 
                      StyleBox["0.956679734899999978`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->10]}], ",", "2", ",", "3", ",", "4", 
                    ",", "5", ",", "6", ",", "7", ",", "8", ",", "9", ",", 
                    StyleBox["0.338251000000000034`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.444486000000000025`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    RowBox[{"-", 
                      StyleBox["1.77836100000000012`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["0.177350000000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.118071999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    RowBox[{"-", 
                      StyleBox["0.140816000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["2.18331499999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["2.03922999999999987`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["0.775116999999999922`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.833380999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.873348000000000013`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["0.959474999999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["1.23076699999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.25708299999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.33270200000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["1.15325799999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7193939999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.940287`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.5155769999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4947239999999979`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.819139000000000017`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["35.1392909999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1436690000000018`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.171988999999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.469203000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6998460000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.6246109999999944`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8523409999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8610460000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.34196500000000003`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9025040000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.920155999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.693397000000000041`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.1244220000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1437049999999988`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.757458999999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["69.5203269999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.5064780000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.544005999999999989`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["26.8523409999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8922669999999985`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.5683860000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.0370069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.0854920000000038`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.90457699999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.9025040000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.8977160000000026`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.188088000000000015`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["63.1244220000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9380710000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["31.9619150000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.7953759999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8145420000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.75285700000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["43.7326410000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["43.7232470000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.369002000000000007`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["58.5110650000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.5221950000000035`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.437227999999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.0928820000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0892929999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.141008999999999984`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["12.7687440000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.93944399999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["33.5155769999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.4738859999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.818863999999999947`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["37.4761409999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4527009999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["0.460379000000000004`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->6]}], ",", 
                    StyleBox["39.6834199999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.7160869999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.64161999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["26.8523409999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.8805359999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.553777000000000008`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["51.9025040000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9193480000000029`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.330824999999999969`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.1244220000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.9384279999999982`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["15.9879700000000006`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.6095959999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.8375999999999947`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["15.1628600000000002`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->8]}], ",", 
                    StyleBox["26.8523409999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["26.9213909999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.35620699999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["44.0370069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["44.1339669999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.90440699999999996`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["51.9025040000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9117419999999984`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.181449999999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["63.1244220000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1982339999999975`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.44974000000000007`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["35.1392909999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1480809999999976`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.172639999999999993`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["37.469203000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.3956179999999971`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    RowBox[{"-", 
                      StyleBox["1.445289`",
                        StyleBoxAutoDelete->True,
                        PrintPrecision->7]}], ",", 
                    StyleBox["39.7953759999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.8790390000000005`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["1.64322600000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->7], ",", 
                    StyleBox["41.880600999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["41.9305899999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["0.981854000000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->6], ",", 
                    StyleBox["12.669999999999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.6834199999999981`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["33.5155769999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.4761409999999983`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["79.3278770000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["78.3088359999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["109.496227000000011`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["99.0725149999999921`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["67.2485029999999994`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["115.171628999999997`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["146.958997000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["149.495988000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["44.0370069999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["66.4569599999999915`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["87.553264999999989`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["111.52000099999999`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["41.880600999999995`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["35.1392909999999991`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["37.469203000000002`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["56.1600379999999965`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.5203269999999928`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["77.5754079999999923`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["99.5747749999999953`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["104.552901000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["43.7326410000000009`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["90.7806340000000133`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.4559210000000071`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["144.161774000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["67.6095959999999962`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["92.5200889999999986`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["94.0245810000000048`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["133.704040000000001`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->9], ",", 
                    StyleBox["26.8523409999999973`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["51.9025040000000004`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["69.7618250000000017`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.1244220000000044`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["39.7953759999999956`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["58.5110650000000021`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["63.0928820000000012`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8], ",", 
                    StyleBox["75.3060829999999992`",
                      StyleBoxAutoDelete->True,
                      PrintPrecision->8]}], "}"}]}], "}"}]}], "}"}]}], 
      ";"}]], "Input"]
}, Closed]],

Cell[CellGroupData[{

Cell["analyze", "Section"],

Cell[BoxData[
    \(data[\([1]\)]\)], "Input"],

Cell["Chi^2", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(chi2 = 
      ListPlot[Map[{Sqrt[#[\([6]\)]], #[\([3]\)]} &, data[\([2]\)]], 
        PlotJoined -> True, Axes -> False, Frame -> True, 
        TextStyle -> {FontFamily -> "\<Courier\>", FontSize -> 12}, 
        FrameLabel -> {"\<m\>", "\<\>"}, PlotRange -> {0, 40}]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["\<\
Select which points to plot (sdata) and which points to use for \
fitting (ssdata).\
\>", "Text"],

Cell[BoxData[{
    \(\(sdata = Select[data[\([2]\)], \((#[\([3]\)] < 40)\) &];\)\), "\n", 
    \(\(ssdata = 
        Select[data[\([2]\)], \((#[\([3]\)] < 20 && \ #[\([38]\)] > 
                  8)\) &];\)\)}], "Input"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[\((#[\([6]\)])\) &, sdata]\)], "Input"],

Cell[BoxData[
    \({0, 0.001967542671`, 0.007919222016`, 0.01800590693`, 0.03249196962`, 
      0.0517766953`, 0.07642881742`, 0.1072401379`, 0.25`}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Map[\((#[\([6]\)])\) &, ssdata]\)], "Input"],

Cell[BoxData[
    \({0.001967542671`, 0.007919222016`, 0.01800590693`, 
      0.03249196962`}\)], "Output"]
}, Open  ]],

Cell["\<\
Using sdata, fit all couplings to either a linear or constant \
function.  Here, x is the mass.\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitting = 
      Chop[Table[
          Fit[Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], #[\([i]\)]/#[\([7]\)]} &, 
              ssdata], If[MemberQ[{11, 13}, i], {1}, {1, x, x^2}], x], {i, 6, 
            15}]]\)], "Input"],

Cell[BoxData[
    \({1.`\ x\^2, 
      0.9999999999999999`, \(\(0.38150070839701933`\)\(\[InvisibleSpace]\)\) \
+ 0.9252689479418348`\ x + 
        4.234441936249746`\ x\^2, \(\(0.04566373308086391`\)\(\
\[InvisibleSpace]\)\) - 0.8001402755611848`\ x + 
        1.809198183065762`\ x\^2, \(-0.06465504007753566`\) - 
        0.05514657951449493`\ x - 0.47463417808019454`\ x\^2, 
      424.92863967500006`, \(\(0.08367357438939606`\)\(\[InvisibleSpace]\)\) \
+ 0.2962536879884249`\ x + 0.6127687748404762`\ x\^2, 
      182.7732899`, \(-0.673623640738949`\) - 2.9199929954791863`\ x + 
        3.5503908939860755`\ x\^2, \(-0.49089428519911404`\) - 
        5.1444725931323365`\ x + 9.92934316812942`\ x\^2}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pc = 
      Table[Show[
          ListPlot[
            Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], #[\([i]\)]/#[\([7]\)]} &, 
              sdata], PlotStyle -> {PointSize[ .02], Hue[2/3]}, 
            DisplayFunction -> Identity], \n\t (*\(ListPlot[tau1, 
              PlotStyle -> {PointSize[ .02]}, 
              DisplayFunction -> Identity]\)\(,\)*) Plot[
            fitting[\([i - 5]\)], {x, 0, 1/2}, PlotStyle -> {Hue[0]}, 
            DisplayFunction -> Identity], 
          DisplayFunction -> $DisplayFunction, Axes -> False, 
          RotateLabel -> False, FormatType -> OutputForm, 
          TextStyle -> {FontFamily -> "\<Courier\>", FontSize -> 12}, 
          Frame -> True, 
          FrameLabel -> {"\<m\>", {"\<b\>", \*"\"\<\!\(l\_1\)\>\"", \*"\"\<\!\
\(l\_2\)\>\"", \*"\"\<\!\(l\_3\)\>\"", \*"\"\<\!\(l\_4\)\>\"", \
\*"\"\<\!\(l\_5\)\>\"", \*"\"\<\!\(t\_1\)\>\"", \*"\"\<\!\(t\_2\)\>\""}[\([i \
- 7]\)]}], {i, 8, 15}]\)], "Input"],

Cell[BoxData[
    RowBox[{"{", 
      RowBox[{
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False], ",", 
        TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
          False,
          Editable->False]}], "}"}]], "Output"]
}, Open  ]],

Cell["\<\
a^2 sigma vs m using two different methods: using the overall scale \
and using the longitudinal potential. \
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(fita2 = 
      Fit[Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], #[\([24]\)]*#[\([5]\)]} &, 
          Drop[ssdata, {2}]], {1, x}, x]\)], "Input"],

Cell[BoxData[
    \(\(\(2.022478482413753`\)\(\[InvisibleSpace]\)\) + 
      1.137984830339073`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fita3 = 
      Fit[Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], #[\([24]\)]/#[\([27]\)]} &, 
          Drop[ssdata, {2}]], {1, x}, x]\)], "Input"],

Cell[BoxData[
    \(\(\(2.0226799306464702`\)\(\[InvisibleSpace]\)\) + 
      0.6435286581292277`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[\n\t\tPlot[fita2, {x, 0,  .5}, DisplayFunction -> Identity, 
        PlotStyle -> {Hue[0.6]}], \n\t\tPlot[fita3, {x, 0,  .5}, 
        DisplayFunction -> Identity, 
        PlotStyle -> {Hue[0]}], \n\t\t (*\(Plot[1 + 2\ x, {x, 0,  .5}, 
          DisplayFunction -> Identity]\)\(,\)*) \n\t
      ListPlot[Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], #[\([24]\)]*#[\([5]\)]} &, 
          sdata], PlotStyle -> {PointSize[0.01], Hue[0.6]}, 
        DisplayFunction -> Identity], \n\t
      ListPlot[Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], #[\([24]\)]/#[\([27]\)]} &, 
          sdata], PlotStyle -> {PointSize[0.01], Hue[0]}, 
        DisplayFunction -> Identity], FrameLabel -> {"\<m\>", "\<\>"}, 
      PlotRange -> All, Axes -> False, Frame -> True, 
      TextStyle -> {FontFamily -> "\<Courier\>", FontSize -> 12}, 
      DisplayFunction -> $DisplayFunction]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(fitag = 
      Fit[Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], Sqrt[#[\([24]\)]]*#[\([5]\)]} &, 
          Drop[ssdata, {2}]], {1, x}, x]\)], "Input"],

Cell[BoxData[
    \(\(\(5.091866692483492`\)\(\[InvisibleSpace]\)\) - 
      2.2778471841273324`\ x\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Show[\n\t\tPlot[fitag, {x, 0,  .5}, DisplayFunction -> Identity, 
        PlotStyle -> {Hue[0.6]}], \n\t
      ListPlot[Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], 
              Sqrt[#[\([24]\)]]*#[\([5]\)]} &, sdata], 
        PlotStyle -> {PointSize[0.01], Hue[0.6]}, 
        DisplayFunction -> Identity], \nFrameLabel -> {"\<m\>", "\<\>"}, 
      PlotRange -> All, Axes -> False, Frame -> True, 
      TextStyle -> {FontFamily -> "\<Courier\>", FontSize -> 12}, 
      DisplayFunction -> $DisplayFunction]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(exam = Sqrt[Partition[Take[data[\([2, 2]\)], \(-40\)], 4]]\)], "Input"],

Cell[BoxData[
    \({{3.4963372262984014`, 4.97000714285201`, 5.6980637062075745`, 
        6.5280748310662`}, {9.069016539845983`, 9.33762223480903`, 
        10.272320088470764`, 11.039075640650355`}, {8.236730722805014`, 
        9.651410363257797`, 10.844002351530545`, 
        10.756670767481916`}, {5.746020535988364`, 8.318284198078352`, 
        9.541465348676796`, 9.76838067440044`}, {4.968623753113129`, 
        5.7064206820037375`, 7.104791974435281`, 
        7.352763698093391`}, {8.391401968681992`, 9.11649537925622`, 
        10.096977319970566`, 10.367887875551123`}, {6.067179492976947`, 
        9.165112547044908`, 10.0852764463846`, 
        9.670015563586235`}, {8.36810558011788`, 9.59763460442207`, 
        9.768000972563424`, 9.546210504697662`}, {5.367422100040205`, 
        7.376504117805398`, 8.006552691389722`, 
        8.870453426967531`}, {5.6207531523809156`, 7.788696617534926`, 
        7.985614065305185`, 8.355544865536897`}}\)], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pspec1 = 
      Block[{bs = 2, err = 0.05}, 
        Show[Graphics[{Text[\*"\"\<\!\(\(0\^++\)\)\>\"", {1, bs}], 
              Text[\*"\"\<\!\(0\^\(-+\)\)\>\"", {2, bs}], 
              Text[\*"\"\<\!\(\(1\^++\)\)\>\"", {3, bs + 0.25}], 
              Text[\*"\"\<\!\(1\^\(-+\)\)\>\"", {3, bs - 0.25}], 
              Text[\*"\"\<\!\(\(2\^++\)\)\>\"", {4, bs}], 
              Text[\*"\"\<\!\(2\^\(-+\)\)\>\"", {5, bs}], {Thickness[0.008], 
                Map[cross[1, #, #\ err] &, exam[\([1]\)]], 
                Map[cross[2, #, #\ err] &, exam[\([3]\)]], 
                Map[cross[3, #, #\ err] &, exam[\([10]\)]], 
                Map[cross[4, #, #\ err] &, exam[\([5]\)]], 
                Map[cross[5, #, #\ err] &, exam[\([7]\)]]}}], Frame -> True, 
          AspectRatio -> 1, PlotRange -> {{1/2, 5 + 1/2}, {0, 7}}, 
          FormatType -> OutputForm, FrameTicks -> {None, Automatic}, 
          TextStyle -> {FontFamily -> "\<Courier\>", 
              FontSize -> 12}]]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pspec2 = 
      Block[{bs = 2, err = 0.05}, 
        Show[Graphics[{Text[\*"\"\<\!\(0\^\(+-\)\)\>\"", {1, bs}], 
              Text[\*"\"\<\!\(\(0\^--\)\)\>\"", {2, bs}], 
              Text[\*"\"\<\!\(1\^\(+-\)\)\>\"", {3, bs + 0.25}], 
              Text[\*"\"\<\!\(\(1\^--\)\)\>\"", {3, bs - 0.25}], 
              Text[\*"\"\<\!\(2\^\(+-\)\)\>\"", {4, bs}], 
              Text[\*"\"\<\!\(\(2\^--\)\)\>\"", {5, bs}], {Thickness[0.008], 
                Map[cross[1, #, #\ err] &, exam[\([2]\)]], 
                Map[cross[2, #, #\ err] &, exam[\([4]\)]], 
                Map[cross[3, #, #\ err] &, exam[\([9]\)]], 
                Map[cross[4, #, #\ err] &, exam[\([6]\)]], 
                Map[cross[5, #, #\ err] &, exam[\([8]\)]]}}], Frame -> True, 
          AspectRatio -> 1, PlotRange -> {{1/2, 5 + 1/2}, {0, 9.5}}, 
          FrameTicks -> {None, Automatic}, 
          TextStyle -> {FontFamily -> "\<Courier\>", 
              FontSize -> 12}]]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Put plots", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Display["\<~/three/ttraj60.spec1.eps\>", pspec1, "\<EPS\>", 
      ImageSize -> 360, ImageOffset -> {0, 0}]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Display["\<~/three/ttraj60.spec2.eps\>", pspec2, "\<EPS\>", 
      ImageSize -> 360, ImageOffset -> {0, 0}]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Display["\<~/three/ttraj60.chi2.eps\>", chi2, "\<EPS\>", 
      ImageSize -> 360, ImageOffset -> {0, 0}]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(pass = 
      Show[\n\t\t (*
          Plot[Sqrt[fita2], {x, 0,  .5}, DisplayFunction -> Identity], *) \n\t
        ListPlot[
          Map[{Sqrt[#[\([6]\)]/#[\([7]\)]], Sqrt[#[\([24]\)]*#[\([5]\)]]}&, 
            sdata], PlotStyle -> {PointSize[0.015]}, 
          DisplayFunction -> Identity], FrameLabel -> {"\<m\>", "\<\>"}, 
        PlotRange -> All, Axes -> False, Frame -> True, 
        TextStyle -> {FontFamily -> "\<Courier\>", FontSize -> 12}, 
        DisplayFunction -> $DisplayFunction]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Display["\<~/three/ttraj60.ass.eps\>", pass, "\<EPS\>", 
      ImageSize -> 360, ImageOffset -> {0, 0}]\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  Graphics  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["\<\
This was printed to a postscript file \"ttraj60.scaling.ps\", size \
616 by 779, and moved to the left such that left=0. (You need to adjust the \
Font size on the graph labels, above)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\(\ Show[GraphicsArray[Partition[pc, \ 2]]]\)\)], "Input"],

Cell[BoxData[
    TagBox[\(\[SkeletonIndicator]  GraphicsArray  \[SkeletonIndicator]\),
      False,
      Editable->False]], "Output"]
}, Open  ]],

Cell["\<\
This prints out scaling graphs to separate files (You need to \
adjust the Font size on the graph labels, above)\
\>", "Text"],

Cell[CellGroupData[{

Cell[BoxData[
    \(Block[{couplelist = {"\<b\>", "\<l1\>", "\<l2\>", "\<l3\>", "\<l4\>", "\
\<l5\>", "\<t1\>", "\<t2\>"}}, \[IndentingNewLine]Do[
        Print["\<~/three/ttraj60.\>" <> couplelist[\([i]\)] <> "\<.eps\>"]; 
        Display["\<~/three/ttraj60.\>" <> couplelist[\([i]\)] <> "\<.eps\>", 
          pc[\([i]\)], "\<EPS\>", ImageSize -> 360, 
          ImageOffset -> {0, 0}], {i, Length[pc]}]]\)], "Input"],

Cell[BoxData[
    \("~/three/ttraj60.b.eps"\)], "Print"],

Cell[BoxData[
    \("~/three/ttraj60.l1.eps"\)], "Print"],

Cell[BoxData[
    \("~/three/ttraj60.l2.eps"\)], "Print"],

Cell[BoxData[
    \("~/three/ttraj60.l3.eps"\)], "Print"],

Cell[BoxData[
    \("~/three/ttraj60.l4.eps"\)], "Print"],

Cell[BoxData[
    \("~/three/ttraj60.l5.eps"\)], "Print"],

Cell[BoxData[
    \("~/three/ttraj60.t1.eps"\)], "Print"],

Cell[BoxData[
    \("~/three/ttraj60.t2.eps"\)], "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Create data file", "Section"],

Cell[CellGroupData[{

Cell[BoxData[
    \(expr2 = 
      Block[{beta, ll = Length[data[\([2]\)]]}, 
        TableForm[
          Flatten[Table[{8, 
                N[If[False\ \  (*5 < data[\([2, i, 24]\)] < 25*) , 
                    Take[data[\([2, i]\)], {6, 15}]/data[\([2, i, 7]\)], 
                    beta = 0.25\ \((i - 1)\)/\((ll - 1)\); 
                    fitting /. x -> Sqrt[beta\ Tan[Pi\ beta]]], 12], {2, 3, 
                  4, 5, 6, 7, 8, 9}}, {i, 4, 4}], 1], \n
          TableSpacing -> {0, 1}]]\)], "Input"],

Cell[BoxData[
    InterpretationBox[GridBox[{
          {"8", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", 
            "\<\"\"\>", "\<\"\"\>", "\<\"\"\>", "\<\"\"\>"},
          {
            StyleBox["0.0180059069310087025`",
              StyleBoxAutoDelete->True,
              PrintPrecision->12], 
            StyleBox["0.999999999999999822`",
              StyleBoxAutoDelete->True,
              PrintPrecision->12], 
            StyleBox["0.578902288074314519`",
              StyleBoxAutoDelete->True,
              PrintPrecision->12], 
            RowBox[{"-", 
              StyleBox["0.0341680976642386458`",
                StyleBoxAutoDelete->True,
                PrintPrecision->12]}], 
            RowBox[{"-", 
              StyleBox["0.0792314618399034031`",
                StyleBoxAutoDelete->True,
                PrintPrecision->12]}], 
            StyleBox["380.601302674999999`",
              StyleBoxAutoDelete->True,
              PrintPrecision->12], 
            StyleBox["0.132491678181059224`",
              StyleBoxAutoDelete->True,
              PrintPrecision->12], 
            StyleBox["160.660779874999999`",
              StyleBoxAutoDelete->True,
              PrintPrecision->12], 
            RowBox[{"-", 
              StyleBox["1.00064500144437085`",
                StyleBoxAutoDelete->True,
                PrintPrecision->12]}], 
            RowBox[{"-", 
              StyleBox["1.00474625071219514`",
                StyleBoxAutoDelete->True,
                PrintPrecision->12]}]},
          {"2", "3", "4", "5", "6", "7", "8", "9", "\<\"\"\>", "\<\"\"\>"}
          },
        RowSpacings->0,
        ColumnSpacings->1,
        RowAlignments->Baseline,
        ColumnAlignments->{Left}],
      TableForm[ {8, {0.018005906931008703, 0.99999999999999989, 
        0.57890228807431454, -0.034168097664238645, -0.0792314618399034, 
        380.601302675, 0.13249167818105922, 
        160.660779875, -1.0006450014443709, -1.0047462507121951}, {2, 3, 4, 
        5, 6, 7, 8, 9}}, TableSpacing -> {0, 1}]]], "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(Block[{
        fp = OpenWrite["\<~/three/ttraj67.in\>", FormatType -> OutputForm, 
            PageWidth -> Infinity]}, \n\t\tWrite[fp, "\<ttraj67.out\>"]; \n
      \t\tWrite[fp, "\<3\>"]; \n\t\tWrite[fp, expr2]; Write[fp, \(-1\)]; 
      Close[fp]]\)], "Input"],

Cell[BoxData[
    \("/home/bvds/three/ttraj67.in"\)], "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["JUNK", "Section"],

Cell[BoxData[
    \(\(5.05838882561427105`\[InvisibleSpace]\) - 3.85558004489796743`\ x\)], 
  "Output"],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((5.05838882561427105`\[InvisibleSpace] - 3.85558004489796743`\ x\ )
          \) {1/Sqrt[2], 1, Sqrt[2]} /. x -> Sqrt[0.00196754]\)], "Input"],

Cell[BoxData[
    \({3.45589035595012106`, 4.88736701145904373`, 6.91178071190024123`}\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((5.05838882561427105`\[InvisibleSpace] - 3.85558004489796743`\ x\ )
          \) {1/Sqrt[2], 1, Sqrt[2]} /. x -> Sqrt[0.032492]\)], "Input"],

Cell[BoxData[
    \({3.08538958838083621`, 4.36339980109291936`, 6.17077917676167153`}\)], 
  "Output"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
    \(\((5.05838882561427105`\[InvisibleSpace] - 3.85558004489796743`\ x\ )
          \) {1/Sqrt[2], 1, Sqrt[2]} /. x -> Sqrt[0.10724]\)], "Input"],

Cell[BoxData[
    \({2.68402320500127178`, 3.79578201823690042`, 5.36804641000254267`}\)], 
  "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
FrontEndVersion->"4.0 for X",
ScreenRectangle->{{0, 800}, {0, 600}},
AutoGeneratedPackage->Automatic,
WindowSize->{800, 600},
WindowMargins->{{Automatic, -5}, {-5, Automatic}},
PrintingPageRange->{Automatic, Automatic},
PageHeaders->{{Cell[ 
        TextData[ {
          CounterBox[ "Page"]}], "PageNumber"], Inherited, Cell[ 
        TextData[ {
          ValueBox[ "FileName"]}], "Header"]}, {Cell[ 
        TextData[ {
          ValueBox[ "FileName"]}], "Header"], Inherited, Cell[ 
        TextData[ {
          CounterBox[ "Page"]}], "PageNumber"]}},
PrintingOptions->{"PaperSize"->{612, 792},
"PaperOrientation"->"Portrait",
"FirstPageHeader"->False,
"FirstPageFooter"->False,
"Magnification"->1}
]


(***********************************************************************
Cached data follows.  If you edit this Notebook file directly, not using
Mathematica, you must remove the line containing CacheID at the top of 
the file.  The cache data will then be recreated when you save this file 
from within Mathematica.
***********************************************************************)

(*CellTagsOutline
CellTagsIndex->{}
*)

(*CellTagsIndex
CellTagsIndex->{}
*)

(*NotebookFileOutline
Notebook[{

Cell[CellGroupData[{
Cell[1739, 51, 54, 0, 64, "Subtitle"],
Cell[1796, 53, 41, 0, 53, "Subsubtitle"],
Cell[1840, 55, 134, 3, 32, "Text"],
Cell[1977, 60, 159, 3, 27, "Input",
  InitializationCell->True],

Cell[CellGroupData[{
Cell[2161, 67, 362, 7, 123, "Input"],
Cell[2526, 76, 130, 2, 23, "Message"],
Cell[2659, 80, 146, 3, 23, "Message"],
Cell[2808, 85, 146, 3, 23, "Message"],
Cell[2957, 90, 146, 3, 23, "Message"],
Cell[3106, 95, 167, 3, 23, "Message"],
Cell[3276, 100, 192, 3, 91, "Output"]
}, Open  ]],
Cell[3483, 106, 48, 1, 27, "Input"],
Cell[3534, 109, 48, 1, 27, "Input"],
Cell[3585, 112, 183, 3, 27, "Input"],

Cell[CellGroupData[{
Cell[3793, 119, 63, 0, 54, "Section"],
Cell[3859, 121, 101667, 2036, 3035, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[105563, 2162, 63, 0, 34, "Section"],
Cell[105629, 2164, 52197, 1035, 1771, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[157863, 3204, 41, 0, 34, "Section"],
Cell[157907, 3206, 281628, 5663, 7675, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[439572, 8874, 41, 0, 34, "Section"],
Cell[439616, 8876, 281179, 5650, 7691, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[720832, 14531, 124, 3, 34, "Section"],
Cell[720959, 14536, 282169, 5675, 6715, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1003165, 20216, 62, 0, 34, "Section"],
Cell[1003230, 20218, 54208, 805, 6363, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1057475, 21028, 144, 3, 56, "Section"],
Cell[1057622, 21033, 277410, 5579, 7979, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1335069, 26617, 117, 3, 34, "Section"],
Cell[1335189, 26622, 279992, 5621, 7723, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1615218, 32248, 117, 3, 34, "Section"],
Cell[1615338, 32253, 279843, 5621, 7707, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[1895218, 37879, 153, 3, 56, "Section"],
Cell[1895374, 37884, 279694, 5615, 7707, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[2175105, 43504, 91, 3, 34, "Section"],
Cell[2175199, 43509, 279632, 5615, 7675, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[2454868, 49129, 154, 3, 56, "Section"],
Cell[2455025, 49134, 279713, 5617, 7675, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[2734775, 54756, 154, 3, 56, "Section"],
Cell[2734932, 54761, 283474, 5710, 10427, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[3018443, 60476, 150, 3, 56, "Section"],
Cell[3018596, 60481, 280936, 5649, 10443, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[3299569, 66135, 124, 3, 56, "Section"],
Cell[3299696, 66140, 280854, 5645, 6347, "Input"]
}, Closed]],

Cell[CellGroupData[{
Cell[3580587, 71790, 26, 0, 34, "Section"],
Cell[3580616, 71792, 46, 1, 27, "Input"],
Cell[3580665, 71795, 21, 0, 32, "Text"],

Cell[CellGroupData[{
Cell[3580711, 71799, 301, 5, 59, "Input"],
Cell[3581015, 71806, 130, 3, 27, "Output"]
}, Open  ]],
Cell[3581160, 71812, 107, 3, 32, "Text"],
Cell[3581270, 71817, 220, 4, 43, "Input"],

Cell[CellGroupData[{
Cell[3581515, 71825, 63, 1, 27, "Input"],
Cell[3581581, 71828, 163, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3581781, 71835, 64, 1, 27, "Input"],
Cell[3581848, 71838, 107, 2, 27, "Output"]
}, Open  ]],
Cell[3581970, 71843, 119, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[3582114, 71850, 233, 5, 59, "Input"],
Cell[3582350, 71857, 721, 12, 65, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3583108, 71874, 965, 18, 155, "Input"],
Cell[3584076, 71894, 1052, 26, 43, "Output"]
}, Open  ]],
Cell[3585143, 71923, 132, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[3585300, 71930, 154, 3, 27, "Input"],
Cell[3585457, 71935, 112, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3585606, 71942, 155, 3, 27, "Input"],
Cell[3585764, 71947, 114, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3585915, 71954, 882, 14, 171, "Input"],
Cell[3586800, 71970, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3586967, 71978, 160, 3, 27, "Input"],
Cell[3587130, 71983, 113, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3587280, 71990, 533, 9, 107, "Input"],
Cell[3587816, 72001, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3587983, 72009, 91, 1, 27, "Input"],
Cell[3588077, 72012, 981, 15, 91, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3589095, 72032, 1016, 17, 139, "Input"],
Cell[3590114, 72051, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3590281, 72059, 991, 17, 139, "Input"],
Cell[3591275, 72078, 130, 3, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3591454, 72087, 28, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[3591507, 72091, 140, 2, 27, "Input"],
Cell[3591650, 72095, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3591817, 72103, 140, 2, 27, "Input"],
Cell[3591960, 72107, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3592127, 72115, 137, 2, 27, "Input"],
Cell[3592267, 72119, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3592434, 72127, 534, 10, 107, "Input"],
Cell[3592971, 72139, 130, 3, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3593138, 72147, 136, 2, 27, "Input"],
Cell[3593277, 72151, 130, 3, 27, "Output"]
}, Open  ]],
Cell[3593422, 72157, 208, 4, 50, "Text"],

Cell[CellGroupData[{
Cell[3593655, 72165, 78, 1, 27, "Input"],
Cell[3593736, 72168, 135, 3, 27, "Output"]
}, Open  ]],
Cell[3593886, 72174, 136, 3, 32, "Text"],

Cell[CellGroupData[{
Cell[3594047, 72181, 419, 6, 75, "Input"],
Cell[3594469, 72189, 56, 1, 23, "Print"],
Cell[3594528, 72192, 57, 1, 23, "Print"],
Cell[3594588, 72195, 57, 1, 23, "Print"],
Cell[3594648, 72198, 57, 1, 23, "Print"],
Cell[3594708, 72201, 57, 1, 23, "Print"],
Cell[3594768, 72204, 57, 1, 23, "Print"],
Cell[3594828, 72207, 57, 1, 23, "Print"],
Cell[3594888, 72210, 57, 1, 23, "Print"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3594994, 72217, 35, 0, 54, "Section"],

Cell[CellGroupData[{
Cell[3595054, 72221, 509, 10, 139, "Input"],
Cell[3595566, 72233, 2081, 49, 51, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3597684, 72287, 283, 5, 75, "Input"],
Cell[3597970, 72294, 63, 1, 27, "Output"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{
Cell[3598082, 72301, 23, 0, 54, "Section"],
Cell[3598108, 72303, 104, 2, 27, "Output"],

Cell[CellGroupData[{
Cell[3598237, 72309, 164, 2, 27, "Input"],
Cell[3598404, 72313, 103, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3598544, 72320, 162, 2, 27, "Input"],
Cell[3598709, 72324, 103, 2, 27, "Output"]
}, Open  ]],

Cell[CellGroupData[{
Cell[3598849, 72331, 161, 2, 27, "Input"],
Cell[3599013, 72335, 103, 2, 27, "Output"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)




(***********************************************************************
End of Mathematica Notebook file.
***********************************************************************)

